#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 4064
#define SYMBOL_COUNT 156
#define ALIAS_COUNT 1
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 15
#define MAX_ALIAS_SEQUENCE_LENGTH 10

enum {
  sym_word = 1,
  anon_sym_LF = 2,
  anon_sym_for = 3,
  anon_sym_in = 4,
  anon_sym_LPAREN_LPAREN = 5,
  anon_sym_RPAREN_RPAREN = 6,
  anon_sym_SEMI = 7,
  anon_sym_while = 8,
  anon_sym_do = 9,
  anon_sym_done = 10,
  anon_sym_if = 11,
  anon_sym_then = 12,
  anon_sym_fi = 13,
  anon_sym_elif = 14,
  anon_sym_else = 15,
  anon_sym_case = 16,
  anon_sym_esac = 17,
  anon_sym_PIPE = 18,
  anon_sym_RPAREN = 19,
  anon_sym_SEMI_SEMI = 20,
  anon_sym_function = 21,
  anon_sym_LPAREN = 22,
  anon_sym_LBRACE = 23,
  anon_sym_RBRACE = 24,
  anon_sym_PIPE_AMP = 25,
  anon_sym_AMP_AMP = 26,
  anon_sym_PIPE_PIPE = 27,
  anon_sym_BANG = 28,
  anon_sym_LBRACK = 29,
  anon_sym_RBRACK = 30,
  anon_sym_LBRACK_LBRACK = 31,
  anon_sym_RBRACK_RBRACK = 32,
  anon_sym_declare = 33,
  anon_sym_typeset = 34,
  anon_sym_export = 35,
  anon_sym_readonly = 36,
  anon_sym_local = 37,
  anon_sym_unset = 38,
  anon_sym_unsetenv = 39,
  anon_sym_EQ_TILDE = 40,
  anon_sym_EQ_EQ = 41,
  anon_sym_EQ = 42,
  anon_sym_PLUS_EQ = 43,
  anon_sym_LT = 44,
  anon_sym_GT = 45,
  anon_sym_GT_GT = 46,
  anon_sym_AMP_GT = 47,
  anon_sym_AMP_GT_GT = 48,
  anon_sym_LT_AMP = 49,
  anon_sym_GT_AMP = 50,
  anon_sym_LT_LT = 51,
  anon_sym_LT_LT_DASH = 52,
  anon_sym_LT_LT_LT = 53,
  anon_sym_BANG_EQ = 54,
  anon_sym_PLUS = 55,
  anon_sym_DASH = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_LT_EQ = 58,
  anon_sym_GT_EQ = 59,
  anon_sym_PLUS_PLUS = 60,
  anon_sym_DASH_DASH = 61,
  anon_sym_DOLLAR = 62,
  sym__special_character = 63,
  anon_sym_DQUOTE = 64,
  sym__string_content = 65,
  sym_raw_string = 66,
  anon_sym_POUND = 67,
  anon_sym_DOLLAR_LBRACE = 68,
  anon_sym_SLASH = 69,
  anon_sym_COLON = 70,
  anon_sym_COLON_QMARK = 71,
  anon_sym_COLON_DASH = 72,
  anon_sym_PERCENT = 73,
  anon_sym_DOLLAR_LPAREN = 74,
  anon_sym_BQUOTE = 75,
  anon_sym_LT_LPAREN = 76,
  anon_sym_GT_LPAREN = 77,
  sym_comment = 78,
  aux_sym__simple_variable_name_token1 = 79,
  anon_sym_STAR = 80,
  anon_sym_AT = 81,
  anon_sym_QMARK = 82,
  anon_sym_0 = 83,
  anon_sym__ = 84,
  sym_test_operator = 85,
  anon_sym_AMP = 86,
  sym_heredoc_start = 87,
  sym__simple_heredoc_body = 88,
  sym__heredoc_body_beginning = 89,
  sym__heredoc_body_middle = 90,
  sym__heredoc_body_end = 91,
  sym_file_descriptor = 92,
  sym__empty_value = 93,
  sym__concat = 94,
  sym_variable_name = 95,
  sym_regex = 96,
  sym_program = 97,
  sym__statements = 98,
  sym__terminated_statement = 99,
  sym_redirected_statement = 100,
  sym_for_statement = 101,
  sym_c_style_for_statement = 102,
  sym_while_statement = 103,
  sym_do_group = 104,
  sym_if_statement = 105,
  sym_elif_clause = 106,
  sym_else_clause = 107,
  sym_case_statement = 108,
  sym_case_item = 109,
  sym_last_case_item = 110,
  sym_function_definition = 111,
  sym_compound_statement = 112,
  sym_subshell = 113,
  sym_pipeline = 114,
  sym_list = 115,
  sym_negated_command = 116,
  sym_test_command = 117,
  sym_declaration_command = 118,
  sym_unset_command = 119,
  sym_command = 120,
  sym_command_name = 121,
  sym_variable_assignment = 122,
  sym_subscript = 123,
  sym_file_redirect = 124,
  sym_heredoc_redirect = 125,
  sym_heredoc_body = 126,
  sym_herestring_redirect = 127,
  sym__expression = 128,
  sym_binary_expression = 129,
  sym_unary_expression = 130,
  sym_postfix_expression = 131,
  sym_parenthesized_expression = 132,
  sym_concatenation = 133,
  sym_string = 134,
  sym_array = 135,
  sym_simple_expansion = 136,
  sym_string_expansion = 137,
  sym_expansion = 138,
  sym_command_substitution = 139,
  sym_process_substitution = 140,
  aux_sym__statements_repeat1 = 141,
  aux_sym_redirected_statement_repeat1 = 142,
  aux_sym_for_statement_repeat1 = 143,
  aux_sym_if_statement_repeat1 = 144,
  aux_sym_case_statement_repeat1 = 145,
  aux_sym_case_item_repeat1 = 146,
  aux_sym_declaration_command_repeat1 = 147,
  aux_sym_unset_command_repeat1 = 148,
  aux_sym_command_repeat1 = 149,
  aux_sym_command_repeat2 = 150,
  aux_sym_heredoc_body_repeat1 = 151,
  aux_sym__literal_repeat1 = 152,
  aux_sym_concatenation_repeat1 = 153,
  aux_sym_string_repeat1 = 154,
  aux_sym_expansion_repeat1 = 155,
  alias_sym_special_variable_name = 156,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_word] = "word",
  [anon_sym_LF] = "\n",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_LPAREN_LPAREN] = "((",
  [anon_sym_RPAREN_RPAREN] = "))",
  [anon_sym_SEMI] = ";",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DOLLAR] = "$",
  [sym__special_character] = "_special_character",
  [anon_sym_DQUOTE] = "\"",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym__simple_variable_name_token1] = "variable_name",
  [anon_sym_STAR] = "special_variable_name",
  [anon_sym_AT] = "special_variable_name",
  [anon_sym_QMARK] = "special_variable_name",
  [anon_sym_0] = "special_variable_name",
  [anon_sym__] = "special_variable_name",
  [sym_test_operator] = "test_operator",
  [anon_sym_AMP] = "&",
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [sym_regex] = "regex",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_redirected_statement] = "redirected_statement",
  [sym_for_statement] = "for_statement",
  [sym_c_style_for_statement] = "c_style_for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_redirected_statement_repeat1] = "redirected_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym__literal_repeat1] = "_literal_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_special_variable_name] = "special_variable_name",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__special_character] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__simple_variable_name_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_redirected_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_c_style_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_redirected_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = sym_word,
  },
  [2] = {
    [1] = sym_word,
  },
  [3] = {
    [1] = alias_sym_special_variable_name,
  },
  [4] = {
    [2] = sym_word,
  },
  [5] = {
    [2] = alias_sym_special_variable_name,
  },
  [6] = {
    [3] = sym_word,
  },
  [7] = {
    [4] = sym_word,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(24);
      if (lookahead == ']')
        ADVANCE(25);
      if (lookahead == '_')
        ADVANCE(26);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == 'f')
        ADVANCE(29);
      if (lookahead == 'i')
        ADVANCE(30);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(36);
      if (lookahead == '{')
        ADVANCE(37);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(38);
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 8:
      if (lookahead == '\'')
        ADVANCE(40);
      if (lookahead != 0)
        ADVANCE(8);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '(')
        ADVANCE(41);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      if (lookahead == ')')
        ADVANCE(42);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(43);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(45);
      if (lookahead == '=')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(48);
      if (lookahead == '?')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(50);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '(')
        ADVANCE(52);
      if (lookahead == '<')
        ADVANCE(53);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(57);
      if (lookahead == '(')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(60);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(61);
      END_STATE();
    case 24:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(62);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(63);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'l')
        ADVANCE(64);
      if (lookahead == 's')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'i')
        ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'n')
        ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(68);
      if (lookahead == '|')
        ADVANCE(69);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 35:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(34);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(70);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LPAREN_LPAREN);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_RPAREN_RPAREN);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(71);
      if (lookahead == '<')
        ADVANCE(72);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 62:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(24);
      if (lookahead == ']')
        ADVANCE(25);
      if (lookahead == '_')
        ADVANCE(26);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == 'f')
        ADVANCE(29);
      if (lookahead == 'i')
        ADVANCE(30);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(62);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'i')
        ADVANCE(73);
      if (lookahead == 's')
        ADVANCE(74);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'a')
        ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'f')
        ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'e')
        ADVANCE(77);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 79:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(83);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(79);
      if (lookahead != 0 &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(80);
      END_STATE();
    case 81:
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 83:
      if (lookahead == ';')
        ADVANCE(50);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '(')
        ADVANCE(52);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(57);
      if (lookahead == '(')
        ADVANCE(58);
      if (lookahead == '>')
        ADVANCE(60);
      END_STATE();
    case 86:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(88);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym__special_character);
      END_STATE();
    case 88:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(83);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(88);
      if (lookahead != 0 &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 89:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(91);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(92);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(89);
      if (lookahead != 0 &&
          lookahead != ';')
        ADVANCE(34);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 91:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(89);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 93:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(94);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(96);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(34);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(94);
      if (lookahead == '\\')
        ADVANCE(96);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '(')
        ADVANCE(52);
      if (lookahead == '<')
        ADVANCE(53);
      END_STATE();
    case 96:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(98);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 98:
      if (lookahead == '\n')
        ADVANCE(94);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(96);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(34);
      END_STATE();
    case 99:
      if (lookahead == '!')
        ADVANCE(100);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(107);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(99);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 107:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(99);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 110:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(111);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(113);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(110);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(111);
      if (lookahead == '\\')
        ADVANCE(113);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 113:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(114);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 114:
      if (lookahead == '\n')
        ADVANCE(111);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(113);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(114);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 115:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(116);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(115);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 116:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(115);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 117:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == ')')
        ADVANCE(118);
      if (lookahead == '-')
        ADVANCE(119);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(122);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(117);
      if (lookahead != 0 &&
          lookahead != '&' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 118:
      if (lookahead == ')')
        ADVANCE(42);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 120:
      if (lookahead == '(')
        ADVANCE(52);
      END_STATE();
    case 121:
      if (lookahead == '(')
        ADVANCE(58);
      END_STATE();
    case 122:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(117);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 123:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(124);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 124:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 125:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '+')
        ADVANCE(126);
      if (lookahead == '=')
        ADVANCE(127);
      if (lookahead == '[')
        ADVANCE(128);
      if (lookahead == '\\')
        SKIP(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(125);
      END_STATE();
    case 126:
      if (lookahead == '=')
        ADVANCE(130);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 129:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(125);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 131:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '(')
        ADVANCE(132);
      if (lookahead == '<')
        ADVANCE(133);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(135);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(131);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 132:
      if (lookahead == '(')
        ADVANCE(41);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(60);
      END_STATE();
    case 135:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(131);
      END_STATE();
    case 136:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(137);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(138);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(139);
      if (lookahead != 0)
        ADVANCE(140);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(140);
      if (lookahead == '\\')
        ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(137);
      END_STATE();
    case 138:
      if (lookahead == '\n')
        ADVANCE(139);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(139);
      if (lookahead != 0)
        ADVANCE(140);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(137);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(138);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(139);
      if (lookahead != 0)
        ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n')
        ADVANCE(140);
      if (lookahead != 0)
        ADVANCE(137);
      END_STATE();
    case 142:
      if (lookahead == '\n')
        ADVANCE(140);
      if (lookahead != 0)
        ADVANCE(140);
      END_STATE();
    case 143:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(146);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(53);
      END_STATE();
    case 146:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(143);
      END_STATE();
    case 147:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(148);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(149);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(147);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(34);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(148);
      if (lookahead == '\\')
        ADVANCE(149);
      END_STATE();
    case 149:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(150);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 150:
      if (lookahead == '\n')
        ADVANCE(148);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(149);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(150);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(34);
      END_STATE();
    case 151:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '=')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(154);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 154:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 155:
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == ')')
        ADVANCE(118);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(163);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(164);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(155);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 156:
      if (lookahead == '=')
        ADVANCE(165);
      END_STATE();
    case 157:
      if (lookahead == '&')
        ADVANCE(38);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(130);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(167);
      if (lookahead == '=')
        ADVANCE(168);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(169);
      if (lookahead == '~')
        ADVANCE(170);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(59);
      END_STATE();
    case 163:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(155);
      END_STATE();
    case 164:
      if (lookahead == '|')
        ADVANCE(69);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 171:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == 'e')
        ADVANCE(173);
      if (lookahead == 'f')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      END_STATE();
    case 172:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(171);
      END_STATE();
    case 173:
      if (lookahead == 'l')
        ADVANCE(175);
      END_STATE();
    case 174:
      if (lookahead == 'i')
        ADVANCE(176);
      END_STATE();
    case 175:
      if (lookahead == 'i')
        ADVANCE(177);
      if (lookahead == 's')
        ADVANCE(178);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 177:
      if (lookahead == 'f')
        ADVANCE(179);
      END_STATE();
    case 178:
      if (lookahead == 'e')
        ADVANCE(180);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 181:
      if (lookahead == '\n')
        ADVANCE(182);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(182);
      if (lookahead == '\\')
        ADVANCE(183);
      END_STATE();
    case 183:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 184:
      if (lookahead == '\n')
        ADVANCE(185);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if (lookahead != 0 &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(185);
      if (lookahead == '\\')
        ADVANCE(186);
      END_STATE();
    case 186:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 187:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(188);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'd')
        ADVANCE(189);
      if (lookahead == 'e')
        ADVANCE(190);
      if (lookahead == 'f')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(187);
      END_STATE();
    case 188:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(187);
      END_STATE();
    case 189:
      if (lookahead == 'o')
        ADVANCE(191);
      END_STATE();
    case 190:
      if (lookahead == 'l')
        ADVANCE(175);
      if (lookahead == 's')
        ADVANCE(192);
      END_STATE();
    case 191:
      if (lookahead == 'n')
        ADVANCE(193);
      END_STATE();
    case 192:
      if (lookahead == 'a')
        ADVANCE(194);
      END_STATE();
    case 193:
      if (lookahead == 'e')
        ADVANCE(195);
      END_STATE();
    case 194:
      if (lookahead == 'c')
        ADVANCE(196);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 197:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(198);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      END_STATE();
    case 198:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        ADVANCE(200);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(201);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(200);
      if (lookahead == '\\')
        ADVANCE(201);
      END_STATE();
    case 201:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(204);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == 'i')
        ADVANCE(205);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 204:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(202);
      END_STATE();
    case 205:
      if (lookahead == 'n')
        ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 207:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        ADVANCE(208);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(209);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      if (lookahead != 0 &&
          lookahead != '`')
        ADVANCE(140);
      END_STATE();
    case 208:
      if (lookahead == '\n')
        ADVANCE(209);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(209);
      if (lookahead != 0)
        ADVANCE(140);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        ADVANCE(208);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(209);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      if (lookahead != 0 &&
          lookahead != '`')
        ADVANCE(140);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        ADVANCE(211);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == '-')
        ADVANCE(119);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(212);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(211);
      if (lookahead == '-')
        ADVANCE(119);
      if (lookahead == '\\')
        ADVANCE(212);
      END_STATE();
    case 212:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 213:
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(214);
      if (lookahead == ']')
        ADVANCE(215);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(164);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      END_STATE();
    case 214:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 216:
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(217);
      if (lookahead == ']')
        ADVANCE(218);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(164);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      END_STATE();
    case 217:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym__special_character);
      if (lookahead == ']')
        ADVANCE(63);
      END_STATE();
    case 219:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '=')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 220:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 221:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(222);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 222:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 223:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(224);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(225);
      if (lookahead == 'f')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 224:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'l')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 226:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(227);
      if (lookahead == 'i')
        ADVANCE(205);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      END_STATE();
    case 227:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      END_STATE();
    case 228:
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(229);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(164);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      END_STATE();
    case 229:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      END_STATE();
    case 230:
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(231);
      if (lookahead == ']')
        ADVANCE(218);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(232);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(230);
      END_STATE();
    case 231:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(230);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(69);
      END_STATE();
    case 233:
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '\\')
        SKIP(234);
      if (lookahead == ']')
        ADVANCE(235);
      if (lookahead == '|')
        ADVANCE(164);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      END_STATE();
    case 234:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      END_STATE();
    case 235:
      if (lookahead == ']')
        ADVANCE(63);
      END_STATE();
    case 236:
      if (lookahead == '\n')
        ADVANCE(237);
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(238);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(164);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(237);
      if (lookahead == '-')
        ADVANCE(159);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(38);
      END_STATE();
    case 239:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      END_STATE();
    case 240:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(241);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'd')
        ADVANCE(242);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 241:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'o')
        ADVANCE(243);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'n')
        ADVANCE(244);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'e')
        ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 246:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(247);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'd')
        ADVANCE(189);
      if (lookahead == 'e')
        ADVANCE(190);
      if (lookahead == 'f')
        ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 247:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 248:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(249);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(250);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(248);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(249);
      if (lookahead == '\\')
        ADVANCE(250);
      END_STATE();
    case 250:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 251:
      if (lookahead == '\n')
        ADVANCE(249);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(250);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 252:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(253);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(255);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(252);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(34);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(253);
      if (lookahead == '\\')
        ADVANCE(255);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 255:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 257:
      if (lookahead == '\n')
        ADVANCE(253);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(255);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(34);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(259);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      END_STATE();
    case 259:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      END_STATE();
    case 260:
      if (lookahead == '\n')
        ADVANCE(261);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(262);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(263);
      if (lookahead == 'f')
        ADVANCE(264);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(261);
      if (lookahead == '\\')
        ADVANCE(262);
      END_STATE();
    case 262:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'l')
        ADVANCE(265);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'i')
        ADVANCE(266);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'i')
        ADVANCE(267);
      if (lookahead == 's')
        ADVANCE(268);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'f')
        ADVANCE(269);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'e')
        ADVANCE(270);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 271:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(272);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'f')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(271);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 272:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(271);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 273:
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(275);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(225);
      if (lookahead == 'f')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      if (lookahead != 0 &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == '\\')
        ADVANCE(275);
      END_STATE();
    case 275:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 276:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(277);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == 'e')
        ADVANCE(173);
      if (lookahead == 'f')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      END_STATE();
    case 277:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      END_STATE();
    case 278:
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(280);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(225);
      if (lookahead == 'f')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(278);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == '\\')
        ADVANCE(280);
      END_STATE();
    case 280:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(278);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 281:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(283);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 282:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 's')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 284:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(285);
      if (lookahead == ']')
        ADVANCE(215);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(284);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 285:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(284);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 286:
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(288);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'd')
        ADVANCE(289);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(287);
      if (lookahead == '\\')
        ADVANCE(288);
      END_STATE();
    case 288:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'o')
        ADVANCE(290);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'n')
        ADVANCE(291);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'e')
        ADVANCE(292);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 293:
      if (lookahead == '\n')
        ADVANCE(294);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(295);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'd')
        ADVANCE(242);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(293);
      if (lookahead != 0 &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(294);
      if (lookahead == '\\')
        ADVANCE(295);
      END_STATE();
    case 295:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(293);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 296:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(297);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == 'd')
        ADVANCE(189);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(296);
      END_STATE();
    case 297:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(296);
      END_STATE();
    case 298:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '\\')
        SKIP(299);
      if (lookahead == 'd')
        ADVANCE(189);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      END_STATE();
    case 299:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      END_STATE();
    case 300:
      if (lookahead == '\n')
        ADVANCE(301);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(302);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'd')
        ADVANCE(242);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(300);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(301);
      if (lookahead == '\\')
        ADVANCE(302);
      END_STATE();
    case 302:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(300);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 303:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '\\')
        SKIP(304);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(190);
      if (lookahead == 'f')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      END_STATE();
    case 304:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      END_STATE();
    case 305:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(306);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(305);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 306:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(305);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 307:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(308);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(309);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(307);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(34);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(308);
      if (lookahead == '\\')
        ADVANCE(309);
      END_STATE();
    case 309:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 310:
      if (lookahead == '\n')
        ADVANCE(308);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(309);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(34);
      END_STATE();
    case 311:
      if (lookahead == '\n')
        ADVANCE(312);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(313);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(311);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(312);
      if (lookahead == '\\')
        ADVANCE(313);
      END_STATE();
    case 313:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(311);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 314:
      if (lookahead == '\n')
        ADVANCE(315);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(316);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'f')
        ADVANCE(264);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(314);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(315);
      if (lookahead == '\\')
        ADVANCE(316);
      END_STATE();
    case 316:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(314);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 317:
      if (lookahead == '\n')
        ADVANCE(318);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(319);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'f')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (lookahead != 0 &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(318);
      if (lookahead == '\\')
        ADVANCE(319);
      END_STATE();
    case 319:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 320:
      if (lookahead == '\n')
        ADVANCE(321);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(322);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'f')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(321);
      if (lookahead == '\\')
        ADVANCE(322);
      END_STATE();
    case 322:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 323:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(83);
      if (lookahead == '\\')
        SKIP(324);
      if (lookahead == 'e')
        ADVANCE(325);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(323);
      END_STATE();
    case 324:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(323);
      END_STATE();
    case 325:
      if (lookahead == 's')
        ADVANCE(192);
      END_STATE();
    case 326:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(327);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == 'i')
        ADVANCE(328);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 327:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'n')
        ADVANCE(329);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_in);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 330:
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(331);
      if (lookahead == ']')
        ADVANCE(235);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == '|')
        ADVANCE(232);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 331:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      END_STATE();
    case 332:
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == ';')
        ADVANCE(333);
      if (lookahead == '\\')
        ADVANCE(334);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(332);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '|' &&
          lookahead != '}')
        ADVANCE(34);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 334:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(332);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 335:
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(157);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(336);
      if (lookahead == ']')
        ADVANCE(215);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == '|')
        ADVANCE(164);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(335);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 336:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(335);
      END_STATE();
    case 337:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '=')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(338);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(337);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 338:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(337);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 339:
      if (lookahead == '\n')
        ADVANCE(340);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(339);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(340);
      if (lookahead == '\\')
        ADVANCE(341);
      END_STATE();
    case 341:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(339);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 342:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(343);
      if (lookahead == 'e')
        ADVANCE(173);
      if (lookahead == 'f')
        ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(342);
      END_STATE();
    case 343:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(342);
      END_STATE();
    case 344:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(81);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(83);
      if (lookahead == '<')
        ADVANCE(84);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(345);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(283);
      if (lookahead == '{')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(344);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 345:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(344);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 346:
      if (lookahead == '\n')
        ADVANCE(237);
      if (lookahead == '!')
        ADVANCE(156);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(238);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '+')
        ADVANCE(158);
      if (lookahead == '-')
        ADVANCE(159);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(162);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(347);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == '|')
        ADVANCE(164);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(346);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 347:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(346);
      END_STATE();
    case 348:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(349);
      if (lookahead == 'd')
        ADVANCE(189);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(348);
      END_STATE();
    case 349:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(348);
      END_STATE();
    case 350:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(82);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(351);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(350);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 351:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(350);
      END_STATE();
    case 352:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(353);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 353:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      END_STATE();
    case 354:
      if (lookahead == '\n')
        ADVANCE(355);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(356);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(263);
      if (lookahead == 'f')
        ADVANCE(264);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(354);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(355);
      if (lookahead == '\\')
        ADVANCE(356);
      END_STATE();
    case 356:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(354);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 357:
      if (lookahead == '\n')
        ADVANCE(358);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(359);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(360);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(357);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(358);
      if (lookahead == '\\')
        ADVANCE(359);
      END_STATE();
    case 359:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(357);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 's')
        ADVANCE(361);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'a')
        ADVANCE(362);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(363);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(34);
      END_STATE();
    case 364:
      if (lookahead == '\n')
        ADVANCE(365);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(90);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(366);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(283);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(364);
      if (lookahead != 0 &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(365);
      if (lookahead == '\\')
        ADVANCE(366);
      END_STATE();
    case 366:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(364);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 367:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        SKIP(368);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == 'e')
        ADVANCE(325);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(367);
      END_STATE();
    case 368:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(367);
      END_STATE();
    case 369:
      if (lookahead == '\n')
        ADVANCE(370);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(371);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(283);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(369);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(370);
      if (lookahead == '\\')
        ADVANCE(371);
      END_STATE();
    case 371:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(369);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 372:
      if (lookahead == '\n')
        ADVANCE(373);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '>')
        ADVANCE(121);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(374);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(372);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != '|')
        ADVANCE(34);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(373);
      if (lookahead == '\\')
        ADVANCE(374);
      END_STATE();
    case 374:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(372);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 375:
      if (lookahead == '\n')
        ADVANCE(376);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(377);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'd')
        ADVANCE(289);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(375);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(376);
      if (lookahead == '\\')
        ADVANCE(377);
      END_STATE();
    case 377:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(375);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 378:
      if (lookahead == '\n')
        ADVANCE(379);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(380);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(263);
      if (lookahead == 'f')
        ADVANCE(264);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(378);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(379);
      if (lookahead == '\\')
        ADVANCE(380);
      END_STATE();
    case 380:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(378);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 381:
      if (lookahead == '\n')
        ADVANCE(382);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(383);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'f')
        ADVANCE(264);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(381);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(382);
      if (lookahead == '\\')
        ADVANCE(383);
      END_STATE();
    case 383:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(381);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 384:
      if (lookahead == '\n')
        ADVANCE(385);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(386);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'd')
        ADVANCE(289);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(384);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(385);
      if (lookahead == '\\')
        ADVANCE(386);
      END_STATE();
    case 386:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(384);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 387:
      if (lookahead == '\n')
        ADVANCE(388);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(389);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'f')
        ADVANCE(264);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(387);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(388);
      if (lookahead == '\\')
        ADVANCE(389);
      END_STATE();
    case 389:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(387);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 390:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(391);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == 'e')
        ADVANCE(392);
      if (lookahead == 'f')
        ADVANCE(393);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 391:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'l')
        ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'i')
        ADVANCE(395);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'i')
        ADVANCE(396);
      if (lookahead == 's')
        ADVANCE(397);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_fi);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'f')
        ADVANCE(398);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'e')
        ADVANCE(399);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_elif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 400:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '#')
        ADVANCE(80);
      if (lookahead == '&')
        ADVANCE(203);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(401);
      if (lookahead == 'e')
        ADVANCE(325);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(400);
      END_STATE();
    case 401:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(400);
      END_STATE();
    case 402:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(403);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == 'd')
        ADVANCE(404);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(402);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 403:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(402);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'o')
        ADVANCE(405);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'n')
        ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'e')
        ADVANCE(407);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_done);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 408:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(409);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == 'f')
        ADVANCE(393);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(408);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 409:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(408);
      END_STATE();
    case 410:
      if (lookahead == '\n')
        ADVANCE(411);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '=')
        ADVANCE(112);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(412);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(360);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(410);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(411);
      if (lookahead == '\\')
        ADVANCE(412);
      END_STATE();
    case 412:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(410);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 413:
      if (lookahead == '\n')
        ADVANCE(414);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '0')
        ADVANCE(254);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(95);
      if (lookahead == '>')
        ADVANCE(85);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(87);
      if (lookahead == '\\')
        ADVANCE(415);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '_')
        ADVANCE(256);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(360);
      if (lookahead == '{')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '}')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(413);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(34);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(414);
      if (lookahead == '\\')
        ADVANCE(415);
      END_STATE();
    case 415:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(413);
      if (lookahead != 0)
        ADVANCE(34);
      END_STATE();
    case 416:
      if (lookahead == '\n')
        ADVANCE(144);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(102);
      if (lookahead == '-')
        ADVANCE(103);
      if (lookahead == '0')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(145);
      if (lookahead == '>')
        ADVANCE(134);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(417);
      if (lookahead == '_')
        ADVANCE(108);
      if (lookahead == 'e')
        ADVANCE(418);
      if (lookahead == '|')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(416);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 417:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(416);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 's')
        ADVANCE(419);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'a')
        ADVANCE(420);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'c')
        ADVANCE(421);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_esac);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(109);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == '\\')
        SKIP(1);
      if (lookahead == 'c')
        ADVANCE(2);
      if (lookahead == 'd')
        ADVANCE(3);
      if (lookahead == 'e')
        ADVANCE(4);
      if (lookahead == 'f')
        ADVANCE(5);
      if (lookahead == 'i')
        ADVANCE(6);
      if (lookahead == 'l')
        ADVANCE(7);
      if (lookahead == 'r')
        ADVANCE(8);
      if (lookahead == 't')
        ADVANCE(9);
      if (lookahead == 'u')
        ADVANCE(10);
      if (lookahead == 'w')
        ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      END_STATE();
    case 2:
      if (lookahead == 'a')
        ADVANCE(12);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(13);
      if (lookahead == 'o')
        ADVANCE(14);
      END_STATE();
    case 4:
      if (lookahead == 'x')
        ADVANCE(15);
      END_STATE();
    case 5:
      if (lookahead == 'o')
        ADVANCE(16);
      if (lookahead == 'u')
        ADVANCE(17);
      END_STATE();
    case 6:
      if (lookahead == 'f')
        ADVANCE(18);
      END_STATE();
    case 7:
      if (lookahead == 'o')
        ADVANCE(19);
      END_STATE();
    case 8:
      if (lookahead == 'e')
        ADVANCE(20);
      END_STATE();
    case 9:
      if (lookahead == 'h')
        ADVANCE(21);
      if (lookahead == 'y')
        ADVANCE(22);
      END_STATE();
    case 10:
      if (lookahead == 'n')
        ADVANCE(23);
      END_STATE();
    case 11:
      if (lookahead == 'h')
        ADVANCE(24);
      END_STATE();
    case 12:
      if (lookahead == 's')
        ADVANCE(25);
      END_STATE();
    case 13:
      if (lookahead == 'c')
        ADVANCE(26);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 15:
      if (lookahead == 'p')
        ADVANCE(27);
      END_STATE();
    case 16:
      if (lookahead == 'r')
        ADVANCE(28);
      END_STATE();
    case 17:
      if (lookahead == 'n')
        ADVANCE(29);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 19:
      if (lookahead == 'c')
        ADVANCE(30);
      END_STATE();
    case 20:
      if (lookahead == 'a')
        ADVANCE(31);
      END_STATE();
    case 21:
      if (lookahead == 'e')
        ADVANCE(32);
      END_STATE();
    case 22:
      if (lookahead == 'p')
        ADVANCE(33);
      END_STATE();
    case 23:
      if (lookahead == 's')
        ADVANCE(34);
      END_STATE();
    case 24:
      if (lookahead == 'i')
        ADVANCE(35);
      END_STATE();
    case 25:
      if (lookahead == 'e')
        ADVANCE(36);
      END_STATE();
    case 26:
      if (lookahead == 'l')
        ADVANCE(37);
      END_STATE();
    case 27:
      if (lookahead == 'o')
        ADVANCE(38);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 29:
      if (lookahead == 'c')
        ADVANCE(39);
      END_STATE();
    case 30:
      if (lookahead == 'a')
        ADVANCE(40);
      END_STATE();
    case 31:
      if (lookahead == 'd')
        ADVANCE(41);
      END_STATE();
    case 32:
      if (lookahead == 'n')
        ADVANCE(42);
      END_STATE();
    case 33:
      if (lookahead == 'e')
        ADVANCE(43);
      END_STATE();
    case 34:
      if (lookahead == 'e')
        ADVANCE(44);
      END_STATE();
    case 35:
      if (lookahead == 'l')
        ADVANCE(45);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 37:
      if (lookahead == 'a')
        ADVANCE(46);
      END_STATE();
    case 38:
      if (lookahead == 'r')
        ADVANCE(47);
      END_STATE();
    case 39:
      if (lookahead == 't')
        ADVANCE(48);
      END_STATE();
    case 40:
      if (lookahead == 'l')
        ADVANCE(49);
      END_STATE();
    case 41:
      if (lookahead == 'o')
        ADVANCE(50);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 43:
      if (lookahead == 's')
        ADVANCE(51);
      END_STATE();
    case 44:
      if (lookahead == 't')
        ADVANCE(52);
      END_STATE();
    case 45:
      if (lookahead == 'e')
        ADVANCE(53);
      END_STATE();
    case 46:
      if (lookahead == 'r')
        ADVANCE(54);
      END_STATE();
    case 47:
      if (lookahead == 't')
        ADVANCE(55);
      END_STATE();
    case 48:
      if (lookahead == 'i')
        ADVANCE(56);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 50:
      if (lookahead == 'n')
        ADVANCE(57);
      END_STATE();
    case 51:
      if (lookahead == 'e')
        ADVANCE(58);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(59);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 54:
      if (lookahead == 'e')
        ADVANCE(60);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 56:
      if (lookahead == 'o')
        ADVANCE(61);
      END_STATE();
    case 57:
      if (lookahead == 'l')
        ADVANCE(62);
      END_STATE();
    case 58:
      if (lookahead == 't')
        ADVANCE(63);
      END_STATE();
    case 59:
      if (lookahead == 'n')
        ADVANCE(64);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 61:
      if (lookahead == 'n')
        ADVANCE(65);
      END_STATE();
    case 62:
      if (lookahead == 'y')
        ADVANCE(66);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 64:
      if (lookahead == 'v')
        ADVANCE(67);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 79, .external_lex_state = 2},
  [2] = {.lex_state = 79, .external_lex_state = 2},
  [3] = {.lex_state = 89},
  [4] = {.lex_state = 93, .external_lex_state = 3},
  [5] = {.lex_state = 93, .external_lex_state = 4},
  [6] = {.lex_state = 99},
  [7] = {.lex_state = 79, .external_lex_state = 2},
  [8] = {.lex_state = 79, .external_lex_state = 2},
  [9] = {.lex_state = 99, .external_lex_state = 5},
  [10] = {.lex_state = 89},
  [11] = {.lex_state = 110, .external_lex_state = 6},
  [12] = {.lex_state = 115, .external_lex_state = 7},
  [13] = {.lex_state = 110, .external_lex_state = 6},
  [14] = {.lex_state = 79, .external_lex_state = 2},
  [15] = {.lex_state = 89},
  [16] = {.lex_state = 117},
  [17] = {.lex_state = 110, .external_lex_state = 6},
  [18] = {.lex_state = 79, .external_lex_state = 2},
  [19] = {.lex_state = 123, .external_lex_state = 2},
  [20] = {.lex_state = 125},
  [21] = {.lex_state = 131},
  [22] = {.lex_state = 136},
  [23] = {.lex_state = 131},
  [24] = {.lex_state = 79, .external_lex_state = 2},
  [25] = {.lex_state = 117},
  [26] = {.lex_state = 117},
  [27] = {.lex_state = 143, .external_lex_state = 4},
  [28] = {.lex_state = 125},
  [29] = {.lex_state = 110, .external_lex_state = 4},
  [30] = {.lex_state = 89, .external_lex_state = 2},
  [31] = {.lex_state = 79},
  [32] = {.lex_state = 79},
  [33] = {.lex_state = 110, .external_lex_state = 4},
  [34] = {.lex_state = 147, .external_lex_state = 3},
  [35] = {.lex_state = 79, .external_lex_state = 2},
  [36] = {.lex_state = 110, .external_lex_state = 4},
  [37] = {.lex_state = 93, .external_lex_state = 3},
  [38] = {.lex_state = 93, .external_lex_state = 4},
  [39] = {.lex_state = 110, .external_lex_state = 6},
  [40] = {.lex_state = 110, .external_lex_state = 6},
  [41] = {.lex_state = 110, .external_lex_state = 6},
  [42] = {.lex_state = 123, .external_lex_state = 2},
  [43] = {.lex_state = 125},
  [44] = {.lex_state = 143, .external_lex_state = 4},
  [45] = {.lex_state = 125},
  [46] = {.lex_state = 89, .external_lex_state = 2},
  [47] = {.lex_state = 79},
  [48] = {.lex_state = 110, .external_lex_state = 4},
  [49] = {.lex_state = 147, .external_lex_state = 3},
  [50] = {.lex_state = 79, .external_lex_state = 2},
  [51] = {.lex_state = 110, .external_lex_state = 4},
  [52] = {.lex_state = 79, .external_lex_state = 2},
  [53] = {.lex_state = 136},
  [54] = {.lex_state = 89, .external_lex_state = 8},
  [55] = {.lex_state = 79, .external_lex_state = 2},
  [56] = {.lex_state = 99},
  [57] = {.lex_state = 79, .external_lex_state = 2},
  [58] = {.lex_state = 89, .external_lex_state = 8},
  [59] = {.lex_state = 99, .external_lex_state = 5},
  [60] = {.lex_state = 89, .external_lex_state = 2},
  [61] = {.lex_state = 89, .external_lex_state = 2},
  [62] = {.lex_state = 79, .external_lex_state = 2},
  [63] = {.lex_state = 136},
  [64] = {.lex_state = 93, .external_lex_state = 9},
  [65] = {.lex_state = 79, .external_lex_state = 2},
  [66] = {.lex_state = 125},
  [67] = {.lex_state = 99},
  [68] = {.lex_state = 79, .external_lex_state = 2},
  [69] = {.lex_state = 93, .external_lex_state = 9},
  [70] = {.lex_state = 99, .external_lex_state = 5},
  [71] = {.lex_state = 93, .external_lex_state = 3},
  [72] = {.lex_state = 93, .external_lex_state = 3},
  [73] = {.lex_state = 125},
  [74] = {.lex_state = 79, .external_lex_state = 2},
  [75] = {.lex_state = 136},
  [76] = {.lex_state = 93, .external_lex_state = 6},
  [77] = {.lex_state = 79, .external_lex_state = 2},
  [78] = {.lex_state = 99},
  [79] = {.lex_state = 79, .external_lex_state = 2},
  [80] = {.lex_state = 93, .external_lex_state = 6},
  [81] = {.lex_state = 99, .external_lex_state = 5},
  [82] = {.lex_state = 93, .external_lex_state = 4},
  [83] = {.lex_state = 93, .external_lex_state = 4},
  [84] = {.lex_state = 110, .external_lex_state = 6},
  [85] = {.lex_state = 110, .external_lex_state = 6},
  [86] = {.lex_state = 110, .external_lex_state = 6},
  [87] = {.lex_state = 79},
  [88] = {.lex_state = 89},
  [89] = {.lex_state = 131},
  [90] = {.lex_state = 89, .external_lex_state = 2},
  [91] = {.lex_state = 79},
  [92] = {.lex_state = 151, .external_lex_state = 10},
  [93] = {.lex_state = 155, .external_lex_state = 5},
  [94] = {.lex_state = 125},
  [95] = {.lex_state = 151, .external_lex_state = 10},
  [96] = {.lex_state = 171},
  [97] = {.lex_state = 79},
  [98] = {.lex_state = 89},
  [99] = {.lex_state = 110, .external_lex_state = 6},
  [100] = {.lex_state = 79, .external_lex_state = 2},
  [101] = {.lex_state = 181, .external_lex_state = 11},
  [102] = {.lex_state = 181, .external_lex_state = 12},
  [103] = {.lex_state = 99},
  [104] = {.lex_state = 79, .external_lex_state = 2},
  [105] = {.lex_state = 79, .external_lex_state = 2},
  [106] = {.lex_state = 99, .external_lex_state = 5},
  [107] = {.lex_state = 89},
  [108] = {.lex_state = 184, .external_lex_state = 13},
  [109] = {.lex_state = 115, .external_lex_state = 7},
  [110] = {.lex_state = 184, .external_lex_state = 13},
  [111] = {.lex_state = 79, .external_lex_state = 2},
  [112] = {.lex_state = 89},
  [113] = {.lex_state = 117},
  [114] = {.lex_state = 184, .external_lex_state = 13},
  [115] = {.lex_state = 79, .external_lex_state = 2},
  [116] = {.lex_state = 123, .external_lex_state = 2},
  [117] = {.lex_state = 125},
  [118] = {.lex_state = 187, .external_lex_state = 4},
  [119] = {.lex_state = 136},
  [120] = {.lex_state = 131},
  [121] = {.lex_state = 79, .external_lex_state = 2},
  [122] = {.lex_state = 117},
  [123] = {.lex_state = 117},
  [124] = {.lex_state = 197, .external_lex_state = 12},
  [125] = {.lex_state = 125},
  [126] = {.lex_state = 184, .external_lex_state = 12},
  [127] = {.lex_state = 89, .external_lex_state = 2},
  [128] = {.lex_state = 115, .external_lex_state = 10},
  [129] = {.lex_state = 184, .external_lex_state = 12},
  [130] = {.lex_state = 199, .external_lex_state = 11},
  [131] = {.lex_state = 79, .external_lex_state = 2},
  [132] = {.lex_state = 184, .external_lex_state = 12},
  [133] = {.lex_state = 93, .external_lex_state = 3},
  [134] = {.lex_state = 93, .external_lex_state = 4},
  [135] = {.lex_state = 110, .external_lex_state = 6},
  [136] = {.lex_state = 110, .external_lex_state = 6},
  [137] = {.lex_state = 110, .external_lex_state = 6},
  [138] = {.lex_state = 123, .external_lex_state = 2},
  [139] = {.lex_state = 125},
  [140] = {.lex_state = 143, .external_lex_state = 4},
  [141] = {.lex_state = 125},
  [142] = {.lex_state = 89, .external_lex_state = 2},
  [143] = {.lex_state = 89},
  [144] = {.lex_state = 110, .external_lex_state = 4},
  [145] = {.lex_state = 147, .external_lex_state = 3},
  [146] = {.lex_state = 110, .external_lex_state = 4},
  [147] = {.lex_state = 79, .external_lex_state = 2},
  [148] = {.lex_state = 136},
  [149] = {.lex_state = 202, .external_lex_state = 14},
  [150] = {.lex_state = 79, .external_lex_state = 2},
  [151] = {.lex_state = 99},
  [152] = {.lex_state = 79, .external_lex_state = 2},
  [153] = {.lex_state = 202, .external_lex_state = 14},
  [154] = {.lex_state = 99, .external_lex_state = 5},
  [155] = {.lex_state = 202, .external_lex_state = 15},
  [156] = {.lex_state = 202, .external_lex_state = 15},
  [157] = {.lex_state = 117},
  [158] = {.lex_state = 117},
  [159] = {.lex_state = 136},
  [160] = {.lex_state = 155, .external_lex_state = 16},
  [161] = {.lex_state = 79, .external_lex_state = 2},
  [162] = {.lex_state = 79, .external_lex_state = 2},
  [163] = {.lex_state = 99},
  [164] = {.lex_state = 79, .external_lex_state = 2},
  [165] = {.lex_state = 155, .external_lex_state = 16},
  [166] = {.lex_state = 99, .external_lex_state = 5},
  [167] = {.lex_state = 155},
  [168] = {.lex_state = 155},
  [169] = {.lex_state = 93, .external_lex_state = 3},
  [170] = {.lex_state = 93, .external_lex_state = 4},
  [171] = {.lex_state = 123, .external_lex_state = 2},
  [172] = {.lex_state = 143, .external_lex_state = 4},
  [173] = {.lex_state = 89, .external_lex_state = 2},
  [174] = {.lex_state = 79},
  [175] = {.lex_state = 110, .external_lex_state = 4},
  [176] = {.lex_state = 147, .external_lex_state = 3},
  [177] = {.lex_state = 79, .external_lex_state = 2},
  [178] = {.lex_state = 125},
  [179] = {.lex_state = 187, .external_lex_state = 4},
  [180] = {.lex_state = 125},
  [181] = {.lex_state = 89, .external_lex_state = 17},
  [182] = {.lex_state = 89},
  [183] = {.lex_state = 89},
  [184] = {.lex_state = 207},
  [185] = {.lex_state = 79, .external_lex_state = 2},
  [186] = {.lex_state = 110, .external_lex_state = 6},
  [187] = {.lex_state = 79, .external_lex_state = 2},
  [188] = {.lex_state = 99, .external_lex_state = 5},
  [189] = {.lex_state = 136, .external_lex_state = 16},
  [190] = {.lex_state = 136},
  [191] = {.lex_state = 202, .external_lex_state = 15},
  [192] = {.lex_state = 210, .external_lex_state = 15},
  [193] = {.lex_state = 89},
  [194] = {.lex_state = 117},
  [195] = {.lex_state = 117},
  [196] = {.lex_state = 136},
  [197] = {.lex_state = 213, .external_lex_state = 18},
  [198] = {.lex_state = 79, .external_lex_state = 2},
  [199] = {.lex_state = 79, .external_lex_state = 2},
  [200] = {.lex_state = 99},
  [201] = {.lex_state = 79, .external_lex_state = 2},
  [202] = {.lex_state = 213, .external_lex_state = 18},
  [203] = {.lex_state = 99, .external_lex_state = 5},
  [204] = {.lex_state = 213, .external_lex_state = 19},
  [205] = {.lex_state = 213, .external_lex_state = 19},
  [206] = {.lex_state = 117},
  [207] = {.lex_state = 216, .external_lex_state = 16},
  [208] = {.lex_state = 216, .external_lex_state = 16},
  [209] = {.lex_state = 216},
  [210] = {.lex_state = 216},
  [211] = {.lex_state = 79, .external_lex_state = 2},
  [212] = {.lex_state = 89},
  [213] = {.lex_state = 79, .external_lex_state = 20},
  [214] = {.lex_state = 79, .external_lex_state = 2},
  [215] = {.lex_state = 131},
  [216] = {.lex_state = 79, .external_lex_state = 21},
  [217] = {.lex_state = 79, .external_lex_state = 2},
  [218] = {.lex_state = 89},
  [219] = {.lex_state = 143, .external_lex_state = 4},
  [220] = {.lex_state = 110, .external_lex_state = 4},
  [221] = {.lex_state = 89, .external_lex_state = 2},
  [222] = {.lex_state = 110, .external_lex_state = 6},
  [223] = {.lex_state = 89, .external_lex_state = 22},
  [224] = {.lex_state = 110, .external_lex_state = 4},
  [225] = {.lex_state = 110, .external_lex_state = 4},
  [226] = {.lex_state = 143, .external_lex_state = 4},
  [227] = {.lex_state = 147, .external_lex_state = 3},
  [228] = {.lex_state = 79, .external_lex_state = 2},
  [229] = {.lex_state = 110, .external_lex_state = 4},
  [230] = {.lex_state = 110, .external_lex_state = 4},
  [231] = {.lex_state = 93, .external_lex_state = 9},
  [232] = {.lex_state = 125},
  [233] = {.lex_state = 93, .external_lex_state = 9},
  [234] = {.lex_state = 93, .external_lex_state = 3},
  [235] = {.lex_state = 93, .external_lex_state = 3},
  [236] = {.lex_state = 125},
  [237] = {.lex_state = 93, .external_lex_state = 6},
  [238] = {.lex_state = 93, .external_lex_state = 6},
  [239] = {.lex_state = 93, .external_lex_state = 4},
  [240] = {.lex_state = 93, .external_lex_state = 4},
  [241] = {.lex_state = 110, .external_lex_state = 6},
  [242] = {.lex_state = 89, .external_lex_state = 17},
  [243] = {.lex_state = 79, .external_lex_state = 2},
  [244] = {.lex_state = 89},
  [245] = {.lex_state = 131},
  [246] = {.lex_state = 79, .external_lex_state = 2},
  [247] = {.lex_state = 89},
  [248] = {.lex_state = 143, .external_lex_state = 4},
  [249] = {.lex_state = 110, .external_lex_state = 4},
  [250] = {.lex_state = 187, .external_lex_state = 4},
  [251] = {.lex_state = 110, .external_lex_state = 6},
  [252] = {.lex_state = 89, .external_lex_state = 22},
  [253] = {.lex_state = 110, .external_lex_state = 4},
  [254] = {.lex_state = 110, .external_lex_state = 4},
  [255] = {.lex_state = 143, .external_lex_state = 4},
  [256] = {.lex_state = 147, .external_lex_state = 3},
  [257] = {.lex_state = 110, .external_lex_state = 4},
  [258] = {.lex_state = 79},
  [259] = {.lex_state = 207},
  [260] = {.lex_state = 89, .external_lex_state = 8},
  [261] = {.lex_state = 136},
  [262] = {.lex_state = 89},
  [263] = {.lex_state = 89, .external_lex_state = 8},
  [264] = {.lex_state = 79},
  [265] = {.lex_state = 89, .external_lex_state = 8},
  [266] = {.lex_state = 89, .external_lex_state = 8},
  [267] = {.lex_state = 89, .external_lex_state = 8},
  [268] = {.lex_state = 89, .external_lex_state = 2},
  [269] = {.lex_state = 79},
  [270] = {.lex_state = 151, .external_lex_state = 10},
  [271] = {.lex_state = 155, .external_lex_state = 5},
  [272] = {.lex_state = 125},
  [273] = {.lex_state = 151, .external_lex_state = 10},
  [274] = {.lex_state = 89, .external_lex_state = 2},
  [275] = {.lex_state = 89, .external_lex_state = 2},
  [276] = {.lex_state = 79},
  [277] = {.lex_state = 207},
  [278] = {.lex_state = 93, .external_lex_state = 9},
  [279] = {.lex_state = 136},
  [280] = {.lex_state = 89},
  [281] = {.lex_state = 93, .external_lex_state = 9},
  [282] = {.lex_state = 79},
  [283] = {.lex_state = 89, .external_lex_state = 17},
  [284] = {.lex_state = 93, .external_lex_state = 9},
  [285] = {.lex_state = 93, .external_lex_state = 9},
  [286] = {.lex_state = 93, .external_lex_state = 9},
  [287] = {.lex_state = 89, .external_lex_state = 2},
  [288] = {.lex_state = 79},
  [289] = {.lex_state = 151, .external_lex_state = 10},
  [290] = {.lex_state = 155, .external_lex_state = 5},
  [291] = {.lex_state = 125},
  [292] = {.lex_state = 151, .external_lex_state = 10},
  [293] = {.lex_state = 93, .external_lex_state = 3},
  [294] = {.lex_state = 93, .external_lex_state = 3},
  [295] = {.lex_state = 93, .external_lex_state = 3},
  [296] = {.lex_state = 79},
  [297] = {.lex_state = 207},
  [298] = {.lex_state = 93, .external_lex_state = 6},
  [299] = {.lex_state = 136},
  [300] = {.lex_state = 89},
  [301] = {.lex_state = 93, .external_lex_state = 6},
  [302] = {.lex_state = 79},
  [303] = {.lex_state = 93, .external_lex_state = 6},
  [304] = {.lex_state = 93, .external_lex_state = 6},
  [305] = {.lex_state = 93, .external_lex_state = 6},
  [306] = {.lex_state = 89, .external_lex_state = 2},
  [307] = {.lex_state = 79},
  [308] = {.lex_state = 151, .external_lex_state = 10},
  [309] = {.lex_state = 155, .external_lex_state = 5},
  [310] = {.lex_state = 125},
  [311] = {.lex_state = 151, .external_lex_state = 10},
  [312] = {.lex_state = 93, .external_lex_state = 4},
  [313] = {.lex_state = 93, .external_lex_state = 4},
  [314] = {.lex_state = 93, .external_lex_state = 4},
  [315] = {.lex_state = 110, .external_lex_state = 6},
  [316] = {.lex_state = 89, .external_lex_state = 8},
  [317] = {.lex_state = 89, .external_lex_state = 8},
  [318] = {.lex_state = 89, .external_lex_state = 2},
  [319] = {.lex_state = 89},
  [320] = {.lex_state = 110, .external_lex_state = 6},
  [321] = {.lex_state = 79, .external_lex_state = 2},
  [322] = {.lex_state = 219, .external_lex_state = 23},
  [323] = {.lex_state = 219, .external_lex_state = 24},
  [324] = {.lex_state = 99},
  [325] = {.lex_state = 79, .external_lex_state = 2},
  [326] = {.lex_state = 79, .external_lex_state = 2},
  [327] = {.lex_state = 99, .external_lex_state = 5},
  [328] = {.lex_state = 110, .external_lex_state = 6},
  [329] = {.lex_state = 136},
  [330] = {.lex_state = 219, .external_lex_state = 24},
  [331] = {.lex_state = 219, .external_lex_state = 10},
  [332] = {.lex_state = 219, .external_lex_state = 10},
  [333] = {.lex_state = 151, .external_lex_state = 10},
  [334] = {.lex_state = 125},
  [335] = {.lex_state = 151, .external_lex_state = 10},
  [336] = {.lex_state = 221, .external_lex_state = 10},
  [337] = {.lex_state = 89},
  [338] = {.lex_state = 219, .external_lex_state = 23},
  [339] = {.lex_state = 110, .external_lex_state = 6},
  [340] = {.lex_state = 219, .external_lex_state = 10},
  [341] = {.lex_state = 79},
  [342] = {.lex_state = 187, .external_lex_state = 4},
  [343] = {.lex_state = 79},
  [344] = {.lex_state = 110, .external_lex_state = 6},
  [345] = {.lex_state = 89},
  [346] = {.lex_state = 110, .external_lex_state = 6},
  [347] = {.lex_state = 79},
  [348] = {.lex_state = 79, .external_lex_state = 2},
  [349] = {.lex_state = 136},
  [350] = {.lex_state = 181, .external_lex_state = 25},
  [351] = {.lex_state = 79, .external_lex_state = 2},
  [352] = {.lex_state = 125},
  [353] = {.lex_state = 99},
  [354] = {.lex_state = 79, .external_lex_state = 2},
  [355] = {.lex_state = 181, .external_lex_state = 25},
  [356] = {.lex_state = 99, .external_lex_state = 5},
  [357] = {.lex_state = 181, .external_lex_state = 11},
  [358] = {.lex_state = 181, .external_lex_state = 11},
  [359] = {.lex_state = 125},
  [360] = {.lex_state = 79, .external_lex_state = 2},
  [361] = {.lex_state = 136},
  [362] = {.lex_state = 181, .external_lex_state = 13},
  [363] = {.lex_state = 79, .external_lex_state = 2},
  [364] = {.lex_state = 99},
  [365] = {.lex_state = 79, .external_lex_state = 2},
  [366] = {.lex_state = 181, .external_lex_state = 13},
  [367] = {.lex_state = 99, .external_lex_state = 5},
  [368] = {.lex_state = 181, .external_lex_state = 12},
  [369] = {.lex_state = 181, .external_lex_state = 12},
  [370] = {.lex_state = 184, .external_lex_state = 13},
  [371] = {.lex_state = 184, .external_lex_state = 13},
  [372] = {.lex_state = 184, .external_lex_state = 13},
  [373] = {.lex_state = 79},
  [374] = {.lex_state = 89, .external_lex_state = 2},
  [375] = {.lex_state = 79},
  [376] = {.lex_state = 151, .external_lex_state = 10},
  [377] = {.lex_state = 155, .external_lex_state = 5},
  [378] = {.lex_state = 125},
  [379] = {.lex_state = 151, .external_lex_state = 10},
  [380] = {.lex_state = 171},
  [381] = {.lex_state = 79},
  [382] = {.lex_state = 89},
  [383] = {.lex_state = 184, .external_lex_state = 13},
  [384] = {.lex_state = 197, .external_lex_state = 12},
  [385] = {.lex_state = 115, .external_lex_state = 10},
  [386] = {.lex_state = 89},
  [387] = {.lex_state = 202, .external_lex_state = 14},
  [388] = {.lex_state = 202, .external_lex_state = 15},
  [389] = {.lex_state = 202, .external_lex_state = 15},
  [390] = {.lex_state = 155},
  [391] = {.lex_state = 79},
  [392] = {.lex_state = 197, .external_lex_state = 12},
  [393] = {.lex_state = 89, .external_lex_state = 17},
  [394] = {.lex_state = 207},
  [395] = {.lex_state = 184, .external_lex_state = 13},
  [396] = {.lex_state = 136},
  [397] = {.lex_state = 202, .external_lex_state = 15},
  [398] = {.lex_state = 210, .external_lex_state = 15},
  [399] = {.lex_state = 89},
  [400] = {.lex_state = 213, .external_lex_state = 19},
  [401] = {.lex_state = 216},
  [402] = {.lex_state = 79, .external_lex_state = 2},
  [403] = {.lex_state = 89},
  [404] = {.lex_state = 115, .external_lex_state = 26},
  [405] = {.lex_state = 115, .external_lex_state = 7},
  [406] = {.lex_state = 131},
  [407] = {.lex_state = 79, .external_lex_state = 21},
  [408] = {.lex_state = 79, .external_lex_state = 2},
  [409] = {.lex_state = 89},
  [410] = {.lex_state = 197, .external_lex_state = 12},
  [411] = {.lex_state = 184, .external_lex_state = 12},
  [412] = {.lex_state = 187, .external_lex_state = 4},
  [413] = {.lex_state = 184, .external_lex_state = 13},
  [414] = {.lex_state = 89, .external_lex_state = 22},
  [415] = {.lex_state = 184, .external_lex_state = 12},
  [416] = {.lex_state = 184, .external_lex_state = 12},
  [417] = {.lex_state = 197, .external_lex_state = 12},
  [418] = {.lex_state = 199, .external_lex_state = 11},
  [419] = {.lex_state = 184, .external_lex_state = 12},
  [420] = {.lex_state = 184, .external_lex_state = 12},
  [421] = {.lex_state = 93, .external_lex_state = 9},
  [422] = {.lex_state = 125},
  [423] = {.lex_state = 93, .external_lex_state = 9},
  [424] = {.lex_state = 93, .external_lex_state = 3},
  [425] = {.lex_state = 93, .external_lex_state = 3},
  [426] = {.lex_state = 125},
  [427] = {.lex_state = 93, .external_lex_state = 6},
  [428] = {.lex_state = 93, .external_lex_state = 6},
  [429] = {.lex_state = 93, .external_lex_state = 4},
  [430] = {.lex_state = 93, .external_lex_state = 4},
  [431] = {.lex_state = 110, .external_lex_state = 6},
  [432] = {.lex_state = 89, .external_lex_state = 17},
  [433] = {.lex_state = 79, .external_lex_state = 2},
  [434] = {.lex_state = 89},
  [435] = {.lex_state = 89},
  [436] = {.lex_state = 131},
  [437] = {.lex_state = 79, .external_lex_state = 2},
  [438] = {.lex_state = 89},
  [439] = {.lex_state = 143, .external_lex_state = 4},
  [440] = {.lex_state = 110, .external_lex_state = 4},
  [441] = {.lex_state = 223, .external_lex_state = 2},
  [442] = {.lex_state = 110, .external_lex_state = 6},
  [443] = {.lex_state = 89, .external_lex_state = 22},
  [444] = {.lex_state = 110, .external_lex_state = 4},
  [445] = {.lex_state = 110, .external_lex_state = 4},
  [446] = {.lex_state = 110, .external_lex_state = 4},
  [447] = {.lex_state = 79},
  [448] = {.lex_state = 207},
  [449] = {.lex_state = 202, .external_lex_state = 14},
  [450] = {.lex_state = 136},
  [451] = {.lex_state = 226},
  [452] = {.lex_state = 89},
  [453] = {.lex_state = 202, .external_lex_state = 15},
  [454] = {.lex_state = 202, .external_lex_state = 14},
  [455] = {.lex_state = 79},
  [456] = {.lex_state = 202, .external_lex_state = 14},
  [457] = {.lex_state = 202, .external_lex_state = 14},
  [458] = {.lex_state = 202, .external_lex_state = 14},
  [459] = {.lex_state = 89, .external_lex_state = 2},
  [460] = {.lex_state = 79},
  [461] = {.lex_state = 151, .external_lex_state = 10},
  [462] = {.lex_state = 155, .external_lex_state = 5},
  [463] = {.lex_state = 125},
  [464] = {.lex_state = 151, .external_lex_state = 10},
  [465] = {.lex_state = 226},
  [466] = {.lex_state = 202, .external_lex_state = 15},
  [467] = {.lex_state = 202, .external_lex_state = 15},
  [468] = {.lex_state = 202, .external_lex_state = 15},
  [469] = {.lex_state = 155},
  [470] = {.lex_state = 117},
  [471] = {.lex_state = 228, .external_lex_state = 16},
  [472] = {.lex_state = 228, .external_lex_state = 16},
  [473] = {.lex_state = 228},
  [474] = {.lex_state = 228},
  [475] = {.lex_state = 207},
  [476] = {.lex_state = 230, .external_lex_state = 16},
  [477] = {.lex_state = 136},
  [478] = {.lex_state = 89},
  [479] = {.lex_state = 155, .external_lex_state = 16},
  [480] = {.lex_state = 79},
  [481] = {.lex_state = 79},
  [482] = {.lex_state = 230, .external_lex_state = 16},
  [483] = {.lex_state = 230, .external_lex_state = 16},
  [484] = {.lex_state = 230, .external_lex_state = 16},
  [485] = {.lex_state = 89, .external_lex_state = 2},
  [486] = {.lex_state = 79},
  [487] = {.lex_state = 151, .external_lex_state = 10},
  [488] = {.lex_state = 155, .external_lex_state = 5},
  [489] = {.lex_state = 125},
  [490] = {.lex_state = 151, .external_lex_state = 10},
  [491] = {.lex_state = 230},
  [492] = {.lex_state = 155},
  [493] = {.lex_state = 117},
  [494] = {.lex_state = 233},
  [495] = {.lex_state = 117, .external_lex_state = 22},
  [496] = {.lex_state = 187, .external_lex_state = 4},
  [497] = {.lex_state = 93, .external_lex_state = 3},
  [498] = {.lex_state = 93, .external_lex_state = 4},
  [499] = {.lex_state = 79, .external_lex_state = 2},
  [500] = {.lex_state = 89},
  [501] = {.lex_state = 79, .external_lex_state = 20},
  [502] = {.lex_state = 79, .external_lex_state = 2},
  [503] = {.lex_state = 131},
  [504] = {.lex_state = 79, .external_lex_state = 2},
  [505] = {.lex_state = 89},
  [506] = {.lex_state = 143, .external_lex_state = 4},
  [507] = {.lex_state = 110, .external_lex_state = 4},
  [508] = {.lex_state = 110, .external_lex_state = 4},
  [509] = {.lex_state = 143, .external_lex_state = 4},
  [510] = {.lex_state = 147, .external_lex_state = 3},
  [511] = {.lex_state = 89, .external_lex_state = 17},
  [512] = {.lex_state = 89},
  [513] = {.lex_state = 79, .external_lex_state = 2},
  [514] = {.lex_state = 136},
  [515] = {.lex_state = 147, .external_lex_state = 9},
  [516] = {.lex_state = 79, .external_lex_state = 2},
  [517] = {.lex_state = 99},
  [518] = {.lex_state = 79, .external_lex_state = 2},
  [519] = {.lex_state = 147, .external_lex_state = 9},
  [520] = {.lex_state = 99, .external_lex_state = 5},
  [521] = {.lex_state = 147, .external_lex_state = 3},
  [522] = {.lex_state = 147, .external_lex_state = 3},
  [523] = {.lex_state = 213, .external_lex_state = 18},
  [524] = {.lex_state = 213, .external_lex_state = 18},
  [525] = {.lex_state = 213, .external_lex_state = 18},
  [526] = {.lex_state = 213, .external_lex_state = 18},
  [527] = {.lex_state = 89, .external_lex_state = 8},
  [528] = {.lex_state = 89, .external_lex_state = 2},
  [529] = {.lex_state = 89, .external_lex_state = 2},
  [530] = {.lex_state = 136, .external_lex_state = 16},
  [531] = {.lex_state = 110, .external_lex_state = 6},
  [532] = {.lex_state = 136, .external_lex_state = 16},
  [533] = {.lex_state = 136, .external_lex_state = 16},
  [534] = {.lex_state = 79},
  [535] = {.lex_state = 89, .external_lex_state = 2},
  [536] = {.lex_state = 79},
  [537] = {.lex_state = 151, .external_lex_state = 10},
  [538] = {.lex_state = 155, .external_lex_state = 5},
  [539] = {.lex_state = 125},
  [540] = {.lex_state = 151, .external_lex_state = 10},
  [541] = {.lex_state = 136},
  [542] = {.lex_state = 207},
  [543] = {.lex_state = 136},
  [544] = {.lex_state = 89},
  [545] = {.lex_state = 89},
  [546] = {.lex_state = 117},
  [547] = {.lex_state = 117},
  [548] = {.lex_state = 79, .external_lex_state = 2},
  [549] = {.lex_state = 236, .external_lex_state = 14},
  [550] = {.lex_state = 210, .external_lex_state = 15},
  [551] = {.lex_state = 99},
  [552] = {.lex_state = 79, .external_lex_state = 2},
  [553] = {.lex_state = 79, .external_lex_state = 2},
  [554] = {.lex_state = 99, .external_lex_state = 5},
  [555] = {.lex_state = 136},
  [556] = {.lex_state = 236, .external_lex_state = 14},
  [557] = {.lex_state = 236, .external_lex_state = 15},
  [558] = {.lex_state = 236, .external_lex_state = 15},
  [559] = {.lex_state = 240, .external_lex_state = 2},
  [560] = {.lex_state = 187, .external_lex_state = 4},
  [561] = {.lex_state = 213, .external_lex_state = 19},
  [562] = {.lex_state = 228},
  [563] = {.lex_state = 207},
  [564] = {.lex_state = 213, .external_lex_state = 18},
  [565] = {.lex_state = 136},
  [566] = {.lex_state = 89},
  [567] = {.lex_state = 213, .external_lex_state = 18},
  [568] = {.lex_state = 79},
  [569] = {.lex_state = 79},
  [570] = {.lex_state = 213, .external_lex_state = 18},
  [571] = {.lex_state = 213, .external_lex_state = 18},
  [572] = {.lex_state = 213, .external_lex_state = 18},
  [573] = {.lex_state = 89, .external_lex_state = 2},
  [574] = {.lex_state = 79},
  [575] = {.lex_state = 151, .external_lex_state = 10},
  [576] = {.lex_state = 155, .external_lex_state = 5},
  [577] = {.lex_state = 125},
  [578] = {.lex_state = 151, .external_lex_state = 10},
  [579] = {.lex_state = 213, .external_lex_state = 19},
  [580] = {.lex_state = 213, .external_lex_state = 19},
  [581] = {.lex_state = 117},
  [582] = {.lex_state = 213, .external_lex_state = 19},
  [583] = {.lex_state = 117, .external_lex_state = 22},
  [584] = {.lex_state = 216},
  [585] = {.lex_state = 216, .external_lex_state = 16},
  [586] = {.lex_state = 216},
  [587] = {.lex_state = 117},
  [588] = {.lex_state = 117, .external_lex_state = 22},
  [589] = {.lex_state = 143, .external_lex_state = 4},
  [590] = {.lex_state = 147, .external_lex_state = 3},
  [591] = {.lex_state = 79, .external_lex_state = 2},
  [592] = {.lex_state = 136},
  [593] = {.lex_state = 143, .external_lex_state = 6},
  [594] = {.lex_state = 79, .external_lex_state = 2},
  [595] = {.lex_state = 99},
  [596] = {.lex_state = 79, .external_lex_state = 2},
  [597] = {.lex_state = 143, .external_lex_state = 6},
  [598] = {.lex_state = 99, .external_lex_state = 5},
  [599] = {.lex_state = 187, .external_lex_state = 4},
  [600] = {.lex_state = 143, .external_lex_state = 4},
  [601] = {.lex_state = 246, .external_lex_state = 15},
  [602] = {.lex_state = 79, .external_lex_state = 27},
  [603] = {.lex_state = 248, .external_lex_state = 15},
  [604] = {.lex_state = 89},
  [605] = {.lex_state = 187, .external_lex_state = 4},
  [606] = {.lex_state = 143, .external_lex_state = 4},
  [607] = {.lex_state = 147, .external_lex_state = 3},
  [608] = {.lex_state = 143, .external_lex_state = 6},
  [609] = {.lex_state = 187, .external_lex_state = 4},
  [610] = {.lex_state = 143, .external_lex_state = 4},
  [611] = {.lex_state = 143, .external_lex_state = 4},
  [612] = {.lex_state = 110, .external_lex_state = 4},
  [613] = {.lex_state = 110, .external_lex_state = 6},
  [614] = {.lex_state = 110, .external_lex_state = 4},
  [615] = {.lex_state = 110, .external_lex_state = 4},
  [616] = {.lex_state = 110, .external_lex_state = 4},
  [617] = {.lex_state = 79, .external_lex_state = 2},
  [618] = {.lex_state = 79, .external_lex_state = 20},
  [619] = {.lex_state = 143, .external_lex_state = 4},
  [620] = {.lex_state = 147, .external_lex_state = 3},
  [621] = {.lex_state = 93, .external_lex_state = 9},
  [622] = {.lex_state = 89, .external_lex_state = 17},
  [623] = {.lex_state = 93, .external_lex_state = 3},
  [624] = {.lex_state = 93, .external_lex_state = 3},
  [625] = {.lex_state = 93, .external_lex_state = 6},
  [626] = {.lex_state = 93, .external_lex_state = 4},
  [627] = {.lex_state = 93, .external_lex_state = 4},
  [628] = {.lex_state = 110, .external_lex_state = 6},
  [629] = {.lex_state = 147, .external_lex_state = 9},
  [630] = {.lex_state = 147, .external_lex_state = 9},
  [631] = {.lex_state = 147, .external_lex_state = 3},
  [632] = {.lex_state = 143, .external_lex_state = 4},
  [633] = {.lex_state = 147, .external_lex_state = 3},
  [634] = {.lex_state = 143, .external_lex_state = 6},
  [635] = {.lex_state = 143, .external_lex_state = 6},
  [636] = {.lex_state = 143, .external_lex_state = 4},
  [637] = {.lex_state = 89},
  [638] = {.lex_state = 143, .external_lex_state = 4},
  [639] = {.lex_state = 147, .external_lex_state = 3},
  [640] = {.lex_state = 143, .external_lex_state = 6},
  [641] = {.lex_state = 143, .external_lex_state = 4},
  [642] = {.lex_state = 143, .external_lex_state = 4},
  [643] = {.lex_state = 110, .external_lex_state = 4},
  [644] = {.lex_state = 110, .external_lex_state = 6},
  [645] = {.lex_state = 110, .external_lex_state = 4},
  [646] = {.lex_state = 110, .external_lex_state = 4},
  [647] = {.lex_state = 89, .external_lex_state = 8},
  [648] = {.lex_state = 89, .external_lex_state = 8},
  [649] = {.lex_state = 207},
  [650] = {.lex_state = 89, .external_lex_state = 8},
  [651] = {.lex_state = 89},
  [652] = {.lex_state = 89, .external_lex_state = 8},
  [653] = {.lex_state = 89, .external_lex_state = 8},
  [654] = {.lex_state = 219, .external_lex_state = 23},
  [655] = {.lex_state = 89, .external_lex_state = 8},
  [656] = {.lex_state = 219, .external_lex_state = 10},
  [657] = {.lex_state = 151, .external_lex_state = 10},
  [658] = {.lex_state = 125},
  [659] = {.lex_state = 151, .external_lex_state = 10},
  [660] = {.lex_state = 221, .external_lex_state = 10},
  [661] = {.lex_state = 219, .external_lex_state = 23},
  [662] = {.lex_state = 89, .external_lex_state = 8},
  [663] = {.lex_state = 219, .external_lex_state = 10},
  [664] = {.lex_state = 93, .external_lex_state = 9},
  [665] = {.lex_state = 93, .external_lex_state = 9},
  [666] = {.lex_state = 207},
  [667] = {.lex_state = 93, .external_lex_state = 9},
  [668] = {.lex_state = 89},
  [669] = {.lex_state = 93, .external_lex_state = 9},
  [670] = {.lex_state = 93, .external_lex_state = 9},
  [671] = {.lex_state = 89},
  [672] = {.lex_state = 93, .external_lex_state = 9},
  [673] = {.lex_state = 93, .external_lex_state = 3},
  [674] = {.lex_state = 93, .external_lex_state = 3},
  [675] = {.lex_state = 219, .external_lex_state = 23},
  [676] = {.lex_state = 93, .external_lex_state = 9},
  [677] = {.lex_state = 219, .external_lex_state = 10},
  [678] = {.lex_state = 151, .external_lex_state = 10},
  [679] = {.lex_state = 125},
  [680] = {.lex_state = 151, .external_lex_state = 10},
  [681] = {.lex_state = 221, .external_lex_state = 10},
  [682] = {.lex_state = 219, .external_lex_state = 23},
  [683] = {.lex_state = 93, .external_lex_state = 9},
  [684] = {.lex_state = 219, .external_lex_state = 10},
  [685] = {.lex_state = 93, .external_lex_state = 6},
  [686] = {.lex_state = 93, .external_lex_state = 6},
  [687] = {.lex_state = 207},
  [688] = {.lex_state = 93, .external_lex_state = 6},
  [689] = {.lex_state = 89},
  [690] = {.lex_state = 93, .external_lex_state = 6},
  [691] = {.lex_state = 93, .external_lex_state = 6},
  [692] = {.lex_state = 219, .external_lex_state = 23},
  [693] = {.lex_state = 93, .external_lex_state = 6},
  [694] = {.lex_state = 219, .external_lex_state = 10},
  [695] = {.lex_state = 151, .external_lex_state = 10},
  [696] = {.lex_state = 125},
  [697] = {.lex_state = 151, .external_lex_state = 10},
  [698] = {.lex_state = 221, .external_lex_state = 10},
  [699] = {.lex_state = 219, .external_lex_state = 23},
  [700] = {.lex_state = 93, .external_lex_state = 6},
  [701] = {.lex_state = 219, .external_lex_state = 10},
  [702] = {.lex_state = 89, .external_lex_state = 8},
  [703] = {.lex_state = 89, .external_lex_state = 2},
  [704] = {.lex_state = 89, .external_lex_state = 8},
  [705] = {.lex_state = 89, .external_lex_state = 2},
  [706] = {.lex_state = 79},
  [707] = {.lex_state = 110, .external_lex_state = 6},
  [708] = {.lex_state = 219, .external_lex_state = 10},
  [709] = {.lex_state = 219, .external_lex_state = 10},
  [710] = {.lex_state = 89},
  [711] = {.lex_state = 219, .external_lex_state = 24},
  [712] = {.lex_state = 219, .external_lex_state = 24},
  [713] = {.lex_state = 219, .external_lex_state = 24},
  [714] = {.lex_state = 219, .external_lex_state = 24},
  [715] = {.lex_state = 79},
  [716] = {.lex_state = 89, .external_lex_state = 2},
  [717] = {.lex_state = 79},
  [718] = {.lex_state = 151, .external_lex_state = 10},
  [719] = {.lex_state = 155, .external_lex_state = 5},
  [720] = {.lex_state = 125},
  [721] = {.lex_state = 151, .external_lex_state = 10},
  [722] = {.lex_state = 207},
  [723] = {.lex_state = 219, .external_lex_state = 24},
  [724] = {.lex_state = 136},
  [725] = {.lex_state = 219, .external_lex_state = 10},
  [726] = {.lex_state = 219, .external_lex_state = 10},
  [727] = {.lex_state = 219, .external_lex_state = 10},
  [728] = {.lex_state = 219, .external_lex_state = 23},
  [729] = {.lex_state = 221, .external_lex_state = 10},
  [730] = {.lex_state = 219, .external_lex_state = 23},
  [731] = {.lex_state = 110, .external_lex_state = 6},
  [732] = {.lex_state = 219, .external_lex_state = 10},
  [733] = {.lex_state = 79, .external_lex_state = 2},
  [734] = {.lex_state = 136},
  [735] = {.lex_state = 115, .external_lex_state = 24},
  [736] = {.lex_state = 79, .external_lex_state = 2},
  [737] = {.lex_state = 99},
  [738] = {.lex_state = 79, .external_lex_state = 2},
  [739] = {.lex_state = 131, .external_lex_state = 24},
  [740] = {.lex_state = 99, .external_lex_state = 5},
  [741] = {.lex_state = 115, .external_lex_state = 10},
  [742] = {.lex_state = 131, .external_lex_state = 10},
  [743] = {.lex_state = 213, .external_lex_state = 18},
  [744] = {.lex_state = 213, .external_lex_state = 18},
  [745] = {.lex_state = 213, .external_lex_state = 18},
  [746] = {.lex_state = 110, .external_lex_state = 6},
  [747] = {.lex_state = 219, .external_lex_state = 10},
  [748] = {.lex_state = 219, .external_lex_state = 10},
  [749] = {.lex_state = 79},
  [750] = {.lex_state = 187, .external_lex_state = 4},
  [751] = {.lex_state = 252, .external_lex_state = 4},
  [752] = {.lex_state = 197, .external_lex_state = 12},
  [753] = {.lex_state = 79},
  [754] = {.lex_state = 207},
  [755] = {.lex_state = 181, .external_lex_state = 25},
  [756] = {.lex_state = 136},
  [757] = {.lex_state = 89},
  [758] = {.lex_state = 181, .external_lex_state = 25},
  [759] = {.lex_state = 79},
  [760] = {.lex_state = 89, .external_lex_state = 17},
  [761] = {.lex_state = 181, .external_lex_state = 25},
  [762] = {.lex_state = 181, .external_lex_state = 25},
  [763] = {.lex_state = 181, .external_lex_state = 25},
  [764] = {.lex_state = 89, .external_lex_state = 2},
  [765] = {.lex_state = 79},
  [766] = {.lex_state = 151, .external_lex_state = 10},
  [767] = {.lex_state = 155, .external_lex_state = 5},
  [768] = {.lex_state = 125},
  [769] = {.lex_state = 151, .external_lex_state = 10},
  [770] = {.lex_state = 181, .external_lex_state = 11},
  [771] = {.lex_state = 181, .external_lex_state = 11},
  [772] = {.lex_state = 181, .external_lex_state = 11},
  [773] = {.lex_state = 79},
  [774] = {.lex_state = 207},
  [775] = {.lex_state = 181, .external_lex_state = 13},
  [776] = {.lex_state = 136},
  [777] = {.lex_state = 89},
  [778] = {.lex_state = 181, .external_lex_state = 13},
  [779] = {.lex_state = 79},
  [780] = {.lex_state = 181, .external_lex_state = 13},
  [781] = {.lex_state = 181, .external_lex_state = 13},
  [782] = {.lex_state = 181, .external_lex_state = 13},
  [783] = {.lex_state = 89, .external_lex_state = 2},
  [784] = {.lex_state = 79},
  [785] = {.lex_state = 151, .external_lex_state = 10},
  [786] = {.lex_state = 155, .external_lex_state = 5},
  [787] = {.lex_state = 125},
  [788] = {.lex_state = 151, .external_lex_state = 10},
  [789] = {.lex_state = 181, .external_lex_state = 12},
  [790] = {.lex_state = 181, .external_lex_state = 12},
  [791] = {.lex_state = 181, .external_lex_state = 12},
  [792] = {.lex_state = 184, .external_lex_state = 13},
  [793] = {.lex_state = 184, .external_lex_state = 13},
  [794] = {.lex_state = 219, .external_lex_state = 23},
  [795] = {.lex_state = 184, .external_lex_state = 13},
  [796] = {.lex_state = 219, .external_lex_state = 10},
  [797] = {.lex_state = 151, .external_lex_state = 10},
  [798] = {.lex_state = 125},
  [799] = {.lex_state = 151, .external_lex_state = 10},
  [800] = {.lex_state = 221, .external_lex_state = 10},
  [801] = {.lex_state = 219, .external_lex_state = 23},
  [802] = {.lex_state = 184, .external_lex_state = 13},
  [803] = {.lex_state = 219, .external_lex_state = 10},
  [804] = {.lex_state = 79},
  [805] = {.lex_state = 197, .external_lex_state = 12},
  [806] = {.lex_state = 79},
  [807] = {.lex_state = 184, .external_lex_state = 13},
  [808] = {.lex_state = 89},
  [809] = {.lex_state = 184, .external_lex_state = 13},
  [810] = {.lex_state = 197, .external_lex_state = 12},
  [811] = {.lex_state = 223, .external_lex_state = 2},
  [812] = {.lex_state = 226},
  [813] = {.lex_state = 202, .external_lex_state = 15},
  [814] = {.lex_state = 226},
  [815] = {.lex_state = 202, .external_lex_state = 15},
  [816] = {.lex_state = 197, .external_lex_state = 12},
  [817] = {.lex_state = 89},
  [818] = {.lex_state = 79, .external_lex_state = 2},
  [819] = {.lex_state = 136},
  [820] = {.lex_state = 199, .external_lex_state = 25},
  [821] = {.lex_state = 79, .external_lex_state = 2},
  [822] = {.lex_state = 99},
  [823] = {.lex_state = 79, .external_lex_state = 2},
  [824] = {.lex_state = 199, .external_lex_state = 25},
  [825] = {.lex_state = 99, .external_lex_state = 5},
  [826] = {.lex_state = 199, .external_lex_state = 11},
  [827] = {.lex_state = 199, .external_lex_state = 11},
  [828] = {.lex_state = 184, .external_lex_state = 13},
  [829] = {.lex_state = 207},
  [830] = {.lex_state = 89},
  [831] = {.lex_state = 89},
  [832] = {.lex_state = 210, .external_lex_state = 15},
  [833] = {.lex_state = 236, .external_lex_state = 15},
  [834] = {.lex_state = 240, .external_lex_state = 2},
  [835] = {.lex_state = 197, .external_lex_state = 12},
  [836] = {.lex_state = 197, .external_lex_state = 12},
  [837] = {.lex_state = 199, .external_lex_state = 11},
  [838] = {.lex_state = 79, .external_lex_state = 2},
  [839] = {.lex_state = 136},
  [840] = {.lex_state = 197, .external_lex_state = 13},
  [841] = {.lex_state = 79, .external_lex_state = 2},
  [842] = {.lex_state = 99},
  [843] = {.lex_state = 79, .external_lex_state = 2},
  [844] = {.lex_state = 197, .external_lex_state = 13},
  [845] = {.lex_state = 99, .external_lex_state = 5},
  [846] = {.lex_state = 197, .external_lex_state = 12},
  [847] = {.lex_state = 197, .external_lex_state = 12},
  [848] = {.lex_state = 258, .external_lex_state = 28},
  [849] = {.lex_state = 79, .external_lex_state = 27},
  [850] = {.lex_state = 258, .external_lex_state = 28},
  [851] = {.lex_state = 89},
  [852] = {.lex_state = 197, .external_lex_state = 12},
  [853] = {.lex_state = 197, .external_lex_state = 12},
  [854] = {.lex_state = 199, .external_lex_state = 11},
  [855] = {.lex_state = 197, .external_lex_state = 13},
  [856] = {.lex_state = 197, .external_lex_state = 12},
  [857] = {.lex_state = 197, .external_lex_state = 12},
  [858] = {.lex_state = 197, .external_lex_state = 12},
  [859] = {.lex_state = 184, .external_lex_state = 12},
  [860] = {.lex_state = 184, .external_lex_state = 13},
  [861] = {.lex_state = 184, .external_lex_state = 12},
  [862] = {.lex_state = 184, .external_lex_state = 12},
  [863] = {.lex_state = 184, .external_lex_state = 12},
  [864] = {.lex_state = 115, .external_lex_state = 7},
  [865] = {.lex_state = 115, .external_lex_state = 26},
  [866] = {.lex_state = 93, .external_lex_state = 9},
  [867] = {.lex_state = 89, .external_lex_state = 17},
  [868] = {.lex_state = 93, .external_lex_state = 3},
  [869] = {.lex_state = 93, .external_lex_state = 3},
  [870] = {.lex_state = 93, .external_lex_state = 6},
  [871] = {.lex_state = 93, .external_lex_state = 4},
  [872] = {.lex_state = 93, .external_lex_state = 4},
  [873] = {.lex_state = 110, .external_lex_state = 6},
  [874] = {.lex_state = 147, .external_lex_state = 9},
  [875] = {.lex_state = 147, .external_lex_state = 9},
  [876] = {.lex_state = 147, .external_lex_state = 3},
  [877] = {.lex_state = 143, .external_lex_state = 4},
  [878] = {.lex_state = 147, .external_lex_state = 3},
  [879] = {.lex_state = 143, .external_lex_state = 6},
  [880] = {.lex_state = 143, .external_lex_state = 6},
  [881] = {.lex_state = 143, .external_lex_state = 4},
  [882] = {.lex_state = 89},
  [883] = {.lex_state = 143, .external_lex_state = 4},
  [884] = {.lex_state = 147, .external_lex_state = 3},
  [885] = {.lex_state = 143, .external_lex_state = 6},
  [886] = {.lex_state = 143, .external_lex_state = 4},
  [887] = {.lex_state = 143, .external_lex_state = 4},
  [888] = {.lex_state = 110, .external_lex_state = 4},
  [889] = {.lex_state = 260, .external_lex_state = 3},
  [890] = {.lex_state = 260, .external_lex_state = 4},
  [891] = {.lex_state = 99},
  [892] = {.lex_state = 79, .external_lex_state = 2},
  [893] = {.lex_state = 79, .external_lex_state = 2},
  [894] = {.lex_state = 271, .external_lex_state = 2},
  [895] = {.lex_state = 99, .external_lex_state = 5},
  [896] = {.lex_state = 187, .external_lex_state = 4},
  [897] = {.lex_state = 273, .external_lex_state = 6},
  [898] = {.lex_state = 273, .external_lex_state = 6},
  [899] = {.lex_state = 273, .external_lex_state = 6},
  [900] = {.lex_state = 79, .external_lex_state = 2},
  [901] = {.lex_state = 123, .external_lex_state = 2},
  [902] = {.lex_state = 125},
  [903] = {.lex_state = 136},
  [904] = {.lex_state = 79, .external_lex_state = 2},
  [905] = {.lex_state = 276, .external_lex_state = 4},
  [906] = {.lex_state = 125},
  [907] = {.lex_state = 273, .external_lex_state = 4},
  [908] = {.lex_state = 89, .external_lex_state = 2},
  [909] = {.lex_state = 171},
  [910] = {.lex_state = 171},
  [911] = {.lex_state = 171},
  [912] = {.lex_state = 273, .external_lex_state = 4},
  [913] = {.lex_state = 278, .external_lex_state = 3},
  [914] = {.lex_state = 79, .external_lex_state = 2},
  [915] = {.lex_state = 273, .external_lex_state = 4},
  [916] = {.lex_state = 110, .external_lex_state = 6},
  [917] = {.lex_state = 110, .external_lex_state = 4},
  [918] = {.lex_state = 110, .external_lex_state = 4},
  [919] = {.lex_state = 202, .external_lex_state = 14},
  [920] = {.lex_state = 202, .external_lex_state = 14},
  [921] = {.lex_state = 207},
  [922] = {.lex_state = 202, .external_lex_state = 15},
  [923] = {.lex_state = 202, .external_lex_state = 14},
  [924] = {.lex_state = 281},
  [925] = {.lex_state = 89},
  [926] = {.lex_state = 202, .external_lex_state = 14},
  [927] = {.lex_state = 202, .external_lex_state = 14},
  [928] = {.lex_state = 219, .external_lex_state = 23},
  [929] = {.lex_state = 202, .external_lex_state = 14},
  [930] = {.lex_state = 219, .external_lex_state = 10},
  [931] = {.lex_state = 151, .external_lex_state = 10},
  [932] = {.lex_state = 125},
  [933] = {.lex_state = 151, .external_lex_state = 10},
  [934] = {.lex_state = 221, .external_lex_state = 10},
  [935] = {.lex_state = 219, .external_lex_state = 23},
  [936] = {.lex_state = 202, .external_lex_state = 14},
  [937] = {.lex_state = 219, .external_lex_state = 10},
  [938] = {.lex_state = 202, .external_lex_state = 15},
  [939] = {.lex_state = 281},
  [940] = {.lex_state = 228},
  [941] = {.lex_state = 228, .external_lex_state = 16},
  [942] = {.lex_state = 228},
  [943] = {.lex_state = 117},
  [944] = {.lex_state = 233},
  [945] = {.lex_state = 117, .external_lex_state = 22},
  [946] = {.lex_state = 230, .external_lex_state = 16},
  [947] = {.lex_state = 207},
  [948] = {.lex_state = 230, .external_lex_state = 16},
  [949] = {.lex_state = 89},
  [950] = {.lex_state = 155, .external_lex_state = 16},
  [951] = {.lex_state = 230, .external_lex_state = 16},
  [952] = {.lex_state = 230, .external_lex_state = 16},
  [953] = {.lex_state = 219, .external_lex_state = 23},
  [954] = {.lex_state = 230, .external_lex_state = 16},
  [955] = {.lex_state = 219, .external_lex_state = 10},
  [956] = {.lex_state = 151, .external_lex_state = 10},
  [957] = {.lex_state = 125},
  [958] = {.lex_state = 151, .external_lex_state = 10},
  [959] = {.lex_state = 221, .external_lex_state = 10},
  [960] = {.lex_state = 219, .external_lex_state = 23},
  [961] = {.lex_state = 230, .external_lex_state = 16},
  [962] = {.lex_state = 219, .external_lex_state = 10},
  [963] = {.lex_state = 233},
  [964] = {.lex_state = 233},
  [965] = {.lex_state = 143, .external_lex_state = 4},
  [966] = {.lex_state = 147, .external_lex_state = 3},
  [967] = {.lex_state = 143, .external_lex_state = 6},
  [968] = {.lex_state = 143, .external_lex_state = 6},
  [969] = {.lex_state = 143, .external_lex_state = 4},
  [970] = {.lex_state = 246, .external_lex_state = 15},
  [971] = {.lex_state = 89},
  [972] = {.lex_state = 143, .external_lex_state = 4},
  [973] = {.lex_state = 147, .external_lex_state = 3},
  [974] = {.lex_state = 143, .external_lex_state = 6},
  [975] = {.lex_state = 143, .external_lex_state = 4},
  [976] = {.lex_state = 143, .external_lex_state = 4},
  [977] = {.lex_state = 110, .external_lex_state = 4},
  [978] = {.lex_state = 79, .external_lex_state = 2},
  [979] = {.lex_state = 79, .external_lex_state = 20},
  [980] = {.lex_state = 89},
  [981] = {.lex_state = 89, .external_lex_state = 8},
  [982] = {.lex_state = 89, .external_lex_state = 2},
  [983] = {.lex_state = 89, .external_lex_state = 2},
  [984] = {.lex_state = 79, .external_lex_state = 2},
  [985] = {.lex_state = 136},
  [986] = {.lex_state = 89, .external_lex_state = 16},
  [987] = {.lex_state = 79, .external_lex_state = 2},
  [988] = {.lex_state = 99},
  [989] = {.lex_state = 147, .external_lex_state = 3},
  [990] = {.lex_state = 79, .external_lex_state = 2},
  [991] = {.lex_state = 89, .external_lex_state = 16},
  [992] = {.lex_state = 99, .external_lex_state = 5},
  [993] = {.lex_state = 89},
  [994] = {.lex_state = 89},
  [995] = {.lex_state = 79},
  [996] = {.lex_state = 207},
  [997] = {.lex_state = 147, .external_lex_state = 9},
  [998] = {.lex_state = 136},
  [999] = {.lex_state = 89},
  [1000] = {.lex_state = 147, .external_lex_state = 9},
  [1001] = {.lex_state = 79},
  [1002] = {.lex_state = 147, .external_lex_state = 9},
  [1003] = {.lex_state = 147, .external_lex_state = 9},
  [1004] = {.lex_state = 147, .external_lex_state = 9},
  [1005] = {.lex_state = 89, .external_lex_state = 2},
  [1006] = {.lex_state = 79},
  [1007] = {.lex_state = 151, .external_lex_state = 10},
  [1008] = {.lex_state = 155, .external_lex_state = 5},
  [1009] = {.lex_state = 125},
  [1010] = {.lex_state = 151, .external_lex_state = 10},
  [1011] = {.lex_state = 147, .external_lex_state = 3},
  [1012] = {.lex_state = 147, .external_lex_state = 3},
  [1013] = {.lex_state = 125, .external_lex_state = 16},
  [1014] = {.lex_state = 284, .external_lex_state = 19},
  [1015] = {.lex_state = 213, .external_lex_state = 18},
  [1016] = {.lex_state = 213, .external_lex_state = 19},
  [1017] = {.lex_state = 125, .external_lex_state = 16},
  [1018] = {.lex_state = 213, .external_lex_state = 18},
  [1019] = {.lex_state = 213, .external_lex_state = 19},
  [1020] = {.lex_state = 213, .external_lex_state = 18},
  [1021] = {.lex_state = 136},
  [1022] = {.lex_state = 136, .external_lex_state = 16},
  [1023] = {.lex_state = 219, .external_lex_state = 23},
  [1024] = {.lex_state = 136, .external_lex_state = 16},
  [1025] = {.lex_state = 219, .external_lex_state = 10},
  [1026] = {.lex_state = 151, .external_lex_state = 10},
  [1027] = {.lex_state = 125},
  [1028] = {.lex_state = 151, .external_lex_state = 10},
  [1029] = {.lex_state = 221, .external_lex_state = 10},
  [1030] = {.lex_state = 219, .external_lex_state = 23},
  [1031] = {.lex_state = 136, .external_lex_state = 16},
  [1032] = {.lex_state = 219, .external_lex_state = 10},
  [1033] = {.lex_state = 110, .external_lex_state = 6},
  [1034] = {.lex_state = 207},
  [1035] = {.lex_state = 79, .external_lex_state = 2},
  [1036] = {.lex_state = 136},
  [1037] = {.lex_state = 248, .external_lex_state = 14},
  [1038] = {.lex_state = 79, .external_lex_state = 2},
  [1039] = {.lex_state = 99},
  [1040] = {.lex_state = 79, .external_lex_state = 2},
  [1041] = {.lex_state = 248, .external_lex_state = 14},
  [1042] = {.lex_state = 99, .external_lex_state = 5},
  [1043] = {.lex_state = 248, .external_lex_state = 15},
  [1044] = {.lex_state = 248, .external_lex_state = 15},
  [1045] = {.lex_state = 187, .external_lex_state = 4},
  [1046] = {.lex_state = 236, .external_lex_state = 15},
  [1047] = {.lex_state = 228},
  [1048] = {.lex_state = 79},
  [1049] = {.lex_state = 89},
  [1050] = {.lex_state = 236, .external_lex_state = 14},
  [1051] = {.lex_state = 117},
  [1052] = {.lex_state = 236, .external_lex_state = 15},
  [1053] = {.lex_state = 236, .external_lex_state = 14},
  [1054] = {.lex_state = 236, .external_lex_state = 14},
  [1055] = {.lex_state = 236, .external_lex_state = 14},
  [1056] = {.lex_state = 79},
  [1057] = {.lex_state = 89, .external_lex_state = 2},
  [1058] = {.lex_state = 79},
  [1059] = {.lex_state = 151, .external_lex_state = 10},
  [1060] = {.lex_state = 155, .external_lex_state = 5},
  [1061] = {.lex_state = 125},
  [1062] = {.lex_state = 151, .external_lex_state = 10},
  [1063] = {.lex_state = 207},
  [1064] = {.lex_state = 236, .external_lex_state = 14},
  [1065] = {.lex_state = 136},
  [1066] = {.lex_state = 236, .external_lex_state = 15},
  [1067] = {.lex_state = 236, .external_lex_state = 15},
  [1068] = {.lex_state = 117},
  [1069] = {.lex_state = 210, .external_lex_state = 15},
  [1070] = {.lex_state = 236, .external_lex_state = 15},
  [1071] = {.lex_state = 117, .external_lex_state = 22},
  [1072] = {.lex_state = 286, .external_lex_state = 3},
  [1073] = {.lex_state = 286, .external_lex_state = 4},
  [1074] = {.lex_state = 99},
  [1075] = {.lex_state = 79, .external_lex_state = 2},
  [1076] = {.lex_state = 79, .external_lex_state = 2},
  [1077] = {.lex_state = 187, .external_lex_state = 4},
  [1078] = {.lex_state = 99, .external_lex_state = 5},
  [1079] = {.lex_state = 293, .external_lex_state = 6},
  [1080] = {.lex_state = 293, .external_lex_state = 6},
  [1081] = {.lex_state = 293, .external_lex_state = 6},
  [1082] = {.lex_state = 79, .external_lex_state = 2},
  [1083] = {.lex_state = 123, .external_lex_state = 2},
  [1084] = {.lex_state = 125},
  [1085] = {.lex_state = 136},
  [1086] = {.lex_state = 296, .external_lex_state = 4},
  [1087] = {.lex_state = 125},
  [1088] = {.lex_state = 293, .external_lex_state = 4},
  [1089] = {.lex_state = 89, .external_lex_state = 2},
  [1090] = {.lex_state = 298},
  [1091] = {.lex_state = 293, .external_lex_state = 4},
  [1092] = {.lex_state = 300, .external_lex_state = 3},
  [1093] = {.lex_state = 79, .external_lex_state = 2},
  [1094] = {.lex_state = 293, .external_lex_state = 4},
  [1095] = {.lex_state = 213, .external_lex_state = 19},
  [1096] = {.lex_state = 213, .external_lex_state = 18},
  [1097] = {.lex_state = 207},
  [1098] = {.lex_state = 213, .external_lex_state = 18},
  [1099] = {.lex_state = 89},
  [1100] = {.lex_state = 213, .external_lex_state = 18},
  [1101] = {.lex_state = 213, .external_lex_state = 18},
  [1102] = {.lex_state = 213, .external_lex_state = 18},
  [1103] = {.lex_state = 219, .external_lex_state = 23},
  [1104] = {.lex_state = 213, .external_lex_state = 18},
  [1105] = {.lex_state = 219, .external_lex_state = 10},
  [1106] = {.lex_state = 151, .external_lex_state = 10},
  [1107] = {.lex_state = 125},
  [1108] = {.lex_state = 151, .external_lex_state = 10},
  [1109] = {.lex_state = 221, .external_lex_state = 10},
  [1110] = {.lex_state = 219, .external_lex_state = 23},
  [1111] = {.lex_state = 213, .external_lex_state = 18},
  [1112] = {.lex_state = 219, .external_lex_state = 10},
  [1113] = {.lex_state = 213, .external_lex_state = 19},
  [1114] = {.lex_state = 213, .external_lex_state = 19},
  [1115] = {.lex_state = 216, .external_lex_state = 16},
  [1116] = {.lex_state = 79},
  [1117] = {.lex_state = 207},
  [1118] = {.lex_state = 303, .external_lex_state = 6},
  [1119] = {.lex_state = 136},
  [1120] = {.lex_state = 89},
  [1121] = {.lex_state = 143, .external_lex_state = 6},
  [1122] = {.lex_state = 79},
  [1123] = {.lex_state = 303, .external_lex_state = 6},
  [1124] = {.lex_state = 303, .external_lex_state = 6},
  [1125] = {.lex_state = 303, .external_lex_state = 6},
  [1126] = {.lex_state = 89, .external_lex_state = 2},
  [1127] = {.lex_state = 79},
  [1128] = {.lex_state = 151, .external_lex_state = 10},
  [1129] = {.lex_state = 155, .external_lex_state = 5},
  [1130] = {.lex_state = 125},
  [1131] = {.lex_state = 151, .external_lex_state = 10},
  [1132] = {.lex_state = 187, .external_lex_state = 4},
  [1133] = {.lex_state = 143, .external_lex_state = 4},
  [1134] = {.lex_state = 99},
  [1135] = {.lex_state = 79, .external_lex_state = 2},
  [1136] = {.lex_state = 79, .external_lex_state = 2},
  [1137] = {.lex_state = 246, .external_lex_state = 15},
  [1138] = {.lex_state = 99, .external_lex_state = 5},
  [1139] = {.lex_state = 79, .external_lex_state = 27},
  [1140] = {.lex_state = 79, .external_lex_state = 2},
  [1141] = {.lex_state = 143, .external_lex_state = 6},
  [1142] = {.lex_state = 187, .external_lex_state = 4},
  [1143] = {.lex_state = 143, .external_lex_state = 4},
  [1144] = {.lex_state = 248, .external_lex_state = 15},
  [1145] = {.lex_state = 79, .external_lex_state = 2},
  [1146] = {.lex_state = 79, .external_lex_state = 20},
  [1147] = {.lex_state = 93, .external_lex_state = 9},
  [1148] = {.lex_state = 93, .external_lex_state = 9},
  [1149] = {.lex_state = 93, .external_lex_state = 3},
  [1150] = {.lex_state = 93, .external_lex_state = 6},
  [1151] = {.lex_state = 147, .external_lex_state = 9},
  [1152] = {.lex_state = 147, .external_lex_state = 3},
  [1153] = {.lex_state = 143, .external_lex_state = 6},
  [1154] = {.lex_state = 143, .external_lex_state = 4},
  [1155] = {.lex_state = 143, .external_lex_state = 6},
  [1156] = {.lex_state = 143, .external_lex_state = 4},
  [1157] = {.lex_state = 89, .external_lex_state = 8},
  [1158] = {.lex_state = 305, .external_lex_state = 2},
  [1159] = {.lex_state = 89, .external_lex_state = 8},
  [1160] = {.lex_state = 219, .external_lex_state = 10},
  [1161] = {.lex_state = 219, .external_lex_state = 10},
  [1162] = {.lex_state = 219, .external_lex_state = 23},
  [1163] = {.lex_state = 221, .external_lex_state = 10},
  [1164] = {.lex_state = 219, .external_lex_state = 23},
  [1165] = {.lex_state = 89, .external_lex_state = 8},
  [1166] = {.lex_state = 219, .external_lex_state = 10},
  [1167] = {.lex_state = 115, .external_lex_state = 24},
  [1168] = {.lex_state = 115, .external_lex_state = 10},
  [1169] = {.lex_state = 131, .external_lex_state = 10},
  [1170] = {.lex_state = 89, .external_lex_state = 8},
  [1171] = {.lex_state = 219, .external_lex_state = 10},
  [1172] = {.lex_state = 219, .external_lex_state = 10},
  [1173] = {.lex_state = 93, .external_lex_state = 9},
  [1174] = {.lex_state = 307, .external_lex_state = 3},
  [1175] = {.lex_state = 93, .external_lex_state = 3},
  [1176] = {.lex_state = 89},
  [1177] = {.lex_state = 93, .external_lex_state = 9},
  [1178] = {.lex_state = 219, .external_lex_state = 10},
  [1179] = {.lex_state = 219, .external_lex_state = 10},
  [1180] = {.lex_state = 219, .external_lex_state = 23},
  [1181] = {.lex_state = 221, .external_lex_state = 10},
  [1182] = {.lex_state = 219, .external_lex_state = 23},
  [1183] = {.lex_state = 93, .external_lex_state = 9},
  [1184] = {.lex_state = 219, .external_lex_state = 10},
  [1185] = {.lex_state = 115, .external_lex_state = 24},
  [1186] = {.lex_state = 115, .external_lex_state = 10},
  [1187] = {.lex_state = 131, .external_lex_state = 10},
  [1188] = {.lex_state = 93, .external_lex_state = 9},
  [1189] = {.lex_state = 219, .external_lex_state = 10},
  [1190] = {.lex_state = 219, .external_lex_state = 10},
  [1191] = {.lex_state = 93, .external_lex_state = 6},
  [1192] = {.lex_state = 307, .external_lex_state = 4},
  [1193] = {.lex_state = 93, .external_lex_state = 6},
  [1194] = {.lex_state = 219, .external_lex_state = 10},
  [1195] = {.lex_state = 219, .external_lex_state = 10},
  [1196] = {.lex_state = 219, .external_lex_state = 23},
  [1197] = {.lex_state = 221, .external_lex_state = 10},
  [1198] = {.lex_state = 219, .external_lex_state = 23},
  [1199] = {.lex_state = 93, .external_lex_state = 6},
  [1200] = {.lex_state = 219, .external_lex_state = 10},
  [1201] = {.lex_state = 115, .external_lex_state = 24},
  [1202] = {.lex_state = 115, .external_lex_state = 10},
  [1203] = {.lex_state = 131, .external_lex_state = 10},
  [1204] = {.lex_state = 93, .external_lex_state = 6},
  [1205] = {.lex_state = 219, .external_lex_state = 10},
  [1206] = {.lex_state = 219, .external_lex_state = 10},
  [1207] = {.lex_state = 89, .external_lex_state = 8},
  [1208] = {.lex_state = 219, .external_lex_state = 24},
  [1209] = {.lex_state = 110, .external_lex_state = 6},
  [1210] = {.lex_state = 219, .external_lex_state = 10},
  [1211] = {.lex_state = 219, .external_lex_state = 24},
  [1212] = {.lex_state = 89},
  [1213] = {.lex_state = 219, .external_lex_state = 24},
  [1214] = {.lex_state = 219, .external_lex_state = 24},
  [1215] = {.lex_state = 219, .external_lex_state = 23},
  [1216] = {.lex_state = 219, .external_lex_state = 24},
  [1217] = {.lex_state = 219, .external_lex_state = 10},
  [1218] = {.lex_state = 151, .external_lex_state = 10},
  [1219] = {.lex_state = 125},
  [1220] = {.lex_state = 151, .external_lex_state = 10},
  [1221] = {.lex_state = 221, .external_lex_state = 10},
  [1222] = {.lex_state = 219, .external_lex_state = 23},
  [1223] = {.lex_state = 219, .external_lex_state = 24},
  [1224] = {.lex_state = 219, .external_lex_state = 10},
  [1225] = {.lex_state = 219, .external_lex_state = 24},
  [1226] = {.lex_state = 207},
  [1227] = {.lex_state = 219, .external_lex_state = 10},
  [1228] = {.lex_state = 115, .external_lex_state = 24},
  [1229] = {.lex_state = 115, .external_lex_state = 10},
  [1230] = {.lex_state = 131, .external_lex_state = 10},
  [1231] = {.lex_state = 110, .external_lex_state = 6},
  [1232] = {.lex_state = 219, .external_lex_state = 10},
  [1233] = {.lex_state = 219, .external_lex_state = 10},
  [1234] = {.lex_state = 79},
  [1235] = {.lex_state = 207},
  [1236] = {.lex_state = 115, .external_lex_state = 24},
  [1237] = {.lex_state = 136},
  [1238] = {.lex_state = 89},
  [1239] = {.lex_state = 115, .external_lex_state = 24},
  [1240] = {.lex_state = 79},
  [1241] = {.lex_state = 115, .external_lex_state = 24},
  [1242] = {.lex_state = 115, .external_lex_state = 24},
  [1243] = {.lex_state = 115, .external_lex_state = 24},
  [1244] = {.lex_state = 89, .external_lex_state = 2},
  [1245] = {.lex_state = 79},
  [1246] = {.lex_state = 151, .external_lex_state = 10},
  [1247] = {.lex_state = 155, .external_lex_state = 5},
  [1248] = {.lex_state = 125},
  [1249] = {.lex_state = 151, .external_lex_state = 10},
  [1250] = {.lex_state = 131, .external_lex_state = 10},
  [1251] = {.lex_state = 110, .external_lex_state = 6},
  [1252] = {.lex_state = 131, .external_lex_state = 10},
  [1253] = {.lex_state = 151, .external_lex_state = 24},
  [1254] = {.lex_state = 284, .external_lex_state = 19},
  [1255] = {.lex_state = 213, .external_lex_state = 19},
  [1256] = {.lex_state = 151, .external_lex_state = 24},
  [1257] = {.lex_state = 213, .external_lex_state = 19},
  [1258] = {.lex_state = 110, .external_lex_state = 6},
  [1259] = {.lex_state = 219, .external_lex_state = 10},
  [1260] = {.lex_state = 187, .external_lex_state = 4},
  [1261] = {.lex_state = 181, .external_lex_state = 25},
  [1262] = {.lex_state = 181, .external_lex_state = 25},
  [1263] = {.lex_state = 207},
  [1264] = {.lex_state = 181, .external_lex_state = 25},
  [1265] = {.lex_state = 89},
  [1266] = {.lex_state = 181, .external_lex_state = 25},
  [1267] = {.lex_state = 181, .external_lex_state = 25},
  [1268] = {.lex_state = 89},
  [1269] = {.lex_state = 181, .external_lex_state = 25},
  [1270] = {.lex_state = 181, .external_lex_state = 11},
  [1271] = {.lex_state = 181, .external_lex_state = 11},
  [1272] = {.lex_state = 219, .external_lex_state = 23},
  [1273] = {.lex_state = 181, .external_lex_state = 25},
  [1274] = {.lex_state = 219, .external_lex_state = 10},
  [1275] = {.lex_state = 151, .external_lex_state = 10},
  [1276] = {.lex_state = 125},
  [1277] = {.lex_state = 151, .external_lex_state = 10},
  [1278] = {.lex_state = 221, .external_lex_state = 10},
  [1279] = {.lex_state = 219, .external_lex_state = 23},
  [1280] = {.lex_state = 181, .external_lex_state = 25},
  [1281] = {.lex_state = 219, .external_lex_state = 10},
  [1282] = {.lex_state = 181, .external_lex_state = 13},
  [1283] = {.lex_state = 181, .external_lex_state = 13},
  [1284] = {.lex_state = 207},
  [1285] = {.lex_state = 181, .external_lex_state = 13},
  [1286] = {.lex_state = 89},
  [1287] = {.lex_state = 181, .external_lex_state = 13},
  [1288] = {.lex_state = 181, .external_lex_state = 13},
  [1289] = {.lex_state = 219, .external_lex_state = 23},
  [1290] = {.lex_state = 181, .external_lex_state = 13},
  [1291] = {.lex_state = 219, .external_lex_state = 10},
  [1292] = {.lex_state = 151, .external_lex_state = 10},
  [1293] = {.lex_state = 125},
  [1294] = {.lex_state = 151, .external_lex_state = 10},
  [1295] = {.lex_state = 221, .external_lex_state = 10},
  [1296] = {.lex_state = 219, .external_lex_state = 23},
  [1297] = {.lex_state = 181, .external_lex_state = 13},
  [1298] = {.lex_state = 219, .external_lex_state = 10},
  [1299] = {.lex_state = 184, .external_lex_state = 13},
  [1300] = {.lex_state = 219, .external_lex_state = 10},
  [1301] = {.lex_state = 219, .external_lex_state = 10},
  [1302] = {.lex_state = 219, .external_lex_state = 23},
  [1303] = {.lex_state = 221, .external_lex_state = 10},
  [1304] = {.lex_state = 219, .external_lex_state = 23},
  [1305] = {.lex_state = 184, .external_lex_state = 13},
  [1306] = {.lex_state = 219, .external_lex_state = 10},
  [1307] = {.lex_state = 115, .external_lex_state = 24},
  [1308] = {.lex_state = 115, .external_lex_state = 10},
  [1309] = {.lex_state = 131, .external_lex_state = 10},
  [1310] = {.lex_state = 184, .external_lex_state = 13},
  [1311] = {.lex_state = 219, .external_lex_state = 10},
  [1312] = {.lex_state = 219, .external_lex_state = 10},
  [1313] = {.lex_state = 79},
  [1314] = {.lex_state = 197, .external_lex_state = 12},
  [1315] = {.lex_state = 311, .external_lex_state = 12},
  [1316] = {.lex_state = 197, .external_lex_state = 12},
  [1317] = {.lex_state = 171},
  [1318] = {.lex_state = 171},
  [1319] = {.lex_state = 171},
  [1320] = {.lex_state = 202, .external_lex_state = 15},
  [1321] = {.lex_state = 281},
  [1322] = {.lex_state = 202, .external_lex_state = 15},
  [1323] = {.lex_state = 281},
  [1324] = {.lex_state = 199, .external_lex_state = 11},
  [1325] = {.lex_state = 89},
  [1326] = {.lex_state = 79},
  [1327] = {.lex_state = 207},
  [1328] = {.lex_state = 199, .external_lex_state = 25},
  [1329] = {.lex_state = 136},
  [1330] = {.lex_state = 89},
  [1331] = {.lex_state = 199, .external_lex_state = 25},
  [1332] = {.lex_state = 79},
  [1333] = {.lex_state = 199, .external_lex_state = 25},
  [1334] = {.lex_state = 199, .external_lex_state = 25},
  [1335] = {.lex_state = 199, .external_lex_state = 25},
  [1336] = {.lex_state = 89, .external_lex_state = 2},
  [1337] = {.lex_state = 79},
  [1338] = {.lex_state = 151, .external_lex_state = 10},
  [1339] = {.lex_state = 155, .external_lex_state = 5},
  [1340] = {.lex_state = 125},
  [1341] = {.lex_state = 151, .external_lex_state = 10},
  [1342] = {.lex_state = 199, .external_lex_state = 11},
  [1343] = {.lex_state = 199, .external_lex_state = 11},
  [1344] = {.lex_state = 184, .external_lex_state = 13},
  [1345] = {.lex_state = 248, .external_lex_state = 15},
  [1346] = {.lex_state = 197, .external_lex_state = 12},
  [1347] = {.lex_state = 117},
  [1348] = {.lex_state = 236, .external_lex_state = 15},
  [1349] = {.lex_state = 210, .external_lex_state = 15},
  [1350] = {.lex_state = 197, .external_lex_state = 12},
  [1351] = {.lex_state = 298},
  [1352] = {.lex_state = 79},
  [1353] = {.lex_state = 207},
  [1354] = {.lex_state = 197, .external_lex_state = 13},
  [1355] = {.lex_state = 136},
  [1356] = {.lex_state = 89},
  [1357] = {.lex_state = 197, .external_lex_state = 13},
  [1358] = {.lex_state = 79},
  [1359] = {.lex_state = 197, .external_lex_state = 13},
  [1360] = {.lex_state = 197, .external_lex_state = 13},
  [1361] = {.lex_state = 197, .external_lex_state = 13},
  [1362] = {.lex_state = 89, .external_lex_state = 2},
  [1363] = {.lex_state = 79},
  [1364] = {.lex_state = 151, .external_lex_state = 10},
  [1365] = {.lex_state = 155, .external_lex_state = 5},
  [1366] = {.lex_state = 125},
  [1367] = {.lex_state = 151, .external_lex_state = 10},
  [1368] = {.lex_state = 197, .external_lex_state = 12},
  [1369] = {.lex_state = 197, .external_lex_state = 12},
  [1370] = {.lex_state = 258, .external_lex_state = 28},
  [1371] = {.lex_state = 79, .external_lex_state = 27},
  [1372] = {.lex_state = 115, .external_lex_state = 7},
  [1373] = {.lex_state = 197, .external_lex_state = 13},
  [1374] = {.lex_state = 197, .external_lex_state = 12},
  [1375] = {.lex_state = 197, .external_lex_state = 12},
  [1376] = {.lex_state = 258, .external_lex_state = 28},
  [1377] = {.lex_state = 93, .external_lex_state = 9},
  [1378] = {.lex_state = 93, .external_lex_state = 9},
  [1379] = {.lex_state = 93, .external_lex_state = 3},
  [1380] = {.lex_state = 93, .external_lex_state = 6},
  [1381] = {.lex_state = 147, .external_lex_state = 9},
  [1382] = {.lex_state = 147, .external_lex_state = 3},
  [1383] = {.lex_state = 143, .external_lex_state = 6},
  [1384] = {.lex_state = 143, .external_lex_state = 4},
  [1385] = {.lex_state = 143, .external_lex_state = 6},
  [1386] = {.lex_state = 143, .external_lex_state = 4},
  [1387] = {.lex_state = 79, .external_lex_state = 2},
  [1388] = {.lex_state = 136},
  [1389] = {.lex_state = 260, .external_lex_state = 9},
  [1390] = {.lex_state = 79, .external_lex_state = 2},
  [1391] = {.lex_state = 125},
  [1392] = {.lex_state = 99},
  [1393] = {.lex_state = 79, .external_lex_state = 2},
  [1394] = {.lex_state = 260, .external_lex_state = 9},
  [1395] = {.lex_state = 99, .external_lex_state = 5},
  [1396] = {.lex_state = 260, .external_lex_state = 3},
  [1397] = {.lex_state = 260, .external_lex_state = 3},
  [1398] = {.lex_state = 125},
  [1399] = {.lex_state = 79, .external_lex_state = 2},
  [1400] = {.lex_state = 136},
  [1401] = {.lex_state = 260, .external_lex_state = 6},
  [1402] = {.lex_state = 79, .external_lex_state = 2},
  [1403] = {.lex_state = 99},
  [1404] = {.lex_state = 79, .external_lex_state = 2},
  [1405] = {.lex_state = 260, .external_lex_state = 6},
  [1406] = {.lex_state = 99, .external_lex_state = 5},
  [1407] = {.lex_state = 260, .external_lex_state = 4},
  [1408] = {.lex_state = 260, .external_lex_state = 4},
  [1409] = {.lex_state = 273, .external_lex_state = 6},
  [1410] = {.lex_state = 273, .external_lex_state = 6},
  [1411] = {.lex_state = 273, .external_lex_state = 6},
  [1412] = {.lex_state = 79},
  [1413] = {.lex_state = 89, .external_lex_state = 2},
  [1414] = {.lex_state = 79},
  [1415] = {.lex_state = 314, .external_lex_state = 3},
  [1416] = {.lex_state = 314, .external_lex_state = 4},
  [1417] = {.lex_state = 99},
  [1418] = {.lex_state = 79, .external_lex_state = 2},
  [1419] = {.lex_state = 79, .external_lex_state = 2},
  [1420] = {.lex_state = 99, .external_lex_state = 5},
  [1421] = {.lex_state = 317, .external_lex_state = 6},
  [1422] = {.lex_state = 317, .external_lex_state = 6},
  [1423] = {.lex_state = 317, .external_lex_state = 6},
  [1424] = {.lex_state = 79, .external_lex_state = 2},
  [1425] = {.lex_state = 123, .external_lex_state = 2},
  [1426] = {.lex_state = 125},
  [1427] = {.lex_state = 136},
  [1428] = {.lex_state = 276, .external_lex_state = 4},
  [1429] = {.lex_state = 125},
  [1430] = {.lex_state = 317, .external_lex_state = 4},
  [1431] = {.lex_state = 89, .external_lex_state = 2},
  [1432] = {.lex_state = 171},
  [1433] = {.lex_state = 317, .external_lex_state = 4},
  [1434] = {.lex_state = 320, .external_lex_state = 3},
  [1435] = {.lex_state = 79, .external_lex_state = 2},
  [1436] = {.lex_state = 317, .external_lex_state = 4},
  [1437] = {.lex_state = 151, .external_lex_state = 10},
  [1438] = {.lex_state = 155, .external_lex_state = 5},
  [1439] = {.lex_state = 125},
  [1440] = {.lex_state = 151, .external_lex_state = 10},
  [1441] = {.lex_state = 89},
  [1442] = {.lex_state = 273, .external_lex_state = 6},
  [1443] = {.lex_state = 79},
  [1444] = {.lex_state = 89, .external_lex_state = 17},
  [1445] = {.lex_state = 207},
  [1446] = {.lex_state = 273, .external_lex_state = 6},
  [1447] = {.lex_state = 136},
  [1448] = {.lex_state = 89},
  [1449] = {.lex_state = 79, .external_lex_state = 2},
  [1450] = {.lex_state = 89},
  [1451] = {.lex_state = 223, .external_lex_state = 20},
  [1452] = {.lex_state = 223, .external_lex_state = 2},
  [1453] = {.lex_state = 131},
  [1454] = {.lex_state = 79, .external_lex_state = 2},
  [1455] = {.lex_state = 89},
  [1456] = {.lex_state = 276, .external_lex_state = 4},
  [1457] = {.lex_state = 273, .external_lex_state = 4},
  [1458] = {.lex_state = 187, .external_lex_state = 4},
  [1459] = {.lex_state = 171},
  [1460] = {.lex_state = 171},
  [1461] = {.lex_state = 171},
  [1462] = {.lex_state = 273, .external_lex_state = 6},
  [1463] = {.lex_state = 89, .external_lex_state = 22},
  [1464] = {.lex_state = 273, .external_lex_state = 4},
  [1465] = {.lex_state = 273, .external_lex_state = 4},
  [1466] = {.lex_state = 276, .external_lex_state = 4},
  [1467] = {.lex_state = 278, .external_lex_state = 3},
  [1468] = {.lex_state = 273, .external_lex_state = 4},
  [1469] = {.lex_state = 273, .external_lex_state = 4},
  [1470] = {.lex_state = 202, .external_lex_state = 14},
  [1471] = {.lex_state = 281},
  [1472] = {.lex_state = 89, .external_lex_state = 16},
  [1473] = {.lex_state = 187, .external_lex_state = 4},
  [1474] = {.lex_state = 89, .external_lex_state = 16},
  [1475] = {.lex_state = 89},
  [1476] = {.lex_state = 323},
  [1477] = {.lex_state = 89},
  [1478] = {.lex_state = 89},
  [1479] = {.lex_state = 326, .external_lex_state = 15},
  [1480] = {.lex_state = 202, .external_lex_state = 14},
  [1481] = {.lex_state = 219, .external_lex_state = 10},
  [1482] = {.lex_state = 219, .external_lex_state = 10},
  [1483] = {.lex_state = 219, .external_lex_state = 23},
  [1484] = {.lex_state = 221, .external_lex_state = 10},
  [1485] = {.lex_state = 219, .external_lex_state = 23},
  [1486] = {.lex_state = 202, .external_lex_state = 14},
  [1487] = {.lex_state = 219, .external_lex_state = 10},
  [1488] = {.lex_state = 115, .external_lex_state = 24},
  [1489] = {.lex_state = 115, .external_lex_state = 10},
  [1490] = {.lex_state = 131, .external_lex_state = 10},
  [1491] = {.lex_state = 202, .external_lex_state = 14},
  [1492] = {.lex_state = 219, .external_lex_state = 10},
  [1493] = {.lex_state = 219, .external_lex_state = 10},
  [1494] = {.lex_state = 281},
  [1495] = {.lex_state = 187, .external_lex_state = 4},
  [1496] = {.lex_state = 323},
  [1497] = {.lex_state = 89},
  [1498] = {.lex_state = 228, .external_lex_state = 16},
  [1499] = {.lex_state = 230, .external_lex_state = 16},
  [1500] = {.lex_state = 330},
  [1501] = {.lex_state = 230, .external_lex_state = 16},
  [1502] = {.lex_state = 219, .external_lex_state = 10},
  [1503] = {.lex_state = 219, .external_lex_state = 10},
  [1504] = {.lex_state = 219, .external_lex_state = 23},
  [1505] = {.lex_state = 221, .external_lex_state = 10},
  [1506] = {.lex_state = 219, .external_lex_state = 23},
  [1507] = {.lex_state = 230, .external_lex_state = 16},
  [1508] = {.lex_state = 219, .external_lex_state = 10},
  [1509] = {.lex_state = 115, .external_lex_state = 24},
  [1510] = {.lex_state = 115, .external_lex_state = 10},
  [1511] = {.lex_state = 131, .external_lex_state = 10},
  [1512] = {.lex_state = 230, .external_lex_state = 16},
  [1513] = {.lex_state = 219, .external_lex_state = 10},
  [1514] = {.lex_state = 219, .external_lex_state = 10},
  [1515] = {.lex_state = 143, .external_lex_state = 6},
  [1516] = {.lex_state = 143, .external_lex_state = 4},
  [1517] = {.lex_state = 79, .external_lex_state = 2},
  [1518] = {.lex_state = 143, .external_lex_state = 6},
  [1519] = {.lex_state = 143, .external_lex_state = 4},
  [1520] = {.lex_state = 246, .external_lex_state = 15},
  [1521] = {.lex_state = 89, .external_lex_state = 2},
  [1522] = {.lex_state = 89},
  [1523] = {.lex_state = 79},
  [1524] = {.lex_state = 207},
  [1525] = {.lex_state = 89, .external_lex_state = 16},
  [1526] = {.lex_state = 136},
  [1527] = {.lex_state = 89},
  [1528] = {.lex_state = 89, .external_lex_state = 16},
  [1529] = {.lex_state = 79},
  [1530] = {.lex_state = 89, .external_lex_state = 16},
  [1531] = {.lex_state = 89, .external_lex_state = 16},
  [1532] = {.lex_state = 89, .external_lex_state = 16},
  [1533] = {.lex_state = 89, .external_lex_state = 2},
  [1534] = {.lex_state = 79},
  [1535] = {.lex_state = 151, .external_lex_state = 10},
  [1536] = {.lex_state = 155, .external_lex_state = 5},
  [1537] = {.lex_state = 125},
  [1538] = {.lex_state = 151, .external_lex_state = 10},
  [1539] = {.lex_state = 89},
  [1540] = {.lex_state = 89},
  [1541] = {.lex_state = 147, .external_lex_state = 3},
  [1542] = {.lex_state = 89},
  [1543] = {.lex_state = 147, .external_lex_state = 9},
  [1544] = {.lex_state = 147, .external_lex_state = 9},
  [1545] = {.lex_state = 207},
  [1546] = {.lex_state = 147, .external_lex_state = 9},
  [1547] = {.lex_state = 89},
  [1548] = {.lex_state = 147, .external_lex_state = 9},
  [1549] = {.lex_state = 147, .external_lex_state = 9},
  [1550] = {.lex_state = 219, .external_lex_state = 23},
  [1551] = {.lex_state = 147, .external_lex_state = 9},
  [1552] = {.lex_state = 219, .external_lex_state = 10},
  [1553] = {.lex_state = 151, .external_lex_state = 10},
  [1554] = {.lex_state = 125},
  [1555] = {.lex_state = 151, .external_lex_state = 10},
  [1556] = {.lex_state = 221, .external_lex_state = 10},
  [1557] = {.lex_state = 219, .external_lex_state = 23},
  [1558] = {.lex_state = 147, .external_lex_state = 9},
  [1559] = {.lex_state = 219, .external_lex_state = 10},
  [1560] = {.lex_state = 125},
  [1561] = {.lex_state = 125, .external_lex_state = 16},
  [1562] = {.lex_state = 89},
  [1563] = {.lex_state = 213, .external_lex_state = 18},
  [1564] = {.lex_state = 125},
  [1565] = {.lex_state = 125, .external_lex_state = 16},
  [1566] = {.lex_state = 136, .external_lex_state = 16},
  [1567] = {.lex_state = 219, .external_lex_state = 10},
  [1568] = {.lex_state = 219, .external_lex_state = 10},
  [1569] = {.lex_state = 219, .external_lex_state = 23},
  [1570] = {.lex_state = 221, .external_lex_state = 10},
  [1571] = {.lex_state = 219, .external_lex_state = 23},
  [1572] = {.lex_state = 136, .external_lex_state = 16},
  [1573] = {.lex_state = 219, .external_lex_state = 10},
  [1574] = {.lex_state = 115, .external_lex_state = 24},
  [1575] = {.lex_state = 115, .external_lex_state = 10},
  [1576] = {.lex_state = 131, .external_lex_state = 10},
  [1577] = {.lex_state = 136, .external_lex_state = 16},
  [1578] = {.lex_state = 219, .external_lex_state = 10},
  [1579] = {.lex_state = 219, .external_lex_state = 10},
  [1580] = {.lex_state = 79},
  [1581] = {.lex_state = 207},
  [1582] = {.lex_state = 248, .external_lex_state = 14},
  [1583] = {.lex_state = 136},
  [1584] = {.lex_state = 89},
  [1585] = {.lex_state = 248, .external_lex_state = 14},
  [1586] = {.lex_state = 79},
  [1587] = {.lex_state = 248, .external_lex_state = 14},
  [1588] = {.lex_state = 248, .external_lex_state = 14},
  [1589] = {.lex_state = 248, .external_lex_state = 14},
  [1590] = {.lex_state = 89, .external_lex_state = 2},
  [1591] = {.lex_state = 79},
  [1592] = {.lex_state = 151, .external_lex_state = 10},
  [1593] = {.lex_state = 155, .external_lex_state = 5},
  [1594] = {.lex_state = 125},
  [1595] = {.lex_state = 151, .external_lex_state = 10},
  [1596] = {.lex_state = 248, .external_lex_state = 15},
  [1597] = {.lex_state = 248, .external_lex_state = 15},
  [1598] = {.lex_state = 89},
  [1599] = {.lex_state = 248, .external_lex_state = 15},
  [1600] = {.lex_state = 236, .external_lex_state = 15},
  [1601] = {.lex_state = 236, .external_lex_state = 14},
  [1602] = {.lex_state = 236, .external_lex_state = 14},
  [1603] = {.lex_state = 89},
  [1604] = {.lex_state = 236, .external_lex_state = 14},
  [1605] = {.lex_state = 332},
  [1606] = {.lex_state = 155},
  [1607] = {.lex_state = 117},
  [1608] = {.lex_state = 236, .external_lex_state = 14},
  [1609] = {.lex_state = 219, .external_lex_state = 23},
  [1610] = {.lex_state = 236, .external_lex_state = 14},
  [1611] = {.lex_state = 219, .external_lex_state = 10},
  [1612] = {.lex_state = 151, .external_lex_state = 10},
  [1613] = {.lex_state = 125},
  [1614] = {.lex_state = 151, .external_lex_state = 10},
  [1615] = {.lex_state = 221, .external_lex_state = 10},
  [1616] = {.lex_state = 219, .external_lex_state = 23},
  [1617] = {.lex_state = 236, .external_lex_state = 14},
  [1618] = {.lex_state = 219, .external_lex_state = 10},
  [1619] = {.lex_state = 236, .external_lex_state = 14},
  [1620] = {.lex_state = 207},
  [1621] = {.lex_state = 236, .external_lex_state = 15},
  [1622] = {.lex_state = 236, .external_lex_state = 15},
  [1623] = {.lex_state = 236, .external_lex_state = 15},
  [1624] = {.lex_state = 79, .external_lex_state = 2},
  [1625] = {.lex_state = 136},
  [1626] = {.lex_state = 286, .external_lex_state = 9},
  [1627] = {.lex_state = 79, .external_lex_state = 2},
  [1628] = {.lex_state = 125},
  [1629] = {.lex_state = 99},
  [1630] = {.lex_state = 79, .external_lex_state = 2},
  [1631] = {.lex_state = 286, .external_lex_state = 9},
  [1632] = {.lex_state = 99, .external_lex_state = 5},
  [1633] = {.lex_state = 286, .external_lex_state = 3},
  [1634] = {.lex_state = 286, .external_lex_state = 3},
  [1635] = {.lex_state = 125},
  [1636] = {.lex_state = 79, .external_lex_state = 2},
  [1637] = {.lex_state = 136},
  [1638] = {.lex_state = 286, .external_lex_state = 6},
  [1639] = {.lex_state = 79, .external_lex_state = 2},
  [1640] = {.lex_state = 99},
  [1641] = {.lex_state = 79, .external_lex_state = 2},
  [1642] = {.lex_state = 286, .external_lex_state = 6},
  [1643] = {.lex_state = 99, .external_lex_state = 5},
  [1644] = {.lex_state = 286, .external_lex_state = 4},
  [1645] = {.lex_state = 286, .external_lex_state = 4},
  [1646] = {.lex_state = 293, .external_lex_state = 6},
  [1647] = {.lex_state = 293, .external_lex_state = 6},
  [1648] = {.lex_state = 293, .external_lex_state = 6},
  [1649] = {.lex_state = 79},
  [1650] = {.lex_state = 89, .external_lex_state = 2},
  [1651] = {.lex_state = 79},
  [1652] = {.lex_state = 151, .external_lex_state = 10},
  [1653] = {.lex_state = 155, .external_lex_state = 5},
  [1654] = {.lex_state = 125},
  [1655] = {.lex_state = 151, .external_lex_state = 10},
  [1656] = {.lex_state = 89},
  [1657] = {.lex_state = 293, .external_lex_state = 6},
  [1658] = {.lex_state = 79},
  [1659] = {.lex_state = 89, .external_lex_state = 17},
  [1660] = {.lex_state = 207},
  [1661] = {.lex_state = 293, .external_lex_state = 6},
  [1662] = {.lex_state = 136},
  [1663] = {.lex_state = 79, .external_lex_state = 2},
  [1664] = {.lex_state = 89},
  [1665] = {.lex_state = 240, .external_lex_state = 20},
  [1666] = {.lex_state = 240, .external_lex_state = 2},
  [1667] = {.lex_state = 131},
  [1668] = {.lex_state = 79, .external_lex_state = 2},
  [1669] = {.lex_state = 89},
  [1670] = {.lex_state = 296, .external_lex_state = 4},
  [1671] = {.lex_state = 293, .external_lex_state = 4},
  [1672] = {.lex_state = 187, .external_lex_state = 4},
  [1673] = {.lex_state = 293, .external_lex_state = 6},
  [1674] = {.lex_state = 89, .external_lex_state = 22},
  [1675] = {.lex_state = 293, .external_lex_state = 4},
  [1676] = {.lex_state = 293, .external_lex_state = 4},
  [1677] = {.lex_state = 296, .external_lex_state = 4},
  [1678] = {.lex_state = 300, .external_lex_state = 3},
  [1679] = {.lex_state = 293, .external_lex_state = 4},
  [1680] = {.lex_state = 293, .external_lex_state = 4},
  [1681] = {.lex_state = 213, .external_lex_state = 18},
  [1682] = {.lex_state = 335, .external_lex_state = 19},
  [1683] = {.lex_state = 213, .external_lex_state = 18},
  [1684] = {.lex_state = 219, .external_lex_state = 10},
  [1685] = {.lex_state = 219, .external_lex_state = 10},
  [1686] = {.lex_state = 219, .external_lex_state = 23},
  [1687] = {.lex_state = 221, .external_lex_state = 10},
  [1688] = {.lex_state = 219, .external_lex_state = 23},
  [1689] = {.lex_state = 213, .external_lex_state = 18},
  [1690] = {.lex_state = 219, .external_lex_state = 10},
  [1691] = {.lex_state = 115, .external_lex_state = 24},
  [1692] = {.lex_state = 115, .external_lex_state = 10},
  [1693] = {.lex_state = 131, .external_lex_state = 10},
  [1694] = {.lex_state = 213, .external_lex_state = 18},
  [1695] = {.lex_state = 219, .external_lex_state = 10},
  [1696] = {.lex_state = 219, .external_lex_state = 10},
  [1697] = {.lex_state = 303, .external_lex_state = 6},
  [1698] = {.lex_state = 303, .external_lex_state = 6},
  [1699] = {.lex_state = 207},
  [1700] = {.lex_state = 303, .external_lex_state = 6},
  [1701] = {.lex_state = 89},
  [1702] = {.lex_state = 143, .external_lex_state = 6},
  [1703] = {.lex_state = 303, .external_lex_state = 6},
  [1704] = {.lex_state = 219, .external_lex_state = 23},
  [1705] = {.lex_state = 303, .external_lex_state = 6},
  [1706] = {.lex_state = 219, .external_lex_state = 10},
  [1707] = {.lex_state = 151, .external_lex_state = 10},
  [1708] = {.lex_state = 125},
  [1709] = {.lex_state = 151, .external_lex_state = 10},
  [1710] = {.lex_state = 221, .external_lex_state = 10},
  [1711] = {.lex_state = 219, .external_lex_state = 23},
  [1712] = {.lex_state = 303, .external_lex_state = 6},
  [1713] = {.lex_state = 219, .external_lex_state = 10},
  [1714] = {.lex_state = 79, .external_lex_state = 27},
  [1715] = {.lex_state = 79, .external_lex_state = 27},
  [1716] = {.lex_state = 79},
  [1717] = {.lex_state = 89, .external_lex_state = 2},
  [1718] = {.lex_state = 79},
  [1719] = {.lex_state = 151, .external_lex_state = 10},
  [1720] = {.lex_state = 155, .external_lex_state = 5},
  [1721] = {.lex_state = 125},
  [1722] = {.lex_state = 151, .external_lex_state = 10},
  [1723] = {.lex_state = 246, .external_lex_state = 15},
  [1724] = {.lex_state = 79, .external_lex_state = 27},
  [1725] = {.lex_state = 79, .external_lex_state = 2},
  [1726] = {.lex_state = 202, .external_lex_state = 15},
  [1727] = {.lex_state = 147, .external_lex_state = 9},
  [1728] = {.lex_state = 143, .external_lex_state = 6},
  [1729] = {.lex_state = 89, .external_lex_state = 8},
  [1730] = {.lex_state = 219, .external_lex_state = 10},
  [1731] = {.lex_state = 219, .external_lex_state = 10},
  [1732] = {.lex_state = 115, .external_lex_state = 24},
  [1733] = {.lex_state = 115, .external_lex_state = 10},
  [1734] = {.lex_state = 131, .external_lex_state = 10},
  [1735] = {.lex_state = 89, .external_lex_state = 8},
  [1736] = {.lex_state = 219, .external_lex_state = 10},
  [1737] = {.lex_state = 219, .external_lex_state = 10},
  [1738] = {.lex_state = 89, .external_lex_state = 8},
  [1739] = {.lex_state = 89, .external_lex_state = 8},
  [1740] = {.lex_state = 219, .external_lex_state = 10},
  [1741] = {.lex_state = 93, .external_lex_state = 3},
  [1742] = {.lex_state = 93, .external_lex_state = 9},
  [1743] = {.lex_state = 219, .external_lex_state = 10},
  [1744] = {.lex_state = 219, .external_lex_state = 10},
  [1745] = {.lex_state = 115, .external_lex_state = 24},
  [1746] = {.lex_state = 115, .external_lex_state = 10},
  [1747] = {.lex_state = 131, .external_lex_state = 10},
  [1748] = {.lex_state = 93, .external_lex_state = 9},
  [1749] = {.lex_state = 219, .external_lex_state = 10},
  [1750] = {.lex_state = 219, .external_lex_state = 10},
  [1751] = {.lex_state = 93, .external_lex_state = 9},
  [1752] = {.lex_state = 93, .external_lex_state = 9},
  [1753] = {.lex_state = 219, .external_lex_state = 10},
  [1754] = {.lex_state = 93, .external_lex_state = 6},
  [1755] = {.lex_state = 219, .external_lex_state = 10},
  [1756] = {.lex_state = 219, .external_lex_state = 10},
  [1757] = {.lex_state = 115, .external_lex_state = 24},
  [1758] = {.lex_state = 115, .external_lex_state = 10},
  [1759] = {.lex_state = 131, .external_lex_state = 10},
  [1760] = {.lex_state = 93, .external_lex_state = 6},
  [1761] = {.lex_state = 219, .external_lex_state = 10},
  [1762] = {.lex_state = 219, .external_lex_state = 10},
  [1763] = {.lex_state = 93, .external_lex_state = 6},
  [1764] = {.lex_state = 93, .external_lex_state = 6},
  [1765] = {.lex_state = 219, .external_lex_state = 10},
  [1766] = {.lex_state = 110, .external_lex_state = 6},
  [1767] = {.lex_state = 337, .external_lex_state = 10},
  [1768] = {.lex_state = 219, .external_lex_state = 24},
  [1769] = {.lex_state = 219, .external_lex_state = 10},
  [1770] = {.lex_state = 219, .external_lex_state = 10},
  [1771] = {.lex_state = 219, .external_lex_state = 23},
  [1772] = {.lex_state = 221, .external_lex_state = 10},
  [1773] = {.lex_state = 219, .external_lex_state = 23},
  [1774] = {.lex_state = 219, .external_lex_state = 24},
  [1775] = {.lex_state = 219, .external_lex_state = 10},
  [1776] = {.lex_state = 115, .external_lex_state = 24},
  [1777] = {.lex_state = 115, .external_lex_state = 10},
  [1778] = {.lex_state = 131, .external_lex_state = 10},
  [1779] = {.lex_state = 219, .external_lex_state = 24},
  [1780] = {.lex_state = 219, .external_lex_state = 10},
  [1781] = {.lex_state = 219, .external_lex_state = 10},
  [1782] = {.lex_state = 219, .external_lex_state = 24},
  [1783] = {.lex_state = 219, .external_lex_state = 10},
  [1784] = {.lex_state = 110, .external_lex_state = 6},
  [1785] = {.lex_state = 110, .external_lex_state = 6},
  [1786] = {.lex_state = 219, .external_lex_state = 10},
  [1787] = {.lex_state = 115, .external_lex_state = 24},
  [1788] = {.lex_state = 115, .external_lex_state = 24},
  [1789] = {.lex_state = 207},
  [1790] = {.lex_state = 115, .external_lex_state = 24},
  [1791] = {.lex_state = 89},
  [1792] = {.lex_state = 115, .external_lex_state = 24},
  [1793] = {.lex_state = 115, .external_lex_state = 24},
  [1794] = {.lex_state = 219, .external_lex_state = 23},
  [1795] = {.lex_state = 115, .external_lex_state = 24},
  [1796] = {.lex_state = 219, .external_lex_state = 10},
  [1797] = {.lex_state = 151, .external_lex_state = 10},
  [1798] = {.lex_state = 125},
  [1799] = {.lex_state = 151, .external_lex_state = 10},
  [1800] = {.lex_state = 221, .external_lex_state = 10},
  [1801] = {.lex_state = 219, .external_lex_state = 23},
  [1802] = {.lex_state = 115, .external_lex_state = 24},
  [1803] = {.lex_state = 219, .external_lex_state = 10},
  [1804] = {.lex_state = 151, .external_lex_state = 10},
  [1805] = {.lex_state = 151, .external_lex_state = 24},
  [1806] = {.lex_state = 151, .external_lex_state = 10},
  [1807] = {.lex_state = 151, .external_lex_state = 24},
  [1808] = {.lex_state = 110, .external_lex_state = 6},
  [1809] = {.lex_state = 181, .external_lex_state = 25},
  [1810] = {.lex_state = 339, .external_lex_state = 11},
  [1811] = {.lex_state = 181, .external_lex_state = 11},
  [1812] = {.lex_state = 89},
  [1813] = {.lex_state = 181, .external_lex_state = 25},
  [1814] = {.lex_state = 219, .external_lex_state = 10},
  [1815] = {.lex_state = 219, .external_lex_state = 10},
  [1816] = {.lex_state = 219, .external_lex_state = 23},
  [1817] = {.lex_state = 221, .external_lex_state = 10},
  [1818] = {.lex_state = 219, .external_lex_state = 23},
  [1819] = {.lex_state = 181, .external_lex_state = 25},
  [1820] = {.lex_state = 219, .external_lex_state = 10},
  [1821] = {.lex_state = 115, .external_lex_state = 24},
  [1822] = {.lex_state = 115, .external_lex_state = 10},
  [1823] = {.lex_state = 131, .external_lex_state = 10},
  [1824] = {.lex_state = 181, .external_lex_state = 25},
  [1825] = {.lex_state = 219, .external_lex_state = 10},
  [1826] = {.lex_state = 219, .external_lex_state = 10},
  [1827] = {.lex_state = 181, .external_lex_state = 13},
  [1828] = {.lex_state = 339, .external_lex_state = 12},
  [1829] = {.lex_state = 181, .external_lex_state = 13},
  [1830] = {.lex_state = 219, .external_lex_state = 10},
  [1831] = {.lex_state = 219, .external_lex_state = 10},
  [1832] = {.lex_state = 219, .external_lex_state = 23},
  [1833] = {.lex_state = 221, .external_lex_state = 10},
  [1834] = {.lex_state = 219, .external_lex_state = 23},
  [1835] = {.lex_state = 181, .external_lex_state = 13},
  [1836] = {.lex_state = 219, .external_lex_state = 10},
  [1837] = {.lex_state = 115, .external_lex_state = 24},
  [1838] = {.lex_state = 115, .external_lex_state = 10},
  [1839] = {.lex_state = 131, .external_lex_state = 10},
  [1840] = {.lex_state = 181, .external_lex_state = 13},
  [1841] = {.lex_state = 219, .external_lex_state = 10},
  [1842] = {.lex_state = 219, .external_lex_state = 10},
  [1843] = {.lex_state = 184, .external_lex_state = 13},
  [1844] = {.lex_state = 219, .external_lex_state = 10},
  [1845] = {.lex_state = 219, .external_lex_state = 10},
  [1846] = {.lex_state = 115, .external_lex_state = 24},
  [1847] = {.lex_state = 115, .external_lex_state = 10},
  [1848] = {.lex_state = 131, .external_lex_state = 10},
  [1849] = {.lex_state = 184, .external_lex_state = 13},
  [1850] = {.lex_state = 219, .external_lex_state = 10},
  [1851] = {.lex_state = 219, .external_lex_state = 10},
  [1852] = {.lex_state = 184, .external_lex_state = 13},
  [1853] = {.lex_state = 184, .external_lex_state = 13},
  [1854] = {.lex_state = 219, .external_lex_state = 10},
  [1855] = {.lex_state = 197, .external_lex_state = 12},
  [1856] = {.lex_state = 197, .external_lex_state = 12},
  [1857] = {.lex_state = 171},
  [1858] = {.lex_state = 171},
  [1859] = {.lex_state = 281},
  [1860] = {.lex_state = 197, .external_lex_state = 12},
  [1861] = {.lex_state = 323},
  [1862] = {.lex_state = 89},
  [1863] = {.lex_state = 281},
  [1864] = {.lex_state = 197, .external_lex_state = 12},
  [1865] = {.lex_state = 323},
  [1866] = {.lex_state = 89},
  [1867] = {.lex_state = 199, .external_lex_state = 11},
  [1868] = {.lex_state = 199, .external_lex_state = 25},
  [1869] = {.lex_state = 199, .external_lex_state = 25},
  [1870] = {.lex_state = 207},
  [1871] = {.lex_state = 199, .external_lex_state = 25},
  [1872] = {.lex_state = 89},
  [1873] = {.lex_state = 199, .external_lex_state = 25},
  [1874] = {.lex_state = 199, .external_lex_state = 25},
  [1875] = {.lex_state = 219, .external_lex_state = 23},
  [1876] = {.lex_state = 199, .external_lex_state = 25},
  [1877] = {.lex_state = 219, .external_lex_state = 10},
  [1878] = {.lex_state = 151, .external_lex_state = 10},
  [1879] = {.lex_state = 125},
  [1880] = {.lex_state = 151, .external_lex_state = 10},
  [1881] = {.lex_state = 221, .external_lex_state = 10},
  [1882] = {.lex_state = 219, .external_lex_state = 23},
  [1883] = {.lex_state = 199, .external_lex_state = 25},
  [1884] = {.lex_state = 219, .external_lex_state = 10},
  [1885] = {.lex_state = 89},
  [1886] = {.lex_state = 332},
  [1887] = {.lex_state = 155},
  [1888] = {.lex_state = 117},
  [1889] = {.lex_state = 236, .external_lex_state = 15},
  [1890] = {.lex_state = 197, .external_lex_state = 12},
  [1891] = {.lex_state = 197, .external_lex_state = 13},
  [1892] = {.lex_state = 197, .external_lex_state = 13},
  [1893] = {.lex_state = 207},
  [1894] = {.lex_state = 197, .external_lex_state = 13},
  [1895] = {.lex_state = 89},
  [1896] = {.lex_state = 197, .external_lex_state = 13},
  [1897] = {.lex_state = 197, .external_lex_state = 13},
  [1898] = {.lex_state = 219, .external_lex_state = 23},
  [1899] = {.lex_state = 197, .external_lex_state = 13},
  [1900] = {.lex_state = 219, .external_lex_state = 10},
  [1901] = {.lex_state = 151, .external_lex_state = 10},
  [1902] = {.lex_state = 125},
  [1903] = {.lex_state = 151, .external_lex_state = 10},
  [1904] = {.lex_state = 221, .external_lex_state = 10},
  [1905] = {.lex_state = 219, .external_lex_state = 23},
  [1906] = {.lex_state = 197, .external_lex_state = 13},
  [1907] = {.lex_state = 219, .external_lex_state = 10},
  [1908] = {.lex_state = 258, .external_lex_state = 28},
  [1909] = {.lex_state = 115, .external_lex_state = 7},
  [1910] = {.lex_state = 147, .external_lex_state = 9},
  [1911] = {.lex_state = 143, .external_lex_state = 6},
  [1912] = {.lex_state = 79},
  [1913] = {.lex_state = 207},
  [1914] = {.lex_state = 260, .external_lex_state = 9},
  [1915] = {.lex_state = 136},
  [1916] = {.lex_state = 89},
  [1917] = {.lex_state = 260, .external_lex_state = 9},
  [1918] = {.lex_state = 79},
  [1919] = {.lex_state = 89, .external_lex_state = 17},
  [1920] = {.lex_state = 260, .external_lex_state = 9},
  [1921] = {.lex_state = 260, .external_lex_state = 9},
  [1922] = {.lex_state = 260, .external_lex_state = 9},
  [1923] = {.lex_state = 89, .external_lex_state = 2},
  [1924] = {.lex_state = 79},
  [1925] = {.lex_state = 151, .external_lex_state = 10},
  [1926] = {.lex_state = 155, .external_lex_state = 5},
  [1927] = {.lex_state = 125},
  [1928] = {.lex_state = 151, .external_lex_state = 10},
  [1929] = {.lex_state = 260, .external_lex_state = 3},
  [1930] = {.lex_state = 260, .external_lex_state = 3},
  [1931] = {.lex_state = 260, .external_lex_state = 3},
  [1932] = {.lex_state = 79},
  [1933] = {.lex_state = 207},
  [1934] = {.lex_state = 260, .external_lex_state = 6},
  [1935] = {.lex_state = 136},
  [1936] = {.lex_state = 89},
  [1937] = {.lex_state = 260, .external_lex_state = 6},
  [1938] = {.lex_state = 79},
  [1939] = {.lex_state = 260, .external_lex_state = 6},
  [1940] = {.lex_state = 260, .external_lex_state = 6},
  [1941] = {.lex_state = 260, .external_lex_state = 6},
  [1942] = {.lex_state = 89, .external_lex_state = 2},
  [1943] = {.lex_state = 79},
  [1944] = {.lex_state = 151, .external_lex_state = 10},
  [1945] = {.lex_state = 155, .external_lex_state = 5},
  [1946] = {.lex_state = 125},
  [1947] = {.lex_state = 151, .external_lex_state = 10},
  [1948] = {.lex_state = 260, .external_lex_state = 4},
  [1949] = {.lex_state = 260, .external_lex_state = 4},
  [1950] = {.lex_state = 260, .external_lex_state = 4},
  [1951] = {.lex_state = 273, .external_lex_state = 6},
  [1952] = {.lex_state = 273, .external_lex_state = 6},
  [1953] = {.lex_state = 79, .external_lex_state = 2},
  [1954] = {.lex_state = 136},
  [1955] = {.lex_state = 314, .external_lex_state = 9},
  [1956] = {.lex_state = 79, .external_lex_state = 2},
  [1957] = {.lex_state = 125},
  [1958] = {.lex_state = 99},
  [1959] = {.lex_state = 79, .external_lex_state = 2},
  [1960] = {.lex_state = 314, .external_lex_state = 9},
  [1961] = {.lex_state = 99, .external_lex_state = 5},
  [1962] = {.lex_state = 314, .external_lex_state = 3},
  [1963] = {.lex_state = 314, .external_lex_state = 3},
  [1964] = {.lex_state = 125},
  [1965] = {.lex_state = 79, .external_lex_state = 2},
  [1966] = {.lex_state = 136},
  [1967] = {.lex_state = 314, .external_lex_state = 6},
  [1968] = {.lex_state = 79, .external_lex_state = 2},
  [1969] = {.lex_state = 99},
  [1970] = {.lex_state = 79, .external_lex_state = 2},
  [1971] = {.lex_state = 314, .external_lex_state = 6},
  [1972] = {.lex_state = 99, .external_lex_state = 5},
  [1973] = {.lex_state = 314, .external_lex_state = 4},
  [1974] = {.lex_state = 314, .external_lex_state = 4},
  [1975] = {.lex_state = 317, .external_lex_state = 6},
  [1976] = {.lex_state = 317, .external_lex_state = 6},
  [1977] = {.lex_state = 317, .external_lex_state = 6},
  [1978] = {.lex_state = 79},
  [1979] = {.lex_state = 89, .external_lex_state = 2},
  [1980] = {.lex_state = 79},
  [1981] = {.lex_state = 151, .external_lex_state = 10},
  [1982] = {.lex_state = 155, .external_lex_state = 5},
  [1983] = {.lex_state = 125},
  [1984] = {.lex_state = 151, .external_lex_state = 10},
  [1985] = {.lex_state = 89},
  [1986] = {.lex_state = 317, .external_lex_state = 6},
  [1987] = {.lex_state = 79},
  [1988] = {.lex_state = 89, .external_lex_state = 17},
  [1989] = {.lex_state = 207},
  [1990] = {.lex_state = 317, .external_lex_state = 6},
  [1991] = {.lex_state = 136},
  [1992] = {.lex_state = 79, .external_lex_state = 2},
  [1993] = {.lex_state = 89},
  [1994] = {.lex_state = 271, .external_lex_state = 20},
  [1995] = {.lex_state = 271, .external_lex_state = 2},
  [1996] = {.lex_state = 131},
  [1997] = {.lex_state = 79, .external_lex_state = 2},
  [1998] = {.lex_state = 89},
  [1999] = {.lex_state = 276, .external_lex_state = 4},
  [2000] = {.lex_state = 317, .external_lex_state = 4},
  [2001] = {.lex_state = 317, .external_lex_state = 6},
  [2002] = {.lex_state = 89, .external_lex_state = 22},
  [2003] = {.lex_state = 317, .external_lex_state = 4},
  [2004] = {.lex_state = 317, .external_lex_state = 4},
  [2005] = {.lex_state = 276, .external_lex_state = 4},
  [2006] = {.lex_state = 320, .external_lex_state = 3},
  [2007] = {.lex_state = 317, .external_lex_state = 4},
  [2008] = {.lex_state = 317, .external_lex_state = 4},
  [2009] = {.lex_state = 219, .external_lex_state = 23},
  [2010] = {.lex_state = 273, .external_lex_state = 6},
  [2011] = {.lex_state = 219, .external_lex_state = 10},
  [2012] = {.lex_state = 151, .external_lex_state = 10},
  [2013] = {.lex_state = 125},
  [2014] = {.lex_state = 151, .external_lex_state = 10},
  [2015] = {.lex_state = 221, .external_lex_state = 10},
  [2016] = {.lex_state = 219, .external_lex_state = 23},
  [2017] = {.lex_state = 273, .external_lex_state = 6},
  [2018] = {.lex_state = 219, .external_lex_state = 10},
  [2019] = {.lex_state = 273, .external_lex_state = 6},
  [2020] = {.lex_state = 89},
  [2021] = {.lex_state = 273, .external_lex_state = 6},
  [2022] = {.lex_state = 89},
  [2023] = {.lex_state = 79, .external_lex_state = 2},
  [2024] = {.lex_state = 136},
  [2025] = {.lex_state = 278, .external_lex_state = 9},
  [2026] = {.lex_state = 79, .external_lex_state = 2},
  [2027] = {.lex_state = 99},
  [2028] = {.lex_state = 79, .external_lex_state = 2},
  [2029] = {.lex_state = 278, .external_lex_state = 9},
  [2030] = {.lex_state = 99, .external_lex_state = 5},
  [2031] = {.lex_state = 278, .external_lex_state = 3},
  [2032] = {.lex_state = 278, .external_lex_state = 3},
  [2033] = {.lex_state = 273, .external_lex_state = 6},
  [2034] = {.lex_state = 207},
  [2035] = {.lex_state = 223, .external_lex_state = 2},
  [2036] = {.lex_state = 276, .external_lex_state = 4},
  [2037] = {.lex_state = 278, .external_lex_state = 3},
  [2038] = {.lex_state = 276, .external_lex_state = 6},
  [2039] = {.lex_state = 276, .external_lex_state = 6},
  [2040] = {.lex_state = 276, .external_lex_state = 4},
  [2041] = {.lex_state = 342, .external_lex_state = 15},
  [2042] = {.lex_state = 89},
  [2043] = {.lex_state = 276, .external_lex_state = 4},
  [2044] = {.lex_state = 278, .external_lex_state = 3},
  [2045] = {.lex_state = 276, .external_lex_state = 6},
  [2046] = {.lex_state = 276, .external_lex_state = 4},
  [2047] = {.lex_state = 276, .external_lex_state = 4},
  [2048] = {.lex_state = 273, .external_lex_state = 4},
  [2049] = {.lex_state = 187, .external_lex_state = 4},
  [2050] = {.lex_state = 171},
  [2051] = {.lex_state = 273, .external_lex_state = 6},
  [2052] = {.lex_state = 273, .external_lex_state = 4},
  [2053] = {.lex_state = 273, .external_lex_state = 4},
  [2054] = {.lex_state = 273, .external_lex_state = 4},
  [2055] = {.lex_state = 223, .external_lex_state = 2},
  [2056] = {.lex_state = 223, .external_lex_state = 20},
  [2057] = {.lex_state = 187, .external_lex_state = 4},
  [2058] = {.lex_state = 323},
  [2059] = {.lex_state = 89},
  [2060] = {.lex_state = 89},
  [2061] = {.lex_state = 344, .external_lex_state = 2},
  [2062] = {.lex_state = 89, .external_lex_state = 16},
  [2063] = {.lex_state = 89},
  [2064] = {.lex_state = 344, .external_lex_state = 2},
  [2065] = {.lex_state = 89},
  [2066] = {.lex_state = 89},
  [2067] = {.lex_state = 89},
  [2068] = {.lex_state = 202, .external_lex_state = 14},
  [2069] = {.lex_state = 219, .external_lex_state = 10},
  [2070] = {.lex_state = 219, .external_lex_state = 10},
  [2071] = {.lex_state = 115, .external_lex_state = 24},
  [2072] = {.lex_state = 115, .external_lex_state = 10},
  [2073] = {.lex_state = 131, .external_lex_state = 10},
  [2074] = {.lex_state = 202, .external_lex_state = 14},
  [2075] = {.lex_state = 219, .external_lex_state = 10},
  [2076] = {.lex_state = 219, .external_lex_state = 10},
  [2077] = {.lex_state = 202, .external_lex_state = 14},
  [2078] = {.lex_state = 202, .external_lex_state = 14},
  [2079] = {.lex_state = 219, .external_lex_state = 10},
  [2080] = {.lex_state = 187, .external_lex_state = 4},
  [2081] = {.lex_state = 323},
  [2082] = {.lex_state = 89},
  [2083] = {.lex_state = 230, .external_lex_state = 16},
  [2084] = {.lex_state = 219, .external_lex_state = 10},
  [2085] = {.lex_state = 219, .external_lex_state = 10},
  [2086] = {.lex_state = 115, .external_lex_state = 24},
  [2087] = {.lex_state = 115, .external_lex_state = 10},
  [2088] = {.lex_state = 131, .external_lex_state = 10},
  [2089] = {.lex_state = 230, .external_lex_state = 16},
  [2090] = {.lex_state = 219, .external_lex_state = 10},
  [2091] = {.lex_state = 219, .external_lex_state = 10},
  [2092] = {.lex_state = 230, .external_lex_state = 16},
  [2093] = {.lex_state = 230, .external_lex_state = 16},
  [2094] = {.lex_state = 219, .external_lex_state = 10},
  [2095] = {.lex_state = 143, .external_lex_state = 6},
  [2096] = {.lex_state = 79, .external_lex_state = 2},
  [2097] = {.lex_state = 89, .external_lex_state = 2},
  [2098] = {.lex_state = 89, .external_lex_state = 16},
  [2099] = {.lex_state = 89, .external_lex_state = 16},
  [2100] = {.lex_state = 207},
  [2101] = {.lex_state = 89, .external_lex_state = 16},
  [2102] = {.lex_state = 89},
  [2103] = {.lex_state = 89, .external_lex_state = 16},
  [2104] = {.lex_state = 89, .external_lex_state = 16},
  [2105] = {.lex_state = 219, .external_lex_state = 23},
  [2106] = {.lex_state = 89, .external_lex_state = 16},
  [2107] = {.lex_state = 219, .external_lex_state = 10},
  [2108] = {.lex_state = 151, .external_lex_state = 10},
  [2109] = {.lex_state = 125},
  [2110] = {.lex_state = 151, .external_lex_state = 10},
  [2111] = {.lex_state = 221, .external_lex_state = 10},
  [2112] = {.lex_state = 219, .external_lex_state = 23},
  [2113] = {.lex_state = 89, .external_lex_state = 16},
  [2114] = {.lex_state = 219, .external_lex_state = 10},
  [2115] = {.lex_state = 147, .external_lex_state = 9},
  [2116] = {.lex_state = 307, .external_lex_state = 3},
  [2117] = {.lex_state = 147, .external_lex_state = 9},
  [2118] = {.lex_state = 219, .external_lex_state = 10},
  [2119] = {.lex_state = 219, .external_lex_state = 10},
  [2120] = {.lex_state = 219, .external_lex_state = 23},
  [2121] = {.lex_state = 221, .external_lex_state = 10},
  [2122] = {.lex_state = 219, .external_lex_state = 23},
  [2123] = {.lex_state = 147, .external_lex_state = 9},
  [2124] = {.lex_state = 219, .external_lex_state = 10},
  [2125] = {.lex_state = 115, .external_lex_state = 24},
  [2126] = {.lex_state = 115, .external_lex_state = 10},
  [2127] = {.lex_state = 131, .external_lex_state = 10},
  [2128] = {.lex_state = 147, .external_lex_state = 9},
  [2129] = {.lex_state = 219, .external_lex_state = 10},
  [2130] = {.lex_state = 219, .external_lex_state = 10},
  [2131] = {.lex_state = 125},
  [2132] = {.lex_state = 335, .external_lex_state = 18},
  [2133] = {.lex_state = 125},
  [2134] = {.lex_state = 136, .external_lex_state = 16},
  [2135] = {.lex_state = 219, .external_lex_state = 10},
  [2136] = {.lex_state = 219, .external_lex_state = 10},
  [2137] = {.lex_state = 115, .external_lex_state = 24},
  [2138] = {.lex_state = 115, .external_lex_state = 10},
  [2139] = {.lex_state = 131, .external_lex_state = 10},
  [2140] = {.lex_state = 136, .external_lex_state = 16},
  [2141] = {.lex_state = 219, .external_lex_state = 10},
  [2142] = {.lex_state = 219, .external_lex_state = 10},
  [2143] = {.lex_state = 136, .external_lex_state = 16},
  [2144] = {.lex_state = 136, .external_lex_state = 16},
  [2145] = {.lex_state = 219, .external_lex_state = 10},
  [2146] = {.lex_state = 248, .external_lex_state = 14},
  [2147] = {.lex_state = 248, .external_lex_state = 14},
  [2148] = {.lex_state = 207},
  [2149] = {.lex_state = 248, .external_lex_state = 14},
  [2150] = {.lex_state = 89},
  [2151] = {.lex_state = 248, .external_lex_state = 14},
  [2152] = {.lex_state = 248, .external_lex_state = 14},
  [2153] = {.lex_state = 219, .external_lex_state = 23},
  [2154] = {.lex_state = 248, .external_lex_state = 14},
  [2155] = {.lex_state = 219, .external_lex_state = 10},
  [2156] = {.lex_state = 151, .external_lex_state = 10},
  [2157] = {.lex_state = 125},
  [2158] = {.lex_state = 151, .external_lex_state = 10},
  [2159] = {.lex_state = 221, .external_lex_state = 10},
  [2160] = {.lex_state = 219, .external_lex_state = 23},
  [2161] = {.lex_state = 248, .external_lex_state = 14},
  [2162] = {.lex_state = 219, .external_lex_state = 10},
  [2163] = {.lex_state = 187, .external_lex_state = 4},
  [2164] = {.lex_state = 346, .external_lex_state = 15},
  [2165] = {.lex_state = 332},
  [2166] = {.lex_state = 187, .external_lex_state = 4},
  [2167] = {.lex_state = 332},
  [2168] = {.lex_state = 155},
  [2169] = {.lex_state = 236, .external_lex_state = 14},
  [2170] = {.lex_state = 219, .external_lex_state = 10},
  [2171] = {.lex_state = 219, .external_lex_state = 10},
  [2172] = {.lex_state = 219, .external_lex_state = 23},
  [2173] = {.lex_state = 221, .external_lex_state = 10},
  [2174] = {.lex_state = 219, .external_lex_state = 23},
  [2175] = {.lex_state = 236, .external_lex_state = 14},
  [2176] = {.lex_state = 219, .external_lex_state = 10},
  [2177] = {.lex_state = 115, .external_lex_state = 24},
  [2178] = {.lex_state = 115, .external_lex_state = 10},
  [2179] = {.lex_state = 131, .external_lex_state = 10},
  [2180] = {.lex_state = 236, .external_lex_state = 14},
  [2181] = {.lex_state = 219, .external_lex_state = 10},
  [2182] = {.lex_state = 219, .external_lex_state = 10},
  [2183] = {.lex_state = 236, .external_lex_state = 14},
  [2184] = {.lex_state = 117},
  [2185] = {.lex_state = 79},
  [2186] = {.lex_state = 207},
  [2187] = {.lex_state = 286, .external_lex_state = 9},
  [2188] = {.lex_state = 136},
  [2189] = {.lex_state = 89},
  [2190] = {.lex_state = 286, .external_lex_state = 9},
  [2191] = {.lex_state = 79},
  [2192] = {.lex_state = 89, .external_lex_state = 17},
  [2193] = {.lex_state = 286, .external_lex_state = 9},
  [2194] = {.lex_state = 286, .external_lex_state = 9},
  [2195] = {.lex_state = 286, .external_lex_state = 9},
  [2196] = {.lex_state = 89, .external_lex_state = 2},
  [2197] = {.lex_state = 79},
  [2198] = {.lex_state = 151, .external_lex_state = 10},
  [2199] = {.lex_state = 155, .external_lex_state = 5},
  [2200] = {.lex_state = 125},
  [2201] = {.lex_state = 151, .external_lex_state = 10},
  [2202] = {.lex_state = 286, .external_lex_state = 3},
  [2203] = {.lex_state = 286, .external_lex_state = 3},
  [2204] = {.lex_state = 286, .external_lex_state = 3},
  [2205] = {.lex_state = 79},
  [2206] = {.lex_state = 207},
  [2207] = {.lex_state = 286, .external_lex_state = 6},
  [2208] = {.lex_state = 136},
  [2209] = {.lex_state = 89},
  [2210] = {.lex_state = 286, .external_lex_state = 6},
  [2211] = {.lex_state = 79},
  [2212] = {.lex_state = 286, .external_lex_state = 6},
  [2213] = {.lex_state = 286, .external_lex_state = 6},
  [2214] = {.lex_state = 286, .external_lex_state = 6},
  [2215] = {.lex_state = 89, .external_lex_state = 2},
  [2216] = {.lex_state = 79},
  [2217] = {.lex_state = 151, .external_lex_state = 10},
  [2218] = {.lex_state = 155, .external_lex_state = 5},
  [2219] = {.lex_state = 125},
  [2220] = {.lex_state = 151, .external_lex_state = 10},
  [2221] = {.lex_state = 286, .external_lex_state = 4},
  [2222] = {.lex_state = 286, .external_lex_state = 4},
  [2223] = {.lex_state = 286, .external_lex_state = 4},
  [2224] = {.lex_state = 293, .external_lex_state = 6},
  [2225] = {.lex_state = 293, .external_lex_state = 6},
  [2226] = {.lex_state = 219, .external_lex_state = 23},
  [2227] = {.lex_state = 293, .external_lex_state = 6},
  [2228] = {.lex_state = 219, .external_lex_state = 10},
  [2229] = {.lex_state = 151, .external_lex_state = 10},
  [2230] = {.lex_state = 125},
  [2231] = {.lex_state = 151, .external_lex_state = 10},
  [2232] = {.lex_state = 221, .external_lex_state = 10},
  [2233] = {.lex_state = 219, .external_lex_state = 23},
  [2234] = {.lex_state = 293, .external_lex_state = 6},
  [2235] = {.lex_state = 219, .external_lex_state = 10},
  [2236] = {.lex_state = 293, .external_lex_state = 6},
  [2237] = {.lex_state = 89},
  [2238] = {.lex_state = 293, .external_lex_state = 6},
  [2239] = {.lex_state = 89},
  [2240] = {.lex_state = 79, .external_lex_state = 2},
  [2241] = {.lex_state = 136},
  [2242] = {.lex_state = 300, .external_lex_state = 9},
  [2243] = {.lex_state = 79, .external_lex_state = 2},
  [2244] = {.lex_state = 99},
  [2245] = {.lex_state = 79, .external_lex_state = 2},
  [2246] = {.lex_state = 300, .external_lex_state = 9},
  [2247] = {.lex_state = 99, .external_lex_state = 5},
  [2248] = {.lex_state = 300, .external_lex_state = 3},
  [2249] = {.lex_state = 300, .external_lex_state = 3},
  [2250] = {.lex_state = 293, .external_lex_state = 6},
  [2251] = {.lex_state = 207},
  [2252] = {.lex_state = 296, .external_lex_state = 4},
  [2253] = {.lex_state = 300, .external_lex_state = 3},
  [2254] = {.lex_state = 79, .external_lex_state = 2},
  [2255] = {.lex_state = 136},
  [2256] = {.lex_state = 296, .external_lex_state = 6},
  [2257] = {.lex_state = 79, .external_lex_state = 2},
  [2258] = {.lex_state = 99},
  [2259] = {.lex_state = 79, .external_lex_state = 2},
  [2260] = {.lex_state = 296, .external_lex_state = 6},
  [2261] = {.lex_state = 99, .external_lex_state = 5},
  [2262] = {.lex_state = 296, .external_lex_state = 4},
  [2263] = {.lex_state = 348, .external_lex_state = 15},
  [2264] = {.lex_state = 89},
  [2265] = {.lex_state = 296, .external_lex_state = 4},
  [2266] = {.lex_state = 300, .external_lex_state = 3},
  [2267] = {.lex_state = 296, .external_lex_state = 6},
  [2268] = {.lex_state = 296, .external_lex_state = 4},
  [2269] = {.lex_state = 296, .external_lex_state = 4},
  [2270] = {.lex_state = 293, .external_lex_state = 4},
  [2271] = {.lex_state = 293, .external_lex_state = 6},
  [2272] = {.lex_state = 293, .external_lex_state = 4},
  [2273] = {.lex_state = 293, .external_lex_state = 4},
  [2274] = {.lex_state = 293, .external_lex_state = 4},
  [2275] = {.lex_state = 240, .external_lex_state = 2},
  [2276] = {.lex_state = 240, .external_lex_state = 20},
  [2277] = {.lex_state = 213, .external_lex_state = 18},
  [2278] = {.lex_state = 219, .external_lex_state = 10},
  [2279] = {.lex_state = 219, .external_lex_state = 10},
  [2280] = {.lex_state = 115, .external_lex_state = 24},
  [2281] = {.lex_state = 115, .external_lex_state = 10},
  [2282] = {.lex_state = 131, .external_lex_state = 10},
  [2283] = {.lex_state = 213, .external_lex_state = 18},
  [2284] = {.lex_state = 219, .external_lex_state = 10},
  [2285] = {.lex_state = 219, .external_lex_state = 10},
  [2286] = {.lex_state = 213, .external_lex_state = 18},
  [2287] = {.lex_state = 213, .external_lex_state = 18},
  [2288] = {.lex_state = 219, .external_lex_state = 10},
  [2289] = {.lex_state = 303, .external_lex_state = 6},
  [2290] = {.lex_state = 350, .external_lex_state = 4},
  [2291] = {.lex_state = 303, .external_lex_state = 6},
  [2292] = {.lex_state = 219, .external_lex_state = 10},
  [2293] = {.lex_state = 219, .external_lex_state = 10},
  [2294] = {.lex_state = 219, .external_lex_state = 23},
  [2295] = {.lex_state = 221, .external_lex_state = 10},
  [2296] = {.lex_state = 219, .external_lex_state = 23},
  [2297] = {.lex_state = 303, .external_lex_state = 6},
  [2298] = {.lex_state = 219, .external_lex_state = 10},
  [2299] = {.lex_state = 115, .external_lex_state = 24},
  [2300] = {.lex_state = 115, .external_lex_state = 10},
  [2301] = {.lex_state = 131, .external_lex_state = 10},
  [2302] = {.lex_state = 303, .external_lex_state = 6},
  [2303] = {.lex_state = 219, .external_lex_state = 10},
  [2304] = {.lex_state = 219, .external_lex_state = 10},
  [2305] = {.lex_state = 79, .external_lex_state = 27},
  [2306] = {.lex_state = 219, .external_lex_state = 23},
  [2307] = {.lex_state = 79, .external_lex_state = 27},
  [2308] = {.lex_state = 219, .external_lex_state = 10},
  [2309] = {.lex_state = 151, .external_lex_state = 10},
  [2310] = {.lex_state = 125},
  [2311] = {.lex_state = 151, .external_lex_state = 10},
  [2312] = {.lex_state = 221, .external_lex_state = 10},
  [2313] = {.lex_state = 219, .external_lex_state = 23},
  [2314] = {.lex_state = 79, .external_lex_state = 27},
  [2315] = {.lex_state = 219, .external_lex_state = 10},
  [2316] = {.lex_state = 79, .external_lex_state = 2},
  [2317] = {.lex_state = 89, .external_lex_state = 8},
  [2318] = {.lex_state = 219, .external_lex_state = 10},
  [2319] = {.lex_state = 89, .external_lex_state = 8},
  [2320] = {.lex_state = 89, .external_lex_state = 8},
  [2321] = {.lex_state = 219, .external_lex_state = 10},
  [2322] = {.lex_state = 89, .external_lex_state = 8},
  [2323] = {.lex_state = 93, .external_lex_state = 9},
  [2324] = {.lex_state = 219, .external_lex_state = 10},
  [2325] = {.lex_state = 93, .external_lex_state = 9},
  [2326] = {.lex_state = 93, .external_lex_state = 9},
  [2327] = {.lex_state = 219, .external_lex_state = 10},
  [2328] = {.lex_state = 93, .external_lex_state = 9},
  [2329] = {.lex_state = 93, .external_lex_state = 6},
  [2330] = {.lex_state = 219, .external_lex_state = 10},
  [2331] = {.lex_state = 93, .external_lex_state = 6},
  [2332] = {.lex_state = 93, .external_lex_state = 6},
  [2333] = {.lex_state = 219, .external_lex_state = 10},
  [2334] = {.lex_state = 93, .external_lex_state = 6},
  [2335] = {.lex_state = 219, .external_lex_state = 24},
  [2336] = {.lex_state = 219, .external_lex_state = 10},
  [2337] = {.lex_state = 219, .external_lex_state = 10},
  [2338] = {.lex_state = 115, .external_lex_state = 24},
  [2339] = {.lex_state = 115, .external_lex_state = 10},
  [2340] = {.lex_state = 131, .external_lex_state = 10},
  [2341] = {.lex_state = 219, .external_lex_state = 24},
  [2342] = {.lex_state = 219, .external_lex_state = 10},
  [2343] = {.lex_state = 219, .external_lex_state = 10},
  [2344] = {.lex_state = 219, .external_lex_state = 24},
  [2345] = {.lex_state = 219, .external_lex_state = 24},
  [2346] = {.lex_state = 219, .external_lex_state = 10},
  [2347] = {.lex_state = 110, .external_lex_state = 6},
  [2348] = {.lex_state = 110, .external_lex_state = 6},
  [2349] = {.lex_state = 115, .external_lex_state = 24},
  [2350] = {.lex_state = 99, .external_lex_state = 10},
  [2351] = {.lex_state = 115, .external_lex_state = 24},
  [2352] = {.lex_state = 219, .external_lex_state = 10},
  [2353] = {.lex_state = 219, .external_lex_state = 10},
  [2354] = {.lex_state = 219, .external_lex_state = 23},
  [2355] = {.lex_state = 221, .external_lex_state = 10},
  [2356] = {.lex_state = 219, .external_lex_state = 23},
  [2357] = {.lex_state = 115, .external_lex_state = 24},
  [2358] = {.lex_state = 219, .external_lex_state = 10},
  [2359] = {.lex_state = 115, .external_lex_state = 24},
  [2360] = {.lex_state = 115, .external_lex_state = 10},
  [2361] = {.lex_state = 131, .external_lex_state = 10},
  [2362] = {.lex_state = 115, .external_lex_state = 24},
  [2363] = {.lex_state = 219, .external_lex_state = 10},
  [2364] = {.lex_state = 219, .external_lex_state = 10},
  [2365] = {.lex_state = 151, .external_lex_state = 10},
  [2366] = {.lex_state = 151, .external_lex_state = 10},
  [2367] = {.lex_state = 181, .external_lex_state = 11},
  [2368] = {.lex_state = 181, .external_lex_state = 25},
  [2369] = {.lex_state = 219, .external_lex_state = 10},
  [2370] = {.lex_state = 219, .external_lex_state = 10},
  [2371] = {.lex_state = 115, .external_lex_state = 24},
  [2372] = {.lex_state = 115, .external_lex_state = 10},
  [2373] = {.lex_state = 131, .external_lex_state = 10},
  [2374] = {.lex_state = 181, .external_lex_state = 25},
  [2375] = {.lex_state = 219, .external_lex_state = 10},
  [2376] = {.lex_state = 219, .external_lex_state = 10},
  [2377] = {.lex_state = 181, .external_lex_state = 25},
  [2378] = {.lex_state = 181, .external_lex_state = 25},
  [2379] = {.lex_state = 219, .external_lex_state = 10},
  [2380] = {.lex_state = 181, .external_lex_state = 13},
  [2381] = {.lex_state = 219, .external_lex_state = 10},
  [2382] = {.lex_state = 219, .external_lex_state = 10},
  [2383] = {.lex_state = 115, .external_lex_state = 24},
  [2384] = {.lex_state = 115, .external_lex_state = 10},
  [2385] = {.lex_state = 131, .external_lex_state = 10},
  [2386] = {.lex_state = 181, .external_lex_state = 13},
  [2387] = {.lex_state = 219, .external_lex_state = 10},
  [2388] = {.lex_state = 219, .external_lex_state = 10},
  [2389] = {.lex_state = 181, .external_lex_state = 13},
  [2390] = {.lex_state = 181, .external_lex_state = 13},
  [2391] = {.lex_state = 219, .external_lex_state = 10},
  [2392] = {.lex_state = 184, .external_lex_state = 13},
  [2393] = {.lex_state = 219, .external_lex_state = 10},
  [2394] = {.lex_state = 184, .external_lex_state = 13},
  [2395] = {.lex_state = 184, .external_lex_state = 13},
  [2396] = {.lex_state = 219, .external_lex_state = 10},
  [2397] = {.lex_state = 184, .external_lex_state = 13},
  [2398] = {.lex_state = 197, .external_lex_state = 12},
  [2399] = {.lex_state = 171},
  [2400] = {.lex_state = 197, .external_lex_state = 12},
  [2401] = {.lex_state = 323},
  [2402] = {.lex_state = 89},
  [2403] = {.lex_state = 197, .external_lex_state = 12},
  [2404] = {.lex_state = 323},
  [2405] = {.lex_state = 89},
  [2406] = {.lex_state = 199, .external_lex_state = 25},
  [2407] = {.lex_state = 339, .external_lex_state = 11},
  [2408] = {.lex_state = 199, .external_lex_state = 25},
  [2409] = {.lex_state = 219, .external_lex_state = 10},
  [2410] = {.lex_state = 219, .external_lex_state = 10},
  [2411] = {.lex_state = 219, .external_lex_state = 23},
  [2412] = {.lex_state = 221, .external_lex_state = 10},
  [2413] = {.lex_state = 219, .external_lex_state = 23},
  [2414] = {.lex_state = 199, .external_lex_state = 25},
  [2415] = {.lex_state = 219, .external_lex_state = 10},
  [2416] = {.lex_state = 115, .external_lex_state = 24},
  [2417] = {.lex_state = 115, .external_lex_state = 10},
  [2418] = {.lex_state = 131, .external_lex_state = 10},
  [2419] = {.lex_state = 199, .external_lex_state = 25},
  [2420] = {.lex_state = 219, .external_lex_state = 10},
  [2421] = {.lex_state = 219, .external_lex_state = 10},
  [2422] = {.lex_state = 197, .external_lex_state = 12},
  [2423] = {.lex_state = 332},
  [2424] = {.lex_state = 197, .external_lex_state = 12},
  [2425] = {.lex_state = 332},
  [2426] = {.lex_state = 155},
  [2427] = {.lex_state = 117},
  [2428] = {.lex_state = 197, .external_lex_state = 13},
  [2429] = {.lex_state = 352, .external_lex_state = 12},
  [2430] = {.lex_state = 197, .external_lex_state = 13},
  [2431] = {.lex_state = 219, .external_lex_state = 10},
  [2432] = {.lex_state = 219, .external_lex_state = 10},
  [2433] = {.lex_state = 219, .external_lex_state = 23},
  [2434] = {.lex_state = 221, .external_lex_state = 10},
  [2435] = {.lex_state = 219, .external_lex_state = 23},
  [2436] = {.lex_state = 197, .external_lex_state = 13},
  [2437] = {.lex_state = 219, .external_lex_state = 10},
  [2438] = {.lex_state = 115, .external_lex_state = 24},
  [2439] = {.lex_state = 115, .external_lex_state = 10},
  [2440] = {.lex_state = 131, .external_lex_state = 10},
  [2441] = {.lex_state = 197, .external_lex_state = 13},
  [2442] = {.lex_state = 219, .external_lex_state = 10},
  [2443] = {.lex_state = 219, .external_lex_state = 10},
  [2444] = {.lex_state = 260, .external_lex_state = 9},
  [2445] = {.lex_state = 260, .external_lex_state = 9},
  [2446] = {.lex_state = 207},
  [2447] = {.lex_state = 260, .external_lex_state = 9},
  [2448] = {.lex_state = 89},
  [2449] = {.lex_state = 260, .external_lex_state = 9},
  [2450] = {.lex_state = 260, .external_lex_state = 9},
  [2451] = {.lex_state = 89},
  [2452] = {.lex_state = 260, .external_lex_state = 9},
  [2453] = {.lex_state = 260, .external_lex_state = 3},
  [2454] = {.lex_state = 260, .external_lex_state = 3},
  [2455] = {.lex_state = 219, .external_lex_state = 23},
  [2456] = {.lex_state = 260, .external_lex_state = 9},
  [2457] = {.lex_state = 219, .external_lex_state = 10},
  [2458] = {.lex_state = 151, .external_lex_state = 10},
  [2459] = {.lex_state = 125},
  [2460] = {.lex_state = 151, .external_lex_state = 10},
  [2461] = {.lex_state = 221, .external_lex_state = 10},
  [2462] = {.lex_state = 219, .external_lex_state = 23},
  [2463] = {.lex_state = 260, .external_lex_state = 9},
  [2464] = {.lex_state = 219, .external_lex_state = 10},
  [2465] = {.lex_state = 260, .external_lex_state = 6},
  [2466] = {.lex_state = 260, .external_lex_state = 6},
  [2467] = {.lex_state = 207},
  [2468] = {.lex_state = 260, .external_lex_state = 6},
  [2469] = {.lex_state = 89},
  [2470] = {.lex_state = 260, .external_lex_state = 6},
  [2471] = {.lex_state = 260, .external_lex_state = 6},
  [2472] = {.lex_state = 219, .external_lex_state = 23},
  [2473] = {.lex_state = 260, .external_lex_state = 6},
  [2474] = {.lex_state = 219, .external_lex_state = 10},
  [2475] = {.lex_state = 151, .external_lex_state = 10},
  [2476] = {.lex_state = 125},
  [2477] = {.lex_state = 151, .external_lex_state = 10},
  [2478] = {.lex_state = 221, .external_lex_state = 10},
  [2479] = {.lex_state = 219, .external_lex_state = 23},
  [2480] = {.lex_state = 260, .external_lex_state = 6},
  [2481] = {.lex_state = 219, .external_lex_state = 10},
  [2482] = {.lex_state = 79},
  [2483] = {.lex_state = 207},
  [2484] = {.lex_state = 314, .external_lex_state = 9},
  [2485] = {.lex_state = 136},
  [2486] = {.lex_state = 89},
  [2487] = {.lex_state = 314, .external_lex_state = 9},
  [2488] = {.lex_state = 79},
  [2489] = {.lex_state = 89, .external_lex_state = 17},
  [2490] = {.lex_state = 314, .external_lex_state = 9},
  [2491] = {.lex_state = 314, .external_lex_state = 9},
  [2492] = {.lex_state = 314, .external_lex_state = 9},
  [2493] = {.lex_state = 89, .external_lex_state = 2},
  [2494] = {.lex_state = 79},
  [2495] = {.lex_state = 151, .external_lex_state = 10},
  [2496] = {.lex_state = 155, .external_lex_state = 5},
  [2497] = {.lex_state = 125},
  [2498] = {.lex_state = 151, .external_lex_state = 10},
  [2499] = {.lex_state = 314, .external_lex_state = 3},
  [2500] = {.lex_state = 314, .external_lex_state = 3},
  [2501] = {.lex_state = 314, .external_lex_state = 3},
  [2502] = {.lex_state = 79},
  [2503] = {.lex_state = 207},
  [2504] = {.lex_state = 314, .external_lex_state = 6},
  [2505] = {.lex_state = 136},
  [2506] = {.lex_state = 89},
  [2507] = {.lex_state = 314, .external_lex_state = 6},
  [2508] = {.lex_state = 79},
  [2509] = {.lex_state = 314, .external_lex_state = 6},
  [2510] = {.lex_state = 314, .external_lex_state = 6},
  [2511] = {.lex_state = 314, .external_lex_state = 6},
  [2512] = {.lex_state = 89, .external_lex_state = 2},
  [2513] = {.lex_state = 79},
  [2514] = {.lex_state = 151, .external_lex_state = 10},
  [2515] = {.lex_state = 155, .external_lex_state = 5},
  [2516] = {.lex_state = 125},
  [2517] = {.lex_state = 151, .external_lex_state = 10},
  [2518] = {.lex_state = 314, .external_lex_state = 4},
  [2519] = {.lex_state = 314, .external_lex_state = 4},
  [2520] = {.lex_state = 314, .external_lex_state = 4},
  [2521] = {.lex_state = 317, .external_lex_state = 6},
  [2522] = {.lex_state = 317, .external_lex_state = 6},
  [2523] = {.lex_state = 219, .external_lex_state = 23},
  [2524] = {.lex_state = 317, .external_lex_state = 6},
  [2525] = {.lex_state = 219, .external_lex_state = 10},
  [2526] = {.lex_state = 151, .external_lex_state = 10},
  [2527] = {.lex_state = 125},
  [2528] = {.lex_state = 151, .external_lex_state = 10},
  [2529] = {.lex_state = 221, .external_lex_state = 10},
  [2530] = {.lex_state = 219, .external_lex_state = 23},
  [2531] = {.lex_state = 317, .external_lex_state = 6},
  [2532] = {.lex_state = 219, .external_lex_state = 10},
  [2533] = {.lex_state = 317, .external_lex_state = 6},
  [2534] = {.lex_state = 89},
  [2535] = {.lex_state = 317, .external_lex_state = 6},
  [2536] = {.lex_state = 89},
  [2537] = {.lex_state = 79, .external_lex_state = 2},
  [2538] = {.lex_state = 136},
  [2539] = {.lex_state = 320, .external_lex_state = 9},
  [2540] = {.lex_state = 79, .external_lex_state = 2},
  [2541] = {.lex_state = 99},
  [2542] = {.lex_state = 79, .external_lex_state = 2},
  [2543] = {.lex_state = 320, .external_lex_state = 9},
  [2544] = {.lex_state = 99, .external_lex_state = 5},
  [2545] = {.lex_state = 320, .external_lex_state = 3},
  [2546] = {.lex_state = 320, .external_lex_state = 3},
  [2547] = {.lex_state = 317, .external_lex_state = 6},
  [2548] = {.lex_state = 207},
  [2549] = {.lex_state = 276, .external_lex_state = 4},
  [2550] = {.lex_state = 320, .external_lex_state = 3},
  [2551] = {.lex_state = 276, .external_lex_state = 6},
  [2552] = {.lex_state = 276, .external_lex_state = 6},
  [2553] = {.lex_state = 276, .external_lex_state = 4},
  [2554] = {.lex_state = 342, .external_lex_state = 15},
  [2555] = {.lex_state = 89},
  [2556] = {.lex_state = 276, .external_lex_state = 4},
  [2557] = {.lex_state = 320, .external_lex_state = 3},
  [2558] = {.lex_state = 276, .external_lex_state = 6},
  [2559] = {.lex_state = 276, .external_lex_state = 4},
  [2560] = {.lex_state = 276, .external_lex_state = 4},
  [2561] = {.lex_state = 317, .external_lex_state = 4},
  [2562] = {.lex_state = 317, .external_lex_state = 6},
  [2563] = {.lex_state = 317, .external_lex_state = 4},
  [2564] = {.lex_state = 317, .external_lex_state = 4},
  [2565] = {.lex_state = 317, .external_lex_state = 4},
  [2566] = {.lex_state = 271, .external_lex_state = 2},
  [2567] = {.lex_state = 271, .external_lex_state = 20},
  [2568] = {.lex_state = 273, .external_lex_state = 6},
  [2569] = {.lex_state = 219, .external_lex_state = 10},
  [2570] = {.lex_state = 219, .external_lex_state = 10},
  [2571] = {.lex_state = 219, .external_lex_state = 23},
  [2572] = {.lex_state = 221, .external_lex_state = 10},
  [2573] = {.lex_state = 219, .external_lex_state = 23},
  [2574] = {.lex_state = 273, .external_lex_state = 6},
  [2575] = {.lex_state = 219, .external_lex_state = 10},
  [2576] = {.lex_state = 115, .external_lex_state = 24},
  [2577] = {.lex_state = 115, .external_lex_state = 10},
  [2578] = {.lex_state = 131, .external_lex_state = 10},
  [2579] = {.lex_state = 273, .external_lex_state = 6},
  [2580] = {.lex_state = 219, .external_lex_state = 10},
  [2581] = {.lex_state = 219, .external_lex_state = 10},
  [2582] = {.lex_state = 354, .external_lex_state = 4},
  [2583] = {.lex_state = 278, .external_lex_state = 3},
  [2584] = {.lex_state = 89},
  [2585] = {.lex_state = 79},
  [2586] = {.lex_state = 207},
  [2587] = {.lex_state = 278, .external_lex_state = 9},
  [2588] = {.lex_state = 136},
  [2589] = {.lex_state = 89},
  [2590] = {.lex_state = 278, .external_lex_state = 9},
  [2591] = {.lex_state = 79},
  [2592] = {.lex_state = 278, .external_lex_state = 9},
  [2593] = {.lex_state = 278, .external_lex_state = 9},
  [2594] = {.lex_state = 278, .external_lex_state = 9},
  [2595] = {.lex_state = 89, .external_lex_state = 2},
  [2596] = {.lex_state = 79},
  [2597] = {.lex_state = 151, .external_lex_state = 10},
  [2598] = {.lex_state = 155, .external_lex_state = 5},
  [2599] = {.lex_state = 125},
  [2600] = {.lex_state = 151, .external_lex_state = 10},
  [2601] = {.lex_state = 278, .external_lex_state = 3},
  [2602] = {.lex_state = 278, .external_lex_state = 3},
  [2603] = {.lex_state = 273, .external_lex_state = 6},
  [2604] = {.lex_state = 171},
  [2605] = {.lex_state = 276, .external_lex_state = 6},
  [2606] = {.lex_state = 276, .external_lex_state = 4},
  [2607] = {.lex_state = 223, .external_lex_state = 2},
  [2608] = {.lex_state = 276, .external_lex_state = 6},
  [2609] = {.lex_state = 276, .external_lex_state = 4},
  [2610] = {.lex_state = 187, .external_lex_state = 4},
  [2611] = {.lex_state = 342, .external_lex_state = 15},
  [2612] = {.lex_state = 187, .external_lex_state = 4},
  [2613] = {.lex_state = 323},
  [2614] = {.lex_state = 89, .external_lex_state = 16},
  [2615] = {.lex_state = 89},
  [2616] = {.lex_state = 89},
  [2617] = {.lex_state = 357, .external_lex_state = 3},
  [2618] = {.lex_state = 357, .external_lex_state = 4},
  [2619] = {.lex_state = 99},
  [2620] = {.lex_state = 79, .external_lex_state = 2},
  [2621] = {.lex_state = 79, .external_lex_state = 2},
  [2622] = {.lex_state = 99, .external_lex_state = 5},
  [2623] = {.lex_state = 364, .external_lex_state = 6},
  [2624] = {.lex_state = 364, .external_lex_state = 6},
  [2625] = {.lex_state = 364, .external_lex_state = 6},
  [2626] = {.lex_state = 79, .external_lex_state = 2},
  [2627] = {.lex_state = 123, .external_lex_state = 2},
  [2628] = {.lex_state = 125},
  [2629] = {.lex_state = 136},
  [2630] = {.lex_state = 281},
  [2631] = {.lex_state = 367, .external_lex_state = 4},
  [2632] = {.lex_state = 125},
  [2633] = {.lex_state = 364, .external_lex_state = 4},
  [2634] = {.lex_state = 89, .external_lex_state = 2},
  [2635] = {.lex_state = 323},
  [2636] = {.lex_state = 364, .external_lex_state = 4},
  [2637] = {.lex_state = 369, .external_lex_state = 3},
  [2638] = {.lex_state = 79, .external_lex_state = 2},
  [2639] = {.lex_state = 364, .external_lex_state = 4},
  [2640] = {.lex_state = 89, .external_lex_state = 16},
  [2641] = {.lex_state = 344, .external_lex_state = 2},
  [2642] = {.lex_state = 89},
  [2643] = {.lex_state = 281},
  [2644] = {.lex_state = 323},
  [2645] = {.lex_state = 344, .external_lex_state = 2},
  [2646] = {.lex_state = 89, .external_lex_state = 16},
  [2647] = {.lex_state = 89},
  [2648] = {.lex_state = 89},
  [2649] = {.lex_state = 202, .external_lex_state = 14},
  [2650] = {.lex_state = 219, .external_lex_state = 10},
  [2651] = {.lex_state = 202, .external_lex_state = 14},
  [2652] = {.lex_state = 202, .external_lex_state = 14},
  [2653] = {.lex_state = 219, .external_lex_state = 10},
  [2654] = {.lex_state = 202, .external_lex_state = 14},
  [2655] = {.lex_state = 187, .external_lex_state = 4},
  [2656] = {.lex_state = 323},
  [2657] = {.lex_state = 230, .external_lex_state = 16},
  [2658] = {.lex_state = 219, .external_lex_state = 10},
  [2659] = {.lex_state = 230, .external_lex_state = 16},
  [2660] = {.lex_state = 230, .external_lex_state = 16},
  [2661] = {.lex_state = 219, .external_lex_state = 10},
  [2662] = {.lex_state = 230, .external_lex_state = 16},
  [2663] = {.lex_state = 89, .external_lex_state = 16},
  [2664] = {.lex_state = 305},
  [2665] = {.lex_state = 89, .external_lex_state = 16},
  [2666] = {.lex_state = 219, .external_lex_state = 10},
  [2667] = {.lex_state = 219, .external_lex_state = 10},
  [2668] = {.lex_state = 219, .external_lex_state = 23},
  [2669] = {.lex_state = 221, .external_lex_state = 10},
  [2670] = {.lex_state = 219, .external_lex_state = 23},
  [2671] = {.lex_state = 89, .external_lex_state = 16},
  [2672] = {.lex_state = 219, .external_lex_state = 10},
  [2673] = {.lex_state = 115, .external_lex_state = 24},
  [2674] = {.lex_state = 115, .external_lex_state = 10},
  [2675] = {.lex_state = 131, .external_lex_state = 10},
  [2676] = {.lex_state = 89, .external_lex_state = 16},
  [2677] = {.lex_state = 219, .external_lex_state = 10},
  [2678] = {.lex_state = 219, .external_lex_state = 10},
  [2679] = {.lex_state = 147, .external_lex_state = 9},
  [2680] = {.lex_state = 219, .external_lex_state = 10},
  [2681] = {.lex_state = 219, .external_lex_state = 10},
  [2682] = {.lex_state = 115, .external_lex_state = 24},
  [2683] = {.lex_state = 115, .external_lex_state = 10},
  [2684] = {.lex_state = 131, .external_lex_state = 10},
  [2685] = {.lex_state = 147, .external_lex_state = 9},
  [2686] = {.lex_state = 219, .external_lex_state = 10},
  [2687] = {.lex_state = 219, .external_lex_state = 10},
  [2688] = {.lex_state = 147, .external_lex_state = 9},
  [2689] = {.lex_state = 147, .external_lex_state = 9},
  [2690] = {.lex_state = 219, .external_lex_state = 10},
  [2691] = {.lex_state = 136, .external_lex_state = 16},
  [2692] = {.lex_state = 219, .external_lex_state = 10},
  [2693] = {.lex_state = 136, .external_lex_state = 16},
  [2694] = {.lex_state = 136, .external_lex_state = 16},
  [2695] = {.lex_state = 219, .external_lex_state = 10},
  [2696] = {.lex_state = 136, .external_lex_state = 16},
  [2697] = {.lex_state = 248, .external_lex_state = 14},
  [2698] = {.lex_state = 372, .external_lex_state = 15},
  [2699] = {.lex_state = 248, .external_lex_state = 14},
  [2700] = {.lex_state = 219, .external_lex_state = 10},
  [2701] = {.lex_state = 219, .external_lex_state = 10},
  [2702] = {.lex_state = 219, .external_lex_state = 23},
  [2703] = {.lex_state = 221, .external_lex_state = 10},
  [2704] = {.lex_state = 219, .external_lex_state = 23},
  [2705] = {.lex_state = 248, .external_lex_state = 14},
  [2706] = {.lex_state = 219, .external_lex_state = 10},
  [2707] = {.lex_state = 115, .external_lex_state = 24},
  [2708] = {.lex_state = 115, .external_lex_state = 10},
  [2709] = {.lex_state = 131, .external_lex_state = 10},
  [2710] = {.lex_state = 248, .external_lex_state = 14},
  [2711] = {.lex_state = 219, .external_lex_state = 10},
  [2712] = {.lex_state = 219, .external_lex_state = 10},
  [2713] = {.lex_state = 187, .external_lex_state = 4},
  [2714] = {.lex_state = 332},
  [2715] = {.lex_state = 332},
  [2716] = {.lex_state = 236, .external_lex_state = 14},
  [2717] = {.lex_state = 219, .external_lex_state = 10},
  [2718] = {.lex_state = 219, .external_lex_state = 10},
  [2719] = {.lex_state = 115, .external_lex_state = 24},
  [2720] = {.lex_state = 115, .external_lex_state = 10},
  [2721] = {.lex_state = 131, .external_lex_state = 10},
  [2722] = {.lex_state = 236, .external_lex_state = 14},
  [2723] = {.lex_state = 219, .external_lex_state = 10},
  [2724] = {.lex_state = 219, .external_lex_state = 10},
  [2725] = {.lex_state = 236, .external_lex_state = 14},
  [2726] = {.lex_state = 236, .external_lex_state = 14},
  [2727] = {.lex_state = 219, .external_lex_state = 10},
  [2728] = {.lex_state = 155},
  [2729] = {.lex_state = 286, .external_lex_state = 9},
  [2730] = {.lex_state = 286, .external_lex_state = 9},
  [2731] = {.lex_state = 207},
  [2732] = {.lex_state = 286, .external_lex_state = 9},
  [2733] = {.lex_state = 89},
  [2734] = {.lex_state = 286, .external_lex_state = 9},
  [2735] = {.lex_state = 286, .external_lex_state = 9},
  [2736] = {.lex_state = 89},
  [2737] = {.lex_state = 286, .external_lex_state = 9},
  [2738] = {.lex_state = 286, .external_lex_state = 3},
  [2739] = {.lex_state = 286, .external_lex_state = 3},
  [2740] = {.lex_state = 219, .external_lex_state = 23},
  [2741] = {.lex_state = 286, .external_lex_state = 9},
  [2742] = {.lex_state = 219, .external_lex_state = 10},
  [2743] = {.lex_state = 151, .external_lex_state = 10},
  [2744] = {.lex_state = 125},
  [2745] = {.lex_state = 151, .external_lex_state = 10},
  [2746] = {.lex_state = 221, .external_lex_state = 10},
  [2747] = {.lex_state = 219, .external_lex_state = 23},
  [2748] = {.lex_state = 286, .external_lex_state = 9},
  [2749] = {.lex_state = 219, .external_lex_state = 10},
  [2750] = {.lex_state = 286, .external_lex_state = 6},
  [2751] = {.lex_state = 286, .external_lex_state = 6},
  [2752] = {.lex_state = 207},
  [2753] = {.lex_state = 286, .external_lex_state = 6},
  [2754] = {.lex_state = 89},
  [2755] = {.lex_state = 286, .external_lex_state = 6},
  [2756] = {.lex_state = 286, .external_lex_state = 6},
  [2757] = {.lex_state = 219, .external_lex_state = 23},
  [2758] = {.lex_state = 286, .external_lex_state = 6},
  [2759] = {.lex_state = 219, .external_lex_state = 10},
  [2760] = {.lex_state = 151, .external_lex_state = 10},
  [2761] = {.lex_state = 125},
  [2762] = {.lex_state = 151, .external_lex_state = 10},
  [2763] = {.lex_state = 221, .external_lex_state = 10},
  [2764] = {.lex_state = 219, .external_lex_state = 23},
  [2765] = {.lex_state = 286, .external_lex_state = 6},
  [2766] = {.lex_state = 219, .external_lex_state = 10},
  [2767] = {.lex_state = 293, .external_lex_state = 6},
  [2768] = {.lex_state = 219, .external_lex_state = 10},
  [2769] = {.lex_state = 219, .external_lex_state = 10},
  [2770] = {.lex_state = 219, .external_lex_state = 23},
  [2771] = {.lex_state = 221, .external_lex_state = 10},
  [2772] = {.lex_state = 219, .external_lex_state = 23},
  [2773] = {.lex_state = 293, .external_lex_state = 6},
  [2774] = {.lex_state = 219, .external_lex_state = 10},
  [2775] = {.lex_state = 115, .external_lex_state = 24},
  [2776] = {.lex_state = 115, .external_lex_state = 10},
  [2777] = {.lex_state = 131, .external_lex_state = 10},
  [2778] = {.lex_state = 293, .external_lex_state = 6},
  [2779] = {.lex_state = 219, .external_lex_state = 10},
  [2780] = {.lex_state = 219, .external_lex_state = 10},
  [2781] = {.lex_state = 375, .external_lex_state = 4},
  [2782] = {.lex_state = 300, .external_lex_state = 3},
  [2783] = {.lex_state = 89},
  [2784] = {.lex_state = 79},
  [2785] = {.lex_state = 207},
  [2786] = {.lex_state = 300, .external_lex_state = 9},
  [2787] = {.lex_state = 136},
  [2788] = {.lex_state = 89},
  [2789] = {.lex_state = 300, .external_lex_state = 9},
  [2790] = {.lex_state = 79},
  [2791] = {.lex_state = 300, .external_lex_state = 9},
  [2792] = {.lex_state = 300, .external_lex_state = 9},
  [2793] = {.lex_state = 300, .external_lex_state = 9},
  [2794] = {.lex_state = 89, .external_lex_state = 2},
  [2795] = {.lex_state = 79},
  [2796] = {.lex_state = 151, .external_lex_state = 10},
  [2797] = {.lex_state = 155, .external_lex_state = 5},
  [2798] = {.lex_state = 125},
  [2799] = {.lex_state = 151, .external_lex_state = 10},
  [2800] = {.lex_state = 300, .external_lex_state = 3},
  [2801] = {.lex_state = 300, .external_lex_state = 3},
  [2802] = {.lex_state = 293, .external_lex_state = 6},
  [2803] = {.lex_state = 79},
  [2804] = {.lex_state = 207},
  [2805] = {.lex_state = 296, .external_lex_state = 6},
  [2806] = {.lex_state = 136},
  [2807] = {.lex_state = 89},
  [2808] = {.lex_state = 296, .external_lex_state = 6},
  [2809] = {.lex_state = 79},
  [2810] = {.lex_state = 296, .external_lex_state = 6},
  [2811] = {.lex_state = 296, .external_lex_state = 6},
  [2812] = {.lex_state = 296, .external_lex_state = 6},
  [2813] = {.lex_state = 89, .external_lex_state = 2},
  [2814] = {.lex_state = 79},
  [2815] = {.lex_state = 151, .external_lex_state = 10},
  [2816] = {.lex_state = 155, .external_lex_state = 5},
  [2817] = {.lex_state = 125},
  [2818] = {.lex_state = 151, .external_lex_state = 10},
  [2819] = {.lex_state = 296, .external_lex_state = 4},
  [2820] = {.lex_state = 240, .external_lex_state = 2},
  [2821] = {.lex_state = 296, .external_lex_state = 6},
  [2822] = {.lex_state = 296, .external_lex_state = 4},
  [2823] = {.lex_state = 348, .external_lex_state = 15},
  [2824] = {.lex_state = 213, .external_lex_state = 18},
  [2825] = {.lex_state = 219, .external_lex_state = 10},
  [2826] = {.lex_state = 213, .external_lex_state = 18},
  [2827] = {.lex_state = 213, .external_lex_state = 18},
  [2828] = {.lex_state = 219, .external_lex_state = 10},
  [2829] = {.lex_state = 213, .external_lex_state = 18},
  [2830] = {.lex_state = 303, .external_lex_state = 6},
  [2831] = {.lex_state = 219, .external_lex_state = 10},
  [2832] = {.lex_state = 219, .external_lex_state = 10},
  [2833] = {.lex_state = 115, .external_lex_state = 24},
  [2834] = {.lex_state = 115, .external_lex_state = 10},
  [2835] = {.lex_state = 131, .external_lex_state = 10},
  [2836] = {.lex_state = 303, .external_lex_state = 6},
  [2837] = {.lex_state = 219, .external_lex_state = 10},
  [2838] = {.lex_state = 219, .external_lex_state = 10},
  [2839] = {.lex_state = 303, .external_lex_state = 6},
  [2840] = {.lex_state = 303, .external_lex_state = 6},
  [2841] = {.lex_state = 219, .external_lex_state = 10},
  [2842] = {.lex_state = 79, .external_lex_state = 27},
  [2843] = {.lex_state = 219, .external_lex_state = 10},
  [2844] = {.lex_state = 219, .external_lex_state = 10},
  [2845] = {.lex_state = 219, .external_lex_state = 23},
  [2846] = {.lex_state = 221, .external_lex_state = 10},
  [2847] = {.lex_state = 219, .external_lex_state = 23},
  [2848] = {.lex_state = 79, .external_lex_state = 27},
  [2849] = {.lex_state = 219, .external_lex_state = 10},
  [2850] = {.lex_state = 115, .external_lex_state = 24},
  [2851] = {.lex_state = 115, .external_lex_state = 10},
  [2852] = {.lex_state = 131, .external_lex_state = 10},
  [2853] = {.lex_state = 79, .external_lex_state = 27},
  [2854] = {.lex_state = 219, .external_lex_state = 10},
  [2855] = {.lex_state = 219, .external_lex_state = 10},
  [2856] = {.lex_state = 89, .external_lex_state = 8},
  [2857] = {.lex_state = 89, .external_lex_state = 8},
  [2858] = {.lex_state = 93, .external_lex_state = 9},
  [2859] = {.lex_state = 93, .external_lex_state = 9},
  [2860] = {.lex_state = 93, .external_lex_state = 6},
  [2861] = {.lex_state = 93, .external_lex_state = 6},
  [2862] = {.lex_state = 219, .external_lex_state = 24},
  [2863] = {.lex_state = 219, .external_lex_state = 10},
  [2864] = {.lex_state = 219, .external_lex_state = 24},
  [2865] = {.lex_state = 219, .external_lex_state = 24},
  [2866] = {.lex_state = 219, .external_lex_state = 10},
  [2867] = {.lex_state = 219, .external_lex_state = 24},
  [2868] = {.lex_state = 115, .external_lex_state = 24},
  [2869] = {.lex_state = 219, .external_lex_state = 10},
  [2870] = {.lex_state = 219, .external_lex_state = 10},
  [2871] = {.lex_state = 115, .external_lex_state = 24},
  [2872] = {.lex_state = 115, .external_lex_state = 10},
  [2873] = {.lex_state = 131, .external_lex_state = 10},
  [2874] = {.lex_state = 115, .external_lex_state = 24},
  [2875] = {.lex_state = 219, .external_lex_state = 10},
  [2876] = {.lex_state = 219, .external_lex_state = 10},
  [2877] = {.lex_state = 115, .external_lex_state = 24},
  [2878] = {.lex_state = 115, .external_lex_state = 24},
  [2879] = {.lex_state = 219, .external_lex_state = 10},
  [2880] = {.lex_state = 181, .external_lex_state = 25},
  [2881] = {.lex_state = 219, .external_lex_state = 10},
  [2882] = {.lex_state = 181, .external_lex_state = 25},
  [2883] = {.lex_state = 181, .external_lex_state = 25},
  [2884] = {.lex_state = 219, .external_lex_state = 10},
  [2885] = {.lex_state = 181, .external_lex_state = 25},
  [2886] = {.lex_state = 181, .external_lex_state = 13},
  [2887] = {.lex_state = 219, .external_lex_state = 10},
  [2888] = {.lex_state = 181, .external_lex_state = 13},
  [2889] = {.lex_state = 181, .external_lex_state = 13},
  [2890] = {.lex_state = 219, .external_lex_state = 10},
  [2891] = {.lex_state = 181, .external_lex_state = 13},
  [2892] = {.lex_state = 184, .external_lex_state = 13},
  [2893] = {.lex_state = 184, .external_lex_state = 13},
  [2894] = {.lex_state = 197, .external_lex_state = 12},
  [2895] = {.lex_state = 197, .external_lex_state = 12},
  [2896] = {.lex_state = 323},
  [2897] = {.lex_state = 197, .external_lex_state = 12},
  [2898] = {.lex_state = 323},
  [2899] = {.lex_state = 199, .external_lex_state = 25},
  [2900] = {.lex_state = 219, .external_lex_state = 10},
  [2901] = {.lex_state = 219, .external_lex_state = 10},
  [2902] = {.lex_state = 115, .external_lex_state = 24},
  [2903] = {.lex_state = 115, .external_lex_state = 10},
  [2904] = {.lex_state = 131, .external_lex_state = 10},
  [2905] = {.lex_state = 199, .external_lex_state = 25},
  [2906] = {.lex_state = 219, .external_lex_state = 10},
  [2907] = {.lex_state = 219, .external_lex_state = 10},
  [2908] = {.lex_state = 199, .external_lex_state = 25},
  [2909] = {.lex_state = 199, .external_lex_state = 25},
  [2910] = {.lex_state = 219, .external_lex_state = 10},
  [2911] = {.lex_state = 197, .external_lex_state = 12},
  [2912] = {.lex_state = 332},
  [2913] = {.lex_state = 332},
  [2914] = {.lex_state = 155},
  [2915] = {.lex_state = 197, .external_lex_state = 13},
  [2916] = {.lex_state = 219, .external_lex_state = 10},
  [2917] = {.lex_state = 219, .external_lex_state = 10},
  [2918] = {.lex_state = 115, .external_lex_state = 24},
  [2919] = {.lex_state = 115, .external_lex_state = 10},
  [2920] = {.lex_state = 131, .external_lex_state = 10},
  [2921] = {.lex_state = 197, .external_lex_state = 13},
  [2922] = {.lex_state = 219, .external_lex_state = 10},
  [2923] = {.lex_state = 219, .external_lex_state = 10},
  [2924] = {.lex_state = 197, .external_lex_state = 13},
  [2925] = {.lex_state = 197, .external_lex_state = 13},
  [2926] = {.lex_state = 219, .external_lex_state = 10},
  [2927] = {.lex_state = 260, .external_lex_state = 9},
  [2928] = {.lex_state = 378, .external_lex_state = 3},
  [2929] = {.lex_state = 260, .external_lex_state = 3},
  [2930] = {.lex_state = 89},
  [2931] = {.lex_state = 260, .external_lex_state = 9},
  [2932] = {.lex_state = 219, .external_lex_state = 10},
  [2933] = {.lex_state = 219, .external_lex_state = 10},
  [2934] = {.lex_state = 219, .external_lex_state = 23},
  [2935] = {.lex_state = 221, .external_lex_state = 10},
  [2936] = {.lex_state = 219, .external_lex_state = 23},
  [2937] = {.lex_state = 260, .external_lex_state = 9},
  [2938] = {.lex_state = 219, .external_lex_state = 10},
  [2939] = {.lex_state = 115, .external_lex_state = 24},
  [2940] = {.lex_state = 115, .external_lex_state = 10},
  [2941] = {.lex_state = 131, .external_lex_state = 10},
  [2942] = {.lex_state = 260, .external_lex_state = 9},
  [2943] = {.lex_state = 219, .external_lex_state = 10},
  [2944] = {.lex_state = 219, .external_lex_state = 10},
  [2945] = {.lex_state = 260, .external_lex_state = 6},
  [2946] = {.lex_state = 378, .external_lex_state = 4},
  [2947] = {.lex_state = 260, .external_lex_state = 6},
  [2948] = {.lex_state = 219, .external_lex_state = 10},
  [2949] = {.lex_state = 219, .external_lex_state = 10},
  [2950] = {.lex_state = 219, .external_lex_state = 23},
  [2951] = {.lex_state = 221, .external_lex_state = 10},
  [2952] = {.lex_state = 219, .external_lex_state = 23},
  [2953] = {.lex_state = 260, .external_lex_state = 6},
  [2954] = {.lex_state = 219, .external_lex_state = 10},
  [2955] = {.lex_state = 115, .external_lex_state = 24},
  [2956] = {.lex_state = 115, .external_lex_state = 10},
  [2957] = {.lex_state = 131, .external_lex_state = 10},
  [2958] = {.lex_state = 260, .external_lex_state = 6},
  [2959] = {.lex_state = 219, .external_lex_state = 10},
  [2960] = {.lex_state = 219, .external_lex_state = 10},
  [2961] = {.lex_state = 314, .external_lex_state = 9},
  [2962] = {.lex_state = 314, .external_lex_state = 9},
  [2963] = {.lex_state = 207},
  [2964] = {.lex_state = 314, .external_lex_state = 9},
  [2965] = {.lex_state = 89},
  [2966] = {.lex_state = 314, .external_lex_state = 9},
  [2967] = {.lex_state = 314, .external_lex_state = 9},
  [2968] = {.lex_state = 89},
  [2969] = {.lex_state = 314, .external_lex_state = 9},
  [2970] = {.lex_state = 314, .external_lex_state = 3},
  [2971] = {.lex_state = 314, .external_lex_state = 3},
  [2972] = {.lex_state = 219, .external_lex_state = 23},
  [2973] = {.lex_state = 314, .external_lex_state = 9},
  [2974] = {.lex_state = 219, .external_lex_state = 10},
  [2975] = {.lex_state = 151, .external_lex_state = 10},
  [2976] = {.lex_state = 125},
  [2977] = {.lex_state = 151, .external_lex_state = 10},
  [2978] = {.lex_state = 221, .external_lex_state = 10},
  [2979] = {.lex_state = 219, .external_lex_state = 23},
  [2980] = {.lex_state = 314, .external_lex_state = 9},
  [2981] = {.lex_state = 219, .external_lex_state = 10},
  [2982] = {.lex_state = 314, .external_lex_state = 6},
  [2983] = {.lex_state = 314, .external_lex_state = 6},
  [2984] = {.lex_state = 207},
  [2985] = {.lex_state = 314, .external_lex_state = 6},
  [2986] = {.lex_state = 89},
  [2987] = {.lex_state = 314, .external_lex_state = 6},
  [2988] = {.lex_state = 314, .external_lex_state = 6},
  [2989] = {.lex_state = 219, .external_lex_state = 23},
  [2990] = {.lex_state = 314, .external_lex_state = 6},
  [2991] = {.lex_state = 219, .external_lex_state = 10},
  [2992] = {.lex_state = 151, .external_lex_state = 10},
  [2993] = {.lex_state = 125},
  [2994] = {.lex_state = 151, .external_lex_state = 10},
  [2995] = {.lex_state = 221, .external_lex_state = 10},
  [2996] = {.lex_state = 219, .external_lex_state = 23},
  [2997] = {.lex_state = 314, .external_lex_state = 6},
  [2998] = {.lex_state = 219, .external_lex_state = 10},
  [2999] = {.lex_state = 317, .external_lex_state = 6},
  [3000] = {.lex_state = 219, .external_lex_state = 10},
  [3001] = {.lex_state = 219, .external_lex_state = 10},
  [3002] = {.lex_state = 219, .external_lex_state = 23},
  [3003] = {.lex_state = 221, .external_lex_state = 10},
  [3004] = {.lex_state = 219, .external_lex_state = 23},
  [3005] = {.lex_state = 317, .external_lex_state = 6},
  [3006] = {.lex_state = 219, .external_lex_state = 10},
  [3007] = {.lex_state = 115, .external_lex_state = 24},
  [3008] = {.lex_state = 115, .external_lex_state = 10},
  [3009] = {.lex_state = 131, .external_lex_state = 10},
  [3010] = {.lex_state = 317, .external_lex_state = 6},
  [3011] = {.lex_state = 219, .external_lex_state = 10},
  [3012] = {.lex_state = 219, .external_lex_state = 10},
  [3013] = {.lex_state = 381, .external_lex_state = 4},
  [3014] = {.lex_state = 320, .external_lex_state = 3},
  [3015] = {.lex_state = 89},
  [3016] = {.lex_state = 79},
  [3017] = {.lex_state = 207},
  [3018] = {.lex_state = 320, .external_lex_state = 9},
  [3019] = {.lex_state = 136},
  [3020] = {.lex_state = 89},
  [3021] = {.lex_state = 320, .external_lex_state = 9},
  [3022] = {.lex_state = 79},
  [3023] = {.lex_state = 320, .external_lex_state = 9},
  [3024] = {.lex_state = 320, .external_lex_state = 9},
  [3025] = {.lex_state = 320, .external_lex_state = 9},
  [3026] = {.lex_state = 89, .external_lex_state = 2},
  [3027] = {.lex_state = 79},
  [3028] = {.lex_state = 151, .external_lex_state = 10},
  [3029] = {.lex_state = 155, .external_lex_state = 5},
  [3030] = {.lex_state = 125},
  [3031] = {.lex_state = 151, .external_lex_state = 10},
  [3032] = {.lex_state = 320, .external_lex_state = 3},
  [3033] = {.lex_state = 320, .external_lex_state = 3},
  [3034] = {.lex_state = 317, .external_lex_state = 6},
  [3035] = {.lex_state = 276, .external_lex_state = 6},
  [3036] = {.lex_state = 276, .external_lex_state = 4},
  [3037] = {.lex_state = 271, .external_lex_state = 2},
  [3038] = {.lex_state = 276, .external_lex_state = 6},
  [3039] = {.lex_state = 276, .external_lex_state = 4},
  [3040] = {.lex_state = 342, .external_lex_state = 15},
  [3041] = {.lex_state = 273, .external_lex_state = 6},
  [3042] = {.lex_state = 219, .external_lex_state = 10},
  [3043] = {.lex_state = 219, .external_lex_state = 10},
  [3044] = {.lex_state = 115, .external_lex_state = 24},
  [3045] = {.lex_state = 115, .external_lex_state = 10},
  [3046] = {.lex_state = 131, .external_lex_state = 10},
  [3047] = {.lex_state = 273, .external_lex_state = 6},
  [3048] = {.lex_state = 219, .external_lex_state = 10},
  [3049] = {.lex_state = 219, .external_lex_state = 10},
  [3050] = {.lex_state = 273, .external_lex_state = 6},
  [3051] = {.lex_state = 273, .external_lex_state = 6},
  [3052] = {.lex_state = 219, .external_lex_state = 10},
  [3053] = {.lex_state = 278, .external_lex_state = 3},
  [3054] = {.lex_state = 278, .external_lex_state = 9},
  [3055] = {.lex_state = 278, .external_lex_state = 9},
  [3056] = {.lex_state = 207},
  [3057] = {.lex_state = 278, .external_lex_state = 9},
  [3058] = {.lex_state = 89},
  [3059] = {.lex_state = 278, .external_lex_state = 9},
  [3060] = {.lex_state = 278, .external_lex_state = 9},
  [3061] = {.lex_state = 219, .external_lex_state = 23},
  [3062] = {.lex_state = 278, .external_lex_state = 9},
  [3063] = {.lex_state = 219, .external_lex_state = 10},
  [3064] = {.lex_state = 151, .external_lex_state = 10},
  [3065] = {.lex_state = 125},
  [3066] = {.lex_state = 151, .external_lex_state = 10},
  [3067] = {.lex_state = 221, .external_lex_state = 10},
  [3068] = {.lex_state = 219, .external_lex_state = 23},
  [3069] = {.lex_state = 278, .external_lex_state = 9},
  [3070] = {.lex_state = 219, .external_lex_state = 10},
  [3071] = {.lex_state = 89},
  [3072] = {.lex_state = 276, .external_lex_state = 6},
  [3073] = {.lex_state = 223, .external_lex_state = 2},
  [3074] = {.lex_state = 187, .external_lex_state = 4},
  [3075] = {.lex_state = 79, .external_lex_state = 2},
  [3076] = {.lex_state = 136},
  [3077] = {.lex_state = 357, .external_lex_state = 9},
  [3078] = {.lex_state = 79, .external_lex_state = 2},
  [3079] = {.lex_state = 125},
  [3080] = {.lex_state = 99},
  [3081] = {.lex_state = 79, .external_lex_state = 2},
  [3082] = {.lex_state = 357, .external_lex_state = 9},
  [3083] = {.lex_state = 99, .external_lex_state = 5},
  [3084] = {.lex_state = 357, .external_lex_state = 3},
  [3085] = {.lex_state = 357, .external_lex_state = 3},
  [3086] = {.lex_state = 125},
  [3087] = {.lex_state = 79, .external_lex_state = 2},
  [3088] = {.lex_state = 136},
  [3089] = {.lex_state = 357, .external_lex_state = 6},
  [3090] = {.lex_state = 79, .external_lex_state = 2},
  [3091] = {.lex_state = 99},
  [3092] = {.lex_state = 79, .external_lex_state = 2},
  [3093] = {.lex_state = 357, .external_lex_state = 6},
  [3094] = {.lex_state = 99, .external_lex_state = 5},
  [3095] = {.lex_state = 357, .external_lex_state = 4},
  [3096] = {.lex_state = 357, .external_lex_state = 4},
  [3097] = {.lex_state = 364, .external_lex_state = 6},
  [3098] = {.lex_state = 364, .external_lex_state = 6},
  [3099] = {.lex_state = 364, .external_lex_state = 6},
  [3100] = {.lex_state = 79},
  [3101] = {.lex_state = 89, .external_lex_state = 2},
  [3102] = {.lex_state = 79},
  [3103] = {.lex_state = 151, .external_lex_state = 10},
  [3104] = {.lex_state = 155, .external_lex_state = 5},
  [3105] = {.lex_state = 125},
  [3106] = {.lex_state = 151, .external_lex_state = 10},
  [3107] = {.lex_state = 89},
  [3108] = {.lex_state = 364, .external_lex_state = 6},
  [3109] = {.lex_state = 79},
  [3110] = {.lex_state = 89, .external_lex_state = 17},
  [3111] = {.lex_state = 207},
  [3112] = {.lex_state = 364, .external_lex_state = 6},
  [3113] = {.lex_state = 136},
  [3114] = {.lex_state = 79, .external_lex_state = 2},
  [3115] = {.lex_state = 89},
  [3116] = {.lex_state = 344, .external_lex_state = 20},
  [3117] = {.lex_state = 344, .external_lex_state = 2},
  [3118] = {.lex_state = 131},
  [3119] = {.lex_state = 79, .external_lex_state = 2},
  [3120] = {.lex_state = 89},
  [3121] = {.lex_state = 367, .external_lex_state = 4},
  [3122] = {.lex_state = 364, .external_lex_state = 4},
  [3123] = {.lex_state = 281},
  [3124] = {.lex_state = 364, .external_lex_state = 6},
  [3125] = {.lex_state = 89, .external_lex_state = 22},
  [3126] = {.lex_state = 364, .external_lex_state = 4},
  [3127] = {.lex_state = 364, .external_lex_state = 4},
  [3128] = {.lex_state = 367, .external_lex_state = 4},
  [3129] = {.lex_state = 369, .external_lex_state = 3},
  [3130] = {.lex_state = 364, .external_lex_state = 4},
  [3131] = {.lex_state = 364, .external_lex_state = 4},
  [3132] = {.lex_state = 323},
  [3133] = {.lex_state = 281},
  [3134] = {.lex_state = 323},
  [3135] = {.lex_state = 79, .external_lex_state = 2},
  [3136] = {.lex_state = 89},
  [3137] = {.lex_state = 79, .external_lex_state = 2},
  [3138] = {.lex_state = 89},
  [3139] = {.lex_state = 202, .external_lex_state = 14},
  [3140] = {.lex_state = 202, .external_lex_state = 14},
  [3141] = {.lex_state = 187, .external_lex_state = 4},
  [3142] = {.lex_state = 230, .external_lex_state = 16},
  [3143] = {.lex_state = 230, .external_lex_state = 16},
  [3144] = {.lex_state = 89, .external_lex_state = 16},
  [3145] = {.lex_state = 219, .external_lex_state = 10},
  [3146] = {.lex_state = 219, .external_lex_state = 10},
  [3147] = {.lex_state = 115, .external_lex_state = 24},
  [3148] = {.lex_state = 115, .external_lex_state = 10},
  [3149] = {.lex_state = 131, .external_lex_state = 10},
  [3150] = {.lex_state = 89, .external_lex_state = 16},
  [3151] = {.lex_state = 219, .external_lex_state = 10},
  [3152] = {.lex_state = 219, .external_lex_state = 10},
  [3153] = {.lex_state = 89, .external_lex_state = 16},
  [3154] = {.lex_state = 89, .external_lex_state = 16},
  [3155] = {.lex_state = 219, .external_lex_state = 10},
  [3156] = {.lex_state = 147, .external_lex_state = 9},
  [3157] = {.lex_state = 219, .external_lex_state = 10},
  [3158] = {.lex_state = 147, .external_lex_state = 9},
  [3159] = {.lex_state = 147, .external_lex_state = 9},
  [3160] = {.lex_state = 219, .external_lex_state = 10},
  [3161] = {.lex_state = 147, .external_lex_state = 9},
  [3162] = {.lex_state = 136, .external_lex_state = 16},
  [3163] = {.lex_state = 136, .external_lex_state = 16},
  [3164] = {.lex_state = 248, .external_lex_state = 14},
  [3165] = {.lex_state = 219, .external_lex_state = 10},
  [3166] = {.lex_state = 219, .external_lex_state = 10},
  [3167] = {.lex_state = 115, .external_lex_state = 24},
  [3168] = {.lex_state = 115, .external_lex_state = 10},
  [3169] = {.lex_state = 131, .external_lex_state = 10},
  [3170] = {.lex_state = 248, .external_lex_state = 14},
  [3171] = {.lex_state = 219, .external_lex_state = 10},
  [3172] = {.lex_state = 219, .external_lex_state = 10},
  [3173] = {.lex_state = 248, .external_lex_state = 14},
  [3174] = {.lex_state = 248, .external_lex_state = 14},
  [3175] = {.lex_state = 219, .external_lex_state = 10},
  [3176] = {.lex_state = 187, .external_lex_state = 4},
  [3177] = {.lex_state = 332},
  [3178] = {.lex_state = 236, .external_lex_state = 14},
  [3179] = {.lex_state = 219, .external_lex_state = 10},
  [3180] = {.lex_state = 236, .external_lex_state = 14},
  [3181] = {.lex_state = 236, .external_lex_state = 14},
  [3182] = {.lex_state = 219, .external_lex_state = 10},
  [3183] = {.lex_state = 236, .external_lex_state = 14},
  [3184] = {.lex_state = 332},
  [3185] = {.lex_state = 286, .external_lex_state = 9},
  [3186] = {.lex_state = 384, .external_lex_state = 3},
  [3187] = {.lex_state = 286, .external_lex_state = 3},
  [3188] = {.lex_state = 89},
  [3189] = {.lex_state = 286, .external_lex_state = 9},
  [3190] = {.lex_state = 219, .external_lex_state = 10},
  [3191] = {.lex_state = 219, .external_lex_state = 10},
  [3192] = {.lex_state = 219, .external_lex_state = 23},
  [3193] = {.lex_state = 221, .external_lex_state = 10},
  [3194] = {.lex_state = 219, .external_lex_state = 23},
  [3195] = {.lex_state = 286, .external_lex_state = 9},
  [3196] = {.lex_state = 219, .external_lex_state = 10},
  [3197] = {.lex_state = 115, .external_lex_state = 24},
  [3198] = {.lex_state = 115, .external_lex_state = 10},
  [3199] = {.lex_state = 131, .external_lex_state = 10},
  [3200] = {.lex_state = 286, .external_lex_state = 9},
  [3201] = {.lex_state = 219, .external_lex_state = 10},
  [3202] = {.lex_state = 219, .external_lex_state = 10},
  [3203] = {.lex_state = 286, .external_lex_state = 6},
  [3204] = {.lex_state = 384, .external_lex_state = 4},
  [3205] = {.lex_state = 286, .external_lex_state = 6},
  [3206] = {.lex_state = 219, .external_lex_state = 10},
  [3207] = {.lex_state = 219, .external_lex_state = 10},
  [3208] = {.lex_state = 219, .external_lex_state = 23},
  [3209] = {.lex_state = 221, .external_lex_state = 10},
  [3210] = {.lex_state = 219, .external_lex_state = 23},
  [3211] = {.lex_state = 286, .external_lex_state = 6},
  [3212] = {.lex_state = 219, .external_lex_state = 10},
  [3213] = {.lex_state = 115, .external_lex_state = 24},
  [3214] = {.lex_state = 115, .external_lex_state = 10},
  [3215] = {.lex_state = 131, .external_lex_state = 10},
  [3216] = {.lex_state = 286, .external_lex_state = 6},
  [3217] = {.lex_state = 219, .external_lex_state = 10},
  [3218] = {.lex_state = 219, .external_lex_state = 10},
  [3219] = {.lex_state = 293, .external_lex_state = 6},
  [3220] = {.lex_state = 219, .external_lex_state = 10},
  [3221] = {.lex_state = 219, .external_lex_state = 10},
  [3222] = {.lex_state = 115, .external_lex_state = 24},
  [3223] = {.lex_state = 115, .external_lex_state = 10},
  [3224] = {.lex_state = 131, .external_lex_state = 10},
  [3225] = {.lex_state = 293, .external_lex_state = 6},
  [3226] = {.lex_state = 219, .external_lex_state = 10},
  [3227] = {.lex_state = 219, .external_lex_state = 10},
  [3228] = {.lex_state = 293, .external_lex_state = 6},
  [3229] = {.lex_state = 293, .external_lex_state = 6},
  [3230] = {.lex_state = 219, .external_lex_state = 10},
  [3231] = {.lex_state = 300, .external_lex_state = 3},
  [3232] = {.lex_state = 300, .external_lex_state = 9},
  [3233] = {.lex_state = 300, .external_lex_state = 9},
  [3234] = {.lex_state = 207},
  [3235] = {.lex_state = 300, .external_lex_state = 9},
  [3236] = {.lex_state = 89},
  [3237] = {.lex_state = 300, .external_lex_state = 9},
  [3238] = {.lex_state = 300, .external_lex_state = 9},
  [3239] = {.lex_state = 219, .external_lex_state = 23},
  [3240] = {.lex_state = 300, .external_lex_state = 9},
  [3241] = {.lex_state = 219, .external_lex_state = 10},
  [3242] = {.lex_state = 151, .external_lex_state = 10},
  [3243] = {.lex_state = 125},
  [3244] = {.lex_state = 151, .external_lex_state = 10},
  [3245] = {.lex_state = 221, .external_lex_state = 10},
  [3246] = {.lex_state = 219, .external_lex_state = 23},
  [3247] = {.lex_state = 300, .external_lex_state = 9},
  [3248] = {.lex_state = 219, .external_lex_state = 10},
  [3249] = {.lex_state = 296, .external_lex_state = 6},
  [3250] = {.lex_state = 296, .external_lex_state = 6},
  [3251] = {.lex_state = 207},
  [3252] = {.lex_state = 296, .external_lex_state = 6},
  [3253] = {.lex_state = 89},
  [3254] = {.lex_state = 296, .external_lex_state = 6},
  [3255] = {.lex_state = 296, .external_lex_state = 6},
  [3256] = {.lex_state = 219, .external_lex_state = 23},
  [3257] = {.lex_state = 296, .external_lex_state = 6},
  [3258] = {.lex_state = 219, .external_lex_state = 10},
  [3259] = {.lex_state = 151, .external_lex_state = 10},
  [3260] = {.lex_state = 125},
  [3261] = {.lex_state = 151, .external_lex_state = 10},
  [3262] = {.lex_state = 221, .external_lex_state = 10},
  [3263] = {.lex_state = 219, .external_lex_state = 23},
  [3264] = {.lex_state = 296, .external_lex_state = 6},
  [3265] = {.lex_state = 219, .external_lex_state = 10},
  [3266] = {.lex_state = 240, .external_lex_state = 2},
  [3267] = {.lex_state = 213, .external_lex_state = 18},
  [3268] = {.lex_state = 213, .external_lex_state = 18},
  [3269] = {.lex_state = 303, .external_lex_state = 6},
  [3270] = {.lex_state = 219, .external_lex_state = 10},
  [3271] = {.lex_state = 303, .external_lex_state = 6},
  [3272] = {.lex_state = 303, .external_lex_state = 6},
  [3273] = {.lex_state = 219, .external_lex_state = 10},
  [3274] = {.lex_state = 303, .external_lex_state = 6},
  [3275] = {.lex_state = 79, .external_lex_state = 27},
  [3276] = {.lex_state = 219, .external_lex_state = 10},
  [3277] = {.lex_state = 219, .external_lex_state = 10},
  [3278] = {.lex_state = 115, .external_lex_state = 24},
  [3279] = {.lex_state = 115, .external_lex_state = 10},
  [3280] = {.lex_state = 131, .external_lex_state = 10},
  [3281] = {.lex_state = 79, .external_lex_state = 27},
  [3282] = {.lex_state = 219, .external_lex_state = 10},
  [3283] = {.lex_state = 219, .external_lex_state = 10},
  [3284] = {.lex_state = 79, .external_lex_state = 27},
  [3285] = {.lex_state = 79, .external_lex_state = 27},
  [3286] = {.lex_state = 219, .external_lex_state = 10},
  [3287] = {.lex_state = 219, .external_lex_state = 24},
  [3288] = {.lex_state = 219, .external_lex_state = 24},
  [3289] = {.lex_state = 115, .external_lex_state = 24},
  [3290] = {.lex_state = 219, .external_lex_state = 10},
  [3291] = {.lex_state = 115, .external_lex_state = 24},
  [3292] = {.lex_state = 115, .external_lex_state = 24},
  [3293] = {.lex_state = 219, .external_lex_state = 10},
  [3294] = {.lex_state = 115, .external_lex_state = 24},
  [3295] = {.lex_state = 181, .external_lex_state = 25},
  [3296] = {.lex_state = 181, .external_lex_state = 25},
  [3297] = {.lex_state = 181, .external_lex_state = 13},
  [3298] = {.lex_state = 181, .external_lex_state = 13},
  [3299] = {.lex_state = 197, .external_lex_state = 12},
  [3300] = {.lex_state = 197, .external_lex_state = 12},
  [3301] = {.lex_state = 199, .external_lex_state = 25},
  [3302] = {.lex_state = 219, .external_lex_state = 10},
  [3303] = {.lex_state = 199, .external_lex_state = 25},
  [3304] = {.lex_state = 199, .external_lex_state = 25},
  [3305] = {.lex_state = 219, .external_lex_state = 10},
  [3306] = {.lex_state = 199, .external_lex_state = 25},
  [3307] = {.lex_state = 197, .external_lex_state = 12},
  [3308] = {.lex_state = 332},
  [3309] = {.lex_state = 332},
  [3310] = {.lex_state = 197, .external_lex_state = 13},
  [3311] = {.lex_state = 219, .external_lex_state = 10},
  [3312] = {.lex_state = 197, .external_lex_state = 13},
  [3313] = {.lex_state = 197, .external_lex_state = 13},
  [3314] = {.lex_state = 219, .external_lex_state = 10},
  [3315] = {.lex_state = 197, .external_lex_state = 13},
  [3316] = {.lex_state = 260, .external_lex_state = 3},
  [3317] = {.lex_state = 260, .external_lex_state = 9},
  [3318] = {.lex_state = 219, .external_lex_state = 10},
  [3319] = {.lex_state = 219, .external_lex_state = 10},
  [3320] = {.lex_state = 115, .external_lex_state = 24},
  [3321] = {.lex_state = 115, .external_lex_state = 10},
  [3322] = {.lex_state = 131, .external_lex_state = 10},
  [3323] = {.lex_state = 260, .external_lex_state = 9},
  [3324] = {.lex_state = 219, .external_lex_state = 10},
  [3325] = {.lex_state = 219, .external_lex_state = 10},
  [3326] = {.lex_state = 260, .external_lex_state = 9},
  [3327] = {.lex_state = 260, .external_lex_state = 9},
  [3328] = {.lex_state = 219, .external_lex_state = 10},
  [3329] = {.lex_state = 260, .external_lex_state = 6},
  [3330] = {.lex_state = 219, .external_lex_state = 10},
  [3331] = {.lex_state = 219, .external_lex_state = 10},
  [3332] = {.lex_state = 115, .external_lex_state = 24},
  [3333] = {.lex_state = 115, .external_lex_state = 10},
  [3334] = {.lex_state = 131, .external_lex_state = 10},
  [3335] = {.lex_state = 260, .external_lex_state = 6},
  [3336] = {.lex_state = 219, .external_lex_state = 10},
  [3337] = {.lex_state = 219, .external_lex_state = 10},
  [3338] = {.lex_state = 260, .external_lex_state = 6},
  [3339] = {.lex_state = 260, .external_lex_state = 6},
  [3340] = {.lex_state = 219, .external_lex_state = 10},
  [3341] = {.lex_state = 314, .external_lex_state = 9},
  [3342] = {.lex_state = 387, .external_lex_state = 3},
  [3343] = {.lex_state = 314, .external_lex_state = 3},
  [3344] = {.lex_state = 89},
  [3345] = {.lex_state = 314, .external_lex_state = 9},
  [3346] = {.lex_state = 219, .external_lex_state = 10},
  [3347] = {.lex_state = 219, .external_lex_state = 10},
  [3348] = {.lex_state = 219, .external_lex_state = 23},
  [3349] = {.lex_state = 221, .external_lex_state = 10},
  [3350] = {.lex_state = 219, .external_lex_state = 23},
  [3351] = {.lex_state = 314, .external_lex_state = 9},
  [3352] = {.lex_state = 219, .external_lex_state = 10},
  [3353] = {.lex_state = 115, .external_lex_state = 24},
  [3354] = {.lex_state = 115, .external_lex_state = 10},
  [3355] = {.lex_state = 131, .external_lex_state = 10},
  [3356] = {.lex_state = 314, .external_lex_state = 9},
  [3357] = {.lex_state = 219, .external_lex_state = 10},
  [3358] = {.lex_state = 219, .external_lex_state = 10},
  [3359] = {.lex_state = 314, .external_lex_state = 6},
  [3360] = {.lex_state = 387, .external_lex_state = 4},
  [3361] = {.lex_state = 314, .external_lex_state = 6},
  [3362] = {.lex_state = 219, .external_lex_state = 10},
  [3363] = {.lex_state = 219, .external_lex_state = 10},
  [3364] = {.lex_state = 219, .external_lex_state = 23},
  [3365] = {.lex_state = 221, .external_lex_state = 10},
  [3366] = {.lex_state = 219, .external_lex_state = 23},
  [3367] = {.lex_state = 314, .external_lex_state = 6},
  [3368] = {.lex_state = 219, .external_lex_state = 10},
  [3369] = {.lex_state = 115, .external_lex_state = 24},
  [3370] = {.lex_state = 115, .external_lex_state = 10},
  [3371] = {.lex_state = 131, .external_lex_state = 10},
  [3372] = {.lex_state = 314, .external_lex_state = 6},
  [3373] = {.lex_state = 219, .external_lex_state = 10},
  [3374] = {.lex_state = 219, .external_lex_state = 10},
  [3375] = {.lex_state = 317, .external_lex_state = 6},
  [3376] = {.lex_state = 219, .external_lex_state = 10},
  [3377] = {.lex_state = 219, .external_lex_state = 10},
  [3378] = {.lex_state = 115, .external_lex_state = 24},
  [3379] = {.lex_state = 115, .external_lex_state = 10},
  [3380] = {.lex_state = 131, .external_lex_state = 10},
  [3381] = {.lex_state = 317, .external_lex_state = 6},
  [3382] = {.lex_state = 219, .external_lex_state = 10},
  [3383] = {.lex_state = 219, .external_lex_state = 10},
  [3384] = {.lex_state = 317, .external_lex_state = 6},
  [3385] = {.lex_state = 317, .external_lex_state = 6},
  [3386] = {.lex_state = 219, .external_lex_state = 10},
  [3387] = {.lex_state = 320, .external_lex_state = 3},
  [3388] = {.lex_state = 320, .external_lex_state = 9},
  [3389] = {.lex_state = 320, .external_lex_state = 9},
  [3390] = {.lex_state = 207},
  [3391] = {.lex_state = 320, .external_lex_state = 9},
  [3392] = {.lex_state = 89},
  [3393] = {.lex_state = 320, .external_lex_state = 9},
  [3394] = {.lex_state = 320, .external_lex_state = 9},
  [3395] = {.lex_state = 219, .external_lex_state = 23},
  [3396] = {.lex_state = 320, .external_lex_state = 9},
  [3397] = {.lex_state = 219, .external_lex_state = 10},
  [3398] = {.lex_state = 151, .external_lex_state = 10},
  [3399] = {.lex_state = 125},
  [3400] = {.lex_state = 151, .external_lex_state = 10},
  [3401] = {.lex_state = 221, .external_lex_state = 10},
  [3402] = {.lex_state = 219, .external_lex_state = 23},
  [3403] = {.lex_state = 320, .external_lex_state = 9},
  [3404] = {.lex_state = 219, .external_lex_state = 10},
  [3405] = {.lex_state = 89},
  [3406] = {.lex_state = 276, .external_lex_state = 6},
  [3407] = {.lex_state = 271, .external_lex_state = 2},
  [3408] = {.lex_state = 273, .external_lex_state = 6},
  [3409] = {.lex_state = 219, .external_lex_state = 10},
  [3410] = {.lex_state = 273, .external_lex_state = 6},
  [3411] = {.lex_state = 273, .external_lex_state = 6},
  [3412] = {.lex_state = 219, .external_lex_state = 10},
  [3413] = {.lex_state = 273, .external_lex_state = 6},
  [3414] = {.lex_state = 278, .external_lex_state = 9},
  [3415] = {.lex_state = 378, .external_lex_state = 3},
  [3416] = {.lex_state = 278, .external_lex_state = 9},
  [3417] = {.lex_state = 219, .external_lex_state = 10},
  [3418] = {.lex_state = 219, .external_lex_state = 10},
  [3419] = {.lex_state = 219, .external_lex_state = 23},
  [3420] = {.lex_state = 221, .external_lex_state = 10},
  [3421] = {.lex_state = 219, .external_lex_state = 23},
  [3422] = {.lex_state = 278, .external_lex_state = 9},
  [3423] = {.lex_state = 219, .external_lex_state = 10},
  [3424] = {.lex_state = 115, .external_lex_state = 24},
  [3425] = {.lex_state = 115, .external_lex_state = 10},
  [3426] = {.lex_state = 131, .external_lex_state = 10},
  [3427] = {.lex_state = 278, .external_lex_state = 9},
  [3428] = {.lex_state = 219, .external_lex_state = 10},
  [3429] = {.lex_state = 219, .external_lex_state = 10},
  [3430] = {.lex_state = 390, .external_lex_state = 4},
  [3431] = {.lex_state = 79},
  [3432] = {.lex_state = 207},
  [3433] = {.lex_state = 357, .external_lex_state = 9},
  [3434] = {.lex_state = 136},
  [3435] = {.lex_state = 89},
  [3436] = {.lex_state = 357, .external_lex_state = 9},
  [3437] = {.lex_state = 79},
  [3438] = {.lex_state = 89, .external_lex_state = 17},
  [3439] = {.lex_state = 357, .external_lex_state = 9},
  [3440] = {.lex_state = 357, .external_lex_state = 9},
  [3441] = {.lex_state = 357, .external_lex_state = 9},
  [3442] = {.lex_state = 89, .external_lex_state = 2},
  [3443] = {.lex_state = 79},
  [3444] = {.lex_state = 151, .external_lex_state = 10},
  [3445] = {.lex_state = 155, .external_lex_state = 5},
  [3446] = {.lex_state = 125},
  [3447] = {.lex_state = 151, .external_lex_state = 10},
  [3448] = {.lex_state = 357, .external_lex_state = 3},
  [3449] = {.lex_state = 357, .external_lex_state = 3},
  [3450] = {.lex_state = 357, .external_lex_state = 3},
  [3451] = {.lex_state = 79},
  [3452] = {.lex_state = 207},
  [3453] = {.lex_state = 357, .external_lex_state = 6},
  [3454] = {.lex_state = 136},
  [3455] = {.lex_state = 89},
  [3456] = {.lex_state = 357, .external_lex_state = 6},
  [3457] = {.lex_state = 79},
  [3458] = {.lex_state = 357, .external_lex_state = 6},
  [3459] = {.lex_state = 357, .external_lex_state = 6},
  [3460] = {.lex_state = 357, .external_lex_state = 6},
  [3461] = {.lex_state = 89, .external_lex_state = 2},
  [3462] = {.lex_state = 79},
  [3463] = {.lex_state = 151, .external_lex_state = 10},
  [3464] = {.lex_state = 155, .external_lex_state = 5},
  [3465] = {.lex_state = 125},
  [3466] = {.lex_state = 151, .external_lex_state = 10},
  [3467] = {.lex_state = 357, .external_lex_state = 4},
  [3468] = {.lex_state = 357, .external_lex_state = 4},
  [3469] = {.lex_state = 357, .external_lex_state = 4},
  [3470] = {.lex_state = 364, .external_lex_state = 6},
  [3471] = {.lex_state = 364, .external_lex_state = 6},
  [3472] = {.lex_state = 219, .external_lex_state = 23},
  [3473] = {.lex_state = 364, .external_lex_state = 6},
  [3474] = {.lex_state = 219, .external_lex_state = 10},
  [3475] = {.lex_state = 151, .external_lex_state = 10},
  [3476] = {.lex_state = 125},
  [3477] = {.lex_state = 151, .external_lex_state = 10},
  [3478] = {.lex_state = 221, .external_lex_state = 10},
  [3479] = {.lex_state = 219, .external_lex_state = 23},
  [3480] = {.lex_state = 364, .external_lex_state = 6},
  [3481] = {.lex_state = 219, .external_lex_state = 10},
  [3482] = {.lex_state = 364, .external_lex_state = 6},
  [3483] = {.lex_state = 89},
  [3484] = {.lex_state = 364, .external_lex_state = 6},
  [3485] = {.lex_state = 89},
  [3486] = {.lex_state = 79, .external_lex_state = 2},
  [3487] = {.lex_state = 136},
  [3488] = {.lex_state = 369, .external_lex_state = 9},
  [3489] = {.lex_state = 79, .external_lex_state = 2},
  [3490] = {.lex_state = 99},
  [3491] = {.lex_state = 79, .external_lex_state = 2},
  [3492] = {.lex_state = 369, .external_lex_state = 9},
  [3493] = {.lex_state = 99, .external_lex_state = 5},
  [3494] = {.lex_state = 369, .external_lex_state = 3},
  [3495] = {.lex_state = 369, .external_lex_state = 3},
  [3496] = {.lex_state = 364, .external_lex_state = 6},
  [3497] = {.lex_state = 207},
  [3498] = {.lex_state = 367, .external_lex_state = 4},
  [3499] = {.lex_state = 369, .external_lex_state = 3},
  [3500] = {.lex_state = 367, .external_lex_state = 6},
  [3501] = {.lex_state = 367, .external_lex_state = 6},
  [3502] = {.lex_state = 367, .external_lex_state = 4},
  [3503] = {.lex_state = 400, .external_lex_state = 15},
  [3504] = {.lex_state = 89},
  [3505] = {.lex_state = 367, .external_lex_state = 4},
  [3506] = {.lex_state = 369, .external_lex_state = 3},
  [3507] = {.lex_state = 367, .external_lex_state = 6},
  [3508] = {.lex_state = 367, .external_lex_state = 4},
  [3509] = {.lex_state = 367, .external_lex_state = 4},
  [3510] = {.lex_state = 364, .external_lex_state = 4},
  [3511] = {.lex_state = 364, .external_lex_state = 6},
  [3512] = {.lex_state = 364, .external_lex_state = 4},
  [3513] = {.lex_state = 364, .external_lex_state = 4},
  [3514] = {.lex_state = 364, .external_lex_state = 4},
  [3515] = {.lex_state = 344, .external_lex_state = 2},
  [3516] = {.lex_state = 344, .external_lex_state = 20},
  [3517] = {.lex_state = 281},
  [3518] = {.lex_state = 281},
  [3519] = {.lex_state = 89},
  [3520] = {.lex_state = 143, .external_lex_state = 4},
  [3521] = {.lex_state = 79},
  [3522] = {.lex_state = 147, .external_lex_state = 3},
  [3523] = {.lex_state = 79, .external_lex_state = 2},
  [3524] = {.lex_state = 79, .external_lex_state = 2},
  [3525] = {.lex_state = 89},
  [3526] = {.lex_state = 79},
  [3527] = {.lex_state = 79, .external_lex_state = 2},
  [3528] = {.lex_state = 89, .external_lex_state = 16},
  [3529] = {.lex_state = 219, .external_lex_state = 10},
  [3530] = {.lex_state = 89, .external_lex_state = 16},
  [3531] = {.lex_state = 89, .external_lex_state = 16},
  [3532] = {.lex_state = 219, .external_lex_state = 10},
  [3533] = {.lex_state = 89, .external_lex_state = 16},
  [3534] = {.lex_state = 147, .external_lex_state = 9},
  [3535] = {.lex_state = 147, .external_lex_state = 9},
  [3536] = {.lex_state = 248, .external_lex_state = 14},
  [3537] = {.lex_state = 219, .external_lex_state = 10},
  [3538] = {.lex_state = 248, .external_lex_state = 14},
  [3539] = {.lex_state = 248, .external_lex_state = 14},
  [3540] = {.lex_state = 219, .external_lex_state = 10},
  [3541] = {.lex_state = 248, .external_lex_state = 14},
  [3542] = {.lex_state = 187, .external_lex_state = 4},
  [3543] = {.lex_state = 236, .external_lex_state = 14},
  [3544] = {.lex_state = 236, .external_lex_state = 14},
  [3545] = {.lex_state = 332},
  [3546] = {.lex_state = 286, .external_lex_state = 3},
  [3547] = {.lex_state = 286, .external_lex_state = 9},
  [3548] = {.lex_state = 219, .external_lex_state = 10},
  [3549] = {.lex_state = 219, .external_lex_state = 10},
  [3550] = {.lex_state = 115, .external_lex_state = 24},
  [3551] = {.lex_state = 115, .external_lex_state = 10},
  [3552] = {.lex_state = 131, .external_lex_state = 10},
  [3553] = {.lex_state = 286, .external_lex_state = 9},
  [3554] = {.lex_state = 219, .external_lex_state = 10},
  [3555] = {.lex_state = 219, .external_lex_state = 10},
  [3556] = {.lex_state = 286, .external_lex_state = 9},
  [3557] = {.lex_state = 286, .external_lex_state = 9},
  [3558] = {.lex_state = 219, .external_lex_state = 10},
  [3559] = {.lex_state = 286, .external_lex_state = 6},
  [3560] = {.lex_state = 219, .external_lex_state = 10},
  [3561] = {.lex_state = 219, .external_lex_state = 10},
  [3562] = {.lex_state = 115, .external_lex_state = 24},
  [3563] = {.lex_state = 115, .external_lex_state = 10},
  [3564] = {.lex_state = 131, .external_lex_state = 10},
  [3565] = {.lex_state = 286, .external_lex_state = 6},
  [3566] = {.lex_state = 219, .external_lex_state = 10},
  [3567] = {.lex_state = 219, .external_lex_state = 10},
  [3568] = {.lex_state = 286, .external_lex_state = 6},
  [3569] = {.lex_state = 286, .external_lex_state = 6},
  [3570] = {.lex_state = 219, .external_lex_state = 10},
  [3571] = {.lex_state = 293, .external_lex_state = 6},
  [3572] = {.lex_state = 219, .external_lex_state = 10},
  [3573] = {.lex_state = 293, .external_lex_state = 6},
  [3574] = {.lex_state = 293, .external_lex_state = 6},
  [3575] = {.lex_state = 219, .external_lex_state = 10},
  [3576] = {.lex_state = 293, .external_lex_state = 6},
  [3577] = {.lex_state = 300, .external_lex_state = 9},
  [3578] = {.lex_state = 384, .external_lex_state = 3},
  [3579] = {.lex_state = 300, .external_lex_state = 9},
  [3580] = {.lex_state = 219, .external_lex_state = 10},
  [3581] = {.lex_state = 219, .external_lex_state = 10},
  [3582] = {.lex_state = 219, .external_lex_state = 23},
  [3583] = {.lex_state = 221, .external_lex_state = 10},
  [3584] = {.lex_state = 219, .external_lex_state = 23},
  [3585] = {.lex_state = 300, .external_lex_state = 9},
  [3586] = {.lex_state = 219, .external_lex_state = 10},
  [3587] = {.lex_state = 115, .external_lex_state = 24},
  [3588] = {.lex_state = 115, .external_lex_state = 10},
  [3589] = {.lex_state = 131, .external_lex_state = 10},
  [3590] = {.lex_state = 300, .external_lex_state = 9},
  [3591] = {.lex_state = 219, .external_lex_state = 10},
  [3592] = {.lex_state = 219, .external_lex_state = 10},
  [3593] = {.lex_state = 296, .external_lex_state = 6},
  [3594] = {.lex_state = 402, .external_lex_state = 4},
  [3595] = {.lex_state = 296, .external_lex_state = 6},
  [3596] = {.lex_state = 219, .external_lex_state = 10},
  [3597] = {.lex_state = 219, .external_lex_state = 10},
  [3598] = {.lex_state = 219, .external_lex_state = 23},
  [3599] = {.lex_state = 221, .external_lex_state = 10},
  [3600] = {.lex_state = 219, .external_lex_state = 23},
  [3601] = {.lex_state = 296, .external_lex_state = 6},
  [3602] = {.lex_state = 219, .external_lex_state = 10},
  [3603] = {.lex_state = 115, .external_lex_state = 24},
  [3604] = {.lex_state = 115, .external_lex_state = 10},
  [3605] = {.lex_state = 131, .external_lex_state = 10},
  [3606] = {.lex_state = 296, .external_lex_state = 6},
  [3607] = {.lex_state = 219, .external_lex_state = 10},
  [3608] = {.lex_state = 219, .external_lex_state = 10},
  [3609] = {.lex_state = 303, .external_lex_state = 6},
  [3610] = {.lex_state = 303, .external_lex_state = 6},
  [3611] = {.lex_state = 79, .external_lex_state = 27},
  [3612] = {.lex_state = 219, .external_lex_state = 10},
  [3613] = {.lex_state = 79, .external_lex_state = 27},
  [3614] = {.lex_state = 79, .external_lex_state = 27},
  [3615] = {.lex_state = 219, .external_lex_state = 10},
  [3616] = {.lex_state = 79, .external_lex_state = 27},
  [3617] = {.lex_state = 115, .external_lex_state = 24},
  [3618] = {.lex_state = 115, .external_lex_state = 24},
  [3619] = {.lex_state = 199, .external_lex_state = 25},
  [3620] = {.lex_state = 199, .external_lex_state = 25},
  [3621] = {.lex_state = 197, .external_lex_state = 12},
  [3622] = {.lex_state = 332},
  [3623] = {.lex_state = 197, .external_lex_state = 13},
  [3624] = {.lex_state = 197, .external_lex_state = 13},
  [3625] = {.lex_state = 260, .external_lex_state = 9},
  [3626] = {.lex_state = 219, .external_lex_state = 10},
  [3627] = {.lex_state = 260, .external_lex_state = 9},
  [3628] = {.lex_state = 260, .external_lex_state = 9},
  [3629] = {.lex_state = 219, .external_lex_state = 10},
  [3630] = {.lex_state = 260, .external_lex_state = 9},
  [3631] = {.lex_state = 260, .external_lex_state = 6},
  [3632] = {.lex_state = 219, .external_lex_state = 10},
  [3633] = {.lex_state = 260, .external_lex_state = 6},
  [3634] = {.lex_state = 260, .external_lex_state = 6},
  [3635] = {.lex_state = 219, .external_lex_state = 10},
  [3636] = {.lex_state = 260, .external_lex_state = 6},
  [3637] = {.lex_state = 314, .external_lex_state = 3},
  [3638] = {.lex_state = 314, .external_lex_state = 9},
  [3639] = {.lex_state = 219, .external_lex_state = 10},
  [3640] = {.lex_state = 219, .external_lex_state = 10},
  [3641] = {.lex_state = 115, .external_lex_state = 24},
  [3642] = {.lex_state = 115, .external_lex_state = 10},
  [3643] = {.lex_state = 131, .external_lex_state = 10},
  [3644] = {.lex_state = 314, .external_lex_state = 9},
  [3645] = {.lex_state = 219, .external_lex_state = 10},
  [3646] = {.lex_state = 219, .external_lex_state = 10},
  [3647] = {.lex_state = 314, .external_lex_state = 9},
  [3648] = {.lex_state = 314, .external_lex_state = 9},
  [3649] = {.lex_state = 219, .external_lex_state = 10},
  [3650] = {.lex_state = 314, .external_lex_state = 6},
  [3651] = {.lex_state = 219, .external_lex_state = 10},
  [3652] = {.lex_state = 219, .external_lex_state = 10},
  [3653] = {.lex_state = 115, .external_lex_state = 24},
  [3654] = {.lex_state = 115, .external_lex_state = 10},
  [3655] = {.lex_state = 131, .external_lex_state = 10},
  [3656] = {.lex_state = 314, .external_lex_state = 6},
  [3657] = {.lex_state = 219, .external_lex_state = 10},
  [3658] = {.lex_state = 219, .external_lex_state = 10},
  [3659] = {.lex_state = 314, .external_lex_state = 6},
  [3660] = {.lex_state = 314, .external_lex_state = 6},
  [3661] = {.lex_state = 219, .external_lex_state = 10},
  [3662] = {.lex_state = 317, .external_lex_state = 6},
  [3663] = {.lex_state = 219, .external_lex_state = 10},
  [3664] = {.lex_state = 317, .external_lex_state = 6},
  [3665] = {.lex_state = 317, .external_lex_state = 6},
  [3666] = {.lex_state = 219, .external_lex_state = 10},
  [3667] = {.lex_state = 317, .external_lex_state = 6},
  [3668] = {.lex_state = 320, .external_lex_state = 9},
  [3669] = {.lex_state = 387, .external_lex_state = 3},
  [3670] = {.lex_state = 320, .external_lex_state = 9},
  [3671] = {.lex_state = 219, .external_lex_state = 10},
  [3672] = {.lex_state = 219, .external_lex_state = 10},
  [3673] = {.lex_state = 219, .external_lex_state = 23},
  [3674] = {.lex_state = 221, .external_lex_state = 10},
  [3675] = {.lex_state = 219, .external_lex_state = 23},
  [3676] = {.lex_state = 320, .external_lex_state = 9},
  [3677] = {.lex_state = 219, .external_lex_state = 10},
  [3678] = {.lex_state = 115, .external_lex_state = 24},
  [3679] = {.lex_state = 115, .external_lex_state = 10},
  [3680] = {.lex_state = 131, .external_lex_state = 10},
  [3681] = {.lex_state = 320, .external_lex_state = 9},
  [3682] = {.lex_state = 219, .external_lex_state = 10},
  [3683] = {.lex_state = 219, .external_lex_state = 10},
  [3684] = {.lex_state = 408, .external_lex_state = 4},
  [3685] = {.lex_state = 273, .external_lex_state = 6},
  [3686] = {.lex_state = 273, .external_lex_state = 6},
  [3687] = {.lex_state = 278, .external_lex_state = 9},
  [3688] = {.lex_state = 219, .external_lex_state = 10},
  [3689] = {.lex_state = 219, .external_lex_state = 10},
  [3690] = {.lex_state = 115, .external_lex_state = 24},
  [3691] = {.lex_state = 115, .external_lex_state = 10},
  [3692] = {.lex_state = 131, .external_lex_state = 10},
  [3693] = {.lex_state = 278, .external_lex_state = 9},
  [3694] = {.lex_state = 219, .external_lex_state = 10},
  [3695] = {.lex_state = 219, .external_lex_state = 10},
  [3696] = {.lex_state = 278, .external_lex_state = 9},
  [3697] = {.lex_state = 278, .external_lex_state = 9},
  [3698] = {.lex_state = 219, .external_lex_state = 10},
  [3699] = {.lex_state = 357, .external_lex_state = 9},
  [3700] = {.lex_state = 357, .external_lex_state = 9},
  [3701] = {.lex_state = 207},
  [3702] = {.lex_state = 357, .external_lex_state = 9},
  [3703] = {.lex_state = 89},
  [3704] = {.lex_state = 357, .external_lex_state = 9},
  [3705] = {.lex_state = 357, .external_lex_state = 9},
  [3706] = {.lex_state = 89},
  [3707] = {.lex_state = 357, .external_lex_state = 9},
  [3708] = {.lex_state = 357, .external_lex_state = 3},
  [3709] = {.lex_state = 357, .external_lex_state = 3},
  [3710] = {.lex_state = 219, .external_lex_state = 23},
  [3711] = {.lex_state = 357, .external_lex_state = 9},
  [3712] = {.lex_state = 219, .external_lex_state = 10},
  [3713] = {.lex_state = 151, .external_lex_state = 10},
  [3714] = {.lex_state = 125},
  [3715] = {.lex_state = 151, .external_lex_state = 10},
  [3716] = {.lex_state = 221, .external_lex_state = 10},
  [3717] = {.lex_state = 219, .external_lex_state = 23},
  [3718] = {.lex_state = 357, .external_lex_state = 9},
  [3719] = {.lex_state = 219, .external_lex_state = 10},
  [3720] = {.lex_state = 357, .external_lex_state = 6},
  [3721] = {.lex_state = 357, .external_lex_state = 6},
  [3722] = {.lex_state = 207},
  [3723] = {.lex_state = 357, .external_lex_state = 6},
  [3724] = {.lex_state = 89},
  [3725] = {.lex_state = 357, .external_lex_state = 6},
  [3726] = {.lex_state = 357, .external_lex_state = 6},
  [3727] = {.lex_state = 219, .external_lex_state = 23},
  [3728] = {.lex_state = 357, .external_lex_state = 6},
  [3729] = {.lex_state = 219, .external_lex_state = 10},
  [3730] = {.lex_state = 151, .external_lex_state = 10},
  [3731] = {.lex_state = 125},
  [3732] = {.lex_state = 151, .external_lex_state = 10},
  [3733] = {.lex_state = 221, .external_lex_state = 10},
  [3734] = {.lex_state = 219, .external_lex_state = 23},
  [3735] = {.lex_state = 357, .external_lex_state = 6},
  [3736] = {.lex_state = 219, .external_lex_state = 10},
  [3737] = {.lex_state = 364, .external_lex_state = 6},
  [3738] = {.lex_state = 219, .external_lex_state = 10},
  [3739] = {.lex_state = 219, .external_lex_state = 10},
  [3740] = {.lex_state = 219, .external_lex_state = 23},
  [3741] = {.lex_state = 221, .external_lex_state = 10},
  [3742] = {.lex_state = 219, .external_lex_state = 23},
  [3743] = {.lex_state = 364, .external_lex_state = 6},
  [3744] = {.lex_state = 219, .external_lex_state = 10},
  [3745] = {.lex_state = 115, .external_lex_state = 24},
  [3746] = {.lex_state = 115, .external_lex_state = 10},
  [3747] = {.lex_state = 131, .external_lex_state = 10},
  [3748] = {.lex_state = 364, .external_lex_state = 6},
  [3749] = {.lex_state = 219, .external_lex_state = 10},
  [3750] = {.lex_state = 219, .external_lex_state = 10},
  [3751] = {.lex_state = 410, .external_lex_state = 4},
  [3752] = {.lex_state = 369, .external_lex_state = 3},
  [3753] = {.lex_state = 89},
  [3754] = {.lex_state = 79},
  [3755] = {.lex_state = 207},
  [3756] = {.lex_state = 369, .external_lex_state = 9},
  [3757] = {.lex_state = 136},
  [3758] = {.lex_state = 89},
  [3759] = {.lex_state = 369, .external_lex_state = 9},
  [3760] = {.lex_state = 79},
  [3761] = {.lex_state = 369, .external_lex_state = 9},
  [3762] = {.lex_state = 369, .external_lex_state = 9},
  [3763] = {.lex_state = 369, .external_lex_state = 9},
  [3764] = {.lex_state = 89, .external_lex_state = 2},
  [3765] = {.lex_state = 79},
  [3766] = {.lex_state = 151, .external_lex_state = 10},
  [3767] = {.lex_state = 155, .external_lex_state = 5},
  [3768] = {.lex_state = 125},
  [3769] = {.lex_state = 151, .external_lex_state = 10},
  [3770] = {.lex_state = 369, .external_lex_state = 3},
  [3771] = {.lex_state = 369, .external_lex_state = 3},
  [3772] = {.lex_state = 364, .external_lex_state = 6},
  [3773] = {.lex_state = 367, .external_lex_state = 6},
  [3774] = {.lex_state = 367, .external_lex_state = 4},
  [3775] = {.lex_state = 344, .external_lex_state = 2},
  [3776] = {.lex_state = 367, .external_lex_state = 6},
  [3777] = {.lex_state = 367, .external_lex_state = 4},
  [3778] = {.lex_state = 400, .external_lex_state = 15},
  [3779] = {.lex_state = 79, .external_lex_state = 20},
  [3780] = {.lex_state = 79, .external_lex_state = 2},
  [3781] = {.lex_state = 89},
  [3782] = {.lex_state = 143, .external_lex_state = 4},
  [3783] = {.lex_state = 147, .external_lex_state = 3},
  [3784] = {.lex_state = 79},
  [3785] = {.lex_state = 89},
  [3786] = {.lex_state = 79},
  [3787] = {.lex_state = 89, .external_lex_state = 16},
  [3788] = {.lex_state = 89, .external_lex_state = 16},
  [3789] = {.lex_state = 248, .external_lex_state = 14},
  [3790] = {.lex_state = 248, .external_lex_state = 14},
  [3791] = {.lex_state = 187, .external_lex_state = 4},
  [3792] = {.lex_state = 286, .external_lex_state = 9},
  [3793] = {.lex_state = 219, .external_lex_state = 10},
  [3794] = {.lex_state = 286, .external_lex_state = 9},
  [3795] = {.lex_state = 286, .external_lex_state = 9},
  [3796] = {.lex_state = 219, .external_lex_state = 10},
  [3797] = {.lex_state = 286, .external_lex_state = 9},
  [3798] = {.lex_state = 286, .external_lex_state = 6},
  [3799] = {.lex_state = 219, .external_lex_state = 10},
  [3800] = {.lex_state = 286, .external_lex_state = 6},
  [3801] = {.lex_state = 286, .external_lex_state = 6},
  [3802] = {.lex_state = 219, .external_lex_state = 10},
  [3803] = {.lex_state = 286, .external_lex_state = 6},
  [3804] = {.lex_state = 293, .external_lex_state = 6},
  [3805] = {.lex_state = 293, .external_lex_state = 6},
  [3806] = {.lex_state = 300, .external_lex_state = 9},
  [3807] = {.lex_state = 219, .external_lex_state = 10},
  [3808] = {.lex_state = 219, .external_lex_state = 10},
  [3809] = {.lex_state = 115, .external_lex_state = 24},
  [3810] = {.lex_state = 115, .external_lex_state = 10},
  [3811] = {.lex_state = 131, .external_lex_state = 10},
  [3812] = {.lex_state = 300, .external_lex_state = 9},
  [3813] = {.lex_state = 219, .external_lex_state = 10},
  [3814] = {.lex_state = 219, .external_lex_state = 10},
  [3815] = {.lex_state = 300, .external_lex_state = 9},
  [3816] = {.lex_state = 300, .external_lex_state = 9},
  [3817] = {.lex_state = 219, .external_lex_state = 10},
  [3818] = {.lex_state = 296, .external_lex_state = 6},
  [3819] = {.lex_state = 219, .external_lex_state = 10},
  [3820] = {.lex_state = 219, .external_lex_state = 10},
  [3821] = {.lex_state = 115, .external_lex_state = 24},
  [3822] = {.lex_state = 115, .external_lex_state = 10},
  [3823] = {.lex_state = 131, .external_lex_state = 10},
  [3824] = {.lex_state = 296, .external_lex_state = 6},
  [3825] = {.lex_state = 219, .external_lex_state = 10},
  [3826] = {.lex_state = 219, .external_lex_state = 10},
  [3827] = {.lex_state = 296, .external_lex_state = 6},
  [3828] = {.lex_state = 296, .external_lex_state = 6},
  [3829] = {.lex_state = 219, .external_lex_state = 10},
  [3830] = {.lex_state = 79, .external_lex_state = 27},
  [3831] = {.lex_state = 79, .external_lex_state = 27},
  [3832] = {.lex_state = 197, .external_lex_state = 12},
  [3833] = {.lex_state = 260, .external_lex_state = 9},
  [3834] = {.lex_state = 260, .external_lex_state = 9},
  [3835] = {.lex_state = 260, .external_lex_state = 6},
  [3836] = {.lex_state = 260, .external_lex_state = 6},
  [3837] = {.lex_state = 314, .external_lex_state = 9},
  [3838] = {.lex_state = 219, .external_lex_state = 10},
  [3839] = {.lex_state = 314, .external_lex_state = 9},
  [3840] = {.lex_state = 314, .external_lex_state = 9},
  [3841] = {.lex_state = 219, .external_lex_state = 10},
  [3842] = {.lex_state = 314, .external_lex_state = 9},
  [3843] = {.lex_state = 314, .external_lex_state = 6},
  [3844] = {.lex_state = 219, .external_lex_state = 10},
  [3845] = {.lex_state = 314, .external_lex_state = 6},
  [3846] = {.lex_state = 314, .external_lex_state = 6},
  [3847] = {.lex_state = 219, .external_lex_state = 10},
  [3848] = {.lex_state = 314, .external_lex_state = 6},
  [3849] = {.lex_state = 317, .external_lex_state = 6},
  [3850] = {.lex_state = 317, .external_lex_state = 6},
  [3851] = {.lex_state = 320, .external_lex_state = 9},
  [3852] = {.lex_state = 219, .external_lex_state = 10},
  [3853] = {.lex_state = 219, .external_lex_state = 10},
  [3854] = {.lex_state = 115, .external_lex_state = 24},
  [3855] = {.lex_state = 115, .external_lex_state = 10},
  [3856] = {.lex_state = 131, .external_lex_state = 10},
  [3857] = {.lex_state = 320, .external_lex_state = 9},
  [3858] = {.lex_state = 219, .external_lex_state = 10},
  [3859] = {.lex_state = 219, .external_lex_state = 10},
  [3860] = {.lex_state = 320, .external_lex_state = 9},
  [3861] = {.lex_state = 320, .external_lex_state = 9},
  [3862] = {.lex_state = 219, .external_lex_state = 10},
  [3863] = {.lex_state = 278, .external_lex_state = 9},
  [3864] = {.lex_state = 219, .external_lex_state = 10},
  [3865] = {.lex_state = 278, .external_lex_state = 9},
  [3866] = {.lex_state = 278, .external_lex_state = 9},
  [3867] = {.lex_state = 219, .external_lex_state = 10},
  [3868] = {.lex_state = 278, .external_lex_state = 9},
  [3869] = {.lex_state = 357, .external_lex_state = 9},
  [3870] = {.lex_state = 413, .external_lex_state = 3},
  [3871] = {.lex_state = 357, .external_lex_state = 3},
  [3872] = {.lex_state = 89},
  [3873] = {.lex_state = 357, .external_lex_state = 9},
  [3874] = {.lex_state = 219, .external_lex_state = 10},
  [3875] = {.lex_state = 219, .external_lex_state = 10},
  [3876] = {.lex_state = 219, .external_lex_state = 23},
  [3877] = {.lex_state = 221, .external_lex_state = 10},
  [3878] = {.lex_state = 219, .external_lex_state = 23},
  [3879] = {.lex_state = 357, .external_lex_state = 9},
  [3880] = {.lex_state = 219, .external_lex_state = 10},
  [3881] = {.lex_state = 115, .external_lex_state = 24},
  [3882] = {.lex_state = 115, .external_lex_state = 10},
  [3883] = {.lex_state = 131, .external_lex_state = 10},
  [3884] = {.lex_state = 357, .external_lex_state = 9},
  [3885] = {.lex_state = 219, .external_lex_state = 10},
  [3886] = {.lex_state = 219, .external_lex_state = 10},
  [3887] = {.lex_state = 357, .external_lex_state = 6},
  [3888] = {.lex_state = 413, .external_lex_state = 4},
  [3889] = {.lex_state = 357, .external_lex_state = 6},
  [3890] = {.lex_state = 219, .external_lex_state = 10},
  [3891] = {.lex_state = 219, .external_lex_state = 10},
  [3892] = {.lex_state = 219, .external_lex_state = 23},
  [3893] = {.lex_state = 221, .external_lex_state = 10},
  [3894] = {.lex_state = 219, .external_lex_state = 23},
  [3895] = {.lex_state = 357, .external_lex_state = 6},
  [3896] = {.lex_state = 219, .external_lex_state = 10},
  [3897] = {.lex_state = 115, .external_lex_state = 24},
  [3898] = {.lex_state = 115, .external_lex_state = 10},
  [3899] = {.lex_state = 131, .external_lex_state = 10},
  [3900] = {.lex_state = 357, .external_lex_state = 6},
  [3901] = {.lex_state = 219, .external_lex_state = 10},
  [3902] = {.lex_state = 219, .external_lex_state = 10},
  [3903] = {.lex_state = 364, .external_lex_state = 6},
  [3904] = {.lex_state = 219, .external_lex_state = 10},
  [3905] = {.lex_state = 219, .external_lex_state = 10},
  [3906] = {.lex_state = 115, .external_lex_state = 24},
  [3907] = {.lex_state = 115, .external_lex_state = 10},
  [3908] = {.lex_state = 131, .external_lex_state = 10},
  [3909] = {.lex_state = 364, .external_lex_state = 6},
  [3910] = {.lex_state = 219, .external_lex_state = 10},
  [3911] = {.lex_state = 219, .external_lex_state = 10},
  [3912] = {.lex_state = 364, .external_lex_state = 6},
  [3913] = {.lex_state = 364, .external_lex_state = 6},
  [3914] = {.lex_state = 219, .external_lex_state = 10},
  [3915] = {.lex_state = 369, .external_lex_state = 3},
  [3916] = {.lex_state = 369, .external_lex_state = 9},
  [3917] = {.lex_state = 369, .external_lex_state = 9},
  [3918] = {.lex_state = 207},
  [3919] = {.lex_state = 369, .external_lex_state = 9},
  [3920] = {.lex_state = 89},
  [3921] = {.lex_state = 369, .external_lex_state = 9},
  [3922] = {.lex_state = 369, .external_lex_state = 9},
  [3923] = {.lex_state = 219, .external_lex_state = 23},
  [3924] = {.lex_state = 369, .external_lex_state = 9},
  [3925] = {.lex_state = 219, .external_lex_state = 10},
  [3926] = {.lex_state = 151, .external_lex_state = 10},
  [3927] = {.lex_state = 125},
  [3928] = {.lex_state = 151, .external_lex_state = 10},
  [3929] = {.lex_state = 221, .external_lex_state = 10},
  [3930] = {.lex_state = 219, .external_lex_state = 23},
  [3931] = {.lex_state = 369, .external_lex_state = 9},
  [3932] = {.lex_state = 219, .external_lex_state = 10},
  [3933] = {.lex_state = 89},
  [3934] = {.lex_state = 367, .external_lex_state = 6},
  [3935] = {.lex_state = 344, .external_lex_state = 2},
  [3936] = {.lex_state = 202, .external_lex_state = 15},
  [3937] = {.lex_state = 79, .external_lex_state = 2},
  [3938] = {.lex_state = 79, .external_lex_state = 20},
  [3939] = {.lex_state = 89},
  [3940] = {.lex_state = 89},
  [3941] = {.lex_state = 286, .external_lex_state = 9},
  [3942] = {.lex_state = 286, .external_lex_state = 9},
  [3943] = {.lex_state = 286, .external_lex_state = 6},
  [3944] = {.lex_state = 286, .external_lex_state = 6},
  [3945] = {.lex_state = 300, .external_lex_state = 9},
  [3946] = {.lex_state = 219, .external_lex_state = 10},
  [3947] = {.lex_state = 300, .external_lex_state = 9},
  [3948] = {.lex_state = 300, .external_lex_state = 9},
  [3949] = {.lex_state = 219, .external_lex_state = 10},
  [3950] = {.lex_state = 300, .external_lex_state = 9},
  [3951] = {.lex_state = 296, .external_lex_state = 6},
  [3952] = {.lex_state = 219, .external_lex_state = 10},
  [3953] = {.lex_state = 296, .external_lex_state = 6},
  [3954] = {.lex_state = 296, .external_lex_state = 6},
  [3955] = {.lex_state = 219, .external_lex_state = 10},
  [3956] = {.lex_state = 296, .external_lex_state = 6},
  [3957] = {.lex_state = 314, .external_lex_state = 9},
  [3958] = {.lex_state = 314, .external_lex_state = 9},
  [3959] = {.lex_state = 314, .external_lex_state = 6},
  [3960] = {.lex_state = 314, .external_lex_state = 6},
  [3961] = {.lex_state = 320, .external_lex_state = 9},
  [3962] = {.lex_state = 219, .external_lex_state = 10},
  [3963] = {.lex_state = 320, .external_lex_state = 9},
  [3964] = {.lex_state = 320, .external_lex_state = 9},
  [3965] = {.lex_state = 219, .external_lex_state = 10},
  [3966] = {.lex_state = 320, .external_lex_state = 9},
  [3967] = {.lex_state = 278, .external_lex_state = 9},
  [3968] = {.lex_state = 278, .external_lex_state = 9},
  [3969] = {.lex_state = 357, .external_lex_state = 3},
  [3970] = {.lex_state = 357, .external_lex_state = 9},
  [3971] = {.lex_state = 219, .external_lex_state = 10},
  [3972] = {.lex_state = 219, .external_lex_state = 10},
  [3973] = {.lex_state = 115, .external_lex_state = 24},
  [3974] = {.lex_state = 115, .external_lex_state = 10},
  [3975] = {.lex_state = 131, .external_lex_state = 10},
  [3976] = {.lex_state = 357, .external_lex_state = 9},
  [3977] = {.lex_state = 219, .external_lex_state = 10},
  [3978] = {.lex_state = 219, .external_lex_state = 10},
  [3979] = {.lex_state = 357, .external_lex_state = 9},
  [3980] = {.lex_state = 357, .external_lex_state = 9},
  [3981] = {.lex_state = 219, .external_lex_state = 10},
  [3982] = {.lex_state = 357, .external_lex_state = 6},
  [3983] = {.lex_state = 219, .external_lex_state = 10},
  [3984] = {.lex_state = 219, .external_lex_state = 10},
  [3985] = {.lex_state = 115, .external_lex_state = 24},
  [3986] = {.lex_state = 115, .external_lex_state = 10},
  [3987] = {.lex_state = 131, .external_lex_state = 10},
  [3988] = {.lex_state = 357, .external_lex_state = 6},
  [3989] = {.lex_state = 219, .external_lex_state = 10},
  [3990] = {.lex_state = 219, .external_lex_state = 10},
  [3991] = {.lex_state = 357, .external_lex_state = 6},
  [3992] = {.lex_state = 357, .external_lex_state = 6},
  [3993] = {.lex_state = 219, .external_lex_state = 10},
  [3994] = {.lex_state = 364, .external_lex_state = 6},
  [3995] = {.lex_state = 219, .external_lex_state = 10},
  [3996] = {.lex_state = 364, .external_lex_state = 6},
  [3997] = {.lex_state = 364, .external_lex_state = 6},
  [3998] = {.lex_state = 219, .external_lex_state = 10},
  [3999] = {.lex_state = 364, .external_lex_state = 6},
  [4000] = {.lex_state = 369, .external_lex_state = 9},
  [4001] = {.lex_state = 413, .external_lex_state = 3},
  [4002] = {.lex_state = 369, .external_lex_state = 9},
  [4003] = {.lex_state = 219, .external_lex_state = 10},
  [4004] = {.lex_state = 219, .external_lex_state = 10},
  [4005] = {.lex_state = 219, .external_lex_state = 23},
  [4006] = {.lex_state = 221, .external_lex_state = 10},
  [4007] = {.lex_state = 219, .external_lex_state = 23},
  [4008] = {.lex_state = 369, .external_lex_state = 9},
  [4009] = {.lex_state = 219, .external_lex_state = 10},
  [4010] = {.lex_state = 115, .external_lex_state = 24},
  [4011] = {.lex_state = 115, .external_lex_state = 10},
  [4012] = {.lex_state = 131, .external_lex_state = 10},
  [4013] = {.lex_state = 369, .external_lex_state = 9},
  [4014] = {.lex_state = 219, .external_lex_state = 10},
  [4015] = {.lex_state = 219, .external_lex_state = 10},
  [4016] = {.lex_state = 416, .external_lex_state = 4},
  [4017] = {.lex_state = 79, .external_lex_state = 2},
  [4018] = {.lex_state = 202, .external_lex_state = 15},
  [4019] = {.lex_state = 300, .external_lex_state = 9},
  [4020] = {.lex_state = 300, .external_lex_state = 9},
  [4021] = {.lex_state = 296, .external_lex_state = 6},
  [4022] = {.lex_state = 296, .external_lex_state = 6},
  [4023] = {.lex_state = 320, .external_lex_state = 9},
  [4024] = {.lex_state = 320, .external_lex_state = 9},
  [4025] = {.lex_state = 357, .external_lex_state = 9},
  [4026] = {.lex_state = 219, .external_lex_state = 10},
  [4027] = {.lex_state = 357, .external_lex_state = 9},
  [4028] = {.lex_state = 357, .external_lex_state = 9},
  [4029] = {.lex_state = 219, .external_lex_state = 10},
  [4030] = {.lex_state = 357, .external_lex_state = 9},
  [4031] = {.lex_state = 357, .external_lex_state = 6},
  [4032] = {.lex_state = 219, .external_lex_state = 10},
  [4033] = {.lex_state = 357, .external_lex_state = 6},
  [4034] = {.lex_state = 357, .external_lex_state = 6},
  [4035] = {.lex_state = 219, .external_lex_state = 10},
  [4036] = {.lex_state = 357, .external_lex_state = 6},
  [4037] = {.lex_state = 364, .external_lex_state = 6},
  [4038] = {.lex_state = 364, .external_lex_state = 6},
  [4039] = {.lex_state = 369, .external_lex_state = 9},
  [4040] = {.lex_state = 219, .external_lex_state = 10},
  [4041] = {.lex_state = 219, .external_lex_state = 10},
  [4042] = {.lex_state = 115, .external_lex_state = 24},
  [4043] = {.lex_state = 115, .external_lex_state = 10},
  [4044] = {.lex_state = 131, .external_lex_state = 10},
  [4045] = {.lex_state = 369, .external_lex_state = 9},
  [4046] = {.lex_state = 219, .external_lex_state = 10},
  [4047] = {.lex_state = 219, .external_lex_state = 10},
  [4048] = {.lex_state = 369, .external_lex_state = 9},
  [4049] = {.lex_state = 369, .external_lex_state = 9},
  [4050] = {.lex_state = 219, .external_lex_state = 10},
  [4051] = {.lex_state = 79, .external_lex_state = 2},
  [4052] = {.lex_state = 357, .external_lex_state = 9},
  [4053] = {.lex_state = 357, .external_lex_state = 9},
  [4054] = {.lex_state = 357, .external_lex_state = 6},
  [4055] = {.lex_state = 357, .external_lex_state = 6},
  [4056] = {.lex_state = 369, .external_lex_state = 9},
  [4057] = {.lex_state = 219, .external_lex_state = 10},
  [4058] = {.lex_state = 369, .external_lex_state = 9},
  [4059] = {.lex_state = 369, .external_lex_state = 9},
  [4060] = {.lex_state = 219, .external_lex_state = 10},
  [4061] = {.lex_state = 369, .external_lex_state = 9},
  [4062] = {.lex_state = 369, .external_lex_state = 9},
  [4063] = {.lex_state = 369, .external_lex_state = 9},
};

enum {
  ts_external_token_heredoc_start = 0,
  ts_external_token__simple_heredoc_body = 1,
  ts_external_token__heredoc_body_beginning = 2,
  ts_external_token__heredoc_body_middle = 3,
  ts_external_token__heredoc_body_end = 4,
  ts_external_token_file_descriptor = 5,
  ts_external_token__empty_value = 6,
  ts_external_token__concat = 7,
  ts_external_token_variable_name = 8,
  ts_external_token_regex = 9,
  ts_external_token_RBRACE = 10,
  ts_external_token_RBRACK = 11,
  ts_external_token_LT_LT = 12,
  ts_external_token_LT_LT_DASH = 13,
  ts_external_token_LF = 14,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_regex] = sym_regex,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LT_LT] = anon_sym_LT_LT,
  [ts_external_token_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[29][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token__concat] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_regex] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__heredoc_body_middle] = true,
  },
  [2] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token_variable_name] = true,
  },
  [6] = {
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
  },
  [8] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [9] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [10] = {
    [ts_external_token_RBRACE] = true,
  },
  [11] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [12] = {
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [13] = {
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LF] = true,
  },
  [14] = {
    [ts_external_token_LF] = true,
    [ts_external_token__concat] = true,
  },
  [15] = {
    [ts_external_token_LF] = true,
  },
  [16] = {
    [ts_external_token__concat] = true,
  },
  [17] = {
    [ts_external_token__empty_value] = true,
  },
  [18] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [19] = {
    [ts_external_token_RBRACK] = true,
  },
  [20] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__simple_heredoc_body] = true,
  },
  [21] = {
    [ts_external_token_heredoc_start] = true,
  },
  [22] = {
    [ts_external_token_regex] = true,
  },
  [23] = {
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
  },
  [24] = {
    [ts_external_token_RBRACE] = true,
    [ts_external_token__concat] = true,
  },
  [25] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LF] = true,
  },
  [26] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__simple_heredoc_body] = true,
  },
  [27] = {
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token__heredoc_body_middle] = true,
  },
  [28] = {
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LF] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_test_operator] = ACTIONS(1),
    [sym_heredoc_start] = ACTIONS(1),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [sym_word] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym__special_character] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [sym_regex] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
  },
  [1] = {
    [sym_redirected_statement] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_function_definition] = STATE(27),
    [sym_compound_statement] = STATE(27),
    [sym_test_command] = STATE(27),
    [sym_declaration_command] = STATE(27),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_program] = STATE(31),
    [sym_for_statement] = STATE(27),
    [sym_c_style_for_statement] = STATE(27),
    [sym_case_statement] = STATE(27),
    [sym_subshell] = STATE(27),
    [sym_pipeline] = STATE(27),
    [sym_unset_command] = STATE(27),
    [sym_command] = STATE(27),
    [sym_simple_expansion] = STATE(17),
    [sym__statements] = STATE(32),
    [sym_while_statement] = STATE(27),
    [sym_list] = STATE(27),
    [sym_negated_command] = STATE(27),
    [sym_command_name] = STATE(33),
    [sym_variable_assignment] = STATE(34),
    [sym_string_expansion] = STATE(17),
    [sym_expansion] = STATE(17),
    [aux_sym__statements_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [ts_builtin_sym_end] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(47),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3] = {
    [sym_process_substitution] = STATE(54),
    [aux_sym__literal_repeat1] = STATE(61),
    [sym_simple_expansion] = STATE(54),
    [sym_string_expansion] = STATE(54),
    [sym_expansion] = STATE(54),
    [sym_concatenation] = STATE(60),
    [sym_string] = STATE(54),
    [sym_command_substitution] = STATE(54),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(79),
    [sym_raw_string] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [4] = {
    [sym_process_substitution] = STATE(64),
    [sym_string] = STATE(64),
    [sym_command_substitution] = STATE(64),
    [sym_simple_expansion] = STATE(64),
    [sym_variable_assignment] = STATE(72),
    [sym_subscript] = STATE(73),
    [sym_string_expansion] = STATE(64),
    [sym_expansion] = STATE(64),
    [sym_concatenation] = STATE(72),
    [aux_sym_declaration_command_repeat1] = STATE(72),
    [aux_sym__literal_repeat1] = STATE(71),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(99),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(103),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(105),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(103),
    [sym_variable_name] = ACTIONS(111),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [ts_builtin_sym_end] = ACTIONS(109),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [5] = {
    [sym_process_substitution] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_unset_command_repeat1] = STATE(83),
    [sym_simple_expansion] = STATE(76),
    [sym_string_expansion] = STATE(76),
    [sym_expansion] = STATE(76),
    [sym_concatenation] = STATE(83),
    [sym_string] = STATE(76),
    [aux_sym__literal_repeat1] = STATE(82),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(127),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [ts_builtin_sym_end] = ACTIONS(133),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [6] = {
    [sym_string] = STATE(85),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_POUND] = ACTIONS(141),
    [anon_sym_DASH] = ACTIONS(141),
    [anon_sym_0] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(143),
    [anon_sym__] = ACTIONS(143),
  },
  [7] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(87),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [8] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(90),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(91),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [9] = {
    [sym_subscript] = STATE(92),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(151),
    [sym_variable_name] = ACTIONS(155),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_0] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(153),
    [aux_sym__simple_variable_name_token1] = ACTIONS(159),
    [anon_sym__] = ACTIONS(159),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_comment] = ACTIONS(51),
    [sym_word] = ACTIONS(161),
  },
  [11] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [ts_builtin_sym_end] = ACTIONS(169),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [12] = {
    [sym_redirected_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_function_definition] = STATE(124),
    [sym_compound_statement] = STATE(124),
    [sym_test_command] = STATE(124),
    [sym_declaration_command] = STATE(124),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(127),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_for_statement] = STATE(124),
    [sym_c_style_for_statement] = STATE(124),
    [sym_case_statement] = STATE(124),
    [sym_subshell] = STATE(124),
    [sym_pipeline] = STATE(124),
    [sym_unset_command] = STATE(124),
    [sym_command] = STATE(124),
    [sym_simple_expansion] = STATE(114),
    [sym__statements] = STATE(128),
    [sym_while_statement] = STATE(124),
    [sym_list] = STATE(124),
    [sym_negated_command] = STATE(124),
    [sym_command_name] = STATE(129),
    [sym_variable_assignment] = STATE(130),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [aux_sym__statements_repeat1] = STATE(131),
    [aux_sym__literal_repeat1] = STATE(132),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(173),
    [anon_sym_typeset] = ACTIONS(173),
    [anon_sym_unsetenv] = ACTIONS(175),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(185),
    [sym_word] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(173),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(197),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_declare] = ACTIONS(173),
    [sym_variable_name] = ACTIONS(205),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(173),
    [anon_sym_unset] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(215),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(217),
  },
  [13] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [14] = {
    [sym_redirected_statement] = STATE(140),
    [sym_if_statement] = STATE(140),
    [sym_function_definition] = STATE(140),
    [sym_compound_statement] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_declaration_command] = STATE(140),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(140),
    [sym_c_style_for_statement] = STATE(140),
    [sym_case_statement] = STATE(140),
    [sym_subshell] = STATE(140),
    [sym_pipeline] = STATE(140),
    [sym_unset_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_simple_expansion] = STATE(137),
    [sym__terminated_statement] = STATE(143),
    [sym_while_statement] = STATE(140),
    [sym_list] = STATE(140),
    [sym_negated_command] = STATE(140),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(145),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [15] = {
    [sym_process_substitution] = STATE(149),
    [aux_sym__literal_repeat1] = STATE(156),
    [sym_simple_expansion] = STATE(149),
    [sym_string_expansion] = STATE(149),
    [sym_expansion] = STATE(149),
    [sym_concatenation] = STATE(155),
    [sym_string] = STATE(149),
    [sym_command_substitution] = STATE(149),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_word] = ACTIONS(241),
    [sym_raw_string] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(245),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [sym__special_character] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
  },
  [16] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(168),
    [sym_parenthesized_expression] = STATE(168),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(168),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(168),
    [sym_unary_expression] = STATE(168),
    [sym_concatenation] = STATE(168),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [17] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [ts_builtin_sym_end] = ACTIONS(169),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [18] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(174),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [19] = {
    [sym_simple_expansion] = STATE(17),
    [sym_test_command] = STATE(179),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [sym_command_name] = STATE(33),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_variable_assignment] = STATE(30),
    [sym_string_expansion] = STATE(17),
    [sym_expansion] = STATE(17),
    [sym_subshell] = STATE(179),
    [sym_command] = STATE(179),
    [aux_sym__literal_repeat1] = STATE(36),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(37),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(29),
  },
  [20] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(285),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(285),
  },
  [21] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(289),
    [anon_sym_GT_AMP] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(291),
    [anon_sym_LT_AMP] = ACTIONS(289),
    [anon_sym_GT_GT] = ACTIONS(289),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_AMP_GT] = ACTIONS(291),
  },
  [22] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(190),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [23] = {
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(305),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(307),
  },
  [24] = {
    [sym_redirected_statement] = STATE(140),
    [sym_if_statement] = STATE(140),
    [sym_function_definition] = STATE(140),
    [sym_compound_statement] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_declaration_command] = STATE(140),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(140),
    [sym_c_style_for_statement] = STATE(140),
    [sym_case_statement] = STATE(140),
    [sym_subshell] = STATE(140),
    [sym_pipeline] = STATE(140),
    [sym_unset_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_simple_expansion] = STATE(137),
    [sym__terminated_statement] = STATE(193),
    [sym_while_statement] = STATE(140),
    [sym_list] = STATE(140),
    [sym_negated_command] = STATE(140),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(145),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [25] = {
    [sym_process_substitution] = STATE(197),
    [sym_postfix_expression] = STATE(205),
    [sym_parenthesized_expression] = STATE(205),
    [sym_command_substitution] = STATE(197),
    [sym_simple_expansion] = STATE(197),
    [sym__expression] = STATE(205),
    [sym_string_expansion] = STATE(197),
    [sym_expansion] = STATE(197),
    [sym_binary_expression] = STATE(205),
    [sym_unary_expression] = STATE(205),
    [sym_concatenation] = STATE(205),
    [sym_string] = STATE(197),
    [aux_sym__literal_repeat1] = STATE(204),
    [sym_test_operator] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(317),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [26] = {
    [sym_process_substitution] = STATE(207),
    [sym_postfix_expression] = STATE(210),
    [sym_parenthesized_expression] = STATE(210),
    [sym_command_substitution] = STATE(207),
    [sym_simple_expansion] = STATE(207),
    [sym__expression] = STATE(210),
    [sym_string_expansion] = STATE(207),
    [sym_expansion] = STATE(207),
    [sym_binary_expression] = STATE(210),
    [sym_unary_expression] = STATE(210),
    [sym_concatenation] = STATE(210),
    [sym_string] = STATE(207),
    [aux_sym__literal_repeat1] = STATE(209),
    [sym_test_operator] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [27] = {
    [aux_sym_redirected_statement_repeat1] = STATE(219),
    [sym_file_redirect] = STATE(219),
    [sym_herestring_redirect] = STATE(219),
    [sym_heredoc_redirect] = STATE(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_AMP_GT_GT] = ACTIONS(345),
    [anon_sym_LF] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(343),
    [sym_file_descriptor] = ACTIONS(349),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(345),
    [anon_sym_AMP_GT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [ts_builtin_sym_end] = ACTIONS(355),
    [anon_sym_LT_LT_LT] = ACTIONS(357),
    [anon_sym_GT_AMP] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(343),
    [anon_sym_LT] = ACTIONS(345),
    [anon_sym_LT_AMP] = ACTIONS(345),
    [anon_sym_GT_GT] = ACTIONS(345),
    [anon_sym_PIPE] = ACTIONS(359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_PIPE_AMP] = ACTIONS(359),
  },
  [28] = {
    [anon_sym_EQ] = ACTIONS(285),
    [anon_sym_PLUS_EQ] = ACTIONS(285),
    [sym_comment] = ACTIONS(51),
  },
  [29] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_RPAREN] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [ts_builtin_sym_end] = ACTIONS(169),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [30] = {
    [sym_process_substitution] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_command_name] = STATE(220),
    [sym_simple_expansion] = STATE(17),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [sym_string_expansion] = STATE(17),
    [sym_expansion] = STATE(17),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(17),
    [aux_sym__literal_repeat1] = STATE(36),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(37),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(37),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(361),
  },
  [31] = {
    [sym_comment] = ACTIONS(51),
    [ts_builtin_sym_end] = ACTIONS(363),
  },
  [32] = {
    [sym_comment] = ACTIONS(51),
    [ts_builtin_sym_end] = ACTIONS(365),
  },
  [33] = {
    [sym_process_substitution] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [aux_sym_command_repeat2] = STATE(225),
    [sym_concatenation] = STATE(225),
    [sym_string] = STATE(222),
    [aux_sym__literal_repeat1] = STATE(224),
    [anon_sym_AMP_GT_GT] = ACTIONS(367),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(367),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [sym_word] = ACTIONS(375),
    [anon_sym_PIPE] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(367),
    [anon_sym_GT_GT] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(377),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(375),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_AMP_GT] = ACTIONS(367),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [ts_builtin_sym_end] = ACTIONS(381),
    [anon_sym_LT_LT_LT] = ACTIONS(367),
    [anon_sym_GT_AMP] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
  },
  [34] = {
    [aux_sym_redirected_statement_repeat1] = STATE(219),
    [sym_file_redirect] = STATE(219),
    [sym_herestring_redirect] = STATE(219),
    [sym_heredoc_redirect] = STATE(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_AMP] = ACTIONS(343),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(343),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [ts_builtin_sym_end] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(357),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(359),
  },
  [35] = {
    [sym_redirected_statement] = STATE(226),
    [sym_if_statement] = STATE(226),
    [sym_function_definition] = STATE(226),
    [sym_compound_statement] = STATE(226),
    [sym_test_command] = STATE(226),
    [sym_declaration_command] = STATE(226),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_for_statement] = STATE(226),
    [sym_c_style_for_statement] = STATE(226),
    [sym_case_statement] = STATE(226),
    [sym_subshell] = STATE(226),
    [sym_pipeline] = STATE(226),
    [sym_unset_command] = STATE(226),
    [sym_command] = STATE(226),
    [sym_simple_expansion] = STATE(17),
    [sym_while_statement] = STATE(226),
    [sym_list] = STATE(226),
    [sym_negated_command] = STATE(226),
    [sym_command_name] = STATE(33),
    [sym_variable_assignment] = STATE(227),
    [sym_string_expansion] = STATE(17),
    [sym_expansion] = STATE(17),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(36),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [36] = {
    [aux_sym__literal_repeat1] = STATE(230),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_EQ_TILDE] = ACTIONS(389),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [ts_builtin_sym_end] = ACTIONS(393),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [37] = {
    [sym_process_substitution] = STATE(231),
    [sym_string] = STATE(231),
    [sym_command_substitution] = STATE(231),
    [sym_simple_expansion] = STATE(231),
    [sym_variable_assignment] = STATE(235),
    [sym_subscript] = STATE(236),
    [sym_string_expansion] = STATE(231),
    [sym_expansion] = STATE(231),
    [sym_concatenation] = STATE(235),
    [aux_sym_declaration_command_repeat1] = STATE(235),
    [aux_sym__literal_repeat1] = STATE(234),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(399),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(397),
    [sym_variable_name] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(91),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [38] = {
    [sym_process_substitution] = STATE(237),
    [sym_command_substitution] = STATE(237),
    [aux_sym_unset_command_repeat1] = STATE(240),
    [sym_simple_expansion] = STATE(237),
    [sym_string_expansion] = STATE(237),
    [sym_expansion] = STATE(237),
    [sym_concatenation] = STATE(240),
    [sym_string] = STATE(237),
    [aux_sym__literal_repeat1] = STATE(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(407),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_RPAREN] = ACTIONS(115),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [39] = {
    [aux_sym_concatenation_repeat1] = STATE(241),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_RPAREN] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [40] = {
    [aux_sym_concatenation_repeat1] = STATE(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [41] = {
    [aux_sym_concatenation_repeat1] = STATE(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_RPAREN] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [42] = {
    [sym_simple_expansion] = STATE(41),
    [sym_test_command] = STATE(179),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [sym_command_name] = STATE(48),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_variable_assignment] = STATE(46),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [sym_subshell] = STATE(179),
    [sym_command] = STATE(179),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(69),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(67),
  },
  [43] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(409),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(409),
  },
  [44] = {
    [aux_sym_redirected_statement_repeat1] = STATE(248),
    [sym_file_redirect] = STATE(248),
    [sym_herestring_redirect] = STATE(248),
    [sym_heredoc_redirect] = STATE(248),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_AMP_GT_GT] = ACTIONS(411),
    [anon_sym_LF] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(413),
    [sym_file_descriptor] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [anon_sym_GT_AMP] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(343),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_AMP] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
  },
  [45] = {
    [anon_sym_EQ] = ACTIONS(409),
    [anon_sym_PLUS_EQ] = ACTIONS(409),
    [sym_comment] = ACTIONS(51),
  },
  [46] = {
    [sym_process_substitution] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_command_name] = STATE(249),
    [sym_simple_expansion] = STATE(41),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(69),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(69),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(423),
  },
  [47] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(425),
  },
  [48] = {
    [sym_process_substitution] = STATE(251),
    [sym_command_substitution] = STATE(251),
    [sym_simple_expansion] = STATE(251),
    [sym_string_expansion] = STATE(251),
    [sym_expansion] = STATE(251),
    [aux_sym_command_repeat2] = STATE(254),
    [sym_concatenation] = STATE(254),
    [sym_string] = STATE(251),
    [aux_sym__literal_repeat1] = STATE(253),
    [anon_sym_AMP_GT_GT] = ACTIONS(367),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(367),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [sym_word] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(367),
    [anon_sym_GT_GT] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(429),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_LT_LT_DASH] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(427),
    [anon_sym_RPAREN] = ACTIONS(367),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_AMP_GT] = ACTIONS(367),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(367),
    [anon_sym_GT_AMP] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
  },
  [49] = {
    [aux_sym_redirected_statement_repeat1] = STATE(248),
    [sym_file_redirect] = STATE(248),
    [sym_herestring_redirect] = STATE(248),
    [sym_heredoc_redirect] = STATE(248),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(343),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(343),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(413),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_SEMI_SEMI] = ACTIONS(343),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
  },
  [50] = {
    [sym_redirected_statement] = STATE(255),
    [sym_if_statement] = STATE(255),
    [sym_function_definition] = STATE(255),
    [sym_compound_statement] = STATE(255),
    [sym_test_command] = STATE(255),
    [sym_declaration_command] = STATE(255),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(255),
    [sym_c_style_for_statement] = STATE(255),
    [sym_case_statement] = STATE(255),
    [sym_subshell] = STATE(255),
    [sym_pipeline] = STATE(255),
    [sym_unset_command] = STATE(255),
    [sym_command] = STATE(255),
    [sym_simple_expansion] = STATE(41),
    [sym_while_statement] = STATE(255),
    [sym_list] = STATE(255),
    [sym_negated_command] = STATE(255),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(256),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [51] = {
    [aux_sym__literal_repeat1] = STATE(257),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_EQ_TILDE] = ACTIONS(389),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [52] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(258),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [53] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(261),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(431),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [54] = {
    [aux_sym_concatenation_repeat1] = STATE(263),
    [anon_sym_BQUOTE] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(435),
    [anon_sym_DOLLAR] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [sym_variable_name] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(435),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(435),
    [anon_sym_GT_LPAREN] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(435),
    [anon_sym_GT_AMP] = ACTIONS(435),
    [sym__concat] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(435),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(435),
  },
  [55] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(264),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [56] = {
    [sym_string] = STATE(266),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(441),
    [anon_sym_QMARK] = ACTIONS(441),
    [sym_raw_string] = ACTIONS(443),
    [anon_sym_AT] = ACTIONS(441),
    [anon_sym_DOLLAR] = ACTIONS(445),
    [anon_sym_POUND] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_0] = ACTIONS(447),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(447),
    [anon_sym__] = ACTIONS(447),
  },
  [57] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(268),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(269),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [58] = {
    [aux_sym_concatenation_repeat1] = STATE(263),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_AMP_GT_GT] = ACTIONS(221),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [sym_variable_name] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [sym_word] = ACTIONS(221),
    [anon_sym_GT_AMP] = ACTIONS(221),
    [sym__concat] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(221),
    [anon_sym_GT_GT] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(221),
  },
  [59] = {
    [sym_subscript] = STATE(270),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(449),
    [anon_sym_BANG] = ACTIONS(451),
    [anon_sym_AT] = ACTIONS(449),
    [sym_variable_name] = ACTIONS(453),
    [anon_sym_DOLLAR] = ACTIONS(455),
    [anon_sym_DASH] = ACTIONS(455),
    [anon_sym_0] = ACTIONS(457),
    [anon_sym_POUND] = ACTIONS(451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(457),
    [anon_sym__] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [anon_sym_BQUOTE] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(435),
    [anon_sym_DOLLAR] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [sym_variable_name] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(435),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(435),
    [anon_sym_GT_LPAREN] = ACTIONS(435),
    [anon_sym_RPAREN] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(435),
    [anon_sym_GT_AMP] = ACTIONS(435),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(435),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(435),
  },
  [61] = {
    [aux_sym__literal_repeat1] = STATE(275),
    [anon_sym_BQUOTE] = ACTIONS(459),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [sym_raw_string] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [anon_sym_GT_LPAREN] = ACTIONS(459),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [sym_word] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_LT_LPAREN] = ACTIONS(459),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(463),
  },
  [62] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(276),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [63] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(279),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(465),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [64] = {
    [aux_sym_concatenation_repeat1] = STATE(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(471),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [ts_builtin_sym_end] = ACTIONS(473),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [65] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(282),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [66] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(475),
  },
  [67] = {
    [sym_string] = STATE(285),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_QMARK] = ACTIONS(479),
    [sym_raw_string] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(483),
    [anon_sym_POUND] = ACTIONS(483),
    [anon_sym_DASH] = ACTIONS(483),
    [anon_sym_0] = ACTIONS(485),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(485),
    [anon_sym__] = ACTIONS(485),
  },
  [68] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(287),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(288),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [69] = {
    [aux_sym_concatenation_repeat1] = STATE(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(471),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [70] = {
    [sym_subscript] = STATE(289),
    [anon_sym_STAR] = ACTIONS(487),
    [anon_sym_QMARK] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(487),
    [sym_variable_name] = ACTIONS(491),
    [anon_sym_DOLLAR] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_0] = ACTIONS(495),
    [anon_sym_POUND] = ACTIONS(489),
    [aux_sym__simple_variable_name_token1] = ACTIONS(495),
    [anon_sym__] = ACTIONS(495),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [aux_sym__literal_repeat1] = STATE(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(497),
    [anon_sym_DOLLAR] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(497),
    [anon_sym_GT_LPAREN] = ACTIONS(497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(497),
    [aux_sym__simple_variable_name_token1] = ACTIONS(497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [sym_word] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(497),
    [anon_sym_LT_AMP] = ACTIONS(497),
    [anon_sym_GT_GT] = ACTIONS(497),
    [sym__special_character] = ACTIONS(499),
    [anon_sym_LT_LT_DASH] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(497),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(497),
    [sym_raw_string] = ACTIONS(497),
    [sym_variable_name] = ACTIONS(501),
    [sym_file_descriptor] = ACTIONS(501),
    [anon_sym_GT] = ACTIONS(497),
    [anon_sym_AMP_GT] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(497),
    [anon_sym_LT_LT_LT] = ACTIONS(497),
    [anon_sym_GT_AMP] = ACTIONS(497),
    [ts_builtin_sym_end] = ACTIONS(501),
    [anon_sym_LT_LPAREN] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [anon_sym_PIPE_AMP] = ACTIONS(497),
  },
  [72] = {
    [sym_process_substitution] = STATE(64),
    [sym_string] = STATE(64),
    [sym_command_substitution] = STATE(64),
    [sym_simple_expansion] = STATE(64),
    [sym_variable_assignment] = STATE(295),
    [sym_subscript] = STATE(73),
    [sym_string_expansion] = STATE(64),
    [sym_expansion] = STATE(64),
    [sym_concatenation] = STATE(295),
    [aux_sym_declaration_command_repeat1] = STATE(295),
    [aux_sym__literal_repeat1] = STATE(71),
    [anon_sym_AMP_GT_GT] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [sym_word] = ACTIONS(103),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_LT_AMP] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [sym__special_character] = ACTIONS(105),
    [anon_sym_LT_LT_DASH] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_raw_string] = ACTIONS(103),
    [sym_variable_name] = ACTIONS(111),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_AMP_GT] = ACTIONS(503),
    [ts_builtin_sym_end] = ACTIONS(507),
    [anon_sym_LT_LT_LT] = ACTIONS(503),
    [anon_sym_GT_AMP] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
  },
  [73] = {
    [anon_sym_EQ] = ACTIONS(475),
    [anon_sym_PLUS_EQ] = ACTIONS(475),
    [sym_comment] = ACTIONS(51),
  },
  [74] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(296),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [75] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(299),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [76] = {
    [aux_sym_concatenation_repeat1] = STATE(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [ts_builtin_sym_end] = ACTIONS(517),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [77] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(302),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [78] = {
    [sym_string] = STATE(304),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(521),
    [sym_raw_string] = ACTIONS(523),
    [anon_sym_AT] = ACTIONS(521),
    [anon_sym_DOLLAR] = ACTIONS(525),
    [anon_sym_POUND] = ACTIONS(525),
    [anon_sym_DASH] = ACTIONS(525),
    [anon_sym_0] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(527),
    [anon_sym__] = ACTIONS(527),
  },
  [79] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(306),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(307),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [80] = {
    [aux_sym_concatenation_repeat1] = STATE(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [81] = {
    [sym_subscript] = STATE(308),
    [anon_sym_STAR] = ACTIONS(529),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(529),
    [sym_variable_name] = ACTIONS(533),
    [anon_sym_DOLLAR] = ACTIONS(535),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_0] = ACTIONS(537),
    [anon_sym_POUND] = ACTIONS(531),
    [aux_sym__simple_variable_name_token1] = ACTIONS(537),
    [anon_sym__] = ACTIONS(537),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [aux_sym__literal_repeat1] = STATE(313),
    [anon_sym_AMP_GT_GT] = ACTIONS(539),
    [anon_sym_DOLLAR] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_GT_LPAREN] = ACTIONS(539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(539),
    [aux_sym__simple_variable_name_token1] = ACTIONS(539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [sym_word] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_LT_AMP] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(539),
    [sym__special_character] = ACTIONS(541),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_raw_string] = ACTIONS(539),
    [sym_file_descriptor] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(539),
    [anon_sym_AMP_GT] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_LT_LT_LT] = ACTIONS(539),
    [anon_sym_GT_AMP] = ACTIONS(539),
    [ts_builtin_sym_end] = ACTIONS(543),
    [anon_sym_LT_LPAREN] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_SEMI_SEMI] = ACTIONS(539),
    [anon_sym_PIPE_AMP] = ACTIONS(539),
  },
  [83] = {
    [sym_process_substitution] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_unset_command_repeat1] = STATE(314),
    [sym_simple_expansion] = STATE(76),
    [sym_string_expansion] = STATE(76),
    [sym_expansion] = STATE(76),
    [sym_concatenation] = STATE(314),
    [sym_string] = STATE(76),
    [aux_sym__literal_repeat1] = STATE(82),
    [anon_sym_AMP_GT_GT] = ACTIONS(545),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(545),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_word] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_LT_AMP] = ACTIONS(545),
    [anon_sym_GT_GT] = ACTIONS(545),
    [sym__special_character] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(545),
    [sym_raw_string] = ACTIONS(127),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_AMP_GT] = ACTIONS(545),
    [ts_builtin_sym_end] = ACTIONS(549),
    [anon_sym_LT_LT_LT] = ACTIONS(545),
    [anon_sym_GT_AMP] = ACTIONS(545),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
  },
  [84] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [ts_builtin_sym_end] = ACTIONS(553),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [85] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(555),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_EQ_EQ] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [ts_builtin_sym_end] = ACTIONS(557),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [86] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(561),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [87] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(563),
  },
  [88] = {
    [sym_process_substitution] = STATE(316),
    [aux_sym__literal_repeat1] = STATE(318),
    [sym_simple_expansion] = STATE(316),
    [sym_string_expansion] = STATE(316),
    [sym_expansion] = STATE(316),
    [sym_concatenation] = STATE(60),
    [sym_string] = STATE(316),
    [sym_command_substitution] = STATE(316),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(565),
    [sym_raw_string] = ACTIONS(565),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [89] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(569),
    [anon_sym_GT_AMP] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_LT_AMP] = ACTIONS(569),
    [anon_sym_GT_GT] = ACTIONS(569),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_AMP_GT] = ACTIONS(571),
  },
  [90] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [91] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(573),
  },
  [92] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(331),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(331),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(577),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(581),
    [anon_sym_PERCENT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(597),
    [anon_sym_COLON_DASH] = ACTIONS(581),
    [sym__special_character] = ACTIONS(599),
  },
  [93] = {
    [sym_subscript] = STATE(333),
    [anon_sym_STAR] = ACTIONS(601),
    [anon_sym_QMARK] = ACTIONS(601),
    [anon_sym_AT] = ACTIONS(601),
    [sym_variable_name] = ACTIONS(603),
    [anon_sym_DOLLAR] = ACTIONS(605),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_0] = ACTIONS(607),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(607),
    [anon_sym__] = ACTIONS(607),
  },
  [94] = {
    [anon_sym_EQ] = ACTIONS(609),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [95] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(340),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(340),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(613),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(615),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_DASH] = ACTIONS(615),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(615),
    [anon_sym_PERCENT] = ACTIONS(615),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(619),
    [anon_sym_COLON_DASH] = ACTIONS(615),
    [sym__special_character] = ACTIONS(599),
  },
  [96] = {
    [sym_compound_statement] = STATE(342),
    [anon_sym_LPAREN] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(51),
  },
  [97] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(623),
  },
  [98] = {
    [sym_process_substitution] = STATE(344),
    [sym_string_expansion] = STATE(344),
    [sym_expansion] = STATE(344),
    [sym_simple_expansion] = STATE(344),
    [sym_string] = STATE(344),
    [sym_command_substitution] = STATE(344),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(625),
    [sym_raw_string] = ACTIONS(625),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
  },
  [99] = {
    [aux_sym_concatenation_repeat1] = STATE(346),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(629),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [ts_builtin_sym_end] = ACTIONS(631),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [100] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(347),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [101] = {
    [sym_process_substitution] = STATE(350),
    [sym_string] = STATE(350),
    [sym_command_substitution] = STATE(350),
    [sym_simple_expansion] = STATE(350),
    [sym_variable_assignment] = STATE(358),
    [sym_subscript] = STATE(359),
    [sym_string_expansion] = STATE(350),
    [sym_expansion] = STATE(350),
    [sym_concatenation] = STATE(358),
    [aux_sym_declaration_command_repeat1] = STATE(358),
    [aux_sym__literal_repeat1] = STATE(357),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(633),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(637),
    [aux_sym__simple_variable_name_token1] = ACTIONS(639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(645),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(647),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(643),
    [sym_variable_name] = ACTIONS(649),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(91),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(651),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [102] = {
    [sym_process_substitution] = STATE(362),
    [sym_command_substitution] = STATE(362),
    [aux_sym_unset_command_repeat1] = STATE(369),
    [sym_simple_expansion] = STATE(362),
    [sym_string_expansion] = STATE(362),
    [sym_expansion] = STATE(362),
    [sym_concatenation] = STATE(369),
    [sym_string] = STATE(362),
    [aux_sym__literal_repeat1] = STATE(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(657),
    [aux_sym__simple_variable_name_token1] = ACTIONS(659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(663),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [103] = {
    [sym_string] = STATE(371),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_QMARK] = ACTIONS(671),
    [sym_raw_string] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(671),
    [anon_sym_DOLLAR] = ACTIONS(675),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_0] = ACTIONS(677),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(677),
    [anon_sym__] = ACTIONS(677),
  },
  [104] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(373),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [105] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(374),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(375),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [106] = {
    [sym_subscript] = STATE(376),
    [anon_sym_STAR] = ACTIONS(679),
    [anon_sym_QMARK] = ACTIONS(679),
    [anon_sym_BANG] = ACTIONS(681),
    [anon_sym_AT] = ACTIONS(679),
    [sym_variable_name] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_0] = ACTIONS(687),
    [anon_sym_POUND] = ACTIONS(681),
    [aux_sym__simple_variable_name_token1] = ACTIONS(687),
    [anon_sym__] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_comment] = ACTIONS(51),
    [sym_word] = ACTIONS(689),
  },
  [108] = {
    [aux_sym_concatenation_repeat1] = STATE(383),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_RBRACE] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [109] = {
    [sym_redirected_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_function_definition] = STATE(124),
    [sym_compound_statement] = STATE(124),
    [sym_test_command] = STATE(124),
    [sym_declaration_command] = STATE(124),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(127),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_for_statement] = STATE(124),
    [sym_c_style_for_statement] = STATE(124),
    [sym_case_statement] = STATE(124),
    [sym_subshell] = STATE(124),
    [sym_pipeline] = STATE(124),
    [sym_unset_command] = STATE(124),
    [sym_command] = STATE(124),
    [sym_simple_expansion] = STATE(114),
    [sym__statements] = STATE(385),
    [sym_while_statement] = STATE(124),
    [sym_list] = STATE(124),
    [sym_negated_command] = STATE(124),
    [sym_command_name] = STATE(129),
    [sym_variable_assignment] = STATE(130),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [aux_sym__statements_repeat1] = STATE(131),
    [aux_sym__literal_repeat1] = STATE(132),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(173),
    [anon_sym_typeset] = ACTIONS(173),
    [anon_sym_unsetenv] = ACTIONS(175),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(185),
    [sym_word] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(173),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(197),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_declare] = ACTIONS(173),
    [sym_variable_name] = ACTIONS(205),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(695),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(173),
    [anon_sym_unset] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(215),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(217),
  },
  [110] = {
    [aux_sym_concatenation_repeat1] = STATE(383),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [111] = {
    [sym_redirected_statement] = STATE(140),
    [sym_if_statement] = STATE(140),
    [sym_function_definition] = STATE(140),
    [sym_compound_statement] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_declaration_command] = STATE(140),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(140),
    [sym_c_style_for_statement] = STATE(140),
    [sym_case_statement] = STATE(140),
    [sym_subshell] = STATE(140),
    [sym_pipeline] = STATE(140),
    [sym_unset_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_simple_expansion] = STATE(137),
    [sym__terminated_statement] = STATE(386),
    [sym_while_statement] = STATE(140),
    [sym_list] = STATE(140),
    [sym_negated_command] = STATE(140),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(145),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [112] = {
    [sym_process_substitution] = STATE(387),
    [aux_sym__literal_repeat1] = STATE(389),
    [sym_simple_expansion] = STATE(387),
    [sym_string_expansion] = STATE(387),
    [sym_expansion] = STATE(387),
    [sym_concatenation] = STATE(388),
    [sym_string] = STATE(387),
    [sym_command_substitution] = STATE(387),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_word] = ACTIONS(697),
    [sym_raw_string] = ACTIONS(697),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(245),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [sym__special_character] = ACTIONS(249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
  },
  [113] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(390),
    [sym_parenthesized_expression] = STATE(390),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(390),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_concatenation] = STATE(390),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [114] = {
    [aux_sym_concatenation_repeat1] = STATE(383),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_RBRACE] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [115] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(391),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [116] = {
    [sym_simple_expansion] = STATE(114),
    [sym_test_command] = STATE(392),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(127),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_command_name] = STATE(129),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_variable_assignment] = STATE(127),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [sym_subshell] = STATE(392),
    [sym_command] = STATE(392),
    [aux_sym__literal_repeat1] = STATE(132),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(197),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_word] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(215),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(217),
    [sym__special_character] = ACTIONS(191),
  },
  [117] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(699),
  },
  [118] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_BQUOTE] = ACTIONS(701),
    [anon_sym_AMP_GT_GT] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(703),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [sym_file_descriptor] = ACTIONS(703),
    [anon_sym_GT] = ACTIONS(701),
    [anon_sym_RPAREN] = ACTIONS(701),
    [anon_sym_AMP_GT] = ACTIONS(701),
    [anon_sym_fi] = ACTIONS(701),
    [anon_sym_else] = ACTIONS(701),
    [anon_sym_done] = ACTIONS(701),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [ts_builtin_sym_end] = ACTIONS(703),
    [anon_sym_LT_LT_LT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_GT_AMP] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_LT_AMP] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(701),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_esac] = ACTIONS(701),
    [anon_sym_SEMI_SEMI] = ACTIONS(701),
    [anon_sym_PIPE_AMP] = ACTIONS(701),
  },
  [119] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(396),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(705),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [120] = {
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(709),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(711),
  },
  [121] = {
    [sym_redirected_statement] = STATE(140),
    [sym_if_statement] = STATE(140),
    [sym_function_definition] = STATE(140),
    [sym_compound_statement] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_declaration_command] = STATE(140),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(140),
    [sym_c_style_for_statement] = STATE(140),
    [sym_case_statement] = STATE(140),
    [sym_subshell] = STATE(140),
    [sym_pipeline] = STATE(140),
    [sym_unset_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_simple_expansion] = STATE(137),
    [sym__terminated_statement] = STATE(399),
    [sym_while_statement] = STATE(140),
    [sym_list] = STATE(140),
    [sym_negated_command] = STATE(140),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(145),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [122] = {
    [sym_process_substitution] = STATE(197),
    [sym_postfix_expression] = STATE(400),
    [sym_parenthesized_expression] = STATE(400),
    [sym_command_substitution] = STATE(197),
    [sym_simple_expansion] = STATE(197),
    [sym__expression] = STATE(400),
    [sym_string_expansion] = STATE(197),
    [sym_expansion] = STATE(197),
    [sym_binary_expression] = STATE(400),
    [sym_unary_expression] = STATE(400),
    [sym_concatenation] = STATE(400),
    [sym_string] = STATE(197),
    [aux_sym__literal_repeat1] = STATE(204),
    [sym_test_operator] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(317),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [123] = {
    [sym_process_substitution] = STATE(207),
    [sym_postfix_expression] = STATE(401),
    [sym_parenthesized_expression] = STATE(401),
    [sym_command_substitution] = STATE(207),
    [sym_simple_expansion] = STATE(207),
    [sym__expression] = STATE(401),
    [sym_string_expansion] = STATE(207),
    [sym_expansion] = STATE(207),
    [sym_binary_expression] = STATE(401),
    [sym_unary_expression] = STATE(401),
    [sym_concatenation] = STATE(401),
    [sym_string] = STATE(207),
    [aux_sym__literal_repeat1] = STATE(209),
    [sym_test_operator] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [124] = {
    [aux_sym_redirected_statement_repeat1] = STATE(410),
    [sym_file_redirect] = STATE(410),
    [sym_herestring_redirect] = STATE(410),
    [sym_heredoc_redirect] = STATE(410),
    [anon_sym_SEMI_SEMI] = ACTIONS(713),
    [anon_sym_AMP_GT_GT] = ACTIONS(715),
    [anon_sym_LF] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(713),
    [sym_file_descriptor] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_AMP_GT] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_LT_LT_LT] = ACTIONS(725),
    [anon_sym_GT_AMP] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_AMP] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT_DASH] = ACTIONS(721),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
  },
  [125] = {
    [anon_sym_EQ] = ACTIONS(699),
    [anon_sym_PLUS_EQ] = ACTIONS(699),
    [sym_comment] = ACTIONS(51),
  },
  [126] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_RBRACE] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [127] = {
    [sym_process_substitution] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_command_name] = STATE(411),
    [sym_simple_expansion] = STATE(114),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(132),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_word] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(729),
  },
  [128] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(731),
  },
  [129] = {
    [sym_process_substitution] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [aux_sym_command_repeat2] = STATE(416),
    [sym_concatenation] = STATE(416),
    [sym_string] = STATE(413),
    [aux_sym__literal_repeat1] = STATE(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(367),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_LT_LT] = ACTIONS(367),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [sym_word] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(367),
    [anon_sym_GT_GT] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(741),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(743),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_AMP_GT] = ACTIONS(367),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(367),
    [anon_sym_GT_AMP] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
  },
  [130] = {
    [aux_sym_redirected_statement_repeat1] = STATE(410),
    [sym_file_redirect] = STATE(410),
    [sym_herestring_redirect] = STATE(410),
    [sym_heredoc_redirect] = STATE(410),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(721),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(721),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(713),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(725),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_SEMI_SEMI] = ACTIONS(713),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
  },
  [131] = {
    [sym_redirected_statement] = STATE(417),
    [sym_if_statement] = STATE(417),
    [sym_function_definition] = STATE(417),
    [sym_compound_statement] = STATE(417),
    [sym_test_command] = STATE(417),
    [sym_declaration_command] = STATE(417),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(127),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_for_statement] = STATE(417),
    [sym_c_style_for_statement] = STATE(417),
    [sym_case_statement] = STATE(417),
    [sym_subshell] = STATE(417),
    [sym_pipeline] = STATE(417),
    [sym_unset_command] = STATE(417),
    [sym_command] = STATE(417),
    [sym_simple_expansion] = STATE(114),
    [sym_while_statement] = STATE(417),
    [sym_list] = STATE(417),
    [sym_negated_command] = STATE(417),
    [sym_command_name] = STATE(129),
    [sym_variable_assignment] = STATE(418),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(132),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(173),
    [anon_sym_typeset] = ACTIONS(173),
    [anon_sym_unsetenv] = ACTIONS(175),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(185),
    [sym_word] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(173),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(197),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_declare] = ACTIONS(173),
    [sym_variable_name] = ACTIONS(205),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(173),
    [anon_sym_unset] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(215),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(217),
  },
  [132] = {
    [aux_sym__literal_repeat1] = STATE(420),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_EQ_TILDE] = ACTIONS(389),
    [sym__special_character] = ACTIONS(747),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [133] = {
    [sym_process_substitution] = STATE(421),
    [sym_string] = STATE(421),
    [sym_command_substitution] = STATE(421),
    [sym_simple_expansion] = STATE(421),
    [sym_variable_assignment] = STATE(425),
    [sym_subscript] = STATE(426),
    [sym_string_expansion] = STATE(421),
    [sym_expansion] = STATE(421),
    [sym_concatenation] = STATE(425),
    [aux_sym_declaration_command_repeat1] = STATE(425),
    [aux_sym__literal_repeat1] = STATE(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(753),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(751),
    [sym_variable_name] = ACTIONS(755),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [134] = {
    [sym_process_substitution] = STATE(427),
    [sym_command_substitution] = STATE(427),
    [aux_sym_unset_command_repeat1] = STATE(430),
    [sym_simple_expansion] = STATE(427),
    [sym_string_expansion] = STATE(427),
    [sym_expansion] = STATE(427),
    [sym_concatenation] = STATE(430),
    [sym_string] = STATE(427),
    [aux_sym__literal_repeat1] = STATE(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(757),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(759),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(761),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(759),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [135] = {
    [aux_sym_concatenation_repeat1] = STATE(431),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [136] = {
    [aux_sym_concatenation_repeat1] = STATE(431),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [137] = {
    [aux_sym_concatenation_repeat1] = STATE(431),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [138] = {
    [sym_simple_expansion] = STATE(137),
    [sym_test_command] = STATE(179),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [sym_command_name] = STATE(144),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_variable_assignment] = STATE(142),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_subshell] = STATE(179),
    [sym_command] = STATE(179),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(231),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(229),
  },
  [139] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(763),
  },
  [140] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_AMP_GT_GT] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_LT_LT_LT] = ACTIONS(775),
    [anon_sym_GT_AMP] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_AMP] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
  },
  [141] = {
    [anon_sym_EQ] = ACTIONS(763),
    [anon_sym_PLUS_EQ] = ACTIONS(763),
    [sym_comment] = ACTIONS(51),
  },
  [142] = {
    [sym_process_substitution] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_command_name] = STATE(440),
    [sym_simple_expansion] = STATE(137),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(231),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(779),
  },
  [143] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(781),
  },
  [144] = {
    [sym_process_substitution] = STATE(442),
    [sym_command_substitution] = STATE(442),
    [sym_simple_expansion] = STATE(442),
    [sym_string_expansion] = STATE(442),
    [sym_expansion] = STATE(442),
    [aux_sym_command_repeat2] = STATE(445),
    [sym_concatenation] = STATE(445),
    [sym_string] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(444),
    [anon_sym_AMP_GT_GT] = ACTIONS(367),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(367),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [sym_word] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(367),
    [anon_sym_GT_GT] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_AMP_GT] = ACTIONS(367),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(367),
    [anon_sym_GT_AMP] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
  },
  [145] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(765),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(765),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(775),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_SEMI_SEMI] = ACTIONS(765),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
  },
  [146] = {
    [aux_sym__literal_repeat1] = STATE(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_EQ_TILDE] = ACTIONS(389),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [147] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(447),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [148] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(450),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [149] = {
    [aux_sym_concatenation_repeat1] = STATE(454),
    [anon_sym_SEMI_SEMI] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(793),
    [anon_sym_LF] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(791),
    [anon_sym_in] = ACTIONS(797),
  },
  [150] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(455),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [151] = {
    [sym_string] = STATE(457),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_QMARK] = ACTIONS(799),
    [sym_raw_string] = ACTIONS(801),
    [anon_sym_AT] = ACTIONS(799),
    [anon_sym_DOLLAR] = ACTIONS(803),
    [anon_sym_POUND] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_0] = ACTIONS(805),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(805),
    [anon_sym__] = ACTIONS(805),
  },
  [152] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(459),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(460),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [153] = {
    [aux_sym_concatenation_repeat1] = STATE(454),
    [sym__concat] = ACTIONS(793),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_in] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
  },
  [154] = {
    [sym_subscript] = STATE(461),
    [anon_sym_STAR] = ACTIONS(807),
    [anon_sym_QMARK] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_AT] = ACTIONS(807),
    [sym_variable_name] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_0] = ACTIONS(815),
    [anon_sym_POUND] = ACTIONS(809),
    [aux_sym__simple_variable_name_token1] = ACTIONS(815),
    [anon_sym__] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(795),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_SEMI] = ACTIONS(791),
    [anon_sym_in] = ACTIONS(797),
  },
  [156] = {
    [aux_sym__literal_repeat1] = STATE(468),
    [anon_sym_in] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(819),
    [anon_sym_SEMI_SEMI] = ACTIONS(819),
    [sym__special_character] = ACTIONS(823),
  },
  [157] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(469),
    [sym_parenthesized_expression] = STATE(469),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(469),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(469),
    [sym_unary_expression] = STATE(469),
    [sym_concatenation] = STATE(469),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [158] = {
    [sym_process_substitution] = STATE(471),
    [sym_postfix_expression] = STATE(474),
    [sym_parenthesized_expression] = STATE(474),
    [sym_command_substitution] = STATE(471),
    [sym_simple_expansion] = STATE(471),
    [sym__expression] = STATE(474),
    [sym_string_expansion] = STATE(471),
    [sym_expansion] = STATE(471),
    [sym_binary_expression] = STATE(474),
    [sym_unary_expression] = STATE(474),
    [sym_concatenation] = STATE(474),
    [sym_string] = STATE(471),
    [aux_sym__literal_repeat1] = STATE(473),
    [sym_test_operator] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [159] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(477),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [160] = {
    [aux_sym_concatenation_repeat1] = STATE(479),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_PLUS_EQ] = ACTIONS(839),
    [sym_test_operator] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_LT] = ACTIONS(841),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH_EQ] = ACTIONS(839),
  },
  [161] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(480),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [162] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(481),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [163] = {
    [sym_string] = STATE(483),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [anon_sym_STAR] = ACTIONS(845),
    [anon_sym_QMARK] = ACTIONS(845),
    [sym_raw_string] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [anon_sym_POUND] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(849),
    [anon_sym_0] = ACTIONS(851),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(851),
    [anon_sym__] = ACTIONS(851),
  },
  [164] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(485),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(486),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [165] = {
    [aux_sym_concatenation_repeat1] = STATE(479),
    [anon_sym_BANG_EQ] = ACTIONS(221),
    [anon_sym_PLUS_EQ] = ACTIONS(221),
    [sym_test_operator] = ACTIONS(221),
    [anon_sym_PLUS_PLUS] = ACTIONS(221),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(221),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_GT_EQ] = ACTIONS(221),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(221),
    [anon_sym_DASH_DASH] = ACTIONS(221),
    [anon_sym_LT_EQ] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [sym__special_character] = ACTIONS(221),
    [anon_sym_DASH_EQ] = ACTIONS(221),
  },
  [166] = {
    [sym_subscript] = STATE(487),
    [anon_sym_STAR] = ACTIONS(853),
    [anon_sym_QMARK] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(853),
    [sym_variable_name] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_0] = ACTIONS(861),
    [anon_sym_POUND] = ACTIONS(855),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym__] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [aux_sym__literal_repeat1] = STATE(492),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_PLUS_EQ] = ACTIONS(863),
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_PLUS_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(863),
    [anon_sym_DASH_DASH] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_AMP_AMP] = ACTIONS(863),
    [sym__special_character] = ACTIONS(867),
    [anon_sym_DASH_EQ] = ACTIONS(863),
  },
  [168] = {
    [anon_sym_BANG_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [sym_test_operator] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_GT_EQ] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_DASH_EQ] = ACTIONS(869),
  },
  [169] = {
    [sym_process_substitution] = STATE(421),
    [sym_string] = STATE(421),
    [sym_command_substitution] = STATE(421),
    [sym_simple_expansion] = STATE(421),
    [sym_variable_assignment] = STATE(497),
    [sym_subscript] = STATE(426),
    [sym_string_expansion] = STATE(421),
    [sym_expansion] = STATE(421),
    [sym_concatenation] = STATE(497),
    [aux_sym_declaration_command_repeat1] = STATE(497),
    [aux_sym__literal_repeat1] = STATE(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(753),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(751),
    [sym_variable_name] = ACTIONS(755),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [170] = {
    [sym_process_substitution] = STATE(427),
    [sym_command_substitution] = STATE(427),
    [aux_sym_unset_command_repeat1] = STATE(498),
    [sym_simple_expansion] = STATE(427),
    [sym_string_expansion] = STATE(427),
    [sym_expansion] = STATE(427),
    [sym_concatenation] = STATE(498),
    [sym_string] = STATE(427),
    [aux_sym__literal_repeat1] = STATE(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(759),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(761),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(115),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(759),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [171] = {
    [sym_simple_expansion] = STATE(137),
    [sym_test_command] = STATE(179),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [sym_command_name] = STATE(175),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_variable_assignment] = STATE(173),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_subshell] = STATE(179),
    [sym_command] = STATE(179),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(231),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(229),
  },
  [172] = {
    [aux_sym_redirected_statement_repeat1] = STATE(506),
    [sym_file_redirect] = STATE(506),
    [sym_herestring_redirect] = STATE(506),
    [sym_heredoc_redirect] = STATE(506),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(413),
    [anon_sym_AMP_GT_GT] = ACTIONS(885),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [anon_sym_GT_AMP] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_LT_AMP] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
  },
  [173] = {
    [sym_process_substitution] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_command_name] = STATE(507),
    [sym_simple_expansion] = STATE(137),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(231),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(779),
  },
  [174] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(573),
  },
  [175] = {
    [sym_process_substitution] = STATE(442),
    [sym_command_substitution] = STATE(442),
    [sym_simple_expansion] = STATE(442),
    [sym_string_expansion] = STATE(442),
    [sym_expansion] = STATE(442),
    [aux_sym_command_repeat2] = STATE(508),
    [sym_concatenation] = STATE(508),
    [sym_string] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(444),
    [anon_sym_AMP_GT_GT] = ACTIONS(367),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(367),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [sym_word] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(367),
    [anon_sym_GT_GT] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_AMP_GT] = ACTIONS(367),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(367),
    [anon_sym_GT_AMP] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
  },
  [176] = {
    [aux_sym_redirected_statement_repeat1] = STATE(506),
    [sym_file_redirect] = STATE(506),
    [sym_herestring_redirect] = STATE(506),
    [sym_heredoc_redirect] = STATE(506),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(413),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(887),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
  },
  [177] = {
    [sym_redirected_statement] = STATE(509),
    [sym_if_statement] = STATE(509),
    [sym_function_definition] = STATE(509),
    [sym_compound_statement] = STATE(509),
    [sym_test_command] = STATE(509),
    [sym_declaration_command] = STATE(509),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(509),
    [sym_c_style_for_statement] = STATE(509),
    [sym_case_statement] = STATE(509),
    [sym_subshell] = STATE(509),
    [sym_pipeline] = STATE(509),
    [sym_unset_command] = STATE(509),
    [sym_command] = STATE(509),
    [sym_simple_expansion] = STATE(137),
    [sym_while_statement] = STATE(509),
    [sym_list] = STATE(509),
    [sym_negated_command] = STATE(509),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(510),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [178] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(897),
  },
  [179] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(899),
    [anon_sym_BQUOTE] = ACTIONS(899),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LF] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [sym_file_descriptor] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_AMP_GT] = ACTIONS(899),
    [anon_sym_fi] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_done] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [ts_builtin_sym_end] = ACTIONS(901),
    [anon_sym_LT_LT_LT] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_esac] = ACTIONS(899),
    [anon_sym_SEMI_SEMI] = ACTIONS(899),
    [anon_sym_PIPE_AMP] = ACTIONS(899),
  },
  [180] = {
    [anon_sym_EQ] = ACTIONS(897),
    [anon_sym_PLUS_EQ] = ACTIONS(897),
    [sym_comment] = ACTIONS(51),
  },
  [181] = {
    [sym_process_substitution] = STATE(515),
    [aux_sym__literal_repeat1] = STATE(522),
    [sym_array] = STATE(521),
    [sym_simple_expansion] = STATE(515),
    [sym_string_expansion] = STATE(515),
    [sym_expansion] = STATE(515),
    [sym_concatenation] = STATE(521),
    [sym_string] = STATE(515),
    [sym_command_substitution] = STATE(515),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(909),
    [sym_raw_string] = ACTIONS(909),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [sym__empty_value] = ACTIONS(921),
  },
  [182] = {
    [sym_process_substitution] = STATE(523),
    [aux_sym__literal_repeat1] = STATE(526),
    [sym_simple_expansion] = STATE(523),
    [sym_string_expansion] = STATE(523),
    [sym_expansion] = STATE(523),
    [sym_concatenation] = STATE(525),
    [sym_string] = STATE(523),
    [sym_command_substitution] = STATE(523),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(923),
    [sym_raw_string] = ACTIONS(923),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [183] = {
    [sym_process_substitution] = STATE(527),
    [aux_sym__literal_repeat1] = STATE(529),
    [sym_simple_expansion] = STATE(527),
    [sym_string_expansion] = STATE(527),
    [sym_expansion] = STATE(527),
    [sym_concatenation] = STATE(528),
    [sym_string] = STATE(527),
    [sym_command_substitution] = STATE(527),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(927),
    [sym_raw_string] = ACTIONS(927),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [184] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(534),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [186] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [187] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(535),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(536),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [188] = {
    [sym_subscript] = STATE(537),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_QMARK] = ACTIONS(943),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(947),
    [anon_sym_DOLLAR] = ACTIONS(949),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_0] = ACTIONS(951),
    [anon_sym_POUND] = ACTIONS(945),
    [aux_sym__simple_variable_name_token1] = ACTIONS(951),
    [anon_sym__] = ACTIONS(951),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [anon_sym_BQUOTE] = ACTIONS(953),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [sym__concat] = ACTIONS(955),
    [sym__string_content] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(953),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
  },
  [190] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [191] = {
    [anon_sym_AMP] = ACTIONS(961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(963),
    [anon_sym_SEMI] = ACTIONS(961),
    [anon_sym_in] = ACTIONS(965),
    [anon_sym_SEMI_SEMI] = ACTIONS(961),
  },
  [192] = {
    [sym_process_substitution] = STATE(549),
    [sym_postfix_expression] = STATE(558),
    [sym_parenthesized_expression] = STATE(558),
    [sym_command_substitution] = STATE(549),
    [sym_simple_expansion] = STATE(549),
    [sym__expression] = STATE(558),
    [sym_string_expansion] = STATE(549),
    [sym_expansion] = STATE(549),
    [sym_binary_expression] = STATE(558),
    [sym_unary_expression] = STATE(558),
    [sym_concatenation] = STATE(558),
    [sym_string] = STATE(549),
    [aux_sym__literal_repeat1] = STATE(557),
    [sym_test_operator] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [sym_raw_string] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(975),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [anon_sym_GT_LPAREN] = ACTIONS(981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_word] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_LT_LPAREN] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(975),
  },
  [193] = {
    [sym_do_group] = STATE(560),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(991),
  },
  [194] = {
    [sym_process_substitution] = STATE(197),
    [sym_postfix_expression] = STATE(561),
    [sym_parenthesized_expression] = STATE(561),
    [sym_command_substitution] = STATE(197),
    [sym_simple_expansion] = STATE(197),
    [sym__expression] = STATE(561),
    [sym_string_expansion] = STATE(197),
    [sym_expansion] = STATE(197),
    [sym_binary_expression] = STATE(561),
    [sym_unary_expression] = STATE(561),
    [sym_concatenation] = STATE(561),
    [sym_string] = STATE(197),
    [aux_sym__literal_repeat1] = STATE(204),
    [sym_test_operator] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(317),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [195] = {
    [sym_process_substitution] = STATE(471),
    [sym_postfix_expression] = STATE(562),
    [sym_parenthesized_expression] = STATE(562),
    [sym_command_substitution] = STATE(471),
    [sym_simple_expansion] = STATE(471),
    [sym__expression] = STATE(562),
    [sym_string_expansion] = STATE(471),
    [sym_expansion] = STATE(471),
    [sym_binary_expression] = STATE(562),
    [sym_unary_expression] = STATE(562),
    [sym_concatenation] = STATE(562),
    [sym_string] = STATE(471),
    [aux_sym__literal_repeat1] = STATE(473),
    [sym_test_operator] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [196] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(565),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [197] = {
    [aux_sym_concatenation_repeat1] = STATE(567),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_PLUS_EQ] = ACTIONS(839),
    [sym_test_operator] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_RBRACK] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [sym__concat] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_LT] = ACTIONS(841),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH_EQ] = ACTIONS(839),
  },
  [198] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(568),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [199] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(569),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [200] = {
    [sym_string] = STATE(571),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [anon_sym_STAR] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_POUND] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_0] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1005),
    [anon_sym__] = ACTIONS(1005),
  },
  [201] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(573),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(574),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [202] = {
    [aux_sym_concatenation_repeat1] = STATE(567),
    [anon_sym_BANG_EQ] = ACTIONS(221),
    [anon_sym_PLUS_EQ] = ACTIONS(221),
    [sym_test_operator] = ACTIONS(221),
    [anon_sym_PLUS_PLUS] = ACTIONS(221),
    [anon_sym_RBRACK] = ACTIONS(221),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_GT_EQ] = ACTIONS(221),
    [sym__concat] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(221),
    [anon_sym_DASH_DASH] = ACTIONS(221),
    [anon_sym_LT_EQ] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_DASH_EQ] = ACTIONS(221),
  },
  [203] = {
    [sym_subscript] = STATE(575),
    [anon_sym_STAR] = ACTIONS(1007),
    [anon_sym_QMARK] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_AT] = ACTIONS(1007),
    [sym_variable_name] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_0] = ACTIONS(1015),
    [anon_sym_POUND] = ACTIONS(1009),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1015),
    [anon_sym__] = ACTIONS(1015),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [aux_sym__literal_repeat1] = STATE(580),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_PLUS_EQ] = ACTIONS(863),
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_PLUS_PLUS] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(863),
    [anon_sym_DASH_DASH] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_AMP_AMP] = ACTIONS(863),
    [sym__special_character] = ACTIONS(1017),
    [anon_sym_DASH_EQ] = ACTIONS(863),
  },
  [205] = {
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_PLUS_EQ] = ACTIONS(1019),
    [sym_test_operator] = ACTIONS(1019),
    [anon_sym_PLUS_PLUS] = ACTIONS(1021),
    [anon_sym_RBRACK] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_DASH_EQ] = ACTIONS(1019),
  },
  [206] = {
    [sym_process_substitution] = STATE(207),
    [sym_postfix_expression] = STATE(584),
    [sym_parenthesized_expression] = STATE(584),
    [sym_command_substitution] = STATE(207),
    [sym_simple_expansion] = STATE(207),
    [sym__expression] = STATE(584),
    [sym_string_expansion] = STATE(207),
    [sym_expansion] = STATE(207),
    [sym_binary_expression] = STATE(584),
    [sym_unary_expression] = STATE(584),
    [sym_concatenation] = STATE(584),
    [sym_string] = STATE(207),
    [aux_sym__literal_repeat1] = STATE(209),
    [sym_test_operator] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [207] = {
    [aux_sym_concatenation_repeat1] = STATE(585),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_PLUS_EQ] = ACTIONS(839),
    [sym_test_operator] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_LT] = ACTIONS(841),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH_EQ] = ACTIONS(839),
  },
  [208] = {
    [aux_sym_concatenation_repeat1] = STATE(585),
    [anon_sym_BANG_EQ] = ACTIONS(221),
    [anon_sym_PLUS_EQ] = ACTIONS(221),
    [sym_test_operator] = ACTIONS(221),
    [anon_sym_PLUS_PLUS] = ACTIONS(221),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(221),
    [anon_sym_GT_EQ] = ACTIONS(221),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(221),
    [anon_sym_DASH_DASH] = ACTIONS(221),
    [anon_sym_LT_EQ] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_DASH_EQ] = ACTIONS(221),
  },
  [209] = {
    [aux_sym__literal_repeat1] = STATE(586),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_PLUS_EQ] = ACTIONS(863),
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_PLUS_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(863),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(863),
    [anon_sym_DASH_DASH] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_AMP_AMP] = ACTIONS(863),
    [sym__special_character] = ACTIONS(1027),
    [anon_sym_DASH_EQ] = ACTIONS(863),
  },
  [210] = {
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [sym_test_operator] = ACTIONS(1029),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_EQ_EQ] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1029),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_LT] = ACTIONS(1031),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
  },
  [211] = {
    [sym_redirected_statement] = STATE(589),
    [sym_if_statement] = STATE(589),
    [sym_function_definition] = STATE(589),
    [sym_compound_statement] = STATE(589),
    [sym_test_command] = STATE(589),
    [sym_declaration_command] = STATE(589),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_for_statement] = STATE(589),
    [sym_c_style_for_statement] = STATE(589),
    [sym_case_statement] = STATE(589),
    [sym_subshell] = STATE(589),
    [sym_pipeline] = STATE(589),
    [sym_unset_command] = STATE(589),
    [sym_command] = STATE(589),
    [sym_simple_expansion] = STATE(17),
    [sym_while_statement] = STATE(589),
    [sym_list] = STATE(589),
    [sym_negated_command] = STATE(589),
    [sym_command_name] = STATE(33),
    [sym_variable_assignment] = STATE(590),
    [sym_string_expansion] = STATE(17),
    [sym_expansion] = STATE(17),
    [aux_sym__literal_repeat1] = STATE(36),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [212] = {
    [sym_process_substitution] = STATE(593),
    [aux_sym__literal_repeat1] = STATE(600),
    [sym_simple_expansion] = STATE(593),
    [sym_string_expansion] = STATE(593),
    [sym_expansion] = STATE(593),
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(593),
    [sym_command_substitution] = STATE(593),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(1039),
    [sym_raw_string] = ACTIONS(1039),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [213] = {
    [sym_heredoc_body] = STATE(603),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [214] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [215] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_AMP] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1063),
  },
  [216] = {
    [sym_heredoc_start] = ACTIONS(1065),
    [sym_comment] = ACTIONS(51),
  },
  [217] = {
    [sym_redirected_statement] = STATE(606),
    [sym_if_statement] = STATE(606),
    [sym_function_definition] = STATE(606),
    [sym_compound_statement] = STATE(606),
    [sym_test_command] = STATE(606),
    [sym_declaration_command] = STATE(606),
    [sym_subscript] = STATE(28),
    [sym_file_redirect] = STATE(30),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_for_statement] = STATE(606),
    [sym_c_style_for_statement] = STATE(606),
    [sym_case_statement] = STATE(606),
    [sym_subshell] = STATE(606),
    [sym_pipeline] = STATE(606),
    [sym_unset_command] = STATE(606),
    [sym_command] = STATE(606),
    [sym_simple_expansion] = STATE(17),
    [sym_while_statement] = STATE(606),
    [sym_list] = STATE(606),
    [sym_negated_command] = STATE(606),
    [sym_command_name] = STATE(33),
    [sym_variable_assignment] = STATE(607),
    [sym_string_expansion] = STATE(17),
    [sym_expansion] = STATE(17),
    [aux_sym__literal_repeat1] = STATE(36),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [218] = {
    [sym_process_substitution] = STATE(608),
    [aux_sym__literal_repeat1] = STATE(610),
    [sym_simple_expansion] = STATE(608),
    [sym_string_expansion] = STATE(608),
    [sym_expansion] = STATE(608),
    [sym_concatenation] = STATE(609),
    [sym_string] = STATE(608),
    [sym_command_substitution] = STATE(608),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(1067),
    [sym_raw_string] = ACTIONS(1067),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [219] = {
    [aux_sym_redirected_statement_repeat1] = STATE(611),
    [sym_file_redirect] = STATE(611),
    [sym_herestring_redirect] = STATE(611),
    [sym_heredoc_redirect] = STATE(611),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(345),
    [anon_sym_LF] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(351),
    [sym_file_descriptor] = ACTIONS(349),
    [anon_sym_GT] = ACTIONS(345),
    [anon_sym_AMP_GT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [ts_builtin_sym_end] = ACTIONS(1069),
    [anon_sym_LT_LT_LT] = ACTIONS(357),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(345),
    [anon_sym_LT_AMP] = ACTIONS(345),
    [anon_sym_GT_GT] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
  },
  [220] = {
    [sym_process_substitution] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [aux_sym_command_repeat2] = STATE(612),
    [sym_concatenation] = STATE(612),
    [sym_string] = STATE(222),
    [aux_sym__literal_repeat1] = STATE(224),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(375),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(377),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(375),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [ts_builtin_sym_end] = ACTIONS(1075),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [221] = {
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [anon_sym_AMP_GT_GT] = ACTIONS(1079),
    [sym_raw_string] = ACTIONS(1077),
    [anon_sym_DOLLAR] = ACTIONS(1082),
    [sym_file_descriptor] = ACTIONS(1084),
    [sym_variable_name] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1090),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1077),
    [anon_sym_AMP_GT] = ACTIONS(1090),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1077),
    [anon_sym_GT_LPAREN] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1077),
    [sym_word] = ACTIONS(1077),
    [anon_sym_GT_AMP] = ACTIONS(1079),
    [anon_sym_LT] = ACTIONS(1090),
    [anon_sym_LT_AMP] = ACTIONS(1079),
    [anon_sym_GT_GT] = ACTIONS(1079),
    [anon_sym_LT_LPAREN] = ACTIONS(1077),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1077),
  },
  [222] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [sym__special_character] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
  },
  [223] = {
    [sym_process_substitution] = STATE(613),
    [aux_sym__literal_repeat1] = STATE(615),
    [sym_simple_expansion] = STATE(613),
    [sym_string_expansion] = STATE(613),
    [sym_expansion] = STATE(613),
    [sym_concatenation] = STATE(614),
    [sym_string] = STATE(613),
    [sym_command_substitution] = STATE(613),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(1097),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [sym_regex] = ACTIONS(1099),
  },
  [224] = {
    [aux_sym__literal_repeat1] = STATE(230),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [ts_builtin_sym_end] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
  },
  [225] = {
    [sym_process_substitution] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [aux_sym_command_repeat2] = STATE(616),
    [sym_concatenation] = STATE(616),
    [sym_string] = STATE(222),
    [aux_sym__literal_repeat1] = STATE(224),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(375),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(377),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(375),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [ts_builtin_sym_end] = ACTIONS(1075),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [226] = {
    [aux_sym_redirected_statement_repeat1] = STATE(219),
    [sym_file_redirect] = STATE(219),
    [sym_herestring_redirect] = STATE(219),
    [sym_heredoc_redirect] = STATE(219),
    [anon_sym_PIPE_AMP] = ACTIONS(359),
    [anon_sym_AMP_GT_GT] = ACTIONS(345),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [sym_file_descriptor] = ACTIONS(349),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(345),
    [anon_sym_AMP_GT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(357),
    [anon_sym_GT_AMP] = ACTIONS(345),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(345),
    [anon_sym_LT_AMP] = ACTIONS(345),
    [anon_sym_GT_GT] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
  },
  [227] = {
    [aux_sym_redirected_statement_repeat1] = STATE(219),
    [sym_file_redirect] = STATE(219),
    [sym_herestring_redirect] = STATE(219),
    [sym_heredoc_redirect] = STATE(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(357),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(359),
  },
  [228] = {
    [sym_redirected_statement] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_function_definition] = STATE(619),
    [sym_compound_statement] = STATE(619),
    [sym_test_command] = STATE(619),
    [sym_declaration_command] = STATE(619),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(619),
    [sym_c_style_for_statement] = STATE(619),
    [sym_case_statement] = STATE(619),
    [sym_subshell] = STATE(619),
    [sym_pipeline] = STATE(619),
    [sym_unset_command] = STATE(619),
    [sym_command] = STATE(619),
    [sym_simple_expansion] = STATE(137),
    [sym_while_statement] = STATE(619),
    [sym_list] = STATE(619),
    [sym_negated_command] = STATE(619),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(620),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_AMP_GT_GT] = ACTIONS(1112),
    [anon_sym_local] = ACTIONS(1115),
    [anon_sym_typeset] = ACTIONS(1115),
    [anon_sym_unsetenv] = ACTIONS(1118),
    [anon_sym_DOLLAR] = ACTIONS(1121),
    [anon_sym_GT_LPAREN] = ACTIONS(1124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1130),
    [anon_sym_function] = ACTIONS(1133),
    [sym_word] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_LT] = ACTIONS(1142),
    [anon_sym_LT_AMP] = ACTIONS(1112),
    [anon_sym_GT_GT] = ACTIONS(1112),
    [anon_sym_export] = ACTIONS(1115),
    [sym__special_character] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1148),
    [anon_sym_case] = ACTIONS(1151),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1154),
    [sym_raw_string] = ACTIONS(1157),
    [anon_sym_BQUOTE] = ACTIONS(1160),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_declare] = ACTIONS(1115),
    [sym_variable_name] = ACTIONS(1166),
    [sym_file_descriptor] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1142),
    [anon_sym_AMP_GT] = ACTIONS(1142),
    [anon_sym_readonly] = ACTIONS(1115),
    [anon_sym_unset] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1172),
    [anon_sym_GT_AMP] = ACTIONS(1112),
    [anon_sym_LT_LPAREN] = ACTIONS(1124),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1175),
    [anon_sym_while] = ACTIONS(1178),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1184),
  },
  [229] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [230] = {
    [aux_sym__literal_repeat1] = STATE(230),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_EQ_TILDE] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1189),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [ts_builtin_sym_end] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [231] = {
    [aux_sym_concatenation_repeat1] = STATE(621),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(471),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [232] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(1194),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(1194),
  },
  [233] = {
    [aux_sym_concatenation_repeat1] = STATE(621),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(471),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [234] = {
    [aux_sym__literal_repeat1] = STATE(623),
    [anon_sym_AMP_GT_GT] = ACTIONS(497),
    [anon_sym_DOLLAR] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(497),
    [anon_sym_GT_LPAREN] = ACTIONS(497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(497),
    [aux_sym__simple_variable_name_token1] = ACTIONS(497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [sym_word] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(497),
    [anon_sym_LT_AMP] = ACTIONS(497),
    [anon_sym_GT_GT] = ACTIONS(497),
    [sym__special_character] = ACTIONS(499),
    [anon_sym_LT_LT_DASH] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(497),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(497),
    [sym_raw_string] = ACTIONS(497),
    [sym_variable_name] = ACTIONS(501),
    [anon_sym_RPAREN] = ACTIONS(497),
    [sym_file_descriptor] = ACTIONS(501),
    [anon_sym_GT] = ACTIONS(497),
    [anon_sym_AMP_GT] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(497),
    [anon_sym_LT_LT_LT] = ACTIONS(497),
    [anon_sym_GT_AMP] = ACTIONS(497),
    [anon_sym_LT_LPAREN] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [anon_sym_PIPE_AMP] = ACTIONS(497),
  },
  [235] = {
    [sym_process_substitution] = STATE(231),
    [sym_string] = STATE(231),
    [sym_command_substitution] = STATE(231),
    [sym_simple_expansion] = STATE(231),
    [sym_variable_assignment] = STATE(624),
    [sym_subscript] = STATE(236),
    [sym_string_expansion] = STATE(231),
    [sym_expansion] = STATE(231),
    [sym_concatenation] = STATE(624),
    [aux_sym_declaration_command_repeat1] = STATE(624),
    [aux_sym__literal_repeat1] = STATE(234),
    [anon_sym_AMP_GT_GT] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1196),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [sym_word] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_LT_AMP] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [sym__special_character] = ACTIONS(399),
    [anon_sym_LT_LT_DASH] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_raw_string] = ACTIONS(397),
    [sym_variable_name] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(503),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_AMP_GT] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(503),
    [anon_sym_GT_AMP] = ACTIONS(503),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
  },
  [236] = {
    [anon_sym_EQ] = ACTIONS(1194),
    [anon_sym_PLUS_EQ] = ACTIONS(1194),
    [sym_comment] = ACTIONS(51),
  },
  [237] = {
    [aux_sym_concatenation_repeat1] = STATE(625),
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_RPAREN] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [238] = {
    [aux_sym_concatenation_repeat1] = STATE(625),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [239] = {
    [aux_sym__literal_repeat1] = STATE(626),
    [anon_sym_AMP_GT_GT] = ACTIONS(539),
    [anon_sym_DOLLAR] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_GT_LPAREN] = ACTIONS(539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(539),
    [aux_sym__simple_variable_name_token1] = ACTIONS(539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [sym_word] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_LT_AMP] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(539),
    [sym__special_character] = ACTIONS(541),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_raw_string] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(539),
    [sym_file_descriptor] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(539),
    [anon_sym_AMP_GT] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_LT_LT_LT] = ACTIONS(539),
    [anon_sym_GT_AMP] = ACTIONS(539),
    [anon_sym_LT_LPAREN] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_SEMI_SEMI] = ACTIONS(539),
    [anon_sym_PIPE_AMP] = ACTIONS(539),
  },
  [240] = {
    [sym_process_substitution] = STATE(237),
    [sym_command_substitution] = STATE(237),
    [aux_sym_unset_command_repeat1] = STATE(627),
    [sym_simple_expansion] = STATE(237),
    [sym_string_expansion] = STATE(237),
    [sym_expansion] = STATE(237),
    [sym_concatenation] = STATE(627),
    [sym_string] = STATE(237),
    [aux_sym__literal_repeat1] = STATE(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(545),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(545),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_LT_AMP] = ACTIONS(545),
    [anon_sym_GT_GT] = ACTIONS(545),
    [sym__special_character] = ACTIONS(407),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(545),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_RPAREN] = ACTIONS(545),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_AMP_GT] = ACTIONS(545),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(545),
    [anon_sym_GT_AMP] = ACTIONS(545),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
  },
  [241] = {
    [aux_sym_concatenation_repeat1] = STATE(628),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(629),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [242] = {
    [sym_process_substitution] = STATE(629),
    [aux_sym__literal_repeat1] = STATE(631),
    [sym_array] = STATE(521),
    [sym_simple_expansion] = STATE(629),
    [sym_string_expansion] = STATE(629),
    [sym_expansion] = STATE(629),
    [sym_concatenation] = STATE(521),
    [sym_string] = STATE(629),
    [sym_command_substitution] = STATE(629),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(1200),
    [sym_raw_string] = ACTIONS(1200),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(1202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [sym__empty_value] = ACTIONS(921),
  },
  [243] = {
    [sym_redirected_statement] = STATE(632),
    [sym_if_statement] = STATE(632),
    [sym_function_definition] = STATE(632),
    [sym_compound_statement] = STATE(632),
    [sym_test_command] = STATE(632),
    [sym_declaration_command] = STATE(632),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(632),
    [sym_c_style_for_statement] = STATE(632),
    [sym_case_statement] = STATE(632),
    [sym_subshell] = STATE(632),
    [sym_pipeline] = STATE(632),
    [sym_unset_command] = STATE(632),
    [sym_command] = STATE(632),
    [sym_simple_expansion] = STATE(41),
    [sym_while_statement] = STATE(632),
    [sym_list] = STATE(632),
    [sym_negated_command] = STATE(632),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(633),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [244] = {
    [sym_process_substitution] = STATE(634),
    [aux_sym__literal_repeat1] = STATE(636),
    [sym_simple_expansion] = STATE(634),
    [sym_string_expansion] = STATE(634),
    [sym_expansion] = STATE(634),
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(634),
    [sym_command_substitution] = STATE(634),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [245] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1208),
    [anon_sym_GT_AMP] = ACTIONS(1208),
    [anon_sym_LT] = ACTIONS(1210),
    [anon_sym_LT_AMP] = ACTIONS(1208),
    [anon_sym_GT_GT] = ACTIONS(1208),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1210),
    [anon_sym_AMP_GT] = ACTIONS(1210),
  },
  [246] = {
    [sym_redirected_statement] = STATE(638),
    [sym_if_statement] = STATE(638),
    [sym_function_definition] = STATE(638),
    [sym_compound_statement] = STATE(638),
    [sym_test_command] = STATE(638),
    [sym_declaration_command] = STATE(638),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(638),
    [sym_c_style_for_statement] = STATE(638),
    [sym_case_statement] = STATE(638),
    [sym_subshell] = STATE(638),
    [sym_pipeline] = STATE(638),
    [sym_unset_command] = STATE(638),
    [sym_command] = STATE(638),
    [sym_simple_expansion] = STATE(41),
    [sym_while_statement] = STATE(638),
    [sym_list] = STATE(638),
    [sym_negated_command] = STATE(638),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(639),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [247] = {
    [sym_process_substitution] = STATE(640),
    [aux_sym__literal_repeat1] = STATE(641),
    [sym_simple_expansion] = STATE(640),
    [sym_string_expansion] = STATE(640),
    [sym_expansion] = STATE(640),
    [sym_concatenation] = STATE(609),
    [sym_string] = STATE(640),
    [sym_command_substitution] = STATE(640),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(1212),
    [sym_raw_string] = ACTIONS(1212),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [248] = {
    [aux_sym_redirected_statement_repeat1] = STATE(642),
    [sym_file_redirect] = STATE(642),
    [sym_herestring_redirect] = STATE(642),
    [sym_heredoc_redirect] = STATE(642),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(411),
    [anon_sym_LF] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_RPAREN] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(411),
    [sym_file_descriptor] = ACTIONS(415),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(411),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_AMP] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
  },
  [249] = {
    [sym_process_substitution] = STATE(251),
    [sym_command_substitution] = STATE(251),
    [sym_simple_expansion] = STATE(251),
    [sym_string_expansion] = STATE(251),
    [sym_expansion] = STATE(251),
    [aux_sym_command_repeat2] = STATE(643),
    [sym_concatenation] = STATE(643),
    [sym_string] = STATE(251),
    [aux_sym__literal_repeat1] = STATE(253),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(429),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(427),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [250] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(1214),
    [anon_sym_AMP_GT_GT] = ACTIONS(1214),
    [anon_sym_LF] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_LT_LT] = ACTIONS(1214),
    [sym_file_descriptor] = ACTIONS(1216),
    [anon_sym_GT] = ACTIONS(1214),
    [anon_sym_RPAREN] = ACTIONS(1214),
    [anon_sym_AMP_GT] = ACTIONS(1214),
    [anon_sym_fi] = ACTIONS(1214),
    [anon_sym_else] = ACTIONS(1214),
    [anon_sym_done] = ACTIONS(1214),
    [anon_sym_PIPE_PIPE] = ACTIONS(1214),
    [ts_builtin_sym_end] = ACTIONS(1216),
    [anon_sym_LT_LT_LT] = ACTIONS(1214),
    [anon_sym_PIPE] = ACTIONS(1214),
    [anon_sym_GT_AMP] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_LT_AMP] = ACTIONS(1214),
    [anon_sym_GT_GT] = ACTIONS(1214),
    [anon_sym_AMP] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(1214),
    [anon_sym_AMP_AMP] = ACTIONS(1214),
    [anon_sym_esac] = ACTIONS(1214),
    [anon_sym_SEMI_SEMI] = ACTIONS(1214),
    [anon_sym_PIPE_AMP] = ACTIONS(1214),
  },
  [251] = {
    [aux_sym_concatenation_repeat1] = STATE(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [sym__special_character] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1093),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
  },
  [252] = {
    [sym_process_substitution] = STATE(644),
    [aux_sym__literal_repeat1] = STATE(645),
    [sym_simple_expansion] = STATE(644),
    [sym_string_expansion] = STATE(644),
    [sym_expansion] = STATE(644),
    [sym_concatenation] = STATE(614),
    [sym_string] = STATE(644),
    [sym_command_substitution] = STATE(644),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(1218),
    [sym_raw_string] = ACTIONS(1218),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [sym_regex] = ACTIONS(1099),
  },
  [253] = {
    [aux_sym__literal_repeat1] = STATE(257),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
  },
  [254] = {
    [sym_process_substitution] = STATE(251),
    [sym_command_substitution] = STATE(251),
    [sym_simple_expansion] = STATE(251),
    [sym_string_expansion] = STATE(251),
    [sym_expansion] = STATE(251),
    [aux_sym_command_repeat2] = STATE(646),
    [sym_concatenation] = STATE(646),
    [sym_string] = STATE(251),
    [aux_sym__literal_repeat1] = STATE(253),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(429),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(427),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [255] = {
    [aux_sym_redirected_statement_repeat1] = STATE(248),
    [sym_file_redirect] = STATE(248),
    [sym_herestring_redirect] = STATE(248),
    [sym_heredoc_redirect] = STATE(248),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_GT_GT] = ACTIONS(411),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1220),
    [sym_file_descriptor] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [anon_sym_GT_AMP] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_LT_AMP] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
  },
  [256] = {
    [aux_sym_redirected_statement_repeat1] = STATE(248),
    [sym_file_redirect] = STATE(248),
    [sym_herestring_redirect] = STATE(248),
    [sym_heredoc_redirect] = STATE(248),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(1220),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_SEMI_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
  },
  [257] = {
    [aux_sym__literal_repeat1] = STATE(257),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_EQ_TILDE] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1189),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [258] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1222),
  },
  [259] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(1224),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [anon_sym_BQUOTE] = ACTIONS(941),
    [anon_sym_AMP_GT_GT] = ACTIONS(941),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(941),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(941),
    [anon_sym_GT_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_word] = ACTIONS(941),
    [anon_sym_GT_AMP] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(941),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(941),
  },
  [261] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1226),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [262] = {
    [sym_process_substitution] = STATE(650),
    [sym_string_expansion] = STATE(650),
    [sym_expansion] = STATE(650),
    [sym_simple_expansion] = STATE(650),
    [sym_string] = STATE(650),
    [sym_command_substitution] = STATE(650),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(1228),
    [sym_raw_string] = ACTIONS(1228),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(1228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [263] = {
    [aux_sym_concatenation_repeat1] = STATE(652),
    [anon_sym_BQUOTE] = ACTIONS(631),
    [anon_sym_AMP_GT_GT] = ACTIONS(631),
    [sym_raw_string] = ACTIONS(631),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [sym_variable_name] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(631),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(631),
    [anon_sym_GT_LPAREN] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(631),
    [sym_word] = ACTIONS(631),
    [anon_sym_GT_AMP] = ACTIONS(631),
    [sym__concat] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(631),
    [anon_sym_GT_GT] = ACTIONS(631),
    [anon_sym_LT_LPAREN] = ACTIONS(631),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(631),
  },
  [264] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1232),
  },
  [265] = {
    [anon_sym_BQUOTE] = ACTIONS(553),
    [anon_sym_AMP_GT_GT] = ACTIONS(553),
    [sym_raw_string] = ACTIONS(553),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [sym_variable_name] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(553),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(553),
    [anon_sym_GT_LPAREN] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(553),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [sym_word] = ACTIONS(553),
    [anon_sym_GT_AMP] = ACTIONS(553),
    [sym__concat] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(553),
    [anon_sym_GT_GT] = ACTIONS(553),
    [anon_sym_LT_LPAREN] = ACTIONS(553),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(553),
  },
  [266] = {
    [anon_sym_BQUOTE] = ACTIONS(557),
    [anon_sym_AMP_GT_GT] = ACTIONS(557),
    [sym_raw_string] = ACTIONS(557),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [sym_variable_name] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(557),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(557),
    [anon_sym_GT_LPAREN] = ACTIONS(557),
    [anon_sym_RPAREN] = ACTIONS(557),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [sym_word] = ACTIONS(557),
    [anon_sym_GT_AMP] = ACTIONS(557),
    [sym__concat] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(557),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_LT_LPAREN] = ACTIONS(557),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(557),
  },
  [267] = {
    [anon_sym_BQUOTE] = ACTIONS(561),
    [anon_sym_AMP_GT_GT] = ACTIONS(561),
    [sym_raw_string] = ACTIONS(561),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [sym_variable_name] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(561),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(561),
    [anon_sym_GT_LPAREN] = ACTIONS(561),
    [anon_sym_RPAREN] = ACTIONS(561),
    [anon_sym_DQUOTE] = ACTIONS(561),
    [sym_word] = ACTIONS(561),
    [anon_sym_GT_AMP] = ACTIONS(561),
    [sym__concat] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_LT_LPAREN] = ACTIONS(561),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(561),
  },
  [268] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(1222),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [269] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1222),
  },
  [270] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(656),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(656),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1234),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1236),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_PERCENT] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1240),
    [anon_sym_COLON_DASH] = ACTIONS(1236),
    [sym__special_character] = ACTIONS(599),
  },
  [271] = {
    [sym_subscript] = STATE(657),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_QMARK] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1242),
    [sym_variable_name] = ACTIONS(1244),
    [anon_sym_DOLLAR] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_0] = ACTIONS(1248),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(1248),
  },
  [272] = {
    [anon_sym_EQ] = ACTIONS(1250),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [273] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(663),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(663),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1252),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1254),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1258),
    [anon_sym_COLON_DASH] = ACTIONS(1254),
    [sym__special_character] = ACTIONS(599),
  },
  [274] = {
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_AMP_GT_GT] = ACTIONS(221),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [sym_variable_name] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [sym_word] = ACTIONS(221),
    [anon_sym_GT_AMP] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(221),
    [anon_sym_GT_GT] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(221),
  },
  [275] = {
    [aux_sym__literal_repeat1] = STATE(275),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [anon_sym_AMP_GT_GT] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [sym_variable_name] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_word] = ACTIONS(1192),
    [anon_sym_GT_AMP] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1192),
    [anon_sym_GT_GT] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1260),
  },
  [276] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1263),
  },
  [277] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [279] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1267),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [280] = {
    [sym_process_substitution] = STATE(667),
    [sym_string_expansion] = STATE(667),
    [sym_expansion] = STATE(667),
    [sym_simple_expansion] = STATE(667),
    [sym_string] = STATE(667),
    [sym_command_substitution] = STATE(667),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [sym_word] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1275),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1277),
  },
  [281] = {
    [aux_sym_concatenation_repeat1] = STATE(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(1279),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [ts_builtin_sym_end] = ACTIONS(631),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [282] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1281),
  },
  [283] = {
    [sym_process_substitution] = STATE(672),
    [aux_sym__literal_repeat1] = STATE(674),
    [sym_array] = STATE(673),
    [sym_simple_expansion] = STATE(672),
    [sym_string_expansion] = STATE(672),
    [sym_expansion] = STATE(672),
    [sym_concatenation] = STATE(673),
    [sym_string] = STATE(672),
    [sym_command_substitution] = STATE(672),
    [anon_sym_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [sym_word] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1275),
    [sym__special_character] = ACTIONS(1287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1277),
    [sym__empty_value] = ACTIONS(1289),
  },
  [284] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [ts_builtin_sym_end] = ACTIONS(553),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [285] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [ts_builtin_sym_end] = ACTIONS(557),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [286] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(561),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [287] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [288] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1263),
  },
  [289] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(677),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(677),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1291),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1297),
    [anon_sym_COLON_DASH] = ACTIONS(1293),
    [sym__special_character] = ACTIONS(599),
  },
  [290] = {
    [sym_subscript] = STATE(678),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_QMARK] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1299),
    [sym_variable_name] = ACTIONS(1301),
    [anon_sym_DOLLAR] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1303),
    [anon_sym_0] = ACTIONS(1305),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1305),
    [anon_sym__] = ACTIONS(1305),
  },
  [291] = {
    [anon_sym_EQ] = ACTIONS(1307),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [292] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(684),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(684),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1311),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1313),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1311),
    [anon_sym_PERCENT] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1315),
    [anon_sym_COLON_DASH] = ACTIONS(1311),
    [sym__special_character] = ACTIONS(599),
  },
  [293] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [294] = {
    [aux_sym__literal_repeat1] = STATE(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1317),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [ts_builtin_sym_end] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [295] = {
    [sym_process_substitution] = STATE(64),
    [sym_string] = STATE(64),
    [sym_command_substitution] = STATE(64),
    [sym_simple_expansion] = STATE(64),
    [sym_variable_assignment] = STATE(295),
    [sym_subscript] = STATE(73),
    [sym_string_expansion] = STATE(64),
    [sym_expansion] = STATE(64),
    [sym_concatenation] = STATE(295),
    [aux_sym_declaration_command_repeat1] = STATE(295),
    [aux_sym__literal_repeat1] = STATE(71),
    [anon_sym_AMP_GT_GT] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(1322),
    [anon_sym_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_LPAREN] = ACTIONS(1325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1328),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1334),
    [anon_sym_PIPE_PIPE] = ACTIONS(1320),
    [sym_word] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_AMP] = ACTIONS(1320),
    [anon_sym_LT] = ACTIONS(1320),
    [anon_sym_LT_AMP] = ACTIONS(1320),
    [anon_sym_GT_GT] = ACTIONS(1320),
    [sym__special_character] = ACTIONS(1340),
    [anon_sym_LT_LT_DASH] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(1343),
    [anon_sym_LF] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_raw_string] = ACTIONS(1337),
    [sym_variable_name] = ACTIONS(1348),
    [sym_file_descriptor] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1320),
    [anon_sym_AMP_GT] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_AMP] = ACTIONS(1320),
    [ts_builtin_sym_end] = ACTIONS(1346),
    [anon_sym_LT_LPAREN] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1320),
    [anon_sym_SEMI_SEMI] = ACTIONS(1320),
    [anon_sym_PIPE_AMP] = ACTIONS(1320),
  },
  [296] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1354),
  },
  [297] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [299] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [300] = {
    [sym_process_substitution] = STATE(688),
    [sym_string_expansion] = STATE(688),
    [sym_expansion] = STATE(688),
    [sym_simple_expansion] = STATE(688),
    [sym_string] = STATE(688),
    [sym_command_substitution] = STATE(688),
    [anon_sym_BQUOTE] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [sym_word] = ACTIONS(1362),
    [sym_raw_string] = ACTIONS(1362),
    [anon_sym_LT_LPAREN] = ACTIONS(1364),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1366),
    [sym__special_character] = ACTIONS(1362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [301] = {
    [aux_sym_concatenation_repeat1] = STATE(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(1370),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [ts_builtin_sym_end] = ACTIONS(631),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [302] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1372),
  },
  [303] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [ts_builtin_sym_end] = ACTIONS(553),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [304] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [ts_builtin_sym_end] = ACTIONS(557),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [305] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(561),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [306] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [307] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1354),
  },
  [308] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(694),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(694),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1374),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1376),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1376),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1376),
    [anon_sym_PERCENT] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1380),
    [anon_sym_COLON_DASH] = ACTIONS(1376),
    [sym__special_character] = ACTIONS(599),
  },
  [309] = {
    [sym_subscript] = STATE(695),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_QMARK] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1382),
    [sym_variable_name] = ACTIONS(1384),
    [anon_sym_DOLLAR] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_0] = ACTIONS(1388),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1388),
    [anon_sym__] = ACTIONS(1388),
  },
  [310] = {
    [anon_sym_EQ] = ACTIONS(1390),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [311] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(701),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(701),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1392),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1394),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1398),
    [anon_sym_COLON_DASH] = ACTIONS(1394),
    [sym__special_character] = ACTIONS(599),
  },
  [312] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [313] = {
    [aux_sym__literal_repeat1] = STATE(313),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [ts_builtin_sym_end] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [314] = {
    [sym_process_substitution] = STATE(76),
    [sym_command_substitution] = STATE(76),
    [aux_sym_unset_command_repeat1] = STATE(314),
    [sym_simple_expansion] = STATE(76),
    [sym_string_expansion] = STATE(76),
    [sym_expansion] = STATE(76),
    [sym_concatenation] = STATE(314),
    [sym_string] = STATE(76),
    [aux_sym__literal_repeat1] = STATE(82),
    [anon_sym_AMP_GT_GT] = ACTIONS(1403),
    [anon_sym_DOLLAR] = ACTIONS(1405),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_LPAREN] = ACTIONS(1408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1411),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1417),
    [anon_sym_PIPE_PIPE] = ACTIONS(1403),
    [sym_word] = ACTIONS(1420),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_LT_AMP] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [sym__special_character] = ACTIONS(1423),
    [anon_sym_LT_LT_DASH] = ACTIONS(1403),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [anon_sym_LF] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(1420),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_AMP_GT] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [anon_sym_LT_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_AMP] = ACTIONS(1403),
    [ts_builtin_sym_end] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1403),
    [anon_sym_PIPE_AMP] = ACTIONS(1403),
  },
  [315] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_EQ_TILDE] = ACTIONS(1434),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [ts_builtin_sym_end] = ACTIONS(1436),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [316] = {
    [aux_sym_concatenation_repeat1] = STATE(702),
    [anon_sym_BQUOTE] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(435),
    [anon_sym_DOLLAR] = ACTIONS(437),
    [anon_sym_RPAREN] = ACTIONS(435),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(435),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(435),
    [anon_sym_GT_LPAREN] = ACTIONS(435),
    [sym_variable_name] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(435),
    [anon_sym_GT_AMP] = ACTIONS(435),
    [sym__concat] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(435),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(435),
  },
  [317] = {
    [aux_sym_concatenation_repeat1] = STATE(702),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_AMP_GT_GT] = ACTIONS(221),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [sym_variable_name] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [sym_word] = ACTIONS(221),
    [anon_sym_GT_AMP] = ACTIONS(221),
    [sym__concat] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(221),
    [anon_sym_GT_GT] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(221),
  },
  [318] = {
    [aux_sym__literal_repeat1] = STATE(703),
    [anon_sym_BQUOTE] = ACTIONS(459),
    [anon_sym_AMP_GT_GT] = ACTIONS(459),
    [sym_raw_string] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(459),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(459),
    [anon_sym_GT_LPAREN] = ACTIONS(459),
    [sym_variable_name] = ACTIONS(459),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [sym_word] = ACTIONS(459),
    [anon_sym_GT_AMP] = ACTIONS(459),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(459),
    [anon_sym_GT_GT] = ACTIONS(459),
    [anon_sym_LT_LPAREN] = ACTIONS(459),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(463),
  },
  [319] = {
    [sym_process_substitution] = STATE(704),
    [aux_sym__literal_repeat1] = STATE(705),
    [sym_simple_expansion] = STATE(704),
    [sym_string_expansion] = STATE(704),
    [sym_expansion] = STATE(704),
    [sym_concatenation] = STATE(528),
    [sym_string] = STATE(704),
    [sym_command_substitution] = STATE(704),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(1438),
    [sym_raw_string] = ACTIONS(1438),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [320] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_EQ_TILDE] = ACTIONS(1440),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [321] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(706),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [322] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(709),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(709),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1448),
    [anon_sym_COLON_DASH] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(1450),
  },
  [323] = {
    [aux_sym_concatenation_repeat1] = STATE(711),
    [anon_sym_BQUOTE] = ACTIONS(1452),
    [sym_raw_string] = ACTIONS(1452),
    [anon_sym_COLON_QMARK] = ACTIONS(1454),
    [anon_sym_DOLLAR] = ACTIONS(1454),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1452),
    [anon_sym_EQ] = ACTIONS(1454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1454),
    [anon_sym_COLON] = ACTIONS(1454),
    [anon_sym_GT_LPAREN] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [sym_word] = ACTIONS(1454),
    [sym__concat] = ACTIONS(1456),
    [anon_sym_LT_LPAREN] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1452),
    [anon_sym_COLON_DASH] = ACTIONS(1454),
    [sym__special_character] = ACTIONS(1454),
  },
  [324] = {
    [sym_string] = STATE(713),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [anon_sym_STAR] = ACTIONS(1458),
    [anon_sym_QMARK] = ACTIONS(1458),
    [sym_raw_string] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(1458),
    [anon_sym_DOLLAR] = ACTIONS(1462),
    [anon_sym_POUND] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_0] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1464),
    [anon_sym__] = ACTIONS(1464),
  },
  [325] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(715),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [326] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(716),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(717),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [327] = {
    [sym_subscript] = STATE(718),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_QMARK] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_AT] = ACTIONS(1466),
    [sym_variable_name] = ACTIONS(1470),
    [anon_sym_DOLLAR] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_0] = ACTIONS(1474),
    [anon_sym_POUND] = ACTIONS(1468),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1474),
    [anon_sym__] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_EQ_TILDE] = ACTIONS(1476),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [ts_builtin_sym_end] = ACTIONS(1478),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [329] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(724),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1480),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [330] = {
    [aux_sym_concatenation_repeat1] = STATE(711),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_COLON_QMARK] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_RBRACE] = ACTIONS(221),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [sym_word] = ACTIONS(219),
    [sym__concat] = ACTIONS(1456),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(221),
    [anon_sym_COLON_DASH] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
  },
  [331] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [332] = {
    [aux_sym__literal_repeat1] = STATE(727),
    [anon_sym_BQUOTE] = ACTIONS(1488),
    [sym_raw_string] = ACTIONS(1488),
    [anon_sym_COLON_QMARK] = ACTIONS(1490),
    [anon_sym_DOLLAR] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1488),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1488),
    [anon_sym_PERCENT] = ACTIONS(1490),
    [anon_sym_COLON] = ACTIONS(1490),
    [anon_sym_GT_LPAREN] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [sym_word] = ACTIONS(1490),
    [anon_sym_LT_LPAREN] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1488),
    [anon_sym_COLON_DASH] = ACTIONS(1490),
    [sym__special_character] = ACTIONS(1492),
  },
  [333] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(709),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(709),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1494),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1444),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1448),
    [anon_sym_COLON_DASH] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(599),
  },
  [334] = {
    [anon_sym_EQ] = ACTIONS(1496),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [335] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(732),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(732),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1498),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1500),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1502),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1500),
    [anon_sym_PERCENT] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1504),
    [anon_sym_COLON_DASH] = ACTIONS(1500),
    [sym__special_character] = ACTIONS(599),
  },
  [336] = {
    [sym_process_substitution] = STATE(735),
    [aux_sym__literal_repeat1] = STATE(742),
    [sym_simple_expansion] = STATE(735),
    [sym_string_expansion] = STATE(735),
    [sym_expansion] = STATE(735),
    [sym_concatenation] = STATE(741),
    [sym_string] = STATE(735),
    [sym_command_substitution] = STATE(735),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(1510),
    [sym_raw_string] = ACTIONS(1510),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [337] = {
    [sym_process_substitution] = STATE(743),
    [aux_sym__literal_repeat1] = STATE(745),
    [sym_simple_expansion] = STATE(743),
    [sym_string_expansion] = STATE(743),
    [sym_expansion] = STATE(743),
    [sym_concatenation] = STATE(744),
    [sym_string] = STATE(743),
    [sym_command_substitution] = STATE(743),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(1522),
    [sym_raw_string] = ACTIONS(1522),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [338] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(748),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(748),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1524),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1524),
    [anon_sym_PERCENT] = ACTIONS(1524),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1528),
    [anon_sym_COLON_DASH] = ACTIONS(1524),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(1530),
  },
  [339] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1532),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [ts_builtin_sym_end] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [340] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [341] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1536),
  },
  [342] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [sym_file_descriptor] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1538),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(1538),
    [anon_sym_fi] = ACTIONS(1538),
    [anon_sym_else] = ACTIONS(1538),
    [anon_sym_done] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [ts_builtin_sym_end] = ACTIONS(1540),
    [anon_sym_LT_LT_LT] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP] = ACTIONS(1538),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_esac] = ACTIONS(1538),
    [anon_sym_SEMI_SEMI] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
  },
  [343] = {
    [sym_compound_statement] = STATE(750),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
  },
  [344] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [345] = {
    [sym_process_substitution] = STATE(344),
    [sym_string_expansion] = STATE(344),
    [sym_expansion] = STATE(344),
    [sym_simple_expansion] = STATE(344),
    [sym_string] = STATE(344),
    [sym_command_substitution] = STATE(344),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(625),
    [sym_raw_string] = ACTIONS(625),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(1546),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
  },
  [346] = {
    [aux_sym_concatenation_repeat1] = STATE(346),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1548),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [347] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1551),
  },
  [348] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(753),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [349] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(756),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1553),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [350] = {
    [aux_sym_concatenation_repeat1] = STATE(758),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(1557),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [351] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(759),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [352] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(1559),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(1559),
  },
  [353] = {
    [sym_string] = STATE(762),
    [anon_sym_DQUOTE] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1563),
    [anon_sym_QMARK] = ACTIONS(1563),
    [sym_raw_string] = ACTIONS(1565),
    [anon_sym_AT] = ACTIONS(1563),
    [anon_sym_DOLLAR] = ACTIONS(1567),
    [anon_sym_POUND] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_0] = ACTIONS(1569),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1569),
  },
  [354] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(764),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(765),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [355] = {
    [aux_sym_concatenation_repeat1] = STATE(758),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(1557),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [356] = {
    [sym_subscript] = STATE(766),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_QMARK] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_AT] = ACTIONS(1571),
    [sym_variable_name] = ACTIONS(1575),
    [anon_sym_DOLLAR] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_0] = ACTIONS(1579),
    [anon_sym_POUND] = ACTIONS(1573),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1579),
    [anon_sym__] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [aux_sym__literal_repeat1] = STATE(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(497),
    [anon_sym_DOLLAR] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(497),
    [anon_sym_GT_LPAREN] = ACTIONS(497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(497),
    [aux_sym__simple_variable_name_token1] = ACTIONS(497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [sym_word] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(497),
    [anon_sym_LT_AMP] = ACTIONS(497),
    [anon_sym_GT_GT] = ACTIONS(497),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_LT_LT_DASH] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(497),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(497),
    [sym_raw_string] = ACTIONS(497),
    [sym_variable_name] = ACTIONS(501),
    [sym_file_descriptor] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(497),
    [anon_sym_GT] = ACTIONS(497),
    [anon_sym_AMP_GT] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(497),
    [anon_sym_LT_LT_LT] = ACTIONS(497),
    [anon_sym_GT_AMP] = ACTIONS(497),
    [anon_sym_LT_LPAREN] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [anon_sym_PIPE_AMP] = ACTIONS(497),
  },
  [358] = {
    [sym_process_substitution] = STATE(350),
    [sym_string] = STATE(350),
    [sym_command_substitution] = STATE(350),
    [sym_simple_expansion] = STATE(350),
    [sym_variable_assignment] = STATE(772),
    [sym_subscript] = STATE(359),
    [sym_string_expansion] = STATE(350),
    [sym_expansion] = STATE(350),
    [sym_concatenation] = STATE(772),
    [aux_sym_declaration_command_repeat1] = STATE(772),
    [aux_sym__literal_repeat1] = STATE(357),
    [anon_sym_AMP_GT_GT] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(633),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(637),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(641),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [sym_word] = ACTIONS(643),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_LT_AMP] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [sym__special_character] = ACTIONS(645),
    [anon_sym_LT_LT_DASH] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(647),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_raw_string] = ACTIONS(643),
    [sym_variable_name] = ACTIONS(649),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_AMP_GT] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(651),
    [anon_sym_LT_LT_LT] = ACTIONS(503),
    [anon_sym_GT_AMP] = ACTIONS(503),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
  },
  [359] = {
    [anon_sym_EQ] = ACTIONS(1559),
    [anon_sym_PLUS_EQ] = ACTIONS(1559),
    [sym_comment] = ACTIONS(51),
  },
  [360] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(773),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [361] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(776),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1585),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [362] = {
    [aux_sym_concatenation_repeat1] = STATE(778),
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(1589),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(517),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [363] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(779),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [364] = {
    [sym_string] = STATE(781),
    [anon_sym_DQUOTE] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_QMARK] = ACTIONS(1593),
    [sym_raw_string] = ACTIONS(1595),
    [anon_sym_AT] = ACTIONS(1593),
    [anon_sym_DOLLAR] = ACTIONS(1597),
    [anon_sym_POUND] = ACTIONS(1597),
    [anon_sym_DASH] = ACTIONS(1597),
    [anon_sym_0] = ACTIONS(1599),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1599),
    [anon_sym__] = ACTIONS(1599),
  },
  [365] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(783),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(784),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [366] = {
    [aux_sym_concatenation_repeat1] = STATE(778),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(1589),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [367] = {
    [sym_subscript] = STATE(785),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_QMARK] = ACTIONS(1601),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_AT] = ACTIONS(1601),
    [sym_variable_name] = ACTIONS(1605),
    [anon_sym_DOLLAR] = ACTIONS(1607),
    [anon_sym_DASH] = ACTIONS(1607),
    [anon_sym_0] = ACTIONS(1609),
    [anon_sym_POUND] = ACTIONS(1603),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1609),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [aux_sym__literal_repeat1] = STATE(790),
    [anon_sym_AMP_GT_GT] = ACTIONS(539),
    [anon_sym_DOLLAR] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_GT_LPAREN] = ACTIONS(539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(539),
    [aux_sym__simple_variable_name_token1] = ACTIONS(539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [sym_word] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_LT_AMP] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(539),
    [sym__special_character] = ACTIONS(1611),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_raw_string] = ACTIONS(539),
    [sym_file_descriptor] = ACTIONS(543),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_GT] = ACTIONS(539),
    [anon_sym_AMP_GT] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_LT_LT_LT] = ACTIONS(539),
    [anon_sym_GT_AMP] = ACTIONS(539),
    [anon_sym_LT_LPAREN] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_SEMI_SEMI] = ACTIONS(539),
    [anon_sym_PIPE_AMP] = ACTIONS(539),
  },
  [369] = {
    [sym_process_substitution] = STATE(362),
    [sym_command_substitution] = STATE(362),
    [aux_sym_unset_command_repeat1] = STATE(791),
    [sym_simple_expansion] = STATE(362),
    [sym_string_expansion] = STATE(362),
    [sym_expansion] = STATE(362),
    [sym_concatenation] = STATE(791),
    [sym_string] = STATE(362),
    [aux_sym__literal_repeat1] = STATE(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(545),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(545),
    [anon_sym_GT_LPAREN] = ACTIONS(655),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(657),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_word] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_LT_AMP] = ACTIONS(545),
    [anon_sym_GT_GT] = ACTIONS(545),
    [sym__special_character] = ACTIONS(665),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_BQUOTE] = ACTIONS(667),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(545),
    [sym_raw_string] = ACTIONS(663),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_AMP_GT] = ACTIONS(545),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(545),
    [anon_sym_GT_AMP] = ACTIONS(545),
    [anon_sym_LT_LPAREN] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
  },
  [370] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [371] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(555),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_EQ_EQ] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [372] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [373] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1615),
  },
  [374] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [375] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1617),
  },
  [376] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(796),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(796),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1619),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1621),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1623),
    [anon_sym_DASH] = ACTIONS(1621),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1621),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1621),
    [anon_sym_PERCENT] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1625),
    [anon_sym_COLON_DASH] = ACTIONS(1621),
    [sym__special_character] = ACTIONS(599),
  },
  [377] = {
    [sym_subscript] = STATE(797),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(1627),
    [anon_sym_AT] = ACTIONS(1627),
    [sym_variable_name] = ACTIONS(1629),
    [anon_sym_DOLLAR] = ACTIONS(1631),
    [anon_sym_DASH] = ACTIONS(1631),
    [anon_sym_0] = ACTIONS(1633),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1633),
    [anon_sym__] = ACTIONS(1633),
  },
  [378] = {
    [anon_sym_EQ] = ACTIONS(1635),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [379] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(803),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(803),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1637),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DASH] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1639),
    [anon_sym_PERCENT] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1643),
    [anon_sym_COLON_DASH] = ACTIONS(1639),
    [sym__special_character] = ACTIONS(599),
  },
  [380] = {
    [sym_compound_statement] = STATE(805),
    [anon_sym_LPAREN] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(189),
    [sym_comment] = ACTIONS(51),
  },
  [381] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1647),
  },
  [382] = {
    [sym_process_substitution] = STATE(807),
    [sym_string_expansion] = STATE(807),
    [sym_expansion] = STATE(807),
    [sym_simple_expansion] = STATE(807),
    [sym_string] = STATE(807),
    [sym_command_substitution] = STATE(807),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_word] = ACTIONS(1649),
    [sym_raw_string] = ACTIONS(1649),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [sym__special_character] = ACTIONS(1649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
  },
  [383] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(1651),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [384] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(701),
    [anon_sym_AMP_GT_GT] = ACTIONS(701),
    [anon_sym_LF] = ACTIONS(703),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_LT_LT] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_GT] = ACTIONS(701),
    [sym_file_descriptor] = ACTIONS(703),
    [anon_sym_AMP_GT] = ACTIONS(701),
    [anon_sym_PIPE_PIPE] = ACTIONS(701),
    [anon_sym_LT_LT_LT] = ACTIONS(701),
    [anon_sym_PIPE] = ACTIONS(701),
    [anon_sym_GT_AMP] = ACTIONS(701),
    [anon_sym_LT] = ACTIONS(701),
    [anon_sym_LT_AMP] = ACTIONS(701),
    [anon_sym_GT_GT] = ACTIONS(701),
    [anon_sym_AMP] = ACTIONS(701),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(701),
    [anon_sym_SEMI_SEMI] = ACTIONS(701),
    [anon_sym_PIPE_AMP] = ACTIONS(701),
  },
  [385] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1653),
  },
  [386] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(1655),
  },
  [387] = {
    [aux_sym_concatenation_repeat1] = STATE(454),
    [anon_sym_SEMI_SEMI] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(793),
    [anon_sym_LF] = ACTIONS(1659),
    [anon_sym_AMP] = ACTIONS(1657),
    [anon_sym_SEMI] = ACTIONS(1657),
    [anon_sym_in] = ACTIONS(1661),
  },
  [388] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1659),
    [anon_sym_AMP] = ACTIONS(1657),
    [anon_sym_SEMI] = ACTIONS(1657),
    [anon_sym_in] = ACTIONS(1661),
  },
  [389] = {
    [aux_sym__literal_repeat1] = STATE(468),
    [anon_sym_in] = ACTIONS(1663),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [sym__special_character] = ACTIONS(823),
  },
  [390] = {
    [anon_sym_BANG_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [sym_test_operator] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1669),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_GT_EQ] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_DASH_EQ] = ACTIONS(869),
  },
  [391] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1617),
  },
  [392] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(899),
    [anon_sym_AMP_GT_GT] = ACTIONS(899),
    [anon_sym_LF] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_GT] = ACTIONS(899),
    [sym_file_descriptor] = ACTIONS(901),
    [anon_sym_AMP_GT] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_LT_LT_LT] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_GT_AMP] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_LT_AMP] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_SEMI_SEMI] = ACTIONS(899),
    [anon_sym_PIPE_AMP] = ACTIONS(899),
  },
  [393] = {
    [sym_process_substitution] = STATE(820),
    [aux_sym__literal_repeat1] = STATE(827),
    [sym_array] = STATE(826),
    [sym_simple_expansion] = STATE(820),
    [sym_string_expansion] = STATE(820),
    [sym_expansion] = STATE(820),
    [sym_concatenation] = STATE(826),
    [sym_string] = STATE(820),
    [sym_command_substitution] = STATE(820),
    [anon_sym_LPAREN] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1677),
    [sym_raw_string] = ACTIONS(1677),
    [anon_sym_LT_LPAREN] = ACTIONS(1679),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1685),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1687),
    [sym__empty_value] = ACTIONS(1689),
  },
  [394] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(1691),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [396] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1693),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [397] = {
    [anon_sym_AMP] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1697),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1699),
    [anon_sym_SEMI_SEMI] = ACTIONS(1695),
  },
  [398] = {
    [sym_process_substitution] = STATE(549),
    [sym_postfix_expression] = STATE(833),
    [sym_parenthesized_expression] = STATE(833),
    [sym_command_substitution] = STATE(549),
    [sym_simple_expansion] = STATE(549),
    [sym__expression] = STATE(833),
    [sym_string_expansion] = STATE(549),
    [sym_expansion] = STATE(549),
    [sym_binary_expression] = STATE(833),
    [sym_unary_expression] = STATE(833),
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(549),
    [aux_sym__literal_repeat1] = STATE(557),
    [sym_test_operator] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [sym_raw_string] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(1701),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [anon_sym_GT_LPAREN] = ACTIONS(981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_word] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_LT_LPAREN] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(1701),
  },
  [399] = {
    [sym_do_group] = STATE(835),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(1703),
  },
  [400] = {
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_PLUS_EQ] = ACTIONS(1019),
    [sym_test_operator] = ACTIONS(1019),
    [anon_sym_PLUS_PLUS] = ACTIONS(1021),
    [anon_sym_RBRACK] = ACTIONS(1669),
    [anon_sym_DASH] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_DASH_EQ] = ACTIONS(1019),
  },
  [401] = {
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [sym_test_operator] = ACTIONS(1029),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_EQ_EQ] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1029),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1669),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_LT] = ACTIONS(1031),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
  },
  [402] = {
    [sym_redirected_statement] = STATE(836),
    [sym_if_statement] = STATE(836),
    [sym_function_definition] = STATE(836),
    [sym_compound_statement] = STATE(836),
    [sym_test_command] = STATE(836),
    [sym_declaration_command] = STATE(836),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(127),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_for_statement] = STATE(836),
    [sym_c_style_for_statement] = STATE(836),
    [sym_case_statement] = STATE(836),
    [sym_subshell] = STATE(836),
    [sym_pipeline] = STATE(836),
    [sym_unset_command] = STATE(836),
    [sym_command] = STATE(836),
    [sym_simple_expansion] = STATE(114),
    [sym_while_statement] = STATE(836),
    [sym_list] = STATE(836),
    [sym_negated_command] = STATE(836),
    [sym_command_name] = STATE(129),
    [sym_variable_assignment] = STATE(837),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(132),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(173),
    [anon_sym_typeset] = ACTIONS(173),
    [anon_sym_unsetenv] = ACTIONS(175),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(185),
    [sym_word] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(173),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(197),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_declare] = ACTIONS(173),
    [sym_variable_name] = ACTIONS(205),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(173),
    [anon_sym_unset] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(215),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(217),
  },
  [403] = {
    [sym_process_substitution] = STATE(840),
    [aux_sym__literal_repeat1] = STATE(847),
    [sym_simple_expansion] = STATE(840),
    [sym_string_expansion] = STATE(840),
    [sym_expansion] = STATE(840),
    [sym_concatenation] = STATE(846),
    [sym_string] = STATE(840),
    [sym_command_substitution] = STATE(840),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1707),
    [sym_word] = ACTIONS(1709),
    [sym_raw_string] = ACTIONS(1709),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1715),
    [sym__special_character] = ACTIONS(1717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1719),
  },
  [404] = {
    [sym_heredoc_body] = STATE(850),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1721),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1723),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [405] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [406] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1725),
    [anon_sym_GT_AMP] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1727),
    [anon_sym_LT_AMP] = ACTIONS(1725),
    [anon_sym_GT_GT] = ACTIONS(1725),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1727),
    [anon_sym_AMP_GT] = ACTIONS(1727),
  },
  [407] = {
    [sym_heredoc_start] = ACTIONS(1729),
    [sym_comment] = ACTIONS(51),
  },
  [408] = {
    [sym_redirected_statement] = STATE(853),
    [sym_if_statement] = STATE(853),
    [sym_function_definition] = STATE(853),
    [sym_compound_statement] = STATE(853),
    [sym_test_command] = STATE(853),
    [sym_declaration_command] = STATE(853),
    [sym_subscript] = STATE(125),
    [sym_file_redirect] = STATE(127),
    [sym_concatenation] = STATE(126),
    [sym_string] = STATE(114),
    [sym_command_substitution] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [aux_sym_command_repeat1] = STATE(127),
    [sym_for_statement] = STATE(853),
    [sym_c_style_for_statement] = STATE(853),
    [sym_case_statement] = STATE(853),
    [sym_subshell] = STATE(853),
    [sym_pipeline] = STATE(853),
    [sym_unset_command] = STATE(853),
    [sym_command] = STATE(853),
    [sym_simple_expansion] = STATE(114),
    [sym_while_statement] = STATE(853),
    [sym_list] = STATE(853),
    [sym_negated_command] = STATE(853),
    [sym_command_name] = STATE(129),
    [sym_variable_assignment] = STATE(854),
    [sym_string_expansion] = STATE(114),
    [sym_expansion] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(132),
    [anon_sym_LPAREN] = ACTIONS(171),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(173),
    [anon_sym_typeset] = ACTIONS(173),
    [anon_sym_unsetenv] = ACTIONS(175),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(185),
    [sym_word] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(173),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_if] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(197),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_declare] = ACTIONS(173),
    [sym_variable_name] = ACTIONS(205),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(173),
    [anon_sym_unset] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(211),
    [anon_sym_while] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(215),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(217),
  },
  [409] = {
    [sym_process_substitution] = STATE(855),
    [aux_sym__literal_repeat1] = STATE(857),
    [sym_simple_expansion] = STATE(855),
    [sym_string_expansion] = STATE(855),
    [sym_expansion] = STATE(855),
    [sym_concatenation] = STATE(856),
    [sym_string] = STATE(855),
    [sym_command_substitution] = STATE(855),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1707),
    [sym_word] = ACTIONS(1731),
    [sym_raw_string] = ACTIONS(1731),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1715),
    [sym__special_character] = ACTIONS(1717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1719),
  },
  [410] = {
    [aux_sym_redirected_statement_repeat1] = STATE(858),
    [sym_file_redirect] = STATE(858),
    [sym_herestring_redirect] = STATE(858),
    [sym_heredoc_redirect] = STATE(858),
    [anon_sym_LT_LT_DASH] = ACTIONS(721),
    [anon_sym_AMP_GT_GT] = ACTIONS(715),
    [anon_sym_LF] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(715),
    [sym_file_descriptor] = ACTIONS(719),
    [anon_sym_AMP_GT] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(715),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_AMP] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
  },
  [411] = {
    [sym_process_substitution] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [aux_sym_command_repeat2] = STATE(859),
    [sym_concatenation] = STATE(859),
    [sym_string] = STATE(413),
    [aux_sym__literal_repeat1] = STATE(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(741),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(743),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [412] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1733),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1735),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1735),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_RPAREN] = ACTIONS(1733),
    [anon_sym_AMP_GT] = ACTIONS(1733),
    [anon_sym_fi] = ACTIONS(1733),
    [anon_sym_else] = ACTIONS(1733),
    [anon_sym_done] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [ts_builtin_sym_end] = ACTIONS(1735),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_esac] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
  },
  [413] = {
    [aux_sym_concatenation_repeat1] = STATE(383),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [sym__concat] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [sym__special_character] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
  },
  [414] = {
    [sym_process_substitution] = STATE(860),
    [aux_sym__literal_repeat1] = STATE(862),
    [sym_simple_expansion] = STATE(860),
    [sym_string_expansion] = STATE(860),
    [sym_expansion] = STATE(860),
    [sym_concatenation] = STATE(861),
    [sym_string] = STATE(860),
    [sym_command_substitution] = STATE(860),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_word] = ACTIONS(1737),
    [sym_raw_string] = ACTIONS(1737),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [sym__special_character] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
    [sym_regex] = ACTIONS(1739),
  },
  [415] = {
    [aux_sym__literal_repeat1] = STATE(420),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(747),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
  },
  [416] = {
    [sym_process_substitution] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [aux_sym_command_repeat2] = STATE(863),
    [sym_concatenation] = STATE(863),
    [sym_string] = STATE(413),
    [aux_sym__literal_repeat1] = STATE(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(741),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(743),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [417] = {
    [aux_sym_redirected_statement_repeat1] = STATE(410),
    [sym_file_redirect] = STATE(410),
    [sym_herestring_redirect] = STATE(410),
    [sym_heredoc_redirect] = STATE(410),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
    [anon_sym_AMP_GT_GT] = ACTIONS(715),
    [anon_sym_LF] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(1743),
    [sym_file_descriptor] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(1220),
    [anon_sym_LT_LT] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_AMP_GT] = ACTIONS(715),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_LT_LT_LT] = ACTIONS(725),
    [anon_sym_GT_AMP] = ACTIONS(715),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_LT_AMP] = ACTIONS(715),
    [anon_sym_GT_GT] = ACTIONS(715),
    [anon_sym_AMP] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_SEMI_SEMI] = ACTIONS(1743),
    [anon_sym_LT_LT_DASH] = ACTIONS(721),
  },
  [418] = {
    [aux_sym_redirected_statement_repeat1] = STATE(410),
    [sym_file_redirect] = STATE(410),
    [sym_herestring_redirect] = STATE(410),
    [sym_heredoc_redirect] = STATE(410),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(721),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(1743),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(721),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(1743),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(1220),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(725),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_SEMI_SEMI] = ACTIONS(1743),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
  },
  [419] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [420] = {
    [aux_sym__literal_repeat1] = STATE(420),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_EQ_TILDE] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1745),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [421] = {
    [aux_sym_concatenation_repeat1] = STATE(866),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(471),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [422] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(1748),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(1748),
  },
  [423] = {
    [aux_sym_concatenation_repeat1] = STATE(866),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(471),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [424] = {
    [aux_sym__literal_repeat1] = STATE(868),
    [anon_sym_AMP_GT_GT] = ACTIONS(497),
    [anon_sym_DOLLAR] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(497),
    [anon_sym_GT_LPAREN] = ACTIONS(497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(497),
    [aux_sym__simple_variable_name_token1] = ACTIONS(497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [sym_word] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(497),
    [anon_sym_LT_AMP] = ACTIONS(497),
    [anon_sym_GT_GT] = ACTIONS(497),
    [sym__special_character] = ACTIONS(499),
    [anon_sym_LT_LT_DASH] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(497),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(497),
    [sym_raw_string] = ACTIONS(497),
    [sym_variable_name] = ACTIONS(501),
    [sym_file_descriptor] = ACTIONS(501),
    [anon_sym_GT] = ACTIONS(497),
    [anon_sym_AMP_GT] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(497),
    [anon_sym_LT_LT_LT] = ACTIONS(497),
    [anon_sym_GT_AMP] = ACTIONS(497),
    [anon_sym_LT_LPAREN] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [anon_sym_PIPE_AMP] = ACTIONS(497),
  },
  [425] = {
    [sym_process_substitution] = STATE(421),
    [sym_string] = STATE(421),
    [sym_command_substitution] = STATE(421),
    [sym_simple_expansion] = STATE(421),
    [sym_variable_assignment] = STATE(869),
    [sym_subscript] = STATE(426),
    [sym_string_expansion] = STATE(421),
    [sym_expansion] = STATE(421),
    [sym_concatenation] = STATE(869),
    [aux_sym_declaration_command_repeat1] = STATE(869),
    [aux_sym__literal_repeat1] = STATE(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [sym_word] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_LT_AMP] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [sym__special_character] = ACTIONS(753),
    [anon_sym_LT_LT_DASH] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_raw_string] = ACTIONS(751),
    [sym_variable_name] = ACTIONS(755),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_AMP_GT] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(503),
    [anon_sym_GT_AMP] = ACTIONS(503),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
  },
  [426] = {
    [anon_sym_EQ] = ACTIONS(1748),
    [anon_sym_PLUS_EQ] = ACTIONS(1748),
    [sym_comment] = ACTIONS(51),
  },
  [427] = {
    [aux_sym_concatenation_repeat1] = STATE(870),
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [428] = {
    [aux_sym_concatenation_repeat1] = STATE(870),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [429] = {
    [aux_sym__literal_repeat1] = STATE(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(539),
    [anon_sym_DOLLAR] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_GT_LPAREN] = ACTIONS(539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(539),
    [aux_sym__simple_variable_name_token1] = ACTIONS(539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [sym_word] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_LT_AMP] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(539),
    [sym__special_character] = ACTIONS(541),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_raw_string] = ACTIONS(539),
    [sym_file_descriptor] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(539),
    [anon_sym_AMP_GT] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_LT_LT_LT] = ACTIONS(539),
    [anon_sym_GT_AMP] = ACTIONS(539),
    [anon_sym_LT_LPAREN] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_SEMI_SEMI] = ACTIONS(539),
    [anon_sym_PIPE_AMP] = ACTIONS(539),
  },
  [430] = {
    [sym_process_substitution] = STATE(427),
    [sym_command_substitution] = STATE(427),
    [aux_sym_unset_command_repeat1] = STATE(872),
    [sym_simple_expansion] = STATE(427),
    [sym_string_expansion] = STATE(427),
    [sym_expansion] = STATE(427),
    [sym_concatenation] = STATE(872),
    [sym_string] = STATE(427),
    [aux_sym__literal_repeat1] = STATE(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(545),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(545),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_word] = ACTIONS(759),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_LT_AMP] = ACTIONS(545),
    [anon_sym_GT_GT] = ACTIONS(545),
    [sym__special_character] = ACTIONS(761),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(545),
    [sym_raw_string] = ACTIONS(759),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_AMP_GT] = ACTIONS(545),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(545),
    [anon_sym_GT_AMP] = ACTIONS(545),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
  },
  [431] = {
    [aux_sym_concatenation_repeat1] = STATE(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(629),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [432] = {
    [sym_process_substitution] = STATE(874),
    [aux_sym__literal_repeat1] = STATE(876),
    [sym_array] = STATE(521),
    [sym_simple_expansion] = STATE(874),
    [sym_string_expansion] = STATE(874),
    [sym_expansion] = STATE(874),
    [sym_concatenation] = STATE(521),
    [sym_string] = STATE(874),
    [sym_command_substitution] = STATE(874),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(1754),
    [sym_raw_string] = ACTIONS(1754),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(1756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [sym__empty_value] = ACTIONS(921),
  },
  [433] = {
    [sym_redirected_statement] = STATE(877),
    [sym_if_statement] = STATE(877),
    [sym_function_definition] = STATE(877),
    [sym_compound_statement] = STATE(877),
    [sym_test_command] = STATE(877),
    [sym_declaration_command] = STATE(877),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(877),
    [sym_c_style_for_statement] = STATE(877),
    [sym_case_statement] = STATE(877),
    [sym_subshell] = STATE(877),
    [sym_pipeline] = STATE(877),
    [sym_unset_command] = STATE(877),
    [sym_command] = STATE(877),
    [sym_simple_expansion] = STATE(137),
    [sym_while_statement] = STATE(877),
    [sym_list] = STATE(877),
    [sym_negated_command] = STATE(877),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(878),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [434] = {
    [sym_process_substitution] = STATE(879),
    [aux_sym__literal_repeat1] = STATE(881),
    [sym_simple_expansion] = STATE(879),
    [sym_string_expansion] = STATE(879),
    [sym_expansion] = STATE(879),
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(879),
    [sym_command_substitution] = STATE(879),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(1758),
    [sym_raw_string] = ACTIONS(1758),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1760),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [435] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(1762),
    [anon_sym_do] = ACTIONS(1762),
  },
  [436] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1764),
    [anon_sym_GT_AMP] = ACTIONS(1764),
    [anon_sym_LT] = ACTIONS(1766),
    [anon_sym_LT_AMP] = ACTIONS(1764),
    [anon_sym_GT_GT] = ACTIONS(1764),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1766),
    [anon_sym_AMP_GT] = ACTIONS(1766),
  },
  [437] = {
    [sym_redirected_statement] = STATE(883),
    [sym_if_statement] = STATE(883),
    [sym_function_definition] = STATE(883),
    [sym_compound_statement] = STATE(883),
    [sym_test_command] = STATE(883),
    [sym_declaration_command] = STATE(883),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(883),
    [sym_c_style_for_statement] = STATE(883),
    [sym_case_statement] = STATE(883),
    [sym_subshell] = STATE(883),
    [sym_pipeline] = STATE(883),
    [sym_unset_command] = STATE(883),
    [sym_command] = STATE(883),
    [sym_simple_expansion] = STATE(137),
    [sym_while_statement] = STATE(883),
    [sym_list] = STATE(883),
    [sym_negated_command] = STATE(883),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(884),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [438] = {
    [sym_process_substitution] = STATE(885),
    [aux_sym__literal_repeat1] = STATE(886),
    [sym_simple_expansion] = STATE(885),
    [sym_string_expansion] = STATE(885),
    [sym_expansion] = STATE(885),
    [sym_concatenation] = STATE(609),
    [sym_string] = STATE(885),
    [sym_command_substitution] = STATE(885),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(1768),
    [sym_raw_string] = ACTIONS(1768),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1760),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [439] = {
    [aux_sym_redirected_statement_repeat1] = STATE(887),
    [sym_file_redirect] = STATE(887),
    [sym_herestring_redirect] = STATE(887),
    [sym_heredoc_redirect] = STATE(887),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(351),
    [sym_file_descriptor] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_AMP] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
  },
  [440] = {
    [sym_process_substitution] = STATE(442),
    [sym_command_substitution] = STATE(442),
    [sym_simple_expansion] = STATE(442),
    [sym_string_expansion] = STATE(442),
    [sym_expansion] = STATE(442),
    [aux_sym_command_repeat2] = STATE(888),
    [sym_concatenation] = STATE(888),
    [sym_string] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(444),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [441] = {
    [sym_redirected_statement] = STATE(905),
    [sym_if_statement] = STATE(905),
    [sym_elif_clause] = STATE(910),
    [sym_function_definition] = STATE(905),
    [sym_compound_statement] = STATE(905),
    [sym_test_command] = STATE(905),
    [sym_declaration_command] = STATE(905),
    [sym_subscript] = STATE(906),
    [sym_file_redirect] = STATE(908),
    [sym_concatenation] = STATE(907),
    [sym_string] = STATE(899),
    [sym_command_substitution] = STATE(899),
    [sym_process_substitution] = STATE(899),
    [aux_sym_command_repeat1] = STATE(908),
    [sym_for_statement] = STATE(905),
    [sym_c_style_for_statement] = STATE(905),
    [sym_else_clause] = STATE(909),
    [sym_case_statement] = STATE(905),
    [sym_subshell] = STATE(905),
    [sym_pipeline] = STATE(905),
    [sym_unset_command] = STATE(905),
    [sym_command] = STATE(905),
    [sym_simple_expansion] = STATE(899),
    [aux_sym_if_statement_repeat1] = STATE(910),
    [sym__statements] = STATE(911),
    [sym_while_statement] = STATE(905),
    [sym_list] = STATE(905),
    [sym_negated_command] = STATE(905),
    [sym_command_name] = STATE(912),
    [sym_variable_assignment] = STATE(913),
    [sym_string_expansion] = STATE(899),
    [sym_expansion] = STATE(899),
    [aux_sym__statements_repeat1] = STATE(914),
    [aux_sym__literal_repeat1] = STATE(915),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1770),
    [anon_sym_typeset] = ACTIONS(1770),
    [anon_sym_unsetenv] = ACTIONS(1772),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [anon_sym_else] = ACTIONS(1780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
    [anon_sym_fi] = ACTIONS(1784),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1770),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(1790),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1770),
    [sym_variable_name] = ACTIONS(1796),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1770),
    [anon_sym_unset] = ACTIONS(1772),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [anon_sym_elif] = ACTIONS(1800),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [442] = {
    [aux_sym_concatenation_repeat1] = STATE(431),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [sym__special_character] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
  },
  [443] = {
    [sym_process_substitution] = STATE(916),
    [aux_sym__literal_repeat1] = STATE(917),
    [sym_simple_expansion] = STATE(916),
    [sym_string_expansion] = STATE(916),
    [sym_expansion] = STATE(916),
    [sym_concatenation] = STATE(614),
    [sym_string] = STATE(916),
    [sym_command_substitution] = STATE(916),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(1802),
    [sym_raw_string] = ACTIONS(1802),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [sym_regex] = ACTIONS(1099),
  },
  [444] = {
    [aux_sym__literal_repeat1] = STATE(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
  },
  [445] = {
    [sym_process_substitution] = STATE(442),
    [sym_command_substitution] = STATE(442),
    [sym_simple_expansion] = STATE(442),
    [sym_string_expansion] = STATE(442),
    [sym_expansion] = STATE(442),
    [aux_sym_command_repeat2] = STATE(918),
    [sym_concatenation] = STATE(918),
    [sym_string] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(444),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [446] = {
    [aux_sym__literal_repeat1] = STATE(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_EQ_TILDE] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1189),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [447] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1804),
  },
  [448] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [449] = {
    [anon_sym_AMP] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(941),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_in] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
  },
  [450] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1808),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [451] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(1810),
  },
  [452] = {
    [sym_process_substitution] = STATE(923),
    [sym_string_expansion] = STATE(923),
    [sym_expansion] = STATE(923),
    [sym_simple_expansion] = STATE(923),
    [sym_string] = STATE(923),
    [sym_command_substitution] = STATE(923),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_word] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(245),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
  },
  [453] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1814),
    [anon_sym_SEMI] = ACTIONS(1816),
    [anon_sym_SEMI_SEMI] = ACTIONS(1816),
    [anon_sym_AMP] = ACTIONS(1816),
  },
  [454] = {
    [aux_sym_concatenation_repeat1] = STATE(926),
    [anon_sym_AMP] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_in] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
  },
  [455] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1820),
  },
  [456] = {
    [anon_sym_AMP] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(553),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [anon_sym_in] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
  },
  [457] = {
    [anon_sym_AMP] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(557),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [anon_sym_in] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
  },
  [458] = {
    [anon_sym_AMP] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(561),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
  },
  [459] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(1804),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [460] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1804),
  },
  [461] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(930),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(930),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1822),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1824),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1826),
    [anon_sym_DASH] = ACTIONS(1824),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1824),
    [anon_sym_PERCENT] = ACTIONS(1824),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1828),
    [anon_sym_COLON_DASH] = ACTIONS(1824),
    [sym__special_character] = ACTIONS(599),
  },
  [462] = {
    [sym_subscript] = STATE(931),
    [anon_sym_STAR] = ACTIONS(1830),
    [anon_sym_QMARK] = ACTIONS(1830),
    [anon_sym_AT] = ACTIONS(1830),
    [sym_variable_name] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [anon_sym_DASH] = ACTIONS(1834),
    [anon_sym_0] = ACTIONS(1836),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1836),
    [anon_sym__] = ACTIONS(1836),
  },
  [463] = {
    [anon_sym_EQ] = ACTIONS(1838),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [464] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(937),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(937),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1840),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1842),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1844),
    [anon_sym_DASH] = ACTIONS(1842),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1842),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1842),
    [anon_sym_PERCENT] = ACTIONS(1842),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1846),
    [anon_sym_COLON_DASH] = ACTIONS(1842),
    [sym__special_character] = ACTIONS(599),
  },
  [465] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(1848),
  },
  [466] = {
    [sym__special_character] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_in] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
  },
  [467] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1850),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_SEMI_SEMI] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1852),
  },
  [468] = {
    [aux_sym__literal_repeat1] = STATE(468),
    [sym__special_character] = ACTIONS(1854),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_in] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
  },
  [469] = {
    [anon_sym_BANG_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [sym_test_operator] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1857),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_GT_EQ] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_DASH_EQ] = ACTIONS(869),
  },
  [470] = {
    [sym_process_substitution] = STATE(471),
    [sym_postfix_expression] = STATE(940),
    [sym_parenthesized_expression] = STATE(940),
    [sym_command_substitution] = STATE(471),
    [sym_simple_expansion] = STATE(471),
    [sym__expression] = STATE(940),
    [sym_string_expansion] = STATE(471),
    [sym_expansion] = STATE(471),
    [sym_binary_expression] = STATE(940),
    [sym_unary_expression] = STATE(940),
    [sym_concatenation] = STATE(940),
    [sym_string] = STATE(471),
    [aux_sym__literal_repeat1] = STATE(473),
    [sym_test_operator] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [471] = {
    [aux_sym_concatenation_repeat1] = STATE(941),
    [anon_sym_BANG_EQ] = ACTIONS(839),
    [anon_sym_PLUS_EQ] = ACTIONS(839),
    [sym_test_operator] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_LT] = ACTIONS(841),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH_EQ] = ACTIONS(839),
  },
  [472] = {
    [aux_sym_concatenation_repeat1] = STATE(941),
    [anon_sym_BANG_EQ] = ACTIONS(221),
    [anon_sym_PLUS_EQ] = ACTIONS(221),
    [sym_test_operator] = ACTIONS(221),
    [anon_sym_PLUS_PLUS] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(221),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_GT_EQ] = ACTIONS(221),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(221),
    [anon_sym_DASH_DASH] = ACTIONS(221),
    [anon_sym_LT_EQ] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [sym__special_character] = ACTIONS(221),
    [anon_sym_DASH_EQ] = ACTIONS(221),
  },
  [473] = {
    [aux_sym__literal_repeat1] = STATE(942),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_PLUS_EQ] = ACTIONS(863),
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_PLUS_PLUS] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(863),
    [anon_sym_DASH_DASH] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_AMP_AMP] = ACTIONS(863),
    [sym__special_character] = ACTIONS(867),
    [anon_sym_DASH_EQ] = ACTIONS(863),
  },
  [474] = {
    [anon_sym_BANG_EQ] = ACTIONS(1859),
    [anon_sym_PLUS_EQ] = ACTIONS(1859),
    [sym_test_operator] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_EQ] = ACTIONS(1863),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_PIPE] = ACTIONS(1859),
    [anon_sym_GT_EQ] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1863),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1865),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(1859),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_DASH_EQ] = ACTIONS(1859),
  },
  [475] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(1867),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [sym_test_operator] = ACTIONS(941),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
  },
  [477] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1869),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [478] = {
    [sym_process_substitution] = STATE(948),
    [sym_string_expansion] = STATE(948),
    [sym_expansion] = STATE(948),
    [sym_simple_expansion] = STATE(948),
    [sym_string] = STATE(948),
    [sym_command_substitution] = STATE(948),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(1871),
    [sym_raw_string] = ACTIONS(1871),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(1871),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [479] = {
    [aux_sym_concatenation_repeat1] = STATE(950),
    [anon_sym_BANG_EQ] = ACTIONS(631),
    [anon_sym_PLUS_EQ] = ACTIONS(631),
    [sym_test_operator] = ACTIONS(631),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_EQ] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(631),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(631),
    [anon_sym_PIPE_PIPE] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(631),
    [sym__concat] = ACTIONS(1873),
    [anon_sym_PLUS] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_LT_EQ] = ACTIONS(631),
    [anon_sym_AMP_AMP] = ACTIONS(631),
    [anon_sym_DASH_EQ] = ACTIONS(631),
  },
  [480] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1875),
  },
  [481] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1877),
  },
  [482] = {
    [anon_sym_BANG_EQ] = ACTIONS(553),
    [anon_sym_PLUS_EQ] = ACTIONS(553),
    [sym_test_operator] = ACTIONS(553),
    [anon_sym_PLUS_PLUS] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_EQ] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(553),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(553),
    [anon_sym_PIPE_PIPE] = ACTIONS(553),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [sym__concat] = ACTIONS(553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(553),
    [anon_sym_DASH_DASH] = ACTIONS(553),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(553),
    [anon_sym_DASH_EQ] = ACTIONS(553),
  },
  [483] = {
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [sym_test_operator] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(557),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_EQ] = ACTIONS(555),
    [anon_sym_EQ_EQ] = ACTIONS(557),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [sym__concat] = ACTIONS(557),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(557),
    [anon_sym_DASH_DASH] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_DASH_EQ] = ACTIONS(557),
  },
  [484] = {
    [anon_sym_BANG_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(561),
    [sym_test_operator] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(561),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(561),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(561),
    [sym__concat] = ACTIONS(561),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_DASH_DASH] = ACTIONS(561),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(561),
  },
  [485] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(1875),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [486] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1875),
  },
  [487] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(955),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(955),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1879),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1881),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1881),
    [anon_sym_PERCENT] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1885),
    [anon_sym_COLON_DASH] = ACTIONS(1881),
    [sym__special_character] = ACTIONS(599),
  },
  [488] = {
    [sym_subscript] = STATE(956),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_QMARK] = ACTIONS(1887),
    [anon_sym_AT] = ACTIONS(1887),
    [sym_variable_name] = ACTIONS(1889),
    [anon_sym_DOLLAR] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_0] = ACTIONS(1893),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1893),
    [anon_sym__] = ACTIONS(1893),
  },
  [489] = {
    [anon_sym_EQ] = ACTIONS(1895),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [490] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(962),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(962),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(1897),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1899),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1899),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1899),
    [anon_sym_PERCENT] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1903),
    [anon_sym_COLON_DASH] = ACTIONS(1899),
    [sym__special_character] = ACTIONS(599),
  },
  [491] = {
    [anon_sym_BANG_EQ] = ACTIONS(221),
    [anon_sym_PLUS_EQ] = ACTIONS(221),
    [sym_test_operator] = ACTIONS(221),
    [anon_sym_PLUS_PLUS] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(221),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_GT_EQ] = ACTIONS(221),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(221),
    [anon_sym_DASH_DASH] = ACTIONS(221),
    [anon_sym_LT_EQ] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_DASH_EQ] = ACTIONS(221),
  },
  [492] = {
    [aux_sym__literal_repeat1] = STATE(492),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [sym_test_operator] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_DASH_DASH] = ACTIONS(1192),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [sym__special_character] = ACTIONS(1905),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
  },
  [493] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(963),
    [sym_parenthesized_expression] = STATE(963),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(963),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(963),
    [sym_unary_expression] = STATE(963),
    [sym_concatenation] = STATE(963),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [494] = {
    [anon_sym_BANG_EQ] = ACTIONS(1908),
    [anon_sym_PLUS_EQ] = ACTIONS(1908),
    [sym_test_operator] = ACTIONS(1908),
    [anon_sym_PLUS_PLUS] = ACTIONS(1908),
    [anon_sym_RPAREN] = ACTIONS(1910),
    [anon_sym_DASH] = ACTIONS(1910),
    [anon_sym_GT] = ACTIONS(1910),
    [anon_sym_EQ] = ACTIONS(1910),
    [anon_sym_EQ_EQ] = ACTIONS(1908),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1908),
    [anon_sym_PIPE_PIPE] = ACTIONS(1908),
    [anon_sym_GT_EQ] = ACTIONS(1908),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1908),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_LT] = ACTIONS(1910),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1908),
    [anon_sym_DASH_DASH] = ACTIONS(1908),
    [anon_sym_LT_EQ] = ACTIONS(1908),
    [anon_sym_AMP_AMP] = ACTIONS(1908),
    [anon_sym_DASH_EQ] = ACTIONS(1908),
  },
  [495] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(963),
    [sym_parenthesized_expression] = STATE(963),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(963),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(963),
    [sym_unary_expression] = STATE(963),
    [sym_concatenation] = STATE(963),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(273),
    [sym_regex] = ACTIONS(1912),
  },
  [496] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_RPAREN] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_fi] = ACTIONS(1914),
    [anon_sym_else] = ACTIONS(1914),
    [anon_sym_done] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(1914),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_esac] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [497] = {
    [sym_process_substitution] = STATE(421),
    [sym_string] = STATE(421),
    [sym_command_substitution] = STATE(421),
    [sym_simple_expansion] = STATE(421),
    [sym_variable_assignment] = STATE(869),
    [sym_subscript] = STATE(426),
    [sym_string_expansion] = STATE(421),
    [sym_expansion] = STATE(421),
    [sym_concatenation] = STATE(869),
    [aux_sym_declaration_command_repeat1] = STATE(869),
    [aux_sym__literal_repeat1] = STATE(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [sym_word] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_LT_AMP] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [sym__special_character] = ACTIONS(753),
    [anon_sym_LT_LT_DASH] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(503),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_raw_string] = ACTIONS(751),
    [sym_variable_name] = ACTIONS(755),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_AMP_GT] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(503),
    [anon_sym_GT_AMP] = ACTIONS(503),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
  },
  [498] = {
    [sym_process_substitution] = STATE(427),
    [sym_command_substitution] = STATE(427),
    [aux_sym_unset_command_repeat1] = STATE(872),
    [sym_simple_expansion] = STATE(427),
    [sym_string_expansion] = STATE(427),
    [sym_expansion] = STATE(427),
    [sym_concatenation] = STATE(872),
    [sym_string] = STATE(427),
    [aux_sym__literal_repeat1] = STATE(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(545),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(545),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_word] = ACTIONS(759),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_LT_AMP] = ACTIONS(545),
    [anon_sym_GT_GT] = ACTIONS(545),
    [sym__special_character] = ACTIONS(761),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_BQUOTE] = ACTIONS(545),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(545),
    [sym_raw_string] = ACTIONS(759),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_AMP_GT] = ACTIONS(545),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(545),
    [anon_sym_GT_AMP] = ACTIONS(545),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
  },
  [499] = {
    [sym_redirected_statement] = STATE(965),
    [sym_if_statement] = STATE(965),
    [sym_function_definition] = STATE(965),
    [sym_compound_statement] = STATE(965),
    [sym_test_command] = STATE(965),
    [sym_declaration_command] = STATE(965),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(965),
    [sym_c_style_for_statement] = STATE(965),
    [sym_case_statement] = STATE(965),
    [sym_subshell] = STATE(965),
    [sym_pipeline] = STATE(965),
    [sym_unset_command] = STATE(965),
    [sym_command] = STATE(965),
    [sym_simple_expansion] = STATE(137),
    [sym_while_statement] = STATE(965),
    [sym_list] = STATE(965),
    [sym_negated_command] = STATE(965),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(966),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [500] = {
    [sym_process_substitution] = STATE(967),
    [aux_sym__literal_repeat1] = STATE(969),
    [sym_simple_expansion] = STATE(967),
    [sym_string_expansion] = STATE(967),
    [sym_expansion] = STATE(967),
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(967),
    [sym_command_substitution] = STATE(967),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1918),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [501] = {
    [sym_heredoc_body] = STATE(970),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [anon_sym_case] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [502] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [anon_sym_case] = ACTIONS(1051),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [503] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1922),
    [anon_sym_GT_AMP] = ACTIONS(1922),
    [anon_sym_LT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1922),
    [anon_sym_GT_GT] = ACTIONS(1922),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1924),
  },
  [504] = {
    [sym_redirected_statement] = STATE(972),
    [sym_if_statement] = STATE(972),
    [sym_function_definition] = STATE(972),
    [sym_compound_statement] = STATE(972),
    [sym_test_command] = STATE(972),
    [sym_declaration_command] = STATE(972),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(972),
    [sym_c_style_for_statement] = STATE(972),
    [sym_case_statement] = STATE(972),
    [sym_subshell] = STATE(972),
    [sym_pipeline] = STATE(972),
    [sym_unset_command] = STATE(972),
    [sym_command] = STATE(972),
    [sym_simple_expansion] = STATE(137),
    [sym_while_statement] = STATE(972),
    [sym_list] = STATE(972),
    [sym_negated_command] = STATE(972),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(973),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [505] = {
    [sym_process_substitution] = STATE(974),
    [aux_sym__literal_repeat1] = STATE(975),
    [sym_simple_expansion] = STATE(974),
    [sym_string_expansion] = STATE(974),
    [sym_expansion] = STATE(974),
    [sym_concatenation] = STATE(609),
    [sym_string] = STATE(974),
    [sym_command_substitution] = STATE(974),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(1926),
    [sym_raw_string] = ACTIONS(1926),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [506] = {
    [aux_sym_redirected_statement_repeat1] = STATE(976),
    [sym_file_redirect] = STATE(976),
    [sym_herestring_redirect] = STATE(976),
    [sym_heredoc_redirect] = STATE(976),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(1071),
    [anon_sym_AMP_GT_GT] = ACTIONS(885),
    [anon_sym_LF] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(351),
    [sym_file_descriptor] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_LT_AMP] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
  },
  [507] = {
    [sym_process_substitution] = STATE(442),
    [sym_command_substitution] = STATE(442),
    [sym_simple_expansion] = STATE(442),
    [sym_string_expansion] = STATE(442),
    [sym_expansion] = STATE(442),
    [aux_sym_command_repeat2] = STATE(977),
    [sym_concatenation] = STATE(977),
    [sym_string] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(444),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [508] = {
    [sym_process_substitution] = STATE(442),
    [sym_command_substitution] = STATE(442),
    [sym_simple_expansion] = STATE(442),
    [sym_string_expansion] = STATE(442),
    [sym_expansion] = STATE(442),
    [aux_sym_command_repeat2] = STATE(918),
    [sym_concatenation] = STATE(918),
    [sym_string] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(444),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [509] = {
    [aux_sym_redirected_statement_repeat1] = STATE(506),
    [sym_file_redirect] = STATE(506),
    [sym_herestring_redirect] = STATE(506),
    [sym_heredoc_redirect] = STATE(506),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_BQUOTE] = ACTIONS(1220),
    [anon_sym_AMP_GT_GT] = ACTIONS(885),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1930),
    [sym_file_descriptor] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(885),
    [anon_sym_AMP_GT] = ACTIONS(885),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [anon_sym_GT_AMP] = ACTIONS(885),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_LT_AMP] = ACTIONS(885),
    [anon_sym_GT_GT] = ACTIONS(885),
    [anon_sym_AMP] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_SEMI_SEMI] = ACTIONS(1930),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
  },
  [510] = {
    [aux_sym_redirected_statement_repeat1] = STATE(506),
    [sym_file_redirect] = STATE(506),
    [sym_herestring_redirect] = STATE(506),
    [sym_heredoc_redirect] = STATE(506),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(1220),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1930),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(893),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_SEMI_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
  },
  [511] = {
    [sym_process_substitution] = STATE(981),
    [aux_sym__literal_repeat1] = STATE(983),
    [sym_array] = STATE(982),
    [sym_simple_expansion] = STATE(981),
    [sym_string_expansion] = STATE(981),
    [sym_expansion] = STATE(981),
    [sym_concatenation] = STATE(982),
    [sym_string] = STATE(981),
    [sym_command_substitution] = STATE(981),
    [anon_sym_LPAREN] = ACTIONS(1932),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(1934),
    [sym_raw_string] = ACTIONS(1934),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
    [sym__empty_value] = ACTIONS(1936),
  },
  [512] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(994),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(994),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(1948),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [513] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(995),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [514] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(998),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(1956),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(1958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [515] = {
    [aux_sym_concatenation_repeat1] = STATE(1000),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(1962),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [516] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1001),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [517] = {
    [sym_string] = STATE(1003),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_QMARK] = ACTIONS(1966),
    [sym_raw_string] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1966),
    [anon_sym_DOLLAR] = ACTIONS(1970),
    [anon_sym_POUND] = ACTIONS(1970),
    [anon_sym_DASH] = ACTIONS(1970),
    [anon_sym_0] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1972),
    [anon_sym__] = ACTIONS(1972),
  },
  [518] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1005),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1006),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [519] = {
    [aux_sym_concatenation_repeat1] = STATE(1000),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(1962),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [520] = {
    [sym_subscript] = STATE(1007),
    [anon_sym_STAR] = ACTIONS(1974),
    [anon_sym_QMARK] = ACTIONS(1974),
    [anon_sym_BANG] = ACTIONS(1976),
    [anon_sym_AT] = ACTIONS(1974),
    [sym_variable_name] = ACTIONS(1978),
    [anon_sym_DOLLAR] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_0] = ACTIONS(1982),
    [anon_sym_POUND] = ACTIONS(1976),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1982),
    [anon_sym__] = ACTIONS(1982),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [522] = {
    [aux_sym__literal_repeat1] = STATE(1012),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(1986),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [ts_builtin_sym_end] = ACTIONS(1988),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [523] = {
    [aux_sym_concatenation_repeat1] = STATE(1015),
    [anon_sym_RBRACK] = ACTIONS(1990),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1992),
  },
  [524] = {
    [aux_sym_concatenation_repeat1] = STATE(1015),
    [anon_sym_RBRACK] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(221),
    [sym__special_character] = ACTIONS(219),
  },
  [525] = {
    [anon_sym_RBRACK] = ACTIONS(1990),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1994),
  },
  [526] = {
    [aux_sym__literal_repeat1] = STATE(1020),
    [anon_sym_RBRACK] = ACTIONS(1996),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1998),
    [sym__special_character] = ACTIONS(2000),
  },
  [527] = {
    [aux_sym_concatenation_repeat1] = STATE(263),
    [anon_sym_BQUOTE] = ACTIONS(2002),
    [anon_sym_AMP_GT_GT] = ACTIONS(2002),
    [sym_raw_string] = ACTIONS(2002),
    [anon_sym_DOLLAR] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [sym_variable_name] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2002),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2002),
    [anon_sym_GT_LPAREN] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [sym_word] = ACTIONS(2002),
    [anon_sym_GT_AMP] = ACTIONS(2002),
    [sym__concat] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2002),
    [anon_sym_GT_GT] = ACTIONS(2002),
    [anon_sym_LT_LPAREN] = ACTIONS(2002),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2002),
  },
  [528] = {
    [anon_sym_BQUOTE] = ACTIONS(2002),
    [anon_sym_AMP_GT_GT] = ACTIONS(2002),
    [sym_raw_string] = ACTIONS(2002),
    [anon_sym_DOLLAR] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [sym_variable_name] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2002),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2002),
    [anon_sym_GT_LPAREN] = ACTIONS(2002),
    [anon_sym_RPAREN] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [sym_word] = ACTIONS(2002),
    [anon_sym_GT_AMP] = ACTIONS(2002),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2002),
    [anon_sym_GT_GT] = ACTIONS(2002),
    [anon_sym_LT_LPAREN] = ACTIONS(2002),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2002),
  },
  [529] = {
    [aux_sym__literal_repeat1] = STATE(275),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [anon_sym_AMP_GT_GT] = ACTIONS(2006),
    [sym_raw_string] = ACTIONS(2006),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [sym_variable_name] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2006),
    [anon_sym_GT_LPAREN] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_word] = ACTIONS(2006),
    [anon_sym_GT_AMP] = ACTIONS(2006),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2006),
    [anon_sym_GT_GT] = ACTIONS(2006),
    [anon_sym_LT_LPAREN] = ACTIONS(2006),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(463),
  },
  [530] = {
    [anon_sym_BQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [sym__concat] = ACTIONS(553),
    [sym__string_content] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(553),
  },
  [531] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2010),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [ts_builtin_sym_end] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [532] = {
    [anon_sym_BQUOTE] = ACTIONS(561),
    [anon_sym_DQUOTE] = ACTIONS(561),
    [sym__concat] = ACTIONS(561),
    [sym__string_content] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(561),
  },
  [533] = {
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [sym__concat] = ACTIONS(2016),
    [sym__string_content] = ACTIONS(2018),
    [anon_sym_DOLLAR] = ACTIONS(2018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2014),
  },
  [534] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2020),
  },
  [535] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(2020),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [536] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2020),
  },
  [537] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1025),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1025),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2022),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2024),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2024),
    [anon_sym_PERCENT] = ACTIONS(2024),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2028),
    [anon_sym_COLON_DASH] = ACTIONS(2024),
    [sym__special_character] = ACTIONS(599),
  },
  [538] = {
    [sym_subscript] = STATE(1026),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_QMARK] = ACTIONS(2030),
    [anon_sym_AT] = ACTIONS(2030),
    [sym_variable_name] = ACTIONS(2032),
    [anon_sym_DOLLAR] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2034),
    [anon_sym_0] = ACTIONS(2036),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2036),
    [anon_sym__] = ACTIONS(2036),
  },
  [539] = {
    [anon_sym_EQ] = ACTIONS(2038),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [540] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1032),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1032),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2040),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2042),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2044),
    [anon_sym_DASH] = ACTIONS(2042),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2042),
    [anon_sym_PERCENT] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2046),
    [anon_sym_COLON_DASH] = ACTIONS(2042),
    [sym__special_character] = ACTIONS(599),
  },
  [541] = {
    [anon_sym_DOLLAR] = ACTIONS(2018),
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2014),
    [sym__string_content] = ACTIONS(2018),
  },
  [542] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(2048),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2050),
    [anon_sym_BQUOTE] = ACTIONS(2053),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2056),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2059),
    [sym__string_content] = ACTIONS(2062),
  },
  [544] = {
    [sym_process_substitution] = STATE(1037),
    [sym_command_substitution] = STATE(1037),
    [aux_sym_for_statement_repeat1] = STATE(1044),
    [sym_simple_expansion] = STATE(1037),
    [sym_string_expansion] = STATE(1037),
    [sym_expansion] = STATE(1037),
    [sym_concatenation] = STATE(1044),
    [sym_string] = STATE(1037),
    [aux_sym__literal_repeat1] = STATE(1043),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [sym_word] = ACTIONS(2069),
    [sym_raw_string] = ACTIONS(2069),
    [anon_sym_LT_LPAREN] = ACTIONS(2071),
    [anon_sym_DOLLAR] = ACTIONS(2073),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2075),
    [sym__special_character] = ACTIONS(2077),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2079),
  },
  [545] = {
    [sym_do_group] = STATE(1045),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(991),
  },
  [546] = {
    [sym_process_substitution] = STATE(549),
    [sym_postfix_expression] = STATE(1046),
    [sym_parenthesized_expression] = STATE(1046),
    [sym_command_substitution] = STATE(549),
    [sym_simple_expansion] = STATE(549),
    [sym__expression] = STATE(1046),
    [sym_string_expansion] = STATE(549),
    [sym_expansion] = STATE(549),
    [sym_binary_expression] = STATE(1046),
    [sym_unary_expression] = STATE(1046),
    [sym_concatenation] = STATE(1046),
    [sym_string] = STATE(549),
    [aux_sym__literal_repeat1] = STATE(557),
    [sym_test_operator] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [sym_word] = ACTIONS(973),
    [sym_raw_string] = ACTIONS(2085),
    [anon_sym_BQUOTE] = ACTIONS(2087),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(2089),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2091),
    [sym__special_character] = ACTIONS(2093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2095),
  },
  [547] = {
    [sym_process_substitution] = STATE(471),
    [sym_postfix_expression] = STATE(1047),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_command_substitution] = STATE(471),
    [sym_simple_expansion] = STATE(471),
    [sym__expression] = STATE(1047),
    [sym_string_expansion] = STATE(471),
    [sym_expansion] = STATE(471),
    [sym_binary_expression] = STATE(1047),
    [sym_unary_expression] = STATE(1047),
    [sym_concatenation] = STATE(1047),
    [sym_string] = STATE(471),
    [aux_sym__literal_repeat1] = STATE(473),
    [sym_test_operator] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [548] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1048),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [549] = {
    [aux_sym_concatenation_repeat1] = STATE(1050),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_PLUS_EQ] = ACTIONS(841),
    [sym_test_operator] = ACTIONS(839),
    [anon_sym_LF] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(841),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [sym__concat] = ACTIONS(2097),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_AMP_AMP] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(841),
    [anon_sym_SEMI_SEMI] = ACTIONS(841),
    [anon_sym_DASH_EQ] = ACTIONS(841),
  },
  [550] = {
    [sym_process_substitution] = STATE(549),
    [sym_postfix_expression] = STATE(1052),
    [sym_parenthesized_expression] = STATE(1052),
    [sym_command_substitution] = STATE(549),
    [sym_simple_expansion] = STATE(549),
    [sym__expression] = STATE(1052),
    [sym_string_expansion] = STATE(549),
    [sym_expansion] = STATE(549),
    [sym_binary_expression] = STATE(1052),
    [sym_unary_expression] = STATE(1052),
    [sym_concatenation] = STATE(1052),
    [sym_string] = STATE(549),
    [aux_sym__literal_repeat1] = STATE(557),
    [sym_test_operator] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [sym_raw_string] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(2099),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [anon_sym_GT_LPAREN] = ACTIONS(981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_word] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(2099),
    [anon_sym_LT_LPAREN] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(2099),
  },
  [551] = {
    [sym_string] = STATE(1054),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2101),
    [anon_sym_QMARK] = ACTIONS(2101),
    [sym_raw_string] = ACTIONS(2103),
    [anon_sym_AT] = ACTIONS(2101),
    [anon_sym_DOLLAR] = ACTIONS(2105),
    [anon_sym_POUND] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_0] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2107),
    [anon_sym__] = ACTIONS(2107),
  },
  [552] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1056),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [553] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1057),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1058),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [554] = {
    [sym_subscript] = STATE(1059),
    [anon_sym_STAR] = ACTIONS(2109),
    [anon_sym_QMARK] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_AT] = ACTIONS(2109),
    [sym_variable_name] = ACTIONS(2113),
    [anon_sym_DOLLAR] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_0] = ACTIONS(2117),
    [anon_sym_POUND] = ACTIONS(2111),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2117),
    [anon_sym__] = ACTIONS(2117),
    [sym_comment] = ACTIONS(3),
  },
  [555] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1065),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2119),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(2121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [556] = {
    [aux_sym_concatenation_repeat1] = STATE(1050),
    [anon_sym_BANG_EQ] = ACTIONS(219),
    [anon_sym_PLUS_EQ] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [sym_test_operator] = ACTIONS(221),
    [anon_sym_LF] = ACTIONS(219),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_PLUS_PLUS] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(219),
    [sym__concat] = ACTIONS(2097),
    [anon_sym_PLUS] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [anon_sym_DASH_DASH] = ACTIONS(219),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_LT_EQ] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_DASH_EQ] = ACTIONS(219),
  },
  [557] = {
    [aux_sym__literal_repeat1] = STATE(1067),
    [anon_sym_BANG_EQ] = ACTIONS(865),
    [anon_sym_PLUS_EQ] = ACTIONS(865),
    [sym_test_operator] = ACTIONS(863),
    [sym__special_character] = ACTIONS(2123),
    [anon_sym_LF] = ACTIONS(865),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(865),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(865),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_GT_EQ] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_AMP] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_AMP_AMP] = ACTIONS(865),
    [anon_sym_LT_EQ] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(865),
  },
  [558] = {
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [sym_test_operator] = ACTIONS(2127),
    [anon_sym_LF] = ACTIONS(2129),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_SEMI_SEMI] = ACTIONS(2129),
    [anon_sym_DASH_EQ] = ACTIONS(2125),
  },
  [559] = {
    [sym_redirected_statement] = STATE(1086),
    [sym_if_statement] = STATE(1086),
    [sym_function_definition] = STATE(1086),
    [sym_compound_statement] = STATE(1086),
    [sym_test_command] = STATE(1086),
    [sym_declaration_command] = STATE(1086),
    [sym_subscript] = STATE(1087),
    [sym_file_redirect] = STATE(1089),
    [sym_concatenation] = STATE(1088),
    [sym_string] = STATE(1081),
    [sym_command_substitution] = STATE(1081),
    [sym_process_substitution] = STATE(1081),
    [aux_sym_command_repeat1] = STATE(1089),
    [sym_for_statement] = STATE(1086),
    [sym_c_style_for_statement] = STATE(1086),
    [sym_case_statement] = STATE(1086),
    [sym_subshell] = STATE(1086),
    [sym_pipeline] = STATE(1086),
    [sym_unset_command] = STATE(1086),
    [sym_command] = STATE(1086),
    [sym_simple_expansion] = STATE(1081),
    [sym__statements] = STATE(1090),
    [sym_while_statement] = STATE(1086),
    [sym_list] = STATE(1086),
    [sym_negated_command] = STATE(1086),
    [sym_command_name] = STATE(1091),
    [sym_variable_assignment] = STATE(1092),
    [sym_string_expansion] = STATE(1081),
    [sym_expansion] = STATE(1081),
    [aux_sym__statements_repeat1] = STATE(1093),
    [aux_sym__literal_repeat1] = STATE(1094),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(2135),
    [anon_sym_typeset] = ACTIONS(2135),
    [anon_sym_unsetenv] = ACTIONS(2137),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [anon_sym_done] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(2135),
    [sym__special_character] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(2153),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_declare] = ACTIONS(2135),
    [sym_variable_name] = ACTIONS(2159),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(2135),
    [anon_sym_unset] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [560] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_BQUOTE] = ACTIONS(2163),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LF] = ACTIONS(2165),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2165),
    [anon_sym_GT] = ACTIONS(2163),
    [anon_sym_RPAREN] = ACTIONS(2163),
    [anon_sym_AMP_GT] = ACTIONS(2163),
    [anon_sym_fi] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_done] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [ts_builtin_sym_end] = ACTIONS(2165),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(2163),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_esac] = ACTIONS(2163),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
  },
  [561] = {
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_PLUS_EQ] = ACTIONS(1019),
    [sym_test_operator] = ACTIONS(1019),
    [anon_sym_PLUS_PLUS] = ACTIONS(1021),
    [anon_sym_RBRACK] = ACTIONS(1857),
    [anon_sym_DASH] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_AMP_AMP] = ACTIONS(1019),
    [anon_sym_DASH_EQ] = ACTIONS(1019),
  },
  [562] = {
    [anon_sym_BANG_EQ] = ACTIONS(1859),
    [anon_sym_PLUS_EQ] = ACTIONS(1859),
    [sym_test_operator] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_EQ] = ACTIONS(1863),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_PIPE] = ACTIONS(1859),
    [anon_sym_GT_EQ] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1863),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1865),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(1859),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_DASH_EQ] = ACTIONS(1859),
  },
  [563] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [564] = {
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [sym_test_operator] = ACTIONS(941),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
  },
  [565] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2171),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [566] = {
    [sym_process_substitution] = STATE(1098),
    [sym_string_expansion] = STATE(1098),
    [sym_expansion] = STATE(1098),
    [sym_simple_expansion] = STATE(1098),
    [sym_string] = STATE(1098),
    [sym_command_substitution] = STATE(1098),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(2173),
    [sym_raw_string] = ACTIONS(2173),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(2173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [567] = {
    [aux_sym_concatenation_repeat1] = STATE(1100),
    [anon_sym_BANG_EQ] = ACTIONS(631),
    [anon_sym_PLUS_EQ] = ACTIONS(631),
    [sym_test_operator] = ACTIONS(631),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_EQ] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(631),
    [anon_sym_PIPE_PIPE] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(631),
    [sym__concat] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_LT_EQ] = ACTIONS(631),
    [anon_sym_AMP_AMP] = ACTIONS(631),
    [anon_sym_DASH_EQ] = ACTIONS(631),
  },
  [568] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2177),
  },
  [569] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2179),
  },
  [570] = {
    [anon_sym_BANG_EQ] = ACTIONS(553),
    [anon_sym_PLUS_EQ] = ACTIONS(553),
    [sym_test_operator] = ACTIONS(553),
    [anon_sym_PLUS_PLUS] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(553),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_EQ] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(553),
    [anon_sym_PIPE_PIPE] = ACTIONS(553),
    [anon_sym_GT_EQ] = ACTIONS(553),
    [sym__concat] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(553),
    [anon_sym_DASH_DASH] = ACTIONS(553),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_AMP_AMP] = ACTIONS(553),
    [anon_sym_DASH_EQ] = ACTIONS(553),
  },
  [571] = {
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [sym_test_operator] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_EQ] = ACTIONS(555),
    [anon_sym_EQ_EQ] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [sym__concat] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(557),
    [anon_sym_DASH_DASH] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_DASH_EQ] = ACTIONS(557),
  },
  [572] = {
    [anon_sym_BANG_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(561),
    [sym_test_operator] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(561),
    [anon_sym_RBRACK] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(561),
    [sym__concat] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(561),
    [anon_sym_DASH_DASH] = ACTIONS(561),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(561),
  },
  [573] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [574] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2177),
  },
  [575] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1105),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1105),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2181),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2183),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [anon_sym_DASH] = ACTIONS(2183),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2183),
    [anon_sym_PERCENT] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_COLON_DASH] = ACTIONS(2183),
    [sym__special_character] = ACTIONS(599),
  },
  [576] = {
    [sym_subscript] = STATE(1106),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_AT] = ACTIONS(2189),
    [sym_variable_name] = ACTIONS(2191),
    [anon_sym_DOLLAR] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2193),
    [anon_sym_0] = ACTIONS(2195),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2195),
    [anon_sym__] = ACTIONS(2195),
  },
  [577] = {
    [anon_sym_EQ] = ACTIONS(2197),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [578] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1112),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1112),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2199),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2201),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2203),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2201),
    [anon_sym_PERCENT] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2205),
    [anon_sym_COLON_DASH] = ACTIONS(2201),
    [sym__special_character] = ACTIONS(599),
  },
  [579] = {
    [anon_sym_BANG_EQ] = ACTIONS(221),
    [anon_sym_PLUS_EQ] = ACTIONS(221),
    [sym_test_operator] = ACTIONS(221),
    [anon_sym_PLUS_PLUS] = ACTIONS(221),
    [anon_sym_RBRACK] = ACTIONS(221),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(221),
    [anon_sym_PIPE_PIPE] = ACTIONS(221),
    [anon_sym_GT_EQ] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(221),
    [anon_sym_DASH_DASH] = ACTIONS(221),
    [anon_sym_LT_EQ] = ACTIONS(221),
    [anon_sym_AMP_AMP] = ACTIONS(221),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_DASH_EQ] = ACTIONS(221),
  },
  [580] = {
    [aux_sym__literal_repeat1] = STATE(580),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [sym_test_operator] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1192),
    [anon_sym_RBRACK] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_DASH_DASH] = ACTIONS(1192),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [sym__special_character] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
  },
  [581] = {
    [sym_process_substitution] = STATE(197),
    [sym_postfix_expression] = STATE(1113),
    [sym_parenthesized_expression] = STATE(1113),
    [sym_command_substitution] = STATE(197),
    [sym_simple_expansion] = STATE(197),
    [sym__expression] = STATE(1113),
    [sym_string_expansion] = STATE(197),
    [sym_expansion] = STATE(197),
    [sym_binary_expression] = STATE(1113),
    [sym_unary_expression] = STATE(1113),
    [sym_concatenation] = STATE(1113),
    [sym_string] = STATE(197),
    [aux_sym__literal_repeat1] = STATE(204),
    [sym_test_operator] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(315),
    [sym_raw_string] = ACTIONS(317),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [582] = {
    [anon_sym_BANG_EQ] = ACTIONS(1908),
    [anon_sym_PLUS_EQ] = ACTIONS(1908),
    [sym_test_operator] = ACTIONS(1908),
    [anon_sym_PLUS_PLUS] = ACTIONS(1908),
    [anon_sym_RBRACK] = ACTIONS(1908),
    [anon_sym_DASH] = ACTIONS(1910),
    [anon_sym_GT] = ACTIONS(1910),
    [anon_sym_EQ] = ACTIONS(1910),
    [anon_sym_EQ_EQ] = ACTIONS(1908),
    [anon_sym_PIPE_PIPE] = ACTIONS(1908),
    [anon_sym_GT_EQ] = ACTIONS(1908),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_LT] = ACTIONS(1910),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1908),
    [anon_sym_DASH_DASH] = ACTIONS(1908),
    [anon_sym_LT_EQ] = ACTIONS(1908),
    [anon_sym_AMP_AMP] = ACTIONS(1908),
    [anon_sym_DASH_EQ] = ACTIONS(1908),
  },
  [583] = {
    [sym_process_substitution] = STATE(197),
    [sym_postfix_expression] = STATE(1113),
    [sym_parenthesized_expression] = STATE(1113),
    [sym_command_substitution] = STATE(197),
    [sym_simple_expansion] = STATE(197),
    [sym__expression] = STATE(1113),
    [sym_string_expansion] = STATE(197),
    [sym_expansion] = STATE(197),
    [sym_binary_expression] = STATE(1113),
    [sym_unary_expression] = STATE(1113),
    [sym_concatenation] = STATE(1113),
    [sym_string] = STATE(197),
    [aux_sym__literal_repeat1] = STATE(204),
    [sym_test_operator] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [sym_raw_string] = ACTIONS(317),
    [anon_sym_BANG] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(315),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(329),
    [sym_regex] = ACTIONS(2210),
  },
  [584] = {
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_PLUS_EQ] = ACTIONS(1029),
    [sym_test_operator] = ACTIONS(1029),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_EQ_EQ] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1029),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1857),
    [anon_sym_GT_EQ] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_LT] = ACTIONS(1031),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(1029),
    [anon_sym_AMP_AMP] = ACTIONS(1029),
    [anon_sym_DASH_EQ] = ACTIONS(1029),
  },
  [585] = {
    [aux_sym_concatenation_repeat1] = STATE(1115),
    [anon_sym_BANG_EQ] = ACTIONS(631),
    [anon_sym_PLUS_EQ] = ACTIONS(631),
    [sym_test_operator] = ACTIONS(631),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_EQ] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(631),
    [anon_sym_PIPE_PIPE] = ACTIONS(631),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(631),
    [sym__concat] = ACTIONS(1873),
    [anon_sym_PLUS] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_LT_EQ] = ACTIONS(631),
    [anon_sym_AMP_AMP] = ACTIONS(631),
    [anon_sym_DASH_EQ] = ACTIONS(631),
  },
  [586] = {
    [aux_sym__literal_repeat1] = STATE(586),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [sym_test_operator] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_DASH_DASH] = ACTIONS(1192),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [sym__special_character] = ACTIONS(2212),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
  },
  [587] = {
    [sym_process_substitution] = STATE(207),
    [sym_postfix_expression] = STATE(963),
    [sym_parenthesized_expression] = STATE(963),
    [sym_command_substitution] = STATE(207),
    [sym_simple_expansion] = STATE(207),
    [sym__expression] = STATE(963),
    [sym_string_expansion] = STATE(207),
    [sym_expansion] = STATE(207),
    [sym_binary_expression] = STATE(963),
    [sym_unary_expression] = STATE(963),
    [sym_concatenation] = STATE(963),
    [sym_string] = STATE(207),
    [aux_sym__literal_repeat1] = STATE(209),
    [sym_test_operator] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(335),
    [sym_raw_string] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [588] = {
    [sym_process_substitution] = STATE(207),
    [sym_postfix_expression] = STATE(963),
    [sym_parenthesized_expression] = STATE(963),
    [sym_command_substitution] = STATE(207),
    [sym_simple_expansion] = STATE(207),
    [sym__expression] = STATE(963),
    [sym_string_expansion] = STATE(207),
    [sym_expansion] = STATE(207),
    [sym_binary_expression] = STATE(963),
    [sym_unary_expression] = STATE(963),
    [sym_concatenation] = STATE(963),
    [sym_string] = STATE(207),
    [aux_sym__literal_repeat1] = STATE(209),
    [sym_test_operator] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_raw_string] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(335),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(341),
    [sym_regex] = ACTIONS(1912),
  },
  [589] = {
    [aux_sym_redirected_statement_repeat1] = STATE(219),
    [sym_file_redirect] = STATE(219),
    [sym_herestring_redirect] = STATE(219),
    [sym_heredoc_redirect] = STATE(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [ts_builtin_sym_end] = ACTIONS(2217),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [590] = {
    [aux_sym_redirected_statement_repeat1] = STATE(219),
    [sym_file_redirect] = STATE(219),
    [sym_herestring_redirect] = STATE(219),
    [sym_heredoc_redirect] = STATE(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [ts_builtin_sym_end] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [591] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1116),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [592] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1119),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2219),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [593] = {
    [aux_sym_concatenation_repeat1] = STATE(1121),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [ts_builtin_sym_end] = ACTIONS(435),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [594] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1122),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [595] = {
    [sym_string] = STATE(1124),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_QMARK] = ACTIONS(2225),
    [sym_raw_string] = ACTIONS(2227),
    [anon_sym_AT] = ACTIONS(2225),
    [anon_sym_DOLLAR] = ACTIONS(2229),
    [anon_sym_POUND] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_0] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2231),
    [anon_sym__] = ACTIONS(2231),
  },
  [596] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1126),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1127),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [597] = {
    [aux_sym_concatenation_repeat1] = STATE(1121),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [598] = {
    [sym_subscript] = STATE(1128),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_QMARK] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_AT] = ACTIONS(2233),
    [sym_variable_name] = ACTIONS(2237),
    [anon_sym_DOLLAR] = ACTIONS(2239),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_0] = ACTIONS(2241),
    [anon_sym_POUND] = ACTIONS(2235),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2241),
    [anon_sym__] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
  },
  [599] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_RPAREN] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_fi] = ACTIONS(437),
    [anon_sym_else] = ACTIONS(437),
    [anon_sym_done] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [ts_builtin_sym_end] = ACTIONS(435),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_esac] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [600] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [ts_builtin_sym_end] = ACTIONS(459),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
  },
  [601] = {
    [anon_sym_BQUOTE] = ACTIONS(2245),
    [ts_builtin_sym_end] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2247),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2245),
    [anon_sym_esac] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(2245),
    [anon_sym_elif] = ACTIONS(2245),
    [anon_sym_fi] = ACTIONS(2245),
    [anon_sym_done] = ACTIONS(2245),
    [anon_sym_else] = ACTIONS(2245),
    [anon_sym_SEMI_SEMI] = ACTIONS(2245),
  },
  [602] = {
    [sym_expansion] = STATE(1139),
    [aux_sym_heredoc_body_repeat1] = STATE(1139),
    [sym_simple_expansion] = STATE(1139),
    [sym_command_substitution] = STATE(1139),
    [anon_sym_DOLLAR] = ACTIONS(2249),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2253),
    [sym__heredoc_body_end] = ACTIONS(2255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2257),
    [sym__heredoc_body_middle] = ACTIONS(2259),
  },
  [603] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [ts_builtin_sym_end] = ACTIONS(2263),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_SEMI_SEMI] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
  },
  [604] = {
    [sym_process_substitution] = STATE(1141),
    [aux_sym__literal_repeat1] = STATE(1143),
    [sym_simple_expansion] = STATE(1141),
    [sym_string_expansion] = STATE(1141),
    [sym_expansion] = STATE(1141),
    [sym_concatenation] = STATE(1142),
    [sym_string] = STATE(1141),
    [sym_command_substitution] = STATE(1141),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(2269),
    [sym_raw_string] = ACTIONS(2269),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1047),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [605] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2271),
    [anon_sym_BQUOTE] = ACTIONS(2271),
    [anon_sym_AMP_GT_GT] = ACTIONS(2271),
    [anon_sym_LF] = ACTIONS(2273),
    [anon_sym_SEMI] = ACTIONS(2271),
    [anon_sym_LT_LT] = ACTIONS(2271),
    [sym_file_descriptor] = ACTIONS(2273),
    [anon_sym_GT] = ACTIONS(2271),
    [anon_sym_RPAREN] = ACTIONS(2271),
    [anon_sym_AMP_GT] = ACTIONS(2271),
    [anon_sym_fi] = ACTIONS(2271),
    [anon_sym_else] = ACTIONS(2271),
    [anon_sym_done] = ACTIONS(2271),
    [anon_sym_PIPE_PIPE] = ACTIONS(2271),
    [ts_builtin_sym_end] = ACTIONS(2273),
    [anon_sym_LT_LT_LT] = ACTIONS(2271),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_GT_AMP] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_LT_AMP] = ACTIONS(2271),
    [anon_sym_GT_GT] = ACTIONS(2271),
    [anon_sym_AMP] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(2271),
    [anon_sym_AMP_AMP] = ACTIONS(2271),
    [anon_sym_esac] = ACTIONS(2271),
    [anon_sym_SEMI_SEMI] = ACTIONS(2271),
    [anon_sym_PIPE_AMP] = ACTIONS(2271),
  },
  [606] = {
    [aux_sym_redirected_statement_repeat1] = STATE(219),
    [sym_file_redirect] = STATE(219),
    [sym_herestring_redirect] = STATE(219),
    [sym_heredoc_redirect] = STATE(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [sym_file_descriptor] = ACTIONS(2277),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [ts_builtin_sym_end] = ACTIONS(2277),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(359),
  },
  [607] = {
    [aux_sym_redirected_statement_repeat1] = STATE(219),
    [sym_file_redirect] = STATE(219),
    [sym_herestring_redirect] = STATE(219),
    [sym_heredoc_redirect] = STATE(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [ts_builtin_sym_end] = ACTIONS(2277),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(359),
  },
  [608] = {
    [aux_sym_concatenation_repeat1] = STATE(1121),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [ts_builtin_sym_end] = ACTIONS(2281),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [609] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_BQUOTE] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(2279),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_fi] = ACTIONS(2279),
    [anon_sym_else] = ACTIONS(2279),
    [anon_sym_done] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [ts_builtin_sym_end] = ACTIONS(2281),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(2279),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_esac] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [610] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LT_LT] = ACTIONS(2283),
    [sym_file_descriptor] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [ts_builtin_sym_end] = ACTIONS(2285),
    [anon_sym_LT_LT_LT] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_GT_AMP] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_LT_AMP] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
  },
  [611] = {
    [aux_sym_redirected_statement_repeat1] = STATE(611),
    [sym_file_redirect] = STATE(611),
    [sym_herestring_redirect] = STATE(611),
    [sym_heredoc_redirect] = STATE(611),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_AMP_GT_GT] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2287),
    [sym_file_descriptor] = ACTIONS(2297),
    [anon_sym_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym_LT_LT_LT] = ACTIONS(2300),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_LT_AMP] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
  },
  [612] = {
    [sym_process_substitution] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [aux_sym_command_repeat2] = STATE(616),
    [sym_concatenation] = STATE(616),
    [sym_string] = STATE(222),
    [aux_sym__literal_repeat1] = STATE(224),
    [anon_sym_AMP_GT_GT] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [sym_word] = ACTIONS(375),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_LT_AMP] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_TILDE] = ACTIONS(377),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [sym_raw_string] = ACTIONS(375),
    [sym_file_descriptor] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(377),
    [ts_builtin_sym_end] = ACTIONS(2305),
    [anon_sym_LT_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_AMP] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_SEMI_SEMI] = ACTIONS(2303),
    [anon_sym_PIPE_AMP] = ACTIONS(2303),
  },
  [613] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [ts_builtin_sym_end] = ACTIONS(2309),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [614] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [ts_builtin_sym_end] = ACTIONS(2309),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [615] = {
    [aux_sym__literal_repeat1] = STATE(230),
    [anon_sym_AMP_GT_GT] = ACTIONS(2311),
    [anon_sym_DOLLAR] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [sym_word] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_LT_AMP] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(2311),
    [anon_sym_EQ_TILDE] = ACTIONS(2311),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [sym_raw_string] = ACTIONS(2311),
    [sym_file_descriptor] = ACTIONS(2313),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP_GT] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_LT_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_AMP] = ACTIONS(2311),
    [ts_builtin_sym_end] = ACTIONS(2313),
    [anon_sym_LT_LPAREN] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_SEMI_SEMI] = ACTIONS(2311),
    [anon_sym_PIPE_AMP] = ACTIONS(2311),
  },
  [616] = {
    [sym_process_substitution] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [aux_sym_command_repeat2] = STATE(616),
    [sym_concatenation] = STATE(616),
    [sym_string] = STATE(222),
    [aux_sym__literal_repeat1] = STATE(224),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2318),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2324),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2327),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2330),
    [sym__special_character] = ACTIONS(2333),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2336),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2327),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2330),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [ts_builtin_sym_end] = ACTIONS(2309),
    [anon_sym_LT_LPAREN] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [617] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [ts_builtin_sym_end] = ACTIONS(2263),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [618] = {
    [sym_heredoc_body] = STATE(1144),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(2263),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [ts_builtin_sym_end] = ACTIONS(2263),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [619] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
    [anon_sym_AMP_GT_GT] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_LT_LT_LT] = ACTIONS(775),
    [anon_sym_GT_AMP] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_AMP] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(2344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
  },
  [620] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(775),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
  },
  [621] = {
    [aux_sym_concatenation_repeat1] = STATE(1147),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(1279),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [anon_sym_RPAREN] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [622] = {
    [sym_process_substitution] = STATE(1148),
    [aux_sym__literal_repeat1] = STATE(1149),
    [sym_array] = STATE(673),
    [sym_simple_expansion] = STATE(1148),
    [sym_string_expansion] = STATE(1148),
    [sym_expansion] = STATE(1148),
    [sym_concatenation] = STATE(673),
    [sym_string] = STATE(1148),
    [sym_command_substitution] = STATE(1148),
    [anon_sym_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [sym_word] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2346),
    [anon_sym_LT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1275),
    [sym__special_character] = ACTIONS(2348),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1277),
    [sym__empty_value] = ACTIONS(1289),
  },
  [623] = {
    [aux_sym__literal_repeat1] = STATE(623),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1317),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [624] = {
    [sym_process_substitution] = STATE(231),
    [sym_string] = STATE(231),
    [sym_command_substitution] = STATE(231),
    [sym_simple_expansion] = STATE(231),
    [sym_variable_assignment] = STATE(624),
    [sym_subscript] = STATE(236),
    [sym_string_expansion] = STATE(231),
    [sym_expansion] = STATE(231),
    [sym_concatenation] = STATE(624),
    [aux_sym_declaration_command_repeat1] = STATE(624),
    [aux_sym__literal_repeat1] = STATE(234),
    [anon_sym_AMP_GT_GT] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(1322),
    [anon_sym_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_LPAREN] = ACTIONS(1325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1328),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2350),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1334),
    [anon_sym_PIPE_PIPE] = ACTIONS(1320),
    [sym_word] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_AMP] = ACTIONS(1320),
    [anon_sym_LT] = ACTIONS(1320),
    [anon_sym_LT_AMP] = ACTIONS(1320),
    [anon_sym_GT_GT] = ACTIONS(1320),
    [sym__special_character] = ACTIONS(2356),
    [anon_sym_LT_LT_DASH] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(1343),
    [anon_sym_LF] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_raw_string] = ACTIONS(2353),
    [sym_variable_name] = ACTIONS(2359),
    [anon_sym_RPAREN] = ACTIONS(1320),
    [sym_file_descriptor] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1320),
    [anon_sym_AMP_GT] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_AMP] = ACTIONS(1320),
    [anon_sym_LT_LPAREN] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1320),
    [anon_sym_SEMI_SEMI] = ACTIONS(1320),
    [anon_sym_PIPE_AMP] = ACTIONS(1320),
  },
  [625] = {
    [aux_sym_concatenation_repeat1] = STATE(1150),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(1370),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [626] = {
    [aux_sym__literal_repeat1] = STATE(626),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [627] = {
    [sym_process_substitution] = STATE(237),
    [sym_command_substitution] = STATE(237),
    [aux_sym_unset_command_repeat1] = STATE(627),
    [sym_simple_expansion] = STATE(237),
    [sym_string_expansion] = STATE(237),
    [sym_expansion] = STATE(237),
    [sym_concatenation] = STATE(627),
    [sym_string] = STATE(237),
    [aux_sym__literal_repeat1] = STATE(239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1403),
    [anon_sym_DOLLAR] = ACTIONS(1405),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_LPAREN] = ACTIONS(1408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1411),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1417),
    [anon_sym_PIPE_PIPE] = ACTIONS(1403),
    [sym_word] = ACTIONS(2365),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_LT_AMP] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [sym__special_character] = ACTIONS(2368),
    [anon_sym_LT_LT_DASH] = ACTIONS(1403),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [anon_sym_LF] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(2365),
    [anon_sym_RPAREN] = ACTIONS(1403),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_AMP_GT] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [anon_sym_LT_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_AMP] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1403),
    [anon_sym_PIPE_AMP] = ACTIONS(1403),
  },
  [628] = {
    [aux_sym_concatenation_repeat1] = STATE(628),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1548),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [629] = {
    [aux_sym_concatenation_repeat1] = STATE(1151),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(1962),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [630] = {
    [aux_sym_concatenation_repeat1] = STATE(1151),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(1962),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [631] = {
    [aux_sym__literal_repeat1] = STATE(1152),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(1986),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [632] = {
    [aux_sym_redirected_statement_repeat1] = STATE(248),
    [sym_file_redirect] = STATE(248),
    [sym_herestring_redirect] = STATE(248),
    [sym_heredoc_redirect] = STATE(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_RPAREN] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [633] = {
    [aux_sym_redirected_statement_repeat1] = STATE(248),
    [sym_file_redirect] = STATE(248),
    [sym_herestring_redirect] = STATE(248),
    [sym_heredoc_redirect] = STATE(248),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_RPAREN] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [634] = {
    [aux_sym_concatenation_repeat1] = STATE(1153),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_RPAREN] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [635] = {
    [aux_sym_concatenation_repeat1] = STATE(1153),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [636] = {
    [aux_sym__literal_repeat1] = STATE(1154),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
  },
  [637] = {
    [sym_process_substitution] = STATE(1155),
    [aux_sym__literal_repeat1] = STATE(1156),
    [sym_simple_expansion] = STATE(1155),
    [sym_string_expansion] = STATE(1155),
    [sym_expansion] = STATE(1155),
    [sym_concatenation] = STATE(1142),
    [sym_string] = STATE(1155),
    [sym_command_substitution] = STATE(1155),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [638] = {
    [aux_sym_redirected_statement_repeat1] = STATE(248),
    [sym_file_redirect] = STATE(248),
    [sym_herestring_redirect] = STATE(248),
    [sym_heredoc_redirect] = STATE(248),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_RPAREN] = ACTIONS(2275),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [sym_file_descriptor] = ACTIONS(2277),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
  },
  [639] = {
    [aux_sym_redirected_statement_repeat1] = STATE(248),
    [sym_file_redirect] = STATE(248),
    [sym_herestring_redirect] = STATE(248),
    [sym_heredoc_redirect] = STATE(248),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
  },
  [640] = {
    [aux_sym_concatenation_repeat1] = STATE(1153),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_RPAREN] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [641] = {
    [aux_sym__literal_repeat1] = STATE(1154),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_RPAREN] = ACTIONS(2283),
    [anon_sym_LT_LT] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [sym_file_descriptor] = ACTIONS(2285),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_LT_LT_LT] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_GT_AMP] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_LT_AMP] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
  },
  [642] = {
    [aux_sym_redirected_statement_repeat1] = STATE(642),
    [sym_file_redirect] = STATE(642),
    [sym_herestring_redirect] = STATE(642),
    [sym_heredoc_redirect] = STATE(642),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_AMP_GT_GT] = ACTIONS(2373),
    [anon_sym_LF] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_RPAREN] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2373),
    [sym_file_descriptor] = ACTIONS(2376),
    [anon_sym_AMP_GT] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT_LT_LT] = ACTIONS(2379),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_LT_AMP] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
  },
  [643] = {
    [sym_process_substitution] = STATE(251),
    [sym_command_substitution] = STATE(251),
    [sym_simple_expansion] = STATE(251),
    [sym_string_expansion] = STATE(251),
    [sym_expansion] = STATE(251),
    [aux_sym_command_repeat2] = STATE(646),
    [sym_concatenation] = STATE(646),
    [sym_string] = STATE(251),
    [aux_sym__literal_repeat1] = STATE(253),
    [anon_sym_AMP_GT_GT] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [sym_word] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_LT_AMP] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_TILDE] = ACTIONS(429),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [sym_raw_string] = ACTIONS(427),
    [anon_sym_RPAREN] = ACTIONS(2303),
    [sym_file_descriptor] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_AMP] = ACTIONS(2303),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_SEMI_SEMI] = ACTIONS(2303),
    [anon_sym_PIPE_AMP] = ACTIONS(2303),
  },
  [644] = {
    [aux_sym_concatenation_repeat1] = STATE(241),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [645] = {
    [aux_sym__literal_repeat1] = STATE(257),
    [anon_sym_AMP_GT_GT] = ACTIONS(2311),
    [anon_sym_DOLLAR] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [sym_word] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_LT_AMP] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(2311),
    [anon_sym_EQ_TILDE] = ACTIONS(2311),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [sym_raw_string] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2311),
    [sym_file_descriptor] = ACTIONS(2313),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP_GT] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_LT_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_AMP] = ACTIONS(2311),
    [anon_sym_LT_LPAREN] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_SEMI_SEMI] = ACTIONS(2311),
    [anon_sym_PIPE_AMP] = ACTIONS(2311),
  },
  [646] = {
    [sym_process_substitution] = STATE(251),
    [sym_command_substitution] = STATE(251),
    [sym_simple_expansion] = STATE(251),
    [sym_string_expansion] = STATE(251),
    [sym_expansion] = STATE(251),
    [aux_sym_command_repeat2] = STATE(646),
    [sym_concatenation] = STATE(646),
    [sym_string] = STATE(251),
    [aux_sym__literal_repeat1] = STATE(253),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2318),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2324),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2382),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2385),
    [sym__special_character] = ACTIONS(2388),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2336),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2382),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [647] = {
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [anon_sym_AMP_GT_GT] = ACTIONS(1442),
    [sym_raw_string] = ACTIONS(1442),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [sym_variable_name] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1442),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1442),
    [anon_sym_GT_LPAREN] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym_word] = ACTIONS(1442),
    [anon_sym_GT_AMP] = ACTIONS(1442),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1442),
    [anon_sym_GT_GT] = ACTIONS(1442),
    [anon_sym_LT_LPAREN] = ACTIONS(1442),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1442),
  },
  [648] = {
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_AMP_GT_GT] = ACTIONS(2012),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [sym_variable_name] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [anon_sym_RPAREN] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [sym_word] = ACTIONS(2012),
    [anon_sym_GT_AMP] = ACTIONS(2012),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2012),
  },
  [649] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [650] = {
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [anon_sym_AMP_GT_GT] = ACTIONS(1544),
    [sym_raw_string] = ACTIONS(1544),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [sym_variable_name] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1544),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1544),
    [anon_sym_GT_LPAREN] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [sym_word] = ACTIONS(1544),
    [anon_sym_GT_AMP] = ACTIONS(1544),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1544),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1544),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1544),
  },
  [651] = {
    [sym_process_substitution] = STATE(650),
    [sym_string_expansion] = STATE(650),
    [sym_expansion] = STATE(650),
    [sym_simple_expansion] = STATE(650),
    [sym_string] = STATE(650),
    [sym_command_substitution] = STATE(650),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(1228),
    [sym_raw_string] = ACTIONS(1228),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(2393),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(1228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [652] = {
    [aux_sym_concatenation_repeat1] = STATE(652),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [anon_sym_AMP_GT_GT] = ACTIONS(1544),
    [sym_raw_string] = ACTIONS(1544),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [sym_variable_name] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1544),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1544),
    [anon_sym_GT_LPAREN] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [sym_word] = ACTIONS(1544),
    [anon_sym_GT_AMP] = ACTIONS(1544),
    [sym__concat] = ACTIONS(2395),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1544),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1544),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1544),
  },
  [653] = {
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [anon_sym_AMP_GT_GT] = ACTIONS(1436),
    [sym_raw_string] = ACTIONS(1436),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [sym_variable_name] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1436),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1436),
    [anon_sym_GT_LPAREN] = ACTIONS(1436),
    [anon_sym_RPAREN] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [sym_word] = ACTIONS(1436),
    [anon_sym_GT_AMP] = ACTIONS(1436),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1436),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_LT_LPAREN] = ACTIONS(1436),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1436),
  },
  [654] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1161),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1161),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2398),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2398),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2402),
    [anon_sym_COLON_DASH] = ACTIONS(2398),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2404),
  },
  [655] = {
    [anon_sym_BQUOTE] = ACTIONS(1478),
    [anon_sym_AMP_GT_GT] = ACTIONS(1478),
    [sym_raw_string] = ACTIONS(1478),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [sym_variable_name] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1478),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1478),
    [anon_sym_GT_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_word] = ACTIONS(1478),
    [anon_sym_GT_AMP] = ACTIONS(1478),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1478),
    [anon_sym_GT_GT] = ACTIONS(1478),
    [anon_sym_LT_LPAREN] = ACTIONS(1478),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1478),
  },
  [656] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [657] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1161),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1161),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2406),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2398),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2398),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2402),
    [anon_sym_COLON_DASH] = ACTIONS(2398),
    [sym__special_character] = ACTIONS(599),
  },
  [658] = {
    [anon_sym_EQ] = ACTIONS(2408),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [659] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1166),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1166),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2410),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2412),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2412),
    [anon_sym_PERCENT] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2416),
    [anon_sym_COLON_DASH] = ACTIONS(2412),
    [sym__special_character] = ACTIONS(599),
  },
  [660] = {
    [sym_process_substitution] = STATE(1167),
    [aux_sym__literal_repeat1] = STATE(1169),
    [sym_simple_expansion] = STATE(1167),
    [sym_string_expansion] = STATE(1167),
    [sym_expansion] = STATE(1167),
    [sym_concatenation] = STATE(1168),
    [sym_string] = STATE(1167),
    [sym_command_substitution] = STATE(1167),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(2418),
    [sym_raw_string] = ACTIONS(2418),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [661] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1172),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1172),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2420),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2424),
    [anon_sym_COLON_DASH] = ACTIONS(2420),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2426),
  },
  [662] = {
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [anon_sym_AMP_GT_GT] = ACTIONS(1534),
    [sym_raw_string] = ACTIONS(1534),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [sym_variable_name] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1534),
    [anon_sym_GT_LPAREN] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [sym_word] = ACTIONS(1534),
    [anon_sym_GT_AMP] = ACTIONS(1534),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1534),
    [anon_sym_GT_GT] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1534),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1534),
  },
  [663] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [664] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [665] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [ts_builtin_sym_end] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [666] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(2428),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [667] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [668] = {
    [sym_process_substitution] = STATE(667),
    [sym_string_expansion] = STATE(667),
    [sym_expansion] = STATE(667),
    [sym_simple_expansion] = STATE(667),
    [sym_string] = STATE(667),
    [sym_command_substitution] = STATE(667),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [sym_word] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR] = ACTIONS(2430),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1275),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1277),
  },
  [669] = {
    [aux_sym_concatenation_repeat1] = STATE(669),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(2432),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [670] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [ts_builtin_sym_end] = ACTIONS(1436),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [671] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1176),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1176),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(2435),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [672] = {
    [aux_sym_concatenation_repeat1] = STATE(281),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(471),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [673] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [ts_builtin_sym_end] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [674] = {
    [aux_sym__literal_repeat1] = STATE(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(499),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [ts_builtin_sym_end] = ACTIONS(1988),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [675] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1179),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1179),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2437),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2437),
    [anon_sym_PERCENT] = ACTIONS(2437),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2441),
    [anon_sym_COLON_DASH] = ACTIONS(2437),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2443),
  },
  [676] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [ts_builtin_sym_end] = ACTIONS(1478),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [677] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [678] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1179),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1179),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2445),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2437),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2437),
    [anon_sym_PERCENT] = ACTIONS(2437),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2441),
    [anon_sym_COLON_DASH] = ACTIONS(2437),
    [sym__special_character] = ACTIONS(599),
  },
  [679] = {
    [anon_sym_EQ] = ACTIONS(2447),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [680] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1184),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1184),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2449),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2451),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2453),
    [anon_sym_DASH] = ACTIONS(2451),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2451),
    [anon_sym_PERCENT] = ACTIONS(2451),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2455),
    [anon_sym_COLON_DASH] = ACTIONS(2451),
    [sym__special_character] = ACTIONS(599),
  },
  [681] = {
    [sym_process_substitution] = STATE(1185),
    [aux_sym__literal_repeat1] = STATE(1187),
    [sym_simple_expansion] = STATE(1185),
    [sym_string_expansion] = STATE(1185),
    [sym_expansion] = STATE(1185),
    [sym_concatenation] = STATE(1186),
    [sym_string] = STATE(1185),
    [sym_command_substitution] = STATE(1185),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(2457),
    [sym_raw_string] = ACTIONS(2457),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [682] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2459),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2461),
    [anon_sym_DASH] = ACTIONS(2459),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2459),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2463),
    [anon_sym_COLON_DASH] = ACTIONS(2459),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2465),
  },
  [683] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [ts_builtin_sym_end] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [684] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2461),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [685] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [686] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [ts_builtin_sym_end] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [687] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [688] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [689] = {
    [sym_process_substitution] = STATE(688),
    [sym_string_expansion] = STATE(688),
    [sym_expansion] = STATE(688),
    [sym_simple_expansion] = STATE(688),
    [sym_string] = STATE(688),
    [sym_command_substitution] = STATE(688),
    [anon_sym_BQUOTE] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(519),
    [sym_word] = ACTIONS(1362),
    [sym_raw_string] = ACTIONS(1362),
    [anon_sym_LT_LPAREN] = ACTIONS(1364),
    [anon_sym_DOLLAR] = ACTIONS(2469),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1366),
    [sym__special_character] = ACTIONS(1362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [690] = {
    [aux_sym_concatenation_repeat1] = STATE(690),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(2471),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [691] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [ts_builtin_sym_end] = ACTIONS(1436),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [692] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1195),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1195),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2478),
    [anon_sym_COLON_DASH] = ACTIONS(2474),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2480),
  },
  [693] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [ts_builtin_sym_end] = ACTIONS(1478),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [694] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [695] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1195),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1195),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2482),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2478),
    [anon_sym_COLON_DASH] = ACTIONS(2474),
    [sym__special_character] = ACTIONS(599),
  },
  [696] = {
    [anon_sym_EQ] = ACTIONS(2484),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [697] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1200),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1200),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2486),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2492),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(599),
  },
  [698] = {
    [sym_process_substitution] = STATE(1201),
    [aux_sym__literal_repeat1] = STATE(1203),
    [sym_simple_expansion] = STATE(1201),
    [sym_string_expansion] = STATE(1201),
    [sym_expansion] = STATE(1201),
    [sym_concatenation] = STATE(1202),
    [sym_string] = STATE(1201),
    [sym_command_substitution] = STATE(1201),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2494),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [699] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1206),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1206),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2496),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2496),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2496),
    [anon_sym_PERCENT] = ACTIONS(2496),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2500),
    [anon_sym_COLON_DASH] = ACTIONS(2496),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2502),
  },
  [700] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [ts_builtin_sym_end] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [701] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [702] = {
    [aux_sym_concatenation_repeat1] = STATE(1207),
    [anon_sym_BQUOTE] = ACTIONS(631),
    [anon_sym_AMP_GT_GT] = ACTIONS(631),
    [sym_raw_string] = ACTIONS(631),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(631),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(631),
    [anon_sym_GT_LPAREN] = ACTIONS(631),
    [sym_variable_name] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(631),
    [sym_word] = ACTIONS(631),
    [anon_sym_GT_AMP] = ACTIONS(631),
    [sym__concat] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(631),
    [anon_sym_GT_GT] = ACTIONS(631),
    [anon_sym_LT_LPAREN] = ACTIONS(631),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(631),
  },
  [703] = {
    [aux_sym__literal_repeat1] = STATE(703),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [anon_sym_AMP_GT_GT] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [sym_variable_name] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_word] = ACTIONS(1192),
    [anon_sym_GT_AMP] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1192),
    [anon_sym_GT_GT] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1260),
  },
  [704] = {
    [aux_sym_concatenation_repeat1] = STATE(702),
    [anon_sym_BQUOTE] = ACTIONS(2002),
    [anon_sym_AMP_GT_GT] = ACTIONS(2002),
    [sym_raw_string] = ACTIONS(2002),
    [anon_sym_DOLLAR] = ACTIONS(2004),
    [anon_sym_RPAREN] = ACTIONS(2002),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2002),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2002),
    [anon_sym_GT_LPAREN] = ACTIONS(2002),
    [sym_variable_name] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [sym_word] = ACTIONS(2002),
    [anon_sym_GT_AMP] = ACTIONS(2002),
    [sym__concat] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2002),
    [anon_sym_GT_GT] = ACTIONS(2002),
    [anon_sym_LT_LPAREN] = ACTIONS(2002),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2002),
  },
  [705] = {
    [aux_sym__literal_repeat1] = STATE(703),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [anon_sym_AMP_GT_GT] = ACTIONS(2006),
    [sym_raw_string] = ACTIONS(2006),
    [anon_sym_DOLLAR] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2006),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2006),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2006),
    [anon_sym_GT_LPAREN] = ACTIONS(2006),
    [sym_variable_name] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_word] = ACTIONS(2006),
    [anon_sym_GT_AMP] = ACTIONS(2006),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2006),
    [anon_sym_GT_GT] = ACTIONS(2006),
    [anon_sym_LT_LPAREN] = ACTIONS(2006),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(463),
  },
  [706] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2504),
  },
  [707] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_EQ_TILDE] = ACTIONS(2506),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [ts_builtin_sym_end] = ACTIONS(2508),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [708] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1210),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1210),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2514),
    [anon_sym_COLON_DASH] = ACTIONS(2510),
    [sym__special_character] = ACTIONS(599),
  },
  [709] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [710] = {
    [sym_process_substitution] = STATE(1211),
    [sym_string_expansion] = STATE(1211),
    [sym_expansion] = STATE(1211),
    [sym_simple_expansion] = STATE(1211),
    [sym_string] = STATE(1211),
    [sym_command_substitution] = STATE(1211),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(2516),
    [sym_raw_string] = ACTIONS(2516),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [sym__special_character] = ACTIONS(2516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
  },
  [711] = {
    [aux_sym_concatenation_repeat1] = STATE(1213),
    [anon_sym_BQUOTE] = ACTIONS(631),
    [sym_raw_string] = ACTIONS(631),
    [anon_sym_COLON_QMARK] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(631),
    [anon_sym_EQ] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(631),
    [anon_sym_PERCENT] = ACTIONS(627),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(631),
    [sym_word] = ACTIONS(627),
    [sym__concat] = ACTIONS(2518),
    [anon_sym_LT_LPAREN] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(631),
    [anon_sym_COLON_DASH] = ACTIONS(627),
    [sym__special_character] = ACTIONS(627),
  },
  [712] = {
    [anon_sym_BQUOTE] = ACTIONS(553),
    [sym_raw_string] = ACTIONS(553),
    [anon_sym_COLON_QMARK] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(553),
    [anon_sym_EQ] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(553),
    [anon_sym_PERCENT] = ACTIONS(551),
    [anon_sym_COLON] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(553),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [sym_word] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [anon_sym_LT_LPAREN] = ACTIONS(553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(553),
    [anon_sym_COLON_DASH] = ACTIONS(551),
    [sym__special_character] = ACTIONS(551),
  },
  [713] = {
    [anon_sym_BQUOTE] = ACTIONS(557),
    [sym_raw_string] = ACTIONS(557),
    [anon_sym_COLON_QMARK] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(557),
    [anon_sym_EQ] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(557),
    [anon_sym_PERCENT] = ACTIONS(555),
    [anon_sym_COLON] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(557),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [sym_word] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [anon_sym_LT_LPAREN] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(557),
    [anon_sym_COLON_DASH] = ACTIONS(555),
    [sym__special_character] = ACTIONS(555),
  },
  [714] = {
    [anon_sym_BQUOTE] = ACTIONS(561),
    [sym_raw_string] = ACTIONS(561),
    [anon_sym_COLON_QMARK] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(559),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(561),
    [anon_sym_DQUOTE] = ACTIONS(561),
    [sym_word] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [anon_sym_LT_LPAREN] = ACTIONS(561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(561),
    [anon_sym_COLON_DASH] = ACTIONS(559),
    [sym__special_character] = ACTIONS(559),
  },
  [715] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2520),
  },
  [716] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [717] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2504),
  },
  [718] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1217),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1217),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2522),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2524),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2524),
    [anon_sym_PERCENT] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2528),
    [anon_sym_COLON_DASH] = ACTIONS(2524),
    [sym__special_character] = ACTIONS(599),
  },
  [719] = {
    [sym_subscript] = STATE(1218),
    [anon_sym_STAR] = ACTIONS(2530),
    [anon_sym_QMARK] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2530),
    [sym_variable_name] = ACTIONS(2532),
    [anon_sym_DOLLAR] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_0] = ACTIONS(2536),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2536),
    [anon_sym__] = ACTIONS(2536),
  },
  [720] = {
    [anon_sym_EQ] = ACTIONS(2538),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [721] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1224),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1224),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2540),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2542),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2542),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2542),
    [anon_sym_PERCENT] = ACTIONS(2542),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2546),
    [anon_sym_COLON_DASH] = ACTIONS(2542),
    [sym__special_character] = ACTIONS(599),
  },
  [722] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [723] = {
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_COLON_QMARK] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(939),
    [anon_sym_COLON] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_word] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(941),
    [anon_sym_COLON_DASH] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
  },
  [724] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2550),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [725] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(2552),
    [sym_raw_string] = ACTIONS(2555),
    [anon_sym_COLON_QMARK] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2561),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2566),
    [anon_sym_EQ] = ACTIONS(2558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2569),
    [anon_sym_PERCENT] = ACTIONS(2558),
    [anon_sym_COLON] = ACTIONS(2558),
    [anon_sym_GT_LPAREN] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2575),
    [sym_word] = ACTIONS(2578),
    [anon_sym_LT_LPAREN] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2581),
    [anon_sym_COLON_DASH] = ACTIONS(2558),
    [sym__special_character] = ACTIONS(2584),
  },
  [726] = {
    [anon_sym_BQUOTE] = ACTIONS(221),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_COLON_QMARK] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_RBRACE] = ACTIONS(221),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
    [anon_sym_PERCENT] = ACTIONS(219),
    [anon_sym_COLON] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [sym_word] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(221),
    [anon_sym_COLON_DASH] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
  },
  [727] = {
    [aux_sym__literal_repeat1] = STATE(727),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_COLON_QMARK] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_RBRACE] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
    [anon_sym_PERCENT] = ACTIONS(1187),
    [anon_sym_COLON] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_word] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1192),
    [anon_sym_COLON_DASH] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(2587),
  },
  [728] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1210),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1210),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2514),
    [anon_sym_COLON_DASH] = ACTIONS(2510),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2590),
  },
  [729] = {
    [sym_process_substitution] = STATE(1228),
    [aux_sym__literal_repeat1] = STATE(1230),
    [sym_simple_expansion] = STATE(1228),
    [sym_string_expansion] = STATE(1228),
    [sym_expansion] = STATE(1228),
    [sym_concatenation] = STATE(1229),
    [sym_string] = STATE(1228),
    [sym_command_substitution] = STATE(1228),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(2592),
    [sym_raw_string] = ACTIONS(2592),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [730] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1233),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1233),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2594),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2594),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2594),
    [anon_sym_PERCENT] = ACTIONS(2594),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2598),
    [anon_sym_COLON_DASH] = ACTIONS(2594),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2600),
  },
  [731] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [ts_builtin_sym_end] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [732] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [733] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1234),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [734] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1237),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2606),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [735] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [sym__concat] = ACTIONS(2610),
  },
  [736] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1240),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [737] = {
    [sym_string] = STATE(1242),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [anon_sym_STAR] = ACTIONS(2612),
    [anon_sym_QMARK] = ACTIONS(2612),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_POUND] = ACTIONS(2616),
    [anon_sym_DASH] = ACTIONS(2616),
    [anon_sym_0] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2618),
    [anon_sym__] = ACTIONS(2618),
  },
  [738] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1244),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1245),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [739] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(221),
    [sym__concat] = ACTIONS(2610),
    [sym__special_character] = ACTIONS(219),
  },
  [740] = {
    [sym_subscript] = STATE(1246),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_AT] = ACTIONS(2620),
    [sym_variable_name] = ACTIONS(2624),
    [anon_sym_DOLLAR] = ACTIONS(2626),
    [anon_sym_DASH] = ACTIONS(2626),
    [anon_sym_0] = ACTIONS(2628),
    [anon_sym_POUND] = ACTIONS(2622),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2628),
    [anon_sym__] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
  },
  [741] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2512),
  },
  [742] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2632),
  },
  [743] = {
    [aux_sym_concatenation_repeat1] = STATE(1015),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(2636),
  },
  [744] = {
    [anon_sym_RBRACK] = ACTIONS(2634),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(2638),
  },
  [745] = {
    [aux_sym__literal_repeat1] = STATE(1020),
    [anon_sym_RBRACK] = ACTIONS(2640),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(2642),
    [sym__special_character] = ACTIONS(2000),
  },
  [746] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2644),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [747] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1259),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1259),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2648),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2648),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2652),
    [anon_sym_COLON_DASH] = ACTIONS(2648),
    [sym__special_character] = ACTIONS(599),
  },
  [748] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [749] = {
    [sym_compound_statement] = STATE(1260),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
  },
  [750] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2654),
    [anon_sym_BQUOTE] = ACTIONS(2654),
    [anon_sym_AMP_GT_GT] = ACTIONS(2654),
    [anon_sym_LF] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym_LT_LT] = ACTIONS(2654),
    [sym_file_descriptor] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2654),
    [anon_sym_RPAREN] = ACTIONS(2654),
    [anon_sym_AMP_GT] = ACTIONS(2654),
    [anon_sym_fi] = ACTIONS(2654),
    [anon_sym_else] = ACTIONS(2654),
    [anon_sym_done] = ACTIONS(2654),
    [anon_sym_PIPE_PIPE] = ACTIONS(2654),
    [ts_builtin_sym_end] = ACTIONS(2656),
    [anon_sym_LT_LT_LT] = ACTIONS(2654),
    [anon_sym_PIPE] = ACTIONS(2654),
    [anon_sym_GT_AMP] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym_LT_AMP] = ACTIONS(2654),
    [anon_sym_GT_GT] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(2654),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_esac] = ACTIONS(2654),
    [anon_sym_SEMI_SEMI] = ACTIONS(2654),
    [anon_sym_PIPE_AMP] = ACTIONS(2654),
  },
  [751] = {
    [sym_string] = STATE(85),
    [anon_sym__] = ACTIONS(143),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(2660),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(2660),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_EQ_TILDE] = ACTIONS(2658),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(2664),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_RPAREN] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [ts_builtin_sym_end] = ACTIONS(2662),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [752] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1214),
    [anon_sym_AMP_GT_GT] = ACTIONS(1214),
    [anon_sym_LF] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_LT_LT] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_GT] = ACTIONS(1214),
    [sym_file_descriptor] = ACTIONS(1216),
    [anon_sym_AMP_GT] = ACTIONS(1214),
    [anon_sym_PIPE_PIPE] = ACTIONS(1214),
    [anon_sym_LT_LT_LT] = ACTIONS(1214),
    [anon_sym_PIPE] = ACTIONS(1214),
    [anon_sym_GT_AMP] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_LT_AMP] = ACTIONS(1214),
    [anon_sym_GT_GT] = ACTIONS(1214),
    [anon_sym_AMP] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1214),
    [anon_sym_SEMI_SEMI] = ACTIONS(1214),
    [anon_sym_PIPE_AMP] = ACTIONS(1214),
  },
  [753] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2666),
  },
  [754] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [755] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [756] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2670),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [757] = {
    [sym_process_substitution] = STATE(1264),
    [sym_string_expansion] = STATE(1264),
    [sym_expansion] = STATE(1264),
    [sym_simple_expansion] = STATE(1264),
    [sym_string] = STATE(1264),
    [sym_command_substitution] = STATE(1264),
    [anon_sym_BQUOTE] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(1561),
    [sym_word] = ACTIONS(2674),
    [sym_raw_string] = ACTIONS(2674),
    [anon_sym_LT_LPAREN] = ACTIONS(2676),
    [anon_sym_DOLLAR] = ACTIONS(633),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2678),
    [sym__special_character] = ACTIONS(2674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2680),
  },
  [758] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(2682),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [759] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2684),
  },
  [760] = {
    [sym_process_substitution] = STATE(1269),
    [aux_sym__literal_repeat1] = STATE(1271),
    [sym_array] = STATE(1270),
    [sym_simple_expansion] = STATE(1269),
    [sym_string_expansion] = STATE(1269),
    [sym_expansion] = STATE(1269),
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(1269),
    [sym_command_substitution] = STATE(1269),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [anon_sym_BQUOTE] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(1561),
    [sym_word] = ACTIONS(2688),
    [sym_raw_string] = ACTIONS(2688),
    [anon_sym_LT_LPAREN] = ACTIONS(2676),
    [anon_sym_DOLLAR] = ACTIONS(633),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2678),
    [sym__special_character] = ACTIONS(2690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2680),
    [sym__empty_value] = ACTIONS(2692),
  },
  [761] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [762] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [763] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [764] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [765] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2666),
  },
  [766] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1274),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1274),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2694),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2696),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2696),
    [anon_sym_PERCENT] = ACTIONS(2696),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2700),
    [anon_sym_COLON_DASH] = ACTIONS(2696),
    [sym__special_character] = ACTIONS(599),
  },
  [767] = {
    [sym_subscript] = STATE(1275),
    [anon_sym_STAR] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [sym_variable_name] = ACTIONS(2704),
    [anon_sym_DOLLAR] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_0] = ACTIONS(2708),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2708),
    [anon_sym__] = ACTIONS(2708),
  },
  [768] = {
    [anon_sym_EQ] = ACTIONS(2710),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [769] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1281),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1281),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2712),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2714),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2714),
    [anon_sym_PERCENT] = ACTIONS(2714),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2718),
    [anon_sym_COLON_DASH] = ACTIONS(2714),
    [sym__special_character] = ACTIONS(599),
  },
  [770] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [771] = {
    [aux_sym__literal_repeat1] = STATE(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(2720),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [772] = {
    [sym_process_substitution] = STATE(350),
    [sym_string] = STATE(350),
    [sym_command_substitution] = STATE(350),
    [sym_simple_expansion] = STATE(350),
    [sym_variable_assignment] = STATE(772),
    [sym_subscript] = STATE(359),
    [sym_string_expansion] = STATE(350),
    [sym_expansion] = STATE(350),
    [sym_concatenation] = STATE(772),
    [aux_sym_declaration_command_repeat1] = STATE(772),
    [aux_sym__literal_repeat1] = STATE(357),
    [anon_sym_AMP_GT_GT] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_LPAREN] = ACTIONS(2726),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2729),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2735),
    [anon_sym_PIPE_PIPE] = ACTIONS(1320),
    [sym_word] = ACTIONS(2738),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_AMP] = ACTIONS(1320),
    [anon_sym_LT] = ACTIONS(1320),
    [anon_sym_LT_AMP] = ACTIONS(1320),
    [anon_sym_GT_GT] = ACTIONS(1320),
    [sym__special_character] = ACTIONS(2741),
    [anon_sym_LT_LT_DASH] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [anon_sym_LF] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_raw_string] = ACTIONS(2738),
    [sym_variable_name] = ACTIONS(2747),
    [sym_file_descriptor] = ACTIONS(1346),
    [anon_sym_RBRACE] = ACTIONS(1320),
    [anon_sym_GT] = ACTIONS(1320),
    [anon_sym_AMP_GT] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_AMP] = ACTIONS(1320),
    [anon_sym_LT_LPAREN] = ACTIONS(2726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1320),
    [anon_sym_SEMI_SEMI] = ACTIONS(1320),
    [anon_sym_PIPE_AMP] = ACTIONS(1320),
  },
  [773] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2753),
  },
  [774] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(2755),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [775] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [776] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2757),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [777] = {
    [sym_process_substitution] = STATE(1285),
    [sym_string_expansion] = STATE(1285),
    [sym_expansion] = STATE(1285),
    [sym_simple_expansion] = STATE(1285),
    [sym_string] = STATE(1285),
    [sym_command_substitution] = STATE(1285),
    [anon_sym_BQUOTE] = ACTIONS(2759),
    [anon_sym_DQUOTE] = ACTIONS(1591),
    [sym_word] = ACTIONS(2761),
    [sym_raw_string] = ACTIONS(2761),
    [anon_sym_LT_LPAREN] = ACTIONS(2763),
    [anon_sym_DOLLAR] = ACTIONS(653),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2765),
    [sym__special_character] = ACTIONS(2761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2767),
  },
  [778] = {
    [aux_sym_concatenation_repeat1] = STATE(1287),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(2769),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [779] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2771),
  },
  [780] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [781] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [782] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [783] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [784] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2753),
  },
  [785] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1291),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1291),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2773),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2775),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2775),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2779),
    [anon_sym_COLON_DASH] = ACTIONS(2775),
    [sym__special_character] = ACTIONS(599),
  },
  [786] = {
    [sym_subscript] = STATE(1292),
    [anon_sym_STAR] = ACTIONS(2781),
    [anon_sym_QMARK] = ACTIONS(2781),
    [anon_sym_AT] = ACTIONS(2781),
    [sym_variable_name] = ACTIONS(2783),
    [anon_sym_DOLLAR] = ACTIONS(2785),
    [anon_sym_DASH] = ACTIONS(2785),
    [anon_sym_0] = ACTIONS(2787),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2787),
    [anon_sym__] = ACTIONS(2787),
  },
  [787] = {
    [anon_sym_EQ] = ACTIONS(2789),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [788] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1298),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1298),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2791),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2793),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2795),
    [anon_sym_DASH] = ACTIONS(2793),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2793),
    [anon_sym_PERCENT] = ACTIONS(2793),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2797),
    [anon_sym_COLON_DASH] = ACTIONS(2793),
    [sym__special_character] = ACTIONS(599),
  },
  [789] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [790] = {
    [aux_sym__literal_repeat1] = STATE(790),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(2799),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [791] = {
    [sym_process_substitution] = STATE(362),
    [sym_command_substitution] = STATE(362),
    [aux_sym_unset_command_repeat1] = STATE(791),
    [sym_simple_expansion] = STATE(362),
    [sym_string_expansion] = STATE(362),
    [sym_expansion] = STATE(362),
    [sym_concatenation] = STATE(791),
    [sym_string] = STATE(362),
    [aux_sym__literal_repeat1] = STATE(368),
    [anon_sym_AMP_GT_GT] = ACTIONS(1403),
    [anon_sym_DOLLAR] = ACTIONS(2802),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_LPAREN] = ACTIONS(2805),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2808),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2811),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2814),
    [anon_sym_PIPE_PIPE] = ACTIONS(1403),
    [sym_word] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_LT_AMP] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [sym__special_character] = ACTIONS(2820),
    [anon_sym_LT_LT_DASH] = ACTIONS(1403),
    [anon_sym_BQUOTE] = ACTIONS(2823),
    [anon_sym_LF] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(2817),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1403),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_AMP_GT] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(2826),
    [anon_sym_LT_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_AMP] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1403),
    [anon_sym_PIPE_AMP] = ACTIONS(1403),
  },
  [792] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_EQ_TILDE] = ACTIONS(1434),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [793] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_EQ_TILDE] = ACTIONS(1440),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [794] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1301),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1301),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2829),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2833),
    [anon_sym_COLON_DASH] = ACTIONS(2829),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2835),
  },
  [795] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_EQ_TILDE] = ACTIONS(1476),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [796] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [797] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1301),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1301),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2837),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2829),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2829),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2833),
    [anon_sym_COLON_DASH] = ACTIONS(2829),
    [sym__special_character] = ACTIONS(599),
  },
  [798] = {
    [anon_sym_EQ] = ACTIONS(2839),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [799] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1306),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1306),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(2841),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2843),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2847),
    [anon_sym_COLON_DASH] = ACTIONS(2843),
    [sym__special_character] = ACTIONS(599),
  },
  [800] = {
    [sym_process_substitution] = STATE(1307),
    [aux_sym__literal_repeat1] = STATE(1309),
    [sym_simple_expansion] = STATE(1307),
    [sym_string_expansion] = STATE(1307),
    [sym_expansion] = STATE(1307),
    [sym_concatenation] = STATE(1308),
    [sym_string] = STATE(1307),
    [sym_command_substitution] = STATE(1307),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(2849),
    [sym_raw_string] = ACTIONS(2849),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [801] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1312),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1312),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(2851),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2855),
    [anon_sym_COLON_DASH] = ACTIONS(2851),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(2857),
  },
  [802] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1532),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [803] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [804] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2859),
  },
  [805] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1538),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_RBRACE] = ACTIONS(1538),
    [anon_sym_GT] = ACTIONS(1538),
    [sym_file_descriptor] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT_LT_LT] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP] = ACTIONS(1538),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_SEMI_SEMI] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
  },
  [806] = {
    [sym_compound_statement] = STATE(1314),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
  },
  [807] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [808] = {
    [sym_process_substitution] = STATE(807),
    [sym_string_expansion] = STATE(807),
    [sym_expansion] = STATE(807),
    [sym_simple_expansion] = STATE(807),
    [sym_string] = STATE(807),
    [sym_command_substitution] = STATE(807),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(209),
    [sym_word] = ACTIONS(1649),
    [sym_raw_string] = ACTIONS(1649),
    [anon_sym_LT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR] = ACTIONS(2861),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(181),
    [sym__special_character] = ACTIONS(1649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(183),
  },
  [809] = {
    [aux_sym_concatenation_repeat1] = STATE(809),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(2863),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [810] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1733),
    [anon_sym_AMP_GT_GT] = ACTIONS(1733),
    [anon_sym_LF] = ACTIONS(1735),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_RBRACE] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1733),
    [sym_file_descriptor] = ACTIONS(1735),
    [anon_sym_AMP_GT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1733),
    [anon_sym_LT_LT_LT] = ACTIONS(1733),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_GT_AMP] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_AMP] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1733),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
    [anon_sym_PIPE_AMP] = ACTIONS(1733),
  },
  [811] = {
    [sym_redirected_statement] = STATE(905),
    [sym_if_statement] = STATE(905),
    [sym_elif_clause] = STATE(1318),
    [sym_function_definition] = STATE(905),
    [sym_compound_statement] = STATE(905),
    [sym_test_command] = STATE(905),
    [sym_declaration_command] = STATE(905),
    [sym_subscript] = STATE(906),
    [sym_file_redirect] = STATE(908),
    [sym_concatenation] = STATE(907),
    [sym_string] = STATE(899),
    [sym_command_substitution] = STATE(899),
    [sym_process_substitution] = STATE(899),
    [aux_sym_command_repeat1] = STATE(908),
    [sym_for_statement] = STATE(905),
    [sym_c_style_for_statement] = STATE(905),
    [sym_else_clause] = STATE(1317),
    [sym_case_statement] = STATE(905),
    [sym_subshell] = STATE(905),
    [sym_pipeline] = STATE(905),
    [sym_unset_command] = STATE(905),
    [sym_command] = STATE(905),
    [sym_simple_expansion] = STATE(899),
    [aux_sym_if_statement_repeat1] = STATE(1318),
    [sym__statements] = STATE(1319),
    [sym_while_statement] = STATE(905),
    [sym_list] = STATE(905),
    [sym_negated_command] = STATE(905),
    [sym_command_name] = STATE(912),
    [sym_variable_assignment] = STATE(913),
    [sym_string_expansion] = STATE(899),
    [sym_expansion] = STATE(899),
    [aux_sym__statements_repeat1] = STATE(914),
    [aux_sym__literal_repeat1] = STATE(915),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1770),
    [anon_sym_typeset] = ACTIONS(1770),
    [anon_sym_unsetenv] = ACTIONS(1772),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [anon_sym_else] = ACTIONS(1780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
    [anon_sym_fi] = ACTIONS(2866),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1770),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(1790),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1770),
    [sym_variable_name] = ACTIONS(1796),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1770),
    [anon_sym_unset] = ACTIONS(1772),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [anon_sym_elif] = ACTIONS(1800),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [812] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(2868),
  },
  [813] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_SEMI_SEMI] = ACTIONS(2872),
    [anon_sym_AMP] = ACTIONS(2872),
  },
  [814] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(2874),
  },
  [815] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_SEMI_SEMI] = ACTIONS(2878),
    [anon_sym_AMP] = ACTIONS(2878),
  },
  [816] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_RBRACE] = ACTIONS(1914),
    [anon_sym_GT] = ACTIONS(1914),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [817] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1325),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1325),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(2880),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [818] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1326),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [819] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1329),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2882),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(2884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [820] = {
    [aux_sym_concatenation_repeat1] = STATE(1331),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(2886),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1960),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [821] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1332),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [822] = {
    [sym_string] = STATE(1334),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_STAR] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2888),
    [sym_raw_string] = ACTIONS(2890),
    [anon_sym_AT] = ACTIONS(2888),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [anon_sym_POUND] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_0] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2894),
    [anon_sym__] = ACTIONS(2894),
  },
  [823] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1336),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1337),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [824] = {
    [aux_sym_concatenation_repeat1] = STATE(1331),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(2886),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [825] = {
    [sym_subscript] = STATE(1338),
    [anon_sym_STAR] = ACTIONS(2896),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_BANG] = ACTIONS(2898),
    [anon_sym_AT] = ACTIONS(2896),
    [sym_variable_name] = ACTIONS(2900),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_0] = ACTIONS(2904),
    [anon_sym_POUND] = ACTIONS(2898),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2904),
    [anon_sym__] = ACTIONS(2904),
    [sym_comment] = ACTIONS(3),
  },
  [826] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1960),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [827] = {
    [aux_sym__literal_repeat1] = STATE(1343),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(2906),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [828] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2010),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [829] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(2908),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [830] = {
    [sym_process_substitution] = STATE(1037),
    [sym_command_substitution] = STATE(1037),
    [aux_sym_for_statement_repeat1] = STATE(1345),
    [sym_simple_expansion] = STATE(1037),
    [sym_string_expansion] = STATE(1037),
    [sym_expansion] = STATE(1037),
    [sym_concatenation] = STATE(1345),
    [sym_string] = STATE(1037),
    [aux_sym__literal_repeat1] = STATE(1043),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [sym_word] = ACTIONS(2069),
    [sym_raw_string] = ACTIONS(2069),
    [anon_sym_LT_LPAREN] = ACTIONS(2071),
    [anon_sym_DOLLAR] = ACTIONS(2073),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2075),
    [sym__special_character] = ACTIONS(2077),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2079),
  },
  [831] = {
    [sym_do_group] = STATE(1346),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(1703),
  },
  [832] = {
    [sym_process_substitution] = STATE(549),
    [sym_postfix_expression] = STATE(1348),
    [sym_parenthesized_expression] = STATE(1348),
    [sym_command_substitution] = STATE(549),
    [sym_simple_expansion] = STATE(549),
    [sym__expression] = STATE(1348),
    [sym_string_expansion] = STATE(549),
    [sym_expansion] = STATE(549),
    [sym_binary_expression] = STATE(1348),
    [sym_unary_expression] = STATE(1348),
    [sym_concatenation] = STATE(1348),
    [sym_string] = STATE(549),
    [aux_sym__literal_repeat1] = STATE(557),
    [sym_test_operator] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [sym_raw_string] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(2910),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(2910),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [anon_sym_GT_LPAREN] = ACTIONS(981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_word] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LT_LPAREN] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(2910),
  },
  [833] = {
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [sym_test_operator] = ACTIONS(2127),
    [anon_sym_LF] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2912),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(2912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_SEMI_SEMI] = ACTIONS(2912),
    [anon_sym_DASH_EQ] = ACTIONS(2125),
  },
  [834] = {
    [sym_redirected_statement] = STATE(1086),
    [sym_if_statement] = STATE(1086),
    [sym_function_definition] = STATE(1086),
    [sym_compound_statement] = STATE(1086),
    [sym_test_command] = STATE(1086),
    [sym_declaration_command] = STATE(1086),
    [sym_subscript] = STATE(1087),
    [sym_file_redirect] = STATE(1089),
    [sym_concatenation] = STATE(1088),
    [sym_string] = STATE(1081),
    [sym_command_substitution] = STATE(1081),
    [sym_process_substitution] = STATE(1081),
    [aux_sym_command_repeat1] = STATE(1089),
    [sym_for_statement] = STATE(1086),
    [sym_c_style_for_statement] = STATE(1086),
    [sym_case_statement] = STATE(1086),
    [sym_subshell] = STATE(1086),
    [sym_pipeline] = STATE(1086),
    [sym_unset_command] = STATE(1086),
    [sym_command] = STATE(1086),
    [sym_simple_expansion] = STATE(1081),
    [sym__statements] = STATE(1351),
    [sym_while_statement] = STATE(1086),
    [sym_list] = STATE(1086),
    [sym_negated_command] = STATE(1086),
    [sym_command_name] = STATE(1091),
    [sym_variable_assignment] = STATE(1092),
    [sym_string_expansion] = STATE(1081),
    [sym_expansion] = STATE(1081),
    [aux_sym__statements_repeat1] = STATE(1093),
    [aux_sym__literal_repeat1] = STATE(1094),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(2135),
    [anon_sym_typeset] = ACTIONS(2135),
    [anon_sym_unsetenv] = ACTIONS(2137),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [anon_sym_done] = ACTIONS(2914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(2135),
    [sym__special_character] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(2153),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_declare] = ACTIONS(2135),
    [sym_variable_name] = ACTIONS(2159),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(2135),
    [anon_sym_unset] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [835] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2163),
    [anon_sym_AMP_GT_GT] = ACTIONS(2163),
    [anon_sym_LF] = ACTIONS(2165),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_LT_LT] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2163),
    [sym_file_descriptor] = ACTIONS(2165),
    [anon_sym_AMP_GT] = ACTIONS(2163),
    [anon_sym_PIPE_PIPE] = ACTIONS(2163),
    [anon_sym_LT_LT_LT] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2163),
    [anon_sym_GT_AMP] = ACTIONS(2163),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_LT_AMP] = ACTIONS(2163),
    [anon_sym_GT_GT] = ACTIONS(2163),
    [anon_sym_AMP] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2163),
    [anon_sym_SEMI_SEMI] = ACTIONS(2163),
    [anon_sym_PIPE_AMP] = ACTIONS(2163),
  },
  [836] = {
    [aux_sym_redirected_statement_repeat1] = STATE(410),
    [sym_file_redirect] = STATE(410),
    [sym_herestring_redirect] = STATE(410),
    [sym_heredoc_redirect] = STATE(410),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [837] = {
    [aux_sym_redirected_statement_repeat1] = STATE(410),
    [sym_file_redirect] = STATE(410),
    [sym_herestring_redirect] = STATE(410),
    [sym_heredoc_redirect] = STATE(410),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [838] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1352),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [839] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1355),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(2916),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [840] = {
    [aux_sym_concatenation_repeat1] = STATE(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym__concat] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [841] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1358),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [842] = {
    [sym_string] = STATE(1360),
    [anon_sym_DQUOTE] = ACTIONS(1707),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [sym_raw_string] = ACTIONS(2924),
    [anon_sym_AT] = ACTIONS(2922),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_POUND] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_0] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2928),
    [anon_sym__] = ACTIONS(2928),
  },
  [843] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1362),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1363),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [844] = {
    [aux_sym_concatenation_repeat1] = STATE(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym__concat] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [845] = {
    [sym_subscript] = STATE(1364),
    [anon_sym_STAR] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_AT] = ACTIONS(2930),
    [sym_variable_name] = ACTIONS(2934),
    [anon_sym_DOLLAR] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2936),
    [anon_sym_0] = ACTIONS(2938),
    [anon_sym_POUND] = ACTIONS(2932),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2938),
    [anon_sym__] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
  },
  [846] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [847] = {
    [aux_sym__literal_repeat1] = STATE(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [sym__special_character] = ACTIONS(2940),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
  },
  [848] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_LF] = ACTIONS(2247),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym_SEMI_SEMI] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2245),
  },
  [849] = {
    [sym_expansion] = STATE(1371),
    [aux_sym_heredoc_body_repeat1] = STATE(1371),
    [sym_simple_expansion] = STATE(1371),
    [sym_command_substitution] = STATE(1371),
    [anon_sym_DOLLAR] = ACTIONS(2249),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2253),
    [sym__heredoc_body_end] = ACTIONS(2942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2257),
    [sym__heredoc_body_middle] = ACTIONS(2944),
  },
  [850] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_LF] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym_SEMI_SEMI] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
  },
  [851] = {
    [sym_process_substitution] = STATE(1373),
    [aux_sym__literal_repeat1] = STATE(1375),
    [sym_simple_expansion] = STATE(1373),
    [sym_string_expansion] = STATE(1373),
    [sym_expansion] = STATE(1373),
    [sym_concatenation] = STATE(1374),
    [sym_string] = STATE(1373),
    [sym_command_substitution] = STATE(1373),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1707),
    [sym_word] = ACTIONS(2950),
    [sym_raw_string] = ACTIONS(2950),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1715),
    [sym__special_character] = ACTIONS(1717),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1719),
  },
  [852] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2271),
    [anon_sym_AMP_GT_GT] = ACTIONS(2271),
    [anon_sym_LF] = ACTIONS(2273),
    [anon_sym_SEMI] = ACTIONS(2271),
    [anon_sym_LT_LT] = ACTIONS(2271),
    [anon_sym_RBRACE] = ACTIONS(2271),
    [anon_sym_GT] = ACTIONS(2271),
    [sym_file_descriptor] = ACTIONS(2273),
    [anon_sym_AMP_GT] = ACTIONS(2271),
    [anon_sym_PIPE_PIPE] = ACTIONS(2271),
    [anon_sym_LT_LT_LT] = ACTIONS(2271),
    [anon_sym_PIPE] = ACTIONS(2271),
    [anon_sym_GT_AMP] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(2271),
    [anon_sym_LT_AMP] = ACTIONS(2271),
    [anon_sym_GT_GT] = ACTIONS(2271),
    [anon_sym_AMP] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2271),
    [anon_sym_SEMI_SEMI] = ACTIONS(2271),
    [anon_sym_PIPE_AMP] = ACTIONS(2271),
  },
  [853] = {
    [aux_sym_redirected_statement_repeat1] = STATE(410),
    [sym_file_redirect] = STATE(410),
    [sym_herestring_redirect] = STATE(410),
    [sym_heredoc_redirect] = STATE(410),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_RBRACE] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [sym_file_descriptor] = ACTIONS(2277),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
  },
  [854] = {
    [aux_sym_redirected_statement_repeat1] = STATE(410),
    [sym_file_redirect] = STATE(410),
    [sym_herestring_redirect] = STATE(410),
    [sym_heredoc_redirect] = STATE(410),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_RBRACE] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(727),
  },
  [855] = {
    [aux_sym_concatenation_repeat1] = STATE(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [anon_sym_RBRACE] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym__concat] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [856] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [anon_sym_RBRACE] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [857] = {
    [aux_sym__literal_repeat1] = STATE(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LT_LT] = ACTIONS(2283),
    [anon_sym_RBRACE] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [sym_file_descriptor] = ACTIONS(2285),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_LT_LT_LT] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_GT_AMP] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_LT_AMP] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [sym__special_character] = ACTIONS(2940),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
  },
  [858] = {
    [aux_sym_redirected_statement_repeat1] = STATE(858),
    [sym_file_redirect] = STATE(858),
    [sym_herestring_redirect] = STATE(858),
    [sym_heredoc_redirect] = STATE(858),
    [anon_sym_LT_LT_DASH] = ACTIONS(2952),
    [anon_sym_AMP_GT_GT] = ACTIONS(2955),
    [anon_sym_LF] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2955),
    [sym_file_descriptor] = ACTIONS(2958),
    [anon_sym_AMP_GT] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT_LT_LT] = ACTIONS(2961),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(2955),
    [anon_sym_LT] = ACTIONS(2955),
    [anon_sym_LT_AMP] = ACTIONS(2955),
    [anon_sym_GT_GT] = ACTIONS(2955),
    [anon_sym_AMP] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
  },
  [859] = {
    [sym_process_substitution] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [aux_sym_command_repeat2] = STATE(863),
    [sym_concatenation] = STATE(863),
    [sym_string] = STATE(413),
    [aux_sym__literal_repeat1] = STATE(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(177),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [sym_word] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_LT_AMP] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_TILDE] = ACTIONS(741),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(743),
    [anon_sym_LF] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [sym_raw_string] = ACTIONS(739),
    [sym_file_descriptor] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_AMP] = ACTIONS(2303),
    [anon_sym_LT_LPAREN] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_SEMI_SEMI] = ACTIONS(2303),
    [anon_sym_PIPE_AMP] = ACTIONS(2303),
  },
  [860] = {
    [aux_sym_concatenation_repeat1] = STATE(383),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [sym__concat] = ACTIONS(693),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [861] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [862] = {
    [aux_sym__literal_repeat1] = STATE(420),
    [anon_sym_AMP_GT_GT] = ACTIONS(2311),
    [anon_sym_DOLLAR] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [sym_word] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_LT_AMP] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(2311),
    [anon_sym_EQ_TILDE] = ACTIONS(2311),
    [sym__special_character] = ACTIONS(747),
    [anon_sym_LT_LT_DASH] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [sym_raw_string] = ACTIONS(2311),
    [sym_file_descriptor] = ACTIONS(2313),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP_GT] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_LT_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_AMP] = ACTIONS(2311),
    [anon_sym_LT_LPAREN] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_SEMI_SEMI] = ACTIONS(2311),
    [anon_sym_PIPE_AMP] = ACTIONS(2311),
  },
  [863] = {
    [sym_process_substitution] = STATE(413),
    [sym_command_substitution] = STATE(413),
    [sym_simple_expansion] = STATE(413),
    [sym_string_expansion] = STATE(413),
    [sym_expansion] = STATE(413),
    [aux_sym_command_repeat2] = STATE(863),
    [sym_concatenation] = STATE(863),
    [sym_string] = STATE(413),
    [aux_sym__literal_repeat1] = STATE(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2967),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2970),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2976),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2979),
    [sym__special_character] = ACTIONS(2982),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2976),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [864] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [865] = {
    [sym_heredoc_body] = STATE(1376),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1721),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(2263),
    [anon_sym_GT] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1723),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [866] = {
    [aux_sym_concatenation_repeat1] = STATE(1377),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(1279),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [867] = {
    [sym_process_substitution] = STATE(1378),
    [aux_sym__literal_repeat1] = STATE(1379),
    [sym_array] = STATE(673),
    [sym_simple_expansion] = STATE(1378),
    [sym_string_expansion] = STATE(1378),
    [sym_expansion] = STATE(1378),
    [sym_concatenation] = STATE(673),
    [sym_string] = STATE(1378),
    [sym_command_substitution] = STATE(1378),
    [anon_sym_LPAREN] = ACTIONS(1283),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [sym_word] = ACTIONS(2991),
    [sym_raw_string] = ACTIONS(2991),
    [anon_sym_LT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1275),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1277),
    [sym__empty_value] = ACTIONS(1289),
  },
  [868] = {
    [aux_sym__literal_repeat1] = STATE(868),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1317),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [869] = {
    [sym_process_substitution] = STATE(421),
    [sym_string] = STATE(421),
    [sym_command_substitution] = STATE(421),
    [sym_simple_expansion] = STATE(421),
    [sym_variable_assignment] = STATE(869),
    [sym_subscript] = STATE(426),
    [sym_string_expansion] = STATE(421),
    [sym_expansion] = STATE(421),
    [sym_concatenation] = STATE(869),
    [aux_sym_declaration_command_repeat1] = STATE(869),
    [aux_sym__literal_repeat1] = STATE(424),
    [anon_sym_AMP_GT_GT] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(1322),
    [anon_sym_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_LPAREN] = ACTIONS(1325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1328),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1334),
    [anon_sym_PIPE_PIPE] = ACTIONS(1320),
    [sym_word] = ACTIONS(2998),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_AMP] = ACTIONS(1320),
    [anon_sym_LT] = ACTIONS(1320),
    [anon_sym_LT_AMP] = ACTIONS(1320),
    [anon_sym_GT_GT] = ACTIONS(1320),
    [sym__special_character] = ACTIONS(3001),
    [anon_sym_LT_LT_DASH] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(1343),
    [anon_sym_LF] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_raw_string] = ACTIONS(2998),
    [sym_variable_name] = ACTIONS(3004),
    [sym_file_descriptor] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1320),
    [anon_sym_AMP_GT] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_AMP] = ACTIONS(1320),
    [anon_sym_LT_LPAREN] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1320),
    [anon_sym_SEMI_SEMI] = ACTIONS(1320),
    [anon_sym_PIPE_AMP] = ACTIONS(1320),
  },
  [870] = {
    [aux_sym_concatenation_repeat1] = STATE(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(1370),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [871] = {
    [aux_sym__literal_repeat1] = STATE(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [872] = {
    [sym_process_substitution] = STATE(427),
    [sym_command_substitution] = STATE(427),
    [aux_sym_unset_command_repeat1] = STATE(872),
    [sym_simple_expansion] = STATE(427),
    [sym_string_expansion] = STATE(427),
    [sym_expansion] = STATE(427),
    [sym_concatenation] = STATE(872),
    [sym_string] = STATE(427),
    [aux_sym__literal_repeat1] = STATE(429),
    [anon_sym_AMP_GT_GT] = ACTIONS(1403),
    [anon_sym_DOLLAR] = ACTIONS(1405),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_LPAREN] = ACTIONS(1408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1411),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3007),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1417),
    [anon_sym_PIPE_PIPE] = ACTIONS(1403),
    [sym_word] = ACTIONS(3010),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_LT_AMP] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [sym__special_character] = ACTIONS(3013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1403),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [anon_sym_LF] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(3010),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_AMP_GT] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [anon_sym_LT_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_AMP] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1403),
    [anon_sym_PIPE_AMP] = ACTIONS(1403),
  },
  [873] = {
    [aux_sym_concatenation_repeat1] = STATE(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1548),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [874] = {
    [aux_sym_concatenation_repeat1] = STATE(1381),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(1962),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [875] = {
    [aux_sym_concatenation_repeat1] = STATE(1381),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(1962),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [876] = {
    [aux_sym__literal_repeat1] = STATE(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(1986),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [877] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [878] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [879] = {
    [aux_sym_concatenation_repeat1] = STATE(1383),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [880] = {
    [aux_sym_concatenation_repeat1] = STATE(1383),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [881] = {
    [aux_sym__literal_repeat1] = STATE(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
  },
  [882] = {
    [sym_process_substitution] = STATE(1385),
    [aux_sym__literal_repeat1] = STATE(1386),
    [sym_simple_expansion] = STATE(1385),
    [sym_string_expansion] = STATE(1385),
    [sym_expansion] = STATE(1385),
    [sym_concatenation] = STATE(1142),
    [sym_string] = STATE(1385),
    [sym_command_substitution] = STATE(1385),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(3016),
    [sym_raw_string] = ACTIONS(3016),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1760),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [883] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [sym_file_descriptor] = ACTIONS(2277),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
  },
  [884] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
  },
  [885] = {
    [aux_sym_concatenation_repeat1] = STATE(1383),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [886] = {
    [aux_sym__literal_repeat1] = STATE(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LT_LT] = ACTIONS(2283),
    [sym_file_descriptor] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_LT_LT_LT] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_GT_AMP] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_LT_AMP] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
  },
  [887] = {
    [aux_sym_redirected_statement_repeat1] = STATE(887),
    [sym_file_redirect] = STATE(887),
    [sym_herestring_redirect] = STATE(887),
    [sym_heredoc_redirect] = STATE(887),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_AMP_GT_GT] = ACTIONS(3018),
    [anon_sym_LF] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2287),
    [sym_file_descriptor] = ACTIONS(3021),
    [anon_sym_GT] = ACTIONS(3018),
    [anon_sym_AMP_GT] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT_LT_LT] = ACTIONS(3024),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3018),
    [anon_sym_LT_AMP] = ACTIONS(3018),
    [anon_sym_GT_GT] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
  },
  [888] = {
    [sym_process_substitution] = STATE(442),
    [sym_command_substitution] = STATE(442),
    [sym_simple_expansion] = STATE(442),
    [sym_string_expansion] = STATE(442),
    [sym_expansion] = STATE(442),
    [aux_sym_command_repeat2] = STATE(918),
    [sym_concatenation] = STATE(918),
    [sym_string] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [sym_word] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_LT_AMP] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_LF] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [sym_raw_string] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_AMP] = ACTIONS(2303),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_SEMI_SEMI] = ACTIONS(2303),
    [anon_sym_PIPE_AMP] = ACTIONS(2303),
  },
  [889] = {
    [sym_process_substitution] = STATE(1389),
    [sym_string] = STATE(1389),
    [sym_command_substitution] = STATE(1389),
    [sym_simple_expansion] = STATE(1389),
    [sym_variable_assignment] = STATE(1397),
    [sym_subscript] = STATE(1398),
    [sym_string_expansion] = STATE(1389),
    [sym_expansion] = STATE(1389),
    [sym_concatenation] = STATE(1397),
    [aux_sym_declaration_command_repeat1] = STATE(1397),
    [aux_sym__literal_repeat1] = STATE(1396),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_fi] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(3029),
    [anon_sym_else] = ACTIONS(91),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3031),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(3037),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(3039),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(3037),
    [sym_variable_name] = ACTIONS(3043),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(3029),
    [anon_sym_elif] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [890] = {
    [sym_process_substitution] = STATE(1401),
    [sym_command_substitution] = STATE(1401),
    [aux_sym_unset_command_repeat1] = STATE(1408),
    [sym_simple_expansion] = STATE(1401),
    [sym_string_expansion] = STATE(1401),
    [sym_expansion] = STATE(1401),
    [sym_concatenation] = STATE(1408),
    [sym_string] = STATE(1401),
    [aux_sym__literal_repeat1] = STATE(1407),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_fi] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3053),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(3057),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(3059),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(3061),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(3057),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(3049),
    [anon_sym_elif] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [891] = {
    [sym_string] = STATE(1410),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3065),
    [sym_raw_string] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3069),
    [anon_sym_POUND] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_0] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3071),
    [anon_sym__] = ACTIONS(3071),
  },
  [892] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1412),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [893] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1413),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1414),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [894] = {
    [sym_redirected_statement] = STATE(1428),
    [sym_if_statement] = STATE(1428),
    [sym_function_definition] = STATE(1428),
    [sym_compound_statement] = STATE(1428),
    [sym_test_command] = STATE(1428),
    [sym_declaration_command] = STATE(1428),
    [sym_subscript] = STATE(1429),
    [sym_file_redirect] = STATE(1431),
    [sym_concatenation] = STATE(1430),
    [sym_string] = STATE(1423),
    [sym_command_substitution] = STATE(1423),
    [sym_process_substitution] = STATE(1423),
    [aux_sym_command_repeat1] = STATE(1431),
    [sym_for_statement] = STATE(1428),
    [sym_c_style_for_statement] = STATE(1428),
    [sym_case_statement] = STATE(1428),
    [sym_subshell] = STATE(1428),
    [sym_pipeline] = STATE(1428),
    [sym_unset_command] = STATE(1428),
    [sym_command] = STATE(1428),
    [sym_simple_expansion] = STATE(1423),
    [sym__statements] = STATE(1432),
    [sym_while_statement] = STATE(1428),
    [sym_list] = STATE(1428),
    [sym_negated_command] = STATE(1428),
    [sym_command_name] = STATE(1433),
    [sym_variable_assignment] = STATE(1434),
    [sym_string_expansion] = STATE(1423),
    [sym_expansion] = STATE(1423),
    [aux_sym__statements_repeat1] = STATE(1435),
    [aux_sym__literal_repeat1] = STATE(1436),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3073),
    [anon_sym_typeset] = ACTIONS(3073),
    [anon_sym_unsetenv] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_fi] = ACTIONS(3079),
    [anon_sym_GT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3073),
    [sym__special_character] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_declare] = ACTIONS(3073),
    [sym_variable_name] = ACTIONS(3097),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3073),
    [anon_sym_unset] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3081),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [895] = {
    [sym_subscript] = STATE(1437),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3103),
    [anon_sym_AT] = ACTIONS(3101),
    [sym_variable_name] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_0] = ACTIONS(3109),
    [anon_sym_POUND] = ACTIONS(3103),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3109),
    [anon_sym__] = ACTIONS(3109),
    [sym_comment] = ACTIONS(3),
  },
  [896] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3111),
    [anon_sym_BQUOTE] = ACTIONS(3111),
    [anon_sym_AMP_GT_GT] = ACTIONS(3111),
    [anon_sym_LF] = ACTIONS(3113),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_LT_LT] = ACTIONS(3111),
    [sym_file_descriptor] = ACTIONS(3113),
    [anon_sym_GT] = ACTIONS(3111),
    [anon_sym_RPAREN] = ACTIONS(3111),
    [anon_sym_AMP_GT] = ACTIONS(3111),
    [anon_sym_fi] = ACTIONS(3111),
    [anon_sym_else] = ACTIONS(3111),
    [anon_sym_done] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [ts_builtin_sym_end] = ACTIONS(3113),
    [anon_sym_LT_LT_LT] = ACTIONS(3111),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_GT_AMP] = ACTIONS(3111),
    [anon_sym_LT] = ACTIONS(3111),
    [anon_sym_LT_AMP] = ACTIONS(3111),
    [anon_sym_GT_GT] = ACTIONS(3111),
    [anon_sym_AMP] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_esac] = ACTIONS(3111),
    [anon_sym_SEMI_SEMI] = ACTIONS(3111),
    [anon_sym_PIPE_AMP] = ACTIONS(3111),
  },
  [897] = {
    [aux_sym_concatenation_repeat1] = STATE(1442),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_fi] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(3115),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_elif] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [898] = {
    [aux_sym_concatenation_repeat1] = STATE(1442),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(3115),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_elif] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [899] = {
    [aux_sym_concatenation_repeat1] = STATE(1442),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_fi] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(3115),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_elif] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [900] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1443),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [901] = {
    [sym_simple_expansion] = STATE(899),
    [sym_test_command] = STATE(179),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(908),
    [sym_concatenation] = STATE(907),
    [sym_string] = STATE(899),
    [sym_command_substitution] = STATE(899),
    [sym_process_substitution] = STATE(899),
    [sym_command_name] = STATE(912),
    [aux_sym_command_repeat1] = STATE(908),
    [sym_variable_assignment] = STATE(908),
    [sym_string_expansion] = STATE(899),
    [sym_expansion] = STATE(899),
    [sym_subshell] = STATE(179),
    [sym_command] = STATE(179),
    [aux_sym__literal_repeat1] = STATE(915),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(1790),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [sym_word] = ACTIONS(1790),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(1788),
  },
  [902] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(3117),
  },
  [903] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1447),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [904] = {
    [sym_redirected_statement] = STATE(140),
    [sym_if_statement] = STATE(140),
    [sym_function_definition] = STATE(140),
    [sym_compound_statement] = STATE(140),
    [sym_test_command] = STATE(140),
    [sym_declaration_command] = STATE(140),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(140),
    [sym_c_style_for_statement] = STATE(140),
    [sym_case_statement] = STATE(140),
    [sym_subshell] = STATE(140),
    [sym_pipeline] = STATE(140),
    [sym_unset_command] = STATE(140),
    [sym_command] = STATE(140),
    [sym_simple_expansion] = STATE(137),
    [sym__terminated_statement] = STATE(1448),
    [sym_while_statement] = STATE(140),
    [sym_list] = STATE(140),
    [sym_negated_command] = STATE(140),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(145),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [905] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1456),
    [sym_file_redirect] = STATE(1456),
    [sym_herestring_redirect] = STATE(1456),
    [sym_heredoc_redirect] = STATE(1456),
    [anon_sym_SEMI_SEMI] = ACTIONS(3123),
    [anon_sym_AMP_GT_GT] = ACTIONS(3125),
    [anon_sym_LF] = ACTIONS(3127),
    [anon_sym_SEMI] = ACTIONS(3123),
    [sym_file_descriptor] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_fi] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(3125),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_LT_LT_LT] = ACTIONS(3133),
    [anon_sym_GT_AMP] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_LT_AMP] = ACTIONS(3125),
    [anon_sym_elif] = ACTIONS(413),
    [anon_sym_GT_GT] = ACTIONS(3125),
    [anon_sym_PIPE] = ACTIONS(3135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_PIPE_AMP] = ACTIONS(3135),
  },
  [906] = {
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_PLUS_EQ] = ACTIONS(3117),
    [sym_comment] = ACTIONS(51),
  },
  [907] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_fi] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_else] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_elif] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [908] = {
    [sym_process_substitution] = STATE(899),
    [sym_command_substitution] = STATE(899),
    [sym_command_name] = STATE(1457),
    [sym_simple_expansion] = STATE(899),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [sym_string_expansion] = STATE(899),
    [sym_expansion] = STATE(899),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_concatenation] = STATE(907),
    [sym_string] = STATE(899),
    [aux_sym__literal_repeat1] = STATE(915),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(1790),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [sym_word] = ACTIONS(1790),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3137),
  },
  [909] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3139),
  },
  [910] = {
    [sym_elif_clause] = STATE(1460),
    [sym_else_clause] = STATE(1459),
    [aux_sym_if_statement_repeat1] = STATE(1460),
    [anon_sym_elif] = ACTIONS(3141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3139),
    [anon_sym_else] = ACTIONS(3143),
  },
  [911] = {
    [sym_elif_clause] = STATE(1461),
    [sym_else_clause] = STATE(1459),
    [aux_sym_if_statement_repeat1] = STATE(1461),
    [anon_sym_elif] = ACTIONS(3141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3139),
    [anon_sym_else] = ACTIONS(3143),
  },
  [912] = {
    [sym_process_substitution] = STATE(1462),
    [sym_command_substitution] = STATE(1462),
    [sym_simple_expansion] = STATE(1462),
    [sym_string_expansion] = STATE(1462),
    [sym_expansion] = STATE(1462),
    [aux_sym_command_repeat2] = STATE(1465),
    [sym_concatenation] = STATE(1465),
    [sym_string] = STATE(1462),
    [aux_sym__literal_repeat1] = STATE(1464),
    [anon_sym_AMP_GT_GT] = ACTIONS(367),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_LT_LT] = ACTIONS(367),
    [anon_sym_fi] = ACTIONS(367),
    [anon_sym_GT_LPAREN] = ACTIONS(3145),
    [anon_sym_else] = ACTIONS(367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3149),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [sym_word] = ACTIONS(3151),
    [anon_sym_PIPE] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(367),
    [anon_sym_GT_GT] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(3153),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_LT_LT_DASH] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(3155),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(3151),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_AMP_GT] = ACTIONS(367),
    [anon_sym_EQ_EQ] = ACTIONS(3153),
    [anon_sym_DQUOTE] = ACTIONS(3157),
    [anon_sym_LT_LT_LT] = ACTIONS(367),
    [anon_sym_GT_AMP] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(3145),
    [anon_sym_elif] = ACTIONS(367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
  },
  [913] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1456),
    [sym_file_redirect] = STATE(1456),
    [sym_herestring_redirect] = STATE(1456),
    [sym_heredoc_redirect] = STATE(1456),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_fi] = ACTIONS(413),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(3127),
    [anon_sym_SEMI] = ACTIONS(3123),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(3133),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [anon_sym_elif] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_SEMI_SEMI] = ACTIONS(3123),
    [anon_sym_PIPE_AMP] = ACTIONS(3135),
  },
  [914] = {
    [sym_redirected_statement] = STATE(1466),
    [sym_if_statement] = STATE(1466),
    [sym_function_definition] = STATE(1466),
    [sym_compound_statement] = STATE(1466),
    [sym_test_command] = STATE(1466),
    [sym_declaration_command] = STATE(1466),
    [sym_subscript] = STATE(906),
    [sym_file_redirect] = STATE(908),
    [sym_concatenation] = STATE(907),
    [sym_string] = STATE(899),
    [sym_command_substitution] = STATE(899),
    [sym_process_substitution] = STATE(899),
    [aux_sym_command_repeat1] = STATE(908),
    [sym_for_statement] = STATE(1466),
    [sym_c_style_for_statement] = STATE(1466),
    [sym_case_statement] = STATE(1466),
    [sym_subshell] = STATE(1466),
    [sym_pipeline] = STATE(1466),
    [sym_unset_command] = STATE(1466),
    [sym_command] = STATE(1466),
    [sym_simple_expansion] = STATE(899),
    [sym_while_statement] = STATE(1466),
    [sym_list] = STATE(1466),
    [sym_negated_command] = STATE(1466),
    [sym_command_name] = STATE(912),
    [sym_variable_assignment] = STATE(1467),
    [sym_string_expansion] = STATE(899),
    [sym_expansion] = STATE(899),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(915),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1770),
    [anon_sym_typeset] = ACTIONS(1770),
    [anon_sym_unsetenv] = ACTIONS(1772),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1770),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(1790),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1770),
    [sym_variable_name] = ACTIONS(1796),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1770),
    [anon_sym_unset] = ACTIONS(1772),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [915] = {
    [aux_sym__literal_repeat1] = STATE(1469),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_fi] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_else] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_EQ_TILDE] = ACTIONS(389),
    [sym__special_character] = ACTIONS(3159),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [anon_sym_elif] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [916] = {
    [aux_sym_concatenation_repeat1] = STATE(431),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [917] = {
    [aux_sym__literal_repeat1] = STATE(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(2311),
    [anon_sym_DOLLAR] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [sym_word] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_LT_AMP] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(2311),
    [anon_sym_EQ_TILDE] = ACTIONS(2311),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [sym_raw_string] = ACTIONS(2311),
    [sym_file_descriptor] = ACTIONS(2313),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP_GT] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_LT_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_AMP] = ACTIONS(2311),
    [anon_sym_LT_LPAREN] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_SEMI_SEMI] = ACTIONS(2311),
    [anon_sym_PIPE_AMP] = ACTIONS(2311),
  },
  [918] = {
    [sym_process_substitution] = STATE(442),
    [sym_command_substitution] = STATE(442),
    [sym_simple_expansion] = STATE(442),
    [sym_string_expansion] = STATE(442),
    [sym_expansion] = STATE(442),
    [aux_sym_command_repeat2] = STATE(918),
    [sym_concatenation] = STATE(918),
    [sym_string] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2318),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2324),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(3164),
    [sym__special_character] = ACTIONS(3167),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2336),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(3161),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(2339),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [919] = {
    [anon_sym_AMP] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_in] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
  },
  [920] = {
    [anon_sym_AMP] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_in] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
  },
  [921] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [922] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(3172),
    [anon_sym_SEMI] = ACTIONS(3174),
    [anon_sym_SEMI_SEMI] = ACTIONS(3174),
    [anon_sym_AMP] = ACTIONS(3174),
  },
  [923] = {
    [anon_sym_AMP] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_in] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
  },
  [924] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(1476),
    [sym_case_item] = STATE(1477),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(1477),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3176),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_esac] = ACTIONS(3180),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [925] = {
    [sym_process_substitution] = STATE(923),
    [sym_string_expansion] = STATE(923),
    [sym_expansion] = STATE(923),
    [sym_simple_expansion] = STATE(923),
    [sym_string] = STATE(923),
    [sym_command_substitution] = STATE(923),
    [anon_sym_BQUOTE] = ACTIONS(237),
    [anon_sym_DQUOTE] = ACTIONS(239),
    [sym_word] = ACTIONS(1812),
    [sym_raw_string] = ACTIONS(1812),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(3184),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(247),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(251),
  },
  [926] = {
    [aux_sym_concatenation_repeat1] = STATE(926),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3186),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_in] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
  },
  [927] = {
    [anon_sym_AMP] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_in] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
  },
  [928] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1482),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1482),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3189),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3189),
    [anon_sym_PERCENT] = ACTIONS(3189),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3193),
    [anon_sym_COLON_DASH] = ACTIONS(3189),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3195),
  },
  [929] = {
    [anon_sym_AMP] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_in] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
  },
  [930] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [931] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1482),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1482),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3197),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3189),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3189),
    [anon_sym_PERCENT] = ACTIONS(3189),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3193),
    [anon_sym_COLON_DASH] = ACTIONS(3189),
    [sym__special_character] = ACTIONS(599),
  },
  [932] = {
    [anon_sym_EQ] = ACTIONS(3199),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [933] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1487),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1487),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3201),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3203),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3203),
    [anon_sym_PERCENT] = ACTIONS(3203),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3207),
    [anon_sym_COLON_DASH] = ACTIONS(3203),
    [sym__special_character] = ACTIONS(599),
  },
  [934] = {
    [sym_process_substitution] = STATE(1488),
    [aux_sym__literal_repeat1] = STATE(1490),
    [sym_simple_expansion] = STATE(1488),
    [sym_string_expansion] = STATE(1488),
    [sym_expansion] = STATE(1488),
    [sym_concatenation] = STATE(1489),
    [sym_string] = STATE(1488),
    [sym_command_substitution] = STATE(1488),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3209),
    [sym_raw_string] = ACTIONS(3209),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [935] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1493),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1493),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3211),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3211),
    [anon_sym_PERCENT] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3215),
    [anon_sym_COLON_DASH] = ACTIONS(3211),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3217),
  },
  [936] = {
    [anon_sym_AMP] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_in] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
  },
  [937] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [938] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_SEMI_SEMI] = ACTIONS(3221),
    [anon_sym_AMP] = ACTIONS(3221),
  },
  [939] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(1496),
    [sym_case_item] = STATE(1497),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(1497),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3176),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_esac] = ACTIONS(3223),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [940] = {
    [anon_sym_BANG_EQ] = ACTIONS(1859),
    [anon_sym_PLUS_EQ] = ACTIONS(1859),
    [sym_test_operator] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(1857),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_EQ] = ACTIONS(1863),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_PIPE] = ACTIONS(1859),
    [anon_sym_GT_EQ] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1863),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1865),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(1859),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_DASH_EQ] = ACTIONS(1859),
  },
  [941] = {
    [aux_sym_concatenation_repeat1] = STATE(1498),
    [anon_sym_BANG_EQ] = ACTIONS(631),
    [anon_sym_PLUS_EQ] = ACTIONS(631),
    [sym_test_operator] = ACTIONS(631),
    [anon_sym_PLUS_PLUS] = ACTIONS(631),
    [anon_sym_RPAREN] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_EQ] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(631),
    [anon_sym_PIPE_PIPE] = ACTIONS(631),
    [anon_sym_GT_EQ] = ACTIONS(631),
    [sym__concat] = ACTIONS(1873),
    [anon_sym_PLUS] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(631),
    [anon_sym_DASH_DASH] = ACTIONS(631),
    [anon_sym_LT_EQ] = ACTIONS(631),
    [anon_sym_AMP_AMP] = ACTIONS(631),
    [anon_sym_DASH_EQ] = ACTIONS(631),
  },
  [942] = {
    [aux_sym__literal_repeat1] = STATE(942),
    [anon_sym_BANG_EQ] = ACTIONS(1192),
    [anon_sym_PLUS_EQ] = ACTIONS(1192),
    [sym_test_operator] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1192),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1192),
    [anon_sym_DASH_DASH] = ACTIONS(1192),
    [anon_sym_LT_EQ] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [sym__special_character] = ACTIONS(1905),
    [anon_sym_DASH_EQ] = ACTIONS(1192),
  },
  [943] = {
    [sym_process_substitution] = STATE(471),
    [sym_postfix_expression] = STATE(963),
    [sym_parenthesized_expression] = STATE(963),
    [sym_command_substitution] = STATE(471),
    [sym_simple_expansion] = STATE(471),
    [sym__expression] = STATE(963),
    [sym_string_expansion] = STATE(471),
    [sym_expansion] = STATE(471),
    [sym_binary_expression] = STATE(963),
    [sym_unary_expression] = STATE(963),
    [sym_concatenation] = STATE(963),
    [sym_string] = STATE(471),
    [aux_sym__literal_repeat1] = STATE(473),
    [sym_test_operator] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(827),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [944] = {
    [anon_sym_BANG_EQ] = ACTIONS(3225),
    [anon_sym_PLUS_EQ] = ACTIONS(3225),
    [sym_test_operator] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_RPAREN] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_GT] = ACTIONS(3227),
    [anon_sym_EQ] = ACTIONS(3227),
    [anon_sym_EQ_EQ] = ACTIONS(3225),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3225),
    [anon_sym_PIPE_PIPE] = ACTIONS(3225),
    [anon_sym_GT_EQ] = ACTIONS(3225),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3227),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [anon_sym_LT_EQ] = ACTIONS(3225),
    [anon_sym_AMP_AMP] = ACTIONS(3225),
    [anon_sym_DASH_EQ] = ACTIONS(3225),
  },
  [945] = {
    [sym_process_substitution] = STATE(471),
    [sym_postfix_expression] = STATE(963),
    [sym_parenthesized_expression] = STATE(963),
    [sym_command_substitution] = STATE(471),
    [sym_simple_expansion] = STATE(471),
    [sym__expression] = STATE(963),
    [sym_string_expansion] = STATE(471),
    [sym_expansion] = STATE(471),
    [sym_binary_expression] = STATE(963),
    [sym_unary_expression] = STATE(963),
    [sym_concatenation] = STATE(963),
    [sym_string] = STATE(471),
    [aux_sym__literal_repeat1] = STATE(473),
    [sym_test_operator] = ACTIONS(825),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_raw_string] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(827),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(833),
    [sym_regex] = ACTIONS(1912),
  },
  [946] = {
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [sym_test_operator] = ACTIONS(2012),
    [anon_sym_PLUS_PLUS] = ACTIONS(2012),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2012),
    [anon_sym_DASH_DASH] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
  },
  [947] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3229),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [948] = {
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_PLUS_EQ] = ACTIONS(1544),
    [sym_test_operator] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1544),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1544),
    [anon_sym_DASH_EQ] = ACTIONS(1544),
  },
  [949] = {
    [sym_process_substitution] = STATE(948),
    [sym_string_expansion] = STATE(948),
    [sym_expansion] = STATE(948),
    [sym_simple_expansion] = STATE(948),
    [sym_string] = STATE(948),
    [sym_command_substitution] = STATE(948),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(1871),
    [sym_raw_string] = ACTIONS(1871),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(3231),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(1871),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [950] = {
    [aux_sym_concatenation_repeat1] = STATE(950),
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_PLUS_EQ] = ACTIONS(1544),
    [sym_test_operator] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1544),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1544),
    [anon_sym_DASH_EQ] = ACTIONS(1544),
  },
  [951] = {
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [sym_test_operator] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1442),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
  },
  [952] = {
    [anon_sym_BANG_EQ] = ACTIONS(1436),
    [anon_sym_PLUS_EQ] = ACTIONS(1436),
    [sym_test_operator] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1436),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1436),
    [anon_sym_PIPE_PIPE] = ACTIONS(1436),
    [anon_sym_GT_EQ] = ACTIONS(1436),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1436),
    [anon_sym_AMP_AMP] = ACTIONS(1436),
    [anon_sym_DASH_EQ] = ACTIONS(1436),
  },
  [953] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1503),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1503),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3236),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3236),
    [anon_sym_PERCENT] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3240),
    [anon_sym_COLON_DASH] = ACTIONS(3236),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3242),
  },
  [954] = {
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_PLUS_EQ] = ACTIONS(1478),
    [sym_test_operator] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1478),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_DASH_EQ] = ACTIONS(1478),
  },
  [955] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [956] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1503),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1503),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3244),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3236),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3236),
    [anon_sym_PERCENT] = ACTIONS(3236),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3240),
    [anon_sym_COLON_DASH] = ACTIONS(3236),
    [sym__special_character] = ACTIONS(599),
  },
  [957] = {
    [anon_sym_EQ] = ACTIONS(3246),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [958] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1508),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1508),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3248),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3250),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3250),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3250),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3250),
    [anon_sym_PERCENT] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3254),
    [anon_sym_COLON_DASH] = ACTIONS(3250),
    [sym__special_character] = ACTIONS(599),
  },
  [959] = {
    [sym_process_substitution] = STATE(1509),
    [aux_sym__literal_repeat1] = STATE(1511),
    [sym_simple_expansion] = STATE(1509),
    [sym_string_expansion] = STATE(1509),
    [sym_expansion] = STATE(1509),
    [sym_concatenation] = STATE(1510),
    [sym_string] = STATE(1509),
    [sym_command_substitution] = STATE(1509),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3256),
    [sym_raw_string] = ACTIONS(3256),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [960] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1514),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1514),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3258),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3258),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3258),
    [anon_sym_PERCENT] = ACTIONS(3258),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3262),
    [anon_sym_COLON_DASH] = ACTIONS(3258),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3264),
  },
  [961] = {
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_PLUS_EQ] = ACTIONS(1534),
    [sym_test_operator] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1534),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_GT_EQ] = ACTIONS(1534),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1534),
    [anon_sym_DASH_DASH] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_DASH_EQ] = ACTIONS(1534),
  },
  [962] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [963] = {
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_PLUS_EQ] = ACTIONS(3266),
    [sym_test_operator] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_RPAREN] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_DASH_EQ] = ACTIONS(3266),
  },
  [964] = {
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_PLUS_EQ] = ACTIONS(3266),
    [sym_test_operator] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_RPAREN] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_DASH_EQ] = ACTIONS(3266),
  },
  [965] = {
    [aux_sym_redirected_statement_repeat1] = STATE(506),
    [sym_file_redirect] = STATE(506),
    [sym_herestring_redirect] = STATE(506),
    [sym_heredoc_redirect] = STATE(506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2215),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [966] = {
    [aux_sym_redirected_statement_repeat1] = STATE(506),
    [sym_file_redirect] = STATE(506),
    [sym_herestring_redirect] = STATE(506),
    [sym_heredoc_redirect] = STATE(506),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2215),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [967] = {
    [aux_sym_concatenation_repeat1] = STATE(1515),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [968] = {
    [aux_sym_concatenation_repeat1] = STATE(1515),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [969] = {
    [aux_sym__literal_repeat1] = STATE(1516),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_BQUOTE] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
  },
  [970] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_LF] = ACTIONS(3270),
    [anon_sym_SEMI] = ACTIONS(3272),
    [anon_sym_SEMI_SEMI] = ACTIONS(3272),
    [anon_sym_AMP] = ACTIONS(3272),
  },
  [971] = {
    [sym_process_substitution] = STATE(1518),
    [aux_sym__literal_repeat1] = STATE(1519),
    [sym_simple_expansion] = STATE(1518),
    [sym_string_expansion] = STATE(1518),
    [sym_expansion] = STATE(1518),
    [sym_concatenation] = STATE(1142),
    [sym_string] = STATE(1518),
    [sym_command_substitution] = STATE(1518),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(3274),
    [sym_raw_string] = ACTIONS(3274),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(1920),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [972] = {
    [aux_sym_redirected_statement_repeat1] = STATE(506),
    [sym_file_redirect] = STATE(506),
    [sym_herestring_redirect] = STATE(506),
    [sym_heredoc_redirect] = STATE(506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [sym_file_descriptor] = ACTIONS(2277),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
  },
  [973] = {
    [aux_sym_redirected_statement_repeat1] = STATE(506),
    [sym_file_redirect] = STATE(506),
    [sym_herestring_redirect] = STATE(506),
    [sym_heredoc_redirect] = STATE(506),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
  },
  [974] = {
    [aux_sym_concatenation_repeat1] = STATE(1515),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_BQUOTE] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [975] = {
    [aux_sym__literal_repeat1] = STATE(1516),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_BQUOTE] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LT_LT] = ACTIONS(2283),
    [sym_file_descriptor] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_LT_LT_LT] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_GT_AMP] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_LT_AMP] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
  },
  [976] = {
    [aux_sym_redirected_statement_repeat1] = STATE(976),
    [sym_file_redirect] = STATE(976),
    [sym_herestring_redirect] = STATE(976),
    [sym_heredoc_redirect] = STATE(976),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2295),
    [anon_sym_AMP_GT_GT] = ACTIONS(3276),
    [anon_sym_LF] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2287),
    [sym_file_descriptor] = ACTIONS(3279),
    [anon_sym_GT] = ACTIONS(3276),
    [anon_sym_AMP_GT] = ACTIONS(3276),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT_LT_LT] = ACTIONS(3282),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_LT_AMP] = ACTIONS(3276),
    [anon_sym_GT_GT] = ACTIONS(3276),
    [anon_sym_AMP] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
  },
  [977] = {
    [sym_process_substitution] = STATE(442),
    [sym_command_substitution] = STATE(442),
    [sym_simple_expansion] = STATE(442),
    [sym_string_expansion] = STATE(442),
    [sym_expansion] = STATE(442),
    [aux_sym_command_repeat2] = STATE(918),
    [sym_concatenation] = STATE(918),
    [sym_string] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(369),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [sym_word] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_LT_AMP] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_TILDE] = ACTIONS(785),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(2303),
    [anon_sym_LF] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [sym_raw_string] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(785),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_AMP] = ACTIONS(2303),
    [anon_sym_LT_LPAREN] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_SEMI_SEMI] = ACTIONS(2303),
    [anon_sym_PIPE_AMP] = ACTIONS(2303),
  },
  [978] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(2263),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [979] = {
    [sym_heredoc_body] = STATE(1520),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(2263),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [980] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1522),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1522),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(3285),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [981] = {
    [aux_sym_concatenation_repeat1] = STATE(263),
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym_variable_name] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [sym_word] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [sym__concat] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1964),
  },
  [982] = {
    [anon_sym_BQUOTE] = ACTIONS(1964),
    [anon_sym_AMP_GT_GT] = ACTIONS(1964),
    [sym_raw_string] = ACTIONS(1964),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [sym_file_descriptor] = ACTIONS(1964),
    [sym_variable_name] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_GT_LPAREN] = ACTIONS(1964),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [sym_word] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1964),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1964),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_LT_LPAREN] = ACTIONS(1964),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1964),
  },
  [983] = {
    [aux_sym__literal_repeat1] = STATE(275),
    [anon_sym_BQUOTE] = ACTIONS(1988),
    [anon_sym_AMP_GT_GT] = ACTIONS(1988),
    [sym_raw_string] = ACTIONS(1988),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [sym_file_descriptor] = ACTIONS(1988),
    [sym_variable_name] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1988),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1988),
    [anon_sym_GT_LPAREN] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1988),
    [sym_word] = ACTIONS(1988),
    [anon_sym_GT_AMP] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1988),
    [anon_sym_LT_LPAREN] = ACTIONS(1988),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(463),
  },
  [984] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1523),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [985] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1526),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(3287),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [986] = {
    [aux_sym_concatenation_repeat1] = STATE(1528),
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [sym_word] = ACTIONS(3291),
    [sym_raw_string] = ACTIONS(3291),
    [sym__concat] = ACTIONS(3293),
    [anon_sym_LT_LPAREN] = ACTIONS(3291),
    [anon_sym_DOLLAR] = ACTIONS(3295),
    [anon_sym_RPAREN] = ACTIONS(3291),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3291),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3291),
    [sym__special_character] = ACTIONS(3291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3291),
  },
  [987] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1529),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [988] = {
    [sym_string] = STATE(1531),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [anon_sym_STAR] = ACTIONS(3297),
    [anon_sym_QMARK] = ACTIONS(3297),
    [sym_raw_string] = ACTIONS(3299),
    [anon_sym_AT] = ACTIONS(3297),
    [anon_sym_DOLLAR] = ACTIONS(3301),
    [anon_sym_POUND] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_0] = ACTIONS(3303),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3303),
    [anon_sym__] = ACTIONS(3303),
  },
  [989] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_RPAREN] = ACTIONS(3305),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [ts_builtin_sym_end] = ACTIONS(3307),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [990] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1533),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1534),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [991] = {
    [aux_sym_concatenation_repeat1] = STATE(1528),
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [sym_word] = ACTIONS(221),
    [sym_raw_string] = ACTIONS(221),
    [sym__concat] = ACTIONS(3293),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [sym__special_character] = ACTIONS(221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
  },
  [992] = {
    [sym_subscript] = STATE(1535),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_QMARK] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_AT] = ACTIONS(3309),
    [sym_variable_name] = ACTIONS(3313),
    [anon_sym_DOLLAR] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_0] = ACTIONS(3317),
    [anon_sym_POUND] = ACTIONS(3311),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3317),
    [anon_sym__] = ACTIONS(3317),
    [sym_comment] = ACTIONS(3),
  },
  [993] = {
    [aux_sym__literal_repeat1] = STATE(1540),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [sym_word] = ACTIONS(3319),
    [sym_raw_string] = ACTIONS(3319),
    [anon_sym_LT_LPAREN] = ACTIONS(3319),
    [anon_sym_DOLLAR] = ACTIONS(3321),
    [anon_sym_RPAREN] = ACTIONS(3319),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3319),
    [sym__special_character] = ACTIONS(3323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3319),
  },
  [994] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(3325),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [995] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3327),
  },
  [996] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [997] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [998] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(3331),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [999] = {
    [sym_process_substitution] = STATE(1546),
    [sym_string_expansion] = STATE(1546),
    [sym_expansion] = STATE(1546),
    [sym_simple_expansion] = STATE(1546),
    [sym_string] = STATE(1546),
    [sym_command_substitution] = STATE(1546),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3333),
    [sym_raw_string] = ACTIONS(3333),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(3333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1000] = {
    [aux_sym_concatenation_repeat1] = STATE(1548),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(3335),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [ts_builtin_sym_end] = ACTIONS(631),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1001] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3337),
  },
  [1002] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [ts_builtin_sym_end] = ACTIONS(553),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [1003] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [ts_builtin_sym_end] = ACTIONS(557),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [1004] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(561),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [1005] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1006] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3327),
  },
  [1007] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1552),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1552),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3339),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3341),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3341),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3341),
    [anon_sym_PERCENT] = ACTIONS(3341),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3345),
    [anon_sym_COLON_DASH] = ACTIONS(3341),
    [sym__special_character] = ACTIONS(599),
  },
  [1008] = {
    [sym_subscript] = STATE(1553),
    [anon_sym_STAR] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3347),
    [anon_sym_AT] = ACTIONS(3347),
    [sym_variable_name] = ACTIONS(3349),
    [anon_sym_DOLLAR] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_0] = ACTIONS(3353),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3353),
    [anon_sym__] = ACTIONS(3353),
  },
  [1009] = {
    [anon_sym_EQ] = ACTIONS(3355),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1010] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1559),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1559),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3357),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3359),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3359),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3359),
    [anon_sym_PERCENT] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3363),
    [anon_sym_COLON_DASH] = ACTIONS(3359),
    [sym__special_character] = ACTIONS(599),
  },
  [1011] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1012] = {
    [aux_sym__literal_repeat1] = STATE(1012),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3365),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [ts_builtin_sym_end] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1013] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(3368),
    [sym__concat] = ACTIONS(3370),
    [anon_sym_EQ] = ACTIONS(3368),
  },
  [1014] = {
    [sym_process_substitution] = STATE(1098),
    [sym_string_expansion] = STATE(1098),
    [sym_expansion] = STATE(1098),
    [sym_simple_expansion] = STATE(1098),
    [sym_string] = STATE(1098),
    [sym_command_substitution] = STATE(1098),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(2173),
    [sym_raw_string] = ACTIONS(2173),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [anon_sym_RBRACK] = ACTIONS(3372),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(3374),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [1015] = {
    [aux_sym_concatenation_repeat1] = STATE(1563),
    [anon_sym_RBRACK] = ACTIONS(631),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(3376),
  },
  [1016] = {
    [anon_sym_RBRACK] = ACTIONS(3372),
    [sym_comment] = ACTIONS(51),
  },
  [1017] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(3378),
    [sym__concat] = ACTIONS(3380),
    [anon_sym_EQ] = ACTIONS(3378),
  },
  [1018] = {
    [anon_sym_RBRACK] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(221),
    [sym__special_character] = ACTIONS(219),
  },
  [1019] = {
    [anon_sym_RBRACK] = ACTIONS(3382),
    [sym_comment] = ACTIONS(51),
  },
  [1020] = {
    [aux_sym__literal_repeat1] = STATE(1020),
    [anon_sym_RBRACK] = ACTIONS(1192),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1192),
    [sym__special_character] = ACTIONS(3384),
  },
  [1021] = {
    [anon_sym_DOLLAR] = ACTIONS(3387),
    [anon_sym_BQUOTE] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3389),
    [sym__string_content] = ACTIONS(3387),
  },
  [1022] = {
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym__concat] = ACTIONS(1442),
    [sym__string_content] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1442),
  },
  [1023] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1568),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1568),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3391),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3391),
    [anon_sym_PERCENT] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3395),
    [anon_sym_COLON_DASH] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3397),
  },
  [1024] = {
    [anon_sym_BQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym__concat] = ACTIONS(1478),
    [sym__string_content] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1478),
  },
  [1025] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1026] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1568),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1568),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3399),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3391),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3391),
    [anon_sym_PERCENT] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3395),
    [anon_sym_COLON_DASH] = ACTIONS(3391),
    [sym__special_character] = ACTIONS(599),
  },
  [1027] = {
    [anon_sym_EQ] = ACTIONS(3401),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1028] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1573),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1573),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3403),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3405),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3405),
    [anon_sym_PERCENT] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3409),
    [anon_sym_COLON_DASH] = ACTIONS(3405),
    [sym__special_character] = ACTIONS(599),
  },
  [1029] = {
    [sym_process_substitution] = STATE(1574),
    [aux_sym__literal_repeat1] = STATE(1576),
    [sym_simple_expansion] = STATE(1574),
    [sym_string_expansion] = STATE(1574),
    [sym_expansion] = STATE(1574),
    [sym_concatenation] = STATE(1575),
    [sym_string] = STATE(1574),
    [sym_command_substitution] = STATE(1574),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3411),
    [sym_raw_string] = ACTIONS(3411),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1030] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1579),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1579),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3413),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3413),
    [anon_sym_PERCENT] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3417),
    [anon_sym_COLON_DASH] = ACTIONS(3413),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3419),
  },
  [1031] = {
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [sym__concat] = ACTIONS(1534),
    [sym__string_content] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1534),
  },
  [1032] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1033] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_EQ_TILDE] = ACTIONS(3421),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [ts_builtin_sym_end] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [1034] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1035] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1580),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1036] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1583),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1037] = {
    [aux_sym_concatenation_repeat1] = STATE(1585),
    [anon_sym_BQUOTE] = ACTIONS(3295),
    [sym_raw_string] = ACTIONS(3295),
    [anon_sym_LF] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_DOLLAR] = ACTIONS(3295),
    [anon_sym_GT_LPAREN] = ACTIONS(3295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [sym_word] = ACTIONS(3295),
    [sym__concat] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3295),
    [anon_sym_LT_LPAREN] = ACTIONS(3295),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3295),
    [anon_sym_SEMI_SEMI] = ACTIONS(3295),
  },
  [1038] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1586),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1039] = {
    [sym_string] = STATE(1588),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3431),
    [sym_raw_string] = ACTIONS(3433),
    [anon_sym_AT] = ACTIONS(3431),
    [anon_sym_DOLLAR] = ACTIONS(3435),
    [anon_sym_POUND] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_0] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3437),
    [anon_sym__] = ACTIONS(3437),
  },
  [1040] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1590),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1591),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1041] = {
    [aux_sym_concatenation_repeat1] = STATE(1585),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [sym__concat] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
  },
  [1042] = {
    [sym_subscript] = STATE(1592),
    [anon_sym_STAR] = ACTIONS(3439),
    [anon_sym_QMARK] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_AT] = ACTIONS(3439),
    [sym_variable_name] = ACTIONS(3443),
    [anon_sym_DOLLAR] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_0] = ACTIONS(3447),
    [anon_sym_POUND] = ACTIONS(3441),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3447),
    [anon_sym__] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
  },
  [1043] = {
    [aux_sym__literal_repeat1] = STATE(1597),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [sym_raw_string] = ACTIONS(3321),
    [anon_sym_LF] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_DOLLAR] = ACTIONS(3321),
    [anon_sym_GT_LPAREN] = ACTIONS(3321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [sym_word] = ACTIONS(3321),
    [anon_sym_AMP] = ACTIONS(3321),
    [anon_sym_LT_LPAREN] = ACTIONS(3321),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3449),
    [anon_sym_SEMI_SEMI] = ACTIONS(3321),
  },
  [1044] = {
    [sym_process_substitution] = STATE(1037),
    [sym_command_substitution] = STATE(1037),
    [aux_sym_for_statement_repeat1] = STATE(1599),
    [sym_simple_expansion] = STATE(1037),
    [sym_string_expansion] = STATE(1037),
    [sym_expansion] = STATE(1037),
    [sym_concatenation] = STATE(1599),
    [sym_string] = STATE(1037),
    [aux_sym__literal_repeat1] = STATE(1043),
    [anon_sym_BQUOTE] = ACTIONS(3451),
    [sym_raw_string] = ACTIONS(3453),
    [anon_sym_LF] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym_DOLLAR] = ACTIONS(2073),
    [anon_sym_GT_LPAREN] = ACTIONS(3459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [sym_word] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_LT_LPAREN] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3467),
    [anon_sym_SEMI_SEMI] = ACTIONS(3457),
  },
  [1045] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3469),
    [anon_sym_BQUOTE] = ACTIONS(3469),
    [anon_sym_AMP_GT_GT] = ACTIONS(3469),
    [anon_sym_LF] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym_LT_LT] = ACTIONS(3469),
    [sym_file_descriptor] = ACTIONS(3471),
    [anon_sym_GT] = ACTIONS(3469),
    [anon_sym_RPAREN] = ACTIONS(3469),
    [anon_sym_AMP_GT] = ACTIONS(3469),
    [anon_sym_fi] = ACTIONS(3469),
    [anon_sym_else] = ACTIONS(3469),
    [anon_sym_done] = ACTIONS(3469),
    [anon_sym_PIPE_PIPE] = ACTIONS(3469),
    [ts_builtin_sym_end] = ACTIONS(3471),
    [anon_sym_LT_LT_LT] = ACTIONS(3469),
    [anon_sym_PIPE] = ACTIONS(3469),
    [anon_sym_GT_AMP] = ACTIONS(3469),
    [anon_sym_LT] = ACTIONS(3469),
    [anon_sym_LT_AMP] = ACTIONS(3469),
    [anon_sym_GT_GT] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_esac] = ACTIONS(3469),
    [anon_sym_SEMI_SEMI] = ACTIONS(3469),
    [anon_sym_PIPE_AMP] = ACTIONS(3469),
  },
  [1046] = {
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [sym_test_operator] = ACTIONS(2127),
    [anon_sym_LF] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(3473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_SEMI_SEMI] = ACTIONS(3473),
    [anon_sym_DASH_EQ] = ACTIONS(2125),
  },
  [1047] = {
    [anon_sym_BANG_EQ] = ACTIONS(1859),
    [anon_sym_PLUS_EQ] = ACTIONS(1859),
    [sym_test_operator] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(3475),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_EQ] = ACTIONS(1863),
    [anon_sym_EQ_EQ] = ACTIONS(1865),
    [anon_sym_PIPE_PIPE] = ACTIONS(1859),
    [anon_sym_GT_EQ] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1863),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1865),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(1859),
    [anon_sym_AMP_AMP] = ACTIONS(1859),
    [anon_sym_DASH_EQ] = ACTIONS(1859),
  },
  [1048] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3477),
  },
  [1049] = {
    [sym_process_substitution] = STATE(1602),
    [sym_string_expansion] = STATE(1602),
    [sym_expansion] = STATE(1602),
    [sym_simple_expansion] = STATE(1602),
    [sym_string] = STATE(1602),
    [sym_command_substitution] = STATE(1602),
    [anon_sym_BQUOTE] = ACTIONS(2087),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [sym_word] = ACTIONS(3479),
    [sym_raw_string] = ACTIONS(3479),
    [anon_sym_LT_LPAREN] = ACTIONS(2089),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2091),
    [sym__special_character] = ACTIONS(3479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2095),
  },
  [1050] = {
    [aux_sym_concatenation_repeat1] = STATE(1604),
    [anon_sym_BANG_EQ] = ACTIONS(627),
    [anon_sym_PLUS_EQ] = ACTIONS(627),
    [sym_test_operator] = ACTIONS(631),
    [anon_sym_LF] = ACTIONS(627),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_PLUS_PLUS] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_EQ] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_GT_EQ] = ACTIONS(627),
    [sym__concat] = ACTIONS(3481),
    [anon_sym_PLUS] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [anon_sym_DASH_DASH] = ACTIONS(627),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_LT_EQ] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_DASH_EQ] = ACTIONS(627),
  },
  [1051] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(1606),
    [sym_parenthesized_expression] = STATE(1606),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(1606),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(1606),
    [sym_unary_expression] = STATE(1606),
    [sym_concatenation] = STATE(1606),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(273),
  },
  [1052] = {
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [sym_test_operator] = ACTIONS(2127),
    [anon_sym_LF] = ACTIONS(3485),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(3485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_SEMI_SEMI] = ACTIONS(3485),
    [anon_sym_DASH_EQ] = ACTIONS(2125),
  },
  [1053] = {
    [anon_sym_BANG_EQ] = ACTIONS(551),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [sym_test_operator] = ACTIONS(553),
    [anon_sym_LF] = ACTIONS(551),
    [anon_sym_SEMI] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(551),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_EQ] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [anon_sym_GT_EQ] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_DASH_DASH] = ACTIONS(551),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_LT_EQ] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
  },
  [1054] = {
    [anon_sym_BANG_EQ] = ACTIONS(555),
    [anon_sym_PLUS_EQ] = ACTIONS(555),
    [sym_test_operator] = ACTIONS(557),
    [anon_sym_LF] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(555),
    [anon_sym_PLUS_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_EQ] = ACTIONS(555),
    [anon_sym_EQ_EQ] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_GT_EQ] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(555),
    [anon_sym_DASH_DASH] = ACTIONS(555),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_LT_EQ] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_DASH_EQ] = ACTIONS(555),
  },
  [1055] = {
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [sym_test_operator] = ACTIONS(561),
    [anon_sym_LF] = ACTIONS(559),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_DASH_DASH] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
  },
  [1056] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3487),
  },
  [1057] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(3477),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1058] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3477),
  },
  [1059] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1611),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1611),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3489),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3491),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3491),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3491),
    [anon_sym_PERCENT] = ACTIONS(3491),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3495),
    [anon_sym_COLON_DASH] = ACTIONS(3491),
    [sym__special_character] = ACTIONS(599),
  },
  [1060] = {
    [sym_subscript] = STATE(1612),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_QMARK] = ACTIONS(3497),
    [anon_sym_AT] = ACTIONS(3497),
    [sym_variable_name] = ACTIONS(3499),
    [anon_sym_DOLLAR] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3501),
    [anon_sym_0] = ACTIONS(3503),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3503),
    [anon_sym__] = ACTIONS(3503),
  },
  [1061] = {
    [anon_sym_EQ] = ACTIONS(3505),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1062] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1618),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1618),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3507),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3509),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3509),
    [anon_sym_PERCENT] = ACTIONS(3509),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3513),
    [anon_sym_COLON_DASH] = ACTIONS(3509),
    [sym__special_character] = ACTIONS(599),
  },
  [1063] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1064] = {
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [sym_test_operator] = ACTIONS(941),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_DASH_DASH] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
  },
  [1065] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1066] = {
    [anon_sym_BANG_EQ] = ACTIONS(219),
    [anon_sym_PLUS_EQ] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [sym_test_operator] = ACTIONS(221),
    [anon_sym_LF] = ACTIONS(219),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_PLUS_PLUS] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_EQ] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [anon_sym_DASH_DASH] = ACTIONS(219),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_LT_EQ] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_DASH_EQ] = ACTIONS(219),
  },
  [1067] = {
    [aux_sym__literal_repeat1] = STATE(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1187),
    [anon_sym_PLUS_EQ] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3519),
    [sym_test_operator] = ACTIONS(1192),
    [anon_sym_LF] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [anon_sym_GT_EQ] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1187),
    [anon_sym_DASH_DASH] = ACTIONS(1187),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_DASH_EQ] = ACTIONS(1187),
  },
  [1068] = {
    [sym_process_substitution] = STATE(549),
    [sym_postfix_expression] = STATE(1621),
    [sym_parenthesized_expression] = STATE(1621),
    [sym_command_substitution] = STATE(549),
    [sym_simple_expansion] = STATE(549),
    [sym__expression] = STATE(1621),
    [sym_string_expansion] = STATE(549),
    [sym_expansion] = STATE(549),
    [sym_binary_expression] = STATE(1621),
    [sym_unary_expression] = STATE(1621),
    [sym_concatenation] = STATE(1621),
    [sym_string] = STATE(549),
    [aux_sym__literal_repeat1] = STATE(557),
    [sym_test_operator] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [sym_word] = ACTIONS(973),
    [sym_raw_string] = ACTIONS(2085),
    [anon_sym_BQUOTE] = ACTIONS(2087),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(2089),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2091),
    [sym__special_character] = ACTIONS(2093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2095),
  },
  [1069] = {
    [sym_process_substitution] = STATE(549),
    [sym_postfix_expression] = STATE(1622),
    [sym_parenthesized_expression] = STATE(1622),
    [sym_command_substitution] = STATE(549),
    [sym_simple_expansion] = STATE(549),
    [sym__expression] = STATE(1622),
    [sym_string_expansion] = STATE(549),
    [sym_expansion] = STATE(549),
    [sym_binary_expression] = STATE(1622),
    [sym_unary_expression] = STATE(1622),
    [sym_concatenation] = STATE(1622),
    [sym_string] = STATE(549),
    [aux_sym__literal_repeat1] = STATE(557),
    [sym_test_operator] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [sym_raw_string] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [anon_sym_GT_LPAREN] = ACTIONS(981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_word] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(3485),
    [anon_sym_LT_LPAREN] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(3485),
  },
  [1070] = {
    [anon_sym_BANG_EQ] = ACTIONS(1910),
    [anon_sym_PLUS_EQ] = ACTIONS(1910),
    [sym_test_operator] = ACTIONS(1908),
    [anon_sym_LF] = ACTIONS(1910),
    [anon_sym_SEMI] = ACTIONS(1910),
    [anon_sym_PLUS_PLUS] = ACTIONS(1910),
    [anon_sym_DASH] = ACTIONS(1910),
    [anon_sym_GT] = ACTIONS(1910),
    [anon_sym_EQ] = ACTIONS(1910),
    [anon_sym_EQ_EQ] = ACTIONS(1910),
    [anon_sym_PIPE_PIPE] = ACTIONS(1910),
    [anon_sym_GT_EQ] = ACTIONS(1910),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_LT] = ACTIONS(1910),
    [anon_sym_AMP] = ACTIONS(1910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1910),
    [anon_sym_DASH_DASH] = ACTIONS(1910),
    [anon_sym_AMP_AMP] = ACTIONS(1910),
    [anon_sym_LT_EQ] = ACTIONS(1910),
    [anon_sym_SEMI_SEMI] = ACTIONS(1910),
    [anon_sym_DASH_EQ] = ACTIONS(1910),
  },
  [1071] = {
    [sym_process_substitution] = STATE(549),
    [sym_postfix_expression] = STATE(1621),
    [sym_parenthesized_expression] = STATE(1621),
    [sym_command_substitution] = STATE(549),
    [sym_simple_expansion] = STATE(549),
    [sym__expression] = STATE(1621),
    [sym_string_expansion] = STATE(549),
    [sym_expansion] = STATE(549),
    [sym_binary_expression] = STATE(1621),
    [sym_unary_expression] = STATE(1621),
    [sym_concatenation] = STATE(1621),
    [sym_string] = STATE(549),
    [aux_sym__literal_repeat1] = STATE(557),
    [sym_test_operator] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_BQUOTE] = ACTIONS(2087),
    [sym_raw_string] = ACTIONS(2085),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [anon_sym_GT_LPAREN] = ACTIONS(2089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2095),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [sym_word] = ACTIONS(973),
    [anon_sym_LT_LPAREN] = ACTIONS(2089),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2093),
    [sym_regex] = ACTIONS(3522),
  },
  [1072] = {
    [sym_process_substitution] = STATE(1626),
    [sym_string] = STATE(1626),
    [sym_command_substitution] = STATE(1626),
    [sym_simple_expansion] = STATE(1626),
    [sym_variable_assignment] = STATE(1634),
    [sym_subscript] = STATE(1635),
    [sym_string_expansion] = STATE(1626),
    [sym_expansion] = STATE(1626),
    [sym_concatenation] = STATE(1634),
    [aux_sym_declaration_command_repeat1] = STATE(1634),
    [aux_sym__literal_repeat1] = STATE(1633),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(3524),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(3526),
    [anon_sym_done] = ACTIONS(91),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3530),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3532),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(3534),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(3536),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(3538),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(3534),
    [sym_variable_name] = ACTIONS(3540),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(3526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [1073] = {
    [sym_process_substitution] = STATE(1638),
    [sym_command_substitution] = STATE(1638),
    [aux_sym_unset_command_repeat1] = STATE(1645),
    [sym_simple_expansion] = STATE(1638),
    [sym_string_expansion] = STATE(1638),
    [sym_expansion] = STATE(1638),
    [sym_concatenation] = STATE(1645),
    [sym_string] = STATE(1638),
    [aux_sym__literal_repeat1] = STATE(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(3544),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(3546),
    [anon_sym_done] = ACTIONS(115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3550),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3552),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(3554),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(3556),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(3558),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(3554),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(3546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [1074] = {
    [sym_string] = STATE(1647),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(3562),
    [anon_sym_QMARK] = ACTIONS(3562),
    [sym_raw_string] = ACTIONS(3564),
    [anon_sym_AT] = ACTIONS(3562),
    [anon_sym_DOLLAR] = ACTIONS(3566),
    [anon_sym_POUND] = ACTIONS(3566),
    [anon_sym_DASH] = ACTIONS(3566),
    [anon_sym_0] = ACTIONS(3568),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3568),
    [anon_sym__] = ACTIONS(3568),
  },
  [1075] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1649),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1076] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1650),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1651),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1077] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3570),
    [anon_sym_BQUOTE] = ACTIONS(3570),
    [anon_sym_AMP_GT_GT] = ACTIONS(3570),
    [anon_sym_LF] = ACTIONS(3572),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym_LT_LT] = ACTIONS(3570),
    [sym_file_descriptor] = ACTIONS(3572),
    [anon_sym_GT] = ACTIONS(3570),
    [anon_sym_RPAREN] = ACTIONS(3570),
    [anon_sym_AMP_GT] = ACTIONS(3570),
    [anon_sym_fi] = ACTIONS(3570),
    [anon_sym_else] = ACTIONS(3570),
    [anon_sym_done] = ACTIONS(3570),
    [anon_sym_PIPE_PIPE] = ACTIONS(3570),
    [ts_builtin_sym_end] = ACTIONS(3572),
    [anon_sym_LT_LT_LT] = ACTIONS(3570),
    [anon_sym_PIPE] = ACTIONS(3570),
    [anon_sym_GT_AMP] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3570),
    [anon_sym_LT_AMP] = ACTIONS(3570),
    [anon_sym_GT_GT] = ACTIONS(3570),
    [anon_sym_AMP] = ACTIONS(3570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(3570),
    [anon_sym_AMP_AMP] = ACTIONS(3570),
    [anon_sym_esac] = ACTIONS(3570),
    [anon_sym_SEMI_SEMI] = ACTIONS(3570),
    [anon_sym_PIPE_AMP] = ACTIONS(3570),
  },
  [1078] = {
    [sym_subscript] = STATE(1652),
    [anon_sym_STAR] = ACTIONS(3574),
    [anon_sym_QMARK] = ACTIONS(3574),
    [anon_sym_BANG] = ACTIONS(3576),
    [anon_sym_AT] = ACTIONS(3574),
    [sym_variable_name] = ACTIONS(3578),
    [anon_sym_DOLLAR] = ACTIONS(3580),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_0] = ACTIONS(3582),
    [anon_sym_POUND] = ACTIONS(3576),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3582),
    [anon_sym__] = ACTIONS(3582),
    [sym_comment] = ACTIONS(3),
  },
  [1079] = {
    [aux_sym_concatenation_repeat1] = STATE(1657),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_done] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(3584),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [1080] = {
    [aux_sym_concatenation_repeat1] = STATE(1657),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(3584),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1081] = {
    [aux_sym_concatenation_repeat1] = STATE(1657),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_done] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(3584),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [1082] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1658),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1083] = {
    [sym_simple_expansion] = STATE(1081),
    [sym_test_command] = STATE(179),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(1089),
    [sym_concatenation] = STATE(1088),
    [sym_string] = STATE(1081),
    [sym_command_substitution] = STATE(1081),
    [sym_process_substitution] = STATE(1081),
    [sym_command_name] = STATE(1091),
    [aux_sym_command_repeat1] = STATE(1089),
    [sym_variable_assignment] = STATE(1089),
    [sym_string_expansion] = STATE(1081),
    [sym_expansion] = STATE(1081),
    [sym_subshell] = STATE(179),
    [sym_command] = STATE(179),
    [aux_sym__literal_repeat1] = STATE(1094),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(2153),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_word] = ACTIONS(2153),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(2151),
  },
  [1084] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(3586),
  },
  [1085] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1662),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(3588),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(3590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1086] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1670),
    [sym_file_redirect] = STATE(1670),
    [sym_herestring_redirect] = STATE(1670),
    [sym_heredoc_redirect] = STATE(1670),
    [anon_sym_SEMI_SEMI] = ACTIONS(3592),
    [anon_sym_AMP_GT_GT] = ACTIONS(3594),
    [anon_sym_LF] = ACTIONS(3596),
    [anon_sym_SEMI] = ACTIONS(3592),
    [sym_file_descriptor] = ACTIONS(3598),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(3594),
    [anon_sym_done] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(3594),
    [anon_sym_PIPE_PIPE] = ACTIONS(3600),
    [anon_sym_LT_LT_LT] = ACTIONS(3602),
    [anon_sym_GT_AMP] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(3592),
    [anon_sym_LT] = ACTIONS(3594),
    [anon_sym_LT_AMP] = ACTIONS(3594),
    [anon_sym_GT_GT] = ACTIONS(3594),
    [anon_sym_PIPE] = ACTIONS(3604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3600),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_PIPE_AMP] = ACTIONS(3604),
  },
  [1087] = {
    [anon_sym_EQ] = ACTIONS(3586),
    [anon_sym_PLUS_EQ] = ACTIONS(3586),
    [sym_comment] = ACTIONS(51),
  },
  [1088] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_done] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [1089] = {
    [sym_process_substitution] = STATE(1081),
    [sym_command_substitution] = STATE(1081),
    [sym_command_name] = STATE(1671),
    [sym_simple_expansion] = STATE(1081),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [sym_string_expansion] = STATE(1081),
    [sym_expansion] = STATE(1081),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_concatenation] = STATE(1088),
    [sym_string] = STATE(1081),
    [aux_sym__literal_repeat1] = STATE(1094),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(2153),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_word] = ACTIONS(2153),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3606),
  },
  [1090] = {
    [anon_sym_done] = ACTIONS(3608),
    [sym_comment] = ACTIONS(51),
  },
  [1091] = {
    [sym_process_substitution] = STATE(1673),
    [sym_command_substitution] = STATE(1673),
    [sym_simple_expansion] = STATE(1673),
    [sym_string_expansion] = STATE(1673),
    [sym_expansion] = STATE(1673),
    [aux_sym_command_repeat2] = STATE(1676),
    [sym_concatenation] = STATE(1676),
    [sym_string] = STATE(1673),
    [aux_sym__literal_repeat1] = STATE(1675),
    [anon_sym_AMP_GT_GT] = ACTIONS(367),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(367),
    [anon_sym_GT_LPAREN] = ACTIONS(3610),
    [anon_sym_done] = ACTIONS(367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3614),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [sym_word] = ACTIONS(3616),
    [anon_sym_PIPE] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(367),
    [anon_sym_GT_GT] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(3618),
    [sym__special_character] = ACTIONS(2151),
    [anon_sym_LT_LT_DASH] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(3620),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(3616),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_AMP_GT] = ACTIONS(367),
    [anon_sym_EQ_EQ] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3622),
    [anon_sym_LT_LT_LT] = ACTIONS(367),
    [anon_sym_GT_AMP] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(3610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
  },
  [1092] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1670),
    [sym_file_redirect] = STATE(1670),
    [sym_herestring_redirect] = STATE(1670),
    [sym_heredoc_redirect] = STATE(1670),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_done] = ACTIONS(413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(3600),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(3592),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(3596),
    [anon_sym_SEMI] = ACTIONS(3592),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(3602),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3600),
    [anon_sym_SEMI_SEMI] = ACTIONS(3592),
    [anon_sym_PIPE_AMP] = ACTIONS(3604),
  },
  [1093] = {
    [sym_redirected_statement] = STATE(1677),
    [sym_if_statement] = STATE(1677),
    [sym_function_definition] = STATE(1677),
    [sym_compound_statement] = STATE(1677),
    [sym_test_command] = STATE(1677),
    [sym_declaration_command] = STATE(1677),
    [sym_subscript] = STATE(1087),
    [sym_file_redirect] = STATE(1089),
    [sym_concatenation] = STATE(1088),
    [sym_string] = STATE(1081),
    [sym_command_substitution] = STATE(1081),
    [sym_process_substitution] = STATE(1081),
    [aux_sym_command_repeat1] = STATE(1089),
    [sym_for_statement] = STATE(1677),
    [sym_c_style_for_statement] = STATE(1677),
    [sym_case_statement] = STATE(1677),
    [sym_subshell] = STATE(1677),
    [sym_pipeline] = STATE(1677),
    [sym_unset_command] = STATE(1677),
    [sym_command] = STATE(1677),
    [sym_simple_expansion] = STATE(1081),
    [sym_while_statement] = STATE(1677),
    [sym_list] = STATE(1677),
    [sym_negated_command] = STATE(1677),
    [sym_command_name] = STATE(1091),
    [sym_variable_assignment] = STATE(1678),
    [sym_string_expansion] = STATE(1081),
    [sym_expansion] = STATE(1081),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(1094),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(2135),
    [anon_sym_typeset] = ACTIONS(2135),
    [anon_sym_unsetenv] = ACTIONS(2137),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(2135),
    [sym__special_character] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(2153),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_declare] = ACTIONS(2135),
    [sym_variable_name] = ACTIONS(2159),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(2135),
    [anon_sym_unset] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1094] = {
    [aux_sym__literal_repeat1] = STATE(1680),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_done] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_EQ_TILDE] = ACTIONS(389),
    [sym__special_character] = ACTIONS(3624),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [1095] = {
    [anon_sym_BANG_EQ] = ACTIONS(3225),
    [anon_sym_PLUS_EQ] = ACTIONS(3225),
    [sym_test_operator] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_RBRACK] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_GT] = ACTIONS(3227),
    [anon_sym_EQ] = ACTIONS(3227),
    [anon_sym_EQ_EQ] = ACTIONS(3225),
    [anon_sym_PIPE_PIPE] = ACTIONS(3225),
    [anon_sym_GT_EQ] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3227),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [anon_sym_LT_EQ] = ACTIONS(3225),
    [anon_sym_AMP_AMP] = ACTIONS(3225),
    [anon_sym_DASH_EQ] = ACTIONS(3225),
  },
  [1096] = {
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2012),
    [sym_test_operator] = ACTIONS(2012),
    [anon_sym_PLUS_PLUS] = ACTIONS(2012),
    [anon_sym_RBRACK] = ACTIONS(2012),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_GT_EQ] = ACTIONS(2012),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2012),
    [anon_sym_DASH_DASH] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2012),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_DASH_EQ] = ACTIONS(2012),
  },
  [1097] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3626),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1098] = {
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_PLUS_EQ] = ACTIONS(1544),
    [sym_test_operator] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1544),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1544),
    [anon_sym_DASH_EQ] = ACTIONS(1544),
  },
  [1099] = {
    [sym_process_substitution] = STATE(1098),
    [sym_string_expansion] = STATE(1098),
    [sym_expansion] = STATE(1098),
    [sym_simple_expansion] = STATE(1098),
    [sym_string] = STATE(1098),
    [sym_command_substitution] = STATE(1098),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(2173),
    [sym_raw_string] = ACTIONS(2173),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(2173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [1100] = {
    [aux_sym_concatenation_repeat1] = STATE(1100),
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_PLUS_EQ] = ACTIONS(1544),
    [sym_test_operator] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1544),
    [sym__concat] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1544),
    [anon_sym_DASH_EQ] = ACTIONS(1544),
  },
  [1101] = {
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_PLUS_EQ] = ACTIONS(1442),
    [sym_test_operator] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_RBRACK] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_DASH_EQ] = ACTIONS(1442),
  },
  [1102] = {
    [anon_sym_BANG_EQ] = ACTIONS(1436),
    [anon_sym_PLUS_EQ] = ACTIONS(1436),
    [sym_test_operator] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_RBRACK] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1436),
    [anon_sym_PIPE_PIPE] = ACTIONS(1436),
    [anon_sym_GT_EQ] = ACTIONS(1436),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1436),
    [anon_sym_AMP_AMP] = ACTIONS(1436),
    [anon_sym_DASH_EQ] = ACTIONS(1436),
  },
  [1103] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1685),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1685),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3633),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3637),
    [anon_sym_COLON_DASH] = ACTIONS(3633),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3639),
  },
  [1104] = {
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_PLUS_EQ] = ACTIONS(1478),
    [sym_test_operator] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_DASH_EQ] = ACTIONS(1478),
  },
  [1105] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1106] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1685),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1685),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3641),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3633),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3633),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3633),
    [anon_sym_PERCENT] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3637),
    [anon_sym_COLON_DASH] = ACTIONS(3633),
    [sym__special_character] = ACTIONS(599),
  },
  [1107] = {
    [anon_sym_EQ] = ACTIONS(3643),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1108] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1690),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1690),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3645),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3647),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(3647),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3647),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3647),
    [anon_sym_PERCENT] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3651),
    [anon_sym_COLON_DASH] = ACTIONS(3647),
    [sym__special_character] = ACTIONS(599),
  },
  [1109] = {
    [sym_process_substitution] = STATE(1691),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym_simple_expansion] = STATE(1691),
    [sym_string_expansion] = STATE(1691),
    [sym_expansion] = STATE(1691),
    [sym_concatenation] = STATE(1692),
    [sym_string] = STATE(1691),
    [sym_command_substitution] = STATE(1691),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3653),
    [sym_raw_string] = ACTIONS(3653),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1110] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1696),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1696),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3655),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3655),
    [anon_sym_PERCENT] = ACTIONS(3655),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3659),
    [anon_sym_COLON_DASH] = ACTIONS(3655),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3661),
  },
  [1111] = {
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_PLUS_EQ] = ACTIONS(1534),
    [sym_test_operator] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1534),
    [anon_sym_RBRACK] = ACTIONS(1534),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_GT_EQ] = ACTIONS(1534),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1534),
    [anon_sym_DASH_DASH] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_DASH_EQ] = ACTIONS(1534),
  },
  [1112] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1113] = {
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_PLUS_EQ] = ACTIONS(3266),
    [sym_test_operator] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_RBRACK] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_DASH_EQ] = ACTIONS(3266),
  },
  [1114] = {
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_PLUS_EQ] = ACTIONS(3266),
    [sym_test_operator] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_RBRACK] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_DASH_EQ] = ACTIONS(3266),
  },
  [1115] = {
    [aux_sym_concatenation_repeat1] = STATE(1115),
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_PLUS_EQ] = ACTIONS(1544),
    [sym_test_operator] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1544),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1544),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1544),
    [anon_sym_DASH_EQ] = ACTIONS(1544),
  },
  [1116] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3663),
  },
  [1117] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1118] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_fi] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_elif] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1119] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(3667),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1120] = {
    [sym_process_substitution] = STATE(1700),
    [sym_string_expansion] = STATE(1700),
    [sym_expansion] = STATE(1700),
    [sym_simple_expansion] = STATE(1700),
    [sym_string] = STATE(1700),
    [sym_command_substitution] = STATE(1700),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(3669),
    [sym_raw_string] = ACTIONS(3669),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(3669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [1121] = {
    [aux_sym_concatenation_repeat1] = STATE(1702),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [ts_builtin_sym_end] = ACTIONS(631),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym__concat] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1122] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3673),
  },
  [1123] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_esac] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_fi] = ACTIONS(551),
    [anon_sym_else] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [ts_builtin_sym_end] = ACTIONS(553),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_elif] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [1124] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_esac] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_fi] = ACTIONS(555),
    [anon_sym_else] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [ts_builtin_sym_end] = ACTIONS(557),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_elif] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [1125] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_esac] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_fi] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(561),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_elif] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [1126] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1127] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3663),
  },
  [1128] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1706),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1706),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3675),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3677),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3677),
    [anon_sym_PERCENT] = ACTIONS(3677),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3681),
    [anon_sym_COLON_DASH] = ACTIONS(3677),
    [sym__special_character] = ACTIONS(599),
  },
  [1129] = {
    [sym_subscript] = STATE(1707),
    [anon_sym_STAR] = ACTIONS(3683),
    [anon_sym_QMARK] = ACTIONS(3683),
    [anon_sym_AT] = ACTIONS(3683),
    [sym_variable_name] = ACTIONS(3685),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_0] = ACTIONS(3689),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3689),
    [anon_sym__] = ACTIONS(3689),
  },
  [1130] = {
    [anon_sym_EQ] = ACTIONS(3691),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1131] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1713),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1713),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3693),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3695),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3695),
    [anon_sym_PERCENT] = ACTIONS(3695),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3699),
    [anon_sym_COLON_DASH] = ACTIONS(3695),
    [sym__special_character] = ACTIONS(599),
  },
  [1132] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [ts_builtin_sym_end] = ACTIONS(221),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(219),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1133] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [ts_builtin_sym_end] = ACTIONS(1192),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3701),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1134] = {
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_QMARK] = ACTIONS(3704),
    [anon_sym_AT] = ACTIONS(3704),
    [anon_sym_DOLLAR] = ACTIONS(3706),
    [anon_sym_POUND] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_0] = ACTIONS(3708),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3708),
    [anon_sym__] = ACTIONS(3708),
  },
  [1135] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1716),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1136] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1717),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1718),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1137] = {
    [anon_sym_BQUOTE] = ACTIONS(3710),
    [ts_builtin_sym_end] = ACTIONS(3712),
    [anon_sym_LF] = ACTIONS(3712),
    [anon_sym_SEMI] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3710),
    [anon_sym_esac] = ACTIONS(3710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(3710),
    [anon_sym_elif] = ACTIONS(3710),
    [anon_sym_fi] = ACTIONS(3710),
    [anon_sym_done] = ACTIONS(3710),
    [anon_sym_else] = ACTIONS(3710),
    [anon_sym_SEMI_SEMI] = ACTIONS(3710),
  },
  [1138] = {
    [sym_subscript] = STATE(1719),
    [anon_sym_STAR] = ACTIONS(3714),
    [anon_sym_QMARK] = ACTIONS(3714),
    [anon_sym_BANG] = ACTIONS(3716),
    [anon_sym_AT] = ACTIONS(3714),
    [sym_variable_name] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_DASH] = ACTIONS(3720),
    [anon_sym_0] = ACTIONS(3722),
    [anon_sym_POUND] = ACTIONS(3716),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3722),
    [anon_sym__] = ACTIONS(3722),
    [sym_comment] = ACTIONS(3),
  },
  [1139] = {
    [sym_expansion] = STATE(1724),
    [aux_sym_heredoc_body_repeat1] = STATE(1724),
    [sym_simple_expansion] = STATE(1724),
    [sym_command_substitution] = STATE(1724),
    [anon_sym_DOLLAR] = ACTIONS(2249),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2253),
    [sym__heredoc_body_end] = ACTIONS(3724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2257),
    [sym__heredoc_body_middle] = ACTIONS(3726),
  },
  [1140] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_RPAREN] = ACTIONS(3732),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [ts_builtin_sym_end] = ACTIONS(3732),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [1141] = {
    [aux_sym_concatenation_repeat1] = STATE(1121),
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [ts_builtin_sym_end] = ACTIONS(2002),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [1142] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_RPAREN] = ACTIONS(2004),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_fi] = ACTIONS(2004),
    [anon_sym_else] = ACTIONS(2004),
    [anon_sym_done] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [ts_builtin_sym_end] = ACTIONS(2002),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(2004),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_esac] = ACTIONS(2004),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [1143] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [ts_builtin_sym_end] = ACTIONS(2006),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
  },
  [1144] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [ts_builtin_sym_end] = ACTIONS(3732),
    [anon_sym_LF] = ACTIONS(3736),
    [anon_sym_SEMI] = ACTIONS(3738),
    [anon_sym_SEMI_SEMI] = ACTIONS(3738),
    [anon_sym_AMP] = ACTIONS(3738),
  },
  [1145] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [1146] = {
    [sym_heredoc_body] = STATE(1726),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [1147] = {
    [aux_sym_concatenation_repeat1] = STATE(1147),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(2432),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1148] = {
    [aux_sym_concatenation_repeat1] = STATE(621),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(471),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [anon_sym_RPAREN] = ACTIONS(1960),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [1149] = {
    [aux_sym__literal_repeat1] = STATE(623),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(499),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [1150] = {
    [aux_sym_concatenation_repeat1] = STATE(1150),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(2471),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1151] = {
    [aux_sym_concatenation_repeat1] = STATE(1727),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(3335),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [anon_sym_RPAREN] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1152] = {
    [aux_sym__literal_repeat1] = STATE(1152),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3365),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1153] = {
    [aux_sym_concatenation_repeat1] = STATE(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym__concat] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1154] = {
    [aux_sym__literal_repeat1] = STATE(1154),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3701),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1155] = {
    [aux_sym_concatenation_repeat1] = STATE(1153),
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_RPAREN] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [anon_sym_GT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [1156] = {
    [aux_sym__literal_repeat1] = STATE(1154),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_RPAREN] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
  },
  [1157] = {
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_AMP_GT_GT] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [sym_variable_name] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_word] = ACTIONS(3423),
    [anon_sym_GT_AMP] = ACTIONS(3423),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3423),
  },
  [1158] = {
    [sym_string] = STATE(266),
    [anon_sym_AMP_GT_GT] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(3740),
    [anon_sym_DASH] = ACTIONS(3740),
    [anon_sym_GT_LPAREN] = ACTIONS(2662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2662),
    [aux_sym__simple_variable_name_token1] = ACTIONS(447),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2662),
    [sym_word] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(447),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2662),
    [anon_sym_GT_GT] = ACTIONS(2662),
    [sym__special_character] = ACTIONS(2662),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(447),
    [sym_raw_string] = ACTIONS(443),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(447),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_RPAREN] = ACTIONS(2662),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [anon_sym_GT_AMP] = ACTIONS(2662),
    [anon_sym_LT_LPAREN] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(445),
    [anon_sym__] = ACTIONS(447),
  },
  [1159] = {
    [anon_sym_BQUOTE] = ACTIONS(2508),
    [anon_sym_AMP_GT_GT] = ACTIONS(2508),
    [sym_raw_string] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [sym_variable_name] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2508),
    [anon_sym_GT_LPAREN] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2508),
    [anon_sym_DQUOTE] = ACTIONS(2508),
    [sym_word] = ACTIONS(2508),
    [anon_sym_GT_AMP] = ACTIONS(2508),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_LT_LPAREN] = ACTIONS(2508),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2508),
  },
  [1160] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1730),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1730),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3742),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3746),
    [anon_sym_COLON_DASH] = ACTIONS(3742),
    [sym__special_character] = ACTIONS(599),
  },
  [1161] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1162] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1730),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1730),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3742),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3742),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3742),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_PERCENT] = ACTIONS(3742),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3746),
    [anon_sym_COLON_DASH] = ACTIONS(3742),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3748),
  },
  [1163] = {
    [sym_process_substitution] = STATE(1732),
    [aux_sym__literal_repeat1] = STATE(1734),
    [sym_simple_expansion] = STATE(1732),
    [sym_string_expansion] = STATE(1732),
    [sym_expansion] = STATE(1732),
    [sym_concatenation] = STATE(1733),
    [sym_string] = STATE(1732),
    [sym_command_substitution] = STATE(1732),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3750),
    [sym_raw_string] = ACTIONS(3750),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1164] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1737),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1737),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3752),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_DASH] = ACTIONS(3752),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3756),
    [anon_sym_COLON_DASH] = ACTIONS(3752),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3758),
  },
  [1165] = {
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_AMP_GT_GT] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [sym_variable_name] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [anon_sym_RPAREN] = ACTIONS(2604),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_word] = ACTIONS(2604),
    [anon_sym_GT_AMP] = ACTIONS(2604),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2604),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2604),
  },
  [1166] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1167] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [sym__concat] = ACTIONS(2610),
  },
  [1168] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3744),
  },
  [1169] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(3760),
  },
  [1170] = {
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [anon_sym_AMP_GT_GT] = ACTIONS(2646),
    [sym_raw_string] = ACTIONS(2646),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [sym_variable_name] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2646),
    [anon_sym_GT_LPAREN] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [sym_word] = ACTIONS(2646),
    [anon_sym_GT_AMP] = ACTIONS(2646),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2646),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_LT_LPAREN] = ACTIONS(2646),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2646),
  },
  [1171] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1740),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1740),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3762),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3766),
    [anon_sym_COLON_DASH] = ACTIONS(3762),
    [sym__special_character] = ACTIONS(599),
  },
  [1172] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1173] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [ts_builtin_sym_end] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [1174] = {
    [sym_string] = STATE(285),
    [anon_sym__] = ACTIONS(485),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(3768),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(3768),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(485),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(485),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(485),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(3770),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_RPAREN] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [ts_builtin_sym_end] = ACTIONS(2662),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3768),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [1175] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_RPAREN] = ACTIONS(3305),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [ts_builtin_sym_end] = ACTIONS(3307),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [1176] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(3772),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [1177] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [ts_builtin_sym_end] = ACTIONS(2508),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [1178] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1743),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1743),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3778),
    [anon_sym_COLON_DASH] = ACTIONS(3774),
    [sym__special_character] = ACTIONS(599),
  },
  [1179] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1180] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1743),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1743),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3774),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3774),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3778),
    [anon_sym_COLON_DASH] = ACTIONS(3774),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3780),
  },
  [1181] = {
    [sym_process_substitution] = STATE(1745),
    [aux_sym__literal_repeat1] = STATE(1747),
    [sym_simple_expansion] = STATE(1745),
    [sym_string_expansion] = STATE(1745),
    [sym_expansion] = STATE(1745),
    [sym_concatenation] = STATE(1746),
    [sym_string] = STATE(1745),
    [sym_command_substitution] = STATE(1745),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3782),
    [sym_raw_string] = ACTIONS(3782),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3776),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1182] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1750),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1750),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3784),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3784),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3788),
    [anon_sym_COLON_DASH] = ACTIONS(3784),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3790),
  },
  [1183] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [ts_builtin_sym_end] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [1184] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1185] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3776),
    [sym__concat] = ACTIONS(2610),
  },
  [1186] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3776),
  },
  [1187] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(3792),
  },
  [1188] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [1189] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1753),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1753),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3794),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3796),
    [anon_sym_DASH] = ACTIONS(3794),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3794),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3794),
    [anon_sym_PERCENT] = ACTIONS(3794),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3798),
    [anon_sym_COLON_DASH] = ACTIONS(3794),
    [sym__special_character] = ACTIONS(599),
  },
  [1190] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3796),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1191] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [ts_builtin_sym_end] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [1192] = {
    [sym_string] = STATE(304),
    [anon_sym__] = ACTIONS(527),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(527),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(527),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(3802),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_RPAREN] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [ts_builtin_sym_end] = ACTIONS(2662),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3800),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [1193] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [ts_builtin_sym_end] = ACTIONS(2508),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [1194] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1755),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1755),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3804),
    [anon_sym_PERCENT] = ACTIONS(3804),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3808),
    [anon_sym_COLON_DASH] = ACTIONS(3804),
    [sym__special_character] = ACTIONS(599),
  },
  [1195] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1196] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1755),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1755),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3804),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3804),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3804),
    [anon_sym_PERCENT] = ACTIONS(3804),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3808),
    [anon_sym_COLON_DASH] = ACTIONS(3804),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3810),
  },
  [1197] = {
    [sym_process_substitution] = STATE(1757),
    [aux_sym__literal_repeat1] = STATE(1759),
    [sym_simple_expansion] = STATE(1757),
    [sym_string_expansion] = STATE(1757),
    [sym_expansion] = STATE(1757),
    [sym_concatenation] = STATE(1758),
    [sym_string] = STATE(1757),
    [sym_command_substitution] = STATE(1757),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3812),
    [sym_raw_string] = ACTIONS(3812),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3806),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1198] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1762),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1762),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3814),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3818),
    [anon_sym_COLON_DASH] = ACTIONS(3814),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3820),
  },
  [1199] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [ts_builtin_sym_end] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [1200] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1201] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3806),
    [sym__concat] = ACTIONS(2610),
  },
  [1202] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3806),
  },
  [1203] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(3822),
  },
  [1204] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [1205] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1765),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1765),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3824),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3826),
    [anon_sym_DASH] = ACTIONS(3824),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3824),
    [anon_sym_PERCENT] = ACTIONS(3824),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3828),
    [anon_sym_COLON_DASH] = ACTIONS(3824),
    [sym__special_character] = ACTIONS(599),
  },
  [1206] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3826),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1207] = {
    [aux_sym_concatenation_repeat1] = STATE(1207),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [anon_sym_AMP_GT_GT] = ACTIONS(1544),
    [sym_raw_string] = ACTIONS(1544),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1544),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1544),
    [anon_sym_GT_LPAREN] = ACTIONS(1544),
    [sym_variable_name] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [sym_word] = ACTIONS(1544),
    [anon_sym_GT_AMP] = ACTIONS(1544),
    [sym__concat] = ACTIONS(2395),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1544),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1544),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1544),
  },
  [1208] = {
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [sym_raw_string] = ACTIONS(1442),
    [anon_sym_COLON_QMARK] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1442),
    [anon_sym_PERCENT] = ACTIONS(1440),
    [anon_sym_COLON] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym_word] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_LT_LPAREN] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1442),
    [anon_sym_COLON_DASH] = ACTIONS(1440),
    [sym__special_character] = ACTIONS(1440),
  },
  [1209] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_EQ_TILDE] = ACTIONS(3830),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [ts_builtin_sym_end] = ACTIONS(3832),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [1210] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3834),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1211] = {
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [sym_raw_string] = ACTIONS(1544),
    [anon_sym_COLON_QMARK] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1544),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1544),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [anon_sym_COLON] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [sym_word] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1544),
    [anon_sym_COLON_DASH] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
  },
  [1212] = {
    [sym_process_substitution] = STATE(1211),
    [sym_string_expansion] = STATE(1211),
    [sym_expansion] = STATE(1211),
    [sym_simple_expansion] = STATE(1211),
    [sym_string] = STATE(1211),
    [sym_command_substitution] = STATE(1211),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(2516),
    [sym_raw_string] = ACTIONS(2516),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(3836),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [sym__special_character] = ACTIONS(2516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
  },
  [1213] = {
    [aux_sym_concatenation_repeat1] = STATE(1213),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [sym_raw_string] = ACTIONS(1544),
    [anon_sym_COLON_QMARK] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1544),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1544),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [anon_sym_COLON] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [sym_word] = ACTIONS(1542),
    [sym__concat] = ACTIONS(3838),
    [anon_sym_LT_LPAREN] = ACTIONS(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1544),
    [anon_sym_COLON_DASH] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
  },
  [1214] = {
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [sym_raw_string] = ACTIONS(1436),
    [anon_sym_COLON_QMARK] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1436),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1436),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [sym_word] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_LT_LPAREN] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1436),
    [anon_sym_COLON_DASH] = ACTIONS(1434),
    [sym__special_character] = ACTIONS(1434),
  },
  [1215] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1770),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1770),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_COLON_DASH] = ACTIONS(3841),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3847),
  },
  [1216] = {
    [anon_sym_BQUOTE] = ACTIONS(1478),
    [sym_raw_string] = ACTIONS(1478),
    [anon_sym_COLON_QMARK] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1478),
    [anon_sym_PERCENT] = ACTIONS(1476),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_word] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_LT_LPAREN] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1478),
    [anon_sym_COLON_DASH] = ACTIONS(1476),
    [sym__special_character] = ACTIONS(1476),
  },
  [1217] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1218] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1770),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1770),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3849),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_COLON_DASH] = ACTIONS(3841),
    [sym__special_character] = ACTIONS(599),
  },
  [1219] = {
    [anon_sym_EQ] = ACTIONS(3851),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1220] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1775),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1775),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3853),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3855),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3855),
    [anon_sym_PERCENT] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3859),
    [anon_sym_COLON_DASH] = ACTIONS(3855),
    [sym__special_character] = ACTIONS(599),
  },
  [1221] = {
    [sym_process_substitution] = STATE(1776),
    [aux_sym__literal_repeat1] = STATE(1778),
    [sym_simple_expansion] = STATE(1776),
    [sym_string_expansion] = STATE(1776),
    [sym_expansion] = STATE(1776),
    [sym_concatenation] = STATE(1777),
    [sym_string] = STATE(1776),
    [sym_command_substitution] = STATE(1776),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3861),
    [sym_raw_string] = ACTIONS(3861),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1222] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1781),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1781),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3863),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_PERCENT] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3867),
    [anon_sym_COLON_DASH] = ACTIONS(3863),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3869),
  },
  [1223] = {
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [sym_raw_string] = ACTIONS(1534),
    [anon_sym_COLON_QMARK] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1534),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [anon_sym_EQ] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1534),
    [anon_sym_PERCENT] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1534),
    [anon_sym_COLON_DASH] = ACTIONS(1532),
    [sym__special_character] = ACTIONS(1532),
  },
  [1224] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1225] = {
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [sym_raw_string] = ACTIONS(2012),
    [anon_sym_COLON_QMARK] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_RBRACE] = ACTIONS(2012),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2010),
    [anon_sym_COLON] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [sym_word] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2012),
    [anon_sym_COLON_DASH] = ACTIONS(2010),
    [sym__special_character] = ACTIONS(2010),
  },
  [1226] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1227] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1783),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1783),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3834),
    [anon_sym_DASH] = ACTIONS(3873),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3873),
    [anon_sym_PERCENT] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3875),
    [anon_sym_COLON_DASH] = ACTIONS(3873),
    [sym__special_character] = ACTIONS(599),
  },
  [1228] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3834),
    [sym__concat] = ACTIONS(2610),
  },
  [1229] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3834),
  },
  [1230] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(3877),
  },
  [1231] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_EQ_TILDE] = ACTIONS(3879),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [ts_builtin_sym_end] = ACTIONS(3881),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [1232] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1786),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1786),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3883),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3883),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3883),
    [anon_sym_PERCENT] = ACTIONS(3883),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3887),
    [anon_sym_COLON_DASH] = ACTIONS(3883),
    [sym__special_character] = ACTIONS(599),
  },
  [1233] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1234] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3889),
  },
  [1235] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3891),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1236] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
  },
  [1237] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(3891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1238] = {
    [sym_process_substitution] = STATE(1790),
    [sym_string_expansion] = STATE(1790),
    [sym_expansion] = STATE(1790),
    [sym_simple_expansion] = STATE(1790),
    [sym_string] = STATE(1790),
    [sym_command_substitution] = STATE(1790),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3895),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(3895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1239] = {
    [aux_sym_concatenation_repeat1] = STATE(1792),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(631),
    [sym__concat] = ACTIONS(3897),
  },
  [1240] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3899),
  },
  [1241] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(553),
    [sym__concat] = ACTIONS(553),
  },
  [1242] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(557),
    [sym__concat] = ACTIONS(557),
  },
  [1243] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(561),
    [sym__concat] = ACTIONS(561),
  },
  [1244] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1245] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3889),
  },
  [1246] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1796),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1796),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3901),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3903),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3903),
    [anon_sym_PERCENT] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3907),
    [anon_sym_COLON_DASH] = ACTIONS(3903),
    [sym__special_character] = ACTIONS(599),
  },
  [1247] = {
    [sym_subscript] = STATE(1797),
    [anon_sym_STAR] = ACTIONS(3909),
    [anon_sym_QMARK] = ACTIONS(3909),
    [anon_sym_AT] = ACTIONS(3909),
    [sym_variable_name] = ACTIONS(3911),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_0] = ACTIONS(3915),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3915),
    [anon_sym__] = ACTIONS(3915),
  },
  [1248] = {
    [anon_sym_EQ] = ACTIONS(3917),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1249] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1803),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1803),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3919),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3921),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3921),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3925),
    [anon_sym_COLON_DASH] = ACTIONS(3921),
    [sym__special_character] = ACTIONS(599),
  },
  [1250] = {
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_RBRACE] = ACTIONS(221),
  },
  [1251] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3927),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [1252] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3931),
    [anon_sym_RBRACE] = ACTIONS(1192),
  },
  [1253] = {
    [anon_sym_BQUOTE] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [sym_raw_string] = ACTIONS(3368),
    [anon_sym_COLON_QMARK] = ACTIONS(3934),
    [anon_sym_DOLLAR] = ACTIONS(3934),
    [anon_sym_RBRACE] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3934),
    [anon_sym_EQ] = ACTIONS(3934),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3368),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3934),
    [anon_sym_COLON] = ACTIONS(3934),
    [anon_sym_GT_LPAREN] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3368),
    [sym_word] = ACTIONS(3934),
    [sym__concat] = ACTIONS(3936),
    [anon_sym_LT_LPAREN] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3368),
    [anon_sym_COLON_DASH] = ACTIONS(3934),
    [sym__special_character] = ACTIONS(3934),
  },
  [1254] = {
    [sym_process_substitution] = STATE(1098),
    [sym_string_expansion] = STATE(1098),
    [sym_expansion] = STATE(1098),
    [sym_simple_expansion] = STATE(1098),
    [sym_string] = STATE(1098),
    [sym_command_substitution] = STATE(1098),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(2173),
    [sym_raw_string] = ACTIONS(2173),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(325),
    [anon_sym_RBRACK] = ACTIONS(3938),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(3374),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [1255] = {
    [anon_sym_RBRACK] = ACTIONS(3938),
    [sym_comment] = ACTIONS(51),
  },
  [1256] = {
    [anon_sym_BQUOTE] = ACTIONS(3378),
    [anon_sym_SLASH] = ACTIONS(3378),
    [sym_raw_string] = ACTIONS(3378),
    [anon_sym_COLON_QMARK] = ACTIONS(3940),
    [anon_sym_DOLLAR] = ACTIONS(3940),
    [anon_sym_RBRACE] = ACTIONS(3378),
    [anon_sym_DASH] = ACTIONS(3940),
    [anon_sym_EQ] = ACTIONS(3940),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3378),
    [anon_sym_PERCENT] = ACTIONS(3940),
    [anon_sym_COLON] = ACTIONS(3940),
    [anon_sym_GT_LPAREN] = ACTIONS(3378),
    [anon_sym_DQUOTE] = ACTIONS(3378),
    [sym_word] = ACTIONS(3940),
    [sym__concat] = ACTIONS(3942),
    [anon_sym_LT_LPAREN] = ACTIONS(3378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3378),
    [anon_sym_COLON_DASH] = ACTIONS(3940),
    [sym__special_character] = ACTIONS(3940),
  },
  [1257] = {
    [anon_sym_RBRACK] = ACTIONS(3944),
    [sym_comment] = ACTIONS(51),
  },
  [1258] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_EQ_TILDE] = ACTIONS(3946),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [ts_builtin_sym_end] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [1259] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3950),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1260] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3952),
    [anon_sym_BQUOTE] = ACTIONS(3952),
    [anon_sym_AMP_GT_GT] = ACTIONS(3952),
    [anon_sym_LF] = ACTIONS(3954),
    [anon_sym_SEMI] = ACTIONS(3952),
    [anon_sym_LT_LT] = ACTIONS(3952),
    [sym_file_descriptor] = ACTIONS(3954),
    [anon_sym_GT] = ACTIONS(3952),
    [anon_sym_RPAREN] = ACTIONS(3952),
    [anon_sym_AMP_GT] = ACTIONS(3952),
    [anon_sym_fi] = ACTIONS(3952),
    [anon_sym_else] = ACTIONS(3952),
    [anon_sym_done] = ACTIONS(3952),
    [anon_sym_PIPE_PIPE] = ACTIONS(3952),
    [ts_builtin_sym_end] = ACTIONS(3954),
    [anon_sym_LT_LT_LT] = ACTIONS(3952),
    [anon_sym_PIPE] = ACTIONS(3952),
    [anon_sym_GT_AMP] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_LT_AMP] = ACTIONS(3952),
    [anon_sym_GT_GT] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(3952),
    [anon_sym_AMP_AMP] = ACTIONS(3952),
    [anon_sym_esac] = ACTIONS(3952),
    [anon_sym_SEMI_SEMI] = ACTIONS(3952),
    [anon_sym_PIPE_AMP] = ACTIONS(3952),
  },
  [1261] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [1262] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [1263] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3956),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1264] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1265] = {
    [sym_process_substitution] = STATE(1264),
    [sym_string_expansion] = STATE(1264),
    [sym_expansion] = STATE(1264),
    [sym_simple_expansion] = STATE(1264),
    [sym_string] = STATE(1264),
    [sym_command_substitution] = STATE(1264),
    [anon_sym_BQUOTE] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(1561),
    [sym_word] = ACTIONS(2674),
    [sym_raw_string] = ACTIONS(2674),
    [anon_sym_LT_LPAREN] = ACTIONS(2676),
    [anon_sym_DOLLAR] = ACTIONS(3958),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2676),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2678),
    [sym__special_character] = ACTIONS(2674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2680),
  },
  [1266] = {
    [aux_sym_concatenation_repeat1] = STATE(1266),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(3960),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1267] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [1268] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1812),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1812),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(3963),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [1269] = {
    [aux_sym_concatenation_repeat1] = STATE(758),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(1557),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1960),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [1270] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1960),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [1271] = {
    [aux_sym__literal_repeat1] = STATE(771),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [1272] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1815),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1815),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3969),
    [anon_sym_COLON_DASH] = ACTIONS(3965),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3971),
  },
  [1273] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [1274] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1275] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1815),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1815),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3973),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3965),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3969),
    [anon_sym_COLON_DASH] = ACTIONS(3965),
    [sym__special_character] = ACTIONS(599),
  },
  [1276] = {
    [anon_sym_EQ] = ACTIONS(3975),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1277] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1820),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1820),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(3977),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3979),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3979),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3979),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3983),
    [anon_sym_COLON_DASH] = ACTIONS(3979),
    [sym__special_character] = ACTIONS(599),
  },
  [1278] = {
    [sym_process_substitution] = STATE(1821),
    [aux_sym__literal_repeat1] = STATE(1823),
    [sym_simple_expansion] = STATE(1821),
    [sym_string_expansion] = STATE(1821),
    [sym_expansion] = STATE(1821),
    [sym_concatenation] = STATE(1822),
    [sym_string] = STATE(1821),
    [sym_command_substitution] = STATE(1821),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3985),
    [sym_raw_string] = ACTIONS(3985),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1279] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1826),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1826),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(3987),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_DASH] = ACTIONS(3987),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(3987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(3987),
    [anon_sym_PERCENT] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3991),
    [anon_sym_COLON_DASH] = ACTIONS(3987),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(3993),
  },
  [1280] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [1281] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1282] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [1283] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [1284] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(3995),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1285] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1286] = {
    [sym_process_substitution] = STATE(1285),
    [sym_string_expansion] = STATE(1285),
    [sym_expansion] = STATE(1285),
    [sym_simple_expansion] = STATE(1285),
    [sym_string] = STATE(1285),
    [sym_command_substitution] = STATE(1285),
    [anon_sym_BQUOTE] = ACTIONS(2759),
    [anon_sym_DQUOTE] = ACTIONS(1591),
    [sym_word] = ACTIONS(2761),
    [sym_raw_string] = ACTIONS(2761),
    [anon_sym_LT_LPAREN] = ACTIONS(2763),
    [anon_sym_DOLLAR] = ACTIONS(3997),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2765),
    [sym__special_character] = ACTIONS(2761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2767),
  },
  [1287] = {
    [aux_sym_concatenation_repeat1] = STATE(1287),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(3999),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1288] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [1289] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1831),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1831),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_DASH] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4002),
    [anon_sym_PERCENT] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4006),
    [anon_sym_COLON_DASH] = ACTIONS(4002),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4008),
  },
  [1290] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [1291] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1292] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1831),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1831),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4010),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4002),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_DASH] = ACTIONS(4002),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4002),
    [anon_sym_PERCENT] = ACTIONS(4002),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4006),
    [anon_sym_COLON_DASH] = ACTIONS(4002),
    [sym__special_character] = ACTIONS(599),
  },
  [1293] = {
    [anon_sym_EQ] = ACTIONS(4012),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1294] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1836),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1836),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4014),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4016),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4016),
    [anon_sym_PERCENT] = ACTIONS(4016),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4020),
    [anon_sym_COLON_DASH] = ACTIONS(4016),
    [sym__special_character] = ACTIONS(599),
  },
  [1295] = {
    [sym_process_substitution] = STATE(1837),
    [aux_sym__literal_repeat1] = STATE(1839),
    [sym_simple_expansion] = STATE(1837),
    [sym_string_expansion] = STATE(1837),
    [sym_expansion] = STATE(1837),
    [sym_concatenation] = STATE(1838),
    [sym_string] = STATE(1837),
    [sym_command_substitution] = STATE(1837),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(4022),
    [sym_raw_string] = ACTIONS(4022),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4004),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1296] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1842),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1842),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4024),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(4024),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4024),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4024),
    [anon_sym_PERCENT] = ACTIONS(4024),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4028),
    [anon_sym_COLON_DASH] = ACTIONS(4024),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4030),
  },
  [1297] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [1298] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4026),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1299] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_EQ_TILDE] = ACTIONS(2506),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [1300] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1844),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1844),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4032),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4032),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4036),
    [anon_sym_COLON_DASH] = ACTIONS(4032),
    [sym__special_character] = ACTIONS(599),
  },
  [1301] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1302] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1844),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1844),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4032),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4032),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4036),
    [anon_sym_COLON_DASH] = ACTIONS(4032),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4038),
  },
  [1303] = {
    [sym_process_substitution] = STATE(1846),
    [aux_sym__literal_repeat1] = STATE(1848),
    [sym_simple_expansion] = STATE(1846),
    [sym_string_expansion] = STATE(1846),
    [sym_expansion] = STATE(1846),
    [sym_concatenation] = STATE(1847),
    [sym_string] = STATE(1846),
    [sym_command_substitution] = STATE(1846),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(4040),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1304] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1851),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1851),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4046),
    [anon_sym_COLON_DASH] = ACTIONS(4042),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4048),
  },
  [1305] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [1306] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1307] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [sym__concat] = ACTIONS(2610),
  },
  [1308] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4034),
  },
  [1309] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(4050),
  },
  [1310] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2644),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [1311] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1854),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1854),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4056),
    [anon_sym_COLON_DASH] = ACTIONS(4052),
    [sym__special_character] = ACTIONS(599),
  },
  [1312] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1313] = {
    [sym_compound_statement] = STATE(1855),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
  },
  [1314] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2654),
    [anon_sym_AMP_GT_GT] = ACTIONS(2654),
    [anon_sym_LF] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym_LT_LT] = ACTIONS(2654),
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_GT] = ACTIONS(2654),
    [sym_file_descriptor] = ACTIONS(2656),
    [anon_sym_AMP_GT] = ACTIONS(2654),
    [anon_sym_PIPE_PIPE] = ACTIONS(2654),
    [anon_sym_LT_LT_LT] = ACTIONS(2654),
    [anon_sym_PIPE] = ACTIONS(2654),
    [anon_sym_GT_AMP] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym_LT_AMP] = ACTIONS(2654),
    [anon_sym_GT_GT] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_SEMI_SEMI] = ACTIONS(2654),
    [anon_sym_PIPE_AMP] = ACTIONS(2654),
  },
  [1315] = {
    [sym_string] = STATE(371),
    [anon_sym__] = ACTIONS(677),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(4058),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(4058),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(677),
    [anon_sym_EQ_TILDE] = ACTIONS(2658),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(677),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(4060),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_0] = ACTIONS(677),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4058),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [1316] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3111),
    [anon_sym_AMP_GT_GT] = ACTIONS(3111),
    [anon_sym_LF] = ACTIONS(3113),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_LT_LT] = ACTIONS(3111),
    [anon_sym_RBRACE] = ACTIONS(3111),
    [anon_sym_GT] = ACTIONS(3111),
    [sym_file_descriptor] = ACTIONS(3113),
    [anon_sym_AMP_GT] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_LT_LT_LT] = ACTIONS(3111),
    [anon_sym_PIPE] = ACTIONS(3111),
    [anon_sym_GT_AMP] = ACTIONS(3111),
    [anon_sym_LT] = ACTIONS(3111),
    [anon_sym_LT_AMP] = ACTIONS(3111),
    [anon_sym_GT_GT] = ACTIONS(3111),
    [anon_sym_AMP] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_SEMI_SEMI] = ACTIONS(3111),
    [anon_sym_PIPE_AMP] = ACTIONS(3111),
  },
  [1317] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(4062),
  },
  [1318] = {
    [sym_elif_clause] = STATE(1460),
    [sym_else_clause] = STATE(1857),
    [aux_sym_if_statement_repeat1] = STATE(1460),
    [anon_sym_elif] = ACTIONS(3141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(4062),
    [anon_sym_else] = ACTIONS(3143),
  },
  [1319] = {
    [sym_elif_clause] = STATE(1858),
    [sym_else_clause] = STATE(1857),
    [aux_sym_if_statement_repeat1] = STATE(1858),
    [anon_sym_elif] = ACTIONS(3141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(4062),
    [anon_sym_else] = ACTIONS(3143),
  },
  [1320] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(4064),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_SEMI_SEMI] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
  },
  [1321] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(1861),
    [sym_case_item] = STATE(1862),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(1862),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3176),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_esac] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1322] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_SEMI_SEMI] = ACTIONS(4072),
    [anon_sym_AMP] = ACTIONS(4072),
  },
  [1323] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(1865),
    [sym_case_item] = STATE(1866),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(1866),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3176),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_esac] = ACTIONS(4074),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1324] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_RBRACE] = ACTIONS(3305),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [1325] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(4076),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [1326] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4078),
  },
  [1327] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(4080),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1328] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1329] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4082),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1330] = {
    [sym_process_substitution] = STATE(1871),
    [sym_string_expansion] = STATE(1871),
    [sym_expansion] = STATE(1871),
    [sym_simple_expansion] = STATE(1871),
    [sym_string] = STATE(1871),
    [sym_command_substitution] = STATE(1871),
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [sym_word] = ACTIONS(4084),
    [sym_raw_string] = ACTIONS(4084),
    [anon_sym_LT_LPAREN] = ACTIONS(1679),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(4084),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1687),
  },
  [1331] = {
    [aux_sym_concatenation_repeat1] = STATE(1873),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(4086),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1332] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4088),
  },
  [1333] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [1334] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [1335] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [1336] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(4078),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1337] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4078),
  },
  [1338] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1877),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1877),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4090),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4092),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4094),
    [anon_sym_DASH] = ACTIONS(4092),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4092),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4092),
    [anon_sym_PERCENT] = ACTIONS(4092),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4096),
    [anon_sym_COLON_DASH] = ACTIONS(4092),
    [sym__special_character] = ACTIONS(599),
  },
  [1339] = {
    [sym_subscript] = STATE(1878),
    [anon_sym_STAR] = ACTIONS(4098),
    [anon_sym_QMARK] = ACTIONS(4098),
    [anon_sym_AT] = ACTIONS(4098),
    [sym_variable_name] = ACTIONS(4100),
    [anon_sym_DOLLAR] = ACTIONS(4102),
    [anon_sym_DASH] = ACTIONS(4102),
    [anon_sym_0] = ACTIONS(4104),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4104),
    [anon_sym__] = ACTIONS(4104),
  },
  [1340] = {
    [anon_sym_EQ] = ACTIONS(4106),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1341] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1884),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1884),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4108),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4110),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4110),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4110),
    [anon_sym_PERCENT] = ACTIONS(4110),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4114),
    [anon_sym_COLON_DASH] = ACTIONS(4110),
    [sym__special_character] = ACTIONS(599),
  },
  [1342] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1343] = {
    [aux_sym__literal_repeat1] = STATE(1343),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(4116),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1344] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_EQ_TILDE] = ACTIONS(3421),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [1345] = {
    [sym_process_substitution] = STATE(1037),
    [sym_command_substitution] = STATE(1037),
    [aux_sym_for_statement_repeat1] = STATE(1599),
    [sym_simple_expansion] = STATE(1037),
    [sym_string_expansion] = STATE(1037),
    [sym_expansion] = STATE(1037),
    [sym_concatenation] = STATE(1599),
    [sym_string] = STATE(1037),
    [aux_sym__literal_repeat1] = STATE(1043),
    [anon_sym_BQUOTE] = ACTIONS(3451),
    [sym_raw_string] = ACTIONS(3453),
    [anon_sym_LF] = ACTIONS(4119),
    [anon_sym_SEMI] = ACTIONS(4121),
    [anon_sym_DOLLAR] = ACTIONS(2073),
    [anon_sym_GT_LPAREN] = ACTIONS(3459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [sym_word] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(4121),
    [anon_sym_LT_LPAREN] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3467),
    [anon_sym_SEMI_SEMI] = ACTIONS(4121),
  },
  [1346] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3469),
    [anon_sym_AMP_GT_GT] = ACTIONS(3469),
    [anon_sym_LF] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym_LT_LT] = ACTIONS(3469),
    [anon_sym_RBRACE] = ACTIONS(3469),
    [anon_sym_GT] = ACTIONS(3469),
    [sym_file_descriptor] = ACTIONS(3471),
    [anon_sym_AMP_GT] = ACTIONS(3469),
    [anon_sym_PIPE_PIPE] = ACTIONS(3469),
    [anon_sym_LT_LT_LT] = ACTIONS(3469),
    [anon_sym_PIPE] = ACTIONS(3469),
    [anon_sym_GT_AMP] = ACTIONS(3469),
    [anon_sym_LT] = ACTIONS(3469),
    [anon_sym_LT_AMP] = ACTIONS(3469),
    [anon_sym_GT_GT] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3469),
    [anon_sym_SEMI_SEMI] = ACTIONS(3469),
    [anon_sym_PIPE_AMP] = ACTIONS(3469),
  },
  [1347] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(1887),
    [sym_parenthesized_expression] = STATE(1887),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(1887),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(1887),
    [sym_unary_expression] = STATE(1887),
    [sym_concatenation] = STATE(1887),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4123),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(273),
  },
  [1348] = {
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [sym_test_operator] = ACTIONS(2127),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_SEMI] = ACTIONS(4125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(4125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
    [anon_sym_DASH_EQ] = ACTIONS(2125),
  },
  [1349] = {
    [sym_process_substitution] = STATE(549),
    [sym_postfix_expression] = STATE(1889),
    [sym_parenthesized_expression] = STATE(1889),
    [sym_command_substitution] = STATE(549),
    [sym_simple_expansion] = STATE(549),
    [sym__expression] = STATE(1889),
    [sym_string_expansion] = STATE(549),
    [sym_expansion] = STATE(549),
    [sym_binary_expression] = STATE(1889),
    [sym_unary_expression] = STATE(1889),
    [sym_concatenation] = STATE(1889),
    [sym_string] = STATE(549),
    [aux_sym__literal_repeat1] = STATE(557),
    [sym_test_operator] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [sym_raw_string] = ACTIONS(973),
    [anon_sym_LF] = ACTIONS(4125),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(4125),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [anon_sym_GT_LPAREN] = ACTIONS(981),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_word] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(4125),
    [anon_sym_LT_LPAREN] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(989),
    [anon_sym_SEMI_SEMI] = ACTIONS(4125),
  },
  [1350] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3570),
    [anon_sym_AMP_GT_GT] = ACTIONS(3570),
    [anon_sym_LF] = ACTIONS(3572),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym_LT_LT] = ACTIONS(3570),
    [anon_sym_RBRACE] = ACTIONS(3570),
    [anon_sym_GT] = ACTIONS(3570),
    [sym_file_descriptor] = ACTIONS(3572),
    [anon_sym_AMP_GT] = ACTIONS(3570),
    [anon_sym_PIPE_PIPE] = ACTIONS(3570),
    [anon_sym_LT_LT_LT] = ACTIONS(3570),
    [anon_sym_PIPE] = ACTIONS(3570),
    [anon_sym_GT_AMP] = ACTIONS(3570),
    [anon_sym_LT] = ACTIONS(3570),
    [anon_sym_LT_AMP] = ACTIONS(3570),
    [anon_sym_GT_GT] = ACTIONS(3570),
    [anon_sym_AMP] = ACTIONS(3570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3570),
    [anon_sym_SEMI_SEMI] = ACTIONS(3570),
    [anon_sym_PIPE_AMP] = ACTIONS(3570),
  },
  [1351] = {
    [anon_sym_done] = ACTIONS(4127),
    [sym_comment] = ACTIONS(51),
  },
  [1352] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4129),
  },
  [1353] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(4131),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1354] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1355] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4133),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1356] = {
    [sym_process_substitution] = STATE(1894),
    [sym_string_expansion] = STATE(1894),
    [sym_expansion] = STATE(1894),
    [sym_simple_expansion] = STATE(1894),
    [sym_string] = STATE(1894),
    [sym_command_substitution] = STATE(1894),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1707),
    [sym_word] = ACTIONS(4135),
    [sym_raw_string] = ACTIONS(4135),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1715),
    [sym__special_character] = ACTIONS(4135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1719),
  },
  [1357] = {
    [aux_sym_concatenation_repeat1] = STATE(1896),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym__concat] = ACTIONS(4137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1358] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4139),
  },
  [1359] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_GT] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [1360] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_GT] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [1361] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_GT] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [1362] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1363] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4129),
  },
  [1364] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1900),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1900),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4141),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4143),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4145),
    [anon_sym_DASH] = ACTIONS(4143),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4143),
    [anon_sym_PERCENT] = ACTIONS(4143),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4147),
    [anon_sym_COLON_DASH] = ACTIONS(4143),
    [sym__special_character] = ACTIONS(599),
  },
  [1365] = {
    [sym_subscript] = STATE(1901),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_QMARK] = ACTIONS(4149),
    [anon_sym_AT] = ACTIONS(4149),
    [sym_variable_name] = ACTIONS(4151),
    [anon_sym_DOLLAR] = ACTIONS(4153),
    [anon_sym_DASH] = ACTIONS(4153),
    [anon_sym_0] = ACTIONS(4155),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4155),
    [anon_sym__] = ACTIONS(4155),
  },
  [1366] = {
    [anon_sym_EQ] = ACTIONS(4157),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1367] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(1907),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(1907),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4159),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4163),
    [anon_sym_DASH] = ACTIONS(4161),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4161),
    [anon_sym_PERCENT] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4165),
    [anon_sym_COLON_DASH] = ACTIONS(4161),
    [sym__special_character] = ACTIONS(599),
  },
  [1368] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1369] = {
    [aux_sym__literal_repeat1] = STATE(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(4167),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1370] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACE] = ACTIONS(3710),
    [anon_sym_LF] = ACTIONS(3712),
    [anon_sym_SEMI] = ACTIONS(3710),
    [anon_sym_SEMI_SEMI] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3710),
  },
  [1371] = {
    [sym_expansion] = STATE(1724),
    [aux_sym_heredoc_body_repeat1] = STATE(1724),
    [sym_simple_expansion] = STATE(1724),
    [sym_command_substitution] = STATE(1724),
    [anon_sym_DOLLAR] = ACTIONS(2249),
    [anon_sym_BQUOTE] = ACTIONS(2251),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2253),
    [sym__heredoc_body_end] = ACTIONS(4170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2257),
    [sym__heredoc_body_middle] = ACTIONS(3726),
  },
  [1372] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_RBRACE] = ACTIONS(3732),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [1373] = {
    [aux_sym_concatenation_repeat1] = STATE(1357),
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [anon_sym_RBRACE] = ACTIONS(2004),
    [anon_sym_GT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym__concat] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [1374] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [anon_sym_RBRACE] = ACTIONS(2004),
    [anon_sym_GT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [1375] = {
    [aux_sym__literal_repeat1] = STATE(1369),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [anon_sym_RBRACE] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [sym__special_character] = ACTIONS(2940),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
  },
  [1376] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LF] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym_SEMI_SEMI] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4174),
  },
  [1377] = {
    [aux_sym_concatenation_repeat1] = STATE(1377),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(2432),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1378] = {
    [aux_sym_concatenation_repeat1] = STATE(866),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(471),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [1379] = {
    [aux_sym__literal_repeat1] = STATE(868),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(499),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [1380] = {
    [aux_sym_concatenation_repeat1] = STATE(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(2471),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1381] = {
    [aux_sym_concatenation_repeat1] = STATE(1910),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(3335),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1382] = {
    [aux_sym__literal_repeat1] = STATE(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3365),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1383] = {
    [aux_sym_concatenation_repeat1] = STATE(1911),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym__concat] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1384] = {
    [aux_sym__literal_repeat1] = STATE(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3701),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1385] = {
    [aux_sym_concatenation_repeat1] = STATE(1383),
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [1386] = {
    [aux_sym__literal_repeat1] = STATE(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
  },
  [1387] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1912),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1388] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1915),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4176),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1389] = {
    [aux_sym_concatenation_repeat1] = STATE(1917),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_fi] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_else] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(4180),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_elif] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1390] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1918),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1391] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(4182),
  },
  [1392] = {
    [sym_string] = STATE(1921),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [sym_raw_string] = ACTIONS(4188),
    [anon_sym_AT] = ACTIONS(4186),
    [anon_sym_DOLLAR] = ACTIONS(4190),
    [anon_sym_POUND] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_0] = ACTIONS(4192),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4192),
    [anon_sym__] = ACTIONS(4192),
  },
  [1393] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1923),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1924),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1394] = {
    [aux_sym_concatenation_repeat1] = STATE(1917),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(4180),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_elif] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1395] = {
    [sym_subscript] = STATE(1925),
    [anon_sym_STAR] = ACTIONS(4194),
    [anon_sym_QMARK] = ACTIONS(4194),
    [anon_sym_BANG] = ACTIONS(4196),
    [anon_sym_AT] = ACTIONS(4194),
    [sym_variable_name] = ACTIONS(4198),
    [anon_sym_DOLLAR] = ACTIONS(4200),
    [anon_sym_DASH] = ACTIONS(4200),
    [anon_sym_0] = ACTIONS(4202),
    [anon_sym_POUND] = ACTIONS(4196),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4202),
    [anon_sym__] = ACTIONS(4202),
    [sym_comment] = ACTIONS(3),
  },
  [1396] = {
    [aux_sym__literal_repeat1] = STATE(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(497),
    [anon_sym_DOLLAR] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(497),
    [anon_sym_fi] = ACTIONS(497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(497),
    [anon_sym_else] = ACTIONS(497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(497),
    [anon_sym_GT_LPAREN] = ACTIONS(497),
    [aux_sym__simple_variable_name_token1] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [sym_word] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(497),
    [anon_sym_LT_AMP] = ACTIONS(497),
    [anon_sym_GT_GT] = ACTIONS(497),
    [sym__special_character] = ACTIONS(4204),
    [anon_sym_LT_LT_DASH] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(497),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(497),
    [sym_raw_string] = ACTIONS(497),
    [sym_variable_name] = ACTIONS(501),
    [sym_file_descriptor] = ACTIONS(501),
    [anon_sym_GT] = ACTIONS(497),
    [anon_sym_AMP_GT] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(497),
    [anon_sym_LT_LT_LT] = ACTIONS(497),
    [anon_sym_GT_AMP] = ACTIONS(497),
    [anon_sym_LT_LPAREN] = ACTIONS(497),
    [anon_sym_elif] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [anon_sym_PIPE_AMP] = ACTIONS(497),
  },
  [1397] = {
    [sym_process_substitution] = STATE(1389),
    [sym_string] = STATE(1389),
    [sym_command_substitution] = STATE(1389),
    [sym_simple_expansion] = STATE(1389),
    [sym_variable_assignment] = STATE(1931),
    [sym_subscript] = STATE(1398),
    [sym_string_expansion] = STATE(1389),
    [sym_expansion] = STATE(1389),
    [sym_concatenation] = STATE(1931),
    [aux_sym_declaration_command_repeat1] = STATE(1931),
    [aux_sym__literal_repeat1] = STATE(1396),
    [anon_sym_AMP_GT_GT] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_fi] = ACTIONS(503),
    [anon_sym_GT_LPAREN] = ACTIONS(3029),
    [anon_sym_else] = ACTIONS(503),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3031),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3033),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4206),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [sym_word] = ACTIONS(3037),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_LT_AMP] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [sym__special_character] = ACTIONS(3039),
    [anon_sym_LT_LT_DASH] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_raw_string] = ACTIONS(3037),
    [sym_variable_name] = ACTIONS(3043),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_AMP_GT] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_LT_LT_LT] = ACTIONS(503),
    [anon_sym_GT_AMP] = ACTIONS(503),
    [anon_sym_LT_LPAREN] = ACTIONS(3029),
    [anon_sym_elif] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
  },
  [1398] = {
    [anon_sym_EQ] = ACTIONS(4182),
    [anon_sym_PLUS_EQ] = ACTIONS(4182),
    [sym_comment] = ACTIONS(51),
  },
  [1399] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1932),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1400] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1935),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4208),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1401] = {
    [aux_sym_concatenation_repeat1] = STATE(1937),
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_fi] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [anon_sym_else] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(4212),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [anon_sym_elif] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [1402] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1938),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1403] = {
    [sym_string] = STATE(1940),
    [anon_sym_DQUOTE] = ACTIONS(4214),
    [anon_sym_STAR] = ACTIONS(4216),
    [anon_sym_QMARK] = ACTIONS(4216),
    [sym_raw_string] = ACTIONS(4218),
    [anon_sym_AT] = ACTIONS(4216),
    [anon_sym_DOLLAR] = ACTIONS(4220),
    [anon_sym_POUND] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_0] = ACTIONS(4222),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4222),
    [anon_sym__] = ACTIONS(4222),
  },
  [1404] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1942),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1943),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1405] = {
    [aux_sym_concatenation_repeat1] = STATE(1937),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(4212),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_elif] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1406] = {
    [sym_subscript] = STATE(1944),
    [anon_sym_STAR] = ACTIONS(4224),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_BANG] = ACTIONS(4226),
    [anon_sym_AT] = ACTIONS(4224),
    [sym_variable_name] = ACTIONS(4228),
    [anon_sym_DOLLAR] = ACTIONS(4230),
    [anon_sym_DASH] = ACTIONS(4230),
    [anon_sym_0] = ACTIONS(4232),
    [anon_sym_POUND] = ACTIONS(4226),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4232),
    [anon_sym__] = ACTIONS(4232),
    [sym_comment] = ACTIONS(3),
  },
  [1407] = {
    [aux_sym__literal_repeat1] = STATE(1949),
    [anon_sym_AMP_GT_GT] = ACTIONS(539),
    [anon_sym_DOLLAR] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_fi] = ACTIONS(539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(539),
    [anon_sym_else] = ACTIONS(539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(539),
    [anon_sym_GT_LPAREN] = ACTIONS(539),
    [aux_sym__simple_variable_name_token1] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [sym_word] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_LT_AMP] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(539),
    [sym__special_character] = ACTIONS(4234),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_raw_string] = ACTIONS(539),
    [sym_file_descriptor] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(539),
    [anon_sym_AMP_GT] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_LT_LT_LT] = ACTIONS(539),
    [anon_sym_GT_AMP] = ACTIONS(539),
    [anon_sym_LT_LPAREN] = ACTIONS(539),
    [anon_sym_elif] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_SEMI_SEMI] = ACTIONS(539),
    [anon_sym_PIPE_AMP] = ACTIONS(539),
  },
  [1408] = {
    [sym_process_substitution] = STATE(1401),
    [sym_command_substitution] = STATE(1401),
    [aux_sym_unset_command_repeat1] = STATE(1950),
    [sym_simple_expansion] = STATE(1401),
    [sym_string_expansion] = STATE(1401),
    [sym_expansion] = STATE(1401),
    [sym_concatenation] = STATE(1950),
    [sym_string] = STATE(1401),
    [aux_sym__literal_repeat1] = STATE(1407),
    [anon_sym_AMP_GT_GT] = ACTIONS(545),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_LT_LT] = ACTIONS(545),
    [anon_sym_fi] = ACTIONS(545),
    [anon_sym_GT_LPAREN] = ACTIONS(3049),
    [anon_sym_else] = ACTIONS(545),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3053),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4236),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_word] = ACTIONS(3057),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_LT_AMP] = ACTIONS(545),
    [anon_sym_GT_GT] = ACTIONS(545),
    [sym__special_character] = ACTIONS(3059),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_BQUOTE] = ACTIONS(3061),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(545),
    [sym_raw_string] = ACTIONS(3057),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_AMP_GT] = ACTIONS(545),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_LT_LT_LT] = ACTIONS(545),
    [anon_sym_GT_AMP] = ACTIONS(545),
    [anon_sym_LT_LPAREN] = ACTIONS(3049),
    [anon_sym_elif] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
  },
  [1409] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_fi] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_else] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [anon_sym_elif] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [1410] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_fi] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_else] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(555),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_EQ_EQ] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_elif] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [1411] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_fi] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [anon_sym_elif] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [1412] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4238),
  },
  [1413] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(4240),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1414] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4240),
  },
  [1415] = {
    [sym_process_substitution] = STATE(1955),
    [sym_string] = STATE(1955),
    [sym_command_substitution] = STATE(1955),
    [sym_simple_expansion] = STATE(1955),
    [sym_variable_assignment] = STATE(1963),
    [sym_subscript] = STATE(1964),
    [sym_string_expansion] = STATE(1955),
    [sym_expansion] = STATE(1955),
    [sym_concatenation] = STATE(1963),
    [aux_sym_declaration_command_repeat1] = STATE(1963),
    [aux_sym__literal_repeat1] = STATE(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_fi] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(4244),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4246),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4248),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4250),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(4252),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(4254),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(4256),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(4252),
    [sym_variable_name] = ACTIONS(4258),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(4260),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [1416] = {
    [sym_process_substitution] = STATE(1967),
    [sym_command_substitution] = STATE(1967),
    [aux_sym_unset_command_repeat1] = STATE(1974),
    [sym_simple_expansion] = STATE(1967),
    [sym_string_expansion] = STATE(1967),
    [sym_expansion] = STATE(1967),
    [sym_concatenation] = STATE(1974),
    [sym_string] = STATE(1967),
    [aux_sym__literal_repeat1] = STATE(1973),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_fi] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(4264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4268),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4270),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(4272),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(4274),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(4276),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(4272),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(4278),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(4264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [1417] = {
    [sym_string] = STATE(1976),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(4280),
    [sym_raw_string] = ACTIONS(4282),
    [anon_sym_AT] = ACTIONS(4280),
    [anon_sym_DOLLAR] = ACTIONS(4284),
    [anon_sym_POUND] = ACTIONS(4284),
    [anon_sym_DASH] = ACTIONS(4284),
    [anon_sym_0] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4286),
    [anon_sym__] = ACTIONS(4286),
  },
  [1418] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1978),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1419] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(1979),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(1980),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1420] = {
    [sym_subscript] = STATE(1981),
    [anon_sym_STAR] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4290),
    [anon_sym_AT] = ACTIONS(4288),
    [sym_variable_name] = ACTIONS(4292),
    [anon_sym_DOLLAR] = ACTIONS(4294),
    [anon_sym_DASH] = ACTIONS(4294),
    [anon_sym_0] = ACTIONS(4296),
    [anon_sym_POUND] = ACTIONS(4290),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4296),
    [anon_sym__] = ACTIONS(4296),
    [sym_comment] = ACTIONS(3),
  },
  [1421] = {
    [aux_sym_concatenation_repeat1] = STATE(1986),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_fi] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(4298),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [1422] = {
    [aux_sym_concatenation_repeat1] = STATE(1986),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(4298),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1423] = {
    [aux_sym_concatenation_repeat1] = STATE(1986),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_fi] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(4298),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [1424] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(1987),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1425] = {
    [sym_simple_expansion] = STATE(1423),
    [sym_test_command] = STATE(179),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(1431),
    [sym_concatenation] = STATE(1430),
    [sym_string] = STATE(1423),
    [sym_command_substitution] = STATE(1423),
    [sym_process_substitution] = STATE(1423),
    [sym_command_name] = STATE(1433),
    [aux_sym_command_repeat1] = STATE(1431),
    [sym_variable_assignment] = STATE(1431),
    [sym_string_expansion] = STATE(1423),
    [sym_expansion] = STATE(1423),
    [sym_subshell] = STATE(179),
    [sym_command] = STATE(179),
    [aux_sym__literal_repeat1] = STATE(1436),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3091),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
    [anon_sym_GT_LPAREN] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [sym_word] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3081),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(3089),
  },
  [1426] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(4300),
  },
  [1427] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(1991),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4302),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1428] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1999),
    [sym_file_redirect] = STATE(1999),
    [sym_herestring_redirect] = STATE(1999),
    [sym_heredoc_redirect] = STATE(1999),
    [anon_sym_SEMI_SEMI] = ACTIONS(4306),
    [anon_sym_AMP_GT_GT] = ACTIONS(4308),
    [anon_sym_LF] = ACTIONS(4310),
    [anon_sym_SEMI] = ACTIONS(4306),
    [sym_file_descriptor] = ACTIONS(4312),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_fi] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(4308),
    [anon_sym_AMP_GT] = ACTIONS(4308),
    [anon_sym_PIPE_PIPE] = ACTIONS(4314),
    [anon_sym_LT_LT_LT] = ACTIONS(4316),
    [anon_sym_GT_AMP] = ACTIONS(4308),
    [anon_sym_AMP] = ACTIONS(4306),
    [anon_sym_LT] = ACTIONS(4308),
    [anon_sym_LT_AMP] = ACTIONS(4308),
    [anon_sym_GT_GT] = ACTIONS(4308),
    [anon_sym_PIPE] = ACTIONS(4318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4314),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_PIPE_AMP] = ACTIONS(4318),
  },
  [1429] = {
    [anon_sym_EQ] = ACTIONS(4300),
    [anon_sym_PLUS_EQ] = ACTIONS(4300),
    [sym_comment] = ACTIONS(51),
  },
  [1430] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_fi] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [1431] = {
    [sym_process_substitution] = STATE(1423),
    [sym_command_substitution] = STATE(1423),
    [sym_command_name] = STATE(2000),
    [sym_simple_expansion] = STATE(1423),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [sym_string_expansion] = STATE(1423),
    [sym_expansion] = STATE(1423),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_concatenation] = STATE(1430),
    [sym_string] = STATE(1423),
    [aux_sym__literal_repeat1] = STATE(1436),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(3091),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
    [anon_sym_GT_LPAREN] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [sym_word] = ACTIONS(3091),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3081),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(4320),
  },
  [1432] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(4322),
  },
  [1433] = {
    [sym_process_substitution] = STATE(2001),
    [sym_command_substitution] = STATE(2001),
    [sym_simple_expansion] = STATE(2001),
    [sym_string_expansion] = STATE(2001),
    [sym_expansion] = STATE(2001),
    [aux_sym_command_repeat2] = STATE(2004),
    [sym_concatenation] = STATE(2004),
    [sym_string] = STATE(2001),
    [aux_sym__literal_repeat1] = STATE(2003),
    [anon_sym_AMP_GT_GT] = ACTIONS(367),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_LT_LT] = ACTIONS(367),
    [anon_sym_fi] = ACTIONS(367),
    [anon_sym_GT_LPAREN] = ACTIONS(4324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4328),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [sym_word] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(367),
    [anon_sym_GT_GT] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(4332),
    [sym__special_character] = ACTIONS(3089),
    [anon_sym_LT_LT_DASH] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(4334),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(4330),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_AMP_GT] = ACTIONS(367),
    [anon_sym_EQ_EQ] = ACTIONS(4332),
    [anon_sym_DQUOTE] = ACTIONS(4336),
    [anon_sym_LT_LT_LT] = ACTIONS(367),
    [anon_sym_GT_AMP] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(4324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
  },
  [1434] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1999),
    [sym_file_redirect] = STATE(1999),
    [sym_herestring_redirect] = STATE(1999),
    [sym_heredoc_redirect] = STATE(1999),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_fi] = ACTIONS(413),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(4314),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(4318),
    [anon_sym_AMP] = ACTIONS(4306),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(4310),
    [anon_sym_SEMI] = ACTIONS(4306),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(4316),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4314),
    [anon_sym_SEMI_SEMI] = ACTIONS(4306),
    [anon_sym_PIPE_AMP] = ACTIONS(4318),
  },
  [1435] = {
    [sym_redirected_statement] = STATE(2005),
    [sym_if_statement] = STATE(2005),
    [sym_function_definition] = STATE(2005),
    [sym_compound_statement] = STATE(2005),
    [sym_test_command] = STATE(2005),
    [sym_declaration_command] = STATE(2005),
    [sym_subscript] = STATE(1429),
    [sym_file_redirect] = STATE(1431),
    [sym_concatenation] = STATE(1430),
    [sym_string] = STATE(1423),
    [sym_command_substitution] = STATE(1423),
    [sym_process_substitution] = STATE(1423),
    [aux_sym_command_repeat1] = STATE(1431),
    [sym_for_statement] = STATE(2005),
    [sym_c_style_for_statement] = STATE(2005),
    [sym_case_statement] = STATE(2005),
    [sym_subshell] = STATE(2005),
    [sym_pipeline] = STATE(2005),
    [sym_unset_command] = STATE(2005),
    [sym_command] = STATE(2005),
    [sym_simple_expansion] = STATE(1423),
    [sym_while_statement] = STATE(2005),
    [sym_list] = STATE(2005),
    [sym_negated_command] = STATE(2005),
    [sym_command_name] = STATE(1433),
    [sym_variable_assignment] = STATE(2006),
    [sym_string_expansion] = STATE(1423),
    [sym_expansion] = STATE(1423),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(1436),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3073),
    [anon_sym_typeset] = ACTIONS(3073),
    [anon_sym_unsetenv] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_GT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3073),
    [sym__special_character] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_declare] = ACTIONS(3073),
    [sym_variable_name] = ACTIONS(3097),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3073),
    [anon_sym_unset] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3081),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1436] = {
    [aux_sym__literal_repeat1] = STATE(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_fi] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_EQ_TILDE] = ACTIONS(389),
    [sym__special_character] = ACTIONS(4338),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [1437] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2011),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2011),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4340),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4342),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4342),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4342),
    [anon_sym_PERCENT] = ACTIONS(4342),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4346),
    [anon_sym_COLON_DASH] = ACTIONS(4342),
    [sym__special_character] = ACTIONS(599),
  },
  [1438] = {
    [sym_subscript] = STATE(2012),
    [anon_sym_STAR] = ACTIONS(4348),
    [anon_sym_QMARK] = ACTIONS(4348),
    [anon_sym_AT] = ACTIONS(4348),
    [sym_variable_name] = ACTIONS(4350),
    [anon_sym_DOLLAR] = ACTIONS(4352),
    [anon_sym_DASH] = ACTIONS(4352),
    [anon_sym_0] = ACTIONS(4354),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4354),
    [anon_sym__] = ACTIONS(4354),
  },
  [1439] = {
    [anon_sym_EQ] = ACTIONS(4356),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1440] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2018),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2018),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4358),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4360),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4362),
    [anon_sym_DASH] = ACTIONS(4360),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4360),
    [anon_sym_PERCENT] = ACTIONS(4360),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4364),
    [anon_sym_COLON_DASH] = ACTIONS(4360),
    [sym__special_character] = ACTIONS(599),
  },
  [1441] = {
    [sym_process_substitution] = STATE(2019),
    [sym_string_expansion] = STATE(2019),
    [sym_expansion] = STATE(2019),
    [sym_simple_expansion] = STATE(2019),
    [sym_string] = STATE(2019),
    [sym_command_substitution] = STATE(2019),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [sym_word] = ACTIONS(4366),
    [sym_raw_string] = ACTIONS(4366),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [sym__special_character] = ACTIONS(4366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
  },
  [1442] = {
    [aux_sym_concatenation_repeat1] = STATE(2021),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_else] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(4368),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [anon_sym_elif] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1443] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4240),
  },
  [1444] = {
    [sym_process_substitution] = STATE(2025),
    [aux_sym__literal_repeat1] = STATE(2032),
    [sym_array] = STATE(2031),
    [sym_simple_expansion] = STATE(2025),
    [sym_string_expansion] = STATE(2025),
    [sym_expansion] = STATE(2025),
    [sym_concatenation] = STATE(2031),
    [sym_string] = STATE(2025),
    [sym_command_substitution] = STATE(2025),
    [anon_sym_LPAREN] = ACTIONS(4370),
    [anon_sym_BQUOTE] = ACTIONS(4372),
    [anon_sym_DQUOTE] = ACTIONS(4374),
    [sym_word] = ACTIONS(4376),
    [sym_raw_string] = ACTIONS(4376),
    [anon_sym_LT_LPAREN] = ACTIONS(4378),
    [anon_sym_DOLLAR] = ACTIONS(4380),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4382),
    [sym__special_character] = ACTIONS(4384),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4386),
    [sym__empty_value] = ACTIONS(4388),
  },
  [1445] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(4390),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1446] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_fi] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_elif] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1447] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4392),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1448] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(4394),
  },
  [1449] = {
    [sym_redirected_statement] = STATE(2036),
    [sym_if_statement] = STATE(2036),
    [sym_function_definition] = STATE(2036),
    [sym_compound_statement] = STATE(2036),
    [sym_test_command] = STATE(2036),
    [sym_declaration_command] = STATE(2036),
    [sym_subscript] = STATE(906),
    [sym_file_redirect] = STATE(908),
    [sym_concatenation] = STATE(907),
    [sym_string] = STATE(899),
    [sym_command_substitution] = STATE(899),
    [sym_process_substitution] = STATE(899),
    [aux_sym_command_repeat1] = STATE(908),
    [sym_for_statement] = STATE(2036),
    [sym_c_style_for_statement] = STATE(2036),
    [sym_case_statement] = STATE(2036),
    [sym_subshell] = STATE(2036),
    [sym_pipeline] = STATE(2036),
    [sym_unset_command] = STATE(2036),
    [sym_command] = STATE(2036),
    [sym_simple_expansion] = STATE(899),
    [sym_while_statement] = STATE(2036),
    [sym_list] = STATE(2036),
    [sym_negated_command] = STATE(2036),
    [sym_command_name] = STATE(912),
    [sym_variable_assignment] = STATE(2037),
    [sym_string_expansion] = STATE(899),
    [sym_expansion] = STATE(899),
    [aux_sym__literal_repeat1] = STATE(915),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1770),
    [anon_sym_typeset] = ACTIONS(1770),
    [anon_sym_unsetenv] = ACTIONS(1772),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1770),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(1790),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1770),
    [sym_variable_name] = ACTIONS(1796),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1770),
    [anon_sym_unset] = ACTIONS(1772),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1450] = {
    [sym_process_substitution] = STATE(2038),
    [aux_sym__literal_repeat1] = STATE(2040),
    [sym_simple_expansion] = STATE(2038),
    [sym_string_expansion] = STATE(2038),
    [sym_expansion] = STATE(2038),
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(2038),
    [sym_command_substitution] = STATE(2038),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(4396),
    [sym_raw_string] = ACTIONS(4396),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(4398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [1451] = {
    [sym_heredoc_body] = STATE(2041),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_elif] = ACTIONS(1220),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [1452] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_elif] = ACTIONS(1220),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [1453] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4400),
    [anon_sym_GT_AMP] = ACTIONS(4400),
    [anon_sym_LT] = ACTIONS(4402),
    [anon_sym_LT_AMP] = ACTIONS(4400),
    [anon_sym_GT_GT] = ACTIONS(4400),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(4402),
    [anon_sym_AMP_GT] = ACTIONS(4402),
  },
  [1454] = {
    [sym_redirected_statement] = STATE(2043),
    [sym_if_statement] = STATE(2043),
    [sym_function_definition] = STATE(2043),
    [sym_compound_statement] = STATE(2043),
    [sym_test_command] = STATE(2043),
    [sym_declaration_command] = STATE(2043),
    [sym_subscript] = STATE(906),
    [sym_file_redirect] = STATE(908),
    [sym_concatenation] = STATE(907),
    [sym_string] = STATE(899),
    [sym_command_substitution] = STATE(899),
    [sym_process_substitution] = STATE(899),
    [aux_sym_command_repeat1] = STATE(908),
    [sym_for_statement] = STATE(2043),
    [sym_c_style_for_statement] = STATE(2043),
    [sym_case_statement] = STATE(2043),
    [sym_subshell] = STATE(2043),
    [sym_pipeline] = STATE(2043),
    [sym_unset_command] = STATE(2043),
    [sym_command] = STATE(2043),
    [sym_simple_expansion] = STATE(899),
    [sym_while_statement] = STATE(2043),
    [sym_list] = STATE(2043),
    [sym_negated_command] = STATE(2043),
    [sym_command_name] = STATE(912),
    [sym_variable_assignment] = STATE(2044),
    [sym_string_expansion] = STATE(899),
    [sym_expansion] = STATE(899),
    [aux_sym__literal_repeat1] = STATE(915),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1770),
    [anon_sym_typeset] = ACTIONS(1770),
    [anon_sym_unsetenv] = ACTIONS(1772),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1770),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(1790),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1770),
    [sym_variable_name] = ACTIONS(1796),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1770),
    [anon_sym_unset] = ACTIONS(1772),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1455] = {
    [sym_process_substitution] = STATE(2045),
    [aux_sym__literal_repeat1] = STATE(2046),
    [sym_simple_expansion] = STATE(2045),
    [sym_string_expansion] = STATE(2045),
    [sym_expansion] = STATE(2045),
    [sym_concatenation] = STATE(609),
    [sym_string] = STATE(2045),
    [sym_command_substitution] = STATE(2045),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(4404),
    [sym_raw_string] = ACTIONS(4404),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(4398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [1456] = {
    [aux_sym_redirected_statement_repeat1] = STATE(2047),
    [sym_file_redirect] = STATE(2047),
    [sym_herestring_redirect] = STATE(2047),
    [sym_heredoc_redirect] = STATE(2047),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(3125),
    [anon_sym_LF] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(351),
    [sym_file_descriptor] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_fi] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(3125),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(3133),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_LT_AMP] = ACTIONS(3125),
    [anon_sym_elif] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
  },
  [1457] = {
    [sym_process_substitution] = STATE(1462),
    [sym_command_substitution] = STATE(1462),
    [sym_simple_expansion] = STATE(1462),
    [sym_string_expansion] = STATE(1462),
    [sym_expansion] = STATE(1462),
    [aux_sym_command_repeat2] = STATE(2048),
    [sym_concatenation] = STATE(2048),
    [sym_string] = STATE(1462),
    [aux_sym__literal_repeat1] = STATE(1464),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_fi] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(3145),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(3151),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(3153),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(3155),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(3151),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(3153),
    [anon_sym_DQUOTE] = ACTIONS(3157),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(3145),
    [anon_sym_elif] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [1458] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4406),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_AMP_GT_GT] = ACTIONS(4406),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4406),
    [sym_file_descriptor] = ACTIONS(4408),
    [anon_sym_GT] = ACTIONS(4406),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_AMP_GT] = ACTIONS(4406),
    [anon_sym_fi] = ACTIONS(4406),
    [anon_sym_else] = ACTIONS(4406),
    [anon_sym_done] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [ts_builtin_sym_end] = ACTIONS(4408),
    [anon_sym_LT_LT_LT] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4406),
    [anon_sym_GT_AMP] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_LT_AMP] = ACTIONS(4406),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_esac] = ACTIONS(4406),
    [anon_sym_SEMI_SEMI] = ACTIONS(4406),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
  },
  [1459] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(4410),
  },
  [1460] = {
    [sym_elif_clause] = STATE(1460),
    [aux_sym_if_statement_repeat1] = STATE(1460),
    [anon_sym_elif] = ACTIONS(4412),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(4415),
    [anon_sym_else] = ACTIONS(4415),
  },
  [1461] = {
    [sym_elif_clause] = STATE(1460),
    [sym_else_clause] = STATE(2050),
    [aux_sym_if_statement_repeat1] = STATE(1460),
    [anon_sym_elif] = ACTIONS(3141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(4410),
    [anon_sym_else] = ACTIONS(3143),
  },
  [1462] = {
    [aux_sym_concatenation_repeat1] = STATE(1442),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_else] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [sym__concat] = ACTIONS(3115),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [sym__special_character] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_elif] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
  },
  [1463] = {
    [sym_process_substitution] = STATE(2051),
    [aux_sym__literal_repeat1] = STATE(2053),
    [sym_simple_expansion] = STATE(2051),
    [sym_string_expansion] = STATE(2051),
    [sym_expansion] = STATE(2051),
    [sym_concatenation] = STATE(2052),
    [sym_string] = STATE(2051),
    [sym_command_substitution] = STATE(2051),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [sym_word] = ACTIONS(4417),
    [sym_raw_string] = ACTIONS(4417),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [sym__special_character] = ACTIONS(3137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
    [sym_regex] = ACTIONS(4419),
  },
  [1464] = {
    [aux_sym__literal_repeat1] = STATE(1469),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_fi] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_else] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(3159),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_elif] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
  },
  [1465] = {
    [sym_process_substitution] = STATE(1462),
    [sym_command_substitution] = STATE(1462),
    [sym_simple_expansion] = STATE(1462),
    [sym_string_expansion] = STATE(1462),
    [sym_expansion] = STATE(1462),
    [aux_sym_command_repeat2] = STATE(2054),
    [sym_concatenation] = STATE(2054),
    [sym_string] = STATE(1462),
    [aux_sym__literal_repeat1] = STATE(1464),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_fi] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(3145),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(3151),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(3153),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(3155),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(3151),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(3153),
    [anon_sym_DQUOTE] = ACTIONS(3157),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(3145),
    [anon_sym_elif] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [1466] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1456),
    [sym_file_redirect] = STATE(1456),
    [sym_herestring_redirect] = STATE(1456),
    [sym_heredoc_redirect] = STATE(1456),
    [anon_sym_PIPE_AMP] = ACTIONS(3135),
    [anon_sym_AMP_GT_GT] = ACTIONS(3125),
    [anon_sym_LF] = ACTIONS(4421),
    [anon_sym_SEMI] = ACTIONS(4423),
    [sym_file_descriptor] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_fi] = ACTIONS(1220),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_else] = ACTIONS(1220),
    [anon_sym_AMP_GT] = ACTIONS(3125),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_LT_LT_LT] = ACTIONS(3133),
    [anon_sym_GT_AMP] = ACTIONS(3125),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_LT_AMP] = ACTIONS(3125),
    [anon_sym_elif] = ACTIONS(1220),
    [anon_sym_GT_GT] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(4423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_SEMI_SEMI] = ACTIONS(4423),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
  },
  [1467] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1456),
    [sym_file_redirect] = STATE(1456),
    [sym_herestring_redirect] = STATE(1456),
    [sym_heredoc_redirect] = STATE(1456),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_fi] = ACTIONS(1220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_else] = ACTIONS(1220),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(4423),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(4421),
    [anon_sym_SEMI] = ACTIONS(4423),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(3133),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [anon_sym_elif] = ACTIONS(1220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_SEMI_SEMI] = ACTIONS(4423),
    [anon_sym_PIPE_AMP] = ACTIONS(3135),
  },
  [1468] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_elif] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1469] = {
    [aux_sym__literal_repeat1] = STATE(1469),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_EQ_TILDE] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(4425),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [anon_sym_elif] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1470] = {
    [anon_sym_AMP] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_in] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
  },
  [1471] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2058),
    [sym_case_item] = STATE(2059),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2059),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3176),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_esac] = ACTIONS(4428),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1472] = {
    [aux_sym_concatenation_repeat1] = STATE(2062),
    [aux_sym_case_item_repeat1] = STATE(2063),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(4432),
  },
  [1473] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4434),
    [anon_sym_BQUOTE] = ACTIONS(4434),
    [anon_sym_AMP_GT_GT] = ACTIONS(4434),
    [anon_sym_LF] = ACTIONS(4436),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_LT_LT] = ACTIONS(4434),
    [sym_file_descriptor] = ACTIONS(4436),
    [anon_sym_GT] = ACTIONS(4434),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_AMP_GT] = ACTIONS(4434),
    [anon_sym_fi] = ACTIONS(4434),
    [anon_sym_else] = ACTIONS(4434),
    [anon_sym_done] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [ts_builtin_sym_end] = ACTIONS(4436),
    [anon_sym_LT_LT_LT] = ACTIONS(4434),
    [anon_sym_PIPE] = ACTIONS(4434),
    [anon_sym_GT_AMP] = ACTIONS(4434),
    [anon_sym_LT] = ACTIONS(4434),
    [anon_sym_LT_AMP] = ACTIONS(4434),
    [anon_sym_GT_GT] = ACTIONS(4434),
    [anon_sym_AMP] = ACTIONS(4434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(4434),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_esac] = ACTIONS(4434),
    [anon_sym_SEMI_SEMI] = ACTIONS(4434),
    [anon_sym_PIPE_AMP] = ACTIONS(4434),
  },
  [1474] = {
    [aux_sym_concatenation_repeat1] = STATE(2062),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(221),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(221),
    [sym__special_character] = ACTIONS(221),
  },
  [1475] = {
    [aux_sym_case_item_repeat1] = STATE(2065),
    [aux_sym__literal_repeat1] = STATE(2066),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_PIPE] = ACTIONS(4432),
    [sym__special_character] = ACTIONS(867),
  },
  [1476] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(4440),
  },
  [1477] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2058),
    [sym_case_item] = STATE(2067),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2067),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3178),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1478] = {
    [aux_sym_case_item_repeat1] = STATE(2063),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [sym_comment] = ACTIONS(51),
  },
  [1479] = {
    [sym_string] = STATE(457),
    [anon_sym_STAR] = ACTIONS(805),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(4442),
    [anon_sym_DOLLAR] = ACTIONS(4444),
    [anon_sym_0] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(4444),
    [aux_sym__simple_variable_name_token1] = ACTIONS(805),
    [anon_sym_in] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(4446),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym__] = ACTIONS(805),
  },
  [1480] = {
    [anon_sym_AMP] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_in] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
  },
  [1481] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2069),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2069),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4448),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_DASH] = ACTIONS(4448),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4448),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4448),
    [anon_sym_PERCENT] = ACTIONS(4448),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4452),
    [anon_sym_COLON_DASH] = ACTIONS(4448),
    [sym__special_character] = ACTIONS(599),
  },
  [1482] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1483] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2069),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2069),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4448),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_DASH] = ACTIONS(4448),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4448),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4448),
    [anon_sym_PERCENT] = ACTIONS(4448),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4452),
    [anon_sym_COLON_DASH] = ACTIONS(4448),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4454),
  },
  [1484] = {
    [sym_process_substitution] = STATE(2071),
    [aux_sym__literal_repeat1] = STATE(2073),
    [sym_simple_expansion] = STATE(2071),
    [sym_string_expansion] = STATE(2071),
    [sym_expansion] = STATE(2071),
    [sym_concatenation] = STATE(2072),
    [sym_string] = STATE(2071),
    [sym_command_substitution] = STATE(2071),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(4456),
    [sym_raw_string] = ACTIONS(4456),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1485] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2076),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2076),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4458),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4460),
    [anon_sym_DASH] = ACTIONS(4458),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4458),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4458),
    [anon_sym_PERCENT] = ACTIONS(4458),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4462),
    [anon_sym_COLON_DASH] = ACTIONS(4458),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4464),
  },
  [1486] = {
    [anon_sym_AMP] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
  },
  [1487] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4460),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1488] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [sym__concat] = ACTIONS(2610),
  },
  [1489] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4450),
  },
  [1490] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(4466),
  },
  [1491] = {
    [anon_sym_AMP] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
  },
  [1492] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2079),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2079),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4468),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4470),
    [anon_sym_DASH] = ACTIONS(4468),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4468),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4468),
    [anon_sym_PERCENT] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4472),
    [anon_sym_COLON_DASH] = ACTIONS(4468),
    [sym__special_character] = ACTIONS(599),
  },
  [1493] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4470),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1494] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2081),
    [sym_case_item] = STATE(2082),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2082),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3176),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_esac] = ACTIONS(4474),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1495] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4476),
    [anon_sym_BQUOTE] = ACTIONS(4476),
    [anon_sym_AMP_GT_GT] = ACTIONS(4476),
    [anon_sym_LF] = ACTIONS(4478),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_LT_LT] = ACTIONS(4476),
    [sym_file_descriptor] = ACTIONS(4478),
    [anon_sym_GT] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_AMP_GT] = ACTIONS(4476),
    [anon_sym_fi] = ACTIONS(4476),
    [anon_sym_else] = ACTIONS(4476),
    [anon_sym_done] = ACTIONS(4476),
    [anon_sym_PIPE_PIPE] = ACTIONS(4476),
    [ts_builtin_sym_end] = ACTIONS(4478),
    [anon_sym_LT_LT_LT] = ACTIONS(4476),
    [anon_sym_PIPE] = ACTIONS(4476),
    [anon_sym_GT_AMP] = ACTIONS(4476),
    [anon_sym_LT] = ACTIONS(4476),
    [anon_sym_LT_AMP] = ACTIONS(4476),
    [anon_sym_GT_GT] = ACTIONS(4476),
    [anon_sym_AMP] = ACTIONS(4476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(4476),
    [anon_sym_AMP_AMP] = ACTIONS(4476),
    [anon_sym_esac] = ACTIONS(4476),
    [anon_sym_SEMI_SEMI] = ACTIONS(4476),
    [anon_sym_PIPE_AMP] = ACTIONS(4476),
  },
  [1496] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(4480),
  },
  [1497] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2081),
    [sym_case_item] = STATE(2067),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2067),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3178),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1498] = {
    [aux_sym_concatenation_repeat1] = STATE(1498),
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_PLUS_EQ] = ACTIONS(1544),
    [sym_test_operator] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_PIPE_PIPE] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1544),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1544),
    [anon_sym_DASH_EQ] = ACTIONS(1544),
  },
  [1499] = {
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3423),
    [sym_test_operator] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_LT_EQ] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_DASH_EQ] = ACTIONS(3423),
  },
  [1500] = {
    [sym_string] = STATE(483),
    [sym_test_operator] = ACTIONS(2662),
    [anon_sym_PLUS_EQ] = ACTIONS(2662),
    [anon_sym_PLUS_PLUS] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [anon_sym_DASH] = ACTIONS(4482),
    [aux_sym__simple_variable_name_token1] = ACTIONS(851),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2662),
    [anon_sym_PIPE_PIPE] = ACTIONS(2662),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2662),
    [anon_sym_QMARK] = ACTIONS(845),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_EQ_TILDE] = ACTIONS(2662),
    [anon_sym_DASH_DASH] = ACTIONS(2662),
    [anon_sym_LT_EQ] = ACTIONS(2662),
    [anon_sym_DASH_EQ] = ACTIONS(2662),
    [anon_sym_BANG_EQ] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(845),
    [sym_raw_string] = ACTIONS(847),
    [anon_sym_0] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(2658),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2662),
    [anon_sym_GT_EQ] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(849),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym__] = ACTIONS(851),
  },
  [1501] = {
    [anon_sym_BANG_EQ] = ACTIONS(2508),
    [anon_sym_PLUS_EQ] = ACTIONS(2508),
    [sym_test_operator] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2508),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2508),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2508),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_AMP_AMP] = ACTIONS(2508),
    [anon_sym_DASH_EQ] = ACTIONS(2508),
  },
  [1502] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2084),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2084),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_DASH] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4484),
    [anon_sym_PERCENT] = ACTIONS(4484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4488),
    [anon_sym_COLON_DASH] = ACTIONS(4484),
    [sym__special_character] = ACTIONS(599),
  },
  [1503] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1504] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2084),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2084),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_DASH] = ACTIONS(4484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4484),
    [anon_sym_PERCENT] = ACTIONS(4484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4488),
    [anon_sym_COLON_DASH] = ACTIONS(4484),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4490),
  },
  [1505] = {
    [sym_process_substitution] = STATE(2086),
    [aux_sym__literal_repeat1] = STATE(2088),
    [sym_simple_expansion] = STATE(2086),
    [sym_string_expansion] = STATE(2086),
    [sym_expansion] = STATE(2086),
    [sym_concatenation] = STATE(2087),
    [sym_string] = STATE(2086),
    [sym_command_substitution] = STATE(2086),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(4492),
    [sym_raw_string] = ACTIONS(4492),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1506] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2091),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2091),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4494),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4494),
    [anon_sym_PERCENT] = ACTIONS(4494),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4498),
    [anon_sym_COLON_DASH] = ACTIONS(4494),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4500),
  },
  [1507] = {
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_PLUS_EQ] = ACTIONS(2604),
    [sym_test_operator] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2604),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2604),
    [anon_sym_PIPE_PIPE] = ACTIONS(2604),
    [anon_sym_GT_EQ] = ACTIONS(2604),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2604),
    [anon_sym_LT_EQ] = ACTIONS(2604),
    [anon_sym_AMP_AMP] = ACTIONS(2604),
    [anon_sym_DASH_EQ] = ACTIONS(2604),
  },
  [1508] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1509] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [sym__concat] = ACTIONS(2610),
  },
  [1510] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4486),
  },
  [1511] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(4502),
  },
  [1512] = {
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [sym_test_operator] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2644),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_DASH_DASH] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
  },
  [1513] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2094),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2094),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4504),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4506),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4504),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4504),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4508),
    [anon_sym_COLON_DASH] = ACTIONS(4504),
    [sym__special_character] = ACTIONS(599),
  },
  [1514] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4506),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1515] = {
    [aux_sym_concatenation_repeat1] = STATE(2095),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym__concat] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1516] = {
    [aux_sym__literal_repeat1] = STATE(1516),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3701),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1517] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_BQUOTE] = ACTIONS(3732),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [anon_sym_case] = ACTIONS(3728),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [1518] = {
    [aux_sym_concatenation_repeat1] = STATE(1515),
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_BQUOTE] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [1519] = {
    [aux_sym__literal_repeat1] = STATE(1516),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_BQUOTE] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
  },
  [1520] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3734),
    [anon_sym_LF] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(4512),
    [anon_sym_SEMI_SEMI] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4512),
  },
  [1521] = {
    [anon_sym_BQUOTE] = ACTIONS(3307),
    [anon_sym_AMP_GT_GT] = ACTIONS(3307),
    [sym_raw_string] = ACTIONS(3307),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [sym_file_descriptor] = ACTIONS(3307),
    [sym_variable_name] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3307),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3307),
    [anon_sym_GT_LPAREN] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_word] = ACTIONS(3307),
    [anon_sym_GT_AMP] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3307),
    [anon_sym_GT_GT] = ACTIONS(3307),
    [anon_sym_LT_LPAREN] = ACTIONS(3307),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3307),
  },
  [1522] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(4514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [1523] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4516),
  },
  [1524] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(4518),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1525] = {
    [anon_sym_BQUOTE] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_word] = ACTIONS(941),
    [sym_raw_string] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(941),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(941),
    [sym__special_character] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(941),
  },
  [1526] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4520),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1527] = {
    [sym_process_substitution] = STATE(2101),
    [sym_string_expansion] = STATE(2101),
    [sym_expansion] = STATE(2101),
    [sym_simple_expansion] = STATE(2101),
    [sym_string] = STATE(2101),
    [sym_command_substitution] = STATE(2101),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(4522),
    [sym_raw_string] = ACTIONS(4522),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(4522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [1528] = {
    [aux_sym_concatenation_repeat1] = STATE(2103),
    [anon_sym_BQUOTE] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(631),
    [sym_word] = ACTIONS(631),
    [sym_raw_string] = ACTIONS(631),
    [sym__concat] = ACTIONS(4524),
    [anon_sym_LT_LPAREN] = ACTIONS(631),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(631),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(631),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(631),
    [sym__special_character] = ACTIONS(631),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(631),
  },
  [1529] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4526),
  },
  [1530] = {
    [anon_sym_BQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [sym_word] = ACTIONS(553),
    [sym_raw_string] = ACTIONS(553),
    [sym__concat] = ACTIONS(553),
    [anon_sym_LT_LPAREN] = ACTIONS(553),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(553),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(553),
    [sym__special_character] = ACTIONS(553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(553),
  },
  [1531] = {
    [anon_sym_BQUOTE] = ACTIONS(557),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [sym_word] = ACTIONS(557),
    [sym_raw_string] = ACTIONS(557),
    [sym__concat] = ACTIONS(557),
    [anon_sym_LT_LPAREN] = ACTIONS(557),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(557),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(557),
    [sym__special_character] = ACTIONS(557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(557),
  },
  [1532] = {
    [anon_sym_BQUOTE] = ACTIONS(561),
    [anon_sym_DQUOTE] = ACTIONS(561),
    [sym_word] = ACTIONS(561),
    [sym_raw_string] = ACTIONS(561),
    [sym__concat] = ACTIONS(561),
    [anon_sym_LT_LPAREN] = ACTIONS(561),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(561),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(561),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(561),
    [sym__special_character] = ACTIONS(561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(561),
  },
  [1533] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(4516),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1534] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4516),
  },
  [1535] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2107),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2107),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4528),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4530),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4530),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4530),
    [anon_sym_PERCENT] = ACTIONS(4530),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4534),
    [anon_sym_COLON_DASH] = ACTIONS(4530),
    [sym__special_character] = ACTIONS(599),
  },
  [1536] = {
    [sym_subscript] = STATE(2108),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_QMARK] = ACTIONS(4536),
    [anon_sym_AT] = ACTIONS(4536),
    [sym_variable_name] = ACTIONS(4538),
    [anon_sym_DOLLAR] = ACTIONS(4540),
    [anon_sym_DASH] = ACTIONS(4540),
    [anon_sym_0] = ACTIONS(4542),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4542),
    [anon_sym__] = ACTIONS(4542),
  },
  [1537] = {
    [anon_sym_EQ] = ACTIONS(4544),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1538] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2114),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2114),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4546),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4548),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4550),
    [anon_sym_DASH] = ACTIONS(4548),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_PERCENT] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4552),
    [anon_sym_COLON_DASH] = ACTIONS(4548),
    [sym__special_character] = ACTIONS(599),
  },
  [1539] = {
    [anon_sym_BQUOTE] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(221),
    [sym_word] = ACTIONS(221),
    [sym_raw_string] = ACTIONS(221),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(221),
    [sym__special_character] = ACTIONS(221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(221),
  },
  [1540] = {
    [aux_sym__literal_repeat1] = STATE(1540),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_word] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [sym__special_character] = ACTIONS(4554),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
  },
  [1541] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [ts_builtin_sym_end] = ACTIONS(4559),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [1542] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(4561),
    [anon_sym_DQUOTE] = ACTIONS(4564),
    [sym_word] = ACTIONS(4567),
    [sym_raw_string] = ACTIONS(4567),
    [anon_sym_LT_LPAREN] = ACTIONS(4570),
    [anon_sym_DOLLAR] = ACTIONS(4573),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4570),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4578),
    [sym__special_character] = ACTIONS(4581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4584),
  },
  [1543] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [1544] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [ts_builtin_sym_end] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [1545] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(4587),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1546] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1547] = {
    [sym_process_substitution] = STATE(1546),
    [sym_string_expansion] = STATE(1546),
    [sym_expansion] = STATE(1546),
    [sym_simple_expansion] = STATE(1546),
    [sym_string] = STATE(1546),
    [sym_command_substitution] = STATE(1546),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3333),
    [sym_raw_string] = ACTIONS(3333),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(4589),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(3333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1548] = {
    [aux_sym_concatenation_repeat1] = STATE(1548),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4591),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1549] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [ts_builtin_sym_end] = ACTIONS(1436),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [1550] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2119),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2119),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4594),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_DASH] = ACTIONS(4594),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4598),
    [anon_sym_COLON_DASH] = ACTIONS(4594),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4600),
  },
  [1551] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [ts_builtin_sym_end] = ACTIONS(1478),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [1552] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1553] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2119),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2119),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4602),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4594),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_DASH] = ACTIONS(4594),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4598),
    [anon_sym_COLON_DASH] = ACTIONS(4594),
    [sym__special_character] = ACTIONS(599),
  },
  [1554] = {
    [anon_sym_EQ] = ACTIONS(4604),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1555] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2124),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2124),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4606),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(4608),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4608),
    [anon_sym_PERCENT] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4612),
    [anon_sym_COLON_DASH] = ACTIONS(4608),
    [sym__special_character] = ACTIONS(599),
  },
  [1556] = {
    [sym_process_substitution] = STATE(2125),
    [aux_sym__literal_repeat1] = STATE(2127),
    [sym_simple_expansion] = STATE(2125),
    [sym_string_expansion] = STATE(2125),
    [sym_expansion] = STATE(2125),
    [sym_concatenation] = STATE(2126),
    [sym_string] = STATE(2125),
    [sym_command_substitution] = STATE(2125),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(4614),
    [sym_raw_string] = ACTIONS(4614),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1557] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2130),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2130),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4616),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(4616),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4616),
    [anon_sym_PERCENT] = ACTIONS(4616),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4620),
    [anon_sym_COLON_DASH] = ACTIONS(4616),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4622),
  },
  [1558] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [ts_builtin_sym_end] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [1559] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1560] = {
    [anon_sym_EQ] = ACTIONS(4624),
    [anon_sym_PLUS_EQ] = ACTIONS(4624),
    [sym_comment] = ACTIONS(51),
  },
  [1561] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(4624),
    [sym__concat] = ACTIONS(4626),
    [anon_sym_EQ] = ACTIONS(4624),
  },
  [1562] = {
    [sym_process_substitution] = STATE(1098),
    [sym_string_expansion] = STATE(1098),
    [sym_expansion] = STATE(1098),
    [sym_simple_expansion] = STATE(1098),
    [sym_string] = STATE(1098),
    [sym_command_substitution] = STATE(1098),
    [anon_sym_BQUOTE] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym_word] = ACTIONS(2173),
    [sym_raw_string] = ACTIONS(2173),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(4628),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(327),
    [sym__special_character] = ACTIONS(2173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(331),
  },
  [1563] = {
    [aux_sym_concatenation_repeat1] = STATE(1563),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(3630),
  },
  [1564] = {
    [anon_sym_EQ] = ACTIONS(4630),
    [anon_sym_PLUS_EQ] = ACTIONS(4630),
    [sym_comment] = ACTIONS(51),
  },
  [1565] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(4630),
    [sym__concat] = ACTIONS(4632),
    [anon_sym_EQ] = ACTIONS(4630),
  },
  [1566] = {
    [anon_sym_BQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE] = ACTIONS(2508),
    [sym__concat] = ACTIONS(2508),
    [sym__string_content] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2508),
  },
  [1567] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2135),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2135),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4634),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_DASH] = ACTIONS(4634),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4634),
    [anon_sym_PERCENT] = ACTIONS(4634),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4638),
    [anon_sym_COLON_DASH] = ACTIONS(4634),
    [sym__special_character] = ACTIONS(599),
  },
  [1568] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1569] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2135),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2135),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4634),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_DASH] = ACTIONS(4634),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4634),
    [anon_sym_PERCENT] = ACTIONS(4634),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4638),
    [anon_sym_COLON_DASH] = ACTIONS(4634),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4640),
  },
  [1570] = {
    [sym_process_substitution] = STATE(2137),
    [aux_sym__literal_repeat1] = STATE(2139),
    [sym_simple_expansion] = STATE(2137),
    [sym_string_expansion] = STATE(2137),
    [sym_expansion] = STATE(2137),
    [sym_concatenation] = STATE(2138),
    [sym_string] = STATE(2137),
    [sym_command_substitution] = STATE(2137),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(4642),
    [sym_raw_string] = ACTIONS(4642),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1571] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2142),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2142),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4644),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(4644),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4644),
    [anon_sym_PERCENT] = ACTIONS(4644),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4648),
    [anon_sym_COLON_DASH] = ACTIONS(4644),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4650),
  },
  [1572] = {
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym__concat] = ACTIONS(2604),
    [sym__string_content] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
  },
  [1573] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1574] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [sym__concat] = ACTIONS(2610),
  },
  [1575] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4636),
  },
  [1576] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(4652),
  },
  [1577] = {
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [sym__concat] = ACTIONS(2646),
    [sym__string_content] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2646),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2646),
  },
  [1578] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2145),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2145),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4654),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4654),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(4654),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4658),
    [anon_sym_COLON_DASH] = ACTIONS(4654),
    [sym__special_character] = ACTIONS(599),
  },
  [1579] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1580] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4660),
  },
  [1581] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(4662),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1582] = {
    [anon_sym_BQUOTE] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
  },
  [1583] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4664),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1584] = {
    [sym_process_substitution] = STATE(2149),
    [sym_string_expansion] = STATE(2149),
    [sym_expansion] = STATE(2149),
    [sym_simple_expansion] = STATE(2149),
    [sym_string] = STATE(2149),
    [sym_command_substitution] = STATE(2149),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [sym_word] = ACTIONS(4666),
    [sym_raw_string] = ACTIONS(4666),
    [anon_sym_LT_LPAREN] = ACTIONS(2071),
    [anon_sym_DOLLAR] = ACTIONS(2073),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2075),
    [sym__special_character] = ACTIONS(4666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2079),
  },
  [1585] = {
    [aux_sym_concatenation_repeat1] = STATE(2151),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [sym__concat] = ACTIONS(4668),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
  },
  [1586] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4670),
  },
  [1587] = {
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
  },
  [1588] = {
    [anon_sym_BQUOTE] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
  },
  [1589] = {
    [anon_sym_BQUOTE] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
  },
  [1590] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(4660),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1591] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4660),
  },
  [1592] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2155),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2155),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4672),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4674),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4676),
    [anon_sym_DASH] = ACTIONS(4674),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4674),
    [anon_sym_PERCENT] = ACTIONS(4674),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4678),
    [anon_sym_COLON_DASH] = ACTIONS(4674),
    [sym__special_character] = ACTIONS(599),
  },
  [1593] = {
    [sym_subscript] = STATE(2156),
    [anon_sym_STAR] = ACTIONS(4680),
    [anon_sym_QMARK] = ACTIONS(4680),
    [anon_sym_AT] = ACTIONS(4680),
    [sym_variable_name] = ACTIONS(4682),
    [anon_sym_DOLLAR] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4684),
    [anon_sym_0] = ACTIONS(4686),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4686),
    [anon_sym__] = ACTIONS(4686),
  },
  [1594] = {
    [anon_sym_EQ] = ACTIONS(4688),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1595] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2162),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2162),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4690),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4692),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4694),
    [anon_sym_DASH] = ACTIONS(4692),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4692),
    [anon_sym_PERCENT] = ACTIONS(4692),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4696),
    [anon_sym_COLON_DASH] = ACTIONS(4692),
    [sym__special_character] = ACTIONS(599),
  },
  [1596] = {
    [anon_sym_BQUOTE] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
  },
  [1597] = {
    [aux_sym__literal_repeat1] = STATE(1597),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(4698),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
  },
  [1598] = {
    [sym_do_group] = STATE(2163),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(991),
  },
  [1599] = {
    [sym_process_substitution] = STATE(1037),
    [sym_command_substitution] = STATE(1037),
    [aux_sym_for_statement_repeat1] = STATE(1599),
    [sym_simple_expansion] = STATE(1037),
    [sym_string_expansion] = STATE(1037),
    [sym_expansion] = STATE(1037),
    [sym_concatenation] = STATE(1599),
    [sym_string] = STATE(1037),
    [aux_sym__literal_repeat1] = STATE(1043),
    [anon_sym_BQUOTE] = ACTIONS(4701),
    [sym_raw_string] = ACTIONS(4704),
    [anon_sym_LF] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4707),
    [anon_sym_DOLLAR] = ACTIONS(4709),
    [anon_sym_GT_LPAREN] = ACTIONS(4712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4718),
    [anon_sym_DQUOTE] = ACTIONS(4721),
    [sym_word] = ACTIONS(4704),
    [anon_sym_AMP] = ACTIONS(4707),
    [anon_sym_LT_LPAREN] = ACTIONS(4712),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(4724),
    [anon_sym_SEMI_SEMI] = ACTIONS(4707),
  },
  [1600] = {
    [anon_sym_BANG_EQ] = ACTIONS(3227),
    [anon_sym_PLUS_EQ] = ACTIONS(3227),
    [sym_test_operator] = ACTIONS(3225),
    [anon_sym_LF] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_GT] = ACTIONS(3227),
    [anon_sym_EQ] = ACTIONS(3227),
    [anon_sym_EQ_EQ] = ACTIONS(3227),
    [anon_sym_PIPE_PIPE] = ACTIONS(3227),
    [anon_sym_GT_EQ] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3227),
    [anon_sym_AMP] = ACTIONS(3227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3227),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [anon_sym_AMP_AMP] = ACTIONS(3227),
    [anon_sym_LT_EQ] = ACTIONS(3227),
    [anon_sym_SEMI_SEMI] = ACTIONS(3227),
    [anon_sym_DASH_EQ] = ACTIONS(3227),
  },
  [1601] = {
    [anon_sym_BANG_EQ] = ACTIONS(1440),
    [anon_sym_PLUS_EQ] = ACTIONS(1440),
    [sym_test_operator] = ACTIONS(1442),
    [anon_sym_LF] = ACTIONS(1440),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [anon_sym_GT_EQ] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_LT_EQ] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_DASH_EQ] = ACTIONS(1440),
  },
  [1602] = {
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_PLUS_EQ] = ACTIONS(1542),
    [sym_test_operator] = ACTIONS(1544),
    [anon_sym_LF] = ACTIONS(1542),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_DASH_EQ] = ACTIONS(1542),
  },
  [1603] = {
    [sym_process_substitution] = STATE(1602),
    [sym_string_expansion] = STATE(1602),
    [sym_expansion] = STATE(1602),
    [sym_simple_expansion] = STATE(1602),
    [sym_string] = STATE(1602),
    [sym_command_substitution] = STATE(1602),
    [anon_sym_BQUOTE] = ACTIONS(2087),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [sym_word] = ACTIONS(3479),
    [sym_raw_string] = ACTIONS(3479),
    [anon_sym_LT_LPAREN] = ACTIONS(2089),
    [anon_sym_DOLLAR] = ACTIONS(4727),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2091),
    [sym__special_character] = ACTIONS(3479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2095),
  },
  [1604] = {
    [aux_sym_concatenation_repeat1] = STATE(1604),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_PLUS_EQ] = ACTIONS(1542),
    [sym_test_operator] = ACTIONS(1544),
    [anon_sym_LF] = ACTIONS(1542),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4729),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_DASH_EQ] = ACTIONS(1542),
  },
  [1605] = {
    [sym_do_group] = STATE(2166),
    [sym_compound_statement] = STATE(2166),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(4732),
    [anon_sym_do] = ACTIONS(991),
  },
  [1606] = {
    [anon_sym_BANG_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [sym_test_operator] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4734),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_GT_EQ] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_DASH_EQ] = ACTIONS(869),
  },
  [1607] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(2168),
    [sym_parenthesized_expression] = STATE(2168),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(2168),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(2168),
    [sym_unary_expression] = STATE(2168),
    [sym_concatenation] = STATE(2168),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4734),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(273),
  },
  [1608] = {
    [anon_sym_BANG_EQ] = ACTIONS(1434),
    [anon_sym_PLUS_EQ] = ACTIONS(1434),
    [sym_test_operator] = ACTIONS(1436),
    [anon_sym_LF] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [anon_sym_GT_EQ] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1434),
    [anon_sym_DASH_DASH] = ACTIONS(1434),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_LT_EQ] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_DASH_EQ] = ACTIONS(1434),
  },
  [1609] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2171),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2171),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4736),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4738),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4736),
    [anon_sym_PERCENT] = ACTIONS(4736),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4740),
    [anon_sym_COLON_DASH] = ACTIONS(4736),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4742),
  },
  [1610] = {
    [anon_sym_BANG_EQ] = ACTIONS(1476),
    [anon_sym_PLUS_EQ] = ACTIONS(1476),
    [sym_test_operator] = ACTIONS(1478),
    [anon_sym_LF] = ACTIONS(1476),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_DASH_EQ] = ACTIONS(1476),
  },
  [1611] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4738),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1612] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2171),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2171),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4744),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4736),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4738),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4736),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4736),
    [anon_sym_PERCENT] = ACTIONS(4736),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4740),
    [anon_sym_COLON_DASH] = ACTIONS(4736),
    [sym__special_character] = ACTIONS(599),
  },
  [1613] = {
    [anon_sym_EQ] = ACTIONS(4746),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1614] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2176),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2176),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4748),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4750),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4752),
    [anon_sym_DASH] = ACTIONS(4750),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4750),
    [anon_sym_PERCENT] = ACTIONS(4750),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4754),
    [anon_sym_COLON_DASH] = ACTIONS(4750),
    [sym__special_character] = ACTIONS(599),
  },
  [1615] = {
    [sym_process_substitution] = STATE(2177),
    [aux_sym__literal_repeat1] = STATE(2179),
    [sym_simple_expansion] = STATE(2177),
    [sym_string_expansion] = STATE(2177),
    [sym_expansion] = STATE(2177),
    [sym_concatenation] = STATE(2178),
    [sym_string] = STATE(2177),
    [sym_command_substitution] = STATE(2177),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(4756),
    [sym_raw_string] = ACTIONS(4756),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4738),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1616] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2182),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2182),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4758),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4760),
    [anon_sym_DASH] = ACTIONS(4758),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4758),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4762),
    [anon_sym_COLON_DASH] = ACTIONS(4758),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4764),
  },
  [1617] = {
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_PLUS_EQ] = ACTIONS(1532),
    [sym_test_operator] = ACTIONS(1534),
    [anon_sym_LF] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_PLUS_PLUS] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_GT_EQ] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1532),
    [anon_sym_DASH_DASH] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_LT_EQ] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_DASH_EQ] = ACTIONS(1532),
  },
  [1618] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4760),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1619] = {
    [anon_sym_BANG_EQ] = ACTIONS(2010),
    [anon_sym_PLUS_EQ] = ACTIONS(2010),
    [sym_test_operator] = ACTIONS(2012),
    [anon_sym_LF] = ACTIONS(2010),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [anon_sym_GT_EQ] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_LT_EQ] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_DASH_EQ] = ACTIONS(2010),
  },
  [1620] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(4766),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1621] = {
    [anon_sym_BANG_EQ] = ACTIONS(3268),
    [anon_sym_PLUS_EQ] = ACTIONS(3268),
    [sym_test_operator] = ACTIONS(3266),
    [anon_sym_LF] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_EQ_EQ] = ACTIONS(3268),
    [anon_sym_PIPE_PIPE] = ACTIONS(3268),
    [anon_sym_GT_EQ] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3268),
    [anon_sym_LT_EQ] = ACTIONS(3268),
    [anon_sym_SEMI_SEMI] = ACTIONS(3268),
    [anon_sym_DASH_EQ] = ACTIONS(3268),
  },
  [1622] = {
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [sym_test_operator] = ACTIONS(2127),
    [anon_sym_LF] = ACTIONS(4768),
    [anon_sym_SEMI] = ACTIONS(4768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_SEMI_SEMI] = ACTIONS(4768),
    [anon_sym_DASH_EQ] = ACTIONS(2125),
  },
  [1623] = {
    [anon_sym_BANG_EQ] = ACTIONS(3268),
    [anon_sym_PLUS_EQ] = ACTIONS(3268),
    [sym_test_operator] = ACTIONS(3266),
    [anon_sym_LF] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_EQ_EQ] = ACTIONS(3268),
    [anon_sym_PIPE_PIPE] = ACTIONS(3268),
    [anon_sym_GT_EQ] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3268),
    [anon_sym_LT_EQ] = ACTIONS(3268),
    [anon_sym_SEMI_SEMI] = ACTIONS(3268),
    [anon_sym_DASH_EQ] = ACTIONS(3268),
  },
  [1624] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(2185),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1625] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(2188),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4770),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1626] = {
    [aux_sym_concatenation_repeat1] = STATE(2190),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_done] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(4774),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1627] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2191),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1628] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(4776),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(4776),
  },
  [1629] = {
    [sym_string] = STATE(2194),
    [anon_sym_DQUOTE] = ACTIONS(4778),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_QMARK] = ACTIONS(4780),
    [sym_raw_string] = ACTIONS(4782),
    [anon_sym_AT] = ACTIONS(4780),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_POUND] = ACTIONS(4784),
    [anon_sym_DASH] = ACTIONS(4784),
    [anon_sym_0] = ACTIONS(4786),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4786),
    [anon_sym__] = ACTIONS(4786),
  },
  [1630] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(2196),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2197),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1631] = {
    [aux_sym_concatenation_repeat1] = STATE(2190),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(4774),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1632] = {
    [sym_subscript] = STATE(2198),
    [anon_sym_STAR] = ACTIONS(4788),
    [anon_sym_QMARK] = ACTIONS(4788),
    [anon_sym_BANG] = ACTIONS(4790),
    [anon_sym_AT] = ACTIONS(4788),
    [sym_variable_name] = ACTIONS(4792),
    [anon_sym_DOLLAR] = ACTIONS(4794),
    [anon_sym_DASH] = ACTIONS(4794),
    [anon_sym_0] = ACTIONS(4796),
    [anon_sym_POUND] = ACTIONS(4790),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4796),
    [anon_sym__] = ACTIONS(4796),
    [sym_comment] = ACTIONS(3),
  },
  [1633] = {
    [aux_sym__literal_repeat1] = STATE(2203),
    [anon_sym_AMP_GT_GT] = ACTIONS(497),
    [anon_sym_DOLLAR] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(497),
    [anon_sym_GT_LPAREN] = ACTIONS(497),
    [anon_sym_done] = ACTIONS(497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(497),
    [aux_sym__simple_variable_name_token1] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [sym_word] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(497),
    [anon_sym_LT_AMP] = ACTIONS(497),
    [anon_sym_GT_GT] = ACTIONS(497),
    [sym__special_character] = ACTIONS(4798),
    [anon_sym_LT_LT_DASH] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(497),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(497),
    [sym_raw_string] = ACTIONS(497),
    [sym_variable_name] = ACTIONS(501),
    [sym_file_descriptor] = ACTIONS(501),
    [anon_sym_GT] = ACTIONS(497),
    [anon_sym_AMP_GT] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(497),
    [anon_sym_LT_LT_LT] = ACTIONS(497),
    [anon_sym_GT_AMP] = ACTIONS(497),
    [anon_sym_LT_LPAREN] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [anon_sym_PIPE_AMP] = ACTIONS(497),
  },
  [1634] = {
    [sym_process_substitution] = STATE(1626),
    [sym_string] = STATE(1626),
    [sym_command_substitution] = STATE(1626),
    [sym_simple_expansion] = STATE(1626),
    [sym_variable_assignment] = STATE(2204),
    [sym_subscript] = STATE(1635),
    [sym_string_expansion] = STATE(1626),
    [sym_expansion] = STATE(1626),
    [sym_concatenation] = STATE(2204),
    [aux_sym_declaration_command_repeat1] = STATE(2204),
    [aux_sym__literal_repeat1] = STATE(1633),
    [anon_sym_AMP_GT_GT] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(3524),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_GT_LPAREN] = ACTIONS(3526),
    [anon_sym_done] = ACTIONS(503),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3530),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4800),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [sym_word] = ACTIONS(3534),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_LT_AMP] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [sym__special_character] = ACTIONS(3536),
    [anon_sym_LT_LT_DASH] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(3538),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_raw_string] = ACTIONS(3534),
    [sym_variable_name] = ACTIONS(3540),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_AMP_GT] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_LT_LT_LT] = ACTIONS(503),
    [anon_sym_GT_AMP] = ACTIONS(503),
    [anon_sym_LT_LPAREN] = ACTIONS(3526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
  },
  [1635] = {
    [anon_sym_EQ] = ACTIONS(4776),
    [anon_sym_PLUS_EQ] = ACTIONS(4776),
    [sym_comment] = ACTIONS(51),
  },
  [1636] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(2205),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1637] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(2208),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4802),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1638] = {
    [aux_sym_concatenation_repeat1] = STATE(2210),
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_done] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(4806),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [1639] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2211),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1640] = {
    [sym_string] = STATE(2213),
    [anon_sym_DQUOTE] = ACTIONS(4808),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4810),
    [sym_raw_string] = ACTIONS(4812),
    [anon_sym_AT] = ACTIONS(4810),
    [anon_sym_DOLLAR] = ACTIONS(4814),
    [anon_sym_POUND] = ACTIONS(4814),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_0] = ACTIONS(4816),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4816),
    [anon_sym__] = ACTIONS(4816),
  },
  [1641] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(2215),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2216),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1642] = {
    [aux_sym_concatenation_repeat1] = STATE(2210),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(4806),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1643] = {
    [sym_subscript] = STATE(2217),
    [anon_sym_STAR] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4818),
    [anon_sym_BANG] = ACTIONS(4820),
    [anon_sym_AT] = ACTIONS(4818),
    [sym_variable_name] = ACTIONS(4822),
    [anon_sym_DOLLAR] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4824),
    [anon_sym_0] = ACTIONS(4826),
    [anon_sym_POUND] = ACTIONS(4820),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4826),
    [anon_sym__] = ACTIONS(4826),
    [sym_comment] = ACTIONS(3),
  },
  [1644] = {
    [aux_sym__literal_repeat1] = STATE(2222),
    [anon_sym_AMP_GT_GT] = ACTIONS(539),
    [anon_sym_DOLLAR] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_GT_LPAREN] = ACTIONS(539),
    [anon_sym_done] = ACTIONS(539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(539),
    [aux_sym__simple_variable_name_token1] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [sym_word] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_LT_AMP] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(539),
    [sym__special_character] = ACTIONS(4828),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_raw_string] = ACTIONS(539),
    [sym_file_descriptor] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(539),
    [anon_sym_AMP_GT] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_LT_LT_LT] = ACTIONS(539),
    [anon_sym_GT_AMP] = ACTIONS(539),
    [anon_sym_LT_LPAREN] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_SEMI_SEMI] = ACTIONS(539),
    [anon_sym_PIPE_AMP] = ACTIONS(539),
  },
  [1645] = {
    [sym_process_substitution] = STATE(1638),
    [sym_command_substitution] = STATE(1638),
    [aux_sym_unset_command_repeat1] = STATE(2223),
    [sym_simple_expansion] = STATE(1638),
    [sym_string_expansion] = STATE(1638),
    [sym_expansion] = STATE(1638),
    [sym_concatenation] = STATE(2223),
    [sym_string] = STATE(1638),
    [aux_sym__literal_repeat1] = STATE(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(545),
    [anon_sym_DOLLAR] = ACTIONS(3544),
    [anon_sym_LT_LT] = ACTIONS(545),
    [anon_sym_GT_LPAREN] = ACTIONS(3546),
    [anon_sym_done] = ACTIONS(545),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3550),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4830),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_word] = ACTIONS(3554),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_LT_AMP] = ACTIONS(545),
    [anon_sym_GT_GT] = ACTIONS(545),
    [sym__special_character] = ACTIONS(3556),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_BQUOTE] = ACTIONS(3558),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(545),
    [sym_raw_string] = ACTIONS(3554),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_AMP_GT] = ACTIONS(545),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [anon_sym_LT_LT_LT] = ACTIONS(545),
    [anon_sym_GT_AMP] = ACTIONS(545),
    [anon_sym_LT_LPAREN] = ACTIONS(3546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
  },
  [1646] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_done] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [1647] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_done] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(555),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_EQ_EQ] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [1648] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_done] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [1649] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4832),
  },
  [1650] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(4834),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1651] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4834),
  },
  [1652] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2228),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2228),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4836),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4838),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4840),
    [anon_sym_DASH] = ACTIONS(4838),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4838),
    [anon_sym_PERCENT] = ACTIONS(4838),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4842),
    [anon_sym_COLON_DASH] = ACTIONS(4838),
    [sym__special_character] = ACTIONS(599),
  },
  [1653] = {
    [sym_subscript] = STATE(2229),
    [anon_sym_STAR] = ACTIONS(4844),
    [anon_sym_QMARK] = ACTIONS(4844),
    [anon_sym_AT] = ACTIONS(4844),
    [sym_variable_name] = ACTIONS(4846),
    [anon_sym_DOLLAR] = ACTIONS(4848),
    [anon_sym_DASH] = ACTIONS(4848),
    [anon_sym_0] = ACTIONS(4850),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4850),
    [anon_sym__] = ACTIONS(4850),
  },
  [1654] = {
    [anon_sym_EQ] = ACTIONS(4852),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1655] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2235),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2235),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4854),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4856),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4858),
    [anon_sym_DASH] = ACTIONS(4856),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4856),
    [anon_sym_PERCENT] = ACTIONS(4856),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4860),
    [anon_sym_COLON_DASH] = ACTIONS(4856),
    [sym__special_character] = ACTIONS(599),
  },
  [1656] = {
    [sym_process_substitution] = STATE(2236),
    [sym_string_expansion] = STATE(2236),
    [sym_expansion] = STATE(2236),
    [sym_simple_expansion] = STATE(2236),
    [sym_string] = STATE(2236),
    [sym_command_substitution] = STATE(2236),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_word] = ACTIONS(4862),
    [sym_raw_string] = ACTIONS(4862),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [sym__special_character] = ACTIONS(4862),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
  },
  [1657] = {
    [aux_sym_concatenation_repeat1] = STATE(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_done] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(4864),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1658] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4834),
  },
  [1659] = {
    [sym_process_substitution] = STATE(2242),
    [aux_sym__literal_repeat1] = STATE(2249),
    [sym_array] = STATE(2248),
    [sym_simple_expansion] = STATE(2242),
    [sym_string_expansion] = STATE(2242),
    [sym_expansion] = STATE(2242),
    [sym_concatenation] = STATE(2248),
    [sym_string] = STATE(2242),
    [sym_command_substitution] = STATE(2242),
    [anon_sym_LPAREN] = ACTIONS(4866),
    [anon_sym_BQUOTE] = ACTIONS(4868),
    [anon_sym_DQUOTE] = ACTIONS(4870),
    [sym_word] = ACTIONS(4872),
    [sym_raw_string] = ACTIONS(4872),
    [anon_sym_LT_LPAREN] = ACTIONS(4874),
    [anon_sym_DOLLAR] = ACTIONS(4876),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [sym__special_character] = ACTIONS(4880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
    [sym__empty_value] = ACTIONS(4884),
  },
  [1660] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1661] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_done] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1662] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(4888),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(4886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1663] = {
    [sym_redirected_statement] = STATE(2252),
    [sym_if_statement] = STATE(2252),
    [sym_function_definition] = STATE(2252),
    [sym_compound_statement] = STATE(2252),
    [sym_test_command] = STATE(2252),
    [sym_declaration_command] = STATE(2252),
    [sym_subscript] = STATE(1087),
    [sym_file_redirect] = STATE(1089),
    [sym_concatenation] = STATE(1088),
    [sym_string] = STATE(1081),
    [sym_command_substitution] = STATE(1081),
    [sym_process_substitution] = STATE(1081),
    [aux_sym_command_repeat1] = STATE(1089),
    [sym_for_statement] = STATE(2252),
    [sym_c_style_for_statement] = STATE(2252),
    [sym_case_statement] = STATE(2252),
    [sym_subshell] = STATE(2252),
    [sym_pipeline] = STATE(2252),
    [sym_unset_command] = STATE(2252),
    [sym_command] = STATE(2252),
    [sym_simple_expansion] = STATE(1081),
    [sym_while_statement] = STATE(2252),
    [sym_list] = STATE(2252),
    [sym_negated_command] = STATE(2252),
    [sym_command_name] = STATE(1091),
    [sym_variable_assignment] = STATE(2253),
    [sym_string_expansion] = STATE(1081),
    [sym_expansion] = STATE(1081),
    [aux_sym__literal_repeat1] = STATE(1094),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(2135),
    [anon_sym_typeset] = ACTIONS(2135),
    [anon_sym_unsetenv] = ACTIONS(2137),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(2135),
    [sym__special_character] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(2153),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_declare] = ACTIONS(2135),
    [sym_variable_name] = ACTIONS(2159),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(2135),
    [anon_sym_unset] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1664] = {
    [sym_process_substitution] = STATE(2256),
    [aux_sym__literal_repeat1] = STATE(2262),
    [sym_simple_expansion] = STATE(2256),
    [sym_string_expansion] = STATE(2256),
    [sym_expansion] = STATE(2256),
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(2256),
    [sym_command_substitution] = STATE(2256),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [sym_word] = ACTIONS(4894),
    [sym_raw_string] = ACTIONS(4894),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [sym__special_character] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
  },
  [1665] = {
    [sym_heredoc_body] = STATE(2263),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_done] = ACTIONS(1220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [1666] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_done] = ACTIONS(1220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [1667] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4906),
    [anon_sym_GT_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4906),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4908),
  },
  [1668] = {
    [sym_redirected_statement] = STATE(2265),
    [sym_if_statement] = STATE(2265),
    [sym_function_definition] = STATE(2265),
    [sym_compound_statement] = STATE(2265),
    [sym_test_command] = STATE(2265),
    [sym_declaration_command] = STATE(2265),
    [sym_subscript] = STATE(1087),
    [sym_file_redirect] = STATE(1089),
    [sym_concatenation] = STATE(1088),
    [sym_string] = STATE(1081),
    [sym_command_substitution] = STATE(1081),
    [sym_process_substitution] = STATE(1081),
    [aux_sym_command_repeat1] = STATE(1089),
    [sym_for_statement] = STATE(2265),
    [sym_c_style_for_statement] = STATE(2265),
    [sym_case_statement] = STATE(2265),
    [sym_subshell] = STATE(2265),
    [sym_pipeline] = STATE(2265),
    [sym_unset_command] = STATE(2265),
    [sym_command] = STATE(2265),
    [sym_simple_expansion] = STATE(1081),
    [sym_while_statement] = STATE(2265),
    [sym_list] = STATE(2265),
    [sym_negated_command] = STATE(2265),
    [sym_command_name] = STATE(1091),
    [sym_variable_assignment] = STATE(2266),
    [sym_string_expansion] = STATE(1081),
    [sym_expansion] = STATE(1081),
    [aux_sym__literal_repeat1] = STATE(1094),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(2135),
    [anon_sym_typeset] = ACTIONS(2135),
    [anon_sym_unsetenv] = ACTIONS(2137),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(2149),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(2135),
    [sym__special_character] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(2153),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_declare] = ACTIONS(2135),
    [sym_variable_name] = ACTIONS(2159),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(2135),
    [anon_sym_unset] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1669] = {
    [sym_process_substitution] = STATE(2267),
    [aux_sym__literal_repeat1] = STATE(2268),
    [sym_simple_expansion] = STATE(2267),
    [sym_string_expansion] = STATE(2267),
    [sym_expansion] = STATE(2267),
    [sym_concatenation] = STATE(609),
    [sym_string] = STATE(2267),
    [sym_command_substitution] = STATE(2267),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [sym_word] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [sym__special_character] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
  },
  [1670] = {
    [aux_sym_redirected_statement_repeat1] = STATE(2269),
    [sym_file_redirect] = STATE(2269),
    [sym_herestring_redirect] = STATE(2269),
    [sym_heredoc_redirect] = STATE(2269),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(3594),
    [anon_sym_LF] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(351),
    [sym_file_descriptor] = ACTIONS(3598),
    [anon_sym_GT] = ACTIONS(3594),
    [anon_sym_done] = ACTIONS(1071),
    [anon_sym_AMP_GT] = ACTIONS(3594),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(3594),
    [anon_sym_LT] = ACTIONS(3594),
    [anon_sym_LT_AMP] = ACTIONS(3594),
    [anon_sym_GT_GT] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
  },
  [1671] = {
    [sym_process_substitution] = STATE(1673),
    [sym_command_substitution] = STATE(1673),
    [sym_simple_expansion] = STATE(1673),
    [sym_string_expansion] = STATE(1673),
    [sym_expansion] = STATE(1673),
    [aux_sym_command_repeat2] = STATE(2270),
    [sym_concatenation] = STATE(2270),
    [sym_string] = STATE(1673),
    [aux_sym__literal_repeat1] = STATE(1675),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(3610),
    [anon_sym_done] = ACTIONS(1073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3614),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(3616),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(3618),
    [sym__special_character] = ACTIONS(2151),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(3620),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(3616),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3622),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(3610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [1672] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4912),
    [anon_sym_BQUOTE] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LT_LT] = ACTIONS(4912),
    [sym_file_descriptor] = ACTIONS(4914),
    [anon_sym_GT] = ACTIONS(4912),
    [anon_sym_RPAREN] = ACTIONS(4912),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_fi] = ACTIONS(4912),
    [anon_sym_else] = ACTIONS(4912),
    [anon_sym_done] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [ts_builtin_sym_end] = ACTIONS(4914),
    [anon_sym_LT_LT_LT] = ACTIONS(4912),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_GT_AMP] = ACTIONS(4912),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_LT_AMP] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4912),
    [anon_sym_AMP] = ACTIONS(4912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(4912),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_esac] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
  },
  [1673] = {
    [aux_sym_concatenation_repeat1] = STATE(1657),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [anon_sym_done] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [sym__concat] = ACTIONS(3584),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [sym__special_character] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
  },
  [1674] = {
    [sym_process_substitution] = STATE(2271),
    [aux_sym__literal_repeat1] = STATE(2273),
    [sym_simple_expansion] = STATE(2271),
    [sym_string_expansion] = STATE(2271),
    [sym_expansion] = STATE(2271),
    [sym_concatenation] = STATE(2272),
    [sym_string] = STATE(2271),
    [sym_command_substitution] = STATE(2271),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_word] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [sym__special_character] = ACTIONS(3606),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
    [sym_regex] = ACTIONS(4918),
  },
  [1675] = {
    [aux_sym__literal_repeat1] = STATE(1680),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [anon_sym_done] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(3624),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
  },
  [1676] = {
    [sym_process_substitution] = STATE(1673),
    [sym_command_substitution] = STATE(1673),
    [sym_simple_expansion] = STATE(1673),
    [sym_string_expansion] = STATE(1673),
    [sym_expansion] = STATE(1673),
    [aux_sym_command_repeat2] = STATE(2274),
    [sym_concatenation] = STATE(2274),
    [sym_string] = STATE(1673),
    [aux_sym__literal_repeat1] = STATE(1675),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(3610),
    [anon_sym_done] = ACTIONS(1073),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3614),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(3616),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(3618),
    [sym__special_character] = ACTIONS(2151),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(3620),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(3616),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3622),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(3610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [1677] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1670),
    [sym_file_redirect] = STATE(1670),
    [sym_herestring_redirect] = STATE(1670),
    [sym_heredoc_redirect] = STATE(1670),
    [anon_sym_PIPE_AMP] = ACTIONS(3604),
    [anon_sym_AMP_GT_GT] = ACTIONS(3594),
    [anon_sym_LF] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4922),
    [sym_file_descriptor] = ACTIONS(3598),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(3594),
    [anon_sym_done] = ACTIONS(1220),
    [anon_sym_AMP_GT] = ACTIONS(3594),
    [anon_sym_PIPE_PIPE] = ACTIONS(3600),
    [anon_sym_LT_LT_LT] = ACTIONS(3602),
    [anon_sym_GT_AMP] = ACTIONS(3594),
    [anon_sym_PIPE] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(3594),
    [anon_sym_LT_AMP] = ACTIONS(3594),
    [anon_sym_GT_GT] = ACTIONS(3594),
    [anon_sym_AMP] = ACTIONS(4922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3600),
    [anon_sym_SEMI_SEMI] = ACTIONS(4922),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
  },
  [1678] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1670),
    [sym_file_redirect] = STATE(1670),
    [sym_herestring_redirect] = STATE(1670),
    [sym_heredoc_redirect] = STATE(1670),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_done] = ACTIONS(1220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(3600),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(4922),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4922),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(3602),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3600),
    [anon_sym_SEMI_SEMI] = ACTIONS(4922),
    [anon_sym_PIPE_AMP] = ACTIONS(3604),
  },
  [1679] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1680] = {
    [aux_sym__literal_repeat1] = STATE(1680),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_done] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_EQ_TILDE] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(4924),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1681] = {
    [anon_sym_BANG_EQ] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3423),
    [sym_test_operator] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_RBRACK] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_LT_EQ] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_DASH_EQ] = ACTIONS(3423),
  },
  [1682] = {
    [sym_string] = STATE(571),
    [sym_test_operator] = ACTIONS(2662),
    [anon_sym_PLUS_EQ] = ACTIONS(2662),
    [anon_sym_PLUS_PLUS] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(4927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1005),
    [anon_sym_PIPE_PIPE] = ACTIONS(2662),
    [anon_sym_QMARK] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_EQ_TILDE] = ACTIONS(2662),
    [anon_sym_DASH_DASH] = ACTIONS(2662),
    [anon_sym_LT_EQ] = ACTIONS(2662),
    [anon_sym_DASH_EQ] = ACTIONS(2662),
    [anon_sym_BANG_EQ] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(1001),
    [anon_sym_RBRACK] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(1005),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2662),
    [anon_sym_GT_EQ] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1003),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym__] = ACTIONS(1005),
  },
  [1683] = {
    [anon_sym_BANG_EQ] = ACTIONS(2508),
    [anon_sym_PLUS_EQ] = ACTIONS(2508),
    [sym_test_operator] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2508),
    [anon_sym_RBRACK] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2508),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2508),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_AMP_AMP] = ACTIONS(2508),
    [anon_sym_DASH_EQ] = ACTIONS(2508),
  },
  [1684] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2278),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2278),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4929),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_DASH] = ACTIONS(4929),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4929),
    [anon_sym_PERCENT] = ACTIONS(4929),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4933),
    [anon_sym_COLON_DASH] = ACTIONS(4929),
    [sym__special_character] = ACTIONS(599),
  },
  [1685] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1686] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2278),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2278),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4929),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_DASH] = ACTIONS(4929),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4929),
    [anon_sym_PERCENT] = ACTIONS(4929),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4933),
    [anon_sym_COLON_DASH] = ACTIONS(4929),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4935),
  },
  [1687] = {
    [sym_process_substitution] = STATE(2280),
    [aux_sym__literal_repeat1] = STATE(2282),
    [sym_simple_expansion] = STATE(2280),
    [sym_string_expansion] = STATE(2280),
    [sym_expansion] = STATE(2280),
    [sym_concatenation] = STATE(2281),
    [sym_string] = STATE(2280),
    [sym_command_substitution] = STATE(2280),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(4937),
    [sym_raw_string] = ACTIONS(4937),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1688] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2285),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2285),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4939),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4939),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4939),
    [anon_sym_PERCENT] = ACTIONS(4939),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4943),
    [anon_sym_COLON_DASH] = ACTIONS(4939),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4945),
  },
  [1689] = {
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_PLUS_EQ] = ACTIONS(2604),
    [sym_test_operator] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2604),
    [anon_sym_RBRACK] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_PIPE_PIPE] = ACTIONS(2604),
    [anon_sym_GT_EQ] = ACTIONS(2604),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2604),
    [anon_sym_LT_EQ] = ACTIONS(2604),
    [anon_sym_AMP_AMP] = ACTIONS(2604),
    [anon_sym_DASH_EQ] = ACTIONS(2604),
  },
  [1690] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1691] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [sym__concat] = ACTIONS(2610),
  },
  [1692] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4931),
  },
  [1693] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(4947),
  },
  [1694] = {
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_PLUS_EQ] = ACTIONS(2646),
    [sym_test_operator] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2646),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_GT_EQ] = ACTIONS(2646),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2646),
    [anon_sym_DASH_DASH] = ACTIONS(2646),
    [anon_sym_LT_EQ] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_DASH_EQ] = ACTIONS(2646),
  },
  [1695] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2288),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2288),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4949),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4951),
    [anon_sym_DASH] = ACTIONS(4949),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4949),
    [anon_sym_PERCENT] = ACTIONS(4949),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4953),
    [anon_sym_COLON_DASH] = ACTIONS(4949),
    [sym__special_character] = ACTIONS(599),
  },
  [1696] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4951),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1697] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_esac] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_fi] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [ts_builtin_sym_end] = ACTIONS(1442),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_elif] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [1698] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_esac] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_fi] = ACTIONS(2010),
    [anon_sym_else] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [ts_builtin_sym_end] = ACTIONS(2012),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_elif] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [1699] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1700] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1701] = {
    [sym_process_substitution] = STATE(1700),
    [sym_string_expansion] = STATE(1700),
    [sym_expansion] = STATE(1700),
    [sym_simple_expansion] = STATE(1700),
    [sym_string] = STATE(1700),
    [sym_command_substitution] = STATE(1700),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(3669),
    [sym_raw_string] = ACTIONS(3669),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(4957),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(3669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [1702] = {
    [aux_sym_concatenation_repeat1] = STATE(1702),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [ts_builtin_sym_end] = ACTIONS(1544),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1703] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_esac] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_fi] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [ts_builtin_sym_end] = ACTIONS(1436),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_elif] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [1704] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2293),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2293),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4962),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4964),
    [anon_sym_DASH] = ACTIONS(4962),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4962),
    [anon_sym_PERCENT] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4966),
    [anon_sym_COLON_DASH] = ACTIONS(4962),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4968),
  },
  [1705] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_esac] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_RPAREN] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_fi] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [ts_builtin_sym_end] = ACTIONS(1478),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_elif] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [1706] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4964),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1707] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2293),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2293),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4970),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4962),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4964),
    [anon_sym_DASH] = ACTIONS(4962),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4962),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4962),
    [anon_sym_PERCENT] = ACTIONS(4962),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4966),
    [anon_sym_COLON_DASH] = ACTIONS(4962),
    [sym__special_character] = ACTIONS(599),
  },
  [1708] = {
    [anon_sym_EQ] = ACTIONS(4972),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1709] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2298),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2298),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4974),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4976),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4978),
    [anon_sym_DASH] = ACTIONS(4976),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4976),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4976),
    [anon_sym_PERCENT] = ACTIONS(4976),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4980),
    [anon_sym_COLON_DASH] = ACTIONS(4976),
    [sym__special_character] = ACTIONS(599),
  },
  [1710] = {
    [sym_process_substitution] = STATE(2299),
    [aux_sym__literal_repeat1] = STATE(2301),
    [sym_simple_expansion] = STATE(2299),
    [sym_string_expansion] = STATE(2299),
    [sym_expansion] = STATE(2299),
    [sym_concatenation] = STATE(2300),
    [sym_string] = STATE(2299),
    [sym_command_substitution] = STATE(2299),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(4982),
    [sym_raw_string] = ACTIONS(4982),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4964),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1711] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2304),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2304),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4984),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4988),
    [anon_sym_COLON_DASH] = ACTIONS(4984),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(4990),
  },
  [1712] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_esac] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_fi] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [ts_builtin_sym_end] = ACTIONS(1534),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_elif] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [1713] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1714] = {
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(553),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(553),
    [sym__heredoc_body_end] = ACTIONS(553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(553),
    [sym__heredoc_body_middle] = ACTIONS(553),
  },
  [1715] = {
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(561),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(561),
    [sym__heredoc_body_end] = ACTIONS(561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(561),
    [sym__heredoc_body_middle] = ACTIONS(561),
  },
  [1716] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4992),
  },
  [1717] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(4992),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1718] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4992),
  },
  [1719] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2308),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2308),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(4994),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(4996),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(4998),
    [anon_sym_DASH] = ACTIONS(4996),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(4996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(4996),
    [anon_sym_PERCENT] = ACTIONS(4996),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5000),
    [anon_sym_COLON_DASH] = ACTIONS(4996),
    [sym__special_character] = ACTIONS(599),
  },
  [1720] = {
    [sym_subscript] = STATE(2309),
    [anon_sym_STAR] = ACTIONS(5002),
    [anon_sym_QMARK] = ACTIONS(5002),
    [anon_sym_AT] = ACTIONS(5002),
    [sym_variable_name] = ACTIONS(5004),
    [anon_sym_DOLLAR] = ACTIONS(5006),
    [anon_sym_DASH] = ACTIONS(5006),
    [anon_sym_0] = ACTIONS(5008),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5008),
    [anon_sym__] = ACTIONS(5008),
  },
  [1721] = {
    [anon_sym_EQ] = ACTIONS(5010),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1722] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2315),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2315),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5012),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5014),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5016),
    [anon_sym_DASH] = ACTIONS(5014),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5014),
    [anon_sym_PERCENT] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5018),
    [anon_sym_COLON_DASH] = ACTIONS(5014),
    [sym__special_character] = ACTIONS(599),
  },
  [1723] = {
    [anon_sym_BQUOTE] = ACTIONS(5020),
    [ts_builtin_sym_end] = ACTIONS(5022),
    [anon_sym_LF] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(5020),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_esac] = ACTIONS(5020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(5020),
    [anon_sym_elif] = ACTIONS(5020),
    [anon_sym_fi] = ACTIONS(5020),
    [anon_sym_done] = ACTIONS(5020),
    [anon_sym_else] = ACTIONS(5020),
    [anon_sym_SEMI_SEMI] = ACTIONS(5020),
  },
  [1724] = {
    [sym_expansion] = STATE(1724),
    [aux_sym_heredoc_body_repeat1] = STATE(1724),
    [sym_simple_expansion] = STATE(1724),
    [sym_command_substitution] = STATE(1724),
    [anon_sym_DOLLAR] = ACTIONS(5024),
    [anon_sym_BQUOTE] = ACTIONS(5027),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5030),
    [sym__heredoc_body_end] = ACTIONS(5033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5035),
    [sym__heredoc_body_middle] = ACTIONS(5038),
  },
  [1725] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_RPAREN] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [ts_builtin_sym_end] = ACTIONS(5041),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [1726] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(5043),
    [anon_sym_SEMI] = ACTIONS(5045),
    [anon_sym_SEMI_SEMI] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5045),
  },
  [1727] = {
    [aux_sym_concatenation_repeat1] = STATE(1727),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4591),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1728] = {
    [aux_sym_concatenation_repeat1] = STATE(1728),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1729] = {
    [anon_sym_BQUOTE] = ACTIONS(3832),
    [anon_sym_AMP_GT_GT] = ACTIONS(3832),
    [sym_raw_string] = ACTIONS(3832),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [sym_variable_name] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3832),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3832),
    [anon_sym_GT_LPAREN] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3832),
    [anon_sym_DQUOTE] = ACTIONS(3832),
    [sym_word] = ACTIONS(3832),
    [anon_sym_GT_AMP] = ACTIONS(3832),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3832),
    [anon_sym_GT_GT] = ACTIONS(3832),
    [anon_sym_LT_LPAREN] = ACTIONS(3832),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3832),
  },
  [1730] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1731] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2318),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2318),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5049),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [anon_sym_DASH] = ACTIONS(5049),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5049),
    [anon_sym_PERCENT] = ACTIONS(5049),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5051),
    [anon_sym_COLON_DASH] = ACTIONS(5049),
    [sym__special_character] = ACTIONS(599),
  },
  [1732] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [sym__concat] = ACTIONS(2610),
  },
  [1733] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5047),
  },
  [1734] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5053),
  },
  [1735] = {
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [anon_sym_AMP_GT_GT] = ACTIONS(3881),
    [sym_raw_string] = ACTIONS(3881),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [sym_variable_name] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3881),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3881),
    [anon_sym_GT_LPAREN] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [sym_word] = ACTIONS(3881),
    [anon_sym_GT_AMP] = ACTIONS(3881),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3881),
    [anon_sym_GT_GT] = ACTIONS(3881),
    [anon_sym_LT_LPAREN] = ACTIONS(3881),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3881),
  },
  [1736] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2321),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2321),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5055),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5057),
    [anon_sym_DASH] = ACTIONS(5055),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5055),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5055),
    [anon_sym_PERCENT] = ACTIONS(5055),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5059),
    [anon_sym_COLON_DASH] = ACTIONS(5055),
    [sym__special_character] = ACTIONS(599),
  },
  [1737] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5057),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1738] = {
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_AMP_GT_GT] = ACTIONS(3929),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [sym_variable_name] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [sym_word] = ACTIONS(3929),
    [anon_sym_GT_AMP] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3929),
    [anon_sym_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3929),
  },
  [1739] = {
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_AMP_GT_GT] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [sym_variable_name] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [sym_word] = ACTIONS(3948),
    [anon_sym_GT_AMP] = ACTIONS(3948),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3948),
    [anon_sym_GT_GT] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3948),
  },
  [1740] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5061),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1741] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [ts_builtin_sym_end] = ACTIONS(4559),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [1742] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [ts_builtin_sym_end] = ACTIONS(3832),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [1743] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1744] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2324),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2324),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5065),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [anon_sym_DASH] = ACTIONS(5065),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5065),
    [anon_sym_PERCENT] = ACTIONS(5065),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5067),
    [anon_sym_COLON_DASH] = ACTIONS(5065),
    [sym__special_character] = ACTIONS(599),
  },
  [1745] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [sym__concat] = ACTIONS(2610),
  },
  [1746] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5063),
  },
  [1747] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5069),
  },
  [1748] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [ts_builtin_sym_end] = ACTIONS(3881),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [1749] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2327),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2327),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5071),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(5071),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5071),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5071),
    [anon_sym_PERCENT] = ACTIONS(5071),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5075),
    [anon_sym_COLON_DASH] = ACTIONS(5071),
    [sym__special_character] = ACTIONS(599),
  },
  [1750] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5073),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1751] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [1752] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [ts_builtin_sym_end] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [1753] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1754] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [ts_builtin_sym_end] = ACTIONS(3832),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [1755] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5079),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1756] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2330),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2330),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5081),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5079),
    [anon_sym_DASH] = ACTIONS(5081),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5081),
    [anon_sym_PERCENT] = ACTIONS(5081),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5083),
    [anon_sym_COLON_DASH] = ACTIONS(5081),
    [sym__special_character] = ACTIONS(599),
  },
  [1757] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5079),
    [sym__concat] = ACTIONS(2610),
  },
  [1758] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5079),
  },
  [1759] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5085),
  },
  [1760] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [ts_builtin_sym_end] = ACTIONS(3881),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [1761] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2333),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2333),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5087),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5089),
    [anon_sym_DASH] = ACTIONS(5087),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5087),
    [anon_sym_PERCENT] = ACTIONS(5087),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5091),
    [anon_sym_COLON_DASH] = ACTIONS(5087),
    [sym__special_character] = ACTIONS(599),
  },
  [1762] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5089),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1763] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [1764] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [ts_builtin_sym_end] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [1765] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1766] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_EQ_TILDE] = ACTIONS(5095),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_EQ_EQ] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [ts_builtin_sym_end] = ACTIONS(5097),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [1767] = {
    [sym_string] = STATE(713),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(1464),
    [sym_raw_string] = ACTIONS(1460),
    [anon_sym_COLON_QMARK] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(5099),
    [anon_sym_0] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_DASH] = ACTIONS(5099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2662),
    [anon_sym_EQ] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2662),
    [anon_sym_PERCENT] = ACTIONS(2658),
    [anon_sym_COLON] = ACTIONS(2658),
    [anon_sym_GT_LPAREN] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(1464),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1464),
    [anon_sym_LT_LPAREN] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1462),
    [anon_sym_COLON_DASH] = ACTIONS(2658),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym__] = ACTIONS(1464),
  },
  [1768] = {
    [anon_sym_BQUOTE] = ACTIONS(2508),
    [sym_raw_string] = ACTIONS(2508),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2508),
    [anon_sym_DQUOTE] = ACTIONS(2508),
    [sym_word] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_LT_LPAREN] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2508),
    [anon_sym_COLON_DASH] = ACTIONS(2506),
    [sym__special_character] = ACTIONS(2506),
  },
  [1769] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2336),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2336),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5101),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [anon_sym_DASH] = ACTIONS(5101),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5101),
    [anon_sym_PERCENT] = ACTIONS(5101),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5105),
    [anon_sym_COLON_DASH] = ACTIONS(5101),
    [sym__special_character] = ACTIONS(599),
  },
  [1770] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1771] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2336),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2336),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5101),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [anon_sym_DASH] = ACTIONS(5101),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5101),
    [anon_sym_PERCENT] = ACTIONS(5101),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5105),
    [anon_sym_COLON_DASH] = ACTIONS(5101),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5107),
  },
  [1772] = {
    [sym_process_substitution] = STATE(2338),
    [aux_sym__literal_repeat1] = STATE(2340),
    [sym_simple_expansion] = STATE(2338),
    [sym_string_expansion] = STATE(2338),
    [sym_expansion] = STATE(2338),
    [sym_concatenation] = STATE(2339),
    [sym_string] = STATE(2338),
    [sym_command_substitution] = STATE(2338),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5109),
    [sym_raw_string] = ACTIONS(5109),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1773] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2343),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2343),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5111),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_DASH] = ACTIONS(5111),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5111),
    [anon_sym_PERCENT] = ACTIONS(5111),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5115),
    [anon_sym_COLON_DASH] = ACTIONS(5111),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5117),
  },
  [1774] = {
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [anon_sym_COLON_QMARK] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [anon_sym_EQ] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(2602),
    [anon_sym_COLON] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_word] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2604),
    [anon_sym_COLON_DASH] = ACTIONS(2602),
    [sym__special_character] = ACTIONS(2602),
  },
  [1775] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1776] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [sym__concat] = ACTIONS(2610),
  },
  [1777] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5103),
  },
  [1778] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5119),
  },
  [1779] = {
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [sym_raw_string] = ACTIONS(2646),
    [anon_sym_COLON_QMARK] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2646),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_COLON] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [sym_word] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_LT_LPAREN] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2646),
    [anon_sym_COLON_DASH] = ACTIONS(2644),
    [sym__special_character] = ACTIONS(2644),
  },
  [1780] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2346),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2346),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5121),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(5121),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5121),
    [anon_sym_PERCENT] = ACTIONS(5121),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5125),
    [anon_sym_COLON_DASH] = ACTIONS(5121),
    [sym__special_character] = ACTIONS(599),
  },
  [1781] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5123),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1782] = {
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_COLON_QMARK] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_word] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3423),
    [anon_sym_COLON_DASH] = ACTIONS(3421),
    [sym__special_character] = ACTIONS(3421),
  },
  [1783] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1784] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [ts_builtin_sym_end] = ACTIONS(5131),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [1785] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5133),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_EQ_EQ] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [ts_builtin_sym_end] = ACTIONS(5135),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [1786] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5137),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1787] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [sym__concat] = ACTIONS(1442),
  },
  [1788] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2012),
    [sym__concat] = ACTIONS(2012),
  },
  [1789] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(5139),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1790] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [sym__concat] = ACTIONS(1544),
  },
  [1791] = {
    [sym_process_substitution] = STATE(1790),
    [sym_string_expansion] = STATE(1790),
    [sym_expansion] = STATE(1790),
    [sym_simple_expansion] = STATE(1790),
    [sym_string] = STATE(1790),
    [sym_command_substitution] = STATE(1790),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(3895),
    [sym_raw_string] = ACTIONS(3895),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(5141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(3895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1792] = {
    [aux_sym_concatenation_repeat1] = STATE(1792),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1544),
    [sym__concat] = ACTIONS(5143),
  },
  [1793] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [sym__concat] = ACTIONS(1436),
  },
  [1794] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2353),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2353),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5146),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5150),
    [anon_sym_COLON_DASH] = ACTIONS(5146),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5152),
  },
  [1795] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1478),
    [sym__concat] = ACTIONS(1478),
  },
  [1796] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1797] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2353),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2353),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5154),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5146),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_DASH] = ACTIONS(5146),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5146),
    [anon_sym_PERCENT] = ACTIONS(5146),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5150),
    [anon_sym_COLON_DASH] = ACTIONS(5146),
    [sym__special_character] = ACTIONS(599),
  },
  [1798] = {
    [anon_sym_EQ] = ACTIONS(5156),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1799] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2358),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2358),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5158),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5160),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5162),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5160),
    [anon_sym_PERCENT] = ACTIONS(5160),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5164),
    [anon_sym_COLON_DASH] = ACTIONS(5160),
    [sym__special_character] = ACTIONS(599),
  },
  [1800] = {
    [sym_process_substitution] = STATE(2359),
    [aux_sym__literal_repeat1] = STATE(2361),
    [sym_simple_expansion] = STATE(2359),
    [sym_string_expansion] = STATE(2359),
    [sym_expansion] = STATE(2359),
    [sym_concatenation] = STATE(2360),
    [sym_string] = STATE(2359),
    [sym_command_substitution] = STATE(2359),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5166),
    [sym_raw_string] = ACTIONS(5166),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1801] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2364),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2364),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5168),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(5168),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5168),
    [anon_sym_PERCENT] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5172),
    [anon_sym_COLON_DASH] = ACTIONS(5168),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5174),
  },
  [1802] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1534),
    [sym__concat] = ACTIONS(1534),
  },
  [1803] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1804] = {
    [anon_sym_BQUOTE] = ACTIONS(4624),
    [anon_sym_SLASH] = ACTIONS(4624),
    [sym_raw_string] = ACTIONS(4624),
    [anon_sym_COLON_QMARK] = ACTIONS(5176),
    [anon_sym_DOLLAR] = ACTIONS(5176),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_DASH] = ACTIONS(5176),
    [anon_sym_EQ] = ACTIONS(5176),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(5176),
    [anon_sym_COLON] = ACTIONS(5176),
    [anon_sym_GT_LPAREN] = ACTIONS(4624),
    [anon_sym_DQUOTE] = ACTIONS(4624),
    [sym_word] = ACTIONS(5176),
    [anon_sym_LT_LPAREN] = ACTIONS(4624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4624),
    [anon_sym_COLON_DASH] = ACTIONS(5176),
    [sym__special_character] = ACTIONS(5176),
  },
  [1805] = {
    [anon_sym_BQUOTE] = ACTIONS(4624),
    [anon_sym_SLASH] = ACTIONS(4624),
    [sym_raw_string] = ACTIONS(4624),
    [anon_sym_COLON_QMARK] = ACTIONS(5176),
    [anon_sym_DOLLAR] = ACTIONS(5176),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_DASH] = ACTIONS(5176),
    [anon_sym_EQ] = ACTIONS(5176),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(5176),
    [anon_sym_COLON] = ACTIONS(5176),
    [anon_sym_GT_LPAREN] = ACTIONS(4624),
    [anon_sym_DQUOTE] = ACTIONS(4624),
    [sym_word] = ACTIONS(5176),
    [sym__concat] = ACTIONS(5178),
    [anon_sym_LT_LPAREN] = ACTIONS(4624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4624),
    [anon_sym_COLON_DASH] = ACTIONS(5176),
    [sym__special_character] = ACTIONS(5176),
  },
  [1806] = {
    [anon_sym_BQUOTE] = ACTIONS(4630),
    [anon_sym_SLASH] = ACTIONS(4630),
    [sym_raw_string] = ACTIONS(4630),
    [anon_sym_COLON_QMARK] = ACTIONS(5180),
    [anon_sym_DOLLAR] = ACTIONS(5180),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [anon_sym_DASH] = ACTIONS(5180),
    [anon_sym_EQ] = ACTIONS(5180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4630),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4630),
    [anon_sym_PERCENT] = ACTIONS(5180),
    [anon_sym_COLON] = ACTIONS(5180),
    [anon_sym_GT_LPAREN] = ACTIONS(4630),
    [anon_sym_DQUOTE] = ACTIONS(4630),
    [sym_word] = ACTIONS(5180),
    [anon_sym_LT_LPAREN] = ACTIONS(4630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4630),
    [anon_sym_COLON_DASH] = ACTIONS(5180),
    [sym__special_character] = ACTIONS(5180),
  },
  [1807] = {
    [anon_sym_BQUOTE] = ACTIONS(4630),
    [anon_sym_SLASH] = ACTIONS(4630),
    [sym_raw_string] = ACTIONS(4630),
    [anon_sym_COLON_QMARK] = ACTIONS(5180),
    [anon_sym_DOLLAR] = ACTIONS(5180),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [anon_sym_DASH] = ACTIONS(5180),
    [anon_sym_EQ] = ACTIONS(5180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4630),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4630),
    [anon_sym_PERCENT] = ACTIONS(5180),
    [anon_sym_COLON] = ACTIONS(5180),
    [anon_sym_GT_LPAREN] = ACTIONS(4630),
    [anon_sym_DQUOTE] = ACTIONS(4630),
    [sym_word] = ACTIONS(5180),
    [sym__concat] = ACTIONS(5182),
    [anon_sym_LT_LPAREN] = ACTIONS(4630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4630),
    [anon_sym_COLON_DASH] = ACTIONS(5180),
    [sym__special_character] = ACTIONS(5180),
  },
  [1808] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_EQ_TILDE] = ACTIONS(5184),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_RPAREN] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_EQ_EQ] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [ts_builtin_sym_end] = ACTIONS(5186),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [1809] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [1810] = {
    [sym_string] = STATE(762),
    [anon_sym__] = ACTIONS(1569),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(5188),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(5188),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(1569),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(5190),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_0] = ACTIONS(1569),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(651),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(1569),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5188),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [1811] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_RBRACE] = ACTIONS(3305),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [1812] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(5192),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [1813] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [1814] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2369),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2369),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5194),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(5194),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5198),
    [anon_sym_COLON_DASH] = ACTIONS(5194),
    [sym__special_character] = ACTIONS(599),
  },
  [1815] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1816] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2369),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2369),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5194),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_DASH] = ACTIONS(5194),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5198),
    [anon_sym_COLON_DASH] = ACTIONS(5194),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5200),
  },
  [1817] = {
    [sym_process_substitution] = STATE(2371),
    [aux_sym__literal_repeat1] = STATE(2373),
    [sym_simple_expansion] = STATE(2371),
    [sym_string_expansion] = STATE(2371),
    [sym_expansion] = STATE(2371),
    [sym_concatenation] = STATE(2372),
    [sym_string] = STATE(2371),
    [sym_command_substitution] = STATE(2371),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5202),
    [sym_raw_string] = ACTIONS(5202),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1818] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2376),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2376),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5204),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5206),
    [anon_sym_DASH] = ACTIONS(5204),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5204),
    [anon_sym_PERCENT] = ACTIONS(5204),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5208),
    [anon_sym_COLON_DASH] = ACTIONS(5204),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5210),
  },
  [1819] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [1820] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5206),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1821] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [sym__concat] = ACTIONS(2610),
  },
  [1822] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5196),
  },
  [1823] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5212),
  },
  [1824] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [1825] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2379),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2379),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5214),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_DASH] = ACTIONS(5214),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5214),
    [anon_sym_PERCENT] = ACTIONS(5214),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5218),
    [anon_sym_COLON_DASH] = ACTIONS(5214),
    [sym__special_character] = ACTIONS(599),
  },
  [1826] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1827] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [1828] = {
    [sym_string] = STATE(781),
    [anon_sym__] = ACTIONS(1599),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(5220),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(5220),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(1599),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(5222),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_0] = ACTIONS(1599),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(1599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5220),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [1829] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [1830] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2381),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2381),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5224),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_DASH] = ACTIONS(5224),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5224),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5224),
    [anon_sym_PERCENT] = ACTIONS(5224),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5228),
    [anon_sym_COLON_DASH] = ACTIONS(5224),
    [sym__special_character] = ACTIONS(599),
  },
  [1831] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1832] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2381),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2381),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5224),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_DASH] = ACTIONS(5224),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5224),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5224),
    [anon_sym_PERCENT] = ACTIONS(5224),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5228),
    [anon_sym_COLON_DASH] = ACTIONS(5224),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5230),
  },
  [1833] = {
    [sym_process_substitution] = STATE(2383),
    [aux_sym__literal_repeat1] = STATE(2385),
    [sym_simple_expansion] = STATE(2383),
    [sym_string_expansion] = STATE(2383),
    [sym_expansion] = STATE(2383),
    [sym_concatenation] = STATE(2384),
    [sym_string] = STATE(2383),
    [sym_command_substitution] = STATE(2383),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5232),
    [sym_raw_string] = ACTIONS(5232),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1834] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2388),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2388),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5234),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5234),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5234),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5234),
    [anon_sym_PERCENT] = ACTIONS(5234),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5238),
    [anon_sym_COLON_DASH] = ACTIONS(5234),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5240),
  },
  [1835] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [1836] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1837] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5226),
    [sym__concat] = ACTIONS(2610),
  },
  [1838] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5226),
  },
  [1839] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5242),
  },
  [1840] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [1841] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2391),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2391),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5244),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_DASH] = ACTIONS(5244),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5244),
    [anon_sym_PERCENT] = ACTIONS(5244),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5248),
    [anon_sym_COLON_DASH] = ACTIONS(5244),
    [sym__special_character] = ACTIONS(599),
  },
  [1842] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1843] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_EQ_TILDE] = ACTIONS(3830),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [1844] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1845] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2393),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2393),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5252),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_DASH] = ACTIONS(5252),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5252),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5252),
    [anon_sym_PERCENT] = ACTIONS(5252),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5254),
    [anon_sym_COLON_DASH] = ACTIONS(5252),
    [sym__special_character] = ACTIONS(599),
  },
  [1846] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [sym__concat] = ACTIONS(2610),
  },
  [1847] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5250),
  },
  [1848] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5256),
  },
  [1849] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_EQ_TILDE] = ACTIONS(3879),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [1850] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2396),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2396),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5258),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5258),
    [anon_sym_PERCENT] = ACTIONS(5258),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5262),
    [anon_sym_COLON_DASH] = ACTIONS(5258),
    [sym__special_character] = ACTIONS(599),
  },
  [1851] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5260),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1852] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3927),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [1853] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_EQ_TILDE] = ACTIONS(3946),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [1854] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1855] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3952),
    [anon_sym_AMP_GT_GT] = ACTIONS(3952),
    [anon_sym_LF] = ACTIONS(3954),
    [anon_sym_SEMI] = ACTIONS(3952),
    [anon_sym_LT_LT] = ACTIONS(3952),
    [anon_sym_RBRACE] = ACTIONS(3952),
    [anon_sym_GT] = ACTIONS(3952),
    [sym_file_descriptor] = ACTIONS(3954),
    [anon_sym_AMP_GT] = ACTIONS(3952),
    [anon_sym_PIPE_PIPE] = ACTIONS(3952),
    [anon_sym_LT_LT_LT] = ACTIONS(3952),
    [anon_sym_PIPE] = ACTIONS(3952),
    [anon_sym_GT_AMP] = ACTIONS(3952),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_LT_AMP] = ACTIONS(3952),
    [anon_sym_GT_GT] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3952),
    [anon_sym_SEMI_SEMI] = ACTIONS(3952),
    [anon_sym_PIPE_AMP] = ACTIONS(3952),
  },
  [1856] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4406),
    [anon_sym_AMP_GT_GT] = ACTIONS(4406),
    [anon_sym_LF] = ACTIONS(4408),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_GT] = ACTIONS(4406),
    [sym_file_descriptor] = ACTIONS(4408),
    [anon_sym_AMP_GT] = ACTIONS(4406),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_LT_LT_LT] = ACTIONS(4406),
    [anon_sym_PIPE] = ACTIONS(4406),
    [anon_sym_GT_AMP] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(4406),
    [anon_sym_LT_AMP] = ACTIONS(4406),
    [anon_sym_GT_GT] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_SEMI_SEMI] = ACTIONS(4406),
    [anon_sym_PIPE_AMP] = ACTIONS(4406),
  },
  [1857] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(5266),
  },
  [1858] = {
    [sym_elif_clause] = STATE(1460),
    [sym_else_clause] = STATE(2399),
    [aux_sym_if_statement_repeat1] = STATE(1460),
    [anon_sym_elif] = ACTIONS(3141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(5266),
    [anon_sym_else] = ACTIONS(3143),
  },
  [1859] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2401),
    [sym_case_item] = STATE(2402),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2402),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3176),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_esac] = ACTIONS(5268),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1860] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4434),
    [anon_sym_AMP_GT_GT] = ACTIONS(4434),
    [anon_sym_LF] = ACTIONS(4436),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_LT_LT] = ACTIONS(4434),
    [anon_sym_RBRACE] = ACTIONS(4434),
    [anon_sym_GT] = ACTIONS(4434),
    [sym_file_descriptor] = ACTIONS(4436),
    [anon_sym_AMP_GT] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE] = ACTIONS(4434),
    [anon_sym_LT_LT_LT] = ACTIONS(4434),
    [anon_sym_PIPE] = ACTIONS(4434),
    [anon_sym_GT_AMP] = ACTIONS(4434),
    [anon_sym_LT] = ACTIONS(4434),
    [anon_sym_LT_AMP] = ACTIONS(4434),
    [anon_sym_GT_GT] = ACTIONS(4434),
    [anon_sym_AMP] = ACTIONS(4434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4434),
    [anon_sym_SEMI_SEMI] = ACTIONS(4434),
    [anon_sym_PIPE_AMP] = ACTIONS(4434),
  },
  [1861] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(5270),
  },
  [1862] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2401),
    [sym_case_item] = STATE(2067),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2067),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3178),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1863] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2404),
    [sym_case_item] = STATE(2405),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2405),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3176),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_esac] = ACTIONS(5272),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1864] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4476),
    [anon_sym_AMP_GT_GT] = ACTIONS(4476),
    [anon_sym_LF] = ACTIONS(4478),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_LT_LT] = ACTIONS(4476),
    [anon_sym_RBRACE] = ACTIONS(4476),
    [anon_sym_GT] = ACTIONS(4476),
    [sym_file_descriptor] = ACTIONS(4478),
    [anon_sym_AMP_GT] = ACTIONS(4476),
    [anon_sym_PIPE_PIPE] = ACTIONS(4476),
    [anon_sym_LT_LT_LT] = ACTIONS(4476),
    [anon_sym_PIPE] = ACTIONS(4476),
    [anon_sym_GT_AMP] = ACTIONS(4476),
    [anon_sym_LT] = ACTIONS(4476),
    [anon_sym_LT_AMP] = ACTIONS(4476),
    [anon_sym_GT_GT] = ACTIONS(4476),
    [anon_sym_AMP] = ACTIONS(4476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4476),
    [anon_sym_SEMI_SEMI] = ACTIONS(4476),
    [anon_sym_PIPE_AMP] = ACTIONS(4476),
  },
  [1865] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(5274),
  },
  [1866] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2404),
    [sym_case_item] = STATE(2067),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2067),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3178),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [1867] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [1868] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [1869] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [1870] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(5276),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1871] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1872] = {
    [sym_process_substitution] = STATE(1871),
    [sym_string_expansion] = STATE(1871),
    [sym_expansion] = STATE(1871),
    [sym_simple_expansion] = STATE(1871),
    [sym_string] = STATE(1871),
    [sym_command_substitution] = STATE(1871),
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [sym_word] = ACTIONS(4084),
    [sym_raw_string] = ACTIONS(4084),
    [anon_sym_LT_LPAREN] = ACTIONS(1679),
    [anon_sym_DOLLAR] = ACTIONS(5278),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1679),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(4084),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1687),
  },
  [1873] = {
    [aux_sym_concatenation_repeat1] = STATE(1873),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(5280),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1874] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [1875] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2410),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2410),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5283),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5285),
    [anon_sym_DASH] = ACTIONS(5283),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5283),
    [anon_sym_PERCENT] = ACTIONS(5283),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5287),
    [anon_sym_COLON_DASH] = ACTIONS(5283),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5289),
  },
  [1876] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [1877] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5285),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1878] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2410),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2410),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5291),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5283),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5285),
    [anon_sym_DASH] = ACTIONS(5283),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5283),
    [anon_sym_PERCENT] = ACTIONS(5283),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5287),
    [anon_sym_COLON_DASH] = ACTIONS(5283),
    [sym__special_character] = ACTIONS(599),
  },
  [1879] = {
    [anon_sym_EQ] = ACTIONS(5293),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1880] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2415),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2415),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5295),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5297),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_DASH] = ACTIONS(5297),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5297),
    [anon_sym_PERCENT] = ACTIONS(5297),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5301),
    [anon_sym_COLON_DASH] = ACTIONS(5297),
    [sym__special_character] = ACTIONS(599),
  },
  [1881] = {
    [sym_process_substitution] = STATE(2416),
    [aux_sym__literal_repeat1] = STATE(2418),
    [sym_simple_expansion] = STATE(2416),
    [sym_string_expansion] = STATE(2416),
    [sym_expansion] = STATE(2416),
    [sym_concatenation] = STATE(2417),
    [sym_string] = STATE(2416),
    [sym_command_substitution] = STATE(2416),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5303),
    [sym_raw_string] = ACTIONS(5303),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5285),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1882] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2421),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2421),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5305),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5307),
    [anon_sym_DASH] = ACTIONS(5305),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5305),
    [anon_sym_PERCENT] = ACTIONS(5305),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5309),
    [anon_sym_COLON_DASH] = ACTIONS(5305),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5311),
  },
  [1883] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [1884] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5307),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1885] = {
    [sym_do_group] = STATE(2422),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(1703),
  },
  [1886] = {
    [sym_do_group] = STATE(2424),
    [sym_compound_statement] = STATE(2424),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(5313),
    [anon_sym_do] = ACTIONS(1703),
  },
  [1887] = {
    [anon_sym_BANG_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [sym_test_operator] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5315),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_GT_EQ] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_DASH_EQ] = ACTIONS(869),
  },
  [1888] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(2426),
    [sym_parenthesized_expression] = STATE(2426),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(2426),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(2426),
    [sym_unary_expression] = STATE(2426),
    [sym_concatenation] = STATE(2426),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5315),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(273),
  },
  [1889] = {
    [anon_sym_BANG_EQ] = ACTIONS(2125),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [sym_test_operator] = ACTIONS(2127),
    [anon_sym_LF] = ACTIONS(5317),
    [anon_sym_SEMI] = ACTIONS(5317),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH] = ACTIONS(2125),
    [anon_sym_GT] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2133),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2125),
    [anon_sym_AMP] = ACTIONS(5317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_SEMI_SEMI] = ACTIONS(5317),
    [anon_sym_DASH_EQ] = ACTIONS(2125),
  },
  [1890] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4912),
    [anon_sym_AMP_GT_GT] = ACTIONS(4912),
    [anon_sym_LF] = ACTIONS(4914),
    [anon_sym_SEMI] = ACTIONS(4912),
    [anon_sym_LT_LT] = ACTIONS(4912),
    [anon_sym_RBRACE] = ACTIONS(4912),
    [anon_sym_GT] = ACTIONS(4912),
    [sym_file_descriptor] = ACTIONS(4914),
    [anon_sym_AMP_GT] = ACTIONS(4912),
    [anon_sym_PIPE_PIPE] = ACTIONS(4912),
    [anon_sym_LT_LT_LT] = ACTIONS(4912),
    [anon_sym_PIPE] = ACTIONS(4912),
    [anon_sym_GT_AMP] = ACTIONS(4912),
    [anon_sym_LT] = ACTIONS(4912),
    [anon_sym_LT_AMP] = ACTIONS(4912),
    [anon_sym_GT_GT] = ACTIONS(4912),
    [anon_sym_AMP] = ACTIONS(4912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4912),
    [anon_sym_SEMI_SEMI] = ACTIONS(4912),
    [anon_sym_PIPE_AMP] = ACTIONS(4912),
  },
  [1891] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [1892] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_GT] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [1893] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(5319),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1894] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1895] = {
    [sym_process_substitution] = STATE(1894),
    [sym_string_expansion] = STATE(1894),
    [sym_expansion] = STATE(1894),
    [sym_simple_expansion] = STATE(1894),
    [sym_string] = STATE(1894),
    [sym_command_substitution] = STATE(1894),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1707),
    [sym_word] = ACTIONS(4135),
    [sym_raw_string] = ACTIONS(4135),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(5321),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1715),
    [sym__special_character] = ACTIONS(4135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1719),
  },
  [1896] = {
    [aux_sym_concatenation_repeat1] = STATE(1896),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(5323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1897] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [1898] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2432),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2432),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5326),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5328),
    [anon_sym_DASH] = ACTIONS(5326),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5326),
    [anon_sym_PERCENT] = ACTIONS(5326),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5330),
    [anon_sym_COLON_DASH] = ACTIONS(5326),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5332),
  },
  [1899] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_GT] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [1900] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5328),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1901] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2432),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2432),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5334),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5326),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5328),
    [anon_sym_DASH] = ACTIONS(5326),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5326),
    [anon_sym_PERCENT] = ACTIONS(5326),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5330),
    [anon_sym_COLON_DASH] = ACTIONS(5326),
    [sym__special_character] = ACTIONS(599),
  },
  [1902] = {
    [anon_sym_EQ] = ACTIONS(5336),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1903] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2437),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2437),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5338),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5340),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5340),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5340),
    [anon_sym_PERCENT] = ACTIONS(5340),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5344),
    [anon_sym_COLON_DASH] = ACTIONS(5340),
    [sym__special_character] = ACTIONS(599),
  },
  [1904] = {
    [sym_process_substitution] = STATE(2438),
    [aux_sym__literal_repeat1] = STATE(2440),
    [sym_simple_expansion] = STATE(2438),
    [sym_string_expansion] = STATE(2438),
    [sym_expansion] = STATE(2438),
    [sym_concatenation] = STATE(2439),
    [sym_string] = STATE(2438),
    [sym_command_substitution] = STATE(2438),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5346),
    [sym_raw_string] = ACTIONS(5346),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5328),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [1905] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2443),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2443),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5348),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_DASH] = ACTIONS(5348),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5348),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5352),
    [anon_sym_COLON_DASH] = ACTIONS(5348),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5354),
  },
  [1906] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [1907] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [1908] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACE] = ACTIONS(5020),
    [anon_sym_LF] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(5020),
    [anon_sym_SEMI_SEMI] = ACTIONS(5020),
    [anon_sym_AMP] = ACTIONS(5020),
  },
  [1909] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_RBRACE] = ACTIONS(5041),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [1910] = {
    [aux_sym_concatenation_repeat1] = STATE(1910),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4591),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1911] = {
    [aux_sym_concatenation_repeat1] = STATE(1911),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [1912] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5356),
  },
  [1913] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1914] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_fi] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_elif] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1915] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(5360),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1916] = {
    [sym_process_substitution] = STATE(2447),
    [sym_string_expansion] = STATE(2447),
    [sym_expansion] = STATE(2447),
    [sym_simple_expansion] = STATE(2447),
    [sym_string] = STATE(2447),
    [sym_command_substitution] = STATE(2447),
    [anon_sym_BQUOTE] = ACTIONS(5362),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [sym_word] = ACTIONS(5364),
    [sym_raw_string] = ACTIONS(5364),
    [anon_sym_LT_LPAREN] = ACTIONS(5366),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5366),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5368),
    [sym__special_character] = ACTIONS(5364),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5370),
  },
  [1917] = {
    [aux_sym_concatenation_repeat1] = STATE(2449),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_else] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(5372),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [anon_sym_elif] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1918] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5374),
  },
  [1919] = {
    [sym_process_substitution] = STATE(2452),
    [aux_sym__literal_repeat1] = STATE(2454),
    [sym_array] = STATE(2453),
    [sym_simple_expansion] = STATE(2452),
    [sym_string_expansion] = STATE(2452),
    [sym_expansion] = STATE(2452),
    [sym_concatenation] = STATE(2453),
    [sym_string] = STATE(2452),
    [sym_command_substitution] = STATE(2452),
    [anon_sym_LPAREN] = ACTIONS(5376),
    [anon_sym_BQUOTE] = ACTIONS(5362),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [sym_word] = ACTIONS(5378),
    [sym_raw_string] = ACTIONS(5378),
    [anon_sym_LT_LPAREN] = ACTIONS(5366),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5366),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5368),
    [sym__special_character] = ACTIONS(5380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5370),
    [sym__empty_value] = ACTIONS(5382),
  },
  [1920] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_fi] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_else] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [anon_sym_elif] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [1921] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_fi] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_else] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_elif] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [1922] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_fi] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [anon_sym_elif] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [1923] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(5356),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1924] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5356),
  },
  [1925] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2457),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2457),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5384),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5386),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5388),
    [anon_sym_DASH] = ACTIONS(5386),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5386),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5386),
    [anon_sym_PERCENT] = ACTIONS(5386),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5390),
    [anon_sym_COLON_DASH] = ACTIONS(5386),
    [sym__special_character] = ACTIONS(599),
  },
  [1926] = {
    [sym_subscript] = STATE(2458),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_QMARK] = ACTIONS(5392),
    [anon_sym_AT] = ACTIONS(5392),
    [sym_variable_name] = ACTIONS(5394),
    [anon_sym_DOLLAR] = ACTIONS(5396),
    [anon_sym_DASH] = ACTIONS(5396),
    [anon_sym_0] = ACTIONS(5398),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5398),
    [anon_sym__] = ACTIONS(5398),
  },
  [1927] = {
    [anon_sym_EQ] = ACTIONS(5400),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1928] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2464),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2464),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5402),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5404),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_DASH] = ACTIONS(5404),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5404),
    [anon_sym_PERCENT] = ACTIONS(5404),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5408),
    [anon_sym_COLON_DASH] = ACTIONS(5404),
    [sym__special_character] = ACTIONS(599),
  },
  [1929] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_elif] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1930] = {
    [aux_sym__literal_repeat1] = STATE(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(5410),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [anon_sym_elif] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1931] = {
    [sym_process_substitution] = STATE(1389),
    [sym_string] = STATE(1389),
    [sym_command_substitution] = STATE(1389),
    [sym_simple_expansion] = STATE(1389),
    [sym_variable_assignment] = STATE(1931),
    [sym_subscript] = STATE(1398),
    [sym_string_expansion] = STATE(1389),
    [sym_expansion] = STATE(1389),
    [sym_concatenation] = STATE(1931),
    [aux_sym_declaration_command_repeat1] = STATE(1931),
    [aux_sym__literal_repeat1] = STATE(1396),
    [anon_sym_AMP_GT_GT] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(5413),
    [anon_sym_LT_LT] = ACTIONS(1320),
    [anon_sym_fi] = ACTIONS(1320),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5416),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5419),
    [anon_sym_GT_LPAREN] = ACTIONS(5422),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5425),
    [anon_sym_PIPE_PIPE] = ACTIONS(1320),
    [sym_word] = ACTIONS(5428),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_AMP] = ACTIONS(1320),
    [anon_sym_LT] = ACTIONS(1320),
    [anon_sym_LT_AMP] = ACTIONS(1320),
    [anon_sym_GT_GT] = ACTIONS(1320),
    [sym__special_character] = ACTIONS(5431),
    [anon_sym_LT_LT_DASH] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(5434),
    [anon_sym_LF] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_raw_string] = ACTIONS(5428),
    [sym_variable_name] = ACTIONS(5437),
    [sym_file_descriptor] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1320),
    [anon_sym_AMP_GT] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(5440),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_AMP] = ACTIONS(1320),
    [anon_sym_LT_LPAREN] = ACTIONS(5422),
    [anon_sym_elif] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1320),
    [anon_sym_SEMI_SEMI] = ACTIONS(1320),
    [anon_sym_PIPE_AMP] = ACTIONS(1320),
  },
  [1932] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5443),
  },
  [1933] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1934] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_fi] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_elif] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1935] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(5447),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1936] = {
    [sym_process_substitution] = STATE(2468),
    [sym_string_expansion] = STATE(2468),
    [sym_expansion] = STATE(2468),
    [sym_simple_expansion] = STATE(2468),
    [sym_string] = STATE(2468),
    [sym_command_substitution] = STATE(2468),
    [anon_sym_BQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(4214),
    [sym_word] = ACTIONS(5451),
    [sym_raw_string] = ACTIONS(5451),
    [anon_sym_LT_LPAREN] = ACTIONS(5453),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5455),
    [sym__special_character] = ACTIONS(5451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5457),
  },
  [1937] = {
    [aux_sym_concatenation_repeat1] = STATE(2470),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_else] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(5459),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [anon_sym_elif] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1938] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5461),
  },
  [1939] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_fi] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_else] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [anon_sym_elif] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [1940] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_fi] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_else] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_elif] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [1941] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_fi] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [anon_sym_elif] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [1942] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(5443),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1943] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5443),
  },
  [1944] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2474),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2474),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5463),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5465),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5467),
    [anon_sym_DASH] = ACTIONS(5465),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5465),
    [anon_sym_PERCENT] = ACTIONS(5465),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5469),
    [anon_sym_COLON_DASH] = ACTIONS(5465),
    [sym__special_character] = ACTIONS(599),
  },
  [1945] = {
    [sym_subscript] = STATE(2475),
    [anon_sym_STAR] = ACTIONS(5471),
    [anon_sym_QMARK] = ACTIONS(5471),
    [anon_sym_AT] = ACTIONS(5471),
    [sym_variable_name] = ACTIONS(5473),
    [anon_sym_DOLLAR] = ACTIONS(5475),
    [anon_sym_DASH] = ACTIONS(5475),
    [anon_sym_0] = ACTIONS(5477),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5477),
    [anon_sym__] = ACTIONS(5477),
  },
  [1946] = {
    [anon_sym_EQ] = ACTIONS(5479),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1947] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2481),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2481),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5481),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5483),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5485),
    [anon_sym_DASH] = ACTIONS(5483),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5483),
    [anon_sym_PERCENT] = ACTIONS(5483),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5487),
    [anon_sym_COLON_DASH] = ACTIONS(5483),
    [sym__special_character] = ACTIONS(599),
  },
  [1948] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_elif] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1949] = {
    [aux_sym__literal_repeat1] = STATE(1949),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(5489),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [anon_sym_elif] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [1950] = {
    [sym_process_substitution] = STATE(1401),
    [sym_command_substitution] = STATE(1401),
    [aux_sym_unset_command_repeat1] = STATE(1950),
    [sym_simple_expansion] = STATE(1401),
    [sym_string_expansion] = STATE(1401),
    [sym_expansion] = STATE(1401),
    [sym_concatenation] = STATE(1950),
    [sym_string] = STATE(1401),
    [aux_sym__literal_repeat1] = STATE(1407),
    [anon_sym_AMP_GT_GT] = ACTIONS(1403),
    [anon_sym_DOLLAR] = ACTIONS(5492),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_fi] = ACTIONS(1403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5495),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5498),
    [anon_sym_GT_LPAREN] = ACTIONS(5501),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5504),
    [anon_sym_PIPE_PIPE] = ACTIONS(1403),
    [sym_word] = ACTIONS(5507),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_LT_AMP] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [sym__special_character] = ACTIONS(5510),
    [anon_sym_LT_LT_DASH] = ACTIONS(1403),
    [anon_sym_BQUOTE] = ACTIONS(5513),
    [anon_sym_LF] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(5507),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_AMP_GT] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(5516),
    [anon_sym_LT_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_AMP] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(5501),
    [anon_sym_elif] = ACTIONS(1403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1403),
    [anon_sym_PIPE_AMP] = ACTIONS(1403),
  },
  [1951] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_fi] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_EQ_TILDE] = ACTIONS(1434),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_elif] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [1952] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_fi] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_EQ_TILDE] = ACTIONS(1440),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [anon_sym_elif] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [1953] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(2482),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1954] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(2485),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(5519),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(5521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1955] = {
    [aux_sym_concatenation_repeat1] = STATE(2487),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_fi] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(5523),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1956] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2488),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1957] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(5525),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(5525),
  },
  [1958] = {
    [sym_string] = STATE(2491),
    [anon_sym_DQUOTE] = ACTIONS(5527),
    [anon_sym_STAR] = ACTIONS(5529),
    [anon_sym_QMARK] = ACTIONS(5529),
    [sym_raw_string] = ACTIONS(5531),
    [anon_sym_AT] = ACTIONS(5529),
    [anon_sym_DOLLAR] = ACTIONS(5533),
    [anon_sym_POUND] = ACTIONS(5533),
    [anon_sym_DASH] = ACTIONS(5533),
    [anon_sym_0] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5535),
    [anon_sym__] = ACTIONS(5535),
  },
  [1959] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(2493),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2494),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1960] = {
    [aux_sym_concatenation_repeat1] = STATE(2487),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(5523),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1961] = {
    [sym_subscript] = STATE(2495),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_QMARK] = ACTIONS(5537),
    [anon_sym_BANG] = ACTIONS(5539),
    [anon_sym_AT] = ACTIONS(5537),
    [sym_variable_name] = ACTIONS(5541),
    [anon_sym_DOLLAR] = ACTIONS(5543),
    [anon_sym_DASH] = ACTIONS(5543),
    [anon_sym_0] = ACTIONS(5545),
    [anon_sym_POUND] = ACTIONS(5539),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5545),
    [anon_sym__] = ACTIONS(5545),
    [sym_comment] = ACTIONS(3),
  },
  [1962] = {
    [aux_sym__literal_repeat1] = STATE(2500),
    [anon_sym_AMP_GT_GT] = ACTIONS(497),
    [anon_sym_DOLLAR] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(497),
    [anon_sym_fi] = ACTIONS(497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(497),
    [anon_sym_GT_LPAREN] = ACTIONS(497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(497),
    [aux_sym__simple_variable_name_token1] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [sym_word] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(497),
    [anon_sym_LT_AMP] = ACTIONS(497),
    [anon_sym_GT_GT] = ACTIONS(497),
    [sym__special_character] = ACTIONS(5547),
    [anon_sym_LT_LT_DASH] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(497),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(497),
    [sym_raw_string] = ACTIONS(497),
    [sym_variable_name] = ACTIONS(501),
    [sym_file_descriptor] = ACTIONS(501),
    [anon_sym_GT] = ACTIONS(497),
    [anon_sym_AMP_GT] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(497),
    [anon_sym_LT_LT_LT] = ACTIONS(497),
    [anon_sym_GT_AMP] = ACTIONS(497),
    [anon_sym_LT_LPAREN] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [anon_sym_PIPE_AMP] = ACTIONS(497),
  },
  [1963] = {
    [sym_process_substitution] = STATE(1955),
    [sym_string] = STATE(1955),
    [sym_command_substitution] = STATE(1955),
    [sym_simple_expansion] = STATE(1955),
    [sym_variable_assignment] = STATE(2501),
    [sym_subscript] = STATE(1964),
    [sym_string_expansion] = STATE(1955),
    [sym_expansion] = STATE(1955),
    [sym_concatenation] = STATE(2501),
    [aux_sym_declaration_command_repeat1] = STATE(2501),
    [aux_sym__literal_repeat1] = STATE(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_fi] = ACTIONS(503),
    [anon_sym_GT_LPAREN] = ACTIONS(4244),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4246),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4248),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5549),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [sym_word] = ACTIONS(4252),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_LT_AMP] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [sym__special_character] = ACTIONS(4254),
    [anon_sym_LT_LT_DASH] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(4256),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_raw_string] = ACTIONS(4252),
    [sym_variable_name] = ACTIONS(4258),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_AMP_GT] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(4260),
    [anon_sym_LT_LT_LT] = ACTIONS(503),
    [anon_sym_GT_AMP] = ACTIONS(503),
    [anon_sym_LT_LPAREN] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
  },
  [1964] = {
    [anon_sym_EQ] = ACTIONS(5525),
    [anon_sym_PLUS_EQ] = ACTIONS(5525),
    [sym_comment] = ACTIONS(51),
  },
  [1965] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(2502),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1966] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(2505),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(5551),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(5553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1967] = {
    [aux_sym_concatenation_repeat1] = STATE(2507),
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_fi] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(5555),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [1968] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2508),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1969] = {
    [sym_string] = STATE(2510),
    [anon_sym_DQUOTE] = ACTIONS(5557),
    [anon_sym_STAR] = ACTIONS(5559),
    [anon_sym_QMARK] = ACTIONS(5559),
    [sym_raw_string] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(5559),
    [anon_sym_DOLLAR] = ACTIONS(5563),
    [anon_sym_POUND] = ACTIONS(5563),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_0] = ACTIONS(5565),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5565),
    [anon_sym__] = ACTIONS(5565),
  },
  [1970] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(2512),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2513),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1971] = {
    [aux_sym_concatenation_repeat1] = STATE(2507),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(5555),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [1972] = {
    [sym_subscript] = STATE(2514),
    [anon_sym_STAR] = ACTIONS(5567),
    [anon_sym_QMARK] = ACTIONS(5567),
    [anon_sym_BANG] = ACTIONS(5569),
    [anon_sym_AT] = ACTIONS(5567),
    [sym_variable_name] = ACTIONS(5571),
    [anon_sym_DOLLAR] = ACTIONS(5573),
    [anon_sym_DASH] = ACTIONS(5573),
    [anon_sym_0] = ACTIONS(5575),
    [anon_sym_POUND] = ACTIONS(5569),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5575),
    [anon_sym__] = ACTIONS(5575),
    [sym_comment] = ACTIONS(3),
  },
  [1973] = {
    [aux_sym__literal_repeat1] = STATE(2519),
    [anon_sym_AMP_GT_GT] = ACTIONS(539),
    [anon_sym_DOLLAR] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_fi] = ACTIONS(539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(539),
    [anon_sym_GT_LPAREN] = ACTIONS(539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(539),
    [aux_sym__simple_variable_name_token1] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [sym_word] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_LT_AMP] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(539),
    [sym__special_character] = ACTIONS(5577),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_raw_string] = ACTIONS(539),
    [sym_file_descriptor] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(539),
    [anon_sym_AMP_GT] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_LT_LT_LT] = ACTIONS(539),
    [anon_sym_GT_AMP] = ACTIONS(539),
    [anon_sym_LT_LPAREN] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_SEMI_SEMI] = ACTIONS(539),
    [anon_sym_PIPE_AMP] = ACTIONS(539),
  },
  [1974] = {
    [sym_process_substitution] = STATE(1967),
    [sym_command_substitution] = STATE(1967),
    [aux_sym_unset_command_repeat1] = STATE(2520),
    [sym_simple_expansion] = STATE(1967),
    [sym_string_expansion] = STATE(1967),
    [sym_expansion] = STATE(1967),
    [sym_concatenation] = STATE(2520),
    [sym_string] = STATE(1967),
    [aux_sym__literal_repeat1] = STATE(1973),
    [anon_sym_AMP_GT_GT] = ACTIONS(545),
    [anon_sym_DOLLAR] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(545),
    [anon_sym_fi] = ACTIONS(545),
    [anon_sym_GT_LPAREN] = ACTIONS(4264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4268),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5579),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_word] = ACTIONS(4272),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_LT_AMP] = ACTIONS(545),
    [anon_sym_GT_GT] = ACTIONS(545),
    [sym__special_character] = ACTIONS(4274),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_BQUOTE] = ACTIONS(4276),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(545),
    [sym_raw_string] = ACTIONS(4272),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_AMP_GT] = ACTIONS(545),
    [anon_sym_DQUOTE] = ACTIONS(4278),
    [anon_sym_LT_LT_LT] = ACTIONS(545),
    [anon_sym_GT_AMP] = ACTIONS(545),
    [anon_sym_LT_LPAREN] = ACTIONS(4264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
  },
  [1975] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_fi] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [1976] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_fi] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(555),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_EQ_EQ] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [1977] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_fi] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [1978] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5581),
  },
  [1979] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(5583),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [1980] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5583),
  },
  [1981] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2525),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2525),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5585),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5587),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5589),
    [anon_sym_DASH] = ACTIONS(5587),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5587),
    [anon_sym_PERCENT] = ACTIONS(5587),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5591),
    [anon_sym_COLON_DASH] = ACTIONS(5587),
    [sym__special_character] = ACTIONS(599),
  },
  [1982] = {
    [sym_subscript] = STATE(2526),
    [anon_sym_STAR] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5593),
    [anon_sym_AT] = ACTIONS(5593),
    [sym_variable_name] = ACTIONS(5595),
    [anon_sym_DOLLAR] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_0] = ACTIONS(5599),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5599),
    [anon_sym__] = ACTIONS(5599),
  },
  [1983] = {
    [anon_sym_EQ] = ACTIONS(5601),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [1984] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2532),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2532),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5603),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5605),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [anon_sym_DASH] = ACTIONS(5605),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5605),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5605),
    [anon_sym_PERCENT] = ACTIONS(5605),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5609),
    [anon_sym_COLON_DASH] = ACTIONS(5605),
    [sym__special_character] = ACTIONS(599),
  },
  [1985] = {
    [sym_process_substitution] = STATE(2533),
    [sym_string_expansion] = STATE(2533),
    [sym_expansion] = STATE(2533),
    [sym_simple_expansion] = STATE(2533),
    [sym_string] = STATE(2533),
    [sym_command_substitution] = STATE(2533),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [sym_word] = ACTIONS(5611),
    [sym_raw_string] = ACTIONS(5611),
    [anon_sym_LT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [sym__special_character] = ACTIONS(5611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
  },
  [1986] = {
    [aux_sym_concatenation_repeat1] = STATE(2535),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(5613),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [1987] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5583),
  },
  [1988] = {
    [sym_process_substitution] = STATE(2539),
    [aux_sym__literal_repeat1] = STATE(2546),
    [sym_array] = STATE(2545),
    [sym_simple_expansion] = STATE(2539),
    [sym_string_expansion] = STATE(2539),
    [sym_expansion] = STATE(2539),
    [sym_concatenation] = STATE(2545),
    [sym_string] = STATE(2539),
    [sym_command_substitution] = STATE(2539),
    [anon_sym_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5617),
    [anon_sym_DQUOTE] = ACTIONS(5619),
    [sym_word] = ACTIONS(5621),
    [sym_raw_string] = ACTIONS(5621),
    [anon_sym_LT_LPAREN] = ACTIONS(5623),
    [anon_sym_DOLLAR] = ACTIONS(5625),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5627),
    [sym__special_character] = ACTIONS(5629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5631),
    [sym__empty_value] = ACTIONS(5633),
  },
  [1989] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(5635),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [1990] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_fi] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1991] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(5637),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(5635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [1992] = {
    [sym_redirected_statement] = STATE(2549),
    [sym_if_statement] = STATE(2549),
    [sym_function_definition] = STATE(2549),
    [sym_compound_statement] = STATE(2549),
    [sym_test_command] = STATE(2549),
    [sym_declaration_command] = STATE(2549),
    [sym_subscript] = STATE(1429),
    [sym_file_redirect] = STATE(1431),
    [sym_concatenation] = STATE(1430),
    [sym_string] = STATE(1423),
    [sym_command_substitution] = STATE(1423),
    [sym_process_substitution] = STATE(1423),
    [aux_sym_command_repeat1] = STATE(1431),
    [sym_for_statement] = STATE(2549),
    [sym_c_style_for_statement] = STATE(2549),
    [sym_case_statement] = STATE(2549),
    [sym_subshell] = STATE(2549),
    [sym_pipeline] = STATE(2549),
    [sym_unset_command] = STATE(2549),
    [sym_command] = STATE(2549),
    [sym_simple_expansion] = STATE(1423),
    [sym_while_statement] = STATE(2549),
    [sym_list] = STATE(2549),
    [sym_negated_command] = STATE(2549),
    [sym_command_name] = STATE(1433),
    [sym_variable_assignment] = STATE(2550),
    [sym_string_expansion] = STATE(1423),
    [sym_expansion] = STATE(1423),
    [aux_sym__literal_repeat1] = STATE(1436),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3073),
    [anon_sym_typeset] = ACTIONS(3073),
    [anon_sym_unsetenv] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_GT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3073),
    [sym__special_character] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_declare] = ACTIONS(3073),
    [sym_variable_name] = ACTIONS(3097),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3073),
    [anon_sym_unset] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3081),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1993] = {
    [sym_process_substitution] = STATE(2551),
    [aux_sym__literal_repeat1] = STATE(2553),
    [sym_simple_expansion] = STATE(2551),
    [sym_string_expansion] = STATE(2551),
    [sym_expansion] = STATE(2551),
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(2551),
    [sym_command_substitution] = STATE(2551),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(5639),
    [sym_raw_string] = ACTIONS(5639),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(5641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [1994] = {
    [sym_heredoc_body] = STATE(2554),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [1995] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_fi] = ACTIONS(1220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [1996] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5643),
    [anon_sym_GT_AMP] = ACTIONS(5643),
    [anon_sym_LT] = ACTIONS(5645),
    [anon_sym_LT_AMP] = ACTIONS(5643),
    [anon_sym_GT_GT] = ACTIONS(5643),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(5645),
    [anon_sym_AMP_GT] = ACTIONS(5645),
  },
  [1997] = {
    [sym_redirected_statement] = STATE(2556),
    [sym_if_statement] = STATE(2556),
    [sym_function_definition] = STATE(2556),
    [sym_compound_statement] = STATE(2556),
    [sym_test_command] = STATE(2556),
    [sym_declaration_command] = STATE(2556),
    [sym_subscript] = STATE(1429),
    [sym_file_redirect] = STATE(1431),
    [sym_concatenation] = STATE(1430),
    [sym_string] = STATE(1423),
    [sym_command_substitution] = STATE(1423),
    [sym_process_substitution] = STATE(1423),
    [aux_sym_command_repeat1] = STATE(1431),
    [sym_for_statement] = STATE(2556),
    [sym_c_style_for_statement] = STATE(2556),
    [sym_case_statement] = STATE(2556),
    [sym_subshell] = STATE(2556),
    [sym_pipeline] = STATE(2556),
    [sym_unset_command] = STATE(2556),
    [sym_command] = STATE(2556),
    [sym_simple_expansion] = STATE(1423),
    [sym_while_statement] = STATE(2556),
    [sym_list] = STATE(2556),
    [sym_negated_command] = STATE(2556),
    [sym_command_name] = STATE(1433),
    [sym_variable_assignment] = STATE(2557),
    [sym_string_expansion] = STATE(1423),
    [sym_expansion] = STATE(1423),
    [aux_sym__literal_repeat1] = STATE(1436),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3073),
    [anon_sym_typeset] = ACTIONS(3073),
    [anon_sym_unsetenv] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_GT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3073),
    [sym__special_character] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3091),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_declare] = ACTIONS(3073),
    [sym_variable_name] = ACTIONS(3097),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3073),
    [anon_sym_unset] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3081),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1998] = {
    [sym_process_substitution] = STATE(2558),
    [aux_sym__literal_repeat1] = STATE(2559),
    [sym_simple_expansion] = STATE(2558),
    [sym_string_expansion] = STATE(2558),
    [sym_expansion] = STATE(2558),
    [sym_concatenation] = STATE(609),
    [sym_string] = STATE(2558),
    [sym_command_substitution] = STATE(2558),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(5647),
    [sym_raw_string] = ACTIONS(5647),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(5641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [1999] = {
    [aux_sym_redirected_statement_repeat1] = STATE(2560),
    [sym_file_redirect] = STATE(2560),
    [sym_herestring_redirect] = STATE(2560),
    [sym_heredoc_redirect] = STATE(2560),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(4308),
    [anon_sym_LF] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(351),
    [sym_file_descriptor] = ACTIONS(4312),
    [anon_sym_fi] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(4308),
    [anon_sym_AMP_GT] = ACTIONS(4308),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(4316),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(4308),
    [anon_sym_LT] = ACTIONS(4308),
    [anon_sym_LT_AMP] = ACTIONS(4308),
    [anon_sym_GT_GT] = ACTIONS(4308),
    [anon_sym_AMP] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
  },
  [2000] = {
    [sym_process_substitution] = STATE(2001),
    [sym_command_substitution] = STATE(2001),
    [sym_simple_expansion] = STATE(2001),
    [sym_string_expansion] = STATE(2001),
    [sym_expansion] = STATE(2001),
    [aux_sym_command_repeat2] = STATE(2561),
    [sym_concatenation] = STATE(2561),
    [sym_string] = STATE(2001),
    [aux_sym__literal_repeat1] = STATE(2003),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_fi] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(4324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(4332),
    [sym__special_character] = ACTIONS(3089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(4334),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(4330),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(4332),
    [anon_sym_DQUOTE] = ACTIONS(4336),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(4324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [2001] = {
    [aux_sym_concatenation_repeat1] = STATE(1986),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_fi] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [sym__concat] = ACTIONS(4298),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [sym__special_character] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
  },
  [2002] = {
    [sym_process_substitution] = STATE(2562),
    [aux_sym__literal_repeat1] = STATE(2564),
    [sym_simple_expansion] = STATE(2562),
    [sym_string_expansion] = STATE(2562),
    [sym_expansion] = STATE(2562),
    [sym_concatenation] = STATE(2563),
    [sym_string] = STATE(2562),
    [sym_command_substitution] = STATE(2562),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [sym_word] = ACTIONS(5649),
    [sym_raw_string] = ACTIONS(5649),
    [anon_sym_LT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [sym__special_character] = ACTIONS(4320),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
    [sym_regex] = ACTIONS(5651),
  },
  [2003] = {
    [aux_sym__literal_repeat1] = STATE(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_fi] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(4338),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
  },
  [2004] = {
    [sym_process_substitution] = STATE(2001),
    [sym_command_substitution] = STATE(2001),
    [sym_simple_expansion] = STATE(2001),
    [sym_string_expansion] = STATE(2001),
    [sym_expansion] = STATE(2001),
    [aux_sym_command_repeat2] = STATE(2565),
    [sym_concatenation] = STATE(2565),
    [sym_string] = STATE(2001),
    [aux_sym__literal_repeat1] = STATE(2003),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_fi] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(4324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4328),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(4332),
    [sym__special_character] = ACTIONS(3089),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(4334),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(4330),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(4332),
    [anon_sym_DQUOTE] = ACTIONS(4336),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(4324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [2005] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1999),
    [sym_file_redirect] = STATE(1999),
    [sym_herestring_redirect] = STATE(1999),
    [sym_heredoc_redirect] = STATE(1999),
    [anon_sym_PIPE_AMP] = ACTIONS(4318),
    [anon_sym_AMP_GT_GT] = ACTIONS(4308),
    [anon_sym_LF] = ACTIONS(5653),
    [anon_sym_SEMI] = ACTIONS(5655),
    [sym_file_descriptor] = ACTIONS(4312),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_fi] = ACTIONS(1220),
    [anon_sym_GT] = ACTIONS(4308),
    [anon_sym_AMP_GT] = ACTIONS(4308),
    [anon_sym_PIPE_PIPE] = ACTIONS(4314),
    [anon_sym_LT_LT_LT] = ACTIONS(4316),
    [anon_sym_GT_AMP] = ACTIONS(4308),
    [anon_sym_PIPE] = ACTIONS(4318),
    [anon_sym_LT] = ACTIONS(4308),
    [anon_sym_LT_AMP] = ACTIONS(4308),
    [anon_sym_GT_GT] = ACTIONS(4308),
    [anon_sym_AMP] = ACTIONS(5655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5655),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
  },
  [2006] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1999),
    [sym_file_redirect] = STATE(1999),
    [sym_herestring_redirect] = STATE(1999),
    [sym_heredoc_redirect] = STATE(1999),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_fi] = ACTIONS(1220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(4314),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(4318),
    [anon_sym_AMP] = ACTIONS(5655),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(5653),
    [anon_sym_SEMI] = ACTIONS(5655),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(4316),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4314),
    [anon_sym_SEMI_SEMI] = ACTIONS(5655),
    [anon_sym_PIPE_AMP] = ACTIONS(4318),
  },
  [2007] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2008] = {
    [aux_sym__literal_repeat1] = STATE(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_EQ_TILDE] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(5657),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [2009] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2570),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2570),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5660),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5660),
    [anon_sym_PERCENT] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5664),
    [anon_sym_COLON_DASH] = ACTIONS(5660),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5666),
  },
  [2010] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_fi] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_EQ_TILDE] = ACTIONS(1476),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [anon_sym_elif] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [2011] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2012] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2570),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2570),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5668),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5660),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5660),
    [anon_sym_PERCENT] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5664),
    [anon_sym_COLON_DASH] = ACTIONS(5660),
    [sym__special_character] = ACTIONS(599),
  },
  [2013] = {
    [anon_sym_EQ] = ACTIONS(5670),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2014] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2575),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2575),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5672),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5674),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5674),
    [anon_sym_PERCENT] = ACTIONS(5674),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5678),
    [anon_sym_COLON_DASH] = ACTIONS(5674),
    [sym__special_character] = ACTIONS(599),
  },
  [2015] = {
    [sym_process_substitution] = STATE(2576),
    [aux_sym__literal_repeat1] = STATE(2578),
    [sym_simple_expansion] = STATE(2576),
    [sym_string_expansion] = STATE(2576),
    [sym_expansion] = STATE(2576),
    [sym_concatenation] = STATE(2577),
    [sym_string] = STATE(2576),
    [sym_command_substitution] = STATE(2576),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5680),
    [sym_raw_string] = ACTIONS(5680),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2016] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2581),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2581),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5682),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(5682),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5682),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5686),
    [anon_sym_COLON_DASH] = ACTIONS(5682),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5688),
  },
  [2017] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_fi] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1532),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_elif] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [2018] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5684),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2019] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2020] = {
    [sym_process_substitution] = STATE(2019),
    [sym_string_expansion] = STATE(2019),
    [sym_expansion] = STATE(2019),
    [sym_simple_expansion] = STATE(2019),
    [sym_string] = STATE(2019),
    [sym_command_substitution] = STATE(2019),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [sym_word] = ACTIONS(4366),
    [sym_raw_string] = ACTIONS(4366),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR] = ACTIONS(5690),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [sym__special_character] = ACTIONS(4366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
  },
  [2021] = {
    [aux_sym_concatenation_repeat1] = STATE(2021),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(5692),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2022] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(2584),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(2584),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(5695),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2023] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(2585),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2024] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(2588),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(5697),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(5699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2025] = {
    [aux_sym_concatenation_repeat1] = STATE(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_fi] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_else] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(5701),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_elif] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2026] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2591),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2027] = {
    [sym_string] = STATE(2593),
    [anon_sym_DQUOTE] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(5703),
    [anon_sym_QMARK] = ACTIONS(5703),
    [sym_raw_string] = ACTIONS(5705),
    [anon_sym_AT] = ACTIONS(5703),
    [anon_sym_DOLLAR] = ACTIONS(5707),
    [anon_sym_POUND] = ACTIONS(5707),
    [anon_sym_DASH] = ACTIONS(5707),
    [anon_sym_0] = ACTIONS(5709),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5709),
    [anon_sym__] = ACTIONS(5709),
  },
  [2028] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(2595),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2596),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2029] = {
    [aux_sym_concatenation_repeat1] = STATE(2590),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(5701),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_elif] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2030] = {
    [sym_subscript] = STATE(2597),
    [anon_sym_STAR] = ACTIONS(5711),
    [anon_sym_QMARK] = ACTIONS(5711),
    [anon_sym_BANG] = ACTIONS(5713),
    [anon_sym_AT] = ACTIONS(5711),
    [sym_variable_name] = ACTIONS(5715),
    [anon_sym_DOLLAR] = ACTIONS(5717),
    [anon_sym_DASH] = ACTIONS(5717),
    [anon_sym_0] = ACTIONS(5719),
    [anon_sym_POUND] = ACTIONS(5713),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5719),
    [anon_sym__] = ACTIONS(5719),
    [sym_comment] = ACTIONS(3),
  },
  [2031] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_fi] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_else] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_elif] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2032] = {
    [aux_sym__literal_repeat1] = STATE(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_fi] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(5721),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_elif] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [2033] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_fi] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_else] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2010),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [anon_sym_elif] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [2034] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(5723),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2035] = {
    [sym_redirected_statement] = STATE(905),
    [sym_if_statement] = STATE(905),
    [sym_function_definition] = STATE(905),
    [sym_compound_statement] = STATE(905),
    [sym_test_command] = STATE(905),
    [sym_declaration_command] = STATE(905),
    [sym_subscript] = STATE(906),
    [sym_file_redirect] = STATE(908),
    [sym_concatenation] = STATE(907),
    [sym_string] = STATE(899),
    [sym_command_substitution] = STATE(899),
    [sym_process_substitution] = STATE(899),
    [aux_sym_command_repeat1] = STATE(908),
    [sym_for_statement] = STATE(905),
    [sym_c_style_for_statement] = STATE(905),
    [sym_case_statement] = STATE(905),
    [sym_subshell] = STATE(905),
    [sym_pipeline] = STATE(905),
    [sym_unset_command] = STATE(905),
    [sym_command] = STATE(905),
    [sym_simple_expansion] = STATE(899),
    [sym__statements] = STATE(2604),
    [sym_while_statement] = STATE(905),
    [sym_list] = STATE(905),
    [sym_negated_command] = STATE(905),
    [sym_command_name] = STATE(912),
    [sym_variable_assignment] = STATE(913),
    [sym_string_expansion] = STATE(899),
    [sym_expansion] = STATE(899),
    [aux_sym__statements_repeat1] = STATE(914),
    [aux_sym__literal_repeat1] = STATE(915),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1770),
    [anon_sym_typeset] = ACTIONS(1770),
    [anon_sym_unsetenv] = ACTIONS(1772),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_fi] = ACTIONS(5725),
    [anon_sym_GT_LPAREN] = ACTIONS(1776),
    [anon_sym_else] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1782),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1770),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(1790),
    [anon_sym_BQUOTE] = ACTIONS(1792),
    [anon_sym_BANG] = ACTIONS(1794),
    [anon_sym_declare] = ACTIONS(1770),
    [sym_variable_name] = ACTIONS(1796),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1770),
    [anon_sym_unset] = ACTIONS(1772),
    [anon_sym_DQUOTE] = ACTIONS(1798),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1776),
    [anon_sym_elif] = ACTIONS(5725),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2036] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1456),
    [sym_file_redirect] = STATE(1456),
    [sym_herestring_redirect] = STATE(1456),
    [sym_heredoc_redirect] = STATE(1456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_fi] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_else] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_elif] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [2037] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1456),
    [sym_file_redirect] = STATE(1456),
    [sym_herestring_redirect] = STATE(1456),
    [sym_heredoc_redirect] = STATE(1456),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_fi] = ACTIONS(2215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_else] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [anon_sym_elif] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [2038] = {
    [aux_sym_concatenation_repeat1] = STATE(2605),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_fi] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_else] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_elif] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [2039] = {
    [aux_sym_concatenation_repeat1] = STATE(2605),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_elif] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2040] = {
    [aux_sym__literal_repeat1] = STATE(2606),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_fi] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_else] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_elif] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
  },
  [2041] = {
    [anon_sym_LF] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5729),
    [anon_sym_SEMI] = ACTIONS(5729),
    [anon_sym_elif] = ACTIONS(2261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_fi] = ACTIONS(2261),
    [anon_sym_else] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(5729),
  },
  [2042] = {
    [sym_process_substitution] = STATE(2608),
    [aux_sym__literal_repeat1] = STATE(2609),
    [sym_simple_expansion] = STATE(2608),
    [sym_string_expansion] = STATE(2608),
    [sym_expansion] = STATE(2608),
    [sym_concatenation] = STATE(1142),
    [sym_string] = STATE(2608),
    [sym_command_substitution] = STATE(2608),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(5731),
    [sym_raw_string] = ACTIONS(5731),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(4398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [2043] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1456),
    [sym_file_redirect] = STATE(1456),
    [sym_herestring_redirect] = STATE(1456),
    [sym_heredoc_redirect] = STATE(1456),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [sym_file_descriptor] = ACTIONS(2277),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_fi] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_else] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_elif] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(3135),
  },
  [2044] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1456),
    [sym_file_redirect] = STATE(1456),
    [sym_herestring_redirect] = STATE(1456),
    [sym_heredoc_redirect] = STATE(1456),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_fi] = ACTIONS(2275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_else] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [anon_sym_elif] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(3135),
  },
  [2045] = {
    [aux_sym_concatenation_repeat1] = STATE(2605),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_fi] = ACTIONS(2279),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_else] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_elif] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [2046] = {
    [aux_sym__literal_repeat1] = STATE(2606),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LT_LT] = ACTIONS(2283),
    [sym_file_descriptor] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_fi] = ACTIONS(2283),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_else] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_LT_LT_LT] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_GT_AMP] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_LT_AMP] = ACTIONS(2283),
    [anon_sym_elif] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
  },
  [2047] = {
    [aux_sym_redirected_statement_repeat1] = STATE(2047),
    [sym_file_redirect] = STATE(2047),
    [sym_herestring_redirect] = STATE(2047),
    [sym_heredoc_redirect] = STATE(2047),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_AMP_GT_GT] = ACTIONS(5733),
    [anon_sym_LF] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2287),
    [sym_file_descriptor] = ACTIONS(5736),
    [anon_sym_GT] = ACTIONS(5733),
    [anon_sym_fi] = ACTIONS(2295),
    [anon_sym_AMP_GT] = ACTIONS(5733),
    [anon_sym_else] = ACTIONS(2295),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT_LT_LT] = ACTIONS(5739),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(5733),
    [anon_sym_LT] = ACTIONS(5733),
    [anon_sym_LT_AMP] = ACTIONS(5733),
    [anon_sym_elif] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(5733),
    [anon_sym_AMP] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
  },
  [2048] = {
    [sym_process_substitution] = STATE(1462),
    [sym_command_substitution] = STATE(1462),
    [sym_simple_expansion] = STATE(1462),
    [sym_string_expansion] = STATE(1462),
    [sym_expansion] = STATE(1462),
    [aux_sym_command_repeat2] = STATE(2054),
    [sym_concatenation] = STATE(2054),
    [sym_string] = STATE(1462),
    [aux_sym__literal_repeat1] = STATE(1464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_fi] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(3145),
    [anon_sym_else] = ACTIONS(2303),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3147),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3149),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [sym_word] = ACTIONS(3151),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_LT_AMP] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_TILDE] = ACTIONS(3153),
    [sym__special_character] = ACTIONS(1788),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(3155),
    [anon_sym_LF] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [sym_raw_string] = ACTIONS(3151),
    [sym_file_descriptor] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(3153),
    [anon_sym_DQUOTE] = ACTIONS(3157),
    [anon_sym_LT_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_AMP] = ACTIONS(2303),
    [anon_sym_LT_LPAREN] = ACTIONS(3145),
    [anon_sym_elif] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_SEMI_SEMI] = ACTIONS(2303),
    [anon_sym_PIPE_AMP] = ACTIONS(2303),
  },
  [2049] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5742),
    [anon_sym_BQUOTE] = ACTIONS(5742),
    [anon_sym_AMP_GT_GT] = ACTIONS(5742),
    [anon_sym_LF] = ACTIONS(5744),
    [anon_sym_SEMI] = ACTIONS(5742),
    [anon_sym_LT_LT] = ACTIONS(5742),
    [sym_file_descriptor] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5742),
    [anon_sym_RPAREN] = ACTIONS(5742),
    [anon_sym_AMP_GT] = ACTIONS(5742),
    [anon_sym_fi] = ACTIONS(5742),
    [anon_sym_else] = ACTIONS(5742),
    [anon_sym_done] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5742),
    [ts_builtin_sym_end] = ACTIONS(5744),
    [anon_sym_LT_LT_LT] = ACTIONS(5742),
    [anon_sym_PIPE] = ACTIONS(5742),
    [anon_sym_GT_AMP] = ACTIONS(5742),
    [anon_sym_LT] = ACTIONS(5742),
    [anon_sym_LT_AMP] = ACTIONS(5742),
    [anon_sym_GT_GT] = ACTIONS(5742),
    [anon_sym_AMP] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(5742),
    [anon_sym_AMP_AMP] = ACTIONS(5742),
    [anon_sym_esac] = ACTIONS(5742),
    [anon_sym_SEMI_SEMI] = ACTIONS(5742),
    [anon_sym_PIPE_AMP] = ACTIONS(5742),
  },
  [2050] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(5746),
  },
  [2051] = {
    [aux_sym_concatenation_repeat1] = STATE(1442),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_fi] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [sym__concat] = ACTIONS(3115),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [anon_sym_elif] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [2052] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_fi] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [anon_sym_elif] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [2053] = {
    [aux_sym__literal_repeat1] = STATE(1469),
    [anon_sym_AMP_GT_GT] = ACTIONS(2311),
    [anon_sym_DOLLAR] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_fi] = ACTIONS(2311),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2311),
    [anon_sym_else] = ACTIONS(2311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2311),
    [anon_sym_GT_LPAREN] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [sym_word] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_LT_AMP] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(2311),
    [anon_sym_EQ_TILDE] = ACTIONS(2311),
    [sym__special_character] = ACTIONS(3159),
    [anon_sym_LT_LT_DASH] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [sym_raw_string] = ACTIONS(2311),
    [sym_file_descriptor] = ACTIONS(2313),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP_GT] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_LT_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_AMP] = ACTIONS(2311),
    [anon_sym_LT_LPAREN] = ACTIONS(2311),
    [anon_sym_elif] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_SEMI_SEMI] = ACTIONS(2311),
    [anon_sym_PIPE_AMP] = ACTIONS(2311),
  },
  [2054] = {
    [sym_process_substitution] = STATE(1462),
    [sym_command_substitution] = STATE(1462),
    [sym_simple_expansion] = STATE(1462),
    [sym_string_expansion] = STATE(1462),
    [sym_expansion] = STATE(1462),
    [aux_sym_command_repeat2] = STATE(2054),
    [sym_concatenation] = STATE(2054),
    [sym_string] = STATE(1462),
    [aux_sym__literal_repeat1] = STATE(1464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(5748),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_fi] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5751),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5754),
    [anon_sym_GT_LPAREN] = ACTIONS(5757),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(5760),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(5763),
    [sym__special_character] = ACTIONS(5766),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(5769),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(5760),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(5763),
    [anon_sym_DQUOTE] = ACTIONS(5772),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(5757),
    [anon_sym_elif] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [2055] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_fi] = ACTIONS(2261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(2261),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_elif] = ACTIONS(2261),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [2056] = {
    [sym_heredoc_body] = STATE(2611),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_fi] = ACTIONS(2261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(2261),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_elif] = ACTIONS(2261),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [2057] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5775),
    [anon_sym_BQUOTE] = ACTIONS(5775),
    [anon_sym_AMP_GT_GT] = ACTIONS(5775),
    [anon_sym_LF] = ACTIONS(5777),
    [anon_sym_SEMI] = ACTIONS(5775),
    [anon_sym_LT_LT] = ACTIONS(5775),
    [sym_file_descriptor] = ACTIONS(5777),
    [anon_sym_GT] = ACTIONS(5775),
    [anon_sym_RPAREN] = ACTIONS(5775),
    [anon_sym_AMP_GT] = ACTIONS(5775),
    [anon_sym_fi] = ACTIONS(5775),
    [anon_sym_else] = ACTIONS(5775),
    [anon_sym_done] = ACTIONS(5775),
    [anon_sym_PIPE_PIPE] = ACTIONS(5775),
    [ts_builtin_sym_end] = ACTIONS(5777),
    [anon_sym_LT_LT_LT] = ACTIONS(5775),
    [anon_sym_PIPE] = ACTIONS(5775),
    [anon_sym_GT_AMP] = ACTIONS(5775),
    [anon_sym_LT] = ACTIONS(5775),
    [anon_sym_LT_AMP] = ACTIONS(5775),
    [anon_sym_GT_GT] = ACTIONS(5775),
    [anon_sym_AMP] = ACTIONS(5775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(5775),
    [anon_sym_AMP_AMP] = ACTIONS(5775),
    [anon_sym_esac] = ACTIONS(5775),
    [anon_sym_SEMI_SEMI] = ACTIONS(5775),
    [anon_sym_PIPE_AMP] = ACTIONS(5775),
  },
  [2058] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(5779),
  },
  [2059] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2613),
    [sym_case_item] = STATE(2067),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2067),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3178),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [2060] = {
    [sym_process_substitution] = STATE(2614),
    [aux_sym__literal_repeat1] = STATE(2616),
    [sym_simple_expansion] = STATE(2614),
    [sym_string_expansion] = STATE(2614),
    [sym_expansion] = STATE(2614),
    [sym_concatenation] = STATE(2615),
    [sym_string] = STATE(2614),
    [sym_command_substitution] = STATE(2614),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(5781),
    [sym_raw_string] = ACTIONS(5781),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [2061] = {
    [sym_redirected_statement] = STATE(2631),
    [sym_if_statement] = STATE(2631),
    [sym_function_definition] = STATE(2631),
    [sym_compound_statement] = STATE(2631),
    [sym_test_command] = STATE(2631),
    [sym_declaration_command] = STATE(2631),
    [sym_subscript] = STATE(2632),
    [sym_file_redirect] = STATE(2634),
    [sym_concatenation] = STATE(2633),
    [sym_string] = STATE(2625),
    [sym_command_substitution] = STATE(2625),
    [sym_process_substitution] = STATE(2625),
    [aux_sym_command_repeat1] = STATE(2634),
    [sym_for_statement] = STATE(2631),
    [sym_c_style_for_statement] = STATE(2631),
    [sym_case_statement] = STATE(2631),
    [sym_subshell] = STATE(2631),
    [sym_pipeline] = STATE(2631),
    [sym_unset_command] = STATE(2631),
    [sym_command] = STATE(2631),
    [sym_simple_expansion] = STATE(2625),
    [sym__statements] = STATE(2635),
    [sym_while_statement] = STATE(2631),
    [sym_list] = STATE(2631),
    [sym_negated_command] = STATE(2631),
    [sym_command_name] = STATE(2636),
    [sym_variable_assignment] = STATE(2637),
    [sym_string_expansion] = STATE(2625),
    [sym_expansion] = STATE(2625),
    [aux_sym__statements_repeat1] = STATE(2638),
    [aux_sym__literal_repeat1] = STATE(2639),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(5783),
    [anon_sym_typeset] = ACTIONS(5783),
    [anon_sym_unsetenv] = ACTIONS(5785),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(5783),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(5799),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_BANG] = ACTIONS(5803),
    [anon_sym_declare] = ACTIONS(5783),
    [sym_variable_name] = ACTIONS(5805),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(5783),
    [anon_sym_unset] = ACTIONS(5785),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [anon_sym_esac] = ACTIONS(5809),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(5811),
  },
  [2062] = {
    [aux_sym_concatenation_repeat1] = STATE(2640),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(631),
    [sym__concat] = ACTIONS(1873),
    [anon_sym_PIPE] = ACTIONS(631),
  },
  [2063] = {
    [aux_sym_case_item_repeat1] = STATE(2642),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(5813),
    [sym_comment] = ACTIONS(51),
  },
  [2064] = {
    [sym_redirected_statement] = STATE(2631),
    [sym_if_statement] = STATE(2631),
    [sym_function_definition] = STATE(2631),
    [sym_compound_statement] = STATE(2631),
    [sym_test_command] = STATE(2631),
    [sym_declaration_command] = STATE(2631),
    [sym_subscript] = STATE(2632),
    [sym_file_redirect] = STATE(2634),
    [sym_concatenation] = STATE(2633),
    [sym_string] = STATE(2625),
    [sym_command_substitution] = STATE(2625),
    [sym_process_substitution] = STATE(2625),
    [aux_sym_command_repeat1] = STATE(2634),
    [sym_for_statement] = STATE(2631),
    [sym_c_style_for_statement] = STATE(2631),
    [sym_case_statement] = STATE(2631),
    [sym_subshell] = STATE(2631),
    [sym_pipeline] = STATE(2631),
    [sym_unset_command] = STATE(2631),
    [sym_command] = STATE(2631),
    [sym_simple_expansion] = STATE(2625),
    [sym__statements] = STATE(2644),
    [sym_while_statement] = STATE(2631),
    [sym_list] = STATE(2631),
    [sym_negated_command] = STATE(2631),
    [sym_command_name] = STATE(2636),
    [sym_variable_assignment] = STATE(2637),
    [sym_string_expansion] = STATE(2625),
    [sym_expansion] = STATE(2625),
    [aux_sym__statements_repeat1] = STATE(2638),
    [aux_sym__literal_repeat1] = STATE(2639),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(5783),
    [anon_sym_typeset] = ACTIONS(5783),
    [anon_sym_unsetenv] = ACTIONS(5785),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(5783),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(5799),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_BANG] = ACTIONS(5803),
    [anon_sym_declare] = ACTIONS(5783),
    [sym_variable_name] = ACTIONS(5805),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(5783),
    [anon_sym_unset] = ACTIONS(5785),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [anon_sym_esac] = ACTIONS(5815),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(5817),
  },
  [2065] = {
    [aux_sym_case_item_repeat1] = STATE(2642),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(5819),
    [sym_comment] = ACTIONS(51),
  },
  [2066] = {
    [aux_sym__literal_repeat1] = STATE(2066),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1192),
    [sym__special_character] = ACTIONS(1905),
  },
  [2067] = {
    [sym_process_substitution] = STATE(2646),
    [sym_case_item] = STATE(2067),
    [sym_command_substitution] = STATE(2646),
    [sym_simple_expansion] = STATE(2646),
    [aux_sym_case_statement_repeat1] = STATE(2067),
    [sym_string_expansion] = STATE(2646),
    [sym_expansion] = STATE(2646),
    [sym_concatenation] = STATE(2648),
    [sym_string] = STATE(2646),
    [aux_sym__literal_repeat1] = STATE(2647),
    [anon_sym_BQUOTE] = ACTIONS(5821),
    [anon_sym_DQUOTE] = ACTIONS(5824),
    [sym_word] = ACTIONS(5827),
    [sym_raw_string] = ACTIONS(5827),
    [anon_sym_LT_LPAREN] = ACTIONS(5830),
    [anon_sym_DOLLAR] = ACTIONS(5833),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5836),
    [sym__special_character] = ACTIONS(5839),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5842),
  },
  [2068] = {
    [anon_sym_AMP] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym_in] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
  },
  [2069] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5845),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2070] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2650),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2650),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5847),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5845),
    [anon_sym_DASH] = ACTIONS(5847),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5847),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5847),
    [anon_sym_PERCENT] = ACTIONS(5847),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5849),
    [anon_sym_COLON_DASH] = ACTIONS(5847),
    [sym__special_character] = ACTIONS(599),
  },
  [2071] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5845),
    [sym__concat] = ACTIONS(2610),
  },
  [2072] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5845),
  },
  [2073] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5851),
  },
  [2074] = {
    [anon_sym_AMP] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym_in] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
  },
  [2075] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2653),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2653),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5853),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5855),
    [anon_sym_DASH] = ACTIONS(5853),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5853),
    [anon_sym_PERCENT] = ACTIONS(5853),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5857),
    [anon_sym_COLON_DASH] = ACTIONS(5853),
    [sym__special_character] = ACTIONS(599),
  },
  [2076] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5855),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2077] = {
    [anon_sym_AMP] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_in] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
  },
  [2078] = {
    [anon_sym_AMP] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [anon_sym_in] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
  },
  [2079] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2080] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5861),
    [anon_sym_BQUOTE] = ACTIONS(5861),
    [anon_sym_AMP_GT_GT] = ACTIONS(5861),
    [anon_sym_LF] = ACTIONS(5863),
    [anon_sym_SEMI] = ACTIONS(5861),
    [anon_sym_LT_LT] = ACTIONS(5861),
    [sym_file_descriptor] = ACTIONS(5863),
    [anon_sym_GT] = ACTIONS(5861),
    [anon_sym_RPAREN] = ACTIONS(5861),
    [anon_sym_AMP_GT] = ACTIONS(5861),
    [anon_sym_fi] = ACTIONS(5861),
    [anon_sym_else] = ACTIONS(5861),
    [anon_sym_done] = ACTIONS(5861),
    [anon_sym_PIPE_PIPE] = ACTIONS(5861),
    [ts_builtin_sym_end] = ACTIONS(5863),
    [anon_sym_LT_LT_LT] = ACTIONS(5861),
    [anon_sym_PIPE] = ACTIONS(5861),
    [anon_sym_GT_AMP] = ACTIONS(5861),
    [anon_sym_LT] = ACTIONS(5861),
    [anon_sym_LT_AMP] = ACTIONS(5861),
    [anon_sym_GT_GT] = ACTIONS(5861),
    [anon_sym_AMP] = ACTIONS(5861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(5861),
    [anon_sym_AMP_AMP] = ACTIONS(5861),
    [anon_sym_esac] = ACTIONS(5861),
    [anon_sym_SEMI_SEMI] = ACTIONS(5861),
    [anon_sym_PIPE_AMP] = ACTIONS(5861),
  },
  [2081] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(5865),
  },
  [2082] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2656),
    [sym_case_item] = STATE(2067),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2067),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3178),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [2083] = {
    [anon_sym_BANG_EQ] = ACTIONS(3832),
    [anon_sym_PLUS_EQ] = ACTIONS(3832),
    [sym_test_operator] = ACTIONS(3832),
    [anon_sym_PLUS_PLUS] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3830),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_EQ] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3832),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3832),
    [anon_sym_PIPE_PIPE] = ACTIONS(3832),
    [anon_sym_GT_EQ] = ACTIONS(3832),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3832),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3832),
    [anon_sym_DASH_DASH] = ACTIONS(3832),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_AMP_AMP] = ACTIONS(3832),
    [anon_sym_DASH_EQ] = ACTIONS(3832),
  },
  [2084] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5867),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2085] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2658),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2658),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5869),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5867),
    [anon_sym_DASH] = ACTIONS(5869),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5869),
    [anon_sym_PERCENT] = ACTIONS(5869),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5871),
    [anon_sym_COLON_DASH] = ACTIONS(5869),
    [sym__special_character] = ACTIONS(599),
  },
  [2086] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5867),
    [sym__concat] = ACTIONS(2610),
  },
  [2087] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5867),
  },
  [2088] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5873),
  },
  [2089] = {
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_PLUS_EQ] = ACTIONS(3881),
    [sym_test_operator] = ACTIONS(3881),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_DASH_EQ] = ACTIONS(3881),
  },
  [2090] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2661),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2661),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5875),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5877),
    [anon_sym_DASH] = ACTIONS(5875),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5875),
    [anon_sym_PERCENT] = ACTIONS(5875),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5879),
    [anon_sym_COLON_DASH] = ACTIONS(5875),
    [sym__special_character] = ACTIONS(599),
  },
  [2091] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5877),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2092] = {
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_PLUS_EQ] = ACTIONS(3929),
    [sym_test_operator] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3929),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_DASH_EQ] = ACTIONS(3929),
  },
  [2093] = {
    [anon_sym_BANG_EQ] = ACTIONS(3948),
    [anon_sym_PLUS_EQ] = ACTIONS(3948),
    [sym_test_operator] = ACTIONS(3948),
    [anon_sym_PLUS_PLUS] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3948),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [anon_sym_GT_EQ] = ACTIONS(3948),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3948),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3948),
    [anon_sym_DASH_DASH] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_DASH_EQ] = ACTIONS(3948),
  },
  [2094] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5881),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2095] = {
    [aux_sym_concatenation_repeat1] = STATE(2095),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2096] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(5041),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [2097] = {
    [anon_sym_BQUOTE] = ACTIONS(4559),
    [anon_sym_AMP_GT_GT] = ACTIONS(4559),
    [sym_raw_string] = ACTIONS(4559),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [sym_file_descriptor] = ACTIONS(4559),
    [sym_variable_name] = ACTIONS(4559),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4559),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4559),
    [anon_sym_GT_LPAREN] = ACTIONS(4559),
    [anon_sym_DQUOTE] = ACTIONS(4559),
    [sym_word] = ACTIONS(4559),
    [anon_sym_GT_AMP] = ACTIONS(4559),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4559),
    [anon_sym_GT_GT] = ACTIONS(4559),
    [anon_sym_LT_LPAREN] = ACTIONS(4559),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(4559),
  },
  [2098] = {
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [sym_word] = ACTIONS(1442),
    [sym_raw_string] = ACTIONS(1442),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_LT_LPAREN] = ACTIONS(1442),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1442),
  },
  [2099] = {
    [anon_sym_BQUOTE] = ACTIONS(2012),
    [anon_sym_DQUOTE] = ACTIONS(2012),
    [sym_word] = ACTIONS(2012),
    [sym_raw_string] = ACTIONS(2012),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_LT_LPAREN] = ACTIONS(2012),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_RPAREN] = ACTIONS(2012),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2012),
  },
  [2100] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(5883),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2101] = {
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [sym_word] = ACTIONS(1544),
    [sym_raw_string] = ACTIONS(1544),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_LT_LPAREN] = ACTIONS(1544),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1544),
  },
  [2102] = {
    [sym_process_substitution] = STATE(2101),
    [sym_string_expansion] = STATE(2101),
    [sym_expansion] = STATE(2101),
    [sym_simple_expansion] = STATE(2101),
    [sym_string] = STATE(2101),
    [sym_command_substitution] = STATE(2101),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(4522),
    [sym_raw_string] = ACTIONS(4522),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(5885),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(4522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2103] = {
    [aux_sym_concatenation_repeat1] = STATE(2103),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [anon_sym_DQUOTE] = ACTIONS(1544),
    [sym_word] = ACTIONS(1544),
    [sym_raw_string] = ACTIONS(1544),
    [sym__concat] = ACTIONS(5887),
    [anon_sym_LT_LPAREN] = ACTIONS(1544),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1544),
  },
  [2104] = {
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [sym_word] = ACTIONS(1436),
    [sym_raw_string] = ACTIONS(1436),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_LT_LPAREN] = ACTIONS(1436),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_RPAREN] = ACTIONS(1436),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1436),
  },
  [2105] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2667),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2667),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5890),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5890),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_COLON_DASH] = ACTIONS(5890),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5896),
  },
  [2106] = {
    [anon_sym_BQUOTE] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [sym_word] = ACTIONS(1478),
    [sym_raw_string] = ACTIONS(1478),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_LT_LPAREN] = ACTIONS(1478),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1478),
  },
  [2107] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2108] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2667),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2667),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5898),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5890),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5890),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5894),
    [anon_sym_COLON_DASH] = ACTIONS(5890),
    [sym__special_character] = ACTIONS(599),
  },
  [2109] = {
    [anon_sym_EQ] = ACTIONS(5900),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2110] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2672),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2672),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5902),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5904),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5906),
    [anon_sym_DASH] = ACTIONS(5904),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5904),
    [anon_sym_PERCENT] = ACTIONS(5904),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5908),
    [anon_sym_COLON_DASH] = ACTIONS(5904),
    [sym__special_character] = ACTIONS(599),
  },
  [2111] = {
    [sym_process_substitution] = STATE(2673),
    [aux_sym__literal_repeat1] = STATE(2675),
    [sym_simple_expansion] = STATE(2673),
    [sym_string_expansion] = STATE(2673),
    [sym_expansion] = STATE(2673),
    [sym_concatenation] = STATE(2674),
    [sym_string] = STATE(2673),
    [sym_command_substitution] = STATE(2673),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5910),
    [sym_raw_string] = ACTIONS(5910),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2112] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2678),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2678),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5912),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(5912),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5912),
    [anon_sym_PERCENT] = ACTIONS(5912),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5916),
    [anon_sym_COLON_DASH] = ACTIONS(5912),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5918),
  },
  [2113] = {
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [sym_word] = ACTIONS(1534),
    [sym_raw_string] = ACTIONS(1534),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_LT_LPAREN] = ACTIONS(1534),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1534),
  },
  [2114] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5914),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2115] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [ts_builtin_sym_end] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [2116] = {
    [sym_string] = STATE(1003),
    [anon_sym__] = ACTIONS(1972),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(5920),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(5920),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1972),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(1972),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(5922),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(1972),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_RPAREN] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(5924),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [ts_builtin_sym_end] = ACTIONS(2662),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5920),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [2117] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [ts_builtin_sym_end] = ACTIONS(2508),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [2118] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2680),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2680),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5926),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5926),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5926),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5930),
    [anon_sym_COLON_DASH] = ACTIONS(5926),
    [sym__special_character] = ACTIONS(599),
  },
  [2119] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2120] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2680),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2680),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5926),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5928),
    [anon_sym_DASH] = ACTIONS(5926),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5926),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5930),
    [anon_sym_COLON_DASH] = ACTIONS(5926),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5932),
  },
  [2121] = {
    [sym_process_substitution] = STATE(2682),
    [aux_sym__literal_repeat1] = STATE(2684),
    [sym_simple_expansion] = STATE(2682),
    [sym_string_expansion] = STATE(2682),
    [sym_expansion] = STATE(2682),
    [sym_concatenation] = STATE(2683),
    [sym_string] = STATE(2682),
    [sym_command_substitution] = STATE(2682),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5934),
    [sym_raw_string] = ACTIONS(5934),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5928),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2122] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2687),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2687),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5936),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5938),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5936),
    [anon_sym_PERCENT] = ACTIONS(5936),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5940),
    [anon_sym_COLON_DASH] = ACTIONS(5936),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5942),
  },
  [2123] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [ts_builtin_sym_end] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [2124] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5938),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2125] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5928),
    [sym__concat] = ACTIONS(2610),
  },
  [2126] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5928),
  },
  [2127] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5944),
  },
  [2128] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [2129] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2690),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2690),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5946),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(5946),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5946),
    [anon_sym_PERCENT] = ACTIONS(5946),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5950),
    [anon_sym_COLON_DASH] = ACTIONS(5946),
    [sym__special_character] = ACTIONS(599),
  },
  [2130] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2131] = {
    [anon_sym_EQ] = ACTIONS(5952),
    [anon_sym_PLUS_EQ] = ACTIONS(5952),
    [sym_comment] = ACTIONS(51),
  },
  [2132] = {
    [sym_string] = STATE(571),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [sym__concat] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(999),
    [anon_sym_QMARK] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(999),
    [anon_sym_RBRACK] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(1003),
    [anon_sym_POUND] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_0] = ACTIONS(1005),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1005),
    [anon_sym__] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
  },
  [2133] = {
    [anon_sym_EQ] = ACTIONS(5954),
    [anon_sym_PLUS_EQ] = ACTIONS(5954),
    [sym_comment] = ACTIONS(51),
  },
  [2134] = {
    [anon_sym_BQUOTE] = ACTIONS(3832),
    [anon_sym_DQUOTE] = ACTIONS(3832),
    [sym__concat] = ACTIONS(3832),
    [sym__string_content] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3832),
  },
  [2135] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2136] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2692),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2692),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5958),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [anon_sym_DASH] = ACTIONS(5958),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5958),
    [anon_sym_PERCENT] = ACTIONS(5958),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5960),
    [anon_sym_COLON_DASH] = ACTIONS(5958),
    [sym__special_character] = ACTIONS(599),
  },
  [2137] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [sym__concat] = ACTIONS(2610),
  },
  [2138] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5956),
  },
  [2139] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(5962),
  },
  [2140] = {
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [sym__concat] = ACTIONS(3881),
    [sym__string_content] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3881),
  },
  [2141] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2695),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2695),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5964),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DASH] = ACTIONS(5964),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5964),
    [anon_sym_PERCENT] = ACTIONS(5964),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5968),
    [anon_sym_COLON_DASH] = ACTIONS(5964),
    [sym__special_character] = ACTIONS(599),
  },
  [2142] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2143] = {
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [sym__string_content] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
  },
  [2144] = {
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [sym__concat] = ACTIONS(3948),
    [sym__string_content] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
  },
  [2145] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2146] = {
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
  },
  [2147] = {
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
  },
  [2148] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(5972),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2149] = {
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
  },
  [2150] = {
    [sym_process_substitution] = STATE(2149),
    [sym_string_expansion] = STATE(2149),
    [sym_expansion] = STATE(2149),
    [sym_simple_expansion] = STATE(2149),
    [sym_string] = STATE(2149),
    [sym_command_substitution] = STATE(2149),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_DQUOTE] = ACTIONS(2067),
    [sym_word] = ACTIONS(4666),
    [sym_raw_string] = ACTIONS(4666),
    [anon_sym_LT_LPAREN] = ACTIONS(2071),
    [anon_sym_DOLLAR] = ACTIONS(5974),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2075),
    [sym__special_character] = ACTIONS(4666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2079),
  },
  [2151] = {
    [aux_sym_concatenation_repeat1] = STATE(2151),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [sym__concat] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
  },
  [2152] = {
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
  },
  [2153] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2701),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2701),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5979),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5981),
    [anon_sym_DASH] = ACTIONS(5979),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5979),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5979),
    [anon_sym_PERCENT] = ACTIONS(5979),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5983),
    [anon_sym_COLON_DASH] = ACTIONS(5979),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(5985),
  },
  [2154] = {
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
  },
  [2155] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5981),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2156] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2701),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2701),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5987),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5979),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5981),
    [anon_sym_DASH] = ACTIONS(5979),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5979),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5979),
    [anon_sym_PERCENT] = ACTIONS(5979),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5983),
    [anon_sym_COLON_DASH] = ACTIONS(5979),
    [sym__special_character] = ACTIONS(599),
  },
  [2157] = {
    [anon_sym_EQ] = ACTIONS(5989),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2158] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2706),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2706),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(5991),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(5993),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(5995),
    [anon_sym_DASH] = ACTIONS(5993),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(5993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(5993),
    [anon_sym_PERCENT] = ACTIONS(5993),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5997),
    [anon_sym_COLON_DASH] = ACTIONS(5993),
    [sym__special_character] = ACTIONS(599),
  },
  [2159] = {
    [sym_process_substitution] = STATE(2707),
    [aux_sym__literal_repeat1] = STATE(2709),
    [sym_simple_expansion] = STATE(2707),
    [sym_string_expansion] = STATE(2707),
    [sym_expansion] = STATE(2707),
    [sym_concatenation] = STATE(2708),
    [sym_string] = STATE(2707),
    [sym_command_substitution] = STATE(2707),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(5999),
    [sym_raw_string] = ACTIONS(5999),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5981),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2160] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2712),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2712),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6001),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6003),
    [anon_sym_DASH] = ACTIONS(6001),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6001),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6001),
    [anon_sym_PERCENT] = ACTIONS(6001),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6005),
    [anon_sym_COLON_DASH] = ACTIONS(6001),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6007),
  },
  [2161] = {
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
  },
  [2162] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6003),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2163] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6009),
    [anon_sym_BQUOTE] = ACTIONS(6009),
    [anon_sym_AMP_GT_GT] = ACTIONS(6009),
    [anon_sym_LF] = ACTIONS(6011),
    [anon_sym_SEMI] = ACTIONS(6009),
    [anon_sym_LT_LT] = ACTIONS(6009),
    [sym_file_descriptor] = ACTIONS(6011),
    [anon_sym_GT] = ACTIONS(6009),
    [anon_sym_RPAREN] = ACTIONS(6009),
    [anon_sym_AMP_GT] = ACTIONS(6009),
    [anon_sym_fi] = ACTIONS(6009),
    [anon_sym_else] = ACTIONS(6009),
    [anon_sym_done] = ACTIONS(6009),
    [anon_sym_PIPE_PIPE] = ACTIONS(6009),
    [ts_builtin_sym_end] = ACTIONS(6011),
    [anon_sym_LT_LT_LT] = ACTIONS(6009),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_GT_AMP] = ACTIONS(6009),
    [anon_sym_LT] = ACTIONS(6009),
    [anon_sym_LT_AMP] = ACTIONS(6009),
    [anon_sym_GT_GT] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(6009),
    [anon_sym_AMP_AMP] = ACTIONS(6009),
    [anon_sym_esac] = ACTIONS(6009),
    [anon_sym_SEMI_SEMI] = ACTIONS(6009),
    [anon_sym_PIPE_AMP] = ACTIONS(6009),
  },
  [2164] = {
    [sym_string] = STATE(1054),
    [sym_test_operator] = ACTIONS(2662),
    [anon_sym_PLUS_EQ] = ACTIONS(2658),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(6013),
    [anon_sym_DASH] = ACTIONS(6013),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2107),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2107),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_EQ_TILDE] = ACTIONS(2658),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_LT_EQ] = ACTIONS(2658),
    [anon_sym_DASH_EQ] = ACTIONS(2658),
    [anon_sym_BANG_EQ] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2107),
    [anon_sym_LF] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(6015),
    [anon_sym_0] = ACTIONS(2107),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2658),
    [anon_sym_GT_EQ] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym__] = ACTIONS(2107),
  },
  [2165] = {
    [sym_do_group] = STATE(2713),
    [sym_compound_statement] = STATE(2713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(991),
  },
  [2166] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6017),
    [anon_sym_BQUOTE] = ACTIONS(6017),
    [anon_sym_AMP_GT_GT] = ACTIONS(6017),
    [anon_sym_LF] = ACTIONS(6019),
    [anon_sym_SEMI] = ACTIONS(6017),
    [anon_sym_LT_LT] = ACTIONS(6017),
    [sym_file_descriptor] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_RPAREN] = ACTIONS(6017),
    [anon_sym_AMP_GT] = ACTIONS(6017),
    [anon_sym_fi] = ACTIONS(6017),
    [anon_sym_else] = ACTIONS(6017),
    [anon_sym_done] = ACTIONS(6017),
    [anon_sym_PIPE_PIPE] = ACTIONS(6017),
    [ts_builtin_sym_end] = ACTIONS(6019),
    [anon_sym_LT_LT_LT] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6017),
    [anon_sym_GT_AMP] = ACTIONS(6017),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_AMP] = ACTIONS(6017),
    [anon_sym_GT_GT] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(6017),
    [anon_sym_AMP_AMP] = ACTIONS(6017),
    [anon_sym_esac] = ACTIONS(6017),
    [anon_sym_SEMI_SEMI] = ACTIONS(6017),
    [anon_sym_PIPE_AMP] = ACTIONS(6017),
  },
  [2167] = {
    [sym_do_group] = STATE(2713),
    [sym_compound_statement] = STATE(2713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(6021),
    [anon_sym_do] = ACTIONS(991),
  },
  [2168] = {
    [anon_sym_BANG_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [sym_test_operator] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6023),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_GT_EQ] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_DASH_EQ] = ACTIONS(869),
  },
  [2169] = {
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_PLUS_EQ] = ACTIONS(2506),
    [sym_test_operator] = ACTIONS(2508),
    [anon_sym_LF] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_GT_EQ] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2506),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_LT_EQ] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_DASH_EQ] = ACTIONS(2506),
  },
  [2170] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2717),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2717),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6025),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [anon_sym_DASH] = ACTIONS(6025),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6029),
    [anon_sym_COLON_DASH] = ACTIONS(6025),
    [sym__special_character] = ACTIONS(599),
  },
  [2171] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2172] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2717),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2717),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6025),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [anon_sym_DASH] = ACTIONS(6025),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6025),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6029),
    [anon_sym_COLON_DASH] = ACTIONS(6025),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6031),
  },
  [2173] = {
    [sym_process_substitution] = STATE(2719),
    [aux_sym__literal_repeat1] = STATE(2721),
    [sym_simple_expansion] = STATE(2719),
    [sym_string_expansion] = STATE(2719),
    [sym_expansion] = STATE(2719),
    [sym_concatenation] = STATE(2720),
    [sym_string] = STATE(2719),
    [sym_command_substitution] = STATE(2719),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6033),
    [sym_raw_string] = ACTIONS(6033),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2174] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2724),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2724),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6035),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6037),
    [anon_sym_DASH] = ACTIONS(6035),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6035),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6035),
    [anon_sym_PERCENT] = ACTIONS(6035),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6039),
    [anon_sym_COLON_DASH] = ACTIONS(6035),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6041),
  },
  [2175] = {
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [anon_sym_PLUS_EQ] = ACTIONS(2602),
    [sym_test_operator] = ACTIONS(2604),
    [anon_sym_LF] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_DASH_EQ] = ACTIONS(2602),
  },
  [2176] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6037),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2177] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [sym__concat] = ACTIONS(2610),
  },
  [2178] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6027),
  },
  [2179] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6043),
  },
  [2180] = {
    [anon_sym_BANG_EQ] = ACTIONS(2644),
    [anon_sym_PLUS_EQ] = ACTIONS(2644),
    [sym_test_operator] = ACTIONS(2646),
    [anon_sym_LF] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_PLUS_PLUS] = ACTIONS(2644),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_DASH_EQ] = ACTIONS(2644),
  },
  [2181] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2727),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2727),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6045),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6045),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6045),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6049),
    [anon_sym_COLON_DASH] = ACTIONS(6045),
    [sym__special_character] = ACTIONS(599),
  },
  [2182] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2183] = {
    [anon_sym_BANG_EQ] = ACTIONS(3421),
    [anon_sym_PLUS_EQ] = ACTIONS(3421),
    [sym_test_operator] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_LT_EQ] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_DASH_EQ] = ACTIONS(3421),
  },
  [2184] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(2728),
    [sym_parenthesized_expression] = STATE(2728),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(2728),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(2728),
    [sym_unary_expression] = STATE(2728),
    [sym_concatenation] = STATE(2728),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6023),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(273),
  },
  [2185] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(6051),
  },
  [2186] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(6053),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2187] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_done] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [2188] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(6055),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(6053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2189] = {
    [sym_process_substitution] = STATE(2732),
    [sym_string_expansion] = STATE(2732),
    [sym_expansion] = STATE(2732),
    [sym_simple_expansion] = STATE(2732),
    [sym_string] = STATE(2732),
    [sym_command_substitution] = STATE(2732),
    [anon_sym_BQUOTE] = ACTIONS(6057),
    [anon_sym_DQUOTE] = ACTIONS(4778),
    [sym_word] = ACTIONS(6059),
    [sym_raw_string] = ACTIONS(6059),
    [anon_sym_LT_LPAREN] = ACTIONS(6061),
    [anon_sym_DOLLAR] = ACTIONS(3524),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6063),
    [sym__special_character] = ACTIONS(6059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6065),
  },
  [2190] = {
    [aux_sym_concatenation_repeat1] = STATE(2734),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_done] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(6067),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [2191] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6069),
  },
  [2192] = {
    [sym_process_substitution] = STATE(2737),
    [aux_sym__literal_repeat1] = STATE(2739),
    [sym_array] = STATE(2738),
    [sym_simple_expansion] = STATE(2737),
    [sym_string_expansion] = STATE(2737),
    [sym_expansion] = STATE(2737),
    [sym_concatenation] = STATE(2738),
    [sym_string] = STATE(2737),
    [sym_command_substitution] = STATE(2737),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_BQUOTE] = ACTIONS(6057),
    [anon_sym_DQUOTE] = ACTIONS(4778),
    [sym_word] = ACTIONS(6073),
    [sym_raw_string] = ACTIONS(6073),
    [anon_sym_LT_LPAREN] = ACTIONS(6061),
    [anon_sym_DOLLAR] = ACTIONS(3524),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6063),
    [sym__special_character] = ACTIONS(6075),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6065),
    [sym__empty_value] = ACTIONS(6077),
  },
  [2193] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_done] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [2194] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_done] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [2195] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_done] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [2196] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(6051),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [2197] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6051),
  },
  [2198] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2742),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2742),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6079),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6081),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6083),
    [anon_sym_DASH] = ACTIONS(6081),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6085),
    [anon_sym_COLON_DASH] = ACTIONS(6081),
    [sym__special_character] = ACTIONS(599),
  },
  [2199] = {
    [sym_subscript] = STATE(2743),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_QMARK] = ACTIONS(6087),
    [anon_sym_AT] = ACTIONS(6087),
    [sym_variable_name] = ACTIONS(6089),
    [anon_sym_DOLLAR] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_0] = ACTIONS(6093),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6093),
  },
  [2200] = {
    [anon_sym_EQ] = ACTIONS(6095),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2201] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2749),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2749),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6097),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6099),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6101),
    [anon_sym_DASH] = ACTIONS(6099),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6099),
    [anon_sym_PERCENT] = ACTIONS(6099),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6103),
    [anon_sym_COLON_DASH] = ACTIONS(6099),
    [sym__special_character] = ACTIONS(599),
  },
  [2202] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2203] = {
    [aux_sym__literal_repeat1] = STATE(2203),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_done] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(6105),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [2204] = {
    [sym_process_substitution] = STATE(1626),
    [sym_string] = STATE(1626),
    [sym_command_substitution] = STATE(1626),
    [sym_simple_expansion] = STATE(1626),
    [sym_variable_assignment] = STATE(2204),
    [sym_subscript] = STATE(1635),
    [sym_string_expansion] = STATE(1626),
    [sym_expansion] = STATE(1626),
    [sym_concatenation] = STATE(2204),
    [aux_sym_declaration_command_repeat1] = STATE(2204),
    [aux_sym__literal_repeat1] = STATE(1633),
    [anon_sym_AMP_GT_GT] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(6108),
    [anon_sym_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_LPAREN] = ACTIONS(6111),
    [anon_sym_done] = ACTIONS(1320),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6117),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6120),
    [anon_sym_PIPE_PIPE] = ACTIONS(1320),
    [sym_word] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_AMP] = ACTIONS(1320),
    [anon_sym_LT] = ACTIONS(1320),
    [anon_sym_LT_AMP] = ACTIONS(1320),
    [anon_sym_GT_GT] = ACTIONS(1320),
    [sym__special_character] = ACTIONS(6126),
    [anon_sym_LT_LT_DASH] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(6129),
    [anon_sym_LF] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_raw_string] = ACTIONS(6123),
    [sym_variable_name] = ACTIONS(6132),
    [sym_file_descriptor] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1320),
    [anon_sym_AMP_GT] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(6135),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_AMP] = ACTIONS(1320),
    [anon_sym_LT_LPAREN] = ACTIONS(6111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1320),
    [anon_sym_SEMI_SEMI] = ACTIONS(1320),
    [anon_sym_PIPE_AMP] = ACTIONS(1320),
  },
  [2205] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(6138),
  },
  [2206] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(6140),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2207] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_done] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [2208] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(6142),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2209] = {
    [sym_process_substitution] = STATE(2753),
    [sym_string_expansion] = STATE(2753),
    [sym_expansion] = STATE(2753),
    [sym_simple_expansion] = STATE(2753),
    [sym_string] = STATE(2753),
    [sym_command_substitution] = STATE(2753),
    [anon_sym_BQUOTE] = ACTIONS(6144),
    [anon_sym_DQUOTE] = ACTIONS(4808),
    [sym_word] = ACTIONS(6146),
    [sym_raw_string] = ACTIONS(6146),
    [anon_sym_LT_LPAREN] = ACTIONS(6148),
    [anon_sym_DOLLAR] = ACTIONS(3544),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6150),
    [sym__special_character] = ACTIONS(6146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6152),
  },
  [2210] = {
    [aux_sym_concatenation_repeat1] = STATE(2755),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_done] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(6154),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [2211] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6156),
  },
  [2212] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_done] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [2213] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_done] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [2214] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_done] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [2215] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(6138),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [2216] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6138),
  },
  [2217] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2759),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2759),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6158),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6162),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6160),
    [anon_sym_PERCENT] = ACTIONS(6160),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6164),
    [anon_sym_COLON_DASH] = ACTIONS(6160),
    [sym__special_character] = ACTIONS(599),
  },
  [2218] = {
    [sym_subscript] = STATE(2760),
    [anon_sym_STAR] = ACTIONS(6166),
    [anon_sym_QMARK] = ACTIONS(6166),
    [anon_sym_AT] = ACTIONS(6166),
    [sym_variable_name] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_DASH] = ACTIONS(6170),
    [anon_sym_0] = ACTIONS(6172),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6172),
    [anon_sym__] = ACTIONS(6172),
  },
  [2219] = {
    [anon_sym_EQ] = ACTIONS(6174),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2220] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2766),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2766),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6176),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6178),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6180),
    [anon_sym_DASH] = ACTIONS(6178),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6178),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6178),
    [anon_sym_PERCENT] = ACTIONS(6178),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6182),
    [anon_sym_COLON_DASH] = ACTIONS(6178),
    [sym__special_character] = ACTIONS(599),
  },
  [2221] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2222] = {
    [aux_sym__literal_repeat1] = STATE(2222),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_done] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(6184),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [2223] = {
    [sym_process_substitution] = STATE(1638),
    [sym_command_substitution] = STATE(1638),
    [aux_sym_unset_command_repeat1] = STATE(2223),
    [sym_simple_expansion] = STATE(1638),
    [sym_string_expansion] = STATE(1638),
    [sym_expansion] = STATE(1638),
    [sym_concatenation] = STATE(2223),
    [sym_string] = STATE(1638),
    [aux_sym__literal_repeat1] = STATE(1644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1403),
    [anon_sym_DOLLAR] = ACTIONS(6187),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_LPAREN] = ACTIONS(6190),
    [anon_sym_done] = ACTIONS(1403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6196),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1403),
    [sym_word] = ACTIONS(6202),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_LT_AMP] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [sym__special_character] = ACTIONS(6205),
    [anon_sym_LT_LT_DASH] = ACTIONS(1403),
    [anon_sym_BQUOTE] = ACTIONS(6208),
    [anon_sym_LF] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(6202),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_AMP_GT] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(6211),
    [anon_sym_LT_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_AMP] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(6190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1403),
    [anon_sym_PIPE_AMP] = ACTIONS(1403),
  },
  [2224] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_done] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_EQ_TILDE] = ACTIONS(1434),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [2225] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_done] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_EQ_TILDE] = ACTIONS(1440),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [2226] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2769),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2769),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6214),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6214),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_PERCENT] = ACTIONS(6214),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6218),
    [anon_sym_COLON_DASH] = ACTIONS(6214),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6220),
  },
  [2227] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_done] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_EQ_TILDE] = ACTIONS(1476),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [2228] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2229] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2769),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2769),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6222),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6214),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6214),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6214),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_PERCENT] = ACTIONS(6214),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6218),
    [anon_sym_COLON_DASH] = ACTIONS(6214),
    [sym__special_character] = ACTIONS(599),
  },
  [2230] = {
    [anon_sym_EQ] = ACTIONS(6224),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2231] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2774),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2774),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6226),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6230),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6228),
    [anon_sym_PERCENT] = ACTIONS(6228),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6232),
    [anon_sym_COLON_DASH] = ACTIONS(6228),
    [sym__special_character] = ACTIONS(599),
  },
  [2232] = {
    [sym_process_substitution] = STATE(2775),
    [aux_sym__literal_repeat1] = STATE(2777),
    [sym_simple_expansion] = STATE(2775),
    [sym_string_expansion] = STATE(2775),
    [sym_expansion] = STATE(2775),
    [sym_concatenation] = STATE(2776),
    [sym_string] = STATE(2775),
    [sym_command_substitution] = STATE(2775),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6234),
    [sym_raw_string] = ACTIONS(6234),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2233] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2780),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2780),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6238),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6240),
    [anon_sym_COLON_DASH] = ACTIONS(6236),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6242),
  },
  [2234] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_done] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1532),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [2235] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6238),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2236] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2237] = {
    [sym_process_substitution] = STATE(2236),
    [sym_string_expansion] = STATE(2236),
    [sym_expansion] = STATE(2236),
    [sym_simple_expansion] = STATE(2236),
    [sym_string] = STATE(2236),
    [sym_command_substitution] = STATE(2236),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_word] = ACTIONS(4862),
    [sym_raw_string] = ACTIONS(4862),
    [anon_sym_LT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR] = ACTIONS(6244),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2143),
    [sym__special_character] = ACTIONS(4862),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2147),
  },
  [2238] = {
    [aux_sym_concatenation_repeat1] = STATE(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(6246),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2239] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(2783),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(2783),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(6249),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2240] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(2784),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2241] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(2787),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(6251),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2242] = {
    [aux_sym_concatenation_repeat1] = STATE(2789),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_done] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(6255),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2243] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2790),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2244] = {
    [sym_string] = STATE(2792),
    [anon_sym_DQUOTE] = ACTIONS(4870),
    [anon_sym_STAR] = ACTIONS(6257),
    [anon_sym_QMARK] = ACTIONS(6257),
    [sym_raw_string] = ACTIONS(6259),
    [anon_sym_AT] = ACTIONS(6257),
    [anon_sym_DOLLAR] = ACTIONS(6261),
    [anon_sym_POUND] = ACTIONS(6261),
    [anon_sym_DASH] = ACTIONS(6261),
    [anon_sym_0] = ACTIONS(6263),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6263),
    [anon_sym__] = ACTIONS(6263),
  },
  [2245] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(2794),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2795),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2246] = {
    [aux_sym_concatenation_repeat1] = STATE(2789),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(6255),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2247] = {
    [sym_subscript] = STATE(2796),
    [anon_sym_STAR] = ACTIONS(6265),
    [anon_sym_QMARK] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(6267),
    [anon_sym_AT] = ACTIONS(6265),
    [sym_variable_name] = ACTIONS(6269),
    [anon_sym_DOLLAR] = ACTIONS(6271),
    [anon_sym_DASH] = ACTIONS(6271),
    [anon_sym_0] = ACTIONS(6273),
    [anon_sym_POUND] = ACTIONS(6267),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6273),
    [anon_sym__] = ACTIONS(6273),
    [sym_comment] = ACTIONS(3),
  },
  [2248] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_done] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2249] = {
    [aux_sym__literal_repeat1] = STATE(2801),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_done] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(6275),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [2250] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_done] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2010),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [2251] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(6277),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2252] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1670),
    [sym_file_redirect] = STATE(1670),
    [sym_herestring_redirect] = STATE(1670),
    [sym_heredoc_redirect] = STATE(1670),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_done] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [2253] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1670),
    [sym_file_redirect] = STATE(1670),
    [sym_herestring_redirect] = STATE(1670),
    [sym_heredoc_redirect] = STATE(1670),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_done] = ACTIONS(2215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [2254] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(2803),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2255] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(2806),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(6279),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(6281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2256] = {
    [aux_sym_concatenation_repeat1] = STATE(2808),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_done] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym__concat] = ACTIONS(6283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [2257] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2809),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2258] = {
    [sym_string] = STATE(2811),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [anon_sym_STAR] = ACTIONS(6285),
    [anon_sym_QMARK] = ACTIONS(6285),
    [sym_raw_string] = ACTIONS(6287),
    [anon_sym_AT] = ACTIONS(6285),
    [anon_sym_DOLLAR] = ACTIONS(6289),
    [anon_sym_POUND] = ACTIONS(6289),
    [anon_sym_DASH] = ACTIONS(6289),
    [anon_sym_0] = ACTIONS(6291),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6291),
    [anon_sym__] = ACTIONS(6291),
  },
  [2259] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(2813),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(2814),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2260] = {
    [aux_sym_concatenation_repeat1] = STATE(2808),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym__concat] = ACTIONS(6283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2261] = {
    [sym_subscript] = STATE(2815),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_BANG] = ACTIONS(6295),
    [anon_sym_AT] = ACTIONS(6293),
    [sym_variable_name] = ACTIONS(6297),
    [anon_sym_DOLLAR] = ACTIONS(6299),
    [anon_sym_DASH] = ACTIONS(6299),
    [anon_sym_0] = ACTIONS(6301),
    [anon_sym_POUND] = ACTIONS(6295),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6301),
    [anon_sym__] = ACTIONS(6301),
    [sym_comment] = ACTIONS(3),
  },
  [2262] = {
    [aux_sym__literal_repeat1] = STATE(2819),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_done] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
  },
  [2263] = {
    [anon_sym_AMP] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_done] = ACTIONS(2261),
    [anon_sym_LF] = ACTIONS(6305),
    [anon_sym_SEMI] = ACTIONS(6303),
    [anon_sym_SEMI_SEMI] = ACTIONS(6303),
  },
  [2264] = {
    [sym_process_substitution] = STATE(2821),
    [aux_sym__literal_repeat1] = STATE(2822),
    [sym_simple_expansion] = STATE(2821),
    [sym_string_expansion] = STATE(2821),
    [sym_expansion] = STATE(2821),
    [sym_concatenation] = STATE(1142),
    [sym_string] = STATE(2821),
    [sym_command_substitution] = STATE(2821),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [sym_word] = ACTIONS(6307),
    [sym_raw_string] = ACTIONS(6307),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [sym__special_character] = ACTIONS(4902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
  },
  [2265] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1670),
    [sym_file_redirect] = STATE(1670),
    [sym_herestring_redirect] = STATE(1670),
    [sym_heredoc_redirect] = STATE(1670),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [sym_file_descriptor] = ACTIONS(2277),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_done] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(3604),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(3604),
  },
  [2266] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1670),
    [sym_file_redirect] = STATE(1670),
    [sym_herestring_redirect] = STATE(1670),
    [sym_heredoc_redirect] = STATE(1670),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_done] = ACTIONS(2275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(3604),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(3604),
  },
  [2267] = {
    [aux_sym_concatenation_repeat1] = STATE(2808),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_done] = ACTIONS(2279),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym__concat] = ACTIONS(6283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [2268] = {
    [aux_sym__literal_repeat1] = STATE(2819),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LT_LT] = ACTIONS(2283),
    [sym_file_descriptor] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_done] = ACTIONS(2283),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_LT_LT_LT] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_GT_AMP] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_LT_AMP] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
  },
  [2269] = {
    [aux_sym_redirected_statement_repeat1] = STATE(2269),
    [sym_file_redirect] = STATE(2269),
    [sym_herestring_redirect] = STATE(2269),
    [sym_heredoc_redirect] = STATE(2269),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_AMP_GT_GT] = ACTIONS(6309),
    [anon_sym_LF] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2287),
    [sym_file_descriptor] = ACTIONS(6312),
    [anon_sym_GT] = ACTIONS(6309),
    [anon_sym_done] = ACTIONS(2295),
    [anon_sym_AMP_GT] = ACTIONS(6309),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT_LT_LT] = ACTIONS(6315),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(6309),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_LT_AMP] = ACTIONS(6309),
    [anon_sym_GT_GT] = ACTIONS(6309),
    [anon_sym_AMP] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
  },
  [2270] = {
    [sym_process_substitution] = STATE(1673),
    [sym_command_substitution] = STATE(1673),
    [sym_simple_expansion] = STATE(1673),
    [sym_string_expansion] = STATE(1673),
    [sym_expansion] = STATE(1673),
    [aux_sym_command_repeat2] = STATE(2274),
    [sym_concatenation] = STATE(2274),
    [sym_string] = STATE(1673),
    [aux_sym__literal_repeat1] = STATE(1675),
    [anon_sym_AMP_GT_GT] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(2139),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(3610),
    [anon_sym_done] = ACTIONS(2303),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3614),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [sym_word] = ACTIONS(3616),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_LT_AMP] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_TILDE] = ACTIONS(3618),
    [sym__special_character] = ACTIONS(2151),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(3620),
    [anon_sym_LF] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [sym_raw_string] = ACTIONS(3616),
    [sym_file_descriptor] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3622),
    [anon_sym_LT_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_AMP] = ACTIONS(2303),
    [anon_sym_LT_LPAREN] = ACTIONS(3610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_SEMI_SEMI] = ACTIONS(2303),
    [anon_sym_PIPE_AMP] = ACTIONS(2303),
  },
  [2271] = {
    [aux_sym_concatenation_repeat1] = STATE(1657),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_done] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [sym__concat] = ACTIONS(3584),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [2272] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_done] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [2273] = {
    [aux_sym__literal_repeat1] = STATE(1680),
    [anon_sym_AMP_GT_GT] = ACTIONS(2311),
    [anon_sym_DOLLAR] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_LPAREN] = ACTIONS(2311),
    [anon_sym_done] = ACTIONS(2311),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [sym_word] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_LT_AMP] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(2311),
    [anon_sym_EQ_TILDE] = ACTIONS(2311),
    [sym__special_character] = ACTIONS(3624),
    [anon_sym_LT_LT_DASH] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [sym_raw_string] = ACTIONS(2311),
    [sym_file_descriptor] = ACTIONS(2313),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP_GT] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_LT_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_AMP] = ACTIONS(2311),
    [anon_sym_LT_LPAREN] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_SEMI_SEMI] = ACTIONS(2311),
    [anon_sym_PIPE_AMP] = ACTIONS(2311),
  },
  [2274] = {
    [sym_process_substitution] = STATE(1673),
    [sym_command_substitution] = STATE(1673),
    [sym_simple_expansion] = STATE(1673),
    [sym_string_expansion] = STATE(1673),
    [sym_expansion] = STATE(1673),
    [aux_sym_command_repeat2] = STATE(2274),
    [sym_concatenation] = STATE(2274),
    [sym_string] = STATE(1673),
    [aux_sym__literal_repeat1] = STATE(1675),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(6321),
    [anon_sym_done] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6327),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(6333),
    [sym__special_character] = ACTIONS(6336),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(6339),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(6330),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(6333),
    [anon_sym_DQUOTE] = ACTIONS(6342),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(6321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [2275] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_done] = ACTIONS(2261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [2276] = {
    [sym_heredoc_body] = STATE(2823),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_done] = ACTIONS(2261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [2277] = {
    [anon_sym_BANG_EQ] = ACTIONS(3832),
    [anon_sym_PLUS_EQ] = ACTIONS(3832),
    [sym_test_operator] = ACTIONS(3832),
    [anon_sym_PLUS_PLUS] = ACTIONS(3832),
    [anon_sym_RBRACK] = ACTIONS(3832),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_EQ] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3832),
    [anon_sym_PIPE_PIPE] = ACTIONS(3832),
    [anon_sym_GT_EQ] = ACTIONS(3832),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3832),
    [anon_sym_DASH_DASH] = ACTIONS(3832),
    [anon_sym_LT_EQ] = ACTIONS(3832),
    [anon_sym_AMP_AMP] = ACTIONS(3832),
    [anon_sym_DASH_EQ] = ACTIONS(3832),
  },
  [2278] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2279] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2825),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2825),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6347),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [anon_sym_DASH] = ACTIONS(6347),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6347),
    [anon_sym_PERCENT] = ACTIONS(6347),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6349),
    [anon_sym_COLON_DASH] = ACTIONS(6347),
    [sym__special_character] = ACTIONS(599),
  },
  [2280] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [sym__concat] = ACTIONS(2610),
  },
  [2281] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6345),
  },
  [2282] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6351),
  },
  [2283] = {
    [anon_sym_BANG_EQ] = ACTIONS(3881),
    [anon_sym_PLUS_EQ] = ACTIONS(3881),
    [sym_test_operator] = ACTIONS(3881),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_RBRACK] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_EQ_EQ] = ACTIONS(3881),
    [anon_sym_PIPE_PIPE] = ACTIONS(3881),
    [anon_sym_GT_EQ] = ACTIONS(3881),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3881),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_LT_EQ] = ACTIONS(3881),
    [anon_sym_AMP_AMP] = ACTIONS(3881),
    [anon_sym_DASH_EQ] = ACTIONS(3881),
  },
  [2284] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2828),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2828),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6353),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6355),
    [anon_sym_DASH] = ACTIONS(6353),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6353),
    [anon_sym_PERCENT] = ACTIONS(6353),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6357),
    [anon_sym_COLON_DASH] = ACTIONS(6353),
    [sym__special_character] = ACTIONS(599),
  },
  [2285] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6355),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2286] = {
    [anon_sym_BANG_EQ] = ACTIONS(3929),
    [anon_sym_PLUS_EQ] = ACTIONS(3929),
    [sym_test_operator] = ACTIONS(3929),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_RBRACK] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_DASH_EQ] = ACTIONS(3929),
  },
  [2287] = {
    [anon_sym_BANG_EQ] = ACTIONS(3948),
    [anon_sym_PLUS_EQ] = ACTIONS(3948),
    [sym_test_operator] = ACTIONS(3948),
    [anon_sym_PLUS_PLUS] = ACTIONS(3948),
    [anon_sym_RBRACK] = ACTIONS(3948),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3948),
    [anon_sym_PIPE_PIPE] = ACTIONS(3948),
    [anon_sym_GT_EQ] = ACTIONS(3948),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3948),
    [anon_sym_DASH_DASH] = ACTIONS(3948),
    [anon_sym_LT_EQ] = ACTIONS(3948),
    [anon_sym_AMP_AMP] = ACTIONS(3948),
    [anon_sym_DASH_EQ] = ACTIONS(3948),
  },
  [2288] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6359),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2289] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_esac] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_fi] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [ts_builtin_sym_end] = ACTIONS(3423),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_elif] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [2290] = {
    [sym_string] = STATE(1124),
    [anon_sym__] = ACTIONS(2231),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(6361),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(6361),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2231),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(6363),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_RPAREN] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [ts_builtin_sym_end] = ACTIONS(2662),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(6365),
    [anon_sym_AT] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6361),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [2291] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_esac] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [ts_builtin_sym_end] = ACTIONS(2508),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_elif] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [2292] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2831),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2831),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6367),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6369),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6367),
    [anon_sym_PERCENT] = ACTIONS(6367),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6371),
    [anon_sym_COLON_DASH] = ACTIONS(6367),
    [sym__special_character] = ACTIONS(599),
  },
  [2293] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6369),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2294] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2831),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2831),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6367),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6369),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6367),
    [anon_sym_PERCENT] = ACTIONS(6367),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6371),
    [anon_sym_COLON_DASH] = ACTIONS(6367),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6373),
  },
  [2295] = {
    [sym_process_substitution] = STATE(2833),
    [aux_sym__literal_repeat1] = STATE(2835),
    [sym_simple_expansion] = STATE(2833),
    [sym_string_expansion] = STATE(2833),
    [sym_expansion] = STATE(2833),
    [sym_concatenation] = STATE(2834),
    [sym_string] = STATE(2833),
    [sym_command_substitution] = STATE(2833),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6375),
    [sym_raw_string] = ACTIONS(6375),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6369),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2296] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2838),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2838),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6377),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6379),
    [anon_sym_DASH] = ACTIONS(6377),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6377),
    [anon_sym_PERCENT] = ACTIONS(6377),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6381),
    [anon_sym_COLON_DASH] = ACTIONS(6377),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6383),
  },
  [2297] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_esac] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2602),
    [anon_sym_else] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [ts_builtin_sym_end] = ACTIONS(2604),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_elif] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [2298] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6379),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2299] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6369),
    [sym__concat] = ACTIONS(2610),
  },
  [2300] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6369),
  },
  [2301] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6385),
  },
  [2302] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_esac] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_fi] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [ts_builtin_sym_end] = ACTIONS(2646),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_elif] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [2303] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2841),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2841),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6387),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6389),
    [anon_sym_DASH] = ACTIONS(6387),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6387),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6387),
    [anon_sym_PERCENT] = ACTIONS(6387),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6391),
    [anon_sym_COLON_DASH] = ACTIONS(6387),
    [sym__special_character] = ACTIONS(599),
  },
  [2304] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6389),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2305] = {
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1442),
    [sym__heredoc_body_end] = ACTIONS(1442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1442),
    [sym__heredoc_body_middle] = ACTIONS(1442),
  },
  [2306] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2844),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2844),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6395),
    [anon_sym_DASH] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6393),
    [anon_sym_PERCENT] = ACTIONS(6393),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6397),
    [anon_sym_COLON_DASH] = ACTIONS(6393),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6399),
  },
  [2307] = {
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1478),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1478),
    [sym__heredoc_body_end] = ACTIONS(1478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1478),
    [sym__heredoc_body_middle] = ACTIONS(1478),
  },
  [2308] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6395),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2309] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2844),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2844),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6401),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6393),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6395),
    [anon_sym_DASH] = ACTIONS(6393),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6393),
    [anon_sym_PERCENT] = ACTIONS(6393),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6397),
    [anon_sym_COLON_DASH] = ACTIONS(6393),
    [sym__special_character] = ACTIONS(599),
  },
  [2310] = {
    [anon_sym_EQ] = ACTIONS(6403),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2311] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2849),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2849),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6405),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6407),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6409),
    [anon_sym_DASH] = ACTIONS(6407),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6407),
    [anon_sym_PERCENT] = ACTIONS(6407),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6411),
    [anon_sym_COLON_DASH] = ACTIONS(6407),
    [sym__special_character] = ACTIONS(599),
  },
  [2312] = {
    [sym_process_substitution] = STATE(2850),
    [aux_sym__literal_repeat1] = STATE(2852),
    [sym_simple_expansion] = STATE(2850),
    [sym_string_expansion] = STATE(2850),
    [sym_expansion] = STATE(2850),
    [sym_concatenation] = STATE(2851),
    [sym_string] = STATE(2850),
    [sym_command_substitution] = STATE(2850),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6413),
    [sym_raw_string] = ACTIONS(6413),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6395),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2313] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2855),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2855),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6415),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6417),
    [anon_sym_DASH] = ACTIONS(6415),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6415),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6415),
    [anon_sym_PERCENT] = ACTIONS(6415),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6419),
    [anon_sym_COLON_DASH] = ACTIONS(6415),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6421),
  },
  [2314] = {
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [sym__heredoc_body_end] = ACTIONS(1534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1534),
    [sym__heredoc_body_middle] = ACTIONS(1534),
  },
  [2315] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6417),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2316] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [2317] = {
    [anon_sym_BQUOTE] = ACTIONS(5097),
    [anon_sym_AMP_GT_GT] = ACTIONS(5097),
    [sym_raw_string] = ACTIONS(5097),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [sym_variable_name] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5097),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5097),
    [anon_sym_GT_LPAREN] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5097),
    [anon_sym_DQUOTE] = ACTIONS(5097),
    [sym_word] = ACTIONS(5097),
    [anon_sym_GT_AMP] = ACTIONS(5097),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5097),
    [anon_sym_GT_GT] = ACTIONS(5097),
    [anon_sym_LT_LPAREN] = ACTIONS(5097),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(5097),
  },
  [2318] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6423),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2319] = {
    [anon_sym_BQUOTE] = ACTIONS(5131),
    [anon_sym_AMP_GT_GT] = ACTIONS(5131),
    [sym_raw_string] = ACTIONS(5131),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [sym_variable_name] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5131),
    [anon_sym_GT_LPAREN] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5131),
    [anon_sym_DQUOTE] = ACTIONS(5131),
    [sym_word] = ACTIONS(5131),
    [anon_sym_GT_AMP] = ACTIONS(5131),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5131),
    [anon_sym_GT_GT] = ACTIONS(5131),
    [anon_sym_LT_LPAREN] = ACTIONS(5131),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(5131),
  },
  [2320] = {
    [anon_sym_BQUOTE] = ACTIONS(5135),
    [anon_sym_AMP_GT_GT] = ACTIONS(5135),
    [sym_raw_string] = ACTIONS(5135),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [sym_variable_name] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5135),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5135),
    [anon_sym_GT_LPAREN] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5135),
    [anon_sym_DQUOTE] = ACTIONS(5135),
    [sym_word] = ACTIONS(5135),
    [anon_sym_GT_AMP] = ACTIONS(5135),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5135),
    [anon_sym_GT_GT] = ACTIONS(5135),
    [anon_sym_LT_LPAREN] = ACTIONS(5135),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(5135),
  },
  [2321] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6425),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2322] = {
    [anon_sym_BQUOTE] = ACTIONS(5186),
    [anon_sym_AMP_GT_GT] = ACTIONS(5186),
    [sym_raw_string] = ACTIONS(5186),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [sym_variable_name] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5186),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5186),
    [anon_sym_GT_LPAREN] = ACTIONS(5186),
    [anon_sym_RPAREN] = ACTIONS(5186),
    [anon_sym_DQUOTE] = ACTIONS(5186),
    [sym_word] = ACTIONS(5186),
    [anon_sym_GT_AMP] = ACTIONS(5186),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5186),
    [anon_sym_GT_GT] = ACTIONS(5186),
    [anon_sym_LT_LPAREN] = ACTIONS(5186),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(5186),
  },
  [2323] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [ts_builtin_sym_end] = ACTIONS(5097),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [2324] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6427),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2325] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [ts_builtin_sym_end] = ACTIONS(5131),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [2326] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [ts_builtin_sym_end] = ACTIONS(5135),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [2327] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6429),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2328] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_RPAREN] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [ts_builtin_sym_end] = ACTIONS(5186),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [2329] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [ts_builtin_sym_end] = ACTIONS(5097),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [2330] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6431),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2331] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [ts_builtin_sym_end] = ACTIONS(5131),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [2332] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [ts_builtin_sym_end] = ACTIONS(5135),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [2333] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6433),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2334] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_RPAREN] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [ts_builtin_sym_end] = ACTIONS(5186),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [2335] = {
    [anon_sym_BQUOTE] = ACTIONS(3832),
    [sym_raw_string] = ACTIONS(3832),
    [anon_sym_COLON_QMARK] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_RBRACE] = ACTIONS(3832),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3832),
    [anon_sym_EQ] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3832),
    [anon_sym_PERCENT] = ACTIONS(3830),
    [anon_sym_COLON] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3832),
    [anon_sym_DQUOTE] = ACTIONS(3832),
    [sym_word] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_LT_LPAREN] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3832),
    [anon_sym_COLON_DASH] = ACTIONS(3830),
    [sym__special_character] = ACTIONS(3830),
  },
  [2336] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2337] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2863),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2863),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6437),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6435),
    [anon_sym_DASH] = ACTIONS(6437),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6437),
    [anon_sym_PERCENT] = ACTIONS(6437),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6439),
    [anon_sym_COLON_DASH] = ACTIONS(6437),
    [sym__special_character] = ACTIONS(599),
  },
  [2338] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6435),
    [sym__concat] = ACTIONS(2610),
  },
  [2339] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6435),
  },
  [2340] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6441),
  },
  [2341] = {
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [sym_raw_string] = ACTIONS(3881),
    [anon_sym_COLON_QMARK] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3881),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3881),
    [anon_sym_PERCENT] = ACTIONS(3879),
    [anon_sym_COLON] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [sym_word] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_LT_LPAREN] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3881),
    [anon_sym_COLON_DASH] = ACTIONS(3879),
    [sym__special_character] = ACTIONS(3879),
  },
  [2342] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2866),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2866),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6443),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_DASH] = ACTIONS(6443),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6443),
    [anon_sym_PERCENT] = ACTIONS(6443),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6447),
    [anon_sym_COLON_DASH] = ACTIONS(6443),
    [sym__special_character] = ACTIONS(599),
  },
  [2343] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6445),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2344] = {
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [sym_raw_string] = ACTIONS(3929),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [sym_word] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3929),
    [anon_sym_COLON_DASH] = ACTIONS(3927),
    [sym__special_character] = ACTIONS(3927),
  },
  [2345] = {
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [anon_sym_COLON_QMARK] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_RBRACE] = ACTIONS(3948),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [anon_sym_EQ] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [anon_sym_PERCENT] = ACTIONS(3946),
    [anon_sym_COLON] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [sym_word] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3948),
    [anon_sym_COLON_DASH] = ACTIONS(3946),
    [sym__special_character] = ACTIONS(3946),
  },
  [2346] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6449),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2347] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_EQ_TILDE] = ACTIONS(6451),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_RPAREN] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_EQ_EQ] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [ts_builtin_sym_end] = ACTIONS(6453),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [2348] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_EQ_TILDE] = ACTIONS(6455),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_RPAREN] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [ts_builtin_sym_end] = ACTIONS(6457),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [2349] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [sym__concat] = ACTIONS(3423),
  },
  [2350] = {
    [sym_string] = STATE(1242),
    [anon_sym_STAR] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [anon_sym_QMARK] = ACTIONS(2612),
    [sym_raw_string] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_POUND] = ACTIONS(2616),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_DASH] = ACTIONS(2616),
    [anon_sym_0] = ACTIONS(2618),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2618),
    [anon_sym__] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
  },
  [2351] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [sym__concat] = ACTIONS(2508),
  },
  [2352] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2869),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2869),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6459),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6461),
    [anon_sym_DASH] = ACTIONS(6459),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6459),
    [anon_sym_PERCENT] = ACTIONS(6459),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6463),
    [anon_sym_COLON_DASH] = ACTIONS(6459),
    [sym__special_character] = ACTIONS(599),
  },
  [2353] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6461),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2354] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2869),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2869),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6459),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6461),
    [anon_sym_DASH] = ACTIONS(6459),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6459),
    [anon_sym_PERCENT] = ACTIONS(6459),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6463),
    [anon_sym_COLON_DASH] = ACTIONS(6459),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6465),
  },
  [2355] = {
    [sym_process_substitution] = STATE(2871),
    [aux_sym__literal_repeat1] = STATE(2873),
    [sym_simple_expansion] = STATE(2871),
    [sym_string_expansion] = STATE(2871),
    [sym_expansion] = STATE(2871),
    [sym_concatenation] = STATE(2872),
    [sym_string] = STATE(2871),
    [sym_command_substitution] = STATE(2871),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6467),
    [sym_raw_string] = ACTIONS(6467),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6461),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2356] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2876),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2876),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6469),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6471),
    [anon_sym_DASH] = ACTIONS(6469),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6469),
    [anon_sym_PERCENT] = ACTIONS(6469),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6473),
    [anon_sym_COLON_DASH] = ACTIONS(6469),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6475),
  },
  [2357] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2604),
    [sym__concat] = ACTIONS(2604),
  },
  [2358] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6471),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2359] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6461),
    [sym__concat] = ACTIONS(2610),
  },
  [2360] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6461),
  },
  [2361] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6477),
  },
  [2362] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [sym__concat] = ACTIONS(2646),
  },
  [2363] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2879),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2879),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6479),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6481),
    [anon_sym_DASH] = ACTIONS(6479),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6479),
    [anon_sym_PERCENT] = ACTIONS(6479),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6483),
    [anon_sym_COLON_DASH] = ACTIONS(6479),
    [sym__special_character] = ACTIONS(599),
  },
  [2364] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6481),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2365] = {
    [anon_sym_BQUOTE] = ACTIONS(5952),
    [anon_sym_SLASH] = ACTIONS(5952),
    [sym_raw_string] = ACTIONS(5952),
    [anon_sym_COLON_QMARK] = ACTIONS(6485),
    [anon_sym_DOLLAR] = ACTIONS(6485),
    [anon_sym_RBRACE] = ACTIONS(5952),
    [anon_sym_DASH] = ACTIONS(6485),
    [anon_sym_EQ] = ACTIONS(6485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(6485),
    [anon_sym_COLON] = ACTIONS(6485),
    [anon_sym_GT_LPAREN] = ACTIONS(5952),
    [anon_sym_DQUOTE] = ACTIONS(5952),
    [sym_word] = ACTIONS(6485),
    [anon_sym_LT_LPAREN] = ACTIONS(5952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5952),
    [anon_sym_COLON_DASH] = ACTIONS(6485),
    [sym__special_character] = ACTIONS(6485),
  },
  [2366] = {
    [anon_sym_BQUOTE] = ACTIONS(5954),
    [anon_sym_SLASH] = ACTIONS(5954),
    [sym_raw_string] = ACTIONS(5954),
    [anon_sym_COLON_QMARK] = ACTIONS(6487),
    [anon_sym_DOLLAR] = ACTIONS(6487),
    [anon_sym_RBRACE] = ACTIONS(5954),
    [anon_sym_DASH] = ACTIONS(6487),
    [anon_sym_EQ] = ACTIONS(6487),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5954),
    [anon_sym_PERCENT] = ACTIONS(6487),
    [anon_sym_COLON] = ACTIONS(6487),
    [anon_sym_GT_LPAREN] = ACTIONS(5954),
    [anon_sym_DQUOTE] = ACTIONS(5954),
    [sym_word] = ACTIONS(6487),
    [anon_sym_LT_LPAREN] = ACTIONS(5954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5954),
    [anon_sym_COLON_DASH] = ACTIONS(6487),
    [sym__special_character] = ACTIONS(6487),
  },
  [2367] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [2368] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [2369] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6489),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2370] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2881),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2881),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6491),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6489),
    [anon_sym_DASH] = ACTIONS(6491),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6491),
    [anon_sym_PERCENT] = ACTIONS(6491),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6493),
    [anon_sym_COLON_DASH] = ACTIONS(6491),
    [sym__special_character] = ACTIONS(599),
  },
  [2371] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6489),
    [sym__concat] = ACTIONS(2610),
  },
  [2372] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6489),
  },
  [2373] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6495),
  },
  [2374] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [2375] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2884),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2884),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6497),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6499),
    [anon_sym_DASH] = ACTIONS(6497),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6497),
    [anon_sym_PERCENT] = ACTIONS(6497),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6501),
    [anon_sym_COLON_DASH] = ACTIONS(6497),
    [sym__special_character] = ACTIONS(599),
  },
  [2376] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6499),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2377] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [2378] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [2379] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6503),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2380] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [2381] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6505),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2382] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2887),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2887),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6507),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6505),
    [anon_sym_DASH] = ACTIONS(6507),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6507),
    [anon_sym_PERCENT] = ACTIONS(6507),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6509),
    [anon_sym_COLON_DASH] = ACTIONS(6507),
    [sym__special_character] = ACTIONS(599),
  },
  [2383] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6505),
    [sym__concat] = ACTIONS(2610),
  },
  [2384] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6505),
  },
  [2385] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6511),
  },
  [2386] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [2387] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2890),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2890),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6513),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6515),
    [anon_sym_DASH] = ACTIONS(6513),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6513),
    [anon_sym_PERCENT] = ACTIONS(6513),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6517),
    [anon_sym_COLON_DASH] = ACTIONS(6513),
    [sym__special_character] = ACTIONS(599),
  },
  [2388] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6515),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2389] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [2390] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [2391] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6519),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2392] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_EQ_TILDE] = ACTIONS(5095),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_EQ_EQ] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [2393] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2394] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [2395] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5133),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_EQ_EQ] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [2396] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6523),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2397] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_EQ_TILDE] = ACTIONS(5184),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_RBRACE] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_EQ_EQ] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [2398] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5742),
    [anon_sym_AMP_GT_GT] = ACTIONS(5742),
    [anon_sym_LF] = ACTIONS(5744),
    [anon_sym_SEMI] = ACTIONS(5742),
    [anon_sym_LT_LT] = ACTIONS(5742),
    [anon_sym_RBRACE] = ACTIONS(5742),
    [anon_sym_GT] = ACTIONS(5742),
    [sym_file_descriptor] = ACTIONS(5744),
    [anon_sym_AMP_GT] = ACTIONS(5742),
    [anon_sym_PIPE_PIPE] = ACTIONS(5742),
    [anon_sym_LT_LT_LT] = ACTIONS(5742),
    [anon_sym_PIPE] = ACTIONS(5742),
    [anon_sym_GT_AMP] = ACTIONS(5742),
    [anon_sym_LT] = ACTIONS(5742),
    [anon_sym_LT_AMP] = ACTIONS(5742),
    [anon_sym_GT_GT] = ACTIONS(5742),
    [anon_sym_AMP] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5742),
    [anon_sym_SEMI_SEMI] = ACTIONS(5742),
    [anon_sym_PIPE_AMP] = ACTIONS(5742),
  },
  [2399] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(6525),
  },
  [2400] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5775),
    [anon_sym_AMP_GT_GT] = ACTIONS(5775),
    [anon_sym_LF] = ACTIONS(5777),
    [anon_sym_SEMI] = ACTIONS(5775),
    [anon_sym_LT_LT] = ACTIONS(5775),
    [anon_sym_RBRACE] = ACTIONS(5775),
    [anon_sym_GT] = ACTIONS(5775),
    [sym_file_descriptor] = ACTIONS(5777),
    [anon_sym_AMP_GT] = ACTIONS(5775),
    [anon_sym_PIPE_PIPE] = ACTIONS(5775),
    [anon_sym_LT_LT_LT] = ACTIONS(5775),
    [anon_sym_PIPE] = ACTIONS(5775),
    [anon_sym_GT_AMP] = ACTIONS(5775),
    [anon_sym_LT] = ACTIONS(5775),
    [anon_sym_LT_AMP] = ACTIONS(5775),
    [anon_sym_GT_GT] = ACTIONS(5775),
    [anon_sym_AMP] = ACTIONS(5775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5775),
    [anon_sym_SEMI_SEMI] = ACTIONS(5775),
    [anon_sym_PIPE_AMP] = ACTIONS(5775),
  },
  [2401] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(6527),
  },
  [2402] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2896),
    [sym_case_item] = STATE(2067),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2067),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3178),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [2403] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5861),
    [anon_sym_AMP_GT_GT] = ACTIONS(5861),
    [anon_sym_LF] = ACTIONS(5863),
    [anon_sym_SEMI] = ACTIONS(5861),
    [anon_sym_LT_LT] = ACTIONS(5861),
    [anon_sym_RBRACE] = ACTIONS(5861),
    [anon_sym_GT] = ACTIONS(5861),
    [sym_file_descriptor] = ACTIONS(5863),
    [anon_sym_AMP_GT] = ACTIONS(5861),
    [anon_sym_PIPE_PIPE] = ACTIONS(5861),
    [anon_sym_LT_LT_LT] = ACTIONS(5861),
    [anon_sym_PIPE] = ACTIONS(5861),
    [anon_sym_GT_AMP] = ACTIONS(5861),
    [anon_sym_LT] = ACTIONS(5861),
    [anon_sym_LT_AMP] = ACTIONS(5861),
    [anon_sym_GT_GT] = ACTIONS(5861),
    [anon_sym_AMP] = ACTIONS(5861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5861),
    [anon_sym_SEMI_SEMI] = ACTIONS(5861),
    [anon_sym_PIPE_AMP] = ACTIONS(5861),
  },
  [2404] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(6529),
  },
  [2405] = {
    [sym_process_substitution] = STATE(1472),
    [sym_last_case_item] = STATE(2898),
    [sym_case_item] = STATE(2067),
    [sym_command_substitution] = STATE(1472),
    [sym_simple_expansion] = STATE(1472),
    [aux_sym_case_statement_repeat1] = STATE(2067),
    [sym_string_expansion] = STATE(1472),
    [sym_expansion] = STATE(1472),
    [sym_concatenation] = STATE(1478),
    [sym_string] = STATE(1472),
    [aux_sym__literal_repeat1] = STATE(1475),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(3178),
    [sym_raw_string] = ACTIONS(3178),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [sym__special_character] = ACTIONS(3182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
  },
  [2406] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [2407] = {
    [sym_string] = STATE(1334),
    [anon_sym__] = ACTIONS(2894),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(6531),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(6531),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2894),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2894),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(6533),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_0] = ACTIONS(2894),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(6535),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6531),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [2408] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [2409] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2900),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2900),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6537),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6539),
    [anon_sym_DASH] = ACTIONS(6537),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6537),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6537),
    [anon_sym_PERCENT] = ACTIONS(6537),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6541),
    [anon_sym_COLON_DASH] = ACTIONS(6537),
    [sym__special_character] = ACTIONS(599),
  },
  [2410] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6539),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2411] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2900),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2900),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6537),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6539),
    [anon_sym_DASH] = ACTIONS(6537),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6537),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6537),
    [anon_sym_PERCENT] = ACTIONS(6537),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6541),
    [anon_sym_COLON_DASH] = ACTIONS(6537),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6543),
  },
  [2412] = {
    [sym_process_substitution] = STATE(2902),
    [aux_sym__literal_repeat1] = STATE(2904),
    [sym_simple_expansion] = STATE(2902),
    [sym_string_expansion] = STATE(2902),
    [sym_expansion] = STATE(2902),
    [sym_concatenation] = STATE(2903),
    [sym_string] = STATE(2902),
    [sym_command_substitution] = STATE(2902),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6545),
    [sym_raw_string] = ACTIONS(6545),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6539),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2413] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2907),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2907),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6547),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6547),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6547),
    [anon_sym_PERCENT] = ACTIONS(6547),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6551),
    [anon_sym_COLON_DASH] = ACTIONS(6547),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6553),
  },
  [2414] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [2415] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2416] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6539),
    [sym__concat] = ACTIONS(2610),
  },
  [2417] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6539),
  },
  [2418] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6555),
  },
  [2419] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [2420] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2910),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2910),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6557),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6559),
    [anon_sym_DASH] = ACTIONS(6557),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6557),
    [anon_sym_PERCENT] = ACTIONS(6557),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6561),
    [anon_sym_COLON_DASH] = ACTIONS(6557),
    [sym__special_character] = ACTIONS(599),
  },
  [2421] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6559),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2422] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6009),
    [anon_sym_AMP_GT_GT] = ACTIONS(6009),
    [anon_sym_LF] = ACTIONS(6011),
    [anon_sym_SEMI] = ACTIONS(6009),
    [anon_sym_LT_LT] = ACTIONS(6009),
    [anon_sym_RBRACE] = ACTIONS(6009),
    [anon_sym_GT] = ACTIONS(6009),
    [sym_file_descriptor] = ACTIONS(6011),
    [anon_sym_AMP_GT] = ACTIONS(6009),
    [anon_sym_PIPE_PIPE] = ACTIONS(6009),
    [anon_sym_LT_LT_LT] = ACTIONS(6009),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_GT_AMP] = ACTIONS(6009),
    [anon_sym_LT] = ACTIONS(6009),
    [anon_sym_LT_AMP] = ACTIONS(6009),
    [anon_sym_GT_GT] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6009),
    [anon_sym_SEMI_SEMI] = ACTIONS(6009),
    [anon_sym_PIPE_AMP] = ACTIONS(6009),
  },
  [2423] = {
    [sym_do_group] = STATE(2911),
    [sym_compound_statement] = STATE(2911),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(1703),
  },
  [2424] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6017),
    [anon_sym_AMP_GT_GT] = ACTIONS(6017),
    [anon_sym_LF] = ACTIONS(6019),
    [anon_sym_SEMI] = ACTIONS(6017),
    [anon_sym_LT_LT] = ACTIONS(6017),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6017),
    [sym_file_descriptor] = ACTIONS(6019),
    [anon_sym_AMP_GT] = ACTIONS(6017),
    [anon_sym_PIPE_PIPE] = ACTIONS(6017),
    [anon_sym_LT_LT_LT] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6017),
    [anon_sym_GT_AMP] = ACTIONS(6017),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_AMP] = ACTIONS(6017),
    [anon_sym_GT_GT] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6017),
    [anon_sym_SEMI_SEMI] = ACTIONS(6017),
    [anon_sym_PIPE_AMP] = ACTIONS(6017),
  },
  [2425] = {
    [sym_do_group] = STATE(2911),
    [sym_compound_statement] = STATE(2911),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(6563),
    [anon_sym_do] = ACTIONS(1703),
  },
  [2426] = {
    [anon_sym_BANG_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [sym_test_operator] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6565),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_GT_EQ] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_DASH_EQ] = ACTIONS(869),
  },
  [2427] = {
    [sym_process_substitution] = STATE(160),
    [sym_postfix_expression] = STATE(2914),
    [sym_parenthesized_expression] = STATE(2914),
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym__expression] = STATE(2914),
    [sym_string_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_binary_expression] = STATE(2914),
    [sym_unary_expression] = STATE(2914),
    [sym_concatenation] = STATE(2914),
    [sym_string] = STATE(160),
    [aux_sym__literal_repeat1] = STATE(167),
    [sym_test_operator] = ACTIONS(253),
    [anon_sym_LPAREN] = ACTIONS(255),
    [anon_sym_BQUOTE] = ACTIONS(263),
    [sym_raw_string] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [anon_sym_GT_LPAREN] = ACTIONS(267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(275),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6565),
    [anon_sym_DQUOTE] = ACTIONS(257),
    [sym_word] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(267),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(273),
  },
  [2428] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [2429] = {
    [sym_string] = STATE(1360),
    [anon_sym__] = ACTIONS(2928),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(6567),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(6567),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2928),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2928),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2928),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(6569),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_0] = ACTIONS(2928),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(6571),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6567),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [2430] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [2431] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2916),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2916),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6573),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6575),
    [anon_sym_DASH] = ACTIONS(6573),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6573),
    [anon_sym_PERCENT] = ACTIONS(6573),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6577),
    [anon_sym_COLON_DASH] = ACTIONS(6573),
    [sym__special_character] = ACTIONS(599),
  },
  [2432] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6575),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2433] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2916),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2916),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6573),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6575),
    [anon_sym_DASH] = ACTIONS(6573),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6573),
    [anon_sym_PERCENT] = ACTIONS(6573),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6577),
    [anon_sym_COLON_DASH] = ACTIONS(6573),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6579),
  },
  [2434] = {
    [sym_process_substitution] = STATE(2918),
    [aux_sym__literal_repeat1] = STATE(2920),
    [sym_simple_expansion] = STATE(2918),
    [sym_string_expansion] = STATE(2918),
    [sym_expansion] = STATE(2918),
    [sym_concatenation] = STATE(2919),
    [sym_string] = STATE(2918),
    [sym_command_substitution] = STATE(2918),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6581),
    [sym_raw_string] = ACTIONS(6581),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6575),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2435] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2923),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2923),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6585),
    [anon_sym_DASH] = ACTIONS(6583),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6583),
    [anon_sym_PERCENT] = ACTIONS(6583),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6587),
    [anon_sym_COLON_DASH] = ACTIONS(6583),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6589),
  },
  [2436] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [2437] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6585),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2438] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6575),
    [sym__concat] = ACTIONS(2610),
  },
  [2439] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6575),
  },
  [2440] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6591),
  },
  [2441] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [2442] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2926),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2926),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6593),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6595),
    [anon_sym_DASH] = ACTIONS(6593),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6593),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6597),
    [anon_sym_COLON_DASH] = ACTIONS(6593),
    [sym__special_character] = ACTIONS(599),
  },
  [2443] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6595),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2444] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_fi] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [anon_sym_elif] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [2445] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_fi] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_else] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [anon_sym_elif] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [2446] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(6599),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2447] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2448] = {
    [sym_process_substitution] = STATE(2447),
    [sym_string_expansion] = STATE(2447),
    [sym_expansion] = STATE(2447),
    [sym_simple_expansion] = STATE(2447),
    [sym_string] = STATE(2447),
    [sym_command_substitution] = STATE(2447),
    [anon_sym_BQUOTE] = ACTIONS(5362),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [sym_word] = ACTIONS(5364),
    [sym_raw_string] = ACTIONS(5364),
    [anon_sym_LT_LPAREN] = ACTIONS(5366),
    [anon_sym_DOLLAR] = ACTIONS(6601),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5366),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5368),
    [sym__special_character] = ACTIONS(5364),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5370),
  },
  [2449] = {
    [aux_sym_concatenation_repeat1] = STATE(2449),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(6603),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2450] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_fi] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_elif] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [2451] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(2930),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(2930),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(6606),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2452] = {
    [aux_sym_concatenation_repeat1] = STATE(1917),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_fi] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_else] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(4180),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_elif] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2453] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_fi] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_else] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_elif] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2454] = {
    [aux_sym__literal_repeat1] = STATE(1930),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_fi] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(4204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_elif] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [2455] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2933),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2933),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6610),
    [anon_sym_DASH] = ACTIONS(6608),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6608),
    [anon_sym_PERCENT] = ACTIONS(6608),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6612),
    [anon_sym_COLON_DASH] = ACTIONS(6608),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6614),
  },
  [2456] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_fi] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [anon_sym_elif] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [2457] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6610),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2458] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2933),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2933),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6616),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6610),
    [anon_sym_DASH] = ACTIONS(6608),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6608),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6608),
    [anon_sym_PERCENT] = ACTIONS(6608),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6612),
    [anon_sym_COLON_DASH] = ACTIONS(6608),
    [sym__special_character] = ACTIONS(599),
  },
  [2459] = {
    [anon_sym_EQ] = ACTIONS(6618),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2460] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2938),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2938),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6620),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6622),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6624),
    [anon_sym_DASH] = ACTIONS(6622),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6622),
    [anon_sym_PERCENT] = ACTIONS(6622),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6626),
    [anon_sym_COLON_DASH] = ACTIONS(6622),
    [sym__special_character] = ACTIONS(599),
  },
  [2461] = {
    [sym_process_substitution] = STATE(2939),
    [aux_sym__literal_repeat1] = STATE(2941),
    [sym_simple_expansion] = STATE(2939),
    [sym_string_expansion] = STATE(2939),
    [sym_expansion] = STATE(2939),
    [sym_concatenation] = STATE(2940),
    [sym_string] = STATE(2939),
    [sym_command_substitution] = STATE(2939),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6628),
    [sym_raw_string] = ACTIONS(6628),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6610),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2462] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2944),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2944),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6630),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6630),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6630),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6630),
    [anon_sym_PERCENT] = ACTIONS(6630),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6634),
    [anon_sym_COLON_DASH] = ACTIONS(6630),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6636),
  },
  [2463] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_fi] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_elif] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [2464] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2465] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_fi] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [anon_sym_elif] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [2466] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_fi] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_else] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [anon_sym_elif] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [2467] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(6638),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2468] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2469] = {
    [sym_process_substitution] = STATE(2468),
    [sym_string_expansion] = STATE(2468),
    [sym_expansion] = STATE(2468),
    [sym_simple_expansion] = STATE(2468),
    [sym_string] = STATE(2468),
    [sym_command_substitution] = STATE(2468),
    [anon_sym_BQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(4214),
    [sym_word] = ACTIONS(5451),
    [sym_raw_string] = ACTIONS(5451),
    [anon_sym_LT_LPAREN] = ACTIONS(5453),
    [anon_sym_DOLLAR] = ACTIONS(6640),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5455),
    [sym__special_character] = ACTIONS(5451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5457),
  },
  [2470] = {
    [aux_sym_concatenation_repeat1] = STATE(2470),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(6642),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2471] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_fi] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_elif] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [2472] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2949),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2949),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6645),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6647),
    [anon_sym_DASH] = ACTIONS(6645),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6645),
    [anon_sym_PERCENT] = ACTIONS(6645),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6649),
    [anon_sym_COLON_DASH] = ACTIONS(6645),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6651),
  },
  [2473] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_fi] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [anon_sym_elif] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [2474] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6647),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2475] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2949),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2949),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6653),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6645),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6647),
    [anon_sym_DASH] = ACTIONS(6645),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6645),
    [anon_sym_PERCENT] = ACTIONS(6645),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6649),
    [anon_sym_COLON_DASH] = ACTIONS(6645),
    [sym__special_character] = ACTIONS(599),
  },
  [2476] = {
    [anon_sym_EQ] = ACTIONS(6655),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2477] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2954),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2954),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6657),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6659),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6661),
    [anon_sym_DASH] = ACTIONS(6659),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6659),
    [anon_sym_PERCENT] = ACTIONS(6659),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6663),
    [anon_sym_COLON_DASH] = ACTIONS(6659),
    [sym__special_character] = ACTIONS(599),
  },
  [2478] = {
    [sym_process_substitution] = STATE(2955),
    [aux_sym__literal_repeat1] = STATE(2957),
    [sym_simple_expansion] = STATE(2955),
    [sym_string_expansion] = STATE(2955),
    [sym_expansion] = STATE(2955),
    [sym_concatenation] = STATE(2956),
    [sym_string] = STATE(2955),
    [sym_command_substitution] = STATE(2955),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6665),
    [sym_raw_string] = ACTIONS(6665),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6647),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2479] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2960),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2960),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6667),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6669),
    [anon_sym_DASH] = ACTIONS(6667),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6667),
    [anon_sym_PERCENT] = ACTIONS(6667),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6671),
    [anon_sym_COLON_DASH] = ACTIONS(6667),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6673),
  },
  [2480] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_fi] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_elif] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [2481] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6669),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2482] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(6675),
  },
  [2483] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(6677),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2484] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_fi] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [2485] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(6679),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(6677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2486] = {
    [sym_process_substitution] = STATE(2964),
    [sym_string_expansion] = STATE(2964),
    [sym_expansion] = STATE(2964),
    [sym_simple_expansion] = STATE(2964),
    [sym_string] = STATE(2964),
    [sym_command_substitution] = STATE(2964),
    [anon_sym_BQUOTE] = ACTIONS(6681),
    [anon_sym_DQUOTE] = ACTIONS(5527),
    [sym_word] = ACTIONS(6683),
    [sym_raw_string] = ACTIONS(6683),
    [anon_sym_LT_LPAREN] = ACTIONS(6685),
    [anon_sym_DOLLAR] = ACTIONS(4242),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6685),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6687),
    [sym__special_character] = ACTIONS(6683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6689),
  },
  [2487] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(6691),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [2488] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6693),
  },
  [2489] = {
    [sym_process_substitution] = STATE(2969),
    [aux_sym__literal_repeat1] = STATE(2971),
    [sym_array] = STATE(2970),
    [sym_simple_expansion] = STATE(2969),
    [sym_string_expansion] = STATE(2969),
    [sym_expansion] = STATE(2969),
    [sym_concatenation] = STATE(2970),
    [sym_string] = STATE(2969),
    [sym_command_substitution] = STATE(2969),
    [anon_sym_LPAREN] = ACTIONS(6695),
    [anon_sym_BQUOTE] = ACTIONS(6681),
    [anon_sym_DQUOTE] = ACTIONS(5527),
    [sym_word] = ACTIONS(6697),
    [sym_raw_string] = ACTIONS(6697),
    [anon_sym_LT_LPAREN] = ACTIONS(6685),
    [anon_sym_DOLLAR] = ACTIONS(4242),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6685),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6687),
    [sym__special_character] = ACTIONS(6699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6689),
    [sym__empty_value] = ACTIONS(6701),
  },
  [2490] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_fi] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [2491] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_fi] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [2492] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_fi] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [2493] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(6675),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [2494] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6675),
  },
  [2495] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2974),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2974),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6703),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6705),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6707),
    [anon_sym_DASH] = ACTIONS(6705),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6705),
    [anon_sym_PERCENT] = ACTIONS(6705),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6709),
    [anon_sym_COLON_DASH] = ACTIONS(6705),
    [sym__special_character] = ACTIONS(599),
  },
  [2496] = {
    [sym_subscript] = STATE(2975),
    [anon_sym_STAR] = ACTIONS(6711),
    [anon_sym_QMARK] = ACTIONS(6711),
    [anon_sym_AT] = ACTIONS(6711),
    [sym_variable_name] = ACTIONS(6713),
    [anon_sym_DOLLAR] = ACTIONS(6715),
    [anon_sym_DASH] = ACTIONS(6715),
    [anon_sym_0] = ACTIONS(6717),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6717),
    [anon_sym__] = ACTIONS(6717),
  },
  [2497] = {
    [anon_sym_EQ] = ACTIONS(6719),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2498] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2981),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2981),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6721),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6723),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6725),
    [anon_sym_DASH] = ACTIONS(6723),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6723),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6723),
    [anon_sym_PERCENT] = ACTIONS(6723),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6727),
    [anon_sym_COLON_DASH] = ACTIONS(6723),
    [sym__special_character] = ACTIONS(599),
  },
  [2499] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2500] = {
    [aux_sym__literal_repeat1] = STATE(2500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(6729),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [2501] = {
    [sym_process_substitution] = STATE(1955),
    [sym_string] = STATE(1955),
    [sym_command_substitution] = STATE(1955),
    [sym_simple_expansion] = STATE(1955),
    [sym_variable_assignment] = STATE(2501),
    [sym_subscript] = STATE(1964),
    [sym_string_expansion] = STATE(1955),
    [sym_expansion] = STATE(1955),
    [sym_concatenation] = STATE(2501),
    [aux_sym_declaration_command_repeat1] = STATE(2501),
    [aux_sym__literal_repeat1] = STATE(1962),
    [anon_sym_AMP_GT_GT] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(6732),
    [anon_sym_LT_LT] = ACTIONS(1320),
    [anon_sym_fi] = ACTIONS(1320),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6735),
    [anon_sym_GT_LPAREN] = ACTIONS(6738),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6741),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1320),
    [sym_word] = ACTIONS(6747),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_AMP] = ACTIONS(1320),
    [anon_sym_LT] = ACTIONS(1320),
    [anon_sym_LT_AMP] = ACTIONS(1320),
    [anon_sym_GT_GT] = ACTIONS(1320),
    [sym__special_character] = ACTIONS(6750),
    [anon_sym_LT_LT_DASH] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(6753),
    [anon_sym_LF] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_raw_string] = ACTIONS(6747),
    [sym_variable_name] = ACTIONS(6756),
    [sym_file_descriptor] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1320),
    [anon_sym_AMP_GT] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(6759),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_AMP] = ACTIONS(1320),
    [anon_sym_LT_LPAREN] = ACTIONS(6738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1320),
    [anon_sym_SEMI_SEMI] = ACTIONS(1320),
    [anon_sym_PIPE_AMP] = ACTIONS(1320),
  },
  [2502] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(6762),
  },
  [2503] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(6764),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2504] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_fi] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [2505] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(6766),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(6764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2506] = {
    [sym_process_substitution] = STATE(2985),
    [sym_string_expansion] = STATE(2985),
    [sym_expansion] = STATE(2985),
    [sym_simple_expansion] = STATE(2985),
    [sym_string] = STATE(2985),
    [sym_command_substitution] = STATE(2985),
    [anon_sym_BQUOTE] = ACTIONS(6768),
    [anon_sym_DQUOTE] = ACTIONS(5557),
    [sym_word] = ACTIONS(6770),
    [sym_raw_string] = ACTIONS(6770),
    [anon_sym_LT_LPAREN] = ACTIONS(6772),
    [anon_sym_DOLLAR] = ACTIONS(4262),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6774),
    [sym__special_character] = ACTIONS(6770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6776),
  },
  [2507] = {
    [aux_sym_concatenation_repeat1] = STATE(2987),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(6778),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [2508] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6780),
  },
  [2509] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_fi] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [2510] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_fi] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [2511] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_fi] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [2512] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(6762),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [2513] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6762),
  },
  [2514] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2991),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2991),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6782),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6784),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6786),
    [anon_sym_DASH] = ACTIONS(6784),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6784),
    [anon_sym_PERCENT] = ACTIONS(6784),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6788),
    [anon_sym_COLON_DASH] = ACTIONS(6784),
    [sym__special_character] = ACTIONS(599),
  },
  [2515] = {
    [sym_subscript] = STATE(2992),
    [anon_sym_STAR] = ACTIONS(6790),
    [anon_sym_QMARK] = ACTIONS(6790),
    [anon_sym_AT] = ACTIONS(6790),
    [sym_variable_name] = ACTIONS(6792),
    [anon_sym_DOLLAR] = ACTIONS(6794),
    [anon_sym_DASH] = ACTIONS(6794),
    [anon_sym_0] = ACTIONS(6796),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6796),
    [anon_sym__] = ACTIONS(6796),
  },
  [2516] = {
    [anon_sym_EQ] = ACTIONS(6798),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2517] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(2998),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(2998),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6800),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6802),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6804),
    [anon_sym_DASH] = ACTIONS(6802),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6802),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6802),
    [anon_sym_PERCENT] = ACTIONS(6802),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6806),
    [anon_sym_COLON_DASH] = ACTIONS(6802),
    [sym__special_character] = ACTIONS(599),
  },
  [2518] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2519] = {
    [aux_sym__literal_repeat1] = STATE(2519),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(6808),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [2520] = {
    [sym_process_substitution] = STATE(1967),
    [sym_command_substitution] = STATE(1967),
    [aux_sym_unset_command_repeat1] = STATE(2520),
    [sym_simple_expansion] = STATE(1967),
    [sym_string_expansion] = STATE(1967),
    [sym_expansion] = STATE(1967),
    [sym_concatenation] = STATE(2520),
    [sym_string] = STATE(1967),
    [aux_sym__literal_repeat1] = STATE(1973),
    [anon_sym_AMP_GT_GT] = ACTIONS(1403),
    [anon_sym_DOLLAR] = ACTIONS(6811),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_fi] = ACTIONS(1403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6814),
    [anon_sym_GT_LPAREN] = ACTIONS(6817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6820),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6823),
    [anon_sym_PIPE_PIPE] = ACTIONS(1403),
    [sym_word] = ACTIONS(6826),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_LT_AMP] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [sym__special_character] = ACTIONS(6829),
    [anon_sym_LT_LT_DASH] = ACTIONS(1403),
    [anon_sym_BQUOTE] = ACTIONS(6832),
    [anon_sym_LF] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(6826),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_AMP_GT] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(6835),
    [anon_sym_LT_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_AMP] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(6817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1403),
    [anon_sym_PIPE_AMP] = ACTIONS(1403),
  },
  [2521] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_fi] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_EQ_TILDE] = ACTIONS(1434),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [2522] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_fi] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_EQ_TILDE] = ACTIONS(1440),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [2523] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3001),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3001),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6838),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6840),
    [anon_sym_DASH] = ACTIONS(6838),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6838),
    [anon_sym_PERCENT] = ACTIONS(6838),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6842),
    [anon_sym_COLON_DASH] = ACTIONS(6838),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6844),
  },
  [2524] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_fi] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_EQ_TILDE] = ACTIONS(1476),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [2525] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6840),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2526] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3001),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3001),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6846),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6838),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6840),
    [anon_sym_DASH] = ACTIONS(6838),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6838),
    [anon_sym_PERCENT] = ACTIONS(6838),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6842),
    [anon_sym_COLON_DASH] = ACTIONS(6838),
    [sym__special_character] = ACTIONS(599),
  },
  [2527] = {
    [anon_sym_EQ] = ACTIONS(6848),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2528] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3006),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3006),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6850),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6852),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6854),
    [anon_sym_DASH] = ACTIONS(6852),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6852),
    [anon_sym_PERCENT] = ACTIONS(6852),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6856),
    [anon_sym_COLON_DASH] = ACTIONS(6852),
    [sym__special_character] = ACTIONS(599),
  },
  [2529] = {
    [sym_process_substitution] = STATE(3007),
    [aux_sym__literal_repeat1] = STATE(3009),
    [sym_simple_expansion] = STATE(3007),
    [sym_string_expansion] = STATE(3007),
    [sym_expansion] = STATE(3007),
    [sym_concatenation] = STATE(3008),
    [sym_string] = STATE(3007),
    [sym_command_substitution] = STATE(3007),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6858),
    [sym_raw_string] = ACTIONS(6858),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6840),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2530] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3012),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3012),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6860),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6862),
    [anon_sym_DASH] = ACTIONS(6860),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6860),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6860),
    [anon_sym_PERCENT] = ACTIONS(6860),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6864),
    [anon_sym_COLON_DASH] = ACTIONS(6860),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6866),
  },
  [2531] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_fi] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1532),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [2532] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6862),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2533] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2534] = {
    [sym_process_substitution] = STATE(2533),
    [sym_string_expansion] = STATE(2533),
    [sym_expansion] = STATE(2533),
    [sym_simple_expansion] = STATE(2533),
    [sym_string] = STATE(2533),
    [sym_command_substitution] = STATE(2533),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [sym_word] = ACTIONS(5611),
    [sym_raw_string] = ACTIONS(5611),
    [anon_sym_LT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(6868),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [sym__special_character] = ACTIONS(5611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3085),
  },
  [2535] = {
    [aux_sym_concatenation_repeat1] = STATE(2535),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(6870),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2536] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(3015),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(3015),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(6873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2537] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(3016),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2538] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(3019),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(6875),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(6877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2539] = {
    [aux_sym_concatenation_repeat1] = STATE(3021),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_fi] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(6879),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2540] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3022),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2541] = {
    [sym_string] = STATE(3024),
    [anon_sym_DQUOTE] = ACTIONS(5619),
    [anon_sym_STAR] = ACTIONS(6881),
    [anon_sym_QMARK] = ACTIONS(6881),
    [sym_raw_string] = ACTIONS(6883),
    [anon_sym_AT] = ACTIONS(6881),
    [anon_sym_DOLLAR] = ACTIONS(6885),
    [anon_sym_POUND] = ACTIONS(6885),
    [anon_sym_DASH] = ACTIONS(6885),
    [anon_sym_0] = ACTIONS(6887),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6887),
    [anon_sym__] = ACTIONS(6887),
  },
  [2542] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(3026),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3027),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2543] = {
    [aux_sym_concatenation_repeat1] = STATE(3021),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(6879),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2544] = {
    [sym_subscript] = STATE(3028),
    [anon_sym_STAR] = ACTIONS(6889),
    [anon_sym_QMARK] = ACTIONS(6889),
    [anon_sym_BANG] = ACTIONS(6891),
    [anon_sym_AT] = ACTIONS(6889),
    [sym_variable_name] = ACTIONS(6893),
    [anon_sym_DOLLAR] = ACTIONS(6895),
    [anon_sym_DASH] = ACTIONS(6895),
    [anon_sym_0] = ACTIONS(6897),
    [anon_sym_POUND] = ACTIONS(6891),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6897),
    [anon_sym__] = ACTIONS(6897),
    [sym_comment] = ACTIONS(3),
  },
  [2545] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_fi] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2546] = {
    [aux_sym__literal_repeat1] = STATE(3033),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_fi] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(6899),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [2547] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_fi] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2010),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [2548] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(6901),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2549] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1999),
    [sym_file_redirect] = STATE(1999),
    [sym_herestring_redirect] = STATE(1999),
    [sym_heredoc_redirect] = STATE(1999),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_fi] = ACTIONS(2215),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [2550] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1999),
    [sym_file_redirect] = STATE(1999),
    [sym_herestring_redirect] = STATE(1999),
    [sym_heredoc_redirect] = STATE(1999),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_fi] = ACTIONS(2215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [2551] = {
    [aux_sym_concatenation_repeat1] = STATE(3035),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_fi] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [2552] = {
    [aux_sym_concatenation_repeat1] = STATE(3035),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2553] = {
    [aux_sym__literal_repeat1] = STATE(3036),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_fi] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
  },
  [2554] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_fi] = ACTIONS(2261),
    [anon_sym_LF] = ACTIONS(6903),
    [anon_sym_SEMI] = ACTIONS(6905),
    [anon_sym_SEMI_SEMI] = ACTIONS(6905),
    [anon_sym_AMP] = ACTIONS(6905),
  },
  [2555] = {
    [sym_process_substitution] = STATE(3038),
    [aux_sym__literal_repeat1] = STATE(3039),
    [sym_simple_expansion] = STATE(3038),
    [sym_string_expansion] = STATE(3038),
    [sym_expansion] = STATE(3038),
    [sym_concatenation] = STATE(1142),
    [sym_string] = STATE(3038),
    [sym_command_substitution] = STATE(3038),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(6907),
    [sym_raw_string] = ACTIONS(6907),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(5641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [2556] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1999),
    [sym_file_redirect] = STATE(1999),
    [sym_herestring_redirect] = STATE(1999),
    [sym_heredoc_redirect] = STATE(1999),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [sym_file_descriptor] = ACTIONS(2277),
    [anon_sym_fi] = ACTIONS(2275),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(4318),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(4318),
  },
  [2557] = {
    [aux_sym_redirected_statement_repeat1] = STATE(1999),
    [sym_file_redirect] = STATE(1999),
    [sym_herestring_redirect] = STATE(1999),
    [sym_heredoc_redirect] = STATE(1999),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_fi] = ACTIONS(2275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(4318),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(4318),
  },
  [2558] = {
    [aux_sym_concatenation_repeat1] = STATE(3035),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_fi] = ACTIONS(2279),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [2559] = {
    [aux_sym__literal_repeat1] = STATE(3036),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LT_LT] = ACTIONS(2283),
    [sym_file_descriptor] = ACTIONS(2285),
    [anon_sym_fi] = ACTIONS(2283),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_LT_LT_LT] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_GT_AMP] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_LT_AMP] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
  },
  [2560] = {
    [aux_sym_redirected_statement_repeat1] = STATE(2560),
    [sym_file_redirect] = STATE(2560),
    [sym_herestring_redirect] = STATE(2560),
    [sym_heredoc_redirect] = STATE(2560),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_AMP_GT_GT] = ACTIONS(6909),
    [anon_sym_LF] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2287),
    [sym_file_descriptor] = ACTIONS(6912),
    [anon_sym_fi] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(6909),
    [anon_sym_AMP_GT] = ACTIONS(6909),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT_LT_LT] = ACTIONS(6915),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(6909),
    [anon_sym_LT] = ACTIONS(6909),
    [anon_sym_LT_AMP] = ACTIONS(6909),
    [anon_sym_GT_GT] = ACTIONS(6909),
    [anon_sym_AMP] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
  },
  [2561] = {
    [sym_process_substitution] = STATE(2001),
    [sym_command_substitution] = STATE(2001),
    [sym_simple_expansion] = STATE(2001),
    [sym_string_expansion] = STATE(2001),
    [sym_expansion] = STATE(2001),
    [aux_sym_command_repeat2] = STATE(2565),
    [sym_concatenation] = STATE(2565),
    [sym_string] = STATE(2001),
    [aux_sym__literal_repeat1] = STATE(2003),
    [anon_sym_AMP_GT_GT] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_fi] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(4324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [sym_word] = ACTIONS(4330),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_LT_AMP] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_TILDE] = ACTIONS(4332),
    [sym__special_character] = ACTIONS(3089),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(4334),
    [anon_sym_LF] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [sym_raw_string] = ACTIONS(4330),
    [sym_file_descriptor] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(4332),
    [anon_sym_DQUOTE] = ACTIONS(4336),
    [anon_sym_LT_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_AMP] = ACTIONS(2303),
    [anon_sym_LT_LPAREN] = ACTIONS(4324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_SEMI_SEMI] = ACTIONS(2303),
    [anon_sym_PIPE_AMP] = ACTIONS(2303),
  },
  [2562] = {
    [aux_sym_concatenation_repeat1] = STATE(1986),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_fi] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [sym__concat] = ACTIONS(4298),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [2563] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_fi] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [2564] = {
    [aux_sym__literal_repeat1] = STATE(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2311),
    [anon_sym_DOLLAR] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_fi] = ACTIONS(2311),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2311),
    [anon_sym_GT_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [sym_word] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_LT_AMP] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(2311),
    [anon_sym_EQ_TILDE] = ACTIONS(2311),
    [sym__special_character] = ACTIONS(4338),
    [anon_sym_LT_LT_DASH] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [sym_raw_string] = ACTIONS(2311),
    [sym_file_descriptor] = ACTIONS(2313),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP_GT] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_LT_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_AMP] = ACTIONS(2311),
    [anon_sym_LT_LPAREN] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_SEMI_SEMI] = ACTIONS(2311),
    [anon_sym_PIPE_AMP] = ACTIONS(2311),
  },
  [2565] = {
    [sym_process_substitution] = STATE(2001),
    [sym_command_substitution] = STATE(2001),
    [sym_simple_expansion] = STATE(2001),
    [sym_string_expansion] = STATE(2001),
    [sym_expansion] = STATE(2001),
    [aux_sym_command_repeat2] = STATE(2565),
    [sym_concatenation] = STATE(2565),
    [sym_string] = STATE(2001),
    [aux_sym__literal_repeat1] = STATE(2003),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(6918),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_fi] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6921),
    [anon_sym_GT_LPAREN] = ACTIONS(6924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(6930),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(6933),
    [sym__special_character] = ACTIONS(6936),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(6939),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(6930),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(6933),
    [anon_sym_DQUOTE] = ACTIONS(6942),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(6924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [2566] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_fi] = ACTIONS(2261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [2567] = {
    [sym_heredoc_body] = STATE(3040),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_fi] = ACTIONS(2261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
  },
  [2568] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_EQ_TILDE] = ACTIONS(2506),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [anon_sym_elif] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [2569] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3042),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6945),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6947),
    [anon_sym_DASH] = ACTIONS(6945),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6945),
    [anon_sym_PERCENT] = ACTIONS(6945),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6949),
    [anon_sym_COLON_DASH] = ACTIONS(6945),
    [sym__special_character] = ACTIONS(599),
  },
  [2570] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6947),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2571] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3042),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6945),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6947),
    [anon_sym_DASH] = ACTIONS(6945),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6945),
    [anon_sym_PERCENT] = ACTIONS(6945),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6949),
    [anon_sym_COLON_DASH] = ACTIONS(6945),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6951),
  },
  [2572] = {
    [sym_process_substitution] = STATE(3044),
    [aux_sym__literal_repeat1] = STATE(3046),
    [sym_simple_expansion] = STATE(3044),
    [sym_string_expansion] = STATE(3044),
    [sym_expansion] = STATE(3044),
    [sym_concatenation] = STATE(3045),
    [sym_string] = STATE(3044),
    [sym_command_substitution] = STATE(3044),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(6953),
    [sym_raw_string] = ACTIONS(6953),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6947),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2573] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3049),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3049),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6955),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6957),
    [anon_sym_DASH] = ACTIONS(6955),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6955),
    [anon_sym_PERCENT] = ACTIONS(6955),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6959),
    [anon_sym_COLON_DASH] = ACTIONS(6955),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(6961),
  },
  [2574] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_else] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [anon_sym_elif] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [2575] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6957),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2576] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6947),
    [sym__concat] = ACTIONS(2610),
  },
  [2577] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6947),
  },
  [2578] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(6963),
  },
  [2579] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_fi] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2644),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_elif] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [2580] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3052),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3052),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6965),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6967),
    [anon_sym_DASH] = ACTIONS(6965),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6965),
    [anon_sym_PERCENT] = ACTIONS(6965),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6969),
    [anon_sym_COLON_DASH] = ACTIONS(6965),
    [sym__special_character] = ACTIONS(599),
  },
  [2581] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6967),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2582] = {
    [sym_string] = STATE(1410),
    [anon_sym__] = ACTIONS(3071),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(6971),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(6971),
    [anon_sym_fi] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_else] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_EQ_TILDE] = ACTIONS(2658),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(3071),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(6973),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(3071),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(3157),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_elif] = ACTIONS(2658),
    [anon_sym_POUND] = ACTIONS(6971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [2583] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_fi] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [anon_sym_else] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [anon_sym_elif] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [2584] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(6975),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2585] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(6977),
  },
  [2586] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(6979),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2587] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_fi] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_elif] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [2588] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(6981),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(6979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2589] = {
    [sym_process_substitution] = STATE(3057),
    [sym_string_expansion] = STATE(3057),
    [sym_expansion] = STATE(3057),
    [sym_simple_expansion] = STATE(3057),
    [sym_string] = STATE(3057),
    [sym_command_substitution] = STATE(3057),
    [anon_sym_BQUOTE] = ACTIONS(4372),
    [anon_sym_DQUOTE] = ACTIONS(4374),
    [sym_word] = ACTIONS(6983),
    [sym_raw_string] = ACTIONS(6983),
    [anon_sym_LT_LPAREN] = ACTIONS(4378),
    [anon_sym_DOLLAR] = ACTIONS(4380),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4382),
    [sym__special_character] = ACTIONS(6983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4386),
  },
  [2590] = {
    [aux_sym_concatenation_repeat1] = STATE(3059),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_else] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(6985),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [anon_sym_elif] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [2591] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6987),
  },
  [2592] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_fi] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_else] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [anon_sym_elif] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [2593] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_fi] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_else] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_elif] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [2594] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_fi] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [anon_sym_elif] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [2595] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(6977),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [2596] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(6977),
  },
  [2597] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3063),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3063),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(6989),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(6991),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(6993),
    [anon_sym_DASH] = ACTIONS(6991),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(6991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(6991),
    [anon_sym_PERCENT] = ACTIONS(6991),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6995),
    [anon_sym_COLON_DASH] = ACTIONS(6991),
    [sym__special_character] = ACTIONS(599),
  },
  [2598] = {
    [sym_subscript] = STATE(3064),
    [anon_sym_STAR] = ACTIONS(6997),
    [anon_sym_QMARK] = ACTIONS(6997),
    [anon_sym_AT] = ACTIONS(6997),
    [sym_variable_name] = ACTIONS(6999),
    [anon_sym_DOLLAR] = ACTIONS(7001),
    [anon_sym_DASH] = ACTIONS(7001),
    [anon_sym_0] = ACTIONS(7003),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7003),
    [anon_sym__] = ACTIONS(7003),
  },
  [2599] = {
    [anon_sym_EQ] = ACTIONS(7005),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2600] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3070),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3070),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7007),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7009),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7011),
    [anon_sym_DASH] = ACTIONS(7009),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7009),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7009),
    [anon_sym_PERCENT] = ACTIONS(7009),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7013),
    [anon_sym_COLON_DASH] = ACTIONS(7009),
    [sym__special_character] = ACTIONS(599),
  },
  [2601] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_else] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_elif] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2602] = {
    [aux_sym__literal_repeat1] = STATE(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(7015),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [anon_sym_elif] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [2603] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_fi] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_EQ_TILDE] = ACTIONS(3421),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_elif] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [2604] = {
    [anon_sym_elif] = ACTIONS(7018),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(7018),
    [anon_sym_else] = ACTIONS(7018),
  },
  [2605] = {
    [aux_sym_concatenation_repeat1] = STATE(3072),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_else] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_elif] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym__concat] = ACTIONS(7020),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [2606] = {
    [aux_sym__literal_repeat1] = STATE(2606),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_elif] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3701),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [2607] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_fi] = ACTIONS(3734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_else] = ACTIONS(3734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [anon_sym_elif] = ACTIONS(3734),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [2608] = {
    [aux_sym_concatenation_repeat1] = STATE(2605),
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_fi] = ACTIONS(2004),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_else] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_elif] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [2609] = {
    [aux_sym__literal_repeat1] = STATE(2606),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_fi] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_else] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_elif] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
  },
  [2610] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7022),
    [anon_sym_BQUOTE] = ACTIONS(7022),
    [anon_sym_AMP_GT_GT] = ACTIONS(7022),
    [anon_sym_LF] = ACTIONS(7024),
    [anon_sym_SEMI] = ACTIONS(7022),
    [anon_sym_LT_LT] = ACTIONS(7022),
    [sym_file_descriptor] = ACTIONS(7024),
    [anon_sym_GT] = ACTIONS(7022),
    [anon_sym_RPAREN] = ACTIONS(7022),
    [anon_sym_AMP_GT] = ACTIONS(7022),
    [anon_sym_fi] = ACTIONS(7022),
    [anon_sym_else] = ACTIONS(7022),
    [anon_sym_done] = ACTIONS(7022),
    [anon_sym_PIPE_PIPE] = ACTIONS(7022),
    [ts_builtin_sym_end] = ACTIONS(7024),
    [anon_sym_LT_LT_LT] = ACTIONS(7022),
    [anon_sym_PIPE] = ACTIONS(7022),
    [anon_sym_GT_AMP] = ACTIONS(7022),
    [anon_sym_LT] = ACTIONS(7022),
    [anon_sym_LT_AMP] = ACTIONS(7022),
    [anon_sym_GT_GT] = ACTIONS(7022),
    [anon_sym_AMP] = ACTIONS(7022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(7022),
    [anon_sym_AMP_AMP] = ACTIONS(7022),
    [anon_sym_esac] = ACTIONS(7022),
    [anon_sym_SEMI_SEMI] = ACTIONS(7022),
    [anon_sym_PIPE_AMP] = ACTIONS(7022),
  },
  [2611] = {
    [anon_sym_LF] = ACTIONS(7026),
    [anon_sym_AMP] = ACTIONS(7028),
    [anon_sym_SEMI] = ACTIONS(7028),
    [anon_sym_elif] = ACTIONS(3734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_fi] = ACTIONS(3734),
    [anon_sym_else] = ACTIONS(3734),
    [anon_sym_SEMI_SEMI] = ACTIONS(7028),
  },
  [2612] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7030),
    [anon_sym_BQUOTE] = ACTIONS(7030),
    [anon_sym_AMP_GT_GT] = ACTIONS(7030),
    [anon_sym_LF] = ACTIONS(7032),
    [anon_sym_SEMI] = ACTIONS(7030),
    [anon_sym_LT_LT] = ACTIONS(7030),
    [sym_file_descriptor] = ACTIONS(7032),
    [anon_sym_GT] = ACTIONS(7030),
    [anon_sym_RPAREN] = ACTIONS(7030),
    [anon_sym_AMP_GT] = ACTIONS(7030),
    [anon_sym_fi] = ACTIONS(7030),
    [anon_sym_else] = ACTIONS(7030),
    [anon_sym_done] = ACTIONS(7030),
    [anon_sym_PIPE_PIPE] = ACTIONS(7030),
    [ts_builtin_sym_end] = ACTIONS(7032),
    [anon_sym_LT_LT_LT] = ACTIONS(7030),
    [anon_sym_PIPE] = ACTIONS(7030),
    [anon_sym_GT_AMP] = ACTIONS(7030),
    [anon_sym_LT] = ACTIONS(7030),
    [anon_sym_LT_AMP] = ACTIONS(7030),
    [anon_sym_GT_GT] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(7030),
    [anon_sym_AMP_AMP] = ACTIONS(7030),
    [anon_sym_esac] = ACTIONS(7030),
    [anon_sym_SEMI_SEMI] = ACTIONS(7030),
    [anon_sym_PIPE_AMP] = ACTIONS(7030),
  },
  [2613] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(7034),
  },
  [2614] = {
    [aux_sym_concatenation_repeat1] = STATE(2062),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7036),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(7036),
  },
  [2615] = {
    [anon_sym_PIPE] = ACTIONS(7036),
    [anon_sym_RPAREN] = ACTIONS(7036),
    [sym_comment] = ACTIONS(51),
  },
  [2616] = {
    [aux_sym__literal_repeat1] = STATE(2066),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7038),
    [anon_sym_PIPE] = ACTIONS(7038),
    [sym__special_character] = ACTIONS(867),
  },
  [2617] = {
    [sym_process_substitution] = STATE(3077),
    [sym_string] = STATE(3077),
    [sym_command_substitution] = STATE(3077),
    [sym_simple_expansion] = STATE(3077),
    [sym_variable_assignment] = STATE(3085),
    [sym_subscript] = STATE(3086),
    [sym_string_expansion] = STATE(3077),
    [sym_expansion] = STATE(3077),
    [sym_concatenation] = STATE(3085),
    [aux_sym_declaration_command_repeat1] = STATE(3085),
    [aux_sym__literal_repeat1] = STATE(3084),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(7042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(7052),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(7054),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(7050),
    [sym_variable_name] = ACTIONS(7056),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(7058),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(7042),
    [anon_sym_esac] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [2618] = {
    [sym_process_substitution] = STATE(3089),
    [sym_command_substitution] = STATE(3089),
    [aux_sym_unset_command_repeat1] = STATE(3096),
    [sym_simple_expansion] = STATE(3089),
    [sym_string_expansion] = STATE(3089),
    [sym_expansion] = STATE(3089),
    [sym_concatenation] = STATE(3096),
    [sym_string] = STATE(3089),
    [aux_sym__literal_repeat1] = STATE(3095),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(7060),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(7062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7064),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7066),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7068),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(7070),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(7072),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(7074),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(7070),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(7076),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(7062),
    [anon_sym_esac] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [2619] = {
    [sym_string] = STATE(3098),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(7078),
    [anon_sym_QMARK] = ACTIONS(7078),
    [sym_raw_string] = ACTIONS(7080),
    [anon_sym_AT] = ACTIONS(7078),
    [anon_sym_DOLLAR] = ACTIONS(7082),
    [anon_sym_POUND] = ACTIONS(7082),
    [anon_sym_DASH] = ACTIONS(7082),
    [anon_sym_0] = ACTIONS(7084),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7084),
    [anon_sym__] = ACTIONS(7084),
  },
  [2620] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3100),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2621] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(3101),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3102),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2622] = {
    [sym_subscript] = STATE(3103),
    [anon_sym_STAR] = ACTIONS(7086),
    [anon_sym_QMARK] = ACTIONS(7086),
    [anon_sym_BANG] = ACTIONS(7088),
    [anon_sym_AT] = ACTIONS(7086),
    [sym_variable_name] = ACTIONS(7090),
    [anon_sym_DOLLAR] = ACTIONS(7092),
    [anon_sym_DASH] = ACTIONS(7092),
    [anon_sym_0] = ACTIONS(7094),
    [anon_sym_POUND] = ACTIONS(7088),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7094),
    [anon_sym__] = ACTIONS(7094),
    [sym_comment] = ACTIONS(3),
  },
  [2623] = {
    [aux_sym_concatenation_repeat1] = STATE(3108),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(7096),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_esac] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [2624] = {
    [aux_sym_concatenation_repeat1] = STATE(3108),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(7096),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2625] = {
    [aux_sym_concatenation_repeat1] = STATE(3108),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(7096),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_esac] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [2626] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(3109),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2627] = {
    [sym_simple_expansion] = STATE(2625),
    [sym_test_command] = STATE(179),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(2634),
    [sym_concatenation] = STATE(2633),
    [sym_string] = STATE(2625),
    [sym_command_substitution] = STATE(2625),
    [sym_process_substitution] = STATE(2625),
    [sym_command_name] = STATE(2636),
    [aux_sym_command_repeat1] = STATE(2634),
    [sym_variable_assignment] = STATE(2634),
    [sym_string_expansion] = STATE(2625),
    [sym_expansion] = STATE(2625),
    [sym_subshell] = STATE(179),
    [sym_command] = STATE(179),
    [aux_sym__literal_repeat1] = STATE(2639),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(5799),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [sym_word] = ACTIONS(5799),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(5797),
  },
  [2628] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(7098),
  },
  [2629] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(3113),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(7100),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(7102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2630] = {
    [anon_sym_BQUOTE] = ACTIONS(7104),
    [anon_sym_DQUOTE] = ACTIONS(7104),
    [sym_word] = ACTIONS(7106),
    [sym_raw_string] = ACTIONS(7104),
    [anon_sym_LT_LPAREN] = ACTIONS(7104),
    [anon_sym_esac] = ACTIONS(7108),
    [anon_sym_DOLLAR] = ACTIONS(7106),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(7104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7104),
    [sym__special_character] = ACTIONS(7104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7104),
  },
  [2631] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3121),
    [sym_file_redirect] = STATE(3121),
    [sym_herestring_redirect] = STATE(3121),
    [sym_heredoc_redirect] = STATE(3121),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(7110),
    [anon_sym_LF] = ACTIONS(7112),
    [anon_sym_SEMI] = ACTIONS(7114),
    [sym_file_descriptor] = ACTIONS(7116),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(7110),
    [anon_sym_AMP_GT] = ACTIONS(7110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_LT_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_AMP] = ACTIONS(7110),
    [anon_sym_AMP] = ACTIONS(7114),
    [anon_sym_LT] = ACTIONS(7110),
    [anon_sym_esac] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(7110),
    [anon_sym_GT_GT] = ACTIONS(7110),
    [anon_sym_PIPE] = ACTIONS(7122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_SEMI_SEMI] = ACTIONS(413),
    [anon_sym_PIPE_AMP] = ACTIONS(7122),
  },
  [2632] = {
    [anon_sym_EQ] = ACTIONS(7098),
    [anon_sym_PLUS_EQ] = ACTIONS(7098),
    [sym_comment] = ACTIONS(51),
  },
  [2633] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_esac] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [2634] = {
    [sym_process_substitution] = STATE(2625),
    [sym_command_substitution] = STATE(2625),
    [sym_command_name] = STATE(3122),
    [sym_simple_expansion] = STATE(2625),
    [sym_variable_assignment] = STATE(221),
    [aux_sym_command_repeat1] = STATE(221),
    [sym_string_expansion] = STATE(2625),
    [sym_expansion] = STATE(2625),
    [sym_subscript] = STATE(180),
    [sym_file_redirect] = STATE(221),
    [sym_concatenation] = STATE(2633),
    [sym_string] = STATE(2625),
    [aux_sym__literal_repeat1] = STATE(2639),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(5799),
    [sym_variable_name] = ACTIONS(283),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [sym_word] = ACTIONS(5799),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(7124),
  },
  [2635] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(7126),
    [anon_sym_esac] = ACTIONS(7128),
  },
  [2636] = {
    [sym_process_substitution] = STATE(3124),
    [sym_command_substitution] = STATE(3124),
    [sym_simple_expansion] = STATE(3124),
    [sym_string_expansion] = STATE(3124),
    [sym_expansion] = STATE(3124),
    [aux_sym_command_repeat2] = STATE(3127),
    [sym_concatenation] = STATE(3127),
    [sym_string] = STATE(3124),
    [aux_sym__literal_repeat1] = STATE(3126),
    [anon_sym_AMP_GT_GT] = ACTIONS(367),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_LT_LT] = ACTIONS(367),
    [anon_sym_GT_LPAREN] = ACTIONS(7130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7134),
    [anon_sym_PIPE_PIPE] = ACTIONS(367),
    [sym_word] = ACTIONS(7136),
    [anon_sym_PIPE] = ACTIONS(367),
    [anon_sym_AMP] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(367),
    [anon_sym_GT_GT] = ACTIONS(367),
    [anon_sym_EQ_TILDE] = ACTIONS(7138),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_LT_LT_DASH] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(7140),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(7136),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_AMP_GT] = ACTIONS(367),
    [anon_sym_EQ_EQ] = ACTIONS(7138),
    [anon_sym_DQUOTE] = ACTIONS(7142),
    [anon_sym_LT_LT_LT] = ACTIONS(367),
    [anon_sym_GT_AMP] = ACTIONS(367),
    [anon_sym_LT_LPAREN] = ACTIONS(7130),
    [anon_sym_esac] = ACTIONS(367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(367),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(367),
  },
  [2637] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3121),
    [sym_file_redirect] = STATE(3121),
    [sym_herestring_redirect] = STATE(3121),
    [sym_heredoc_redirect] = STATE(3121),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(7122),
    [anon_sym_AMP] = ACTIONS(7114),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(7112),
    [anon_sym_SEMI] = ACTIONS(7114),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [anon_sym_esac] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_SEMI_SEMI] = ACTIONS(413),
    [anon_sym_PIPE_AMP] = ACTIONS(7122),
  },
  [2638] = {
    [sym_redirected_statement] = STATE(3128),
    [sym_if_statement] = STATE(3128),
    [sym_function_definition] = STATE(3128),
    [sym_compound_statement] = STATE(3128),
    [sym_test_command] = STATE(3128),
    [sym_declaration_command] = STATE(3128),
    [sym_subscript] = STATE(2632),
    [sym_file_redirect] = STATE(2634),
    [sym_concatenation] = STATE(2633),
    [sym_string] = STATE(2625),
    [sym_command_substitution] = STATE(2625),
    [sym_process_substitution] = STATE(2625),
    [aux_sym_command_repeat1] = STATE(2634),
    [sym_for_statement] = STATE(3128),
    [sym_c_style_for_statement] = STATE(3128),
    [sym_case_statement] = STATE(3128),
    [sym_subshell] = STATE(3128),
    [sym_pipeline] = STATE(3128),
    [sym_unset_command] = STATE(3128),
    [sym_command] = STATE(3128),
    [sym_simple_expansion] = STATE(2625),
    [sym_while_statement] = STATE(3128),
    [sym_list] = STATE(3128),
    [sym_negated_command] = STATE(3128),
    [sym_command_name] = STATE(2636),
    [sym_variable_assignment] = STATE(3129),
    [sym_string_expansion] = STATE(2625),
    [sym_expansion] = STATE(2625),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(2639),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(5783),
    [anon_sym_typeset] = ACTIONS(5783),
    [anon_sym_unsetenv] = ACTIONS(5785),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(5783),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(5799),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_BANG] = ACTIONS(5803),
    [anon_sym_declare] = ACTIONS(5783),
    [sym_variable_name] = ACTIONS(5805),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(5783),
    [anon_sym_unset] = ACTIONS(5785),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2639] = {
    [aux_sym__literal_repeat1] = STATE(3131),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_EQ_TILDE] = ACTIONS(389),
    [sym__special_character] = ACTIONS(7144),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [anon_sym_esac] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [2640] = {
    [aux_sym_concatenation_repeat1] = STATE(2640),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1544),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_PIPE] = ACTIONS(1544),
  },
  [2641] = {
    [sym_redirected_statement] = STATE(2631),
    [sym_if_statement] = STATE(2631),
    [sym_function_definition] = STATE(2631),
    [sym_compound_statement] = STATE(2631),
    [sym_test_command] = STATE(2631),
    [sym_declaration_command] = STATE(2631),
    [sym_subscript] = STATE(2632),
    [sym_file_redirect] = STATE(2634),
    [sym_concatenation] = STATE(2633),
    [sym_string] = STATE(2625),
    [sym_command_substitution] = STATE(2625),
    [sym_process_substitution] = STATE(2625),
    [aux_sym_command_repeat1] = STATE(2634),
    [sym_for_statement] = STATE(2631),
    [sym_c_style_for_statement] = STATE(2631),
    [sym_case_statement] = STATE(2631),
    [sym_subshell] = STATE(2631),
    [sym_pipeline] = STATE(2631),
    [sym_unset_command] = STATE(2631),
    [sym_command] = STATE(2631),
    [sym_simple_expansion] = STATE(2625),
    [sym__statements] = STATE(3132),
    [sym_while_statement] = STATE(2631),
    [sym_list] = STATE(2631),
    [sym_negated_command] = STATE(2631),
    [sym_command_name] = STATE(2636),
    [sym_variable_assignment] = STATE(2637),
    [sym_string_expansion] = STATE(2625),
    [sym_expansion] = STATE(2625),
    [aux_sym__statements_repeat1] = STATE(2638),
    [aux_sym__literal_repeat1] = STATE(2639),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(5783),
    [anon_sym_typeset] = ACTIONS(5783),
    [anon_sym_unsetenv] = ACTIONS(5785),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(5783),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(5799),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_BANG] = ACTIONS(5803),
    [anon_sym_declare] = ACTIONS(5783),
    [sym_variable_name] = ACTIONS(5805),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(5783),
    [anon_sym_unset] = ACTIONS(5785),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [anon_sym_esac] = ACTIONS(7108),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(7126),
  },
  [2642] = {
    [aux_sym_case_item_repeat1] = STATE(2642),
    [anon_sym_PIPE] = ACTIONS(7146),
    [anon_sym_RPAREN] = ACTIONS(7036),
    [sym_comment] = ACTIONS(51),
  },
  [2643] = {
    [anon_sym_BQUOTE] = ACTIONS(7149),
    [anon_sym_DQUOTE] = ACTIONS(7149),
    [sym_word] = ACTIONS(7151),
    [sym_raw_string] = ACTIONS(7149),
    [anon_sym_LT_LPAREN] = ACTIONS(7149),
    [anon_sym_esac] = ACTIONS(7153),
    [anon_sym_DOLLAR] = ACTIONS(7151),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(7149),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7149),
    [sym__special_character] = ACTIONS(7149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7149),
  },
  [2644] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(7155),
    [anon_sym_esac] = ACTIONS(7157),
  },
  [2645] = {
    [sym_redirected_statement] = STATE(2631),
    [sym_if_statement] = STATE(2631),
    [sym_function_definition] = STATE(2631),
    [sym_compound_statement] = STATE(2631),
    [sym_test_command] = STATE(2631),
    [sym_declaration_command] = STATE(2631),
    [sym_subscript] = STATE(2632),
    [sym_file_redirect] = STATE(2634),
    [sym_concatenation] = STATE(2633),
    [sym_string] = STATE(2625),
    [sym_command_substitution] = STATE(2625),
    [sym_process_substitution] = STATE(2625),
    [aux_sym_command_repeat1] = STATE(2634),
    [sym_for_statement] = STATE(2631),
    [sym_c_style_for_statement] = STATE(2631),
    [sym_case_statement] = STATE(2631),
    [sym_subshell] = STATE(2631),
    [sym_pipeline] = STATE(2631),
    [sym_unset_command] = STATE(2631),
    [sym_command] = STATE(2631),
    [sym_simple_expansion] = STATE(2625),
    [sym__statements] = STATE(3134),
    [sym_while_statement] = STATE(2631),
    [sym_list] = STATE(2631),
    [sym_negated_command] = STATE(2631),
    [sym_command_name] = STATE(2636),
    [sym_variable_assignment] = STATE(2637),
    [sym_string_expansion] = STATE(2625),
    [sym_expansion] = STATE(2625),
    [aux_sym__statements_repeat1] = STATE(2638),
    [aux_sym__literal_repeat1] = STATE(2639),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(5783),
    [anon_sym_typeset] = ACTIONS(5783),
    [anon_sym_unsetenv] = ACTIONS(5785),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(5783),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(5799),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_BANG] = ACTIONS(5803),
    [anon_sym_declare] = ACTIONS(5783),
    [sym_variable_name] = ACTIONS(5805),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(5783),
    [anon_sym_unset] = ACTIONS(5785),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [anon_sym_esac] = ACTIONS(7153),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(7155),
  },
  [2646] = {
    [aux_sym_concatenation_repeat1] = STATE(2062),
    [aux_sym_case_item_repeat1] = STATE(3136),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7159),
    [sym__concat] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(4432),
  },
  [2647] = {
    [aux_sym_case_item_repeat1] = STATE(3138),
    [aux_sym__literal_repeat1] = STATE(2066),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7161),
    [anon_sym_PIPE] = ACTIONS(4432),
    [sym__special_character] = ACTIONS(867),
  },
  [2648] = {
    [aux_sym_case_item_repeat1] = STATE(3136),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(7159),
    [sym_comment] = ACTIONS(51),
  },
  [2649] = {
    [anon_sym_AMP] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [anon_sym_in] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
  },
  [2650] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7163),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2651] = {
    [anon_sym_AMP] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_in] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
  },
  [2652] = {
    [anon_sym_AMP] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [anon_sym_in] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
  },
  [2653] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7165),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2654] = {
    [anon_sym_AMP] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [anon_sym_in] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
  },
  [2655] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7167),
    [anon_sym_BQUOTE] = ACTIONS(7167),
    [anon_sym_AMP_GT_GT] = ACTIONS(7167),
    [anon_sym_LF] = ACTIONS(7169),
    [anon_sym_SEMI] = ACTIONS(7167),
    [anon_sym_LT_LT] = ACTIONS(7167),
    [sym_file_descriptor] = ACTIONS(7169),
    [anon_sym_GT] = ACTIONS(7167),
    [anon_sym_RPAREN] = ACTIONS(7167),
    [anon_sym_AMP_GT] = ACTIONS(7167),
    [anon_sym_fi] = ACTIONS(7167),
    [anon_sym_else] = ACTIONS(7167),
    [anon_sym_done] = ACTIONS(7167),
    [anon_sym_PIPE_PIPE] = ACTIONS(7167),
    [ts_builtin_sym_end] = ACTIONS(7169),
    [anon_sym_LT_LT_LT] = ACTIONS(7167),
    [anon_sym_PIPE] = ACTIONS(7167),
    [anon_sym_GT_AMP] = ACTIONS(7167),
    [anon_sym_LT] = ACTIONS(7167),
    [anon_sym_LT_AMP] = ACTIONS(7167),
    [anon_sym_GT_GT] = ACTIONS(7167),
    [anon_sym_AMP] = ACTIONS(7167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(7167),
    [anon_sym_AMP_AMP] = ACTIONS(7167),
    [anon_sym_esac] = ACTIONS(7167),
    [anon_sym_SEMI_SEMI] = ACTIONS(7167),
    [anon_sym_PIPE_AMP] = ACTIONS(7167),
  },
  [2656] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(7171),
  },
  [2657] = {
    [anon_sym_BANG_EQ] = ACTIONS(5097),
    [anon_sym_PLUS_EQ] = ACTIONS(5097),
    [sym_test_operator] = ACTIONS(5097),
    [anon_sym_PLUS_PLUS] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5095),
    [anon_sym_DASH] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_EQ] = ACTIONS(5095),
    [anon_sym_EQ_EQ] = ACTIONS(5097),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5097),
    [anon_sym_PIPE_PIPE] = ACTIONS(5097),
    [anon_sym_GT_EQ] = ACTIONS(5097),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(5097),
    [anon_sym_DASH_DASH] = ACTIONS(5097),
    [anon_sym_LT_EQ] = ACTIONS(5097),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_DASH_EQ] = ACTIONS(5097),
  },
  [2658] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7173),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2659] = {
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [sym_test_operator] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_DASH] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5131),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5131),
    [anon_sym_PLUS] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(5131),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
  },
  [2660] = {
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_PLUS_EQ] = ACTIONS(5135),
    [sym_test_operator] = ACTIONS(5135),
    [anon_sym_PLUS_PLUS] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_DASH] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_EQ] = ACTIONS(5133),
    [anon_sym_EQ_EQ] = ACTIONS(5135),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5135),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_DASH_DASH] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_DASH_EQ] = ACTIONS(5135),
  },
  [2661] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7175),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2662] = {
    [anon_sym_BANG_EQ] = ACTIONS(5186),
    [anon_sym_PLUS_EQ] = ACTIONS(5186),
    [sym_test_operator] = ACTIONS(5186),
    [anon_sym_PLUS_PLUS] = ACTIONS(5186),
    [anon_sym_RPAREN] = ACTIONS(5184),
    [anon_sym_DASH] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_EQ] = ACTIONS(5184),
    [anon_sym_EQ_EQ] = ACTIONS(5186),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5186),
    [anon_sym_PIPE_PIPE] = ACTIONS(5186),
    [anon_sym_GT_EQ] = ACTIONS(5186),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5186),
    [anon_sym_PLUS] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(5186),
    [anon_sym_DASH_DASH] = ACTIONS(5186),
    [anon_sym_LT_EQ] = ACTIONS(5186),
    [anon_sym_AMP_AMP] = ACTIONS(5186),
    [anon_sym_DASH_EQ] = ACTIONS(5186),
  },
  [2663] = {
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_word] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
  },
  [2664] = {
    [sym_string] = STATE(1531),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(3303),
    [sym_raw_string] = ACTIONS(3299),
    [anon_sym_DOLLAR] = ACTIONS(7177),
    [anon_sym_RPAREN] = ACTIONS(2662),
    [anon_sym_DASH] = ACTIONS(7177),
    [anon_sym_GT_LPAREN] = ACTIONS(2662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(3303),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2662),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(3303),
    [anon_sym_LT_LPAREN] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(3303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3301),
    [sym__special_character] = ACTIONS(2662),
    [anon_sym__] = ACTIONS(3303),
  },
  [2665] = {
    [anon_sym_BQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE] = ACTIONS(2508),
    [sym_word] = ACTIONS(2508),
    [sym_raw_string] = ACTIONS(2508),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_LT_LPAREN] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_RPAREN] = ACTIONS(2508),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2508),
  },
  [2666] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3145),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3145),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7179),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7181),
    [anon_sym_DASH] = ACTIONS(7179),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7179),
    [anon_sym_PERCENT] = ACTIONS(7179),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7183),
    [anon_sym_COLON_DASH] = ACTIONS(7179),
    [sym__special_character] = ACTIONS(599),
  },
  [2667] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7181),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2668] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3145),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3145),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7179),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7181),
    [anon_sym_DASH] = ACTIONS(7179),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7179),
    [anon_sym_PERCENT] = ACTIONS(7179),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7183),
    [anon_sym_COLON_DASH] = ACTIONS(7179),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7185),
  },
  [2669] = {
    [sym_process_substitution] = STATE(3147),
    [aux_sym__literal_repeat1] = STATE(3149),
    [sym_simple_expansion] = STATE(3147),
    [sym_string_expansion] = STATE(3147),
    [sym_expansion] = STATE(3147),
    [sym_concatenation] = STATE(3148),
    [sym_string] = STATE(3147),
    [sym_command_substitution] = STATE(3147),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7187),
    [sym_raw_string] = ACTIONS(7187),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7181),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2670] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3152),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3152),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7189),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7191),
    [anon_sym_DASH] = ACTIONS(7189),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7189),
    [anon_sym_PERCENT] = ACTIONS(7189),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7193),
    [anon_sym_COLON_DASH] = ACTIONS(7189),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7195),
  },
  [2671] = {
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [sym_word] = ACTIONS(2604),
    [sym_raw_string] = ACTIONS(2604),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_LT_LPAREN] = ACTIONS(2604),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2604),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
  },
  [2672] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7191),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2673] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7181),
    [sym__concat] = ACTIONS(2610),
  },
  [2674] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7181),
  },
  [2675] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7197),
  },
  [2676] = {
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [sym_word] = ACTIONS(2646),
    [sym_raw_string] = ACTIONS(2646),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_LT_LPAREN] = ACTIONS(2646),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2646),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2646),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2646),
  },
  [2677] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3155),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3155),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7199),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7201),
    [anon_sym_DASH] = ACTIONS(7199),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7203),
    [anon_sym_COLON_DASH] = ACTIONS(7199),
    [sym__special_character] = ACTIONS(599),
  },
  [2678] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7201),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2679] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [ts_builtin_sym_end] = ACTIONS(3832),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [2680] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7205),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2681] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3157),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3157),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7207),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7205),
    [anon_sym_DASH] = ACTIONS(7207),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7207),
    [anon_sym_PERCENT] = ACTIONS(7207),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7209),
    [anon_sym_COLON_DASH] = ACTIONS(7207),
    [sym__special_character] = ACTIONS(599),
  },
  [2682] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7205),
    [sym__concat] = ACTIONS(2610),
  },
  [2683] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7205),
  },
  [2684] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7211),
  },
  [2685] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_RPAREN] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [ts_builtin_sym_end] = ACTIONS(3881),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [2686] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3160),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3160),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7213),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7215),
    [anon_sym_DASH] = ACTIONS(7213),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7213),
    [anon_sym_PERCENT] = ACTIONS(7213),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7217),
    [anon_sym_COLON_DASH] = ACTIONS(7213),
    [sym__special_character] = ACTIONS(599),
  },
  [2687] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7215),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2688] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [2689] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [ts_builtin_sym_end] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [2690] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7219),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2691] = {
    [anon_sym_BQUOTE] = ACTIONS(5097),
    [anon_sym_DQUOTE] = ACTIONS(5097),
    [sym__concat] = ACTIONS(5097),
    [sym__string_content] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5097),
  },
  [2692] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7221),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2693] = {
    [anon_sym_BQUOTE] = ACTIONS(5131),
    [anon_sym_DQUOTE] = ACTIONS(5131),
    [sym__concat] = ACTIONS(5131),
    [sym__string_content] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5131),
  },
  [2694] = {
    [anon_sym_BQUOTE] = ACTIONS(5135),
    [anon_sym_DQUOTE] = ACTIONS(5135),
    [sym__concat] = ACTIONS(5135),
    [sym__string_content] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5135),
  },
  [2695] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7223),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2696] = {
    [anon_sym_BQUOTE] = ACTIONS(5186),
    [anon_sym_DQUOTE] = ACTIONS(5186),
    [sym__concat] = ACTIONS(5186),
    [sym__string_content] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5186),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5186),
  },
  [2697] = {
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
  },
  [2698] = {
    [sym_string] = STATE(1588),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(3437),
    [sym_raw_string] = ACTIONS(7225),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(7227),
    [anon_sym_0] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(7227),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [sym_word] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7227),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym__] = ACTIONS(3437),
  },
  [2699] = {
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
  },
  [2700] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3165),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3165),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7229),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7231),
    [anon_sym_DASH] = ACTIONS(7229),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7229),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7229),
    [anon_sym_PERCENT] = ACTIONS(7229),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7233),
    [anon_sym_COLON_DASH] = ACTIONS(7229),
    [sym__special_character] = ACTIONS(599),
  },
  [2701] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7231),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2702] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3165),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3165),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7229),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7231),
    [anon_sym_DASH] = ACTIONS(7229),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7229),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7229),
    [anon_sym_PERCENT] = ACTIONS(7229),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7233),
    [anon_sym_COLON_DASH] = ACTIONS(7229),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7235),
  },
  [2703] = {
    [sym_process_substitution] = STATE(3167),
    [aux_sym__literal_repeat1] = STATE(3169),
    [sym_simple_expansion] = STATE(3167),
    [sym_string_expansion] = STATE(3167),
    [sym_expansion] = STATE(3167),
    [sym_concatenation] = STATE(3168),
    [sym_string] = STATE(3167),
    [sym_command_substitution] = STATE(3167),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7237),
    [sym_raw_string] = ACTIONS(7237),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7231),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2704] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3172),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3172),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7239),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7241),
    [anon_sym_DASH] = ACTIONS(7239),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7239),
    [anon_sym_PERCENT] = ACTIONS(7239),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7243),
    [anon_sym_COLON_DASH] = ACTIONS(7239),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7245),
  },
  [2705] = {
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
  },
  [2706] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7241),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2707] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7231),
    [sym__concat] = ACTIONS(2610),
  },
  [2708] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7231),
  },
  [2709] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7247),
  },
  [2710] = {
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
  },
  [2711] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3175),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3175),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7249),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7251),
    [anon_sym_DASH] = ACTIONS(7249),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7249),
    [anon_sym_PERCENT] = ACTIONS(7249),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7253),
    [anon_sym_COLON_DASH] = ACTIONS(7249),
    [sym__special_character] = ACTIONS(599),
  },
  [2712] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7251),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2713] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7255),
    [anon_sym_BQUOTE] = ACTIONS(7255),
    [anon_sym_AMP_GT_GT] = ACTIONS(7255),
    [anon_sym_LF] = ACTIONS(7257),
    [anon_sym_SEMI] = ACTIONS(7255),
    [anon_sym_LT_LT] = ACTIONS(7255),
    [sym_file_descriptor] = ACTIONS(7257),
    [anon_sym_GT] = ACTIONS(7255),
    [anon_sym_RPAREN] = ACTIONS(7255),
    [anon_sym_AMP_GT] = ACTIONS(7255),
    [anon_sym_fi] = ACTIONS(7255),
    [anon_sym_else] = ACTIONS(7255),
    [anon_sym_done] = ACTIONS(7255),
    [anon_sym_PIPE_PIPE] = ACTIONS(7255),
    [ts_builtin_sym_end] = ACTIONS(7257),
    [anon_sym_LT_LT_LT] = ACTIONS(7255),
    [anon_sym_PIPE] = ACTIONS(7255),
    [anon_sym_GT_AMP] = ACTIONS(7255),
    [anon_sym_LT] = ACTIONS(7255),
    [anon_sym_LT_AMP] = ACTIONS(7255),
    [anon_sym_GT_GT] = ACTIONS(7255),
    [anon_sym_AMP] = ACTIONS(7255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(7255),
    [anon_sym_AMP_AMP] = ACTIONS(7255),
    [anon_sym_esac] = ACTIONS(7255),
    [anon_sym_SEMI_SEMI] = ACTIONS(7255),
    [anon_sym_PIPE_AMP] = ACTIONS(7255),
  },
  [2714] = {
    [sym_do_group] = STATE(3176),
    [sym_compound_statement] = STATE(3176),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(991),
  },
  [2715] = {
    [sym_do_group] = STATE(3176),
    [sym_compound_statement] = STATE(3176),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(7259),
    [anon_sym_do] = ACTIONS(991),
  },
  [2716] = {
    [anon_sym_BANG_EQ] = ACTIONS(3830),
    [anon_sym_PLUS_EQ] = ACTIONS(3830),
    [sym_test_operator] = ACTIONS(3832),
    [anon_sym_LF] = ACTIONS(3830),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3830),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_EQ] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [anon_sym_GT_EQ] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3830),
    [anon_sym_DASH_DASH] = ACTIONS(3830),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_LT_EQ] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_DASH_EQ] = ACTIONS(3830),
  },
  [2717] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7261),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2718] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3179),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3179),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7263),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7261),
    [anon_sym_DASH] = ACTIONS(7263),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7263),
    [anon_sym_PERCENT] = ACTIONS(7263),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7265),
    [anon_sym_COLON_DASH] = ACTIONS(7263),
    [sym__special_character] = ACTIONS(599),
  },
  [2719] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7261),
    [sym__concat] = ACTIONS(2610),
  },
  [2720] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7261),
  },
  [2721] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7267),
  },
  [2722] = {
    [anon_sym_BANG_EQ] = ACTIONS(3879),
    [anon_sym_PLUS_EQ] = ACTIONS(3879),
    [sym_test_operator] = ACTIONS(3881),
    [anon_sym_LF] = ACTIONS(3879),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3879),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [anon_sym_GT_EQ] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3879),
    [anon_sym_DASH_DASH] = ACTIONS(3879),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_LT_EQ] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_DASH_EQ] = ACTIONS(3879),
  },
  [2723] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3182),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3182),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7269),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7271),
    [anon_sym_DASH] = ACTIONS(7269),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7269),
    [anon_sym_PERCENT] = ACTIONS(7269),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7273),
    [anon_sym_COLON_DASH] = ACTIONS(7269),
    [sym__special_character] = ACTIONS(599),
  },
  [2724] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7271),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2725] = {
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_PLUS_EQ] = ACTIONS(3927),
    [sym_test_operator] = ACTIONS(3929),
    [anon_sym_LF] = ACTIONS(3927),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_PLUS_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_GT_EQ] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3927),
    [anon_sym_DASH_DASH] = ACTIONS(3927),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_DASH_EQ] = ACTIONS(3927),
  },
  [2726] = {
    [anon_sym_BANG_EQ] = ACTIONS(3946),
    [anon_sym_PLUS_EQ] = ACTIONS(3946),
    [sym_test_operator] = ACTIONS(3948),
    [anon_sym_LF] = ACTIONS(3946),
    [anon_sym_SEMI] = ACTIONS(3946),
    [anon_sym_PLUS_PLUS] = ACTIONS(3946),
    [anon_sym_DASH] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_GT_EQ] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_PLUS] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3946),
    [anon_sym_DASH_DASH] = ACTIONS(3946),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_LT_EQ] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_DASH_EQ] = ACTIONS(3946),
  },
  [2727] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7275),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2728] = {
    [anon_sym_BANG_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [sym_test_operator] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7277),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_GT_EQ] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_DASH_EQ] = ACTIONS(869),
  },
  [2729] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_done] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [2730] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_done] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [2731] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(7279),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2732] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2733] = {
    [sym_process_substitution] = STATE(2732),
    [sym_string_expansion] = STATE(2732),
    [sym_expansion] = STATE(2732),
    [sym_simple_expansion] = STATE(2732),
    [sym_string] = STATE(2732),
    [sym_command_substitution] = STATE(2732),
    [anon_sym_BQUOTE] = ACTIONS(6057),
    [anon_sym_DQUOTE] = ACTIONS(4778),
    [sym_word] = ACTIONS(6059),
    [sym_raw_string] = ACTIONS(6059),
    [anon_sym_LT_LPAREN] = ACTIONS(6061),
    [anon_sym_DOLLAR] = ACTIONS(7281),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6063),
    [sym__special_character] = ACTIONS(6059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6065),
  },
  [2734] = {
    [aux_sym_concatenation_repeat1] = STATE(2734),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(7283),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2735] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_done] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [2736] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(3188),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(3188),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(7286),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2737] = {
    [aux_sym_concatenation_repeat1] = STATE(2190),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_done] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(4774),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2738] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_done] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2739] = {
    [aux_sym__literal_repeat1] = STATE(2203),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_done] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(4798),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [2740] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3191),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3191),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7288),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7288),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7292),
    [anon_sym_COLON_DASH] = ACTIONS(7288),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7294),
  },
  [2741] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_done] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [2742] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2743] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3191),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3191),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7296),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7288),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7290),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7288),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7292),
    [anon_sym_COLON_DASH] = ACTIONS(7288),
    [sym__special_character] = ACTIONS(599),
  },
  [2744] = {
    [anon_sym_EQ] = ACTIONS(7298),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2745] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3196),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3196),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7300),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7302),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7304),
    [anon_sym_DASH] = ACTIONS(7302),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7302),
    [anon_sym_PERCENT] = ACTIONS(7302),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7306),
    [anon_sym_COLON_DASH] = ACTIONS(7302),
    [sym__special_character] = ACTIONS(599),
  },
  [2746] = {
    [sym_process_substitution] = STATE(3197),
    [aux_sym__literal_repeat1] = STATE(3199),
    [sym_simple_expansion] = STATE(3197),
    [sym_string_expansion] = STATE(3197),
    [sym_expansion] = STATE(3197),
    [sym_concatenation] = STATE(3198),
    [sym_string] = STATE(3197),
    [sym_command_substitution] = STATE(3197),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7308),
    [sym_raw_string] = ACTIONS(7308),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7290),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2747] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3202),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3202),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7310),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7312),
    [anon_sym_DASH] = ACTIONS(7310),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7310),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7310),
    [anon_sym_PERCENT] = ACTIONS(7310),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7314),
    [anon_sym_COLON_DASH] = ACTIONS(7310),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7316),
  },
  [2748] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_done] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [2749] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7312),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2750] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_done] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [2751] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_done] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [2752] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(7318),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2753] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2754] = {
    [sym_process_substitution] = STATE(2753),
    [sym_string_expansion] = STATE(2753),
    [sym_expansion] = STATE(2753),
    [sym_simple_expansion] = STATE(2753),
    [sym_string] = STATE(2753),
    [sym_command_substitution] = STATE(2753),
    [anon_sym_BQUOTE] = ACTIONS(6144),
    [anon_sym_DQUOTE] = ACTIONS(4808),
    [sym_word] = ACTIONS(6146),
    [sym_raw_string] = ACTIONS(6146),
    [anon_sym_LT_LPAREN] = ACTIONS(6148),
    [anon_sym_DOLLAR] = ACTIONS(7320),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6150),
    [sym__special_character] = ACTIONS(6146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6152),
  },
  [2755] = {
    [aux_sym_concatenation_repeat1] = STATE(2755),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(7322),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2756] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_done] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [2757] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3207),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3207),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7325),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7327),
    [anon_sym_DASH] = ACTIONS(7325),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7325),
    [anon_sym_PERCENT] = ACTIONS(7325),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7329),
    [anon_sym_COLON_DASH] = ACTIONS(7325),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7331),
  },
  [2758] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_done] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [2759] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7327),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2760] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3207),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3207),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7333),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7325),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7327),
    [anon_sym_DASH] = ACTIONS(7325),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7325),
    [anon_sym_PERCENT] = ACTIONS(7325),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7329),
    [anon_sym_COLON_DASH] = ACTIONS(7325),
    [sym__special_character] = ACTIONS(599),
  },
  [2761] = {
    [anon_sym_EQ] = ACTIONS(7335),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2762] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3212),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3212),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7337),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7339),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7341),
    [anon_sym_DASH] = ACTIONS(7339),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7339),
    [anon_sym_PERCENT] = ACTIONS(7339),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7343),
    [anon_sym_COLON_DASH] = ACTIONS(7339),
    [sym__special_character] = ACTIONS(599),
  },
  [2763] = {
    [sym_process_substitution] = STATE(3213),
    [aux_sym__literal_repeat1] = STATE(3215),
    [sym_simple_expansion] = STATE(3213),
    [sym_string_expansion] = STATE(3213),
    [sym_expansion] = STATE(3213),
    [sym_concatenation] = STATE(3214),
    [sym_string] = STATE(3213),
    [sym_command_substitution] = STATE(3213),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7345),
    [sym_raw_string] = ACTIONS(7345),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7327),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2764] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3218),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3218),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7347),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7349),
    [anon_sym_DASH] = ACTIONS(7347),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7347),
    [anon_sym_PERCENT] = ACTIONS(7347),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7351),
    [anon_sym_COLON_DASH] = ACTIONS(7347),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7353),
  },
  [2765] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_done] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [2766] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7349),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2767] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_done] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_EQ_TILDE] = ACTIONS(2506),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [2768] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3220),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3220),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7355),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7357),
    [anon_sym_DASH] = ACTIONS(7355),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7355),
    [anon_sym_PERCENT] = ACTIONS(7355),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7359),
    [anon_sym_COLON_DASH] = ACTIONS(7355),
    [sym__special_character] = ACTIONS(599),
  },
  [2769] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7357),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2770] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3220),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3220),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7355),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7357),
    [anon_sym_DASH] = ACTIONS(7355),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7355),
    [anon_sym_PERCENT] = ACTIONS(7355),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7359),
    [anon_sym_COLON_DASH] = ACTIONS(7355),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7361),
  },
  [2771] = {
    [sym_process_substitution] = STATE(3222),
    [aux_sym__literal_repeat1] = STATE(3224),
    [sym_simple_expansion] = STATE(3222),
    [sym_string_expansion] = STATE(3222),
    [sym_expansion] = STATE(3222),
    [sym_concatenation] = STATE(3223),
    [sym_string] = STATE(3222),
    [sym_command_substitution] = STATE(3222),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7363),
    [sym_raw_string] = ACTIONS(7363),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7357),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2772] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3227),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3227),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7365),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7367),
    [anon_sym_DASH] = ACTIONS(7365),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7365),
    [anon_sym_PERCENT] = ACTIONS(7365),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7369),
    [anon_sym_COLON_DASH] = ACTIONS(7365),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7371),
  },
  [2773] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_done] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [2774] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7367),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2775] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7357),
    [sym__concat] = ACTIONS(2610),
  },
  [2776] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7357),
  },
  [2777] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7373),
  },
  [2778] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_done] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2644),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [2779] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3230),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3230),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7375),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7377),
    [anon_sym_DASH] = ACTIONS(7375),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7375),
    [anon_sym_PERCENT] = ACTIONS(7375),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7379),
    [anon_sym_COLON_DASH] = ACTIONS(7375),
    [sym__special_character] = ACTIONS(599),
  },
  [2780] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7377),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2781] = {
    [sym_string] = STATE(1647),
    [anon_sym__] = ACTIONS(3568),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(7381),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(7381),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_done] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(3568),
    [anon_sym_EQ_TILDE] = ACTIONS(2658),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(3568),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(7383),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(3568),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(3622),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(3568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7381),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [2782] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_done] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [2783] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(7385),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2784] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(7387),
  },
  [2785] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(7389),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2786] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_done] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [2787] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(7391),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(7389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2788] = {
    [sym_process_substitution] = STATE(3235),
    [sym_string_expansion] = STATE(3235),
    [sym_expansion] = STATE(3235),
    [sym_simple_expansion] = STATE(3235),
    [sym_string] = STATE(3235),
    [sym_command_substitution] = STATE(3235),
    [anon_sym_BQUOTE] = ACTIONS(4868),
    [anon_sym_DQUOTE] = ACTIONS(4870),
    [sym_word] = ACTIONS(7393),
    [sym_raw_string] = ACTIONS(7393),
    [anon_sym_LT_LPAREN] = ACTIONS(4874),
    [anon_sym_DOLLAR] = ACTIONS(4876),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [sym__special_character] = ACTIONS(7393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
  },
  [2789] = {
    [aux_sym_concatenation_repeat1] = STATE(3237),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_done] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(7395),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [2790] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7397),
  },
  [2791] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_done] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [2792] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_done] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [2793] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_done] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [2794] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(7387),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [2795] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7387),
  },
  [2796] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3241),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3241),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7399),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7401),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7403),
    [anon_sym_DASH] = ACTIONS(7401),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7401),
    [anon_sym_PERCENT] = ACTIONS(7401),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7405),
    [anon_sym_COLON_DASH] = ACTIONS(7401),
    [sym__special_character] = ACTIONS(599),
  },
  [2797] = {
    [sym_subscript] = STATE(3242),
    [anon_sym_STAR] = ACTIONS(7407),
    [anon_sym_QMARK] = ACTIONS(7407),
    [anon_sym_AT] = ACTIONS(7407),
    [sym_variable_name] = ACTIONS(7409),
    [anon_sym_DOLLAR] = ACTIONS(7411),
    [anon_sym_DASH] = ACTIONS(7411),
    [anon_sym_0] = ACTIONS(7413),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7413),
    [anon_sym__] = ACTIONS(7413),
  },
  [2798] = {
    [anon_sym_EQ] = ACTIONS(7415),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2799] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3248),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3248),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7417),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7419),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7421),
    [anon_sym_DASH] = ACTIONS(7419),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_PERCENT] = ACTIONS(7419),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7423),
    [anon_sym_COLON_DASH] = ACTIONS(7419),
    [sym__special_character] = ACTIONS(599),
  },
  [2800] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_done] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [2801] = {
    [aux_sym__literal_repeat1] = STATE(2801),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_done] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(7425),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [2802] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_done] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_EQ_TILDE] = ACTIONS(3421),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [2803] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(7428),
  },
  [2804] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(7430),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2805] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_done] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [2806] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(7432),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(7430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [2807] = {
    [sym_process_substitution] = STATE(3252),
    [sym_string_expansion] = STATE(3252),
    [sym_expansion] = STATE(3252),
    [sym_simple_expansion] = STATE(3252),
    [sym_string] = STATE(3252),
    [sym_command_substitution] = STATE(3252),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [sym_word] = ACTIONS(7434),
    [sym_raw_string] = ACTIONS(7434),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(4898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [sym__special_character] = ACTIONS(7434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
  },
  [2808] = {
    [aux_sym_concatenation_repeat1] = STATE(3254),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_done] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym__concat] = ACTIONS(7436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [2809] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7438),
  },
  [2810] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_done] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [2811] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_done] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [2812] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_done] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [2813] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(7428),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [2814] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7428),
  },
  [2815] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3258),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3258),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7440),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7442),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7444),
    [anon_sym_DASH] = ACTIONS(7442),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7442),
    [anon_sym_PERCENT] = ACTIONS(7442),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7446),
    [anon_sym_COLON_DASH] = ACTIONS(7442),
    [sym__special_character] = ACTIONS(599),
  },
  [2816] = {
    [sym_subscript] = STATE(3259),
    [anon_sym_STAR] = ACTIONS(7448),
    [anon_sym_QMARK] = ACTIONS(7448),
    [anon_sym_AT] = ACTIONS(7448),
    [sym_variable_name] = ACTIONS(7450),
    [anon_sym_DOLLAR] = ACTIONS(7452),
    [anon_sym_DASH] = ACTIONS(7452),
    [anon_sym_0] = ACTIONS(7454),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7454),
    [anon_sym__] = ACTIONS(7454),
  },
  [2817] = {
    [anon_sym_EQ] = ACTIONS(7456),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2818] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3265),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3265),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7458),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7460),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7462),
    [anon_sym_DASH] = ACTIONS(7460),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7460),
    [anon_sym_PERCENT] = ACTIONS(7460),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7464),
    [anon_sym_COLON_DASH] = ACTIONS(7460),
    [sym__special_character] = ACTIONS(599),
  },
  [2819] = {
    [aux_sym__literal_repeat1] = STATE(2819),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_done] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3701),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [2820] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_done] = ACTIONS(3734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [2821] = {
    [aux_sym_concatenation_repeat1] = STATE(2808),
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_done] = ACTIONS(2004),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym__concat] = ACTIONS(6283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [2822] = {
    [aux_sym__literal_repeat1] = STATE(2819),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_done] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
  },
  [2823] = {
    [anon_sym_AMP] = ACTIONS(7466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_done] = ACTIONS(3734),
    [anon_sym_LF] = ACTIONS(7468),
    [anon_sym_SEMI] = ACTIONS(7466),
    [anon_sym_SEMI_SEMI] = ACTIONS(7466),
  },
  [2824] = {
    [anon_sym_BANG_EQ] = ACTIONS(5097),
    [anon_sym_PLUS_EQ] = ACTIONS(5097),
    [sym_test_operator] = ACTIONS(5097),
    [anon_sym_PLUS_PLUS] = ACTIONS(5097),
    [anon_sym_RBRACK] = ACTIONS(5097),
    [anon_sym_DASH] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_EQ] = ACTIONS(5095),
    [anon_sym_EQ_EQ] = ACTIONS(5097),
    [anon_sym_PIPE_PIPE] = ACTIONS(5097),
    [anon_sym_GT_EQ] = ACTIONS(5097),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(5097),
    [anon_sym_DASH_DASH] = ACTIONS(5097),
    [anon_sym_LT_EQ] = ACTIONS(5097),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_DASH_EQ] = ACTIONS(5097),
  },
  [2825] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7470),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2826] = {
    [anon_sym_BANG_EQ] = ACTIONS(5131),
    [anon_sym_PLUS_EQ] = ACTIONS(5131),
    [sym_test_operator] = ACTIONS(5131),
    [anon_sym_PLUS_PLUS] = ACTIONS(5131),
    [anon_sym_RBRACK] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5131),
    [anon_sym_PIPE_PIPE] = ACTIONS(5131),
    [anon_sym_GT_EQ] = ACTIONS(5131),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_PLUS] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(5131),
    [anon_sym_DASH_DASH] = ACTIONS(5131),
    [anon_sym_LT_EQ] = ACTIONS(5131),
    [anon_sym_AMP_AMP] = ACTIONS(5131),
    [anon_sym_DASH_EQ] = ACTIONS(5131),
  },
  [2827] = {
    [anon_sym_BANG_EQ] = ACTIONS(5135),
    [anon_sym_PLUS_EQ] = ACTIONS(5135),
    [sym_test_operator] = ACTIONS(5135),
    [anon_sym_PLUS_PLUS] = ACTIONS(5135),
    [anon_sym_RBRACK] = ACTIONS(5135),
    [anon_sym_DASH] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_EQ] = ACTIONS(5133),
    [anon_sym_EQ_EQ] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5135),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(5135),
    [anon_sym_DASH_DASH] = ACTIONS(5135),
    [anon_sym_LT_EQ] = ACTIONS(5135),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_DASH_EQ] = ACTIONS(5135),
  },
  [2828] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7472),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2829] = {
    [anon_sym_BANG_EQ] = ACTIONS(5186),
    [anon_sym_PLUS_EQ] = ACTIONS(5186),
    [sym_test_operator] = ACTIONS(5186),
    [anon_sym_PLUS_PLUS] = ACTIONS(5186),
    [anon_sym_RBRACK] = ACTIONS(5186),
    [anon_sym_DASH] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_EQ] = ACTIONS(5184),
    [anon_sym_EQ_EQ] = ACTIONS(5186),
    [anon_sym_PIPE_PIPE] = ACTIONS(5186),
    [anon_sym_GT_EQ] = ACTIONS(5186),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_PLUS] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(5186),
    [anon_sym_DASH_DASH] = ACTIONS(5186),
    [anon_sym_LT_EQ] = ACTIONS(5186),
    [anon_sym_AMP_AMP] = ACTIONS(5186),
    [anon_sym_DASH_EQ] = ACTIONS(5186),
  },
  [2830] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_esac] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_RPAREN] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_fi] = ACTIONS(3830),
    [anon_sym_else] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [ts_builtin_sym_end] = ACTIONS(3832),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_elif] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [2831] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7474),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2832] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3270),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3270),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7476),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7474),
    [anon_sym_DASH] = ACTIONS(7476),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7476),
    [anon_sym_PERCENT] = ACTIONS(7476),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7478),
    [anon_sym_COLON_DASH] = ACTIONS(7476),
    [sym__special_character] = ACTIONS(599),
  },
  [2833] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7474),
    [sym__concat] = ACTIONS(2610),
  },
  [2834] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7474),
  },
  [2835] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7480),
  },
  [2836] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_esac] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_RPAREN] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_fi] = ACTIONS(3879),
    [anon_sym_else] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [ts_builtin_sym_end] = ACTIONS(3881),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_elif] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [2837] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3273),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3273),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7482),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(7482),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7482),
    [anon_sym_PERCENT] = ACTIONS(7482),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7486),
    [anon_sym_COLON_DASH] = ACTIONS(7482),
    [sym__special_character] = ACTIONS(599),
  },
  [2838] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7484),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2839] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_esac] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_RPAREN] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_fi] = ACTIONS(3927),
    [anon_sym_else] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [ts_builtin_sym_end] = ACTIONS(3929),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_elif] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [2840] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_RPAREN] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_fi] = ACTIONS(3946),
    [anon_sym_else] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [ts_builtin_sym_end] = ACTIONS(3948),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_elif] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [2841] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7488),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2842] = {
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2508),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2508),
    [sym__heredoc_body_end] = ACTIONS(2508),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2508),
    [sym__heredoc_body_middle] = ACTIONS(2508),
  },
  [2843] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3276),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3276),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_PERCENT] = ACTIONS(7490),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7494),
    [anon_sym_COLON_DASH] = ACTIONS(7490),
    [sym__special_character] = ACTIONS(599),
  },
  [2844] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2845] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3276),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3276),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7490),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7492),
    [anon_sym_DASH] = ACTIONS(7490),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7490),
    [anon_sym_PERCENT] = ACTIONS(7490),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7494),
    [anon_sym_COLON_DASH] = ACTIONS(7490),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7496),
  },
  [2846] = {
    [sym_process_substitution] = STATE(3278),
    [aux_sym__literal_repeat1] = STATE(3280),
    [sym_simple_expansion] = STATE(3278),
    [sym_string_expansion] = STATE(3278),
    [sym_expansion] = STATE(3278),
    [sym_concatenation] = STATE(3279),
    [sym_string] = STATE(3278),
    [sym_command_substitution] = STATE(3278),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7498),
    [sym_raw_string] = ACTIONS(7498),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7492),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2847] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3283),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3283),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7500),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7502),
    [anon_sym_DASH] = ACTIONS(7500),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7500),
    [anon_sym_PERCENT] = ACTIONS(7500),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7504),
    [anon_sym_COLON_DASH] = ACTIONS(7500),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7506),
  },
  [2848] = {
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2604),
    [sym__heredoc_body_end] = ACTIONS(2604),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2604),
    [sym__heredoc_body_middle] = ACTIONS(2604),
  },
  [2849] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7502),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2850] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7492),
    [sym__concat] = ACTIONS(2610),
  },
  [2851] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7492),
  },
  [2852] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7508),
  },
  [2853] = {
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2646),
    [sym__heredoc_body_end] = ACTIONS(2646),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2646),
    [sym__heredoc_body_middle] = ACTIONS(2646),
  },
  [2854] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3286),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3286),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7510),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7512),
    [anon_sym_DASH] = ACTIONS(7510),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7514),
    [anon_sym_COLON_DASH] = ACTIONS(7510),
    [sym__special_character] = ACTIONS(599),
  },
  [2855] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7512),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2856] = {
    [anon_sym_BQUOTE] = ACTIONS(6453),
    [anon_sym_AMP_GT_GT] = ACTIONS(6453),
    [sym_raw_string] = ACTIONS(6453),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [sym_variable_name] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6453),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6453),
    [anon_sym_GT_LPAREN] = ACTIONS(6453),
    [anon_sym_RPAREN] = ACTIONS(6453),
    [anon_sym_DQUOTE] = ACTIONS(6453),
    [sym_word] = ACTIONS(6453),
    [anon_sym_GT_AMP] = ACTIONS(6453),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6453),
    [anon_sym_GT_GT] = ACTIONS(6453),
    [anon_sym_LT_LPAREN] = ACTIONS(6453),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(6453),
  },
  [2857] = {
    [anon_sym_BQUOTE] = ACTIONS(6457),
    [anon_sym_AMP_GT_GT] = ACTIONS(6457),
    [sym_raw_string] = ACTIONS(6457),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [sym_variable_name] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6457),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6457),
    [anon_sym_GT_LPAREN] = ACTIONS(6457),
    [anon_sym_RPAREN] = ACTIONS(6457),
    [anon_sym_DQUOTE] = ACTIONS(6457),
    [sym_word] = ACTIONS(6457),
    [anon_sym_GT_AMP] = ACTIONS(6457),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6457),
    [anon_sym_GT_GT] = ACTIONS(6457),
    [anon_sym_LT_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(6457),
  },
  [2858] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_RPAREN] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [ts_builtin_sym_end] = ACTIONS(6453),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [2859] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_RPAREN] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [ts_builtin_sym_end] = ACTIONS(6457),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [2860] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_RPAREN] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [ts_builtin_sym_end] = ACTIONS(6453),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [2861] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_RPAREN] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [ts_builtin_sym_end] = ACTIONS(6457),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [2862] = {
    [anon_sym_BQUOTE] = ACTIONS(5097),
    [sym_raw_string] = ACTIONS(5097),
    [anon_sym_COLON_QMARK] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [anon_sym_DASH] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5097),
    [anon_sym_EQ] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5097),
    [anon_sym_PERCENT] = ACTIONS(5095),
    [anon_sym_COLON] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5097),
    [anon_sym_DQUOTE] = ACTIONS(5097),
    [sym_word] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_LT_LPAREN] = ACTIONS(5097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5097),
    [anon_sym_COLON_DASH] = ACTIONS(5095),
    [sym__special_character] = ACTIONS(5095),
  },
  [2863] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7516),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2864] = {
    [anon_sym_BQUOTE] = ACTIONS(5131),
    [sym_raw_string] = ACTIONS(5131),
    [anon_sym_COLON_QMARK] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5131),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5131),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_COLON] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5131),
    [anon_sym_DQUOTE] = ACTIONS(5131),
    [sym_word] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_LT_LPAREN] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5131),
    [anon_sym_COLON_DASH] = ACTIONS(5129),
    [sym__special_character] = ACTIONS(5129),
  },
  [2865] = {
    [anon_sym_BQUOTE] = ACTIONS(5135),
    [sym_raw_string] = ACTIONS(5135),
    [anon_sym_COLON_QMARK] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_RBRACE] = ACTIONS(5135),
    [anon_sym_DASH] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5135),
    [anon_sym_EQ] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5135),
    [anon_sym_PERCENT] = ACTIONS(5133),
    [anon_sym_COLON] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5135),
    [anon_sym_DQUOTE] = ACTIONS(5135),
    [sym_word] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_LT_LPAREN] = ACTIONS(5135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5135),
    [anon_sym_COLON_DASH] = ACTIONS(5133),
    [sym__special_character] = ACTIONS(5133),
  },
  [2866] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7518),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2867] = {
    [anon_sym_BQUOTE] = ACTIONS(5186),
    [sym_raw_string] = ACTIONS(5186),
    [anon_sym_COLON_QMARK] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_RBRACE] = ACTIONS(5186),
    [anon_sym_DASH] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5186),
    [anon_sym_EQ] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5186),
    [anon_sym_PERCENT] = ACTIONS(5184),
    [anon_sym_COLON] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5186),
    [anon_sym_DQUOTE] = ACTIONS(5186),
    [sym_word] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_LT_LPAREN] = ACTIONS(5186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5186),
    [anon_sym_COLON_DASH] = ACTIONS(5184),
    [sym__special_character] = ACTIONS(5184),
  },
  [2868] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3832),
    [sym__concat] = ACTIONS(3832),
  },
  [2869] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7520),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2870] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3290),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3290),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7522),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7520),
    [anon_sym_DASH] = ACTIONS(7522),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7522),
    [anon_sym_PERCENT] = ACTIONS(7522),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7524),
    [anon_sym_COLON_DASH] = ACTIONS(7522),
    [sym__special_character] = ACTIONS(599),
  },
  [2871] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7520),
    [sym__concat] = ACTIONS(2610),
  },
  [2872] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7520),
  },
  [2873] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7526),
  },
  [2874] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [sym__concat] = ACTIONS(3881),
  },
  [2875] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3293),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3293),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(7528),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7528),
    [anon_sym_PERCENT] = ACTIONS(7528),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7532),
    [anon_sym_COLON_DASH] = ACTIONS(7528),
    [sym__special_character] = ACTIONS(599),
  },
  [2876] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7530),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2877] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
  },
  [2878] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3948),
    [sym__concat] = ACTIONS(3948),
  },
  [2879] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7534),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2880] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [2881] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7536),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2882] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [2883] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [2884] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7538),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2885] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_RBRACE] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [2886] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [2887] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7540),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2888] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [2889] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [2890] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7542),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2891] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_RBRACE] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [2892] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_EQ_TILDE] = ACTIONS(6451),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_RBRACE] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_EQ_EQ] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [2893] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_EQ_TILDE] = ACTIONS(6455),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_RBRACE] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [2894] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7022),
    [anon_sym_AMP_GT_GT] = ACTIONS(7022),
    [anon_sym_LF] = ACTIONS(7024),
    [anon_sym_SEMI] = ACTIONS(7022),
    [anon_sym_LT_LT] = ACTIONS(7022),
    [anon_sym_RBRACE] = ACTIONS(7022),
    [anon_sym_GT] = ACTIONS(7022),
    [sym_file_descriptor] = ACTIONS(7024),
    [anon_sym_AMP_GT] = ACTIONS(7022),
    [anon_sym_PIPE_PIPE] = ACTIONS(7022),
    [anon_sym_LT_LT_LT] = ACTIONS(7022),
    [anon_sym_PIPE] = ACTIONS(7022),
    [anon_sym_GT_AMP] = ACTIONS(7022),
    [anon_sym_LT] = ACTIONS(7022),
    [anon_sym_LT_AMP] = ACTIONS(7022),
    [anon_sym_GT_GT] = ACTIONS(7022),
    [anon_sym_AMP] = ACTIONS(7022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(7022),
    [anon_sym_SEMI_SEMI] = ACTIONS(7022),
    [anon_sym_PIPE_AMP] = ACTIONS(7022),
  },
  [2895] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7030),
    [anon_sym_AMP_GT_GT] = ACTIONS(7030),
    [anon_sym_LF] = ACTIONS(7032),
    [anon_sym_SEMI] = ACTIONS(7030),
    [anon_sym_LT_LT] = ACTIONS(7030),
    [anon_sym_RBRACE] = ACTIONS(7030),
    [anon_sym_GT] = ACTIONS(7030),
    [sym_file_descriptor] = ACTIONS(7032),
    [anon_sym_AMP_GT] = ACTIONS(7030),
    [anon_sym_PIPE_PIPE] = ACTIONS(7030),
    [anon_sym_LT_LT_LT] = ACTIONS(7030),
    [anon_sym_PIPE] = ACTIONS(7030),
    [anon_sym_GT_AMP] = ACTIONS(7030),
    [anon_sym_LT] = ACTIONS(7030),
    [anon_sym_LT_AMP] = ACTIONS(7030),
    [anon_sym_GT_GT] = ACTIONS(7030),
    [anon_sym_AMP] = ACTIONS(7030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(7030),
    [anon_sym_SEMI_SEMI] = ACTIONS(7030),
    [anon_sym_PIPE_AMP] = ACTIONS(7030),
  },
  [2896] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(7544),
  },
  [2897] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7167),
    [anon_sym_AMP_GT_GT] = ACTIONS(7167),
    [anon_sym_LF] = ACTIONS(7169),
    [anon_sym_SEMI] = ACTIONS(7167),
    [anon_sym_LT_LT] = ACTIONS(7167),
    [anon_sym_RBRACE] = ACTIONS(7167),
    [anon_sym_GT] = ACTIONS(7167),
    [sym_file_descriptor] = ACTIONS(7169),
    [anon_sym_AMP_GT] = ACTIONS(7167),
    [anon_sym_PIPE_PIPE] = ACTIONS(7167),
    [anon_sym_LT_LT_LT] = ACTIONS(7167),
    [anon_sym_PIPE] = ACTIONS(7167),
    [anon_sym_GT_AMP] = ACTIONS(7167),
    [anon_sym_LT] = ACTIONS(7167),
    [anon_sym_LT_AMP] = ACTIONS(7167),
    [anon_sym_GT_GT] = ACTIONS(7167),
    [anon_sym_AMP] = ACTIONS(7167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(7167),
    [anon_sym_SEMI_SEMI] = ACTIONS(7167),
    [anon_sym_PIPE_AMP] = ACTIONS(7167),
  },
  [2898] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(7546),
  },
  [2899] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [2900] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7548),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2901] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3302),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3302),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7550),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7548),
    [anon_sym_DASH] = ACTIONS(7550),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7550),
    [anon_sym_PERCENT] = ACTIONS(7550),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7552),
    [anon_sym_COLON_DASH] = ACTIONS(7550),
    [sym__special_character] = ACTIONS(599),
  },
  [2902] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7548),
    [sym__concat] = ACTIONS(2610),
  },
  [2903] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7548),
  },
  [2904] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7554),
  },
  [2905] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [2906] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3305),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3305),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7556),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7558),
    [anon_sym_DASH] = ACTIONS(7556),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7556),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_PERCENT] = ACTIONS(7556),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7560),
    [anon_sym_COLON_DASH] = ACTIONS(7556),
    [sym__special_character] = ACTIONS(599),
  },
  [2907] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7558),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2908] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [2909] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [2910] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7562),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2911] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7255),
    [anon_sym_AMP_GT_GT] = ACTIONS(7255),
    [anon_sym_LF] = ACTIONS(7257),
    [anon_sym_SEMI] = ACTIONS(7255),
    [anon_sym_LT_LT] = ACTIONS(7255),
    [anon_sym_RBRACE] = ACTIONS(7255),
    [anon_sym_GT] = ACTIONS(7255),
    [sym_file_descriptor] = ACTIONS(7257),
    [anon_sym_AMP_GT] = ACTIONS(7255),
    [anon_sym_PIPE_PIPE] = ACTIONS(7255),
    [anon_sym_LT_LT_LT] = ACTIONS(7255),
    [anon_sym_PIPE] = ACTIONS(7255),
    [anon_sym_GT_AMP] = ACTIONS(7255),
    [anon_sym_LT] = ACTIONS(7255),
    [anon_sym_LT_AMP] = ACTIONS(7255),
    [anon_sym_GT_GT] = ACTIONS(7255),
    [anon_sym_AMP] = ACTIONS(7255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(7255),
    [anon_sym_SEMI_SEMI] = ACTIONS(7255),
    [anon_sym_PIPE_AMP] = ACTIONS(7255),
  },
  [2912] = {
    [sym_do_group] = STATE(3307),
    [sym_compound_statement] = STATE(3307),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(1703),
  },
  [2913] = {
    [sym_do_group] = STATE(3307),
    [sym_compound_statement] = STATE(3307),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(7564),
    [anon_sym_do] = ACTIONS(1703),
  },
  [2914] = {
    [anon_sym_BANG_EQ] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(869),
    [sym_test_operator] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(873),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7566),
    [anon_sym_PIPE_PIPE] = ACTIONS(869),
    [anon_sym_GT_EQ] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(871),
    [anon_sym_LT_EQ] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(869),
    [anon_sym_DASH_EQ] = ACTIONS(869),
  },
  [2915] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_RBRACE] = ACTIONS(3830),
    [anon_sym_GT] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [2916] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7568),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2917] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3311),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3311),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7570),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7568),
    [anon_sym_DASH] = ACTIONS(7570),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7570),
    [anon_sym_PERCENT] = ACTIONS(7570),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7572),
    [anon_sym_COLON_DASH] = ACTIONS(7570),
    [sym__special_character] = ACTIONS(599),
  },
  [2918] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7568),
    [sym__concat] = ACTIONS(2610),
  },
  [2919] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7568),
  },
  [2920] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7574),
  },
  [2921] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_RBRACE] = ACTIONS(3879),
    [anon_sym_GT] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [2922] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3314),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3314),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7576),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7578),
    [anon_sym_DASH] = ACTIONS(7576),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7576),
    [anon_sym_PERCENT] = ACTIONS(7576),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7580),
    [anon_sym_COLON_DASH] = ACTIONS(7576),
    [sym__special_character] = ACTIONS(599),
  },
  [2923] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7578),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2924] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_RBRACE] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [2925] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_GT] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [2926] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7582),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2927] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_fi] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_elif] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [2928] = {
    [sym_string] = STATE(1921),
    [anon_sym__] = ACTIONS(4192),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(7584),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(7584),
    [anon_sym_fi] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_else] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(4192),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(7586),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(4192),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(3045),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(4192),
    [anon_sym_elif] = ACTIONS(2658),
    [anon_sym_POUND] = ACTIONS(7584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [2929] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_fi] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [anon_sym_else] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [anon_sym_elif] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [2930] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(7588),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2931] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [anon_sym_elif] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [2932] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3318),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3318),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7590),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7592),
    [anon_sym_DASH] = ACTIONS(7590),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7590),
    [anon_sym_PERCENT] = ACTIONS(7590),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7594),
    [anon_sym_COLON_DASH] = ACTIONS(7590),
    [sym__special_character] = ACTIONS(599),
  },
  [2933] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7592),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2934] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3318),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3318),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7590),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7592),
    [anon_sym_DASH] = ACTIONS(7590),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7590),
    [anon_sym_PERCENT] = ACTIONS(7590),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7594),
    [anon_sym_COLON_DASH] = ACTIONS(7590),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7596),
  },
  [2935] = {
    [sym_process_substitution] = STATE(3320),
    [aux_sym__literal_repeat1] = STATE(3322),
    [sym_simple_expansion] = STATE(3320),
    [sym_string_expansion] = STATE(3320),
    [sym_expansion] = STATE(3320),
    [sym_concatenation] = STATE(3321),
    [sym_string] = STATE(3320),
    [sym_command_substitution] = STATE(3320),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7598),
    [sym_raw_string] = ACTIONS(7598),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7592),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2936] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3325),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3325),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7600),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7602),
    [anon_sym_DASH] = ACTIONS(7600),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7600),
    [anon_sym_PERCENT] = ACTIONS(7600),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7604),
    [anon_sym_COLON_DASH] = ACTIONS(7600),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7606),
  },
  [2937] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_else] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [anon_sym_elif] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [2938] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7602),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2939] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7592),
    [sym__concat] = ACTIONS(2610),
  },
  [2940] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7592),
  },
  [2941] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7608),
  },
  [2942] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_fi] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_elif] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [2943] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3328),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3328),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7610),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7612),
    [anon_sym_DASH] = ACTIONS(7610),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7614),
    [anon_sym_COLON_DASH] = ACTIONS(7610),
    [sym__special_character] = ACTIONS(599),
  },
  [2944] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7612),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2945] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_fi] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_elif] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [2946] = {
    [sym_string] = STATE(1940),
    [anon_sym__] = ACTIONS(4222),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(7616),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(7616),
    [anon_sym_fi] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_else] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4222),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(4222),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(4222),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(7618),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(4222),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(4222),
    [anon_sym_elif] = ACTIONS(2658),
    [anon_sym_POUND] = ACTIONS(7616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [2947] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [anon_sym_elif] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [2948] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3330),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3330),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7620),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7622),
    [anon_sym_DASH] = ACTIONS(7620),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7620),
    [anon_sym_PERCENT] = ACTIONS(7620),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7624),
    [anon_sym_COLON_DASH] = ACTIONS(7620),
    [sym__special_character] = ACTIONS(599),
  },
  [2949] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7622),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2950] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3330),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3330),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7620),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7622),
    [anon_sym_DASH] = ACTIONS(7620),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7620),
    [anon_sym_PERCENT] = ACTIONS(7620),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7624),
    [anon_sym_COLON_DASH] = ACTIONS(7620),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7626),
  },
  [2951] = {
    [sym_process_substitution] = STATE(3332),
    [aux_sym__literal_repeat1] = STATE(3334),
    [sym_simple_expansion] = STATE(3332),
    [sym_string_expansion] = STATE(3332),
    [sym_expansion] = STATE(3332),
    [sym_concatenation] = STATE(3333),
    [sym_string] = STATE(3332),
    [sym_command_substitution] = STATE(3332),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7628),
    [sym_raw_string] = ACTIONS(7628),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7622),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2952] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3337),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3337),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7630),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7632),
    [anon_sym_DASH] = ACTIONS(7630),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7630),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7630),
    [anon_sym_PERCENT] = ACTIONS(7630),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7634),
    [anon_sym_COLON_DASH] = ACTIONS(7630),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7636),
  },
  [2953] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_else] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [anon_sym_elif] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [2954] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7632),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2955] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7622),
    [sym__concat] = ACTIONS(2610),
  },
  [2956] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7622),
  },
  [2957] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7638),
  },
  [2958] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_fi] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_elif] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [2959] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3340),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3340),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7640),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7642),
    [anon_sym_DASH] = ACTIONS(7640),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7640),
    [anon_sym_PERCENT] = ACTIONS(7640),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7644),
    [anon_sym_COLON_DASH] = ACTIONS(7640),
    [sym__special_character] = ACTIONS(599),
  },
  [2960] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7642),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2961] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_fi] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [2962] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_fi] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [2963] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2964] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2965] = {
    [sym_process_substitution] = STATE(2964),
    [sym_string_expansion] = STATE(2964),
    [sym_expansion] = STATE(2964),
    [sym_simple_expansion] = STATE(2964),
    [sym_string] = STATE(2964),
    [sym_command_substitution] = STATE(2964),
    [anon_sym_BQUOTE] = ACTIONS(6681),
    [anon_sym_DQUOTE] = ACTIONS(5527),
    [sym_word] = ACTIONS(6683),
    [sym_raw_string] = ACTIONS(6683),
    [anon_sym_LT_LPAREN] = ACTIONS(6685),
    [anon_sym_DOLLAR] = ACTIONS(7648),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6685),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6687),
    [sym__special_character] = ACTIONS(6683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6689),
  },
  [2966] = {
    [aux_sym_concatenation_repeat1] = STATE(2966),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(7650),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2967] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_fi] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [2968] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(3344),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(3344),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(7653),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [2969] = {
    [aux_sym_concatenation_repeat1] = STATE(2487),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_fi] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(5523),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2970] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_fi] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [2971] = {
    [aux_sym__literal_repeat1] = STATE(2500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_fi] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(5547),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [2972] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3347),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3347),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7655),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DASH] = ACTIONS(7655),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7655),
    [anon_sym_PERCENT] = ACTIONS(7655),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7659),
    [anon_sym_COLON_DASH] = ACTIONS(7655),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7661),
  },
  [2973] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_fi] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [2974] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2975] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3347),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3347),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7663),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7655),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DASH] = ACTIONS(7655),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7655),
    [anon_sym_PERCENT] = ACTIONS(7655),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7659),
    [anon_sym_COLON_DASH] = ACTIONS(7655),
    [sym__special_character] = ACTIONS(599),
  },
  [2976] = {
    [anon_sym_EQ] = ACTIONS(7665),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2977] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3352),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3352),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7667),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7669),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7671),
    [anon_sym_DASH] = ACTIONS(7669),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7669),
    [anon_sym_PERCENT] = ACTIONS(7669),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7673),
    [anon_sym_COLON_DASH] = ACTIONS(7669),
    [sym__special_character] = ACTIONS(599),
  },
  [2978] = {
    [sym_process_substitution] = STATE(3353),
    [aux_sym__literal_repeat1] = STATE(3355),
    [sym_simple_expansion] = STATE(3353),
    [sym_string_expansion] = STATE(3353),
    [sym_expansion] = STATE(3353),
    [sym_concatenation] = STATE(3354),
    [sym_string] = STATE(3353),
    [sym_command_substitution] = STATE(3353),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7675),
    [sym_raw_string] = ACTIONS(7675),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2979] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3358),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3358),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7677),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7679),
    [anon_sym_DASH] = ACTIONS(7677),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7677),
    [anon_sym_PERCENT] = ACTIONS(7677),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7681),
    [anon_sym_COLON_DASH] = ACTIONS(7677),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7683),
  },
  [2980] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_fi] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [2981] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7679),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2982] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_fi] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [2983] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_fi] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [2984] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(7685),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [2985] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2986] = {
    [sym_process_substitution] = STATE(2985),
    [sym_string_expansion] = STATE(2985),
    [sym_expansion] = STATE(2985),
    [sym_simple_expansion] = STATE(2985),
    [sym_string] = STATE(2985),
    [sym_command_substitution] = STATE(2985),
    [anon_sym_BQUOTE] = ACTIONS(6768),
    [anon_sym_DQUOTE] = ACTIONS(5557),
    [sym_word] = ACTIONS(6770),
    [sym_raw_string] = ACTIONS(6770),
    [anon_sym_LT_LPAREN] = ACTIONS(6772),
    [anon_sym_DOLLAR] = ACTIONS(7687),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6774),
    [sym__special_character] = ACTIONS(6770),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6776),
  },
  [2987] = {
    [aux_sym_concatenation_repeat1] = STATE(2987),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(7689),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [2988] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_fi] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [2989] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3363),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3363),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7692),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7694),
    [anon_sym_DASH] = ACTIONS(7692),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7692),
    [anon_sym_PERCENT] = ACTIONS(7692),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7696),
    [anon_sym_COLON_DASH] = ACTIONS(7692),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7698),
  },
  [2990] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_fi] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [2991] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7694),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2992] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3363),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3363),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7700),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7692),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7694),
    [anon_sym_DASH] = ACTIONS(7692),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7692),
    [anon_sym_PERCENT] = ACTIONS(7692),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7696),
    [anon_sym_COLON_DASH] = ACTIONS(7692),
    [sym__special_character] = ACTIONS(599),
  },
  [2993] = {
    [anon_sym_EQ] = ACTIONS(7702),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [2994] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3368),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3368),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7704),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7706),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7708),
    [anon_sym_DASH] = ACTIONS(7706),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7706),
    [anon_sym_PERCENT] = ACTIONS(7706),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7710),
    [anon_sym_COLON_DASH] = ACTIONS(7706),
    [sym__special_character] = ACTIONS(599),
  },
  [2995] = {
    [sym_process_substitution] = STATE(3369),
    [aux_sym__literal_repeat1] = STATE(3371),
    [sym_simple_expansion] = STATE(3369),
    [sym_string_expansion] = STATE(3369),
    [sym_expansion] = STATE(3369),
    [sym_concatenation] = STATE(3370),
    [sym_string] = STATE(3369),
    [sym_command_substitution] = STATE(3369),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7712),
    [sym_raw_string] = ACTIONS(7712),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7694),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [2996] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3374),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3374),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7714),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7716),
    [anon_sym_DASH] = ACTIONS(7714),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7714),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7714),
    [anon_sym_PERCENT] = ACTIONS(7714),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7718),
    [anon_sym_COLON_DASH] = ACTIONS(7714),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7720),
  },
  [2997] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_fi] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [2998] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7716),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [2999] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_EQ_TILDE] = ACTIONS(2506),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3000] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3376),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3376),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7722),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_DASH] = ACTIONS(7722),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7722),
    [anon_sym_PERCENT] = ACTIONS(7722),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7726),
    [anon_sym_COLON_DASH] = ACTIONS(7722),
    [sym__special_character] = ACTIONS(599),
  },
  [3001] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3002] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3376),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3376),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7722),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_DASH] = ACTIONS(7722),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7722),
    [anon_sym_PERCENT] = ACTIONS(7722),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7726),
    [anon_sym_COLON_DASH] = ACTIONS(7722),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7728),
  },
  [3003] = {
    [sym_process_substitution] = STATE(3378),
    [aux_sym__literal_repeat1] = STATE(3380),
    [sym_simple_expansion] = STATE(3378),
    [sym_string_expansion] = STATE(3378),
    [sym_expansion] = STATE(3378),
    [sym_concatenation] = STATE(3379),
    [sym_string] = STATE(3378),
    [sym_command_substitution] = STATE(3378),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7730),
    [sym_raw_string] = ACTIONS(7730),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3004] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3383),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3383),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7732),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7734),
    [anon_sym_DASH] = ACTIONS(7732),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7732),
    [anon_sym_PERCENT] = ACTIONS(7732),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7736),
    [anon_sym_COLON_DASH] = ACTIONS(7732),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7738),
  },
  [3005] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3006] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7734),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3007] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [sym__concat] = ACTIONS(2610),
  },
  [3008] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7724),
  },
  [3009] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7740),
  },
  [3010] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_fi] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2644),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3011] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3386),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3386),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7742),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7744),
    [anon_sym_DASH] = ACTIONS(7742),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7742),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7742),
    [anon_sym_PERCENT] = ACTIONS(7742),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7746),
    [anon_sym_COLON_DASH] = ACTIONS(7742),
    [sym__special_character] = ACTIONS(599),
  },
  [3012] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7744),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3013] = {
    [sym_string] = STATE(1976),
    [anon_sym__] = ACTIONS(4286),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(7748),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(7748),
    [anon_sym_fi] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4286),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(4286),
    [anon_sym_EQ_TILDE] = ACTIONS(2658),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(4286),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(7750),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(4286),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(4336),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7748),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3014] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_fi] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [3015] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(7752),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [3016] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(7754),
  },
  [3017] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(7756),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3018] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_fi] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [3019] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(7758),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(7756),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [3020] = {
    [sym_process_substitution] = STATE(3391),
    [sym_string_expansion] = STATE(3391),
    [sym_expansion] = STATE(3391),
    [sym_simple_expansion] = STATE(3391),
    [sym_string] = STATE(3391),
    [sym_command_substitution] = STATE(3391),
    [anon_sym_BQUOTE] = ACTIONS(5617),
    [anon_sym_DQUOTE] = ACTIONS(5619),
    [sym_word] = ACTIONS(7760),
    [sym_raw_string] = ACTIONS(7760),
    [anon_sym_LT_LPAREN] = ACTIONS(5623),
    [anon_sym_DOLLAR] = ACTIONS(5625),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5627),
    [sym__special_character] = ACTIONS(7760),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5631),
  },
  [3021] = {
    [aux_sym_concatenation_repeat1] = STATE(3393),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(7762),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [3022] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7764),
  },
  [3023] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_fi] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [3024] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_fi] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [3025] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_fi] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [3026] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(7754),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [3027] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7754),
  },
  [3028] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3397),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3397),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7766),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7768),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7770),
    [anon_sym_DASH] = ACTIONS(7768),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7768),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7768),
    [anon_sym_PERCENT] = ACTIONS(7768),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7772),
    [anon_sym_COLON_DASH] = ACTIONS(7768),
    [sym__special_character] = ACTIONS(599),
  },
  [3029] = {
    [sym_subscript] = STATE(3398),
    [anon_sym_STAR] = ACTIONS(7774),
    [anon_sym_QMARK] = ACTIONS(7774),
    [anon_sym_AT] = ACTIONS(7774),
    [sym_variable_name] = ACTIONS(7776),
    [anon_sym_DOLLAR] = ACTIONS(7778),
    [anon_sym_DASH] = ACTIONS(7778),
    [anon_sym_0] = ACTIONS(7780),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7780),
    [anon_sym__] = ACTIONS(7780),
  },
  [3030] = {
    [anon_sym_EQ] = ACTIONS(7782),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3031] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3404),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3404),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7784),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7786),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7788),
    [anon_sym_DASH] = ACTIONS(7786),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7786),
    [anon_sym_PERCENT] = ACTIONS(7786),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7790),
    [anon_sym_COLON_DASH] = ACTIONS(7786),
    [sym__special_character] = ACTIONS(599),
  },
  [3032] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_fi] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [3033] = {
    [aux_sym__literal_repeat1] = STATE(3033),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(7792),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [3034] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_fi] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_EQ_TILDE] = ACTIONS(3421),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3035] = {
    [aux_sym_concatenation_repeat1] = STATE(3406),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_fi] = ACTIONS(627),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym__concat] = ACTIONS(7795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [3036] = {
    [aux_sym__literal_repeat1] = STATE(3036),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_fi] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3701),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [3037] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_fi] = ACTIONS(3734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [3038] = {
    [aux_sym_concatenation_repeat1] = STATE(3035),
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_fi] = ACTIONS(2004),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym__concat] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [3039] = {
    [aux_sym__literal_repeat1] = STATE(3036),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_fi] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
  },
  [3040] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_fi] = ACTIONS(3734),
    [anon_sym_LF] = ACTIONS(7797),
    [anon_sym_SEMI] = ACTIONS(7799),
    [anon_sym_SEMI_SEMI] = ACTIONS(7799),
    [anon_sym_AMP] = ACTIONS(7799),
  },
  [3041] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_fi] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_else] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_EQ_TILDE] = ACTIONS(3830),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [anon_sym_elif] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3042] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7801),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3043] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3409),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3409),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7803),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7801),
    [anon_sym_DASH] = ACTIONS(7803),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7803),
    [anon_sym_PERCENT] = ACTIONS(7803),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7805),
    [anon_sym_COLON_DASH] = ACTIONS(7803),
    [sym__special_character] = ACTIONS(599),
  },
  [3044] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7801),
    [sym__concat] = ACTIONS(2610),
  },
  [3045] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7801),
  },
  [3046] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(7807),
  },
  [3047] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_fi] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_else] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_EQ_TILDE] = ACTIONS(3879),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [anon_sym_elif] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3048] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3412),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3412),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7809),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7811),
    [anon_sym_DASH] = ACTIONS(7809),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7809),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7809),
    [anon_sym_PERCENT] = ACTIONS(7809),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7813),
    [anon_sym_COLON_DASH] = ACTIONS(7809),
    [sym__special_character] = ACTIONS(599),
  },
  [3049] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7811),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3050] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_fi] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_else] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3927),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_elif] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3051] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_fi] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_else] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_EQ_TILDE] = ACTIONS(3946),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_elif] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3052] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7815),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3053] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_fi] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [anon_sym_else] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [anon_sym_elif] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [3054] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_fi] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [anon_sym_elif] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [3055] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_fi] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_else] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [anon_sym_elif] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [3056] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(7817),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3057] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3058] = {
    [sym_process_substitution] = STATE(3057),
    [sym_string_expansion] = STATE(3057),
    [sym_expansion] = STATE(3057),
    [sym_simple_expansion] = STATE(3057),
    [sym_string] = STATE(3057),
    [sym_command_substitution] = STATE(3057),
    [anon_sym_BQUOTE] = ACTIONS(4372),
    [anon_sym_DQUOTE] = ACTIONS(4374),
    [sym_word] = ACTIONS(6983),
    [sym_raw_string] = ACTIONS(6983),
    [anon_sym_LT_LPAREN] = ACTIONS(4378),
    [anon_sym_DOLLAR] = ACTIONS(7819),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4382),
    [sym__special_character] = ACTIONS(6983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4386),
  },
  [3059] = {
    [aux_sym_concatenation_repeat1] = STATE(3059),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(7821),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3060] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_fi] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_elif] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [3061] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3418),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3418),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7824),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7826),
    [anon_sym_DASH] = ACTIONS(7824),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7824),
    [anon_sym_PERCENT] = ACTIONS(7824),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7828),
    [anon_sym_COLON_DASH] = ACTIONS(7824),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7830),
  },
  [3062] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_fi] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [anon_sym_elif] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [3063] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7826),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3064] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3418),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3418),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7832),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7824),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7826),
    [anon_sym_DASH] = ACTIONS(7824),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7824),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7824),
    [anon_sym_PERCENT] = ACTIONS(7824),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7828),
    [anon_sym_COLON_DASH] = ACTIONS(7824),
    [sym__special_character] = ACTIONS(599),
  },
  [3065] = {
    [anon_sym_EQ] = ACTIONS(7834),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3066] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3423),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3423),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7838),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7840),
    [anon_sym_DASH] = ACTIONS(7838),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7838),
    [anon_sym_PERCENT] = ACTIONS(7838),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7842),
    [anon_sym_COLON_DASH] = ACTIONS(7838),
    [sym__special_character] = ACTIONS(599),
  },
  [3067] = {
    [sym_process_substitution] = STATE(3424),
    [aux_sym__literal_repeat1] = STATE(3426),
    [sym_simple_expansion] = STATE(3424),
    [sym_string_expansion] = STATE(3424),
    [sym_expansion] = STATE(3424),
    [sym_concatenation] = STATE(3425),
    [sym_string] = STATE(3424),
    [sym_command_substitution] = STATE(3424),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(7844),
    [sym_raw_string] = ACTIONS(7844),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(7826),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3068] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3429),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3429),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7846),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7848),
    [anon_sym_DASH] = ACTIONS(7846),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7846),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7850),
    [anon_sym_COLON_DASH] = ACTIONS(7846),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(7852),
  },
  [3069] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_fi] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_elif] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [3070] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7848),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3071] = {
    [sym_process_substitution] = STATE(1700),
    [sym_string_expansion] = STATE(1700),
    [sym_expansion] = STATE(1700),
    [sym_simple_expansion] = STATE(1700),
    [sym_string] = STATE(1700),
    [sym_command_substitution] = STATE(1700),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(3669),
    [sym_raw_string] = ACTIONS(3669),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(7854),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(3669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [3072] = {
    [aux_sym_concatenation_repeat1] = STATE(3072),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_elif] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3073] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_fi] = ACTIONS(7856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_else] = ACTIONS(7856),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [anon_sym_elif] = ACTIONS(7856),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [3074] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7858),
    [anon_sym_BQUOTE] = ACTIONS(7858),
    [anon_sym_AMP_GT_GT] = ACTIONS(7858),
    [anon_sym_LF] = ACTIONS(7860),
    [anon_sym_SEMI] = ACTIONS(7858),
    [anon_sym_LT_LT] = ACTIONS(7858),
    [sym_file_descriptor] = ACTIONS(7860),
    [anon_sym_GT] = ACTIONS(7858),
    [anon_sym_RPAREN] = ACTIONS(7858),
    [anon_sym_AMP_GT] = ACTIONS(7858),
    [anon_sym_fi] = ACTIONS(7858),
    [anon_sym_else] = ACTIONS(7858),
    [anon_sym_done] = ACTIONS(7858),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [ts_builtin_sym_end] = ACTIONS(7860),
    [anon_sym_LT_LT_LT] = ACTIONS(7858),
    [anon_sym_PIPE] = ACTIONS(7858),
    [anon_sym_GT_AMP] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(7858),
    [anon_sym_LT_AMP] = ACTIONS(7858),
    [anon_sym_GT_GT] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(7858),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [anon_sym_esac] = ACTIONS(7858),
    [anon_sym_SEMI_SEMI] = ACTIONS(7858),
    [anon_sym_PIPE_AMP] = ACTIONS(7858),
  },
  [3075] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(3431),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3076] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(3434),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(7862),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(7864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [3077] = {
    [aux_sym_concatenation_repeat1] = STATE(3436),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(7866),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_esac] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [3078] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3437),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3079] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(7868),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_EQ] = ACTIONS(7868),
  },
  [3080] = {
    [sym_string] = STATE(3440),
    [anon_sym_DQUOTE] = ACTIONS(7870),
    [anon_sym_STAR] = ACTIONS(7872),
    [anon_sym_QMARK] = ACTIONS(7872),
    [sym_raw_string] = ACTIONS(7874),
    [anon_sym_AT] = ACTIONS(7872),
    [anon_sym_DOLLAR] = ACTIONS(7876),
    [anon_sym_POUND] = ACTIONS(7876),
    [anon_sym_DASH] = ACTIONS(7876),
    [anon_sym_0] = ACTIONS(7878),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7878),
    [anon_sym__] = ACTIONS(7878),
  },
  [3081] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(3442),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3443),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3082] = {
    [aux_sym_concatenation_repeat1] = STATE(3436),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(7866),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [3083] = {
    [sym_subscript] = STATE(3444),
    [anon_sym_STAR] = ACTIONS(7880),
    [anon_sym_QMARK] = ACTIONS(7880),
    [anon_sym_BANG] = ACTIONS(7882),
    [anon_sym_AT] = ACTIONS(7880),
    [sym_variable_name] = ACTIONS(7884),
    [anon_sym_DOLLAR] = ACTIONS(7886),
    [anon_sym_DASH] = ACTIONS(7886),
    [anon_sym_0] = ACTIONS(7888),
    [anon_sym_POUND] = ACTIONS(7882),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7888),
    [anon_sym__] = ACTIONS(7888),
    [sym_comment] = ACTIONS(3),
  },
  [3084] = {
    [aux_sym__literal_repeat1] = STATE(3449),
    [anon_sym_AMP_GT_GT] = ACTIONS(497),
    [anon_sym_DOLLAR] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(497),
    [anon_sym_GT_LPAREN] = ACTIONS(497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(497),
    [aux_sym__simple_variable_name_token1] = ACTIONS(497),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [sym_word] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(497),
    [anon_sym_LT] = ACTIONS(497),
    [anon_sym_LT_AMP] = ACTIONS(497),
    [anon_sym_GT_GT] = ACTIONS(497),
    [sym__special_character] = ACTIONS(7890),
    [anon_sym_LT_LT_DASH] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(497),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(497),
    [sym_raw_string] = ACTIONS(497),
    [sym_variable_name] = ACTIONS(501),
    [sym_file_descriptor] = ACTIONS(501),
    [anon_sym_GT] = ACTIONS(497),
    [anon_sym_AMP_GT] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(497),
    [anon_sym_LT_LT_LT] = ACTIONS(497),
    [anon_sym_GT_AMP] = ACTIONS(497),
    [anon_sym_LT_LPAREN] = ACTIONS(497),
    [anon_sym_esac] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_SEMI_SEMI] = ACTIONS(497),
    [anon_sym_PIPE_AMP] = ACTIONS(497),
  },
  [3085] = {
    [sym_process_substitution] = STATE(3077),
    [sym_string] = STATE(3077),
    [sym_command_substitution] = STATE(3077),
    [sym_simple_expansion] = STATE(3077),
    [sym_variable_assignment] = STATE(3450),
    [sym_subscript] = STATE(3086),
    [sym_string_expansion] = STATE(3077),
    [sym_expansion] = STATE(3077),
    [sym_concatenation] = STATE(3450),
    [aux_sym_declaration_command_repeat1] = STATE(3450),
    [aux_sym__literal_repeat1] = STATE(3084),
    [anon_sym_AMP_GT_GT] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_GT_LPAREN] = ACTIONS(7042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(503),
    [sym_word] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_LT_AMP] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [sym__special_character] = ACTIONS(7052),
    [anon_sym_LT_LT_DASH] = ACTIONS(503),
    [anon_sym_BQUOTE] = ACTIONS(7054),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(503),
    [sym_raw_string] = ACTIONS(7050),
    [sym_variable_name] = ACTIONS(7056),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_AMP_GT] = ACTIONS(503),
    [anon_sym_DQUOTE] = ACTIONS(7058),
    [anon_sym_LT_LT_LT] = ACTIONS(503),
    [anon_sym_GT_AMP] = ACTIONS(503),
    [anon_sym_LT_LPAREN] = ACTIONS(7042),
    [anon_sym_esac] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(503),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [anon_sym_PIPE_AMP] = ACTIONS(503),
  },
  [3086] = {
    [anon_sym_EQ] = ACTIONS(7868),
    [anon_sym_PLUS_EQ] = ACTIONS(7868),
    [sym_comment] = ACTIONS(51),
  },
  [3087] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(3451),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3088] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(3454),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(7894),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(7896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [3089] = {
    [aux_sym_concatenation_repeat1] = STATE(3456),
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(7898),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [anon_sym_esac] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [3090] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3457),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3091] = {
    [sym_string] = STATE(3459),
    [anon_sym_DQUOTE] = ACTIONS(7900),
    [anon_sym_STAR] = ACTIONS(7902),
    [anon_sym_QMARK] = ACTIONS(7902),
    [sym_raw_string] = ACTIONS(7904),
    [anon_sym_AT] = ACTIONS(7902),
    [anon_sym_DOLLAR] = ACTIONS(7906),
    [anon_sym_POUND] = ACTIONS(7906),
    [anon_sym_DASH] = ACTIONS(7906),
    [anon_sym_0] = ACTIONS(7908),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7908),
    [anon_sym__] = ACTIONS(7908),
  },
  [3092] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(3461),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3462),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3093] = {
    [aux_sym_concatenation_repeat1] = STATE(3456),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(7898),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [3094] = {
    [sym_subscript] = STATE(3463),
    [anon_sym_STAR] = ACTIONS(7910),
    [anon_sym_QMARK] = ACTIONS(7910),
    [anon_sym_BANG] = ACTIONS(7912),
    [anon_sym_AT] = ACTIONS(7910),
    [sym_variable_name] = ACTIONS(7914),
    [anon_sym_DOLLAR] = ACTIONS(7916),
    [anon_sym_DASH] = ACTIONS(7916),
    [anon_sym_0] = ACTIONS(7918),
    [anon_sym_POUND] = ACTIONS(7912),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7918),
    [anon_sym__] = ACTIONS(7918),
    [sym_comment] = ACTIONS(3),
  },
  [3095] = {
    [aux_sym__literal_repeat1] = STATE(3468),
    [anon_sym_AMP_GT_GT] = ACTIONS(539),
    [anon_sym_DOLLAR] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_GT_LPAREN] = ACTIONS(539),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(539),
    [aux_sym__simple_variable_name_token1] = ACTIONS(539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [sym_word] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_LT_AMP] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(539),
    [sym__special_character] = ACTIONS(7920),
    [anon_sym_LT_LT_DASH] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [anon_sym_LF] = ACTIONS(543),
    [anon_sym_SEMI] = ACTIONS(539),
    [sym_raw_string] = ACTIONS(539),
    [sym_file_descriptor] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(539),
    [anon_sym_AMP_GT] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_LT_LT_LT] = ACTIONS(539),
    [anon_sym_GT_AMP] = ACTIONS(539),
    [anon_sym_LT_LPAREN] = ACTIONS(539),
    [anon_sym_esac] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_SEMI_SEMI] = ACTIONS(539),
    [anon_sym_PIPE_AMP] = ACTIONS(539),
  },
  [3096] = {
    [sym_process_substitution] = STATE(3089),
    [sym_command_substitution] = STATE(3089),
    [aux_sym_unset_command_repeat1] = STATE(3469),
    [sym_simple_expansion] = STATE(3089),
    [sym_string_expansion] = STATE(3089),
    [sym_expansion] = STATE(3089),
    [sym_concatenation] = STATE(3469),
    [sym_string] = STATE(3089),
    [aux_sym__literal_repeat1] = STATE(3095),
    [anon_sym_AMP_GT_GT] = ACTIONS(545),
    [anon_sym_DOLLAR] = ACTIONS(7060),
    [anon_sym_LT_LT] = ACTIONS(545),
    [anon_sym_GT_LPAREN] = ACTIONS(7062),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7064),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7068),
    [anon_sym_PIPE_PIPE] = ACTIONS(545),
    [sym_word] = ACTIONS(7070),
    [anon_sym_PIPE] = ACTIONS(545),
    [anon_sym_AMP] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_LT_AMP] = ACTIONS(545),
    [anon_sym_GT_GT] = ACTIONS(545),
    [sym__special_character] = ACTIONS(7072),
    [anon_sym_LT_LT_DASH] = ACTIONS(545),
    [anon_sym_BQUOTE] = ACTIONS(7074),
    [anon_sym_LF] = ACTIONS(549),
    [anon_sym_SEMI] = ACTIONS(545),
    [sym_raw_string] = ACTIONS(7070),
    [sym_file_descriptor] = ACTIONS(549),
    [anon_sym_GT] = ACTIONS(545),
    [anon_sym_AMP_GT] = ACTIONS(545),
    [anon_sym_DQUOTE] = ACTIONS(7076),
    [anon_sym_LT_LT_LT] = ACTIONS(545),
    [anon_sym_GT_AMP] = ACTIONS(545),
    [anon_sym_LT_LPAREN] = ACTIONS(7062),
    [anon_sym_esac] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(545),
    [anon_sym_SEMI_SEMI] = ACTIONS(545),
    [anon_sym_PIPE_AMP] = ACTIONS(545),
  },
  [3097] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [anon_sym_esac] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [3098] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(555),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_EQ_EQ] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_esac] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [3099] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [anon_sym_esac] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [3100] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7924),
  },
  [3101] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(7926),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [3102] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(7926),
  },
  [3103] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3474),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3474),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7928),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7930),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7932),
    [anon_sym_DASH] = ACTIONS(7930),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7930),
    [anon_sym_PERCENT] = ACTIONS(7930),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7934),
    [anon_sym_COLON_DASH] = ACTIONS(7930),
    [sym__special_character] = ACTIONS(599),
  },
  [3104] = {
    [sym_subscript] = STATE(3475),
    [anon_sym_STAR] = ACTIONS(7936),
    [anon_sym_QMARK] = ACTIONS(7936),
    [anon_sym_AT] = ACTIONS(7936),
    [sym_variable_name] = ACTIONS(7938),
    [anon_sym_DOLLAR] = ACTIONS(7940),
    [anon_sym_DASH] = ACTIONS(7940),
    [anon_sym_0] = ACTIONS(7942),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7942),
    [anon_sym__] = ACTIONS(7942),
  },
  [3105] = {
    [anon_sym_EQ] = ACTIONS(7944),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3106] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3481),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3481),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(7946),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(7948),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(7950),
    [anon_sym_DASH] = ACTIONS(7948),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(7948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(7948),
    [anon_sym_PERCENT] = ACTIONS(7948),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(7952),
    [anon_sym_COLON_DASH] = ACTIONS(7948),
    [sym__special_character] = ACTIONS(599),
  },
  [3107] = {
    [sym_process_substitution] = STATE(3482),
    [sym_string_expansion] = STATE(3482),
    [sym_expansion] = STATE(3482),
    [sym_simple_expansion] = STATE(3482),
    [sym_string] = STATE(3482),
    [sym_command_substitution] = STATE(3482),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [sym_word] = ACTIONS(7954),
    [sym_raw_string] = ACTIONS(7954),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [sym__special_character] = ACTIONS(7954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
  },
  [3108] = {
    [aux_sym_concatenation_repeat1] = STATE(3484),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(7956),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [anon_sym_esac] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [3109] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(7926),
  },
  [3110] = {
    [sym_process_substitution] = STATE(3488),
    [aux_sym__literal_repeat1] = STATE(3495),
    [sym_array] = STATE(3494),
    [sym_simple_expansion] = STATE(3488),
    [sym_string_expansion] = STATE(3488),
    [sym_expansion] = STATE(3488),
    [sym_concatenation] = STATE(3494),
    [sym_string] = STATE(3488),
    [sym_command_substitution] = STATE(3488),
    [anon_sym_LPAREN] = ACTIONS(7958),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [sym_word] = ACTIONS(7964),
    [sym_raw_string] = ACTIONS(7964),
    [anon_sym_LT_LPAREN] = ACTIONS(7966),
    [anon_sym_DOLLAR] = ACTIONS(7968),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(7966),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7970),
    [sym__special_character] = ACTIONS(7972),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7974),
    [sym__empty_value] = ACTIONS(7976),
  },
  [3111] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(7978),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3112] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [3113] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(7980),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(7978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [3114] = {
    [sym_redirected_statement] = STATE(3498),
    [sym_if_statement] = STATE(3498),
    [sym_function_definition] = STATE(3498),
    [sym_compound_statement] = STATE(3498),
    [sym_test_command] = STATE(3498),
    [sym_declaration_command] = STATE(3498),
    [sym_subscript] = STATE(2632),
    [sym_file_redirect] = STATE(2634),
    [sym_concatenation] = STATE(2633),
    [sym_string] = STATE(2625),
    [sym_command_substitution] = STATE(2625),
    [sym_process_substitution] = STATE(2625),
    [aux_sym_command_repeat1] = STATE(2634),
    [sym_for_statement] = STATE(3498),
    [sym_c_style_for_statement] = STATE(3498),
    [sym_case_statement] = STATE(3498),
    [sym_subshell] = STATE(3498),
    [sym_pipeline] = STATE(3498),
    [sym_unset_command] = STATE(3498),
    [sym_command] = STATE(3498),
    [sym_simple_expansion] = STATE(2625),
    [sym_while_statement] = STATE(3498),
    [sym_list] = STATE(3498),
    [sym_negated_command] = STATE(3498),
    [sym_command_name] = STATE(2636),
    [sym_variable_assignment] = STATE(3499),
    [sym_string_expansion] = STATE(2625),
    [sym_expansion] = STATE(2625),
    [aux_sym__literal_repeat1] = STATE(2639),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(5783),
    [anon_sym_typeset] = ACTIONS(5783),
    [anon_sym_unsetenv] = ACTIONS(5785),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(5783),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(5799),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_BANG] = ACTIONS(5803),
    [anon_sym_declare] = ACTIONS(5783),
    [sym_variable_name] = ACTIONS(5805),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(5783),
    [anon_sym_unset] = ACTIONS(5785),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3115] = {
    [sym_process_substitution] = STATE(3500),
    [aux_sym__literal_repeat1] = STATE(3502),
    [sym_simple_expansion] = STATE(3500),
    [sym_string_expansion] = STATE(3500),
    [sym_expansion] = STATE(3500),
    [sym_concatenation] = STATE(599),
    [sym_string] = STATE(3500),
    [sym_command_substitution] = STATE(3500),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(7982),
    [sym_raw_string] = ACTIONS(7982),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(7984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [3116] = {
    [sym_heredoc_body] = STATE(3503),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(1220),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
  },
  [3117] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(1220),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
  },
  [3118] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(7986),
    [anon_sym_GT_AMP] = ACTIONS(7986),
    [anon_sym_LT] = ACTIONS(7988),
    [anon_sym_LT_AMP] = ACTIONS(7986),
    [anon_sym_GT_GT] = ACTIONS(7986),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(7988),
    [anon_sym_AMP_GT] = ACTIONS(7988),
  },
  [3119] = {
    [sym_redirected_statement] = STATE(3505),
    [sym_if_statement] = STATE(3505),
    [sym_function_definition] = STATE(3505),
    [sym_compound_statement] = STATE(3505),
    [sym_test_command] = STATE(3505),
    [sym_declaration_command] = STATE(3505),
    [sym_subscript] = STATE(2632),
    [sym_file_redirect] = STATE(2634),
    [sym_concatenation] = STATE(2633),
    [sym_string] = STATE(2625),
    [sym_command_substitution] = STATE(2625),
    [sym_process_substitution] = STATE(2625),
    [aux_sym_command_repeat1] = STATE(2634),
    [sym_for_statement] = STATE(3505),
    [sym_c_style_for_statement] = STATE(3505),
    [sym_case_statement] = STATE(3505),
    [sym_subshell] = STATE(3505),
    [sym_pipeline] = STATE(3505),
    [sym_unset_command] = STATE(3505),
    [sym_command] = STATE(3505),
    [sym_simple_expansion] = STATE(2625),
    [sym_while_statement] = STATE(3505),
    [sym_list] = STATE(3505),
    [sym_negated_command] = STATE(3505),
    [sym_command_name] = STATE(2636),
    [sym_variable_assignment] = STATE(3506),
    [sym_string_expansion] = STATE(2625),
    [sym_expansion] = STATE(2625),
    [aux_sym__literal_repeat1] = STATE(2639),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(5783),
    [anon_sym_typeset] = ACTIONS(5783),
    [anon_sym_unsetenv] = ACTIONS(5785),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(5783),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(5799),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_BANG] = ACTIONS(5803),
    [anon_sym_declare] = ACTIONS(5783),
    [sym_variable_name] = ACTIONS(5805),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(5783),
    [anon_sym_unset] = ACTIONS(5785),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3120] = {
    [sym_process_substitution] = STATE(3507),
    [aux_sym__literal_repeat1] = STATE(3508),
    [sym_simple_expansion] = STATE(3507),
    [sym_string_expansion] = STATE(3507),
    [sym_expansion] = STATE(3507),
    [sym_concatenation] = STATE(609),
    [sym_string] = STATE(3507),
    [sym_command_substitution] = STATE(3507),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(7990),
    [sym_raw_string] = ACTIONS(7990),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(7984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [3121] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3509),
    [sym_file_redirect] = STATE(3509),
    [sym_herestring_redirect] = STATE(3509),
    [sym_heredoc_redirect] = STATE(3509),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(7110),
    [anon_sym_LF] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(351),
    [sym_file_descriptor] = ACTIONS(7116),
    [anon_sym_GT] = ACTIONS(7110),
    [anon_sym_AMP_GT] = ACTIONS(7110),
    [anon_sym_PIPE_PIPE] = ACTIONS(1071),
    [anon_sym_LT_LT_LT] = ACTIONS(7120),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_GT_AMP] = ACTIONS(7110),
    [anon_sym_LT] = ACTIONS(7110),
    [anon_sym_esac] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(7110),
    [anon_sym_LT_AMP] = ACTIONS(7110),
    [anon_sym_AMP] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1071),
    [anon_sym_SEMI_SEMI] = ACTIONS(1071),
    [anon_sym_PIPE_AMP] = ACTIONS(1071),
  },
  [3122] = {
    [sym_process_substitution] = STATE(3124),
    [sym_command_substitution] = STATE(3124),
    [sym_simple_expansion] = STATE(3124),
    [sym_string_expansion] = STATE(3124),
    [sym_expansion] = STATE(3124),
    [aux_sym_command_repeat2] = STATE(3510),
    [sym_concatenation] = STATE(3510),
    [sym_string] = STATE(3124),
    [aux_sym__literal_repeat1] = STATE(3126),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(7130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7134),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(7136),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(7138),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(7140),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(7136),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(7138),
    [anon_sym_DQUOTE] = ACTIONS(7142),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(7130),
    [anon_sym_esac] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [3123] = {
    [anon_sym_BQUOTE] = ACTIONS(7992),
    [anon_sym_DQUOTE] = ACTIONS(7992),
    [sym_word] = ACTIONS(7994),
    [sym_raw_string] = ACTIONS(7992),
    [anon_sym_LT_LPAREN] = ACTIONS(7992),
    [anon_sym_esac] = ACTIONS(7996),
    [anon_sym_DOLLAR] = ACTIONS(7994),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(7992),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7992),
    [sym__special_character] = ACTIONS(7992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7992),
  },
  [3124] = {
    [aux_sym_concatenation_repeat1] = STATE(3108),
    [anon_sym_AMP_GT_GT] = ACTIONS(1093),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [sym_word] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_LT_AMP] = ACTIONS(1093),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [sym__concat] = ACTIONS(7096),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [sym__special_character] = ACTIONS(1093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1093),
    [anon_sym_BQUOTE] = ACTIONS(1093),
    [anon_sym_LF] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [sym_raw_string] = ACTIONS(1093),
    [sym_file_descriptor] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_AMP_GT] = ACTIONS(1093),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_LT_LT_LT] = ACTIONS(1093),
    [anon_sym_GT_AMP] = ACTIONS(1093),
    [anon_sym_LT_LPAREN] = ACTIONS(1093),
    [anon_sym_esac] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1093),
    [anon_sym_SEMI_SEMI] = ACTIONS(1093),
    [anon_sym_PIPE_AMP] = ACTIONS(1093),
  },
  [3125] = {
    [sym_process_substitution] = STATE(3511),
    [aux_sym__literal_repeat1] = STATE(3513),
    [sym_simple_expansion] = STATE(3511),
    [sym_string_expansion] = STATE(3511),
    [sym_expansion] = STATE(3511),
    [sym_concatenation] = STATE(3512),
    [sym_string] = STATE(3511),
    [sym_command_substitution] = STATE(3511),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [sym_word] = ACTIONS(7998),
    [sym_raw_string] = ACTIONS(7998),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [sym__special_character] = ACTIONS(7124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
    [sym_regex] = ACTIONS(8000),
  },
  [3126] = {
    [aux_sym__literal_repeat1] = STATE(3131),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [sym_word] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(7144),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1101),
    [sym_raw_string] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_esac] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
  },
  [3127] = {
    [sym_process_substitution] = STATE(3124),
    [sym_command_substitution] = STATE(3124),
    [sym_simple_expansion] = STATE(3124),
    [sym_string_expansion] = STATE(3124),
    [sym_expansion] = STATE(3124),
    [aux_sym_command_repeat2] = STATE(3514),
    [sym_concatenation] = STATE(3514),
    [sym_string] = STATE(3124),
    [aux_sym__literal_repeat1] = STATE(3126),
    [anon_sym_AMP_GT_GT] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_LPAREN] = ACTIONS(7130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7134),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [sym_word] = ACTIONS(7136),
    [anon_sym_PIPE] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1073),
    [anon_sym_LT_AMP] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ_TILDE] = ACTIONS(7138),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_LT_LT_DASH] = ACTIONS(1073),
    [anon_sym_BQUOTE] = ACTIONS(7140),
    [anon_sym_LF] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(7136),
    [sym_file_descriptor] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1073),
    [anon_sym_AMP_GT] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(7138),
    [anon_sym_DQUOTE] = ACTIONS(7142),
    [anon_sym_LT_LT_LT] = ACTIONS(1073),
    [anon_sym_GT_AMP] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(7130),
    [anon_sym_esac] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_SEMI_SEMI] = ACTIONS(1073),
    [anon_sym_PIPE_AMP] = ACTIONS(1073),
  },
  [3128] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3121),
    [sym_file_redirect] = STATE(3121),
    [sym_herestring_redirect] = STATE(3121),
    [sym_heredoc_redirect] = STATE(3121),
    [anon_sym_PIPE_AMP] = ACTIONS(7122),
    [anon_sym_AMP_GT_GT] = ACTIONS(7110),
    [anon_sym_LF] = ACTIONS(8002),
    [anon_sym_SEMI] = ACTIONS(8004),
    [sym_file_descriptor] = ACTIONS(7116),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(7110),
    [anon_sym_AMP_GT] = ACTIONS(7110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_LT_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_AMP] = ACTIONS(7110),
    [anon_sym_PIPE] = ACTIONS(7122),
    [anon_sym_LT] = ACTIONS(7110),
    [anon_sym_esac] = ACTIONS(1220),
    [anon_sym_LT_AMP] = ACTIONS(7110),
    [anon_sym_GT_GT] = ACTIONS(7110),
    [anon_sym_AMP] = ACTIONS(8004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_SEMI_SEMI] = ACTIONS(1220),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
  },
  [3129] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3121),
    [sym_file_redirect] = STATE(3121),
    [sym_herestring_redirect] = STATE(3121),
    [sym_heredoc_redirect] = STATE(3121),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(7122),
    [anon_sym_AMP] = ACTIONS(8004),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(8002),
    [anon_sym_SEMI] = ACTIONS(8004),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [anon_sym_esac] = ACTIONS(1220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_SEMI_SEMI] = ACTIONS(1220),
    [anon_sym_PIPE_AMP] = ACTIONS(7122),
  },
  [3130] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_EQ_TILDE] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [3131] = {
    [aux_sym__literal_repeat1] = STATE(3131),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_EQ_TILDE] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(8006),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [anon_sym_esac] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [3132] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(8009),
    [anon_sym_esac] = ACTIONS(8011),
  },
  [3133] = {
    [anon_sym_BQUOTE] = ACTIONS(8013),
    [anon_sym_DQUOTE] = ACTIONS(8013),
    [sym_word] = ACTIONS(8015),
    [sym_raw_string] = ACTIONS(8013),
    [anon_sym_LT_LPAREN] = ACTIONS(8013),
    [anon_sym_esac] = ACTIONS(8017),
    [anon_sym_DOLLAR] = ACTIONS(8015),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8013),
    [sym__special_character] = ACTIONS(8013),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8013),
  },
  [3134] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(8019),
    [anon_sym_esac] = ACTIONS(8021),
  },
  [3135] = {
    [sym_redirected_statement] = STATE(3520),
    [sym_if_statement] = STATE(3520),
    [sym_function_definition] = STATE(3520),
    [sym_compound_statement] = STATE(3520),
    [sym_test_command] = STATE(3520),
    [sym_declaration_command] = STATE(3520),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(3520),
    [sym_c_style_for_statement] = STATE(3520),
    [sym_case_statement] = STATE(3520),
    [sym_subshell] = STATE(3520),
    [sym_pipeline] = STATE(3520),
    [sym_unset_command] = STATE(3520),
    [sym_command] = STATE(3520),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(3521),
    [sym_while_statement] = STATE(3520),
    [sym_list] = STATE(3520),
    [sym_negated_command] = STATE(3520),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(3522),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(3523),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(8023),
  },
  [3136] = {
    [aux_sym_case_item_repeat1] = STATE(2642),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(8025),
    [sym_comment] = ACTIONS(51),
  },
  [3137] = {
    [sym_redirected_statement] = STATE(3520),
    [sym_if_statement] = STATE(3520),
    [sym_function_definition] = STATE(3520),
    [sym_compound_statement] = STATE(3520),
    [sym_test_command] = STATE(3520),
    [sym_declaration_command] = STATE(3520),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(3520),
    [sym_c_style_for_statement] = STATE(3520),
    [sym_case_statement] = STATE(3520),
    [sym_subshell] = STATE(3520),
    [sym_pipeline] = STATE(3520),
    [sym_unset_command] = STATE(3520),
    [sym_command] = STATE(3520),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(3526),
    [sym_while_statement] = STATE(3520),
    [sym_list] = STATE(3520),
    [sym_negated_command] = STATE(3520),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(3522),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(3523),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(8027),
  },
  [3138] = {
    [aux_sym_case_item_repeat1] = STATE(2642),
    [anon_sym_PIPE] = ACTIONS(4432),
    [anon_sym_RPAREN] = ACTIONS(8029),
    [sym_comment] = ACTIONS(51),
  },
  [3139] = {
    [anon_sym_AMP] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [anon_sym_in] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
  },
  [3140] = {
    [anon_sym_AMP] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [anon_sym_in] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
  },
  [3141] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(8031),
    [anon_sym_BQUOTE] = ACTIONS(8031),
    [anon_sym_AMP_GT_GT] = ACTIONS(8031),
    [anon_sym_LF] = ACTIONS(8033),
    [anon_sym_SEMI] = ACTIONS(8031),
    [anon_sym_LT_LT] = ACTIONS(8031),
    [sym_file_descriptor] = ACTIONS(8033),
    [anon_sym_GT] = ACTIONS(8031),
    [anon_sym_RPAREN] = ACTIONS(8031),
    [anon_sym_AMP_GT] = ACTIONS(8031),
    [anon_sym_fi] = ACTIONS(8031),
    [anon_sym_else] = ACTIONS(8031),
    [anon_sym_done] = ACTIONS(8031),
    [anon_sym_PIPE_PIPE] = ACTIONS(8031),
    [ts_builtin_sym_end] = ACTIONS(8033),
    [anon_sym_LT_LT_LT] = ACTIONS(8031),
    [anon_sym_PIPE] = ACTIONS(8031),
    [anon_sym_GT_AMP] = ACTIONS(8031),
    [anon_sym_LT] = ACTIONS(8031),
    [anon_sym_LT_AMP] = ACTIONS(8031),
    [anon_sym_GT_GT] = ACTIONS(8031),
    [anon_sym_AMP] = ACTIONS(8031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(8031),
    [anon_sym_AMP_AMP] = ACTIONS(8031),
    [anon_sym_esac] = ACTIONS(8031),
    [anon_sym_SEMI_SEMI] = ACTIONS(8031),
    [anon_sym_PIPE_AMP] = ACTIONS(8031),
  },
  [3142] = {
    [anon_sym_BANG_EQ] = ACTIONS(6453),
    [anon_sym_PLUS_EQ] = ACTIONS(6453),
    [sym_test_operator] = ACTIONS(6453),
    [anon_sym_PLUS_PLUS] = ACTIONS(6453),
    [anon_sym_RPAREN] = ACTIONS(6451),
    [anon_sym_DASH] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_EQ] = ACTIONS(6451),
    [anon_sym_EQ_EQ] = ACTIONS(6453),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6453),
    [anon_sym_PIPE_PIPE] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6453),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(6453),
    [anon_sym_PLUS] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(6453),
    [anon_sym_DASH_DASH] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6453),
    [anon_sym_AMP_AMP] = ACTIONS(6453),
    [anon_sym_DASH_EQ] = ACTIONS(6453),
  },
  [3143] = {
    [anon_sym_BANG_EQ] = ACTIONS(6457),
    [anon_sym_PLUS_EQ] = ACTIONS(6457),
    [sym_test_operator] = ACTIONS(6457),
    [anon_sym_PLUS_PLUS] = ACTIONS(6457),
    [anon_sym_RPAREN] = ACTIONS(6455),
    [anon_sym_DASH] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6457),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6457),
    [anon_sym_PIPE_PIPE] = ACTIONS(6457),
    [anon_sym_GT_EQ] = ACTIONS(6457),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(6457),
    [anon_sym_PLUS] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(6457),
    [anon_sym_DASH_DASH] = ACTIONS(6457),
    [anon_sym_LT_EQ] = ACTIONS(6457),
    [anon_sym_AMP_AMP] = ACTIONS(6457),
    [anon_sym_DASH_EQ] = ACTIONS(6457),
  },
  [3144] = {
    [anon_sym_BQUOTE] = ACTIONS(3832),
    [anon_sym_DQUOTE] = ACTIONS(3832),
    [sym_word] = ACTIONS(3832),
    [sym_raw_string] = ACTIONS(3832),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_LT_LPAREN] = ACTIONS(3832),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_RPAREN] = ACTIONS(3832),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3832),
  },
  [3145] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8035),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3146] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3529),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3529),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8037),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8035),
    [anon_sym_DASH] = ACTIONS(8037),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8037),
    [anon_sym_PERCENT] = ACTIONS(8037),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8039),
    [anon_sym_COLON_DASH] = ACTIONS(8037),
    [sym__special_character] = ACTIONS(599),
  },
  [3147] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8035),
    [sym__concat] = ACTIONS(2610),
  },
  [3148] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8035),
  },
  [3149] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8041),
  },
  [3150] = {
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [sym_word] = ACTIONS(3881),
    [sym_raw_string] = ACTIONS(3881),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_LT_LPAREN] = ACTIONS(3881),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3881),
  },
  [3151] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3532),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3532),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8043),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8045),
    [anon_sym_DASH] = ACTIONS(8043),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8043),
    [anon_sym_PERCENT] = ACTIONS(8043),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8047),
    [anon_sym_COLON_DASH] = ACTIONS(8043),
    [sym__special_character] = ACTIONS(599),
  },
  [3152] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8045),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3153] = {
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_DQUOTE] = ACTIONS(3929),
    [sym_word] = ACTIONS(3929),
    [sym_raw_string] = ACTIONS(3929),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_LT_LPAREN] = ACTIONS(3929),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
  },
  [3154] = {
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [sym_word] = ACTIONS(3948),
    [sym_raw_string] = ACTIONS(3948),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_LT_LPAREN] = ACTIONS(3948),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_RPAREN] = ACTIONS(3948),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3948),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
  },
  [3155] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8049),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3156] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_RPAREN] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [ts_builtin_sym_end] = ACTIONS(5097),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3157] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8051),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3158] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [ts_builtin_sym_end] = ACTIONS(5131),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3159] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [ts_builtin_sym_end] = ACTIONS(5135),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3160] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8053),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3161] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_RPAREN] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [ts_builtin_sym_end] = ACTIONS(5186),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3162] = {
    [anon_sym_BQUOTE] = ACTIONS(6453),
    [anon_sym_DQUOTE] = ACTIONS(6453),
    [sym__concat] = ACTIONS(6453),
    [sym__string_content] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6453),
  },
  [3163] = {
    [anon_sym_BQUOTE] = ACTIONS(6457),
    [anon_sym_DQUOTE] = ACTIONS(6457),
    [sym__concat] = ACTIONS(6457),
    [sym__string_content] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6457),
  },
  [3164] = {
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
  },
  [3165] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8055),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3166] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3537),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3537),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8057),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8055),
    [anon_sym_DASH] = ACTIONS(8057),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8057),
    [anon_sym_PERCENT] = ACTIONS(8057),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8059),
    [anon_sym_COLON_DASH] = ACTIONS(8057),
    [sym__special_character] = ACTIONS(599),
  },
  [3167] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8055),
    [sym__concat] = ACTIONS(2610),
  },
  [3168] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8055),
  },
  [3169] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8061),
  },
  [3170] = {
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
  },
  [3171] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3540),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3540),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8063),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8065),
    [anon_sym_DASH] = ACTIONS(8063),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8063),
    [anon_sym_PERCENT] = ACTIONS(8063),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8067),
    [anon_sym_COLON_DASH] = ACTIONS(8063),
    [sym__special_character] = ACTIONS(599),
  },
  [3172] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8065),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3173] = {
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
  },
  [3174] = {
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
  },
  [3175] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8069),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3176] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(8071),
    [anon_sym_BQUOTE] = ACTIONS(8071),
    [anon_sym_AMP_GT_GT] = ACTIONS(8071),
    [anon_sym_LF] = ACTIONS(8073),
    [anon_sym_SEMI] = ACTIONS(8071),
    [anon_sym_LT_LT] = ACTIONS(8071),
    [sym_file_descriptor] = ACTIONS(8073),
    [anon_sym_GT] = ACTIONS(8071),
    [anon_sym_RPAREN] = ACTIONS(8071),
    [anon_sym_AMP_GT] = ACTIONS(8071),
    [anon_sym_fi] = ACTIONS(8071),
    [anon_sym_else] = ACTIONS(8071),
    [anon_sym_done] = ACTIONS(8071),
    [anon_sym_PIPE_PIPE] = ACTIONS(8071),
    [ts_builtin_sym_end] = ACTIONS(8073),
    [anon_sym_LT_LT_LT] = ACTIONS(8071),
    [anon_sym_PIPE] = ACTIONS(8071),
    [anon_sym_GT_AMP] = ACTIONS(8071),
    [anon_sym_LT] = ACTIONS(8071),
    [anon_sym_LT_AMP] = ACTIONS(8071),
    [anon_sym_GT_GT] = ACTIONS(8071),
    [anon_sym_AMP] = ACTIONS(8071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(8071),
    [anon_sym_AMP_AMP] = ACTIONS(8071),
    [anon_sym_esac] = ACTIONS(8071),
    [anon_sym_SEMI_SEMI] = ACTIONS(8071),
    [anon_sym_PIPE_AMP] = ACTIONS(8071),
  },
  [3177] = {
    [sym_do_group] = STATE(3542),
    [sym_compound_statement] = STATE(3542),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(991),
  },
  [3178] = {
    [anon_sym_BANG_EQ] = ACTIONS(5095),
    [anon_sym_PLUS_EQ] = ACTIONS(5095),
    [sym_test_operator] = ACTIONS(5097),
    [anon_sym_LF] = ACTIONS(5095),
    [anon_sym_SEMI] = ACTIONS(5095),
    [anon_sym_PLUS_PLUS] = ACTIONS(5095),
    [anon_sym_DASH] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_EQ] = ACTIONS(5095),
    [anon_sym_EQ_EQ] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [anon_sym_GT_EQ] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_PLUS] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(5095),
    [anon_sym_DASH_DASH] = ACTIONS(5095),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_LT_EQ] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_DASH_EQ] = ACTIONS(5095),
  },
  [3179] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8075),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3180] = {
    [anon_sym_BANG_EQ] = ACTIONS(5129),
    [anon_sym_PLUS_EQ] = ACTIONS(5129),
    [sym_test_operator] = ACTIONS(5131),
    [anon_sym_LF] = ACTIONS(5129),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_PLUS_PLUS] = ACTIONS(5129),
    [anon_sym_DASH] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [anon_sym_GT_EQ] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_PLUS] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [anon_sym_DASH_DASH] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_LT_EQ] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_DASH_EQ] = ACTIONS(5129),
  },
  [3181] = {
    [anon_sym_BANG_EQ] = ACTIONS(5133),
    [anon_sym_PLUS_EQ] = ACTIONS(5133),
    [sym_test_operator] = ACTIONS(5135),
    [anon_sym_LF] = ACTIONS(5133),
    [anon_sym_SEMI] = ACTIONS(5133),
    [anon_sym_PLUS_PLUS] = ACTIONS(5133),
    [anon_sym_DASH] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_EQ] = ACTIONS(5133),
    [anon_sym_EQ_EQ] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [anon_sym_GT_EQ] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_PLUS] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(5133),
    [anon_sym_DASH_DASH] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_LT_EQ] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_DASH_EQ] = ACTIONS(5133),
  },
  [3182] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8077),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3183] = {
    [anon_sym_BANG_EQ] = ACTIONS(5184),
    [anon_sym_PLUS_EQ] = ACTIONS(5184),
    [sym_test_operator] = ACTIONS(5186),
    [anon_sym_LF] = ACTIONS(5184),
    [anon_sym_SEMI] = ACTIONS(5184),
    [anon_sym_PLUS_PLUS] = ACTIONS(5184),
    [anon_sym_DASH] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_EQ] = ACTIONS(5184),
    [anon_sym_EQ_EQ] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [anon_sym_GT_EQ] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_PLUS] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(5184),
    [anon_sym_DASH_DASH] = ACTIONS(5184),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_LT_EQ] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_DASH_EQ] = ACTIONS(5184),
  },
  [3184] = {
    [sym_do_group] = STATE(3542),
    [sym_compound_statement] = STATE(3542),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(8079),
    [anon_sym_do] = ACTIONS(991),
  },
  [3185] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_done] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3186] = {
    [sym_string] = STATE(2194),
    [anon_sym__] = ACTIONS(4786),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(8081),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(8081),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_done] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(4786),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(4786),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(8083),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(4786),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(3542),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(4786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8081),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3187] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_done] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [3188] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(8085),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [3189] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_done] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3190] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3548),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3548),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8087),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8089),
    [anon_sym_DASH] = ACTIONS(8087),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8087),
    [anon_sym_PERCENT] = ACTIONS(8087),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8091),
    [anon_sym_COLON_DASH] = ACTIONS(8087),
    [sym__special_character] = ACTIONS(599),
  },
  [3191] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8089),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3192] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3548),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3548),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8087),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8089),
    [anon_sym_DASH] = ACTIONS(8087),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8087),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8087),
    [anon_sym_PERCENT] = ACTIONS(8087),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8091),
    [anon_sym_COLON_DASH] = ACTIONS(8087),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8093),
  },
  [3193] = {
    [sym_process_substitution] = STATE(3550),
    [aux_sym__literal_repeat1] = STATE(3552),
    [sym_simple_expansion] = STATE(3550),
    [sym_string_expansion] = STATE(3550),
    [sym_expansion] = STATE(3550),
    [sym_concatenation] = STATE(3551),
    [sym_string] = STATE(3550),
    [sym_command_substitution] = STATE(3550),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8095),
    [sym_raw_string] = ACTIONS(8095),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8089),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3194] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3555),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3555),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8097),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8099),
    [anon_sym_DASH] = ACTIONS(8097),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8097),
    [anon_sym_PERCENT] = ACTIONS(8097),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8101),
    [anon_sym_COLON_DASH] = ACTIONS(8097),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8103),
  },
  [3195] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_done] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3196] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8099),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3197] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8089),
    [sym__concat] = ACTIONS(2610),
  },
  [3198] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8089),
  },
  [3199] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8105),
  },
  [3200] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_done] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3201] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3558),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3558),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8107),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8109),
    [anon_sym_DASH] = ACTIONS(8107),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8107),
    [anon_sym_PERCENT] = ACTIONS(8107),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8111),
    [anon_sym_COLON_DASH] = ACTIONS(8107),
    [sym__special_character] = ACTIONS(599),
  },
  [3202] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8109),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3203] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_done] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3204] = {
    [sym_string] = STATE(2213),
    [anon_sym__] = ACTIONS(4816),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(8113),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(8113),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_done] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4816),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(4816),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(8115),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(4816),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(3560),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(4816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8113),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3205] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_done] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3206] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3560),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3560),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8117),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8119),
    [anon_sym_DASH] = ACTIONS(8117),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8117),
    [anon_sym_PERCENT] = ACTIONS(8117),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8121),
    [anon_sym_COLON_DASH] = ACTIONS(8117),
    [sym__special_character] = ACTIONS(599),
  },
  [3207] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8119),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3208] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3560),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3560),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8117),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8119),
    [anon_sym_DASH] = ACTIONS(8117),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8117),
    [anon_sym_PERCENT] = ACTIONS(8117),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8121),
    [anon_sym_COLON_DASH] = ACTIONS(8117),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8123),
  },
  [3209] = {
    [sym_process_substitution] = STATE(3562),
    [aux_sym__literal_repeat1] = STATE(3564),
    [sym_simple_expansion] = STATE(3562),
    [sym_string_expansion] = STATE(3562),
    [sym_expansion] = STATE(3562),
    [sym_concatenation] = STATE(3563),
    [sym_string] = STATE(3562),
    [sym_command_substitution] = STATE(3562),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8125),
    [sym_raw_string] = ACTIONS(8125),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8119),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3210] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3567),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3567),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8127),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8129),
    [anon_sym_DASH] = ACTIONS(8127),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8127),
    [anon_sym_PERCENT] = ACTIONS(8127),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8131),
    [anon_sym_COLON_DASH] = ACTIONS(8127),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8133),
  },
  [3211] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_done] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3212] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8129),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3213] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8119),
    [sym__concat] = ACTIONS(2610),
  },
  [3214] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8119),
  },
  [3215] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8135),
  },
  [3216] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_done] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3217] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3570),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3570),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8137),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8139),
    [anon_sym_DASH] = ACTIONS(8137),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8137),
    [anon_sym_PERCENT] = ACTIONS(8137),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8141),
    [anon_sym_COLON_DASH] = ACTIONS(8137),
    [sym__special_character] = ACTIONS(599),
  },
  [3218] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8139),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3219] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_done] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_EQ_TILDE] = ACTIONS(3830),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3220] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8143),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3221] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3572),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3572),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8145),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8143),
    [anon_sym_DASH] = ACTIONS(8145),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8145),
    [anon_sym_PERCENT] = ACTIONS(8145),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8147),
    [anon_sym_COLON_DASH] = ACTIONS(8145),
    [sym__special_character] = ACTIONS(599),
  },
  [3222] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8143),
    [sym__concat] = ACTIONS(2610),
  },
  [3223] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8143),
  },
  [3224] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8149),
  },
  [3225] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_done] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_EQ_TILDE] = ACTIONS(3879),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3226] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3575),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3575),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8151),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8153),
    [anon_sym_DASH] = ACTIONS(8151),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8151),
    [anon_sym_PERCENT] = ACTIONS(8151),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8155),
    [anon_sym_COLON_DASH] = ACTIONS(8151),
    [sym__special_character] = ACTIONS(599),
  },
  [3227] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8153),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3228] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_done] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3927),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3229] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_done] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_EQ_TILDE] = ACTIONS(3946),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3230] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8157),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3231] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_done] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [3232] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_done] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [3233] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_done] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [3234] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(8159),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3235] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3236] = {
    [sym_process_substitution] = STATE(3235),
    [sym_string_expansion] = STATE(3235),
    [sym_expansion] = STATE(3235),
    [sym_simple_expansion] = STATE(3235),
    [sym_string] = STATE(3235),
    [sym_command_substitution] = STATE(3235),
    [anon_sym_BQUOTE] = ACTIONS(4868),
    [anon_sym_DQUOTE] = ACTIONS(4870),
    [sym_word] = ACTIONS(7393),
    [sym_raw_string] = ACTIONS(7393),
    [anon_sym_LT_LPAREN] = ACTIONS(4874),
    [anon_sym_DOLLAR] = ACTIONS(8161),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4874),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4878),
    [sym__special_character] = ACTIONS(7393),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4882),
  },
  [3237] = {
    [aux_sym_concatenation_repeat1] = STATE(3237),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(8163),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3238] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_done] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [3239] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3581),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3581),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [anon_sym_DASH] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_PERCENT] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8170),
    [anon_sym_COLON_DASH] = ACTIONS(8166),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8172),
  },
  [3240] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_done] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [3241] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3242] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3581),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3581),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8174),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8166),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [anon_sym_DASH] = ACTIONS(8166),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8166),
    [anon_sym_PERCENT] = ACTIONS(8166),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8170),
    [anon_sym_COLON_DASH] = ACTIONS(8166),
    [sym__special_character] = ACTIONS(599),
  },
  [3243] = {
    [anon_sym_EQ] = ACTIONS(8176),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3244] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3586),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3586),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8178),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8180),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8182),
    [anon_sym_DASH] = ACTIONS(8180),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8180),
    [anon_sym_PERCENT] = ACTIONS(8180),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8184),
    [anon_sym_COLON_DASH] = ACTIONS(8180),
    [sym__special_character] = ACTIONS(599),
  },
  [3245] = {
    [sym_process_substitution] = STATE(3587),
    [aux_sym__literal_repeat1] = STATE(3589),
    [sym_simple_expansion] = STATE(3587),
    [sym_string_expansion] = STATE(3587),
    [sym_expansion] = STATE(3587),
    [sym_concatenation] = STATE(3588),
    [sym_string] = STATE(3587),
    [sym_command_substitution] = STATE(3587),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8186),
    [sym_raw_string] = ACTIONS(8186),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3246] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3592),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3592),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8188),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8190),
    [anon_sym_DASH] = ACTIONS(8188),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8188),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8188),
    [anon_sym_PERCENT] = ACTIONS(8188),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8192),
    [anon_sym_COLON_DASH] = ACTIONS(8188),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8194),
  },
  [3247] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_done] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [3248] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8190),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3249] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_done] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [3250] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_done] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [3251] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(8196),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3252] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3253] = {
    [sym_process_substitution] = STATE(3252),
    [sym_string_expansion] = STATE(3252),
    [sym_expansion] = STATE(3252),
    [sym_simple_expansion] = STATE(3252),
    [sym_string] = STATE(3252),
    [sym_command_substitution] = STATE(3252),
    [anon_sym_BQUOTE] = ACTIONS(4890),
    [anon_sym_DQUOTE] = ACTIONS(4892),
    [sym_word] = ACTIONS(7434),
    [sym_raw_string] = ACTIONS(7434),
    [anon_sym_LT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR] = ACTIONS(8198),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4900),
    [sym__special_character] = ACTIONS(7434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4904),
  },
  [3254] = {
    [aux_sym_concatenation_repeat1] = STATE(3254),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_done] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(8200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3255] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_done] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [3256] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3597),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3597),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8203),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8205),
    [anon_sym_DASH] = ACTIONS(8203),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8203),
    [anon_sym_PERCENT] = ACTIONS(8203),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8207),
    [anon_sym_COLON_DASH] = ACTIONS(8203),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8209),
  },
  [3257] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_done] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [3258] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8205),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3259] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3597),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3597),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8211),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8203),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8205),
    [anon_sym_DASH] = ACTIONS(8203),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8203),
    [anon_sym_PERCENT] = ACTIONS(8203),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8207),
    [anon_sym_COLON_DASH] = ACTIONS(8203),
    [sym__special_character] = ACTIONS(599),
  },
  [3260] = {
    [anon_sym_EQ] = ACTIONS(8213),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3261] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3602),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3602),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8215),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8217),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8219),
    [anon_sym_DASH] = ACTIONS(8217),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8217),
    [anon_sym_PERCENT] = ACTIONS(8217),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8221),
    [anon_sym_COLON_DASH] = ACTIONS(8217),
    [sym__special_character] = ACTIONS(599),
  },
  [3262] = {
    [sym_process_substitution] = STATE(3603),
    [aux_sym__literal_repeat1] = STATE(3605),
    [sym_simple_expansion] = STATE(3603),
    [sym_string_expansion] = STATE(3603),
    [sym_expansion] = STATE(3603),
    [sym_concatenation] = STATE(3604),
    [sym_string] = STATE(3603),
    [sym_command_substitution] = STATE(3603),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8223),
    [sym_raw_string] = ACTIONS(8223),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8205),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3263] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3608),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3608),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8225),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8227),
    [anon_sym_DASH] = ACTIONS(8225),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8225),
    [anon_sym_PERCENT] = ACTIONS(8225),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8229),
    [anon_sym_COLON_DASH] = ACTIONS(8225),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8231),
  },
  [3264] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_done] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [3265] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8227),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3266] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_done] = ACTIONS(7856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [3267] = {
    [anon_sym_BANG_EQ] = ACTIONS(6453),
    [anon_sym_PLUS_EQ] = ACTIONS(6453),
    [sym_test_operator] = ACTIONS(6453),
    [anon_sym_PLUS_PLUS] = ACTIONS(6453),
    [anon_sym_RBRACK] = ACTIONS(6453),
    [anon_sym_DASH] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_EQ] = ACTIONS(6451),
    [anon_sym_EQ_EQ] = ACTIONS(6453),
    [anon_sym_PIPE_PIPE] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(6453),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_PLUS] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(6453),
    [anon_sym_DASH_DASH] = ACTIONS(6453),
    [anon_sym_LT_EQ] = ACTIONS(6453),
    [anon_sym_AMP_AMP] = ACTIONS(6453),
    [anon_sym_DASH_EQ] = ACTIONS(6453),
  },
  [3268] = {
    [anon_sym_BANG_EQ] = ACTIONS(6457),
    [anon_sym_PLUS_EQ] = ACTIONS(6457),
    [sym_test_operator] = ACTIONS(6457),
    [anon_sym_PLUS_PLUS] = ACTIONS(6457),
    [anon_sym_RBRACK] = ACTIONS(6457),
    [anon_sym_DASH] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6457),
    [anon_sym_PIPE_PIPE] = ACTIONS(6457),
    [anon_sym_GT_EQ] = ACTIONS(6457),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_PLUS] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(6457),
    [anon_sym_DASH_DASH] = ACTIONS(6457),
    [anon_sym_LT_EQ] = ACTIONS(6457),
    [anon_sym_AMP_AMP] = ACTIONS(6457),
    [anon_sym_DASH_EQ] = ACTIONS(6457),
  },
  [3269] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_esac] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_RPAREN] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_fi] = ACTIONS(5095),
    [anon_sym_else] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [ts_builtin_sym_end] = ACTIONS(5097),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_elif] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3270] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8233),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3271] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_esac] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_fi] = ACTIONS(5129),
    [anon_sym_else] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [ts_builtin_sym_end] = ACTIONS(5131),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_elif] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3272] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_esac] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_RPAREN] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_fi] = ACTIONS(5133),
    [anon_sym_else] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [ts_builtin_sym_end] = ACTIONS(5135),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_elif] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3273] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8235),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3274] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_esac] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_RPAREN] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_fi] = ACTIONS(5184),
    [anon_sym_else] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [ts_builtin_sym_end] = ACTIONS(5186),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_elif] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3275] = {
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3832),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3832),
    [sym__heredoc_body_end] = ACTIONS(3832),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3832),
    [sym__heredoc_body_middle] = ACTIONS(3832),
  },
  [3276] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8237),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3277] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3612),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3612),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8239),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8237),
    [anon_sym_DASH] = ACTIONS(8239),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8239),
    [anon_sym_PERCENT] = ACTIONS(8239),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8241),
    [anon_sym_COLON_DASH] = ACTIONS(8239),
    [sym__special_character] = ACTIONS(599),
  },
  [3278] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8237),
    [sym__concat] = ACTIONS(2610),
  },
  [3279] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8237),
  },
  [3280] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8243),
  },
  [3281] = {
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3881),
    [sym__heredoc_body_end] = ACTIONS(3881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3881),
    [sym__heredoc_body_middle] = ACTIONS(3881),
  },
  [3282] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3615),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3615),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8245),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8247),
    [anon_sym_DASH] = ACTIONS(8245),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8245),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8245),
    [anon_sym_PERCENT] = ACTIONS(8245),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8249),
    [anon_sym_COLON_DASH] = ACTIONS(8245),
    [sym__special_character] = ACTIONS(599),
  },
  [3283] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8247),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3284] = {
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3929),
    [sym__heredoc_body_end] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3929),
    [sym__heredoc_body_middle] = ACTIONS(3929),
  },
  [3285] = {
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3948),
    [sym__heredoc_body_end] = ACTIONS(3948),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3948),
    [sym__heredoc_body_middle] = ACTIONS(3948),
  },
  [3286] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8251),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3287] = {
    [anon_sym_BQUOTE] = ACTIONS(6453),
    [sym_raw_string] = ACTIONS(6453),
    [anon_sym_COLON_QMARK] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_RBRACE] = ACTIONS(6453),
    [anon_sym_DASH] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6453),
    [anon_sym_EQ] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6453),
    [anon_sym_PERCENT] = ACTIONS(6451),
    [anon_sym_COLON] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6453),
    [anon_sym_DQUOTE] = ACTIONS(6453),
    [sym_word] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_LT_LPAREN] = ACTIONS(6453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6453),
    [anon_sym_COLON_DASH] = ACTIONS(6451),
    [sym__special_character] = ACTIONS(6451),
  },
  [3288] = {
    [anon_sym_BQUOTE] = ACTIONS(6457),
    [sym_raw_string] = ACTIONS(6457),
    [anon_sym_COLON_QMARK] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_RBRACE] = ACTIONS(6457),
    [anon_sym_DASH] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6457),
    [anon_sym_EQ] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6455),
    [anon_sym_COLON] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6457),
    [anon_sym_DQUOTE] = ACTIONS(6457),
    [sym_word] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_LT_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6457),
    [anon_sym_COLON_DASH] = ACTIONS(6455),
    [sym__special_character] = ACTIONS(6455),
  },
  [3289] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [sym__concat] = ACTIONS(5097),
  },
  [3290] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8253),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3291] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [sym__concat] = ACTIONS(5131),
  },
  [3292] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5135),
    [sym__concat] = ACTIONS(5135),
  },
  [3293] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8255),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3294] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5186),
    [sym__concat] = ACTIONS(5186),
  },
  [3295] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_RBRACE] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3296] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_RBRACE] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3297] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_RBRACE] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3298] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_RBRACE] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3299] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(7858),
    [anon_sym_AMP_GT_GT] = ACTIONS(7858),
    [anon_sym_LF] = ACTIONS(7860),
    [anon_sym_SEMI] = ACTIONS(7858),
    [anon_sym_LT_LT] = ACTIONS(7858),
    [anon_sym_RBRACE] = ACTIONS(7858),
    [anon_sym_GT] = ACTIONS(7858),
    [sym_file_descriptor] = ACTIONS(7860),
    [anon_sym_AMP_GT] = ACTIONS(7858),
    [anon_sym_PIPE_PIPE] = ACTIONS(7858),
    [anon_sym_LT_LT_LT] = ACTIONS(7858),
    [anon_sym_PIPE] = ACTIONS(7858),
    [anon_sym_GT_AMP] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(7858),
    [anon_sym_LT_AMP] = ACTIONS(7858),
    [anon_sym_GT_GT] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(7858),
    [anon_sym_SEMI_SEMI] = ACTIONS(7858),
    [anon_sym_PIPE_AMP] = ACTIONS(7858),
  },
  [3300] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(8031),
    [anon_sym_AMP_GT_GT] = ACTIONS(8031),
    [anon_sym_LF] = ACTIONS(8033),
    [anon_sym_SEMI] = ACTIONS(8031),
    [anon_sym_LT_LT] = ACTIONS(8031),
    [anon_sym_RBRACE] = ACTIONS(8031),
    [anon_sym_GT] = ACTIONS(8031),
    [sym_file_descriptor] = ACTIONS(8033),
    [anon_sym_AMP_GT] = ACTIONS(8031),
    [anon_sym_PIPE_PIPE] = ACTIONS(8031),
    [anon_sym_LT_LT_LT] = ACTIONS(8031),
    [anon_sym_PIPE] = ACTIONS(8031),
    [anon_sym_GT_AMP] = ACTIONS(8031),
    [anon_sym_LT] = ACTIONS(8031),
    [anon_sym_LT_AMP] = ACTIONS(8031),
    [anon_sym_GT_GT] = ACTIONS(8031),
    [anon_sym_AMP] = ACTIONS(8031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(8031),
    [anon_sym_SEMI_SEMI] = ACTIONS(8031),
    [anon_sym_PIPE_AMP] = ACTIONS(8031),
  },
  [3301] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3302] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8257),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3303] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3304] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3305] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8259),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3306] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_RBRACE] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3307] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(8071),
    [anon_sym_AMP_GT_GT] = ACTIONS(8071),
    [anon_sym_LF] = ACTIONS(8073),
    [anon_sym_SEMI] = ACTIONS(8071),
    [anon_sym_LT_LT] = ACTIONS(8071),
    [anon_sym_RBRACE] = ACTIONS(8071),
    [anon_sym_GT] = ACTIONS(8071),
    [sym_file_descriptor] = ACTIONS(8073),
    [anon_sym_AMP_GT] = ACTIONS(8071),
    [anon_sym_PIPE_PIPE] = ACTIONS(8071),
    [anon_sym_LT_LT_LT] = ACTIONS(8071),
    [anon_sym_PIPE] = ACTIONS(8071),
    [anon_sym_GT_AMP] = ACTIONS(8071),
    [anon_sym_LT] = ACTIONS(8071),
    [anon_sym_LT_AMP] = ACTIONS(8071),
    [anon_sym_GT_GT] = ACTIONS(8071),
    [anon_sym_AMP] = ACTIONS(8071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(8071),
    [anon_sym_SEMI_SEMI] = ACTIONS(8071),
    [anon_sym_PIPE_AMP] = ACTIONS(8071),
  },
  [3308] = {
    [sym_do_group] = STATE(3621),
    [sym_compound_statement] = STATE(3621),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(1703),
  },
  [3309] = {
    [sym_do_group] = STATE(3621),
    [sym_compound_statement] = STATE(3621),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(8261),
    [anon_sym_do] = ACTIONS(1703),
  },
  [3310] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_RBRACE] = ACTIONS(5095),
    [anon_sym_GT] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3311] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8263),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3312] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_GT] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3313] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_RBRACE] = ACTIONS(5133),
    [anon_sym_GT] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3314] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8265),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3315] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_RBRACE] = ACTIONS(5184),
    [anon_sym_GT] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3316] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_fi] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [anon_sym_else] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [anon_sym_elif] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [3317] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_fi] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_else] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [anon_sym_elif] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3318] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3319] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3626),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3626),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8269),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [anon_sym_DASH] = ACTIONS(8269),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8269),
    [anon_sym_PERCENT] = ACTIONS(8269),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8271),
    [anon_sym_COLON_DASH] = ACTIONS(8269),
    [sym__special_character] = ACTIONS(599),
  },
  [3320] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8267),
    [sym__concat] = ACTIONS(2610),
  },
  [3321] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8267),
  },
  [3322] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8273),
  },
  [3323] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_fi] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_else] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [anon_sym_elif] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3324] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3629),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3629),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8275),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8277),
    [anon_sym_DASH] = ACTIONS(8275),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8275),
    [anon_sym_PERCENT] = ACTIONS(8275),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8279),
    [anon_sym_COLON_DASH] = ACTIONS(8275),
    [sym__special_character] = ACTIONS(599),
  },
  [3325] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8277),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3326] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_fi] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_else] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_elif] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3327] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_fi] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_else] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_elif] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3328] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8281),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3329] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_fi] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_else] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [anon_sym_elif] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3330] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8283),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3331] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3632),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3632),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8285),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8283),
    [anon_sym_DASH] = ACTIONS(8285),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8285),
    [anon_sym_PERCENT] = ACTIONS(8285),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8287),
    [anon_sym_COLON_DASH] = ACTIONS(8285),
    [sym__special_character] = ACTIONS(599),
  },
  [3332] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8283),
    [sym__concat] = ACTIONS(2610),
  },
  [3333] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8283),
  },
  [3334] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8289),
  },
  [3335] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_fi] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_else] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [anon_sym_elif] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3336] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3635),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3635),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8291),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8293),
    [anon_sym_DASH] = ACTIONS(8291),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8291),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8291),
    [anon_sym_PERCENT] = ACTIONS(8291),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8295),
    [anon_sym_COLON_DASH] = ACTIONS(8291),
    [sym__special_character] = ACTIONS(599),
  },
  [3337] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8293),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3338] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_fi] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_else] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_elif] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3339] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_fi] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_else] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_elif] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3340] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8297),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3341] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_fi] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3342] = {
    [sym_string] = STATE(2491),
    [anon_sym__] = ACTIONS(5535),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(8299),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(8299),
    [anon_sym_fi] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5535),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(5535),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(5535),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(8301),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(4260),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8299),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3343] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_fi] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [3344] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(8303),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [3345] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3346] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3639),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3639),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8305),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8307),
    [anon_sym_DASH] = ACTIONS(8305),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8305),
    [anon_sym_PERCENT] = ACTIONS(8305),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8309),
    [anon_sym_COLON_DASH] = ACTIONS(8305),
    [sym__special_character] = ACTIONS(599),
  },
  [3347] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8307),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3348] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3639),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3639),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8305),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8307),
    [anon_sym_DASH] = ACTIONS(8305),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8305),
    [anon_sym_PERCENT] = ACTIONS(8305),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8309),
    [anon_sym_COLON_DASH] = ACTIONS(8305),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8311),
  },
  [3349] = {
    [sym_process_substitution] = STATE(3641),
    [aux_sym__literal_repeat1] = STATE(3643),
    [sym_simple_expansion] = STATE(3641),
    [sym_string_expansion] = STATE(3641),
    [sym_expansion] = STATE(3641),
    [sym_concatenation] = STATE(3642),
    [sym_string] = STATE(3641),
    [sym_command_substitution] = STATE(3641),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8313),
    [sym_raw_string] = ACTIONS(8313),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8307),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3350] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3646),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3646),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8315),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8317),
    [anon_sym_DASH] = ACTIONS(8315),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8315),
    [anon_sym_PERCENT] = ACTIONS(8315),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8319),
    [anon_sym_COLON_DASH] = ACTIONS(8315),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8321),
  },
  [3351] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3352] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8317),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3353] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8307),
    [sym__concat] = ACTIONS(2610),
  },
  [3354] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8307),
  },
  [3355] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8323),
  },
  [3356] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_fi] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3357] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3649),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3649),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8325),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8327),
    [anon_sym_DASH] = ACTIONS(8325),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8325),
    [anon_sym_PERCENT] = ACTIONS(8325),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8329),
    [anon_sym_COLON_DASH] = ACTIONS(8325),
    [sym__special_character] = ACTIONS(599),
  },
  [3358] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8327),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3359] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_fi] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3360] = {
    [sym_string] = STATE(2510),
    [anon_sym__] = ACTIONS(5565),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(8331),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(8331),
    [anon_sym_fi] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5565),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(5565),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(5565),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(8333),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(5565),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(4278),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(5565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8331),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3361] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3362] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3651),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3651),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8335),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8337),
    [anon_sym_DASH] = ACTIONS(8335),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8335),
    [anon_sym_PERCENT] = ACTIONS(8335),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8339),
    [anon_sym_COLON_DASH] = ACTIONS(8335),
    [sym__special_character] = ACTIONS(599),
  },
  [3363] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8337),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3364] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3651),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3651),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8335),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8337),
    [anon_sym_DASH] = ACTIONS(8335),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8335),
    [anon_sym_PERCENT] = ACTIONS(8335),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8339),
    [anon_sym_COLON_DASH] = ACTIONS(8335),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8341),
  },
  [3365] = {
    [sym_process_substitution] = STATE(3653),
    [aux_sym__literal_repeat1] = STATE(3655),
    [sym_simple_expansion] = STATE(3653),
    [sym_string_expansion] = STATE(3653),
    [sym_expansion] = STATE(3653),
    [sym_concatenation] = STATE(3654),
    [sym_string] = STATE(3653),
    [sym_command_substitution] = STATE(3653),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8343),
    [sym_raw_string] = ACTIONS(8343),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8337),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3366] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3658),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3658),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8345),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8347),
    [anon_sym_DASH] = ACTIONS(8345),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8345),
    [anon_sym_PERCENT] = ACTIONS(8345),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8349),
    [anon_sym_COLON_DASH] = ACTIONS(8345),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8351),
  },
  [3367] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3368] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8347),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3369] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8337),
    [sym__concat] = ACTIONS(2610),
  },
  [3370] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8337),
  },
  [3371] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8353),
  },
  [3372] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_fi] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3373] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3661),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3661),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8355),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8357),
    [anon_sym_DASH] = ACTIONS(8355),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8355),
    [anon_sym_PERCENT] = ACTIONS(8355),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8359),
    [anon_sym_COLON_DASH] = ACTIONS(8355),
    [sym__special_character] = ACTIONS(599),
  },
  [3374] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8357),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3375] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_fi] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_EQ_TILDE] = ACTIONS(3830),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3376] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8361),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3377] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3663),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3663),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8363),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8361),
    [anon_sym_DASH] = ACTIONS(8363),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8363),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8363),
    [anon_sym_PERCENT] = ACTIONS(8363),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8365),
    [anon_sym_COLON_DASH] = ACTIONS(8363),
    [sym__special_character] = ACTIONS(599),
  },
  [3378] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8361),
    [sym__concat] = ACTIONS(2610),
  },
  [3379] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8361),
  },
  [3380] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8367),
  },
  [3381] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_fi] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_EQ_TILDE] = ACTIONS(3879),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3382] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3666),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3666),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8369),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8371),
    [anon_sym_DASH] = ACTIONS(8369),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8369),
    [anon_sym_PERCENT] = ACTIONS(8369),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8373),
    [anon_sym_COLON_DASH] = ACTIONS(8369),
    [sym__special_character] = ACTIONS(599),
  },
  [3383] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8371),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3384] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_fi] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3927),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3385] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_fi] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_EQ_TILDE] = ACTIONS(3946),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3386] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8375),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3387] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_fi] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [3388] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_fi] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [3389] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_fi] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [3390] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(8377),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3391] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3392] = {
    [sym_process_substitution] = STATE(3391),
    [sym_string_expansion] = STATE(3391),
    [sym_expansion] = STATE(3391),
    [sym_simple_expansion] = STATE(3391),
    [sym_string] = STATE(3391),
    [sym_command_substitution] = STATE(3391),
    [anon_sym_BQUOTE] = ACTIONS(5617),
    [anon_sym_DQUOTE] = ACTIONS(5619),
    [sym_word] = ACTIONS(7760),
    [sym_raw_string] = ACTIONS(7760),
    [anon_sym_LT_LPAREN] = ACTIONS(5623),
    [anon_sym_DOLLAR] = ACTIONS(8379),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5623),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5627),
    [sym__special_character] = ACTIONS(7760),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5631),
  },
  [3393] = {
    [aux_sym_concatenation_repeat1] = STATE(3393),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(8381),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3394] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_fi] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [3395] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3672),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3672),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8384),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8386),
    [anon_sym_DASH] = ACTIONS(8384),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_PERCENT] = ACTIONS(8384),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8388),
    [anon_sym_COLON_DASH] = ACTIONS(8384),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8390),
  },
  [3396] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_fi] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [3397] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8386),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3398] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3672),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3672),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8392),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8384),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8386),
    [anon_sym_DASH] = ACTIONS(8384),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_PERCENT] = ACTIONS(8384),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8388),
    [anon_sym_COLON_DASH] = ACTIONS(8384),
    [sym__special_character] = ACTIONS(599),
  },
  [3399] = {
    [anon_sym_EQ] = ACTIONS(8394),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3400] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3677),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3677),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8396),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8398),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8400),
    [anon_sym_DASH] = ACTIONS(8398),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8398),
    [anon_sym_PERCENT] = ACTIONS(8398),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8402),
    [anon_sym_COLON_DASH] = ACTIONS(8398),
    [sym__special_character] = ACTIONS(599),
  },
  [3401] = {
    [sym_process_substitution] = STATE(3678),
    [aux_sym__literal_repeat1] = STATE(3680),
    [sym_simple_expansion] = STATE(3678),
    [sym_string_expansion] = STATE(3678),
    [sym_expansion] = STATE(3678),
    [sym_concatenation] = STATE(3679),
    [sym_string] = STATE(3678),
    [sym_command_substitution] = STATE(3678),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8404),
    [sym_raw_string] = ACTIONS(8404),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8386),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3402] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3683),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3683),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8406),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8408),
    [anon_sym_DASH] = ACTIONS(8406),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8406),
    [anon_sym_PERCENT] = ACTIONS(8406),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8410),
    [anon_sym_COLON_DASH] = ACTIONS(8406),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8412),
  },
  [3403] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_fi] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [3404] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8408),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3405] = {
    [sym_process_substitution] = STATE(1700),
    [sym_string_expansion] = STATE(1700),
    [sym_expansion] = STATE(1700),
    [sym_simple_expansion] = STATE(1700),
    [sym_string] = STATE(1700),
    [sym_command_substitution] = STATE(1700),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(3669),
    [sym_raw_string] = ACTIONS(3669),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(8414),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(3669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [3406] = {
    [aux_sym_concatenation_repeat1] = STATE(3406),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_fi] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3407] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_fi] = ACTIONS(7856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
  },
  [3408] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_fi] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_else] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_EQ_TILDE] = ACTIONS(5095),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_EQ_EQ] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [anon_sym_elif] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3409] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8416),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3410] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_fi] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_else] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [anon_sym_elif] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3411] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_fi] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_else] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5133),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_EQ_EQ] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [anon_sym_elif] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3412] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8418),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3413] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_fi] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_else] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_EQ_TILDE] = ACTIONS(5184),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_EQ_EQ] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [anon_sym_elif] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3414] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_fi] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_elif] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3415] = {
    [sym_string] = STATE(2593),
    [anon_sym__] = ACTIONS(5709),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(8420),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(8420),
    [anon_sym_fi] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_else] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5709),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(5709),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(5709),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(8422),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(5709),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(8424),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(5709),
    [anon_sym_elif] = ACTIONS(2658),
    [anon_sym_POUND] = ACTIONS(8420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3416] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [anon_sym_elif] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3417] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3688),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3688),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8426),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8428),
    [anon_sym_DASH] = ACTIONS(8426),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8426),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8426),
    [anon_sym_PERCENT] = ACTIONS(8426),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8430),
    [anon_sym_COLON_DASH] = ACTIONS(8426),
    [sym__special_character] = ACTIONS(599),
  },
  [3418] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8428),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3419] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3688),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3688),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8426),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8428),
    [anon_sym_DASH] = ACTIONS(8426),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8426),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8426),
    [anon_sym_PERCENT] = ACTIONS(8426),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8430),
    [anon_sym_COLON_DASH] = ACTIONS(8426),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8432),
  },
  [3420] = {
    [sym_process_substitution] = STATE(3690),
    [aux_sym__literal_repeat1] = STATE(3692),
    [sym_simple_expansion] = STATE(3690),
    [sym_string_expansion] = STATE(3690),
    [sym_expansion] = STATE(3690),
    [sym_concatenation] = STATE(3691),
    [sym_string] = STATE(3690),
    [sym_command_substitution] = STATE(3690),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8434),
    [sym_raw_string] = ACTIONS(8434),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8428),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3421] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3695),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3695),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8436),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8438),
    [anon_sym_DASH] = ACTIONS(8436),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8436),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8436),
    [anon_sym_PERCENT] = ACTIONS(8436),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8440),
    [anon_sym_COLON_DASH] = ACTIONS(8436),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8442),
  },
  [3422] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_else] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [anon_sym_elif] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3423] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8438),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3424] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8428),
    [sym__concat] = ACTIONS(2610),
  },
  [3425] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8428),
  },
  [3426] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8444),
  },
  [3427] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_fi] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_elif] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3428] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3698),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3698),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8446),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8448),
    [anon_sym_DASH] = ACTIONS(8446),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8446),
    [anon_sym_PERCENT] = ACTIONS(8446),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8450),
    [anon_sym_COLON_DASH] = ACTIONS(8446),
    [sym__special_character] = ACTIONS(599),
  },
  [3429] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8448),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3430] = {
    [sym_string] = STATE(1124),
    [anon_sym__] = ACTIONS(2231),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(6361),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(6361),
    [anon_sym_fi] = ACTIONS(2658),
    [anon_sym_else] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2231),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(6363),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(6365),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2231),
    [anon_sym_elif] = ACTIONS(2658),
    [anon_sym_POUND] = ACTIONS(6361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3431] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(8452),
  },
  [3432] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(8454),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3433] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [3434] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(8456),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(8454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [3435] = {
    [sym_process_substitution] = STATE(3702),
    [sym_string_expansion] = STATE(3702),
    [sym_expansion] = STATE(3702),
    [sym_simple_expansion] = STATE(3702),
    [sym_string] = STATE(3702),
    [sym_command_substitution] = STATE(3702),
    [anon_sym_BQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE] = ACTIONS(7870),
    [sym_word] = ACTIONS(8460),
    [sym_raw_string] = ACTIONS(8460),
    [anon_sym_LT_LPAREN] = ACTIONS(8462),
    [anon_sym_DOLLAR] = ACTIONS(7040),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8464),
    [sym__special_character] = ACTIONS(8460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8466),
  },
  [3436] = {
    [aux_sym_concatenation_repeat1] = STATE(3704),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(8468),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [anon_sym_esac] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [3437] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(8470),
  },
  [3438] = {
    [sym_process_substitution] = STATE(3707),
    [aux_sym__literal_repeat1] = STATE(3709),
    [sym_array] = STATE(3708),
    [sym_simple_expansion] = STATE(3707),
    [sym_string_expansion] = STATE(3707),
    [sym_expansion] = STATE(3707),
    [sym_concatenation] = STATE(3708),
    [sym_string] = STATE(3707),
    [sym_command_substitution] = STATE(3707),
    [anon_sym_LPAREN] = ACTIONS(8472),
    [anon_sym_BQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE] = ACTIONS(7870),
    [sym_word] = ACTIONS(8474),
    [sym_raw_string] = ACTIONS(8474),
    [anon_sym_LT_LPAREN] = ACTIONS(8462),
    [anon_sym_DOLLAR] = ACTIONS(7040),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8464),
    [sym__special_character] = ACTIONS(8476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8466),
    [sym__empty_value] = ACTIONS(8478),
  },
  [3439] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [anon_sym_esac] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [3440] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_esac] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [3441] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [anon_sym_esac] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [3442] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [3443] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(8452),
  },
  [3444] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3712),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3712),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8480),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8482),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8484),
    [anon_sym_DASH] = ACTIONS(8482),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8482),
    [anon_sym_PERCENT] = ACTIONS(8482),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8486),
    [anon_sym_COLON_DASH] = ACTIONS(8482),
    [sym__special_character] = ACTIONS(599),
  },
  [3445] = {
    [sym_subscript] = STATE(3713),
    [anon_sym_STAR] = ACTIONS(8488),
    [anon_sym_QMARK] = ACTIONS(8488),
    [anon_sym_AT] = ACTIONS(8488),
    [sym_variable_name] = ACTIONS(8490),
    [anon_sym_DOLLAR] = ACTIONS(8492),
    [anon_sym_DASH] = ACTIONS(8492),
    [anon_sym_0] = ACTIONS(8494),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(8494),
    [anon_sym__] = ACTIONS(8494),
  },
  [3446] = {
    [anon_sym_EQ] = ACTIONS(8496),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3447] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3719),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3719),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8498),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8500),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8502),
    [anon_sym_DASH] = ACTIONS(8500),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8500),
    [anon_sym_PERCENT] = ACTIONS(8500),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8504),
    [anon_sym_COLON_DASH] = ACTIONS(8500),
    [sym__special_character] = ACTIONS(599),
  },
  [3448] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [3449] = {
    [aux_sym__literal_repeat1] = STATE(3449),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(8506),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [anon_sym_esac] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [3450] = {
    [sym_process_substitution] = STATE(3077),
    [sym_string] = STATE(3077),
    [sym_command_substitution] = STATE(3077),
    [sym_simple_expansion] = STATE(3077),
    [sym_variable_assignment] = STATE(3450),
    [sym_subscript] = STATE(3086),
    [sym_string_expansion] = STATE(3077),
    [sym_expansion] = STATE(3077),
    [sym_concatenation] = STATE(3450),
    [aux_sym_declaration_command_repeat1] = STATE(3450),
    [aux_sym__literal_repeat1] = STATE(3084),
    [anon_sym_AMP_GT_GT] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(8509),
    [anon_sym_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_LPAREN] = ACTIONS(8512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8515),
    [aux_sym__simple_variable_name_token1] = ACTIONS(8518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8521),
    [anon_sym_PIPE_PIPE] = ACTIONS(1320),
    [sym_word] = ACTIONS(8524),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_AMP] = ACTIONS(1320),
    [anon_sym_LT] = ACTIONS(1320),
    [anon_sym_LT_AMP] = ACTIONS(1320),
    [anon_sym_GT_GT] = ACTIONS(1320),
    [sym__special_character] = ACTIONS(8527),
    [anon_sym_LT_LT_DASH] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(8530),
    [anon_sym_LF] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1320),
    [sym_raw_string] = ACTIONS(8524),
    [sym_variable_name] = ACTIONS(8533),
    [sym_file_descriptor] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1320),
    [anon_sym_AMP_GT] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(8536),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_GT_AMP] = ACTIONS(1320),
    [anon_sym_LT_LPAREN] = ACTIONS(8512),
    [anon_sym_esac] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1320),
    [anon_sym_SEMI_SEMI] = ACTIONS(1320),
    [anon_sym_PIPE_AMP] = ACTIONS(1320),
  },
  [3451] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(8539),
  },
  [3452] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(8541),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3453] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [3454] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(8543),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(8541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [3455] = {
    [sym_process_substitution] = STATE(3723),
    [sym_string_expansion] = STATE(3723),
    [sym_expansion] = STATE(3723),
    [sym_simple_expansion] = STATE(3723),
    [sym_string] = STATE(3723),
    [sym_command_substitution] = STATE(3723),
    [anon_sym_BQUOTE] = ACTIONS(8545),
    [anon_sym_DQUOTE] = ACTIONS(7900),
    [sym_word] = ACTIONS(8547),
    [sym_raw_string] = ACTIONS(8547),
    [anon_sym_LT_LPAREN] = ACTIONS(8549),
    [anon_sym_DOLLAR] = ACTIONS(7060),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8549),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8551),
    [sym__special_character] = ACTIONS(8547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8553),
  },
  [3456] = {
    [aux_sym_concatenation_repeat1] = STATE(3725),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [aux_sym__simple_variable_name_token1] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(8555),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [anon_sym_esac] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [3457] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(8557),
  },
  [3458] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [anon_sym_esac] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [3459] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [aux_sym__simple_variable_name_token1] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_esac] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [3460] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [aux_sym__simple_variable_name_token1] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [anon_sym_esac] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [3461] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(8539),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [3462] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(8539),
  },
  [3463] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3729),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3729),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8559),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8561),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8563),
    [anon_sym_DASH] = ACTIONS(8561),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8561),
    [anon_sym_PERCENT] = ACTIONS(8561),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8565),
    [anon_sym_COLON_DASH] = ACTIONS(8561),
    [sym__special_character] = ACTIONS(599),
  },
  [3464] = {
    [sym_subscript] = STATE(3730),
    [anon_sym_STAR] = ACTIONS(8567),
    [anon_sym_QMARK] = ACTIONS(8567),
    [anon_sym_AT] = ACTIONS(8567),
    [sym_variable_name] = ACTIONS(8569),
    [anon_sym_DOLLAR] = ACTIONS(8571),
    [anon_sym_DASH] = ACTIONS(8571),
    [anon_sym_0] = ACTIONS(8573),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(8573),
    [anon_sym__] = ACTIONS(8573),
  },
  [3465] = {
    [anon_sym_EQ] = ACTIONS(8575),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3466] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3736),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3736),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8577),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8579),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8581),
    [anon_sym_DASH] = ACTIONS(8579),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8579),
    [anon_sym_PERCENT] = ACTIONS(8579),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8583),
    [anon_sym_COLON_DASH] = ACTIONS(8579),
    [sym__special_character] = ACTIONS(599),
  },
  [3467] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [aux_sym__simple_variable_name_token1] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [3468] = {
    [aux_sym__literal_repeat1] = STATE(3468),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(8585),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [anon_sym_esac] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [3469] = {
    [sym_process_substitution] = STATE(3089),
    [sym_command_substitution] = STATE(3089),
    [aux_sym_unset_command_repeat1] = STATE(3469),
    [sym_simple_expansion] = STATE(3089),
    [sym_string_expansion] = STATE(3089),
    [sym_expansion] = STATE(3089),
    [sym_concatenation] = STATE(3469),
    [sym_string] = STATE(3089),
    [aux_sym__literal_repeat1] = STATE(3095),
    [anon_sym_AMP_GT_GT] = ACTIONS(1403),
    [anon_sym_DOLLAR] = ACTIONS(8588),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_LPAREN] = ACTIONS(8591),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8594),
    [aux_sym__simple_variable_name_token1] = ACTIONS(8597),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1403),
    [sym_word] = ACTIONS(8603),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_LT_AMP] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [sym__special_character] = ACTIONS(8606),
    [anon_sym_LT_LT_DASH] = ACTIONS(1403),
    [anon_sym_BQUOTE] = ACTIONS(8609),
    [anon_sym_LF] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1403),
    [sym_raw_string] = ACTIONS(8603),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_AMP_GT] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(8612),
    [anon_sym_LT_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_AMP] = ACTIONS(1403),
    [anon_sym_LT_LPAREN] = ACTIONS(8591),
    [anon_sym_esac] = ACTIONS(1403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1403),
    [anon_sym_PIPE_AMP] = ACTIONS(1403),
  },
  [3470] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [anon_sym_EQ_TILDE] = ACTIONS(1434),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_esac] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [3471] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [anon_sym_EQ_TILDE] = ACTIONS(1440),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_EQ_EQ] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [anon_sym_esac] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [3472] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3739),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3739),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8615),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8617),
    [anon_sym_DASH] = ACTIONS(8615),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8615),
    [anon_sym_PERCENT] = ACTIONS(8615),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8619),
    [anon_sym_COLON_DASH] = ACTIONS(8615),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8621),
  },
  [3473] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [anon_sym_EQ_TILDE] = ACTIONS(1476),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [anon_sym_esac] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [3474] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8617),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3475] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3739),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3739),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8623),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8615),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8617),
    [anon_sym_DASH] = ACTIONS(8615),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8615),
    [anon_sym_PERCENT] = ACTIONS(8615),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8619),
    [anon_sym_COLON_DASH] = ACTIONS(8615),
    [sym__special_character] = ACTIONS(599),
  },
  [3476] = {
    [anon_sym_EQ] = ACTIONS(8625),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3477] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3744),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3744),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8627),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8629),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8631),
    [anon_sym_DASH] = ACTIONS(8629),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8629),
    [anon_sym_PERCENT] = ACTIONS(8629),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8633),
    [anon_sym_COLON_DASH] = ACTIONS(8629),
    [sym__special_character] = ACTIONS(599),
  },
  [3478] = {
    [sym_process_substitution] = STATE(3745),
    [aux_sym__literal_repeat1] = STATE(3747),
    [sym_simple_expansion] = STATE(3745),
    [sym_string_expansion] = STATE(3745),
    [sym_expansion] = STATE(3745),
    [sym_concatenation] = STATE(3746),
    [sym_string] = STATE(3745),
    [sym_command_substitution] = STATE(3745),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8635),
    [sym_raw_string] = ACTIONS(8635),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8617),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3479] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3750),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3750),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8637),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8639),
    [anon_sym_DASH] = ACTIONS(8637),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8637),
    [anon_sym_PERCENT] = ACTIONS(8637),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8641),
    [anon_sym_COLON_DASH] = ACTIONS(8637),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8643),
  },
  [3480] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1532),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_esac] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [3481] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8639),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3482] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3483] = {
    [sym_process_substitution] = STATE(3482),
    [sym_string_expansion] = STATE(3482),
    [sym_expansion] = STATE(3482),
    [sym_simple_expansion] = STATE(3482),
    [sym_string] = STATE(3482),
    [sym_command_substitution] = STATE(3482),
    [anon_sym_BQUOTE] = ACTIONS(5801),
    [anon_sym_DQUOTE] = ACTIONS(5807),
    [sym_word] = ACTIONS(7954),
    [sym_raw_string] = ACTIONS(7954),
    [anon_sym_LT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR] = ACTIONS(8645),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5791),
    [sym__special_character] = ACTIONS(7954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5793),
  },
  [3484] = {
    [aux_sym_concatenation_repeat1] = STATE(3484),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(8647),
    [anon_sym_EQ_TILDE] = ACTIONS(1542),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3485] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(3753),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(3753),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(8650),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [3486] = {
    [sym_redirected_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_function_definition] = STATE(172),
    [sym_compound_statement] = STATE(172),
    [sym_test_command] = STATE(172),
    [sym_declaration_command] = STATE(172),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(173),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(173),
    [sym_for_statement] = STATE(172),
    [sym_c_style_for_statement] = STATE(172),
    [sym_case_statement] = STATE(172),
    [sym_subshell] = STATE(172),
    [sym_pipeline] = STATE(172),
    [sym_unset_command] = STATE(172),
    [sym_command] = STATE(172),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(3754),
    [sym_while_statement] = STATE(172),
    [sym_list] = STATE(172),
    [sym_negated_command] = STATE(172),
    [sym_command_name] = STATE(175),
    [sym_variable_assignment] = STATE(176),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(177),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(277),
    [anon_sym_typeset] = ACTIONS(277),
    [anon_sym_unsetenv] = ACTIONS(279),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(277),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(281),
    [anon_sym_declare] = ACTIONS(277),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(277),
    [anon_sym_unset] = ACTIONS(279),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3487] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(3757),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(8652),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(8654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [3488] = {
    [aux_sym_concatenation_repeat1] = STATE(3759),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(8656),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_esac] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [3489] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(46),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3760),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3490] = {
    [sym_string] = STATE(3762),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [anon_sym_STAR] = ACTIONS(8658),
    [anon_sym_QMARK] = ACTIONS(8658),
    [sym_raw_string] = ACTIONS(8660),
    [anon_sym_AT] = ACTIONS(8658),
    [anon_sym_DOLLAR] = ACTIONS(8662),
    [anon_sym_POUND] = ACTIONS(8662),
    [anon_sym_DASH] = ACTIONS(8662),
    [anon_sym_0] = ACTIONS(8664),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(8664),
    [anon_sym__] = ACTIONS(8664),
  },
  [3491] = {
    [sym_redirected_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_test_command] = STATE(44),
    [sym_declaration_command] = STATE(44),
    [sym_subscript] = STATE(45),
    [sym_file_redirect] = STATE(3764),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(46),
    [sym_for_statement] = STATE(44),
    [sym_c_style_for_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_subshell] = STATE(44),
    [sym_pipeline] = STATE(44),
    [sym_unset_command] = STATE(44),
    [sym_command] = STATE(44),
    [sym_simple_expansion] = STATE(41),
    [sym__statements] = STATE(3765),
    [sym_while_statement] = STATE(44),
    [sym_list] = STATE(44),
    [sym_negated_command] = STATE(44),
    [sym_command_name] = STATE(48),
    [sym_variable_assignment] = STATE(49),
    [sym_string_expansion] = STATE(41),
    [sym_expansion] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(50),
    [aux_sym__literal_repeat1] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3492] = {
    [aux_sym_concatenation_repeat1] = STATE(3759),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__concat] = ACTIONS(8656),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [3493] = {
    [sym_subscript] = STATE(3766),
    [anon_sym_STAR] = ACTIONS(8666),
    [anon_sym_QMARK] = ACTIONS(8666),
    [anon_sym_BANG] = ACTIONS(8668),
    [anon_sym_AT] = ACTIONS(8666),
    [sym_variable_name] = ACTIONS(8670),
    [anon_sym_DOLLAR] = ACTIONS(8672),
    [anon_sym_DASH] = ACTIONS(8672),
    [anon_sym_0] = ACTIONS(8674),
    [anon_sym_POUND] = ACTIONS(8668),
    [aux_sym__simple_variable_name_token1] = ACTIONS(8674),
    [anon_sym__] = ACTIONS(8674),
    [sym_comment] = ACTIONS(3),
  },
  [3494] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_esac] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [3495] = {
    [aux_sym__literal_repeat1] = STATE(3771),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(8676),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_esac] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [3496] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [anon_sym_EQ_TILDE] = ACTIONS(2010),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [anon_sym_esac] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [3497] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(8678),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3498] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3121),
    [sym_file_redirect] = STATE(3121),
    [sym_herestring_redirect] = STATE(3121),
    [sym_heredoc_redirect] = STATE(3121),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_esac] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [3499] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3121),
    [sym_file_redirect] = STATE(3121),
    [sym_herestring_redirect] = STATE(3121),
    [sym_heredoc_redirect] = STATE(3121),
    [anon_sym_AMP_GT_GT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2215),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(2215),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2215),
    [anon_sym_LT_AMP] = ACTIONS(2215),
    [anon_sym_GT_GT] = ACTIONS(2215),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2217),
    [anon_sym_SEMI] = ACTIONS(2215),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(2217),
    [anon_sym_GT] = ACTIONS(2215),
    [anon_sym_AMP_GT] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2215),
    [anon_sym_GT_AMP] = ACTIONS(2215),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [anon_sym_esac] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2215),
    [anon_sym_SEMI_SEMI] = ACTIONS(2215),
    [anon_sym_PIPE_AMP] = ACTIONS(2215),
  },
  [3500] = {
    [aux_sym_concatenation_repeat1] = STATE(3773),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LF] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_esac] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
  },
  [3501] = {
    [aux_sym_concatenation_repeat1] = STATE(3773),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [3502] = {
    [aux_sym__literal_repeat1] = STATE(3774),
    [anon_sym_LT_LT_DASH] = ACTIONS(461),
    [anon_sym_AMP_GT_GT] = ACTIONS(461),
    [anon_sym_LF] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_LT_LT] = ACTIONS(461),
    [sym_file_descriptor] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_AMP_GT] = ACTIONS(461),
    [anon_sym_PIPE_PIPE] = ACTIONS(461),
    [anon_sym_LT_LT_LT] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_GT_AMP] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_esac] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_LT_AMP] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(461),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(461),
    [anon_sym_PIPE_AMP] = ACTIONS(461),
  },
  [3503] = {
    [anon_sym_AMP] = ACTIONS(8680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(8682),
    [anon_sym_SEMI] = ACTIONS(8680),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_esac] = ACTIONS(2261),
  },
  [3504] = {
    [sym_process_substitution] = STATE(3776),
    [aux_sym__literal_repeat1] = STATE(3777),
    [sym_simple_expansion] = STATE(3776),
    [sym_string_expansion] = STATE(3776),
    [sym_expansion] = STATE(3776),
    [sym_concatenation] = STATE(1142),
    [sym_string] = STATE(3776),
    [sym_command_substitution] = STATE(3776),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(8684),
    [sym_raw_string] = ACTIONS(8684),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(1043),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(7984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [3505] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3121),
    [sym_file_redirect] = STATE(3121),
    [sym_herestring_redirect] = STATE(3121),
    [sym_heredoc_redirect] = STATE(3121),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_AMP_GT_GT] = ACTIONS(2275),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [sym_file_descriptor] = ACTIONS(2277),
    [anon_sym_GT] = ACTIONS(2275),
    [anon_sym_AMP_GT] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_PIPE] = ACTIONS(7122),
    [anon_sym_GT_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(2275),
    [anon_sym_esac] = ACTIONS(2275),
    [anon_sym_GT_GT] = ACTIONS(2275),
    [anon_sym_LT_AMP] = ACTIONS(2275),
    [anon_sym_AMP] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(7122),
  },
  [3506] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3121),
    [sym_file_redirect] = STATE(3121),
    [sym_herestring_redirect] = STATE(3121),
    [sym_heredoc_redirect] = STATE(3121),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2275),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(7122),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(2275),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(2277),
    [anon_sym_SEMI] = ACTIONS(2275),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(2275),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [anon_sym_esac] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2275),
    [anon_sym_SEMI_SEMI] = ACTIONS(2275),
    [anon_sym_PIPE_AMP] = ACTIONS(7122),
  },
  [3507] = {
    [aux_sym_concatenation_repeat1] = STATE(3773),
    [anon_sym_LT_LT_DASH] = ACTIONS(2279),
    [anon_sym_AMP_GT_GT] = ACTIONS(2279),
    [anon_sym_LF] = ACTIONS(2281),
    [anon_sym_SEMI] = ACTIONS(2279),
    [anon_sym_LT_LT] = ACTIONS(2279),
    [sym_file_descriptor] = ACTIONS(2281),
    [anon_sym_GT] = ACTIONS(2279),
    [anon_sym_AMP_GT] = ACTIONS(2279),
    [anon_sym_PIPE_PIPE] = ACTIONS(2279),
    [anon_sym_LT_LT_LT] = ACTIONS(2279),
    [anon_sym_PIPE] = ACTIONS(2279),
    [anon_sym_GT_AMP] = ACTIONS(2279),
    [anon_sym_LT] = ACTIONS(2279),
    [anon_sym_esac] = ACTIONS(2279),
    [anon_sym_GT_GT] = ACTIONS(2279),
    [anon_sym_LT_AMP] = ACTIONS(2279),
    [anon_sym_AMP] = ACTIONS(2279),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(2279),
    [anon_sym_PIPE_AMP] = ACTIONS(2279),
  },
  [3508] = {
    [aux_sym__literal_repeat1] = STATE(3774),
    [anon_sym_LT_LT_DASH] = ACTIONS(2283),
    [anon_sym_AMP_GT_GT] = ACTIONS(2283),
    [anon_sym_LF] = ACTIONS(2285),
    [anon_sym_SEMI] = ACTIONS(2283),
    [anon_sym_LT_LT] = ACTIONS(2283),
    [sym_file_descriptor] = ACTIONS(2285),
    [anon_sym_GT] = ACTIONS(2283),
    [anon_sym_AMP_GT] = ACTIONS(2283),
    [anon_sym_PIPE_PIPE] = ACTIONS(2283),
    [anon_sym_LT_LT_LT] = ACTIONS(2283),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_GT_AMP] = ACTIONS(2283),
    [anon_sym_LT] = ACTIONS(2283),
    [anon_sym_esac] = ACTIONS(2283),
    [anon_sym_GT_GT] = ACTIONS(2283),
    [anon_sym_LT_AMP] = ACTIONS(2283),
    [anon_sym_AMP] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2283),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2283),
    [anon_sym_PIPE_AMP] = ACTIONS(2283),
  },
  [3509] = {
    [aux_sym_redirected_statement_repeat1] = STATE(3509),
    [sym_file_redirect] = STATE(3509),
    [sym_herestring_redirect] = STATE(3509),
    [sym_heredoc_redirect] = STATE(3509),
    [anon_sym_LT_LT_DASH] = ACTIONS(2287),
    [anon_sym_AMP_GT_GT] = ACTIONS(8686),
    [anon_sym_LF] = ACTIONS(2293),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2287),
    [sym_file_descriptor] = ACTIONS(8689),
    [anon_sym_GT] = ACTIONS(8686),
    [anon_sym_AMP_GT] = ACTIONS(8686),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_LT_LT_LT] = ACTIONS(8692),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_GT_AMP] = ACTIONS(8686),
    [anon_sym_LT] = ACTIONS(8686),
    [anon_sym_esac] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(8686),
    [anon_sym_LT_AMP] = ACTIONS(8686),
    [anon_sym_AMP] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_SEMI_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_AMP] = ACTIONS(2295),
  },
  [3510] = {
    [sym_process_substitution] = STATE(3124),
    [sym_command_substitution] = STATE(3124),
    [sym_simple_expansion] = STATE(3124),
    [sym_string_expansion] = STATE(3124),
    [sym_expansion] = STATE(3124),
    [aux_sym_command_repeat2] = STATE(3514),
    [sym_concatenation] = STATE(3514),
    [sym_string] = STATE(3124),
    [aux_sym__literal_repeat1] = STATE(3126),
    [anon_sym_AMP_GT_GT] = ACTIONS(2303),
    [anon_sym_DOLLAR] = ACTIONS(5787),
    [anon_sym_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_LPAREN] = ACTIONS(7130),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7134),
    [anon_sym_PIPE_PIPE] = ACTIONS(2303),
    [sym_word] = ACTIONS(7136),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_LT_AMP] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_TILDE] = ACTIONS(7138),
    [sym__special_character] = ACTIONS(5797),
    [anon_sym_LT_LT_DASH] = ACTIONS(2303),
    [anon_sym_BQUOTE] = ACTIONS(7140),
    [anon_sym_LF] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2303),
    [sym_raw_string] = ACTIONS(7136),
    [sym_file_descriptor] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ] = ACTIONS(7138),
    [anon_sym_DQUOTE] = ACTIONS(7142),
    [anon_sym_LT_LT_LT] = ACTIONS(2303),
    [anon_sym_GT_AMP] = ACTIONS(2303),
    [anon_sym_LT_LPAREN] = ACTIONS(7130),
    [anon_sym_esac] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2303),
    [anon_sym_SEMI_SEMI] = ACTIONS(2303),
    [anon_sym_PIPE_AMP] = ACTIONS(2303),
  },
  [3511] = {
    [aux_sym_concatenation_repeat1] = STATE(3108),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [sym__concat] = ACTIONS(7096),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [anon_sym_esac] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [3512] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [sym__special_character] = ACTIONS(2307),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(2307),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(2307),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(2307),
    [anon_sym_esac] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [3513] = {
    [aux_sym__literal_repeat1] = STATE(3131),
    [anon_sym_AMP_GT_GT] = ACTIONS(2311),
    [anon_sym_DOLLAR] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [sym_word] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_LT_AMP] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(2311),
    [anon_sym_EQ_TILDE] = ACTIONS(2311),
    [sym__special_character] = ACTIONS(7144),
    [anon_sym_LT_LT_DASH] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_LF] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [sym_raw_string] = ACTIONS(2311),
    [sym_file_descriptor] = ACTIONS(2313),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP_GT] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_LT_LT_LT] = ACTIONS(2311),
    [anon_sym_GT_AMP] = ACTIONS(2311),
    [anon_sym_LT_LPAREN] = ACTIONS(2311),
    [anon_sym_esac] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_SEMI_SEMI] = ACTIONS(2311),
    [anon_sym_PIPE_AMP] = ACTIONS(2311),
  },
  [3514] = {
    [sym_process_substitution] = STATE(3124),
    [sym_command_substitution] = STATE(3124),
    [sym_simple_expansion] = STATE(3124),
    [sym_string_expansion] = STATE(3124),
    [sym_expansion] = STATE(3124),
    [aux_sym_command_repeat2] = STATE(3514),
    [sym_concatenation] = STATE(3514),
    [sym_string] = STATE(3124),
    [aux_sym__literal_repeat1] = STATE(3126),
    [anon_sym_AMP_GT_GT] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(8695),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_LPAREN] = ACTIONS(8698),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8701),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [sym_word] = ACTIONS(8707),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_LT_AMP] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(8710),
    [sym__special_character] = ACTIONS(8713),
    [anon_sym_LT_LT_DASH] = ACTIONS(2307),
    [anon_sym_BQUOTE] = ACTIONS(8716),
    [anon_sym_LF] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [sym_raw_string] = ACTIONS(8707),
    [sym_file_descriptor] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(8710),
    [anon_sym_DQUOTE] = ACTIONS(8719),
    [anon_sym_LT_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_AMP] = ACTIONS(2307),
    [anon_sym_LT_LPAREN] = ACTIONS(8698),
    [anon_sym_esac] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_SEMI_SEMI] = ACTIONS(2307),
    [anon_sym_PIPE_AMP] = ACTIONS(2307),
  },
  [3515] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(2261),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(2263),
  },
  [3516] = {
    [sym_heredoc_body] = STATE(3778),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(2261),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(2263),
  },
  [3517] = {
    [anon_sym_BQUOTE] = ACTIONS(8722),
    [anon_sym_DQUOTE] = ACTIONS(8722),
    [sym_word] = ACTIONS(8724),
    [sym_raw_string] = ACTIONS(8722),
    [anon_sym_LT_LPAREN] = ACTIONS(8722),
    [anon_sym_esac] = ACTIONS(8726),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8722),
    [sym__special_character] = ACTIONS(8722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8722),
  },
  [3518] = {
    [anon_sym_BQUOTE] = ACTIONS(8728),
    [anon_sym_DQUOTE] = ACTIONS(8728),
    [sym_word] = ACTIONS(8730),
    [sym_raw_string] = ACTIONS(8728),
    [anon_sym_LT_LPAREN] = ACTIONS(8728),
    [anon_sym_esac] = ACTIONS(8732),
    [anon_sym_DOLLAR] = ACTIONS(8730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8728),
    [sym__special_character] = ACTIONS(8728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8728),
  },
  [3519] = {
    [anon_sym_BQUOTE] = ACTIONS(7104),
    [anon_sym_DQUOTE] = ACTIONS(7104),
    [sym_word] = ACTIONS(7104),
    [sym_raw_string] = ACTIONS(7104),
    [anon_sym_LT_LPAREN] = ACTIONS(7104),
    [anon_sym_DOLLAR] = ACTIONS(7106),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(7104),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7104),
    [sym__special_character] = ACTIONS(7104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7104),
  },
  [3520] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_AMP_GT_GT] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(8734),
    [anon_sym_SEMI] = ACTIONS(8736),
    [sym_file_descriptor] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_LT_LT_LT] = ACTIONS(775),
    [anon_sym_GT_AMP] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(8736),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_AMP] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_SEMI_SEMI] = ACTIONS(413),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
  },
  [3521] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(8738),
  },
  [3522] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(8736),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(8734),
    [anon_sym_SEMI] = ACTIONS(8736),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(775),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_SEMI_SEMI] = ACTIONS(413),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
  },
  [3523] = {
    [sym_redirected_statement] = STATE(3782),
    [sym_if_statement] = STATE(3782),
    [sym_function_definition] = STATE(3782),
    [sym_compound_statement] = STATE(3782),
    [sym_test_command] = STATE(3782),
    [sym_declaration_command] = STATE(3782),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(3782),
    [sym_c_style_for_statement] = STATE(3782),
    [sym_case_statement] = STATE(3782),
    [sym_subshell] = STATE(3782),
    [sym_pipeline] = STATE(3782),
    [sym_unset_command] = STATE(3782),
    [sym_command] = STATE(3782),
    [sym_simple_expansion] = STATE(137),
    [sym_while_statement] = STATE(3782),
    [sym_list] = STATE(3782),
    [sym_negated_command] = STATE(3782),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(3783),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(228),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3524] = {
    [sym_redirected_statement] = STATE(3520),
    [sym_if_statement] = STATE(3520),
    [sym_function_definition] = STATE(3520),
    [sym_compound_statement] = STATE(3520),
    [sym_test_command] = STATE(3520),
    [sym_declaration_command] = STATE(3520),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(3520),
    [sym_c_style_for_statement] = STATE(3520),
    [sym_case_statement] = STATE(3520),
    [sym_subshell] = STATE(3520),
    [sym_pipeline] = STATE(3520),
    [sym_unset_command] = STATE(3520),
    [sym_command] = STATE(3520),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(3784),
    [sym_while_statement] = STATE(3520),
    [sym_list] = STATE(3520),
    [sym_negated_command] = STATE(3520),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(3522),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(3523),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(8738),
  },
  [3525] = {
    [anon_sym_BQUOTE] = ACTIONS(7149),
    [anon_sym_DQUOTE] = ACTIONS(7149),
    [sym_word] = ACTIONS(7149),
    [sym_raw_string] = ACTIONS(7149),
    [anon_sym_LT_LPAREN] = ACTIONS(7149),
    [anon_sym_DOLLAR] = ACTIONS(7151),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(7149),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7149),
    [sym__special_character] = ACTIONS(7149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7149),
  },
  [3526] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(8740),
  },
  [3527] = {
    [sym_redirected_statement] = STATE(3520),
    [sym_if_statement] = STATE(3520),
    [sym_function_definition] = STATE(3520),
    [sym_compound_statement] = STATE(3520),
    [sym_test_command] = STATE(3520),
    [sym_declaration_command] = STATE(3520),
    [sym_subscript] = STATE(141),
    [sym_file_redirect] = STATE(142),
    [sym_concatenation] = STATE(29),
    [sym_string] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(142),
    [sym_for_statement] = STATE(3520),
    [sym_c_style_for_statement] = STATE(3520),
    [sym_case_statement] = STATE(3520),
    [sym_subshell] = STATE(3520),
    [sym_pipeline] = STATE(3520),
    [sym_unset_command] = STATE(3520),
    [sym_command] = STATE(3520),
    [sym_simple_expansion] = STATE(137),
    [sym__statements] = STATE(3786),
    [sym_while_statement] = STATE(3520),
    [sym_list] = STATE(3520),
    [sym_negated_command] = STATE(3520),
    [sym_command_name] = STATE(144),
    [sym_variable_assignment] = STATE(3522),
    [sym_string_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [aux_sym__statements_repeat1] = STATE(3523),
    [aux_sym__literal_repeat1] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(223),
    [anon_sym_typeset] = ACTIONS(223),
    [anon_sym_unsetenv] = ACTIONS(225),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(223),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(233),
    [anon_sym_declare] = ACTIONS(223),
    [sym_variable_name] = ACTIONS(235),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_unset] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(8740),
  },
  [3528] = {
    [anon_sym_BQUOTE] = ACTIONS(5097),
    [anon_sym_DQUOTE] = ACTIONS(5097),
    [sym_word] = ACTIONS(5097),
    [sym_raw_string] = ACTIONS(5097),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_LT_LPAREN] = ACTIONS(5097),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_RPAREN] = ACTIONS(5097),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5097),
  },
  [3529] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8742),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3530] = {
    [anon_sym_BQUOTE] = ACTIONS(5131),
    [anon_sym_DQUOTE] = ACTIONS(5131),
    [sym_word] = ACTIONS(5131),
    [sym_raw_string] = ACTIONS(5131),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_LT_LPAREN] = ACTIONS(5131),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_RPAREN] = ACTIONS(5131),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5131),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5131),
  },
  [3531] = {
    [anon_sym_BQUOTE] = ACTIONS(5135),
    [anon_sym_DQUOTE] = ACTIONS(5135),
    [sym_word] = ACTIONS(5135),
    [sym_raw_string] = ACTIONS(5135),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_LT_LPAREN] = ACTIONS(5135),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_RPAREN] = ACTIONS(5135),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5135),
  },
  [3532] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8744),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3533] = {
    [anon_sym_BQUOTE] = ACTIONS(5186),
    [anon_sym_DQUOTE] = ACTIONS(5186),
    [sym_word] = ACTIONS(5186),
    [sym_raw_string] = ACTIONS(5186),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_LT_LPAREN] = ACTIONS(5186),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_RPAREN] = ACTIONS(5186),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(5186),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5186),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5186),
  },
  [3534] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_RPAREN] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [ts_builtin_sym_end] = ACTIONS(6453),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3535] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_RPAREN] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [ts_builtin_sym_end] = ACTIONS(6457),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3536] = {
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
  },
  [3537] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8746),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3538] = {
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
  },
  [3539] = {
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
  },
  [3540] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8748),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3541] = {
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
  },
  [3542] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(8750),
    [anon_sym_BQUOTE] = ACTIONS(8750),
    [anon_sym_AMP_GT_GT] = ACTIONS(8750),
    [anon_sym_LF] = ACTIONS(8752),
    [anon_sym_SEMI] = ACTIONS(8750),
    [anon_sym_LT_LT] = ACTIONS(8750),
    [sym_file_descriptor] = ACTIONS(8752),
    [anon_sym_GT] = ACTIONS(8750),
    [anon_sym_RPAREN] = ACTIONS(8750),
    [anon_sym_AMP_GT] = ACTIONS(8750),
    [anon_sym_fi] = ACTIONS(8750),
    [anon_sym_else] = ACTIONS(8750),
    [anon_sym_done] = ACTIONS(8750),
    [anon_sym_PIPE_PIPE] = ACTIONS(8750),
    [ts_builtin_sym_end] = ACTIONS(8752),
    [anon_sym_LT_LT_LT] = ACTIONS(8750),
    [anon_sym_PIPE] = ACTIONS(8750),
    [anon_sym_GT_AMP] = ACTIONS(8750),
    [anon_sym_LT] = ACTIONS(8750),
    [anon_sym_LT_AMP] = ACTIONS(8750),
    [anon_sym_GT_GT] = ACTIONS(8750),
    [anon_sym_AMP] = ACTIONS(8750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(8750),
    [anon_sym_AMP_AMP] = ACTIONS(8750),
    [anon_sym_esac] = ACTIONS(8750),
    [anon_sym_SEMI_SEMI] = ACTIONS(8750),
    [anon_sym_PIPE_AMP] = ACTIONS(8750),
  },
  [3543] = {
    [anon_sym_BANG_EQ] = ACTIONS(6451),
    [anon_sym_PLUS_EQ] = ACTIONS(6451),
    [sym_test_operator] = ACTIONS(6453),
    [anon_sym_LF] = ACTIONS(6451),
    [anon_sym_SEMI] = ACTIONS(6451),
    [anon_sym_PLUS_PLUS] = ACTIONS(6451),
    [anon_sym_DASH] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_EQ] = ACTIONS(6451),
    [anon_sym_EQ_EQ] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [anon_sym_GT_EQ] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_PLUS] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(6451),
    [anon_sym_DASH_DASH] = ACTIONS(6451),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_LT_EQ] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_DASH_EQ] = ACTIONS(6451),
  },
  [3544] = {
    [anon_sym_BANG_EQ] = ACTIONS(6455),
    [anon_sym_PLUS_EQ] = ACTIONS(6455),
    [sym_test_operator] = ACTIONS(6457),
    [anon_sym_LF] = ACTIONS(6455),
    [anon_sym_SEMI] = ACTIONS(6455),
    [anon_sym_PLUS_PLUS] = ACTIONS(6455),
    [anon_sym_DASH] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_EQ] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [anon_sym_GT_EQ] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_PLUS] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(6455),
    [anon_sym_DASH_DASH] = ACTIONS(6455),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_LT_EQ] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_DASH_EQ] = ACTIONS(6455),
  },
  [3545] = {
    [sym_do_group] = STATE(3791),
    [sym_compound_statement] = STATE(3791),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(991),
  },
  [3546] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_done] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [3547] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_done] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3548] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8754),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3549] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3793),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3793),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8756),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8754),
    [anon_sym_DASH] = ACTIONS(8756),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8756),
    [anon_sym_PERCENT] = ACTIONS(8756),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8758),
    [anon_sym_COLON_DASH] = ACTIONS(8756),
    [sym__special_character] = ACTIONS(599),
  },
  [3550] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8754),
    [sym__concat] = ACTIONS(2610),
  },
  [3551] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8754),
  },
  [3552] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8760),
  },
  [3553] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_done] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3554] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3796),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3796),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8762),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8764),
    [anon_sym_DASH] = ACTIONS(8762),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8762),
    [anon_sym_PERCENT] = ACTIONS(8762),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8766),
    [anon_sym_COLON_DASH] = ACTIONS(8762),
    [sym__special_character] = ACTIONS(599),
  },
  [3555] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8764),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3556] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_done] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3557] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_done] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3558] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8768),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3559] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_done] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3560] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8770),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3561] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3799),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3799),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8772),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8770),
    [anon_sym_DASH] = ACTIONS(8772),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8772),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8772),
    [anon_sym_PERCENT] = ACTIONS(8772),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8774),
    [anon_sym_COLON_DASH] = ACTIONS(8772),
    [sym__special_character] = ACTIONS(599),
  },
  [3562] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8770),
    [sym__concat] = ACTIONS(2610),
  },
  [3563] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8770),
  },
  [3564] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8776),
  },
  [3565] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_done] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3566] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3802),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3802),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8778),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8780),
    [anon_sym_DASH] = ACTIONS(8778),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8778),
    [anon_sym_PERCENT] = ACTIONS(8778),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8782),
    [anon_sym_COLON_DASH] = ACTIONS(8778),
    [sym__special_character] = ACTIONS(599),
  },
  [3567] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8780),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3568] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_done] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3569] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_done] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3570] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8784),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3571] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_done] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_EQ_TILDE] = ACTIONS(5095),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_EQ_EQ] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3572] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8786),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3573] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_done] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3574] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_done] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5133),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_EQ_EQ] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3575] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8788),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3576] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_done] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_EQ_TILDE] = ACTIONS(5184),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_EQ_EQ] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3577] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_done] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3578] = {
    [sym_string] = STATE(2792),
    [anon_sym__] = ACTIONS(6263),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(8790),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(8790),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_done] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6263),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(6263),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(6263),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(8792),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(6263),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(8794),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(6263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8790),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3579] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_done] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3580] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3807),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3807),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8796),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8798),
    [anon_sym_DASH] = ACTIONS(8796),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8796),
    [anon_sym_PERCENT] = ACTIONS(8796),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8800),
    [anon_sym_COLON_DASH] = ACTIONS(8796),
    [sym__special_character] = ACTIONS(599),
  },
  [3581] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8798),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3582] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3807),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3807),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8796),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8798),
    [anon_sym_DASH] = ACTIONS(8796),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8796),
    [anon_sym_PERCENT] = ACTIONS(8796),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8800),
    [anon_sym_COLON_DASH] = ACTIONS(8796),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8802),
  },
  [3583] = {
    [sym_process_substitution] = STATE(3809),
    [aux_sym__literal_repeat1] = STATE(3811),
    [sym_simple_expansion] = STATE(3809),
    [sym_string_expansion] = STATE(3809),
    [sym_expansion] = STATE(3809),
    [sym_concatenation] = STATE(3810),
    [sym_string] = STATE(3809),
    [sym_command_substitution] = STATE(3809),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8804),
    [sym_raw_string] = ACTIONS(8804),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8798),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3584] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3814),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3814),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8806),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8808),
    [anon_sym_DASH] = ACTIONS(8806),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8806),
    [anon_sym_PERCENT] = ACTIONS(8806),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8810),
    [anon_sym_COLON_DASH] = ACTIONS(8806),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8812),
  },
  [3585] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_done] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3586] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8808),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3587] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8798),
    [sym__concat] = ACTIONS(2610),
  },
  [3588] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8798),
  },
  [3589] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8814),
  },
  [3590] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_done] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3591] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3817),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3817),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8816),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8818),
    [anon_sym_DASH] = ACTIONS(8816),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8816),
    [anon_sym_PERCENT] = ACTIONS(8816),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8820),
    [anon_sym_COLON_DASH] = ACTIONS(8816),
    [sym__special_character] = ACTIONS(599),
  },
  [3592] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8818),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3593] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_done] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3594] = {
    [sym_string] = STATE(2811),
    [anon_sym__] = ACTIONS(6291),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(8822),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(8822),
    [anon_sym_done] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6291),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(6291),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(6291),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(8824),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(8826),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(6291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8822),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3595] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_done] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3596] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3819),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3819),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8828),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8830),
    [anon_sym_DASH] = ACTIONS(8828),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8828),
    [anon_sym_PERCENT] = ACTIONS(8828),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8832),
    [anon_sym_COLON_DASH] = ACTIONS(8828),
    [sym__special_character] = ACTIONS(599),
  },
  [3597] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8830),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3598] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3819),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3819),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8828),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8830),
    [anon_sym_DASH] = ACTIONS(8828),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8828),
    [anon_sym_PERCENT] = ACTIONS(8828),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8832),
    [anon_sym_COLON_DASH] = ACTIONS(8828),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8834),
  },
  [3599] = {
    [sym_process_substitution] = STATE(3821),
    [aux_sym__literal_repeat1] = STATE(3823),
    [sym_simple_expansion] = STATE(3821),
    [sym_string_expansion] = STATE(3821),
    [sym_expansion] = STATE(3821),
    [sym_concatenation] = STATE(3822),
    [sym_string] = STATE(3821),
    [sym_command_substitution] = STATE(3821),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8836),
    [sym_raw_string] = ACTIONS(8836),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8830),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3600] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3826),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3826),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8838),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8840),
    [anon_sym_DASH] = ACTIONS(8838),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8838),
    [anon_sym_PERCENT] = ACTIONS(8838),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8842),
    [anon_sym_COLON_DASH] = ACTIONS(8838),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8844),
  },
  [3601] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_done] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3602] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8840),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3603] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8830),
    [sym__concat] = ACTIONS(2610),
  },
  [3604] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8830),
  },
  [3605] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8846),
  },
  [3606] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_done] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3607] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3829),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3829),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8848),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8850),
    [anon_sym_DASH] = ACTIONS(8848),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8848),
    [anon_sym_PERCENT] = ACTIONS(8848),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8852),
    [anon_sym_COLON_DASH] = ACTIONS(8848),
    [sym__special_character] = ACTIONS(599),
  },
  [3608] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8850),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3609] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_esac] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_RPAREN] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(6451),
    [anon_sym_else] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [ts_builtin_sym_end] = ACTIONS(6453),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_elif] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3610] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_esac] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_RPAREN] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(6455),
    [anon_sym_else] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [ts_builtin_sym_end] = ACTIONS(6457),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_elif] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3611] = {
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5097),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5097),
    [sym__heredoc_body_end] = ACTIONS(5097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5097),
    [sym__heredoc_body_middle] = ACTIONS(5097),
  },
  [3612] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8854),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3613] = {
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5131),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5131),
    [sym__heredoc_body_end] = ACTIONS(5131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5131),
    [sym__heredoc_body_middle] = ACTIONS(5131),
  },
  [3614] = {
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5135),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5135),
    [sym__heredoc_body_end] = ACTIONS(5135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5135),
    [sym__heredoc_body_middle] = ACTIONS(5135),
  },
  [3615] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8856),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3616] = {
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5186),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5186),
    [sym__heredoc_body_end] = ACTIONS(5186),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5186),
    [sym__heredoc_body_middle] = ACTIONS(5186),
  },
  [3617] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6453),
    [sym__concat] = ACTIONS(6453),
  },
  [3618] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(6457),
    [sym__concat] = ACTIONS(6457),
  },
  [3619] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_RBRACE] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3620] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_RBRACE] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3621] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(8750),
    [anon_sym_AMP_GT_GT] = ACTIONS(8750),
    [anon_sym_LF] = ACTIONS(8752),
    [anon_sym_SEMI] = ACTIONS(8750),
    [anon_sym_LT_LT] = ACTIONS(8750),
    [anon_sym_RBRACE] = ACTIONS(8750),
    [anon_sym_GT] = ACTIONS(8750),
    [sym_file_descriptor] = ACTIONS(8752),
    [anon_sym_AMP_GT] = ACTIONS(8750),
    [anon_sym_PIPE_PIPE] = ACTIONS(8750),
    [anon_sym_LT_LT_LT] = ACTIONS(8750),
    [anon_sym_PIPE] = ACTIONS(8750),
    [anon_sym_GT_AMP] = ACTIONS(8750),
    [anon_sym_LT] = ACTIONS(8750),
    [anon_sym_LT_AMP] = ACTIONS(8750),
    [anon_sym_GT_GT] = ACTIONS(8750),
    [anon_sym_AMP] = ACTIONS(8750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(8750),
    [anon_sym_SEMI_SEMI] = ACTIONS(8750),
    [anon_sym_PIPE_AMP] = ACTIONS(8750),
  },
  [3622] = {
    [sym_do_group] = STATE(3832),
    [sym_compound_statement] = STATE(3832),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(1703),
  },
  [3623] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_RBRACE] = ACTIONS(6451),
    [anon_sym_GT] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3624] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_RBRACE] = ACTIONS(6455),
    [anon_sym_GT] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3625] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_fi] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_else] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [anon_sym_elif] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3626] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8858),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3627] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_fi] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_else] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [anon_sym_elif] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3628] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_fi] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_else] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [anon_sym_elif] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3629] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8860),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3630] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_fi] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_else] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [anon_sym_elif] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3631] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_fi] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_else] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [anon_sym_elif] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3632] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8862),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3633] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_fi] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_else] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [anon_sym_elif] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3634] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_fi] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_else] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [anon_sym_elif] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3635] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8864),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3636] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_fi] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_else] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [anon_sym_elif] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3637] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_fi] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [3638] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_fi] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3639] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8866),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3640] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3838),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3838),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8868),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8866),
    [anon_sym_DASH] = ACTIONS(8868),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8868),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8868),
    [anon_sym_PERCENT] = ACTIONS(8868),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8870),
    [anon_sym_COLON_DASH] = ACTIONS(8868),
    [sym__special_character] = ACTIONS(599),
  },
  [3641] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8866),
    [sym__concat] = ACTIONS(2610),
  },
  [3642] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8866),
  },
  [3643] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8872),
  },
  [3644] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_fi] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3645] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3841),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3841),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8874),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8876),
    [anon_sym_DASH] = ACTIONS(8874),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8874),
    [anon_sym_PERCENT] = ACTIONS(8874),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8878),
    [anon_sym_COLON_DASH] = ACTIONS(8874),
    [sym__special_character] = ACTIONS(599),
  },
  [3646] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8876),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3647] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_fi] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3648] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_fi] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3649] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8880),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3650] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_fi] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3651] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8882),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3652] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3844),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3844),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8884),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8882),
    [anon_sym_DASH] = ACTIONS(8884),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8884),
    [anon_sym_PERCENT] = ACTIONS(8884),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8886),
    [anon_sym_COLON_DASH] = ACTIONS(8884),
    [sym__special_character] = ACTIONS(599),
  },
  [3653] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8882),
    [sym__concat] = ACTIONS(2610),
  },
  [3654] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8882),
  },
  [3655] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8888),
  },
  [3656] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_fi] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3657] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3847),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3847),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8890),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8892),
    [anon_sym_DASH] = ACTIONS(8890),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8890),
    [anon_sym_PERCENT] = ACTIONS(8890),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8894),
    [anon_sym_COLON_DASH] = ACTIONS(8890),
    [sym__special_character] = ACTIONS(599),
  },
  [3658] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8892),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3659] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_fi] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3660] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_fi] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3661] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8896),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3662] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_fi] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_EQ_TILDE] = ACTIONS(5095),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_EQ_EQ] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3663] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8898),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3664] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_fi] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3665] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_fi] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5133),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_EQ_EQ] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3666] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8900),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3667] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_fi] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_EQ_TILDE] = ACTIONS(5184),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_EQ_EQ] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3668] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_fi] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3669] = {
    [sym_string] = STATE(3024),
    [anon_sym__] = ACTIONS(6887),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(8902),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(8902),
    [anon_sym_fi] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(6887),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(6887),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(8904),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(6887),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(8906),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(6887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8902),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3670] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_fi] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3671] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3852),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3852),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8908),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8910),
    [anon_sym_DASH] = ACTIONS(8908),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8908),
    [anon_sym_PERCENT] = ACTIONS(8908),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8912),
    [anon_sym_COLON_DASH] = ACTIONS(8908),
    [sym__special_character] = ACTIONS(599),
  },
  [3672] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8910),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3673] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3852),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3852),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8908),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8910),
    [anon_sym_DASH] = ACTIONS(8908),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8908),
    [anon_sym_PERCENT] = ACTIONS(8908),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8912),
    [anon_sym_COLON_DASH] = ACTIONS(8908),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8914),
  },
  [3674] = {
    [sym_process_substitution] = STATE(3854),
    [aux_sym__literal_repeat1] = STATE(3856),
    [sym_simple_expansion] = STATE(3854),
    [sym_string_expansion] = STATE(3854),
    [sym_expansion] = STATE(3854),
    [sym_concatenation] = STATE(3855),
    [sym_string] = STATE(3854),
    [sym_command_substitution] = STATE(3854),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8916),
    [sym_raw_string] = ACTIONS(8916),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8910),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3675] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3859),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3859),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8918),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8920),
    [anon_sym_DASH] = ACTIONS(8918),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8918),
    [anon_sym_PERCENT] = ACTIONS(8918),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8922),
    [anon_sym_COLON_DASH] = ACTIONS(8918),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8924),
  },
  [3676] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_fi] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3677] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8920),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3678] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8910),
    [sym__concat] = ACTIONS(2610),
  },
  [3679] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8910),
  },
  [3680] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8926),
  },
  [3681] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_fi] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3682] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3862),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3862),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8928),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8930),
    [anon_sym_DASH] = ACTIONS(8928),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8928),
    [anon_sym_PERCENT] = ACTIONS(8928),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8932),
    [anon_sym_COLON_DASH] = ACTIONS(8928),
    [sym__special_character] = ACTIONS(599),
  },
  [3683] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8930),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3684] = {
    [sym_string] = STATE(1124),
    [anon_sym__] = ACTIONS(2231),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(6361),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(6361),
    [anon_sym_fi] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2231),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(6363),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(6365),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6361),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3685] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_else] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_EQ_TILDE] = ACTIONS(6451),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_EQ_EQ] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [anon_sym_elif] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3686] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_else] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_EQ_TILDE] = ACTIONS(6455),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [anon_sym_elif] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3687] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_fi] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_else] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [anon_sym_elif] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3688] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8934),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3689] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3864),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3864),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8936),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8934),
    [anon_sym_DASH] = ACTIONS(8936),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8936),
    [anon_sym_PERCENT] = ACTIONS(8936),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8938),
    [anon_sym_COLON_DASH] = ACTIONS(8936),
    [sym__special_character] = ACTIONS(599),
  },
  [3690] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8934),
    [sym__concat] = ACTIONS(2610),
  },
  [3691] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8934),
  },
  [3692] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(8940),
  },
  [3693] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_fi] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_else] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [anon_sym_elif] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3694] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3867),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3867),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8942),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8944),
    [anon_sym_DASH] = ACTIONS(8942),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8942),
    [anon_sym_PERCENT] = ACTIONS(8942),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8946),
    [anon_sym_COLON_DASH] = ACTIONS(8942),
    [sym__special_character] = ACTIONS(599),
  },
  [3695] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8944),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3696] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_fi] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_else] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_elif] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3697] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_fi] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_else] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_elif] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3698] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8948),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3699] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [anon_sym_esac] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [3700] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [anon_sym_esac] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [3701] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(8950),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3702] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3703] = {
    [sym_process_substitution] = STATE(3702),
    [sym_string_expansion] = STATE(3702),
    [sym_expansion] = STATE(3702),
    [sym_simple_expansion] = STATE(3702),
    [sym_string] = STATE(3702),
    [sym_command_substitution] = STATE(3702),
    [anon_sym_BQUOTE] = ACTIONS(8458),
    [anon_sym_DQUOTE] = ACTIONS(7870),
    [sym_word] = ACTIONS(8460),
    [sym_raw_string] = ACTIONS(8460),
    [anon_sym_LT_LPAREN] = ACTIONS(8462),
    [anon_sym_DOLLAR] = ACTIONS(8952),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8464),
    [sym__special_character] = ACTIONS(8460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8466),
  },
  [3704] = {
    [aux_sym_concatenation_repeat1] = STATE(3704),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(8954),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3705] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_esac] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [3706] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(3872),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(3872),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(8957),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [3707] = {
    [aux_sym_concatenation_repeat1] = STATE(3436),
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__concat] = ACTIONS(7866),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_esac] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [3708] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1960),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_LPAREN] = ACTIONS(1960),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1960),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1960),
    [sym_word] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_LT_AMP] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1960),
    [anon_sym_LF] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1960),
    [sym_raw_string] = ACTIONS(1960),
    [sym_variable_name] = ACTIONS(1964),
    [sym_file_descriptor] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP_GT] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [anon_sym_LT_LT_LT] = ACTIONS(1960),
    [anon_sym_GT_AMP] = ACTIONS(1960),
    [anon_sym_LT_LPAREN] = ACTIONS(1960),
    [anon_sym_esac] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_SEMI_SEMI] = ACTIONS(1960),
    [anon_sym_PIPE_AMP] = ACTIONS(1960),
  },
  [3709] = {
    [aux_sym__literal_repeat1] = STATE(3449),
    [anon_sym_AMP_GT_GT] = ACTIONS(1984),
    [anon_sym_DOLLAR] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_LPAREN] = ACTIONS(1984),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1984),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1984),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [sym_word] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_LT_AMP] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [sym__special_character] = ACTIONS(7890),
    [anon_sym_LT_LT_DASH] = ACTIONS(1984),
    [anon_sym_BQUOTE] = ACTIONS(1984),
    [anon_sym_LF] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1984),
    [sym_raw_string] = ACTIONS(1984),
    [sym_variable_name] = ACTIONS(1988),
    [sym_file_descriptor] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_AMP_GT] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(1984),
    [anon_sym_LT_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_AMP] = ACTIONS(1984),
    [anon_sym_LT_LPAREN] = ACTIONS(1984),
    [anon_sym_esac] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_SEMI_SEMI] = ACTIONS(1984),
    [anon_sym_PIPE_AMP] = ACTIONS(1984),
  },
  [3710] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3875),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3875),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8959),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [anon_sym_DASH] = ACTIONS(8959),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8959),
    [anon_sym_PERCENT] = ACTIONS(8959),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8963),
    [anon_sym_COLON_DASH] = ACTIONS(8959),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8965),
  },
  [3711] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [anon_sym_esac] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [3712] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3713] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3875),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3875),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8967),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8959),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [anon_sym_DASH] = ACTIONS(8959),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8959),
    [anon_sym_PERCENT] = ACTIONS(8959),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8963),
    [anon_sym_COLON_DASH] = ACTIONS(8959),
    [sym__special_character] = ACTIONS(599),
  },
  [3714] = {
    [anon_sym_EQ] = ACTIONS(8969),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3715] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3880),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3880),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(8971),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8973),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8975),
    [anon_sym_DASH] = ACTIONS(8973),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8973),
    [anon_sym_PERCENT] = ACTIONS(8973),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8977),
    [anon_sym_COLON_DASH] = ACTIONS(8973),
    [sym__special_character] = ACTIONS(599),
  },
  [3716] = {
    [sym_process_substitution] = STATE(3881),
    [aux_sym__literal_repeat1] = STATE(3883),
    [sym_simple_expansion] = STATE(3881),
    [sym_string_expansion] = STATE(3881),
    [sym_expansion] = STATE(3881),
    [sym_concatenation] = STATE(3882),
    [sym_string] = STATE(3881),
    [sym_command_substitution] = STATE(3881),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(8979),
    [sym_raw_string] = ACTIONS(8979),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3717] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3886),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3886),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8981),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8983),
    [anon_sym_DASH] = ACTIONS(8981),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8981),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8981),
    [anon_sym_PERCENT] = ACTIONS(8981),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(8985),
    [anon_sym_COLON_DASH] = ACTIONS(8981),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(8987),
  },
  [3718] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_esac] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [3719] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8983),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3720] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [anon_sym_esac] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [3721] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [anon_sym_esac] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [3722] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(8989),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3723] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3724] = {
    [sym_process_substitution] = STATE(3723),
    [sym_string_expansion] = STATE(3723),
    [sym_expansion] = STATE(3723),
    [sym_simple_expansion] = STATE(3723),
    [sym_string] = STATE(3723),
    [sym_command_substitution] = STATE(3723),
    [anon_sym_BQUOTE] = ACTIONS(8545),
    [anon_sym_DQUOTE] = ACTIONS(7900),
    [sym_word] = ACTIONS(8547),
    [sym_raw_string] = ACTIONS(8547),
    [anon_sym_LT_LPAREN] = ACTIONS(8549),
    [anon_sym_DOLLAR] = ACTIONS(8991),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8549),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8551),
    [sym__special_character] = ACTIONS(8547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8553),
  },
  [3725] = {
    [aux_sym_concatenation_repeat1] = STATE(3725),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(8993),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3726] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_esac] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [3727] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3891),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3891),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8996),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8998),
    [anon_sym_DASH] = ACTIONS(8996),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8996),
    [anon_sym_PERCENT] = ACTIONS(8996),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9000),
    [anon_sym_COLON_DASH] = ACTIONS(8996),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9002),
  },
  [3728] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [anon_sym_esac] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [3729] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8998),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3730] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3891),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3891),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(9004),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(8996),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(8998),
    [anon_sym_DASH] = ACTIONS(8996),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(8996),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(8996),
    [anon_sym_PERCENT] = ACTIONS(8996),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9000),
    [anon_sym_COLON_DASH] = ACTIONS(8996),
    [sym__special_character] = ACTIONS(599),
  },
  [3731] = {
    [anon_sym_EQ] = ACTIONS(9006),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3732] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3896),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3896),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(9008),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9010),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9012),
    [anon_sym_DASH] = ACTIONS(9010),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9010),
    [anon_sym_PERCENT] = ACTIONS(9010),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9014),
    [anon_sym_COLON_DASH] = ACTIONS(9010),
    [sym__special_character] = ACTIONS(599),
  },
  [3733] = {
    [sym_process_substitution] = STATE(3897),
    [aux_sym__literal_repeat1] = STATE(3899),
    [sym_simple_expansion] = STATE(3897),
    [sym_string_expansion] = STATE(3897),
    [sym_expansion] = STATE(3897),
    [sym_concatenation] = STATE(3898),
    [sym_string] = STATE(3897),
    [sym_command_substitution] = STATE(3897),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(9016),
    [sym_raw_string] = ACTIONS(9016),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(8998),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3734] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3902),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3902),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9018),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9020),
    [anon_sym_DASH] = ACTIONS(9018),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9018),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9018),
    [anon_sym_PERCENT] = ACTIONS(9018),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9022),
    [anon_sym_COLON_DASH] = ACTIONS(9018),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9024),
  },
  [3735] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_esac] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [3736] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9020),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3737] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [anon_sym_EQ_TILDE] = ACTIONS(2506),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [anon_sym_esac] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3738] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3904),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3904),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9026),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9028),
    [anon_sym_DASH] = ACTIONS(9026),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9026),
    [anon_sym_PERCENT] = ACTIONS(9026),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9030),
    [anon_sym_COLON_DASH] = ACTIONS(9026),
    [sym__special_character] = ACTIONS(599),
  },
  [3739] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9028),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3740] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3904),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3904),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9026),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9028),
    [anon_sym_DASH] = ACTIONS(9026),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9026),
    [anon_sym_PERCENT] = ACTIONS(9026),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9030),
    [anon_sym_COLON_DASH] = ACTIONS(9026),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9032),
  },
  [3741] = {
    [sym_process_substitution] = STATE(3906),
    [aux_sym__literal_repeat1] = STATE(3908),
    [sym_simple_expansion] = STATE(3906),
    [sym_string_expansion] = STATE(3906),
    [sym_expansion] = STATE(3906),
    [sym_concatenation] = STATE(3907),
    [sym_string] = STATE(3906),
    [sym_command_substitution] = STATE(3906),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(9034),
    [sym_raw_string] = ACTIONS(9034),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9028),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3742] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3911),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3911),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9036),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9038),
    [anon_sym_DASH] = ACTIONS(9036),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9036),
    [anon_sym_PERCENT] = ACTIONS(9036),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9040),
    [anon_sym_COLON_DASH] = ACTIONS(9036),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9042),
  },
  [3743] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [anon_sym_EQ_TILDE] = ACTIONS(2602),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [anon_sym_esac] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3744] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9038),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3745] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9028),
    [sym__concat] = ACTIONS(2610),
  },
  [3746] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9028),
  },
  [3747] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9044),
  },
  [3748] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [anon_sym_EQ_TILDE] = ACTIONS(2644),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_esac] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3749] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3914),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3914),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9046),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9048),
    [anon_sym_DASH] = ACTIONS(9046),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9046),
    [anon_sym_PERCENT] = ACTIONS(9046),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9050),
    [anon_sym_COLON_DASH] = ACTIONS(9046),
    [sym__special_character] = ACTIONS(599),
  },
  [3750] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9048),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3751] = {
    [sym_string] = STATE(3098),
    [anon_sym__] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(9052),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(9052),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7084),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(7084),
    [anon_sym_EQ_TILDE] = ACTIONS(2658),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(9054),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_EQ_EQ] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(7142),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_esac] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(7084),
    [anon_sym_POUND] = ACTIONS(9052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3752] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [anon_sym_esac] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [3753] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(9056),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [3754] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(9058),
  },
  [3755] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(9060),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3756] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [3757] = {
    [sym_expansion] = STATE(189),
    [sym_simple_expansion] = STATE(189),
    [aux_sym_string_repeat1] = STATE(543),
    [sym_command_substitution] = STATE(189),
    [anon_sym_DOLLAR] = ACTIONS(9062),
    [anon_sym_BQUOTE] = ACTIONS(295),
    [anon_sym_DQUOTE] = ACTIONS(9060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(301),
    [sym__string_content] = ACTIONS(303),
  },
  [3758] = {
    [sym_process_substitution] = STATE(3919),
    [sym_string_expansion] = STATE(3919),
    [sym_expansion] = STATE(3919),
    [sym_simple_expansion] = STATE(3919),
    [sym_string] = STATE(3919),
    [sym_command_substitution] = STATE(3919),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [sym_word] = ACTIONS(9064),
    [sym_raw_string] = ACTIONS(9064),
    [anon_sym_LT_LPAREN] = ACTIONS(7966),
    [anon_sym_DOLLAR] = ACTIONS(7968),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(7966),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7970),
    [sym__special_character] = ACTIONS(9064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7974),
  },
  [3759] = {
    [aux_sym_concatenation_repeat1] = STATE(3921),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [anon_sym_GT_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(627),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [sym_word] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [sym__concat] = ACTIONS(9066),
    [sym__special_character] = ACTIONS(627),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_BQUOTE] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_raw_string] = ACTIONS(627),
    [sym_variable_name] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT_LPAREN] = ACTIONS(627),
    [anon_sym_esac] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [3760] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(9068),
  },
  [3761] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(551),
    [anon_sym_DOLLAR] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(551),
    [anon_sym_PIPE_PIPE] = ACTIONS(551),
    [sym_word] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_AMP] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [sym__concat] = ACTIONS(553),
    [sym__special_character] = ACTIONS(551),
    [anon_sym_LT_LT_DASH] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [anon_sym_LF] = ACTIONS(553),
    [anon_sym_SEMI] = ACTIONS(551),
    [sym_raw_string] = ACTIONS(551),
    [sym_variable_name] = ACTIONS(553),
    [sym_file_descriptor] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_AMP_GT] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_LT_LT_LT] = ACTIONS(551),
    [anon_sym_GT_AMP] = ACTIONS(551),
    [anon_sym_LT_LPAREN] = ACTIONS(551),
    [anon_sym_esac] = ACTIONS(551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(551),
    [anon_sym_SEMI_SEMI] = ACTIONS(551),
    [anon_sym_PIPE_AMP] = ACTIONS(551),
  },
  [3762] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(555),
    [anon_sym_LT_LT] = ACTIONS(555),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(555),
    [anon_sym_PIPE_PIPE] = ACTIONS(555),
    [sym_word] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(555),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_LT_AMP] = ACTIONS(555),
    [anon_sym_GT_GT] = ACTIONS(555),
    [sym__concat] = ACTIONS(557),
    [sym__special_character] = ACTIONS(555),
    [anon_sym_LT_LT_DASH] = ACTIONS(555),
    [anon_sym_BQUOTE] = ACTIONS(555),
    [anon_sym_LF] = ACTIONS(557),
    [anon_sym_SEMI] = ACTIONS(555),
    [sym_raw_string] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [sym_file_descriptor] = ACTIONS(557),
    [anon_sym_GT] = ACTIONS(555),
    [anon_sym_AMP_GT] = ACTIONS(555),
    [anon_sym_DQUOTE] = ACTIONS(555),
    [anon_sym_LT_LT_LT] = ACTIONS(555),
    [anon_sym_GT_AMP] = ACTIONS(555),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_esac] = ACTIONS(555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(555),
    [anon_sym_SEMI_SEMI] = ACTIONS(555),
    [anon_sym_PIPE_AMP] = ACTIONS(555),
  },
  [3763] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(559),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [sym_word] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(559),
    [anon_sym_LT_AMP] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [sym__concat] = ACTIONS(561),
    [sym__special_character] = ACTIONS(559),
    [anon_sym_LT_LT_DASH] = ACTIONS(559),
    [anon_sym_BQUOTE] = ACTIONS(559),
    [anon_sym_LF] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [sym_raw_string] = ACTIONS(559),
    [sym_variable_name] = ACTIONS(561),
    [sym_file_descriptor] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(559),
    [anon_sym_AMP_GT] = ACTIONS(559),
    [anon_sym_DQUOTE] = ACTIONS(559),
    [anon_sym_LT_LT_LT] = ACTIONS(559),
    [anon_sym_GT_AMP] = ACTIONS(559),
    [anon_sym_LT_LPAREN] = ACTIONS(559),
    [anon_sym_esac] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_SEMI_SEMI] = ACTIONS(559),
    [anon_sym_PIPE_AMP] = ACTIONS(559),
  },
  [3764] = {
    [anon_sym_BQUOTE] = ACTIONS(387),
    [anon_sym_AMP_GT_GT] = ACTIONS(387),
    [sym_raw_string] = ACTIONS(387),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [sym_file_descriptor] = ACTIONS(387),
    [sym_variable_name] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(387),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(387),
    [anon_sym_GT_LPAREN] = ACTIONS(387),
    [anon_sym_RPAREN] = ACTIONS(9058),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_word] = ACTIONS(387),
    [anon_sym_GT_AMP] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(387),
    [anon_sym_GT_GT] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(387),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(387),
  },
  [3765] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(9058),
  },
  [3766] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3925),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3925),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(9070),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9072),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9074),
    [anon_sym_DASH] = ACTIONS(9072),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9072),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9072),
    [anon_sym_PERCENT] = ACTIONS(9072),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9076),
    [anon_sym_COLON_DASH] = ACTIONS(9072),
    [sym__special_character] = ACTIONS(599),
  },
  [3767] = {
    [sym_subscript] = STATE(3926),
    [anon_sym_STAR] = ACTIONS(9078),
    [anon_sym_QMARK] = ACTIONS(9078),
    [anon_sym_AT] = ACTIONS(9078),
    [sym_variable_name] = ACTIONS(9080),
    [anon_sym_DOLLAR] = ACTIONS(9082),
    [anon_sym_DASH] = ACTIONS(9082),
    [anon_sym_0] = ACTIONS(9084),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(9084),
    [anon_sym__] = ACTIONS(9084),
  },
  [3768] = {
    [anon_sym_EQ] = ACTIONS(9086),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3769] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3932),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3932),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(9088),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9090),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9092),
    [anon_sym_DASH] = ACTIONS(9090),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9090),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9090),
    [anon_sym_PERCENT] = ACTIONS(9090),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9094),
    [anon_sym_COLON_DASH] = ACTIONS(9090),
    [sym__special_character] = ACTIONS(599),
  },
  [3770] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(219),
    [anon_sym_LT_LT] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(219),
    [sym_word] = ACTIONS(219),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(219),
    [anon_sym_LT_AMP] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [sym__special_character] = ACTIONS(219),
    [anon_sym_LT_LT_DASH] = ACTIONS(219),
    [anon_sym_BQUOTE] = ACTIONS(219),
    [anon_sym_LF] = ACTIONS(221),
    [anon_sym_SEMI] = ACTIONS(219),
    [sym_raw_string] = ACTIONS(219),
    [sym_variable_name] = ACTIONS(221),
    [sym_file_descriptor] = ACTIONS(221),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_AMP_GT] = ACTIONS(219),
    [anon_sym_DQUOTE] = ACTIONS(219),
    [anon_sym_LT_LT_LT] = ACTIONS(219),
    [anon_sym_GT_AMP] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_esac] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(219),
    [anon_sym_SEMI_SEMI] = ACTIONS(219),
    [anon_sym_PIPE_AMP] = ACTIONS(219),
  },
  [3771] = {
    [aux_sym__literal_repeat1] = STATE(3771),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_DOLLAR] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [sym_word] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(9096),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_BQUOTE] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [sym_raw_string] = ACTIONS(1187),
    [sym_variable_name] = ACTIONS(1192),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT_LPAREN] = ACTIONS(1187),
    [anon_sym_esac] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [3772] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [anon_sym_EQ_TILDE] = ACTIONS(3421),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_esac] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3773] = {
    [aux_sym_concatenation_repeat1] = STATE(3934),
    [anon_sym_LT_LT_DASH] = ACTIONS(627),
    [anon_sym_AMP_GT_GT] = ACTIONS(627),
    [anon_sym_LF] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(627),
    [anon_sym_LT_LT] = ACTIONS(627),
    [sym_file_descriptor] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_AMP_GT] = ACTIONS(627),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT_LT_LT] = ACTIONS(627),
    [anon_sym_PIPE] = ACTIONS(627),
    [anon_sym_GT_AMP] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_esac] = ACTIONS(627),
    [anon_sym_GT_GT] = ACTIONS(627),
    [anon_sym_LT_AMP] = ACTIONS(627),
    [anon_sym_AMP] = ACTIONS(627),
    [sym__concat] = ACTIONS(9099),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(627),
    [anon_sym_PIPE_AMP] = ACTIONS(627),
  },
  [3774] = {
    [aux_sym__literal_repeat1] = STATE(3774),
    [anon_sym_LT_LT_DASH] = ACTIONS(1187),
    [anon_sym_AMP_GT_GT] = ACTIONS(1187),
    [anon_sym_LF] = ACTIONS(1192),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [sym_file_descriptor] = ACTIONS(1192),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_AMP_GT] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1187),
    [anon_sym_LT_LT_LT] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_GT_AMP] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_esac] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_LT_AMP] = ACTIONS(1187),
    [anon_sym_AMP] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1187),
    [sym__special_character] = ACTIONS(3701),
    [anon_sym_SEMI_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE_AMP] = ACTIONS(1187),
  },
  [3775] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [anon_sym_esac] = ACTIONS(3734),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
    [anon_sym_SEMI_SEMI] = ACTIONS(3732),
  },
  [3776] = {
    [aux_sym_concatenation_repeat1] = STATE(3773),
    [anon_sym_LT_LT_DASH] = ACTIONS(2004),
    [anon_sym_AMP_GT_GT] = ACTIONS(2004),
    [anon_sym_LF] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [sym_file_descriptor] = ACTIONS(2002),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_AMP_GT] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_LT_LT_LT] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_GT_AMP] = ACTIONS(2004),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_esac] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_LT_AMP] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [sym__concat] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(2004),
    [anon_sym_PIPE_AMP] = ACTIONS(2004),
  },
  [3777] = {
    [aux_sym__literal_repeat1] = STATE(3774),
    [anon_sym_LT_LT_DASH] = ACTIONS(2008),
    [anon_sym_AMP_GT_GT] = ACTIONS(2008),
    [anon_sym_LF] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [sym_file_descriptor] = ACTIONS(2006),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_AMP_GT] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_LT_LT_LT] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_GT_AMP] = ACTIONS(2008),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_esac] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_LT_AMP] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [sym__special_character] = ACTIONS(2243),
    [anon_sym_SEMI_SEMI] = ACTIONS(2008),
    [anon_sym_PIPE_AMP] = ACTIONS(2008),
  },
  [3778] = {
    [anon_sym_AMP] = ACTIONS(9101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(9103),
    [anon_sym_SEMI] = ACTIONS(9101),
    [anon_sym_SEMI_SEMI] = ACTIONS(3734),
    [anon_sym_esac] = ACTIONS(3734),
  },
  [3779] = {
    [sym_heredoc_body] = STATE(3936),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
  },
  [3780] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
  },
  [3781] = {
    [anon_sym_BQUOTE] = ACTIONS(7992),
    [anon_sym_DQUOTE] = ACTIONS(7992),
    [sym_word] = ACTIONS(7992),
    [sym_raw_string] = ACTIONS(7992),
    [anon_sym_LT_LPAREN] = ACTIONS(7992),
    [anon_sym_DOLLAR] = ACTIONS(7994),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(7992),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7992),
    [sym__special_character] = ACTIONS(7992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7992),
  },
  [3782] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
    [anon_sym_AMP_GT_GT] = ACTIONS(767),
    [anon_sym_LF] = ACTIONS(9105),
    [anon_sym_SEMI] = ACTIONS(9107),
    [sym_file_descriptor] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_AMP_GT] = ACTIONS(767),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_LT_LT_LT] = ACTIONS(775),
    [anon_sym_GT_AMP] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_LT] = ACTIONS(767),
    [anon_sym_LT_AMP] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(9107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_SEMI_SEMI] = ACTIONS(1220),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
  },
  [3783] = {
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym_file_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(351),
    [anon_sym_GT_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(385),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [sym_word] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(777),
    [anon_sym_AMP] = ACTIONS(9107),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_LT_AMP] = ACTIONS(385),
    [anon_sym_GT_GT] = ACTIONS(385),
    [sym__special_character] = ACTIONS(385),
    [anon_sym_LT_LT_DASH] = ACTIONS(351),
    [anon_sym_BQUOTE] = ACTIONS(385),
    [sym_raw_string] = ACTIONS(385),
    [anon_sym_LF] = ACTIONS(9105),
    [anon_sym_SEMI] = ACTIONS(9107),
    [sym_variable_name] = ACTIONS(387),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_AMP_GT] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_LT_LT_LT] = ACTIONS(775),
    [anon_sym_GT_AMP] = ACTIONS(385),
    [anon_sym_LT_LPAREN] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_SEMI_SEMI] = ACTIONS(1220),
    [anon_sym_PIPE_AMP] = ACTIONS(777),
  },
  [3784] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(9109),
  },
  [3785] = {
    [anon_sym_BQUOTE] = ACTIONS(8013),
    [anon_sym_DQUOTE] = ACTIONS(8013),
    [sym_word] = ACTIONS(8013),
    [sym_raw_string] = ACTIONS(8013),
    [anon_sym_LT_LPAREN] = ACTIONS(8013),
    [anon_sym_DOLLAR] = ACTIONS(8015),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8013),
    [sym__special_character] = ACTIONS(8013),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8013),
  },
  [3786] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(9111),
  },
  [3787] = {
    [anon_sym_BQUOTE] = ACTIONS(6453),
    [anon_sym_DQUOTE] = ACTIONS(6453),
    [sym_word] = ACTIONS(6453),
    [sym_raw_string] = ACTIONS(6453),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_LT_LPAREN] = ACTIONS(6453),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_RPAREN] = ACTIONS(6453),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6453),
  },
  [3788] = {
    [anon_sym_BQUOTE] = ACTIONS(6457),
    [anon_sym_DQUOTE] = ACTIONS(6457),
    [sym_word] = ACTIONS(6457),
    [sym_raw_string] = ACTIONS(6457),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_LT_LPAREN] = ACTIONS(6457),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_RPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(6457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6457),
  },
  [3789] = {
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
  },
  [3790] = {
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
  },
  [3791] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(9113),
    [anon_sym_BQUOTE] = ACTIONS(9113),
    [anon_sym_AMP_GT_GT] = ACTIONS(9113),
    [anon_sym_LF] = ACTIONS(9115),
    [anon_sym_SEMI] = ACTIONS(9113),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [sym_file_descriptor] = ACTIONS(9115),
    [anon_sym_GT] = ACTIONS(9113),
    [anon_sym_RPAREN] = ACTIONS(9113),
    [anon_sym_AMP_GT] = ACTIONS(9113),
    [anon_sym_fi] = ACTIONS(9113),
    [anon_sym_else] = ACTIONS(9113),
    [anon_sym_done] = ACTIONS(9113),
    [anon_sym_PIPE_PIPE] = ACTIONS(9113),
    [ts_builtin_sym_end] = ACTIONS(9115),
    [anon_sym_LT_LT_LT] = ACTIONS(9113),
    [anon_sym_PIPE] = ACTIONS(9113),
    [anon_sym_GT_AMP] = ACTIONS(9113),
    [anon_sym_LT] = ACTIONS(9113),
    [anon_sym_LT_AMP] = ACTIONS(9113),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_AMP] = ACTIONS(9113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_elif] = ACTIONS(9113),
    [anon_sym_AMP_AMP] = ACTIONS(9113),
    [anon_sym_esac] = ACTIONS(9113),
    [anon_sym_SEMI_SEMI] = ACTIONS(9113),
    [anon_sym_PIPE_AMP] = ACTIONS(9113),
  },
  [3792] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_done] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3793] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9117),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3794] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_done] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3795] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_done] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3796] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9119),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3797] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_done] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3798] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_done] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3799] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9121),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3800] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_done] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3801] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_done] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3802] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9123),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3803] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_done] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3804] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_done] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_EQ_TILDE] = ACTIONS(6451),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_EQ_EQ] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3805] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_done] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_EQ_TILDE] = ACTIONS(6455),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3806] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_done] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3807] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9125),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3808] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3946),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3946),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9127),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9125),
    [anon_sym_DASH] = ACTIONS(9127),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9127),
    [anon_sym_PERCENT] = ACTIONS(9127),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9129),
    [anon_sym_COLON_DASH] = ACTIONS(9127),
    [sym__special_character] = ACTIONS(599),
  },
  [3809] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9125),
    [sym__concat] = ACTIONS(2610),
  },
  [3810] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9125),
  },
  [3811] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9131),
  },
  [3812] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_done] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3813] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3949),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3949),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9133),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9135),
    [anon_sym_DASH] = ACTIONS(9133),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9133),
    [anon_sym_PERCENT] = ACTIONS(9133),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9137),
    [anon_sym_COLON_DASH] = ACTIONS(9133),
    [sym__special_character] = ACTIONS(599),
  },
  [3814] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9135),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3815] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_done] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3816] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_done] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3817] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9139),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3818] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_done] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3819] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9141),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3820] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3952),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3952),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9143),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9141),
    [anon_sym_DASH] = ACTIONS(9143),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9143),
    [anon_sym_PERCENT] = ACTIONS(9143),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9145),
    [anon_sym_COLON_DASH] = ACTIONS(9143),
    [sym__special_character] = ACTIONS(599),
  },
  [3821] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9141),
    [sym__concat] = ACTIONS(2610),
  },
  [3822] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9141),
  },
  [3823] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9147),
  },
  [3824] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_done] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3825] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3955),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3955),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9149),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9151),
    [anon_sym_DASH] = ACTIONS(9149),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9149),
    [anon_sym_PERCENT] = ACTIONS(9149),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9153),
    [anon_sym_COLON_DASH] = ACTIONS(9149),
    [sym__special_character] = ACTIONS(599),
  },
  [3826] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9151),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3827] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_done] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3828] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_done] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3829] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9155),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3830] = {
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6453),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6453),
    [sym__heredoc_body_end] = ACTIONS(6453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6453),
    [sym__heredoc_body_middle] = ACTIONS(6453),
  },
  [3831] = {
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6457),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6457),
    [sym__heredoc_body_end] = ACTIONS(6457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6457),
    [sym__heredoc_body_middle] = ACTIONS(6457),
  },
  [3832] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(9113),
    [anon_sym_AMP_GT_GT] = ACTIONS(9113),
    [anon_sym_LF] = ACTIONS(9115),
    [anon_sym_SEMI] = ACTIONS(9113),
    [anon_sym_LT_LT] = ACTIONS(9113),
    [anon_sym_RBRACE] = ACTIONS(9113),
    [anon_sym_GT] = ACTIONS(9113),
    [sym_file_descriptor] = ACTIONS(9115),
    [anon_sym_AMP_GT] = ACTIONS(9113),
    [anon_sym_PIPE_PIPE] = ACTIONS(9113),
    [anon_sym_LT_LT_LT] = ACTIONS(9113),
    [anon_sym_PIPE] = ACTIONS(9113),
    [anon_sym_GT_AMP] = ACTIONS(9113),
    [anon_sym_LT] = ACTIONS(9113),
    [anon_sym_LT_AMP] = ACTIONS(9113),
    [anon_sym_GT_GT] = ACTIONS(9113),
    [anon_sym_AMP] = ACTIONS(9113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(9113),
    [anon_sym_SEMI_SEMI] = ACTIONS(9113),
    [anon_sym_PIPE_AMP] = ACTIONS(9113),
  },
  [3833] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_else] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [anon_sym_elif] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3834] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_else] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [anon_sym_elif] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3835] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_else] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [anon_sym_elif] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3836] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_else] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [anon_sym_elif] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3837] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_fi] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3838] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9157),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3839] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_fi] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3840] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_fi] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3841] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9159),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3842] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_fi] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3843] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_fi] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3844] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9161),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3845] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_fi] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3846] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_fi] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3847] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9163),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3848] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_fi] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3849] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_EQ_TILDE] = ACTIONS(6451),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_EQ_EQ] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3850] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_EQ_TILDE] = ACTIONS(6455),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3851] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_fi] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3852] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9165),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3853] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3962),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3962),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9167),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9165),
    [anon_sym_DASH] = ACTIONS(9167),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9167),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9167),
    [anon_sym_PERCENT] = ACTIONS(9167),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9169),
    [anon_sym_COLON_DASH] = ACTIONS(9167),
    [sym__special_character] = ACTIONS(599),
  },
  [3854] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9165),
    [sym__concat] = ACTIONS(2610),
  },
  [3855] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9165),
  },
  [3856] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9171),
  },
  [3857] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_fi] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3858] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3965),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3965),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9173),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9175),
    [anon_sym_DASH] = ACTIONS(9173),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9173),
    [anon_sym_PERCENT] = ACTIONS(9173),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9177),
    [anon_sym_COLON_DASH] = ACTIONS(9173),
    [sym__special_character] = ACTIONS(599),
  },
  [3859] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9175),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3860] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_fi] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3861] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_fi] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3862] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9179),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3863] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_fi] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_else] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [anon_sym_elif] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3864] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9181),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3865] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_fi] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_else] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [anon_sym_elif] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3866] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_fi] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_else] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [anon_sym_elif] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3867] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9183),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3868] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_fi] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_else] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [anon_sym_elif] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3869] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_esac] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3870] = {
    [sym_string] = STATE(3440),
    [anon_sym__] = ACTIONS(7878),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(9185),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(9185),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(7878),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(7878),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(9187),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(7878),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(7058),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_esac] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(7878),
    [anon_sym_POUND] = ACTIONS(9185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3871] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3305),
    [anon_sym_DOLLAR] = ACTIONS(3305),
    [anon_sym_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_LPAREN] = ACTIONS(3305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3305),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3305),
    [anon_sym_PIPE_PIPE] = ACTIONS(3305),
    [sym_word] = ACTIONS(3305),
    [anon_sym_PIPE] = ACTIONS(3305),
    [anon_sym_AMP] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_LT_AMP] = ACTIONS(3305),
    [anon_sym_GT_GT] = ACTIONS(3305),
    [sym__special_character] = ACTIONS(3305),
    [anon_sym_LT_LT_DASH] = ACTIONS(3305),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [anon_sym_LF] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3305),
    [sym_raw_string] = ACTIONS(3305),
    [sym_variable_name] = ACTIONS(3307),
    [sym_file_descriptor] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_AMP_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_LT_LT_LT] = ACTIONS(3305),
    [anon_sym_GT_AMP] = ACTIONS(3305),
    [anon_sym_LT_LPAREN] = ACTIONS(3305),
    [anon_sym_esac] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3305),
    [anon_sym_SEMI_SEMI] = ACTIONS(3305),
    [anon_sym_PIPE_AMP] = ACTIONS(3305),
  },
  [3872] = {
    [sym_process_substitution] = STATE(986),
    [sym_command_substitution] = STATE(986),
    [aux_sym_for_statement_repeat1] = STATE(1542),
    [sym_simple_expansion] = STATE(986),
    [sym_string_expansion] = STATE(986),
    [sym_expansion] = STATE(986),
    [sym_concatenation] = STATE(1542),
    [sym_string] = STATE(986),
    [aux_sym__literal_repeat1] = STATE(993),
    [anon_sym_BQUOTE] = ACTIONS(1938),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_word] = ACTIONS(1942),
    [sym_raw_string] = ACTIONS(1942),
    [anon_sym_LT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(9189),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1950),
    [sym__special_character] = ACTIONS(1952),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1954),
  },
  [3873] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [anon_sym_esac] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3874] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3971),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3971),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9191),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9193),
    [anon_sym_DASH] = ACTIONS(9191),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9191),
    [anon_sym_PERCENT] = ACTIONS(9191),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9195),
    [anon_sym_COLON_DASH] = ACTIONS(9191),
    [sym__special_character] = ACTIONS(599),
  },
  [3875] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9193),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3876] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3971),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3971),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9191),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9193),
    [anon_sym_DASH] = ACTIONS(9191),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9191),
    [anon_sym_PERCENT] = ACTIONS(9191),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9195),
    [anon_sym_COLON_DASH] = ACTIONS(9191),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9197),
  },
  [3877] = {
    [sym_process_substitution] = STATE(3973),
    [aux_sym__literal_repeat1] = STATE(3975),
    [sym_simple_expansion] = STATE(3973),
    [sym_string_expansion] = STATE(3973),
    [sym_expansion] = STATE(3973),
    [sym_concatenation] = STATE(3974),
    [sym_string] = STATE(3973),
    [sym_command_substitution] = STATE(3973),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(9199),
    [sym_raw_string] = ACTIONS(9199),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9193),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3878] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3978),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3978),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9201),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9203),
    [anon_sym_DASH] = ACTIONS(9201),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9201),
    [anon_sym_PERCENT] = ACTIONS(9201),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9205),
    [anon_sym_COLON_DASH] = ACTIONS(9201),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9207),
  },
  [3879] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [anon_sym_esac] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3880] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9203),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3881] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9193),
    [sym__concat] = ACTIONS(2610),
  },
  [3882] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9193),
  },
  [3883] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9209),
  },
  [3884] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_esac] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3885] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3981),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3981),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9211),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9213),
    [anon_sym_DASH] = ACTIONS(9211),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9211),
    [anon_sym_PERCENT] = ACTIONS(9211),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9215),
    [anon_sym_COLON_DASH] = ACTIONS(9211),
    [sym__special_character] = ACTIONS(599),
  },
  [3886] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9213),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3887] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_esac] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [3888] = {
    [sym_string] = STATE(3459),
    [anon_sym__] = ACTIONS(7908),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(9217),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(9217),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(7908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(7908),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(7908),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(9219),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(7908),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(7076),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_esac] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(7908),
    [anon_sym_POUND] = ACTIONS(9217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [3889] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [anon_sym_esac] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [3890] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3983),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3983),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9221),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9223),
    [anon_sym_DASH] = ACTIONS(9221),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9221),
    [anon_sym_PERCENT] = ACTIONS(9221),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9225),
    [anon_sym_COLON_DASH] = ACTIONS(9221),
    [sym__special_character] = ACTIONS(599),
  },
  [3891] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9223),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3892] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3983),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3983),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9221),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9223),
    [anon_sym_DASH] = ACTIONS(9221),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9221),
    [anon_sym_PERCENT] = ACTIONS(9221),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9225),
    [anon_sym_COLON_DASH] = ACTIONS(9221),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9227),
  },
  [3893] = {
    [sym_process_substitution] = STATE(3985),
    [aux_sym__literal_repeat1] = STATE(3987),
    [sym_simple_expansion] = STATE(3985),
    [sym_string_expansion] = STATE(3985),
    [sym_expansion] = STATE(3985),
    [sym_concatenation] = STATE(3986),
    [sym_string] = STATE(3985),
    [sym_command_substitution] = STATE(3985),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(9229),
    [sym_raw_string] = ACTIONS(9229),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9223),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3894] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3990),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3990),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9231),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9233),
    [anon_sym_DASH] = ACTIONS(9231),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9235),
    [anon_sym_COLON_DASH] = ACTIONS(9231),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9237),
  },
  [3895] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [anon_sym_esac] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [3896] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9233),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3897] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9223),
    [sym__concat] = ACTIONS(2610),
  },
  [3898] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9223),
  },
  [3899] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9239),
  },
  [3900] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_esac] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [3901] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3993),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3993),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9241),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9243),
    [anon_sym_DASH] = ACTIONS(9241),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9241),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9241),
    [anon_sym_PERCENT] = ACTIONS(9241),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9245),
    [anon_sym_COLON_DASH] = ACTIONS(9241),
    [sym__special_character] = ACTIONS(599),
  },
  [3902] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9243),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3903] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [anon_sym_EQ_TILDE] = ACTIONS(3830),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [anon_sym_esac] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3904] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9247),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3905] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3995),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3995),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9249),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9247),
    [anon_sym_DASH] = ACTIONS(9249),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9249),
    [anon_sym_PERCENT] = ACTIONS(9249),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9251),
    [anon_sym_COLON_DASH] = ACTIONS(9249),
    [sym__special_character] = ACTIONS(599),
  },
  [3906] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9247),
    [sym__concat] = ACTIONS(2610),
  },
  [3907] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9247),
  },
  [3908] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9253),
  },
  [3909] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [anon_sym_EQ_TILDE] = ACTIONS(3879),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_EQ_EQ] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [anon_sym_esac] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3910] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(3998),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(3998),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9255),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9257),
    [anon_sym_DASH] = ACTIONS(9255),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9255),
    [anon_sym_PERCENT] = ACTIONS(9255),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9259),
    [anon_sym_COLON_DASH] = ACTIONS(9255),
    [sym__special_character] = ACTIONS(599),
  },
  [3911] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9257),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3912] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [anon_sym_EQ_TILDE] = ACTIONS(3927),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_esac] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3913] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [anon_sym_EQ_TILDE] = ACTIONS(3946),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_EQ_EQ] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3914] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9261),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3915] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [anon_sym_esac] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [3916] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1440),
    [anon_sym_PIPE_PIPE] = ACTIONS(1440),
    [sym_word] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_AMP] = ACTIONS(1440),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [sym__concat] = ACTIONS(1442),
    [sym__special_character] = ACTIONS(1440),
    [anon_sym_LT_LT_DASH] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_LF] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1440),
    [sym_raw_string] = ACTIONS(1440),
    [sym_variable_name] = ACTIONS(1442),
    [sym_file_descriptor] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_AMP_GT] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_GT_AMP] = ACTIONS(1440),
    [anon_sym_LT_LPAREN] = ACTIONS(1440),
    [anon_sym_esac] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1440),
    [anon_sym_SEMI_SEMI] = ACTIONS(1440),
    [anon_sym_PIPE_AMP] = ACTIONS(1440),
  },
  [3917] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2010),
    [anon_sym_DOLLAR] = ACTIONS(2010),
    [anon_sym_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE] = ACTIONS(2010),
    [sym_word] = ACTIONS(2010),
    [anon_sym_PIPE] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2010),
    [anon_sym_LT_AMP] = ACTIONS(2010),
    [anon_sym_GT_GT] = ACTIONS(2010),
    [sym__concat] = ACTIONS(2012),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_LT_LT_DASH] = ACTIONS(2010),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [anon_sym_LF] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2010),
    [sym_raw_string] = ACTIONS(2010),
    [sym_variable_name] = ACTIONS(2012),
    [sym_file_descriptor] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2010),
    [anon_sym_AMP_GT] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_LT_LT_LT] = ACTIONS(2010),
    [anon_sym_GT_AMP] = ACTIONS(2010),
    [anon_sym_LT_LPAREN] = ACTIONS(2010),
    [anon_sym_esac] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_SEMI_SEMI] = ACTIONS(2010),
    [anon_sym_PIPE_AMP] = ACTIONS(2010),
  },
  [3918] = {
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(9263),
    [anon_sym_QMARK] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_POUND] = ACTIONS(933),
    [anon_sym_DASH] = ACTIONS(933),
    [anon_sym_0] = ACTIONS(935),
    [sym__string_content] = ACTIONS(937),
    [aux_sym__simple_variable_name_token1] = ACTIONS(935),
    [anon_sym__] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
  },
  [3919] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(1544),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3920] = {
    [sym_process_substitution] = STATE(3919),
    [sym_string_expansion] = STATE(3919),
    [sym_expansion] = STATE(3919),
    [sym_simple_expansion] = STATE(3919),
    [sym_string] = STATE(3919),
    [sym_command_substitution] = STATE(3919),
    [anon_sym_BQUOTE] = ACTIONS(7960),
    [anon_sym_DQUOTE] = ACTIONS(7962),
    [sym_word] = ACTIONS(9064),
    [sym_raw_string] = ACTIONS(9064),
    [anon_sym_LT_LPAREN] = ACTIONS(7966),
    [anon_sym_DOLLAR] = ACTIONS(9265),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(7966),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7970),
    [sym__special_character] = ACTIONS(9064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7974),
  },
  [3921] = {
    [aux_sym_concatenation_repeat1] = STATE(3921),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [sym_word] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [sym__concat] = ACTIONS(9267),
    [sym__special_character] = ACTIONS(1542),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [sym_raw_string] = ACTIONS(1542),
    [sym_variable_name] = ACTIONS(1544),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT_LPAREN] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3922] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1434),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [sym_word] = ACTIONS(1434),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_LT_AMP] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [sym__concat] = ACTIONS(1436),
    [sym__special_character] = ACTIONS(1434),
    [anon_sym_LT_LT_DASH] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_LF] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1434),
    [sym_raw_string] = ACTIONS(1434),
    [sym_variable_name] = ACTIONS(1436),
    [sym_file_descriptor] = ACTIONS(1436),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_AMP_GT] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_AMP] = ACTIONS(1434),
    [anon_sym_LT_LPAREN] = ACTIONS(1434),
    [anon_sym_esac] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_SEMI_SEMI] = ACTIONS(1434),
    [anon_sym_PIPE_AMP] = ACTIONS(1434),
  },
  [3923] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4004),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4004),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9270),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9272),
    [anon_sym_DASH] = ACTIONS(9270),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9270),
    [anon_sym_PERCENT] = ACTIONS(9270),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9274),
    [anon_sym_COLON_DASH] = ACTIONS(9270),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9276),
  },
  [3924] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [sym_word] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_AMP] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [sym__concat] = ACTIONS(1478),
    [sym__special_character] = ACTIONS(1476),
    [anon_sym_LT_LT_DASH] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_raw_string] = ACTIONS(1476),
    [sym_variable_name] = ACTIONS(1478),
    [sym_file_descriptor] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_AMP_GT] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_GT_AMP] = ACTIONS(1476),
    [anon_sym_LT_LPAREN] = ACTIONS(1476),
    [anon_sym_esac] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(1476),
  },
  [3925] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9272),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3926] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4004),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4004),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(9278),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9270),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9272),
    [anon_sym_DASH] = ACTIONS(9270),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9270),
    [anon_sym_PERCENT] = ACTIONS(9270),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9274),
    [anon_sym_COLON_DASH] = ACTIONS(9270),
    [sym__special_character] = ACTIONS(599),
  },
  [3927] = {
    [anon_sym_EQ] = ACTIONS(9280),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(611),
  },
  [3928] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4009),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4009),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(9282),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9284),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9286),
    [anon_sym_DASH] = ACTIONS(9284),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9284),
    [anon_sym_PERCENT] = ACTIONS(9284),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9288),
    [anon_sym_COLON_DASH] = ACTIONS(9284),
    [sym__special_character] = ACTIONS(599),
  },
  [3929] = {
    [sym_process_substitution] = STATE(4010),
    [aux_sym__literal_repeat1] = STATE(4012),
    [sym_simple_expansion] = STATE(4010),
    [sym_string_expansion] = STATE(4010),
    [sym_expansion] = STATE(4010),
    [sym_concatenation] = STATE(4011),
    [sym_string] = STATE(4010),
    [sym_command_substitution] = STATE(4010),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(9290),
    [sym_raw_string] = ACTIONS(9290),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9272),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [3930] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4015),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4015),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9292),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9294),
    [anon_sym_DASH] = ACTIONS(9292),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9292),
    [anon_sym_PERCENT] = ACTIONS(9292),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9296),
    [anon_sym_COLON_DASH] = ACTIONS(9292),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9298),
  },
  [3931] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE_PIPE] = ACTIONS(1532),
    [sym_word] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_AMP] = ACTIONS(1532),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [sym__concat] = ACTIONS(1534),
    [sym__special_character] = ACTIONS(1532),
    [anon_sym_LT_LT_DASH] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LF] = ACTIONS(1534),
    [anon_sym_SEMI] = ACTIONS(1532),
    [sym_raw_string] = ACTIONS(1532),
    [sym_variable_name] = ACTIONS(1534),
    [sym_file_descriptor] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_AMP_GT] = ACTIONS(1532),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LT_LT] = ACTIONS(1532),
    [anon_sym_GT_AMP] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(1532),
    [anon_sym_esac] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1532),
    [anon_sym_SEMI_SEMI] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(1532),
  },
  [3932] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9294),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3933] = {
    [sym_process_substitution] = STATE(1700),
    [sym_string_expansion] = STATE(1700),
    [sym_expansion] = STATE(1700),
    [sym_simple_expansion] = STATE(1700),
    [sym_string] = STATE(1700),
    [sym_command_substitution] = STATE(1700),
    [anon_sym_BQUOTE] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [sym_word] = ACTIONS(3669),
    [sym_raw_string] = ACTIONS(3669),
    [anon_sym_LT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR] = ACTIONS(9300),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1041),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1045),
    [sym__special_character] = ACTIONS(3669),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1049),
  },
  [3934] = {
    [aux_sym_concatenation_repeat1] = STATE(3934),
    [anon_sym_LT_LT_DASH] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1542),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [sym_file_descriptor] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1542),
    [anon_sym_GT_AMP] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_esac] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1542),
    [anon_sym_LT_AMP] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1542),
    [sym__concat] = ACTIONS(4959),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(1542),
    [anon_sym_PIPE_AMP] = ACTIONS(1542),
  },
  [3935] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [anon_sym_esac] = ACTIONS(7856),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
    [anon_sym_SEMI_SEMI] = ACTIONS(5041),
  },
  [3936] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(9302),
    [anon_sym_SEMI] = ACTIONS(9304),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(9304),
  },
  [3937] = {
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(2263),
  },
  [3938] = {
    [sym_heredoc_body] = STATE(4018),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_AMP_GT_GT] = ACTIONS(1053),
    [anon_sym_local] = ACTIONS(1051),
    [anon_sym_typeset] = ACTIONS(1051),
    [anon_sym_unsetenv] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1051),
    [sym_word] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1051),
    [sym__simple_heredoc_body] = ACTIONS(1055),
    [sym__special_character] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_case] = ACTIONS(1051),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_declare] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1053),
    [sym_file_descriptor] = ACTIONS(1053),
    [sym__heredoc_body_beginning] = ACTIONS(1057),
    [anon_sym_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1051),
    [anon_sym_readonly] = ACTIONS(1051),
    [anon_sym_unset] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_GT_AMP] = ACTIONS(1053),
    [anon_sym_LT_LPAREN] = ACTIONS(1053),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(2263),
  },
  [3939] = {
    [anon_sym_BQUOTE] = ACTIONS(8722),
    [anon_sym_DQUOTE] = ACTIONS(8722),
    [sym_word] = ACTIONS(8722),
    [sym_raw_string] = ACTIONS(8722),
    [anon_sym_LT_LPAREN] = ACTIONS(8722),
    [anon_sym_DOLLAR] = ACTIONS(8724),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8722),
    [sym__special_character] = ACTIONS(8722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8722),
  },
  [3940] = {
    [anon_sym_BQUOTE] = ACTIONS(8728),
    [anon_sym_DQUOTE] = ACTIONS(8728),
    [sym_word] = ACTIONS(8728),
    [sym_raw_string] = ACTIONS(8728),
    [anon_sym_LT_LPAREN] = ACTIONS(8728),
    [anon_sym_DOLLAR] = ACTIONS(8730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(8728),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8728),
    [sym__special_character] = ACTIONS(8728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8728),
  },
  [3941] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_done] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3942] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_done] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3943] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_done] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3944] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_done] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3945] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_done] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3946] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9306),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3947] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_done] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3948] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_done] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3949] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9308),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3950] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_done] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3951] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_done] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3952] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9310),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3953] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_done] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3954] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_done] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3955] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9312),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3956] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_done] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3957] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3958] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3959] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3960] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3961] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_fi] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3962] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9314),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3963] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_fi] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3964] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_fi] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3965] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9316),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3966] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_fi] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [3967] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_else] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [anon_sym_elif] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [3968] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_else] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [anon_sym_elif] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [3969] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4557),
    [anon_sym_DOLLAR] = ACTIONS(4557),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_LPAREN] = ACTIONS(4557),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4557),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [sym_word] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4557),
    [anon_sym_AMP] = ACTIONS(4557),
    [anon_sym_LT] = ACTIONS(4557),
    [anon_sym_LT_AMP] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4557),
    [sym__special_character] = ACTIONS(4557),
    [anon_sym_LT_LT_DASH] = ACTIONS(4557),
    [anon_sym_BQUOTE] = ACTIONS(4557),
    [anon_sym_LF] = ACTIONS(4559),
    [anon_sym_SEMI] = ACTIONS(4557),
    [sym_raw_string] = ACTIONS(4557),
    [sym_variable_name] = ACTIONS(4559),
    [sym_file_descriptor] = ACTIONS(4559),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_AMP_GT] = ACTIONS(4557),
    [anon_sym_DQUOTE] = ACTIONS(4557),
    [anon_sym_LT_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_AMP] = ACTIONS(4557),
    [anon_sym_LT_LPAREN] = ACTIONS(4557),
    [anon_sym_esac] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_SEMI_SEMI] = ACTIONS(4557),
    [anon_sym_PIPE_AMP] = ACTIONS(4557),
  },
  [3970] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [anon_sym_esac] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3971] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9318),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3972] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4026),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4026),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9320),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9318),
    [anon_sym_DASH] = ACTIONS(9320),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9320),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9320),
    [anon_sym_PERCENT] = ACTIONS(9320),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9322),
    [anon_sym_COLON_DASH] = ACTIONS(9320),
    [sym__special_character] = ACTIONS(599),
  },
  [3973] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9318),
    [sym__concat] = ACTIONS(2610),
  },
  [3974] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9318),
  },
  [3975] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9324),
  },
  [3976] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [anon_sym_esac] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3977] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4029),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4029),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9326),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9328),
    [anon_sym_DASH] = ACTIONS(9326),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9326),
    [anon_sym_PERCENT] = ACTIONS(9326),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9330),
    [anon_sym_COLON_DASH] = ACTIONS(9326),
    [sym__special_character] = ACTIONS(599),
  },
  [3978] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9328),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3979] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_esac] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3980] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3981] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9332),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3982] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [anon_sym_esac] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [3983] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9334),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3984] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4032),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4032),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9336),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9334),
    [anon_sym_DASH] = ACTIONS(9336),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9336),
    [anon_sym_PERCENT] = ACTIONS(9336),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9338),
    [anon_sym_COLON_DASH] = ACTIONS(9336),
    [sym__special_character] = ACTIONS(599),
  },
  [3985] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9334),
    [sym__concat] = ACTIONS(2610),
  },
  [3986] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9334),
  },
  [3987] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9340),
  },
  [3988] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [anon_sym_esac] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [3989] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4035),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4035),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9342),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9344),
    [anon_sym_DASH] = ACTIONS(9342),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9342),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9342),
    [anon_sym_PERCENT] = ACTIONS(9342),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9346),
    [anon_sym_COLON_DASH] = ACTIONS(9342),
    [sym__special_character] = ACTIONS(599),
  },
  [3990] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9344),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3991] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_esac] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [3992] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [3993] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9348),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3994] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [anon_sym_EQ_TILDE] = ACTIONS(5095),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_EQ_EQ] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [anon_sym_esac] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [3995] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9350),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3996] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [anon_sym_EQ_TILDE] = ACTIONS(5129),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_EQ_EQ] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [anon_sym_esac] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [3997] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [anon_sym_EQ_TILDE] = ACTIONS(5133),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_EQ_EQ] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [anon_sym_esac] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [3998] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9352),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [3999] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [anon_sym_EQ_TILDE] = ACTIONS(5184),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_EQ_EQ] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [anon_sym_esac] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [4000] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_word] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3423),
    [sym__special_character] = ACTIONS(3421),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3423),
    [sym_file_descriptor] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_esac] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
  },
  [4001] = {
    [sym_string] = STATE(3762),
    [anon_sym__] = ACTIONS(8664),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(9354),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(9354),
    [anon_sym_GT_LPAREN] = ACTIONS(2658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2658),
    [aux_sym__simple_variable_name_token1] = ACTIONS(8664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [sym_word] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(8664),
    [sym__special_character] = ACTIONS(2658),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(8664),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(9356),
    [sym_variable_name] = ACTIONS(2662),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(8664),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(9358),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LPAREN] = ACTIONS(2658),
    [anon_sym_esac] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(8664),
    [anon_sym_POUND] = ACTIONS(9354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [4002] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [sym_word] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_LT_AMP] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2506),
    [sym__concat] = ACTIONS(2508),
    [sym__special_character] = ACTIONS(2506),
    [anon_sym_LT_LT_DASH] = ACTIONS(2506),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [sym_raw_string] = ACTIONS(2506),
    [sym_variable_name] = ACTIONS(2508),
    [sym_file_descriptor] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_AMP_GT] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_LT_LT_LT] = ACTIONS(2506),
    [anon_sym_GT_AMP] = ACTIONS(2506),
    [anon_sym_LT_LPAREN] = ACTIONS(2506),
    [anon_sym_esac] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_SEMI_SEMI] = ACTIONS(2506),
    [anon_sym_PIPE_AMP] = ACTIONS(2506),
  },
  [4003] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4040),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4040),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9360),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9362),
    [anon_sym_DASH] = ACTIONS(9360),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9360),
    [anon_sym_PERCENT] = ACTIONS(9360),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9364),
    [anon_sym_COLON_DASH] = ACTIONS(9360),
    [sym__special_character] = ACTIONS(599),
  },
  [4004] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9362),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4005] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4040),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4040),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9360),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9362),
    [anon_sym_DASH] = ACTIONS(9360),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9360),
    [anon_sym_PERCENT] = ACTIONS(9360),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9364),
    [anon_sym_COLON_DASH] = ACTIONS(9360),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9366),
  },
  [4006] = {
    [sym_process_substitution] = STATE(4042),
    [aux_sym__literal_repeat1] = STATE(4044),
    [sym_simple_expansion] = STATE(4042),
    [sym_string_expansion] = STATE(4042),
    [sym_expansion] = STATE(4042),
    [sym_concatenation] = STATE(4043),
    [sym_string] = STATE(4042),
    [sym_command_substitution] = STATE(4042),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [sym_word] = ACTIONS(9368),
    [sym_raw_string] = ACTIONS(9368),
    [anon_sym_LT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9362),
    [anon_sym_GT_LPAREN] = ACTIONS(1512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1516),
    [sym__special_character] = ACTIONS(1518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1520),
  },
  [4007] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4047),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4047),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9370),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9372),
    [anon_sym_DASH] = ACTIONS(9370),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9370),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9370),
    [anon_sym_PERCENT] = ACTIONS(9370),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9374),
    [anon_sym_COLON_DASH] = ACTIONS(9370),
    [sym__special_character] = ACTIONS(599),
    [sym_regex] = ACTIONS(9376),
  },
  [4008] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2602),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [sym_word] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_LT_AMP] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(2602),
    [anon_sym_LT_LT_DASH] = ACTIONS(2602),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LF] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [sym_raw_string] = ACTIONS(2602),
    [sym_variable_name] = ACTIONS(2604),
    [sym_file_descriptor] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP_GT] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_LT_LT_LT] = ACTIONS(2602),
    [anon_sym_GT_AMP] = ACTIONS(2602),
    [anon_sym_LT_LPAREN] = ACTIONS(2602),
    [anon_sym_esac] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_SEMI_SEMI] = ACTIONS(2602),
    [anon_sym_PIPE_AMP] = ACTIONS(2602),
  },
  [4009] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9372),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4010] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9362),
    [sym__concat] = ACTIONS(2610),
  },
  [4011] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9362),
  },
  [4012] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9378),
  },
  [4013] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [sym_word] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_LT_AMP] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2644),
    [sym__concat] = ACTIONS(2646),
    [sym__special_character] = ACTIONS(2644),
    [anon_sym_LT_LT_DASH] = ACTIONS(2644),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LF] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2644),
    [sym_variable_name] = ACTIONS(2646),
    [sym_file_descriptor] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_AMP_GT] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_LT_LT_LT] = ACTIONS(2644),
    [anon_sym_GT_AMP] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_esac] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_SEMI_SEMI] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2644),
  },
  [4014] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4050),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4050),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9380),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9382),
    [anon_sym_DASH] = ACTIONS(9380),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9380),
    [anon_sym_PERCENT] = ACTIONS(9380),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9384),
    [anon_sym_COLON_DASH] = ACTIONS(9380),
    [sym__special_character] = ACTIONS(599),
  },
  [4015] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9382),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4016] = {
    [sym_string] = STATE(1124),
    [anon_sym__] = ACTIONS(2231),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(6361),
    [anon_sym_LT_LT] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(6361),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_PIPE] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2231),
    [anon_sym_LT_LT_DASH] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2231),
    [anon_sym_LF] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2658),
    [sym_raw_string] = ACTIONS(6363),
    [sym_file_descriptor] = ACTIONS(2662),
    [anon_sym_0] = ACTIONS(2231),
    [anon_sym_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(6365),
    [anon_sym_LT_LT_LT] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_esac] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2231),
    [anon_sym_POUND] = ACTIONS(6361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_SEMI_SEMI] = ACTIONS(2658),
    [anon_sym_PIPE_AMP] = ACTIONS(2658),
  },
  [4017] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
    [anon_sym_SEMI_SEMI] = ACTIONS(3732),
  },
  [4018] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(9386),
    [anon_sym_SEMI] = ACTIONS(9388),
    [anon_sym_SEMI_SEMI] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(9388),
  },
  [4019] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_done] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [4020] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_done] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [4021] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_done] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [4022] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_done] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [4023] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [4024] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_fi] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [4025] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [anon_sym_esac] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [4026] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9390),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4027] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [anon_sym_esac] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [4028] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [anon_sym_esac] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [4029] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9392),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4030] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [anon_sym_esac] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [4031] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [anon_sym_esac] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [4032] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9394),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4033] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [anon_sym_esac] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [4034] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [anon_sym_esac] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [4035] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9396),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4036] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [anon_sym_esac] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [4037] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [anon_sym_EQ_TILDE] = ACTIONS(6451),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_EQ_EQ] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [anon_sym_esac] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [4038] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [anon_sym_EQ_TILDE] = ACTIONS(6455),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_EQ_EQ] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [anon_sym_esac] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [4039] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3830),
    [anon_sym_DOLLAR] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3830),
    [anon_sym_PIPE_PIPE] = ACTIONS(3830),
    [sym_word] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3830),
    [anon_sym_LT_AMP] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [sym__concat] = ACTIONS(3832),
    [sym__special_character] = ACTIONS(3830),
    [anon_sym_LT_LT_DASH] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3830),
    [anon_sym_LF] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3830),
    [sym_raw_string] = ACTIONS(3830),
    [sym_variable_name] = ACTIONS(3832),
    [sym_file_descriptor] = ACTIONS(3832),
    [anon_sym_GT] = ACTIONS(3830),
    [anon_sym_AMP_GT] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [anon_sym_LT_LT_LT] = ACTIONS(3830),
    [anon_sym_GT_AMP] = ACTIONS(3830),
    [anon_sym_LT_LPAREN] = ACTIONS(3830),
    [anon_sym_esac] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3830),
    [anon_sym_SEMI_SEMI] = ACTIONS(3830),
    [anon_sym_PIPE_AMP] = ACTIONS(3830),
  },
  [4040] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9398),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4041] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4057),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4057),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9400),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9398),
    [anon_sym_DASH] = ACTIONS(9400),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9400),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9400),
    [anon_sym_PERCENT] = ACTIONS(9400),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9402),
    [anon_sym_COLON_DASH] = ACTIONS(9400),
    [sym__special_character] = ACTIONS(599),
  },
  [4042] = {
    [aux_sym_concatenation_repeat1] = STATE(1239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9398),
    [sym__concat] = ACTIONS(2610),
  },
  [4043] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(9398),
  },
  [4044] = {
    [aux_sym__literal_repeat1] = STATE(1252),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(9404),
  },
  [4045] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(3879),
    [anon_sym_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3879),
    [anon_sym_PIPE_PIPE] = ACTIONS(3879),
    [sym_word] = ACTIONS(3879),
    [anon_sym_PIPE] = ACTIONS(3879),
    [anon_sym_AMP] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3879),
    [anon_sym_LT_AMP] = ACTIONS(3879),
    [anon_sym_GT_GT] = ACTIONS(3879),
    [sym__concat] = ACTIONS(3881),
    [sym__special_character] = ACTIONS(3879),
    [anon_sym_LT_LT_DASH] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LF] = ACTIONS(3881),
    [anon_sym_SEMI] = ACTIONS(3879),
    [sym_raw_string] = ACTIONS(3879),
    [sym_variable_name] = ACTIONS(3881),
    [sym_file_descriptor] = ACTIONS(3881),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_AMP_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LT_LT] = ACTIONS(3879),
    [anon_sym_GT_AMP] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(3879),
    [anon_sym_esac] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3879),
    [anon_sym_SEMI_SEMI] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(3879),
  },
  [4046] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(4060),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(4060),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(9406),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9408),
    [anon_sym_DASH] = ACTIONS(9406),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(9406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(9406),
    [anon_sym_PERCENT] = ACTIONS(9406),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(9410),
    [anon_sym_COLON_DASH] = ACTIONS(9406),
    [sym__special_character] = ACTIONS(599),
  },
  [4047] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9408),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4048] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3927),
    [anon_sym_DOLLAR] = ACTIONS(3927),
    [anon_sym_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3927),
    [anon_sym_PIPE_PIPE] = ACTIONS(3927),
    [sym_word] = ACTIONS(3927),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_LT_AMP] = ACTIONS(3927),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [sym__concat] = ACTIONS(3929),
    [sym__special_character] = ACTIONS(3927),
    [anon_sym_LT_LT_DASH] = ACTIONS(3927),
    [anon_sym_BQUOTE] = ACTIONS(3927),
    [anon_sym_LF] = ACTIONS(3929),
    [anon_sym_SEMI] = ACTIONS(3927),
    [sym_raw_string] = ACTIONS(3927),
    [sym_variable_name] = ACTIONS(3929),
    [sym_file_descriptor] = ACTIONS(3929),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_AMP_GT] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(3927),
    [anon_sym_LT_LT_LT] = ACTIONS(3927),
    [anon_sym_GT_AMP] = ACTIONS(3927),
    [anon_sym_LT_LPAREN] = ACTIONS(3927),
    [anon_sym_esac] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3927),
    [anon_sym_SEMI_SEMI] = ACTIONS(3927),
    [anon_sym_PIPE_AMP] = ACTIONS(3927),
  },
  [4049] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3946),
    [anon_sym_DOLLAR] = ACTIONS(3946),
    [anon_sym_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3946),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3946),
    [anon_sym_PIPE_PIPE] = ACTIONS(3946),
    [sym_word] = ACTIONS(3946),
    [anon_sym_PIPE] = ACTIONS(3946),
    [anon_sym_AMP] = ACTIONS(3946),
    [anon_sym_LT] = ACTIONS(3946),
    [anon_sym_LT_AMP] = ACTIONS(3946),
    [anon_sym_GT_GT] = ACTIONS(3946),
    [sym__concat] = ACTIONS(3948),
    [sym__special_character] = ACTIONS(3946),
    [anon_sym_LT_LT_DASH] = ACTIONS(3946),
    [anon_sym_BQUOTE] = ACTIONS(3946),
    [anon_sym_LF] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3946),
    [sym_raw_string] = ACTIONS(3946),
    [sym_variable_name] = ACTIONS(3948),
    [sym_file_descriptor] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3946),
    [anon_sym_AMP_GT] = ACTIONS(3946),
    [anon_sym_DQUOTE] = ACTIONS(3946),
    [anon_sym_LT_LT_LT] = ACTIONS(3946),
    [anon_sym_GT_AMP] = ACTIONS(3946),
    [anon_sym_LT_LPAREN] = ACTIONS(3946),
    [anon_sym_esac] = ACTIONS(3946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3946),
    [anon_sym_SEMI_SEMI] = ACTIONS(3946),
    [anon_sym_PIPE_AMP] = ACTIONS(3946),
  },
  [4050] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9412),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4051] = {
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_AMP_GT_GT] = ACTIONS(3730),
    [anon_sym_local] = ACTIONS(3728),
    [anon_sym_typeset] = ACTIONS(3728),
    [anon_sym_unsetenv] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3728),
    [anon_sym_GT_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3730),
    [anon_sym_function] = ACTIONS(3728),
    [sym_word] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3728),
    [anon_sym_LT_AMP] = ACTIONS(3730),
    [anon_sym_GT_GT] = ACTIONS(3730),
    [anon_sym_export] = ACTIONS(3728),
    [sym__special_character] = ACTIONS(3728),
    [anon_sym_if] = ACTIONS(3728),
    [anon_sym_case] = ACTIONS(3728),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(3730),
    [sym_raw_string] = ACTIONS(3730),
    [anon_sym_BQUOTE] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(3728),
    [anon_sym_declare] = ACTIONS(3728),
    [sym_variable_name] = ACTIONS(3730),
    [sym_file_descriptor] = ACTIONS(3730),
    [anon_sym_GT] = ACTIONS(3728),
    [anon_sym_AMP_GT] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_unset] = ACTIONS(3728),
    [anon_sym_DQUOTE] = ACTIONS(3730),
    [anon_sym_GT_AMP] = ACTIONS(3730),
    [anon_sym_LT_LPAREN] = ACTIONS(3730),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3730),
    [anon_sym_SEMI_SEMI] = ACTIONS(5041),
  },
  [4052] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [anon_sym_esac] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [4053] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [anon_sym_esac] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [4054] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [anon_sym_esac] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [4055] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [anon_sym_esac] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
  [4056] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5095),
    [anon_sym_DOLLAR] = ACTIONS(5095),
    [anon_sym_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5095),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5095),
    [anon_sym_PIPE_PIPE] = ACTIONS(5095),
    [sym_word] = ACTIONS(5095),
    [anon_sym_PIPE] = ACTIONS(5095),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(5095),
    [anon_sym_LT_AMP] = ACTIONS(5095),
    [anon_sym_GT_GT] = ACTIONS(5095),
    [sym__concat] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(5095),
    [anon_sym_LT_LT_DASH] = ACTIONS(5095),
    [anon_sym_BQUOTE] = ACTIONS(5095),
    [anon_sym_LF] = ACTIONS(5097),
    [anon_sym_SEMI] = ACTIONS(5095),
    [sym_raw_string] = ACTIONS(5095),
    [sym_variable_name] = ACTIONS(5097),
    [sym_file_descriptor] = ACTIONS(5097),
    [anon_sym_GT] = ACTIONS(5095),
    [anon_sym_AMP_GT] = ACTIONS(5095),
    [anon_sym_DQUOTE] = ACTIONS(5095),
    [anon_sym_LT_LT_LT] = ACTIONS(5095),
    [anon_sym_GT_AMP] = ACTIONS(5095),
    [anon_sym_LT_LPAREN] = ACTIONS(5095),
    [anon_sym_esac] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5095),
    [anon_sym_SEMI_SEMI] = ACTIONS(5095),
    [anon_sym_PIPE_AMP] = ACTIONS(5095),
  },
  [4057] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9414),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4058] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(5129),
    [anon_sym_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5129),
    [anon_sym_PIPE_PIPE] = ACTIONS(5129),
    [sym_word] = ACTIONS(5129),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5129),
    [anon_sym_LT] = ACTIONS(5129),
    [anon_sym_LT_AMP] = ACTIONS(5129),
    [anon_sym_GT_GT] = ACTIONS(5129),
    [sym__concat] = ACTIONS(5131),
    [sym__special_character] = ACTIONS(5129),
    [anon_sym_LT_LT_DASH] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [anon_sym_LF] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_raw_string] = ACTIONS(5129),
    [sym_variable_name] = ACTIONS(5131),
    [sym_file_descriptor] = ACTIONS(5131),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_AMP_GT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(5129),
    [anon_sym_LT_LT_LT] = ACTIONS(5129),
    [anon_sym_GT_AMP] = ACTIONS(5129),
    [anon_sym_LT_LPAREN] = ACTIONS(5129),
    [anon_sym_esac] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_SEMI_SEMI] = ACTIONS(5129),
    [anon_sym_PIPE_AMP] = ACTIONS(5129),
  },
  [4059] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [anon_sym_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5133),
    [anon_sym_PIPE_PIPE] = ACTIONS(5133),
    [sym_word] = ACTIONS(5133),
    [anon_sym_PIPE] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5133),
    [anon_sym_LT] = ACTIONS(5133),
    [anon_sym_LT_AMP] = ACTIONS(5133),
    [anon_sym_GT_GT] = ACTIONS(5133),
    [sym__concat] = ACTIONS(5135),
    [sym__special_character] = ACTIONS(5133),
    [anon_sym_LT_LT_DASH] = ACTIONS(5133),
    [anon_sym_BQUOTE] = ACTIONS(5133),
    [anon_sym_LF] = ACTIONS(5135),
    [anon_sym_SEMI] = ACTIONS(5133),
    [sym_raw_string] = ACTIONS(5133),
    [sym_variable_name] = ACTIONS(5135),
    [sym_file_descriptor] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5133),
    [anon_sym_AMP_GT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(5133),
    [anon_sym_LT_LT_LT] = ACTIONS(5133),
    [anon_sym_GT_AMP] = ACTIONS(5133),
    [anon_sym_LT_LPAREN] = ACTIONS(5133),
    [anon_sym_esac] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_SEMI_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_AMP] = ACTIONS(5133),
  },
  [4060] = {
    [sym_process_substitution] = STATE(323),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_simple_expansion] = STATE(323),
    [aux_sym_expansion_repeat1] = STATE(725),
    [sym_string_expansion] = STATE(323),
    [sym_expansion] = STATE(323),
    [sym_concatenation] = STATE(725),
    [sym_string] = STATE(323),
    [sym_command_substitution] = STATE(323),
    [anon_sym_BQUOTE] = ACTIONS(575),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_COLON_QMARK] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(9416),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_GT_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(589),
    [anon_sym_EQ] = ACTIONS(1484),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(591),
    [anon_sym_COLON] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(593),
    [sym_word] = ACTIONS(595),
    [anon_sym_LT_LPAREN] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_COLON_DASH] = ACTIONS(1484),
    [sym__special_character] = ACTIONS(599),
  },
  [4061] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5184),
    [anon_sym_DOLLAR] = ACTIONS(5184),
    [anon_sym_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5184),
    [anon_sym_PIPE_PIPE] = ACTIONS(5184),
    [sym_word] = ACTIONS(5184),
    [anon_sym_PIPE] = ACTIONS(5184),
    [anon_sym_AMP] = ACTIONS(5184),
    [anon_sym_LT] = ACTIONS(5184),
    [anon_sym_LT_AMP] = ACTIONS(5184),
    [anon_sym_GT_GT] = ACTIONS(5184),
    [sym__concat] = ACTIONS(5186),
    [sym__special_character] = ACTIONS(5184),
    [anon_sym_LT_LT_DASH] = ACTIONS(5184),
    [anon_sym_BQUOTE] = ACTIONS(5184),
    [anon_sym_LF] = ACTIONS(5186),
    [anon_sym_SEMI] = ACTIONS(5184),
    [sym_raw_string] = ACTIONS(5184),
    [sym_variable_name] = ACTIONS(5186),
    [sym_file_descriptor] = ACTIONS(5186),
    [anon_sym_GT] = ACTIONS(5184),
    [anon_sym_AMP_GT] = ACTIONS(5184),
    [anon_sym_DQUOTE] = ACTIONS(5184),
    [anon_sym_LT_LT_LT] = ACTIONS(5184),
    [anon_sym_GT_AMP] = ACTIONS(5184),
    [anon_sym_LT_LPAREN] = ACTIONS(5184),
    [anon_sym_esac] = ACTIONS(5184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(5184),
    [anon_sym_SEMI_SEMI] = ACTIONS(5184),
    [anon_sym_PIPE_AMP] = ACTIONS(5184),
  },
  [4062] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6451),
    [anon_sym_DOLLAR] = ACTIONS(6451),
    [anon_sym_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6451),
    [anon_sym_PIPE_PIPE] = ACTIONS(6451),
    [sym_word] = ACTIONS(6451),
    [anon_sym_PIPE] = ACTIONS(6451),
    [anon_sym_AMP] = ACTIONS(6451),
    [anon_sym_LT] = ACTIONS(6451),
    [anon_sym_LT_AMP] = ACTIONS(6451),
    [anon_sym_GT_GT] = ACTIONS(6451),
    [sym__concat] = ACTIONS(6453),
    [sym__special_character] = ACTIONS(6451),
    [anon_sym_LT_LT_DASH] = ACTIONS(6451),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_SEMI] = ACTIONS(6451),
    [sym_raw_string] = ACTIONS(6451),
    [sym_variable_name] = ACTIONS(6453),
    [sym_file_descriptor] = ACTIONS(6453),
    [anon_sym_GT] = ACTIONS(6451),
    [anon_sym_AMP_GT] = ACTIONS(6451),
    [anon_sym_DQUOTE] = ACTIONS(6451),
    [anon_sym_LT_LT_LT] = ACTIONS(6451),
    [anon_sym_GT_AMP] = ACTIONS(6451),
    [anon_sym_LT_LPAREN] = ACTIONS(6451),
    [anon_sym_esac] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6451),
    [anon_sym_SEMI_SEMI] = ACTIONS(6451),
    [anon_sym_PIPE_AMP] = ACTIONS(6451),
  },
  [4063] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(6455),
    [anon_sym_DOLLAR] = ACTIONS(6455),
    [anon_sym_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6455),
    [anon_sym_PIPE_PIPE] = ACTIONS(6455),
    [sym_word] = ACTIONS(6455),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym_LT] = ACTIONS(6455),
    [anon_sym_LT_AMP] = ACTIONS(6455),
    [anon_sym_GT_GT] = ACTIONS(6455),
    [sym__concat] = ACTIONS(6457),
    [sym__special_character] = ACTIONS(6455),
    [anon_sym_LT_LT_DASH] = ACTIONS(6455),
    [anon_sym_BQUOTE] = ACTIONS(6455),
    [anon_sym_LF] = ACTIONS(6457),
    [anon_sym_SEMI] = ACTIONS(6455),
    [sym_raw_string] = ACTIONS(6455),
    [sym_variable_name] = ACTIONS(6457),
    [sym_file_descriptor] = ACTIONS(6457),
    [anon_sym_GT] = ACTIONS(6455),
    [anon_sym_AMP_GT] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6455),
    [anon_sym_LT_LT_LT] = ACTIONS(6455),
    [anon_sym_GT_AMP] = ACTIONS(6455),
    [anon_sym_LT_LPAREN] = ACTIONS(6455),
    [anon_sym_esac] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(6455),
    [anon_sym_SEMI_SEMI] = ACTIONS(6455),
    [anon_sym_PIPE_AMP] = ACTIONS(6455),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = false}, SHIFT(4),
  [11] = {.count = 1, .reusable = false}, SHIFT(5),
  [13] = {.count = 1, .reusable = false}, SHIFT(6),
  [15] = {.count = 1, .reusable = true}, SHIFT(7),
  [17] = {.count = 1, .reusable = true}, SHIFT(8),
  [19] = {.count = 1, .reusable = true}, SHIFT(9),
  [21] = {.count = 1, .reusable = false}, SHIFT(10),
  [23] = {.count = 1, .reusable = false}, SHIFT(11),
  [25] = {.count = 1, .reusable = true}, SHIFT(12),
  [27] = {.count = 1, .reusable = false}, SHIFT(3),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = true}, SHIFT(16),
  [37] = {.count = 1, .reusable = true}, SHIFT(17),
  [39] = {.count = 1, .reusable = true}, SHIFT(18),
  [41] = {.count = 1, .reusable = false}, SHIFT(19),
  [43] = {.count = 1, .reusable = true}, SHIFT(20),
  [45] = {.count = 1, .reusable = true}, SHIFT(21),
  [47] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [53] = {.count = 1, .reusable = false}, SHIFT(23),
  [55] = {.count = 1, .reusable = false}, SHIFT(24),
  [57] = {.count = 1, .reusable = false}, SHIFT(25),
  [59] = {.count = 1, .reusable = true}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(37),
  [63] = {.count = 1, .reusable = false}, SHIFT(38),
  [65] = {.count = 1, .reusable = false}, SHIFT(39),
  [67] = {.count = 1, .reusable = false}, SHIFT(40),
  [69] = {.count = 1, .reusable = true}, SHIFT(41),
  [71] = {.count = 1, .reusable = false}, SHIFT(42),
  [73] = {.count = 1, .reusable = true}, SHIFT(43),
  [75] = {.count = 1, .reusable = true}, SHIFT(52),
  [77] = {.count = 1, .reusable = true}, SHIFT(53),
  [79] = {.count = 1, .reusable = true}, SHIFT(54),
  [81] = {.count = 1, .reusable = true}, SHIFT(55),
  [83] = {.count = 1, .reusable = false}, SHIFT(56),
  [85] = {.count = 1, .reusable = true}, SHIFT(57),
  [87] = {.count = 1, .reusable = true}, SHIFT(58),
  [89] = {.count = 1, .reusable = true}, SHIFT(59),
  [91] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [93] = {.count = 1, .reusable = false}, SHIFT(67),
  [95] = {.count = 1, .reusable = false}, SHIFT(65),
  [97] = {.count = 1, .reusable = false}, SHIFT(68),
  [99] = {.count = 1, .reusable = false}, SHIFT(72),
  [101] = {.count = 1, .reusable = false}, SHIFT(70),
  [103] = {.count = 1, .reusable = false}, SHIFT(64),
  [105] = {.count = 1, .reusable = false}, SHIFT(69),
  [107] = {.count = 1, .reusable = false}, SHIFT(62),
  [109] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [111] = {.count = 1, .reusable = true}, SHIFT(66),
  [113] = {.count = 1, .reusable = false}, SHIFT(63),
  [115] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [117] = {.count = 1, .reusable = false}, SHIFT(78),
  [119] = {.count = 1, .reusable = false}, SHIFT(77),
  [121] = {.count = 1, .reusable = false}, SHIFT(79),
  [123] = {.count = 1, .reusable = false}, SHIFT(83),
  [125] = {.count = 1, .reusable = false}, SHIFT(81),
  [127] = {.count = 1, .reusable = false}, SHIFT(76),
  [129] = {.count = 1, .reusable = false}, SHIFT(80),
  [131] = {.count = 1, .reusable = false}, SHIFT(74),
  [133] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [135] = {.count = 1, .reusable = false}, SHIFT(75),
  [137] = {.count = 1, .reusable = true}, SHIFT(84),
  [139] = {.count = 1, .reusable = true}, SHIFT(85),
  [141] = {.count = 1, .reusable = true}, SHIFT(86),
  [143] = {.count = 1, .reusable = false}, SHIFT(84),
  [145] = {.count = 1, .reusable = true}, SHIFT(88),
  [147] = {.count = 1, .reusable = false}, SHIFT(88),
  [149] = {.count = 1, .reusable = true}, SHIFT(89),
  [151] = {.count = 1, .reusable = true}, SHIFT(92),
  [153] = {.count = 1, .reusable = true}, SHIFT(93),
  [155] = {.count = 1, .reusable = true}, SHIFT(94),
  [157] = {.count = 1, .reusable = true}, SHIFT(95),
  [159] = {.count = 1, .reusable = false}, SHIFT(92),
  [161] = {.count = 1, .reusable = true}, SHIFT(96),
  [163] = {.count = 1, .reusable = false}, SHIFT(97),
  [165] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [167] = {.count = 1, .reusable = true}, SHIFT(98),
  [169] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [171] = {.count = 1, .reusable = false}, SHIFT(100),
  [173] = {.count = 1, .reusable = false}, SHIFT(101),
  [175] = {.count = 1, .reusable = false}, SHIFT(102),
  [177] = {.count = 1, .reusable = false}, SHIFT(103),
  [179] = {.count = 1, .reusable = true}, SHIFT(104),
  [181] = {.count = 1, .reusable = true}, SHIFT(105),
  [183] = {.count = 1, .reusable = true}, SHIFT(106),
  [185] = {.count = 1, .reusable = false}, SHIFT(107),
  [187] = {.count = 1, .reusable = false}, SHIFT(108),
  [189] = {.count = 1, .reusable = true}, SHIFT(109),
  [191] = {.count = 1, .reusable = false}, SHIFT(110),
  [193] = {.count = 1, .reusable = false}, SHIFT(111),
  [195] = {.count = 1, .reusable = false}, SHIFT(112),
  [197] = {.count = 1, .reusable = true}, SHIFT(113),
  [199] = {.count = 1, .reusable = true}, SHIFT(114),
  [201] = {.count = 1, .reusable = true}, SHIFT(115),
  [203] = {.count = 1, .reusable = false}, SHIFT(116),
  [205] = {.count = 1, .reusable = true}, SHIFT(117),
  [207] = {.count = 1, .reusable = true}, SHIFT(118),
  [209] = {.count = 1, .reusable = true}, SHIFT(119),
  [211] = {.count = 1, .reusable = false}, SHIFT(120),
  [213] = {.count = 1, .reusable = false}, SHIFT(121),
  [215] = {.count = 1, .reusable = false}, SHIFT(122),
  [217] = {.count = 1, .reusable = true}, SHIFT(123),
  [219] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 1),
  [221] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 1),
  [223] = {.count = 1, .reusable = false}, SHIFT(133),
  [225] = {.count = 1, .reusable = false}, SHIFT(134),
  [227] = {.count = 1, .reusable = false}, SHIFT(135),
  [229] = {.count = 1, .reusable = false}, SHIFT(136),
  [231] = {.count = 1, .reusable = true}, SHIFT(137),
  [233] = {.count = 1, .reusable = false}, SHIFT(138),
  [235] = {.count = 1, .reusable = true}, SHIFT(139),
  [237] = {.count = 1, .reusable = true}, SHIFT(147),
  [239] = {.count = 1, .reusable = true}, SHIFT(148),
  [241] = {.count = 1, .reusable = true}, SHIFT(149),
  [243] = {.count = 1, .reusable = true}, SHIFT(150),
  [245] = {.count = 1, .reusable = false}, SHIFT(151),
  [247] = {.count = 1, .reusable = true}, SHIFT(152),
  [249] = {.count = 1, .reusable = true}, SHIFT(153),
  [251] = {.count = 1, .reusable = true}, SHIFT(154),
  [253] = {.count = 1, .reusable = true}, SHIFT(157),
  [255] = {.count = 1, .reusable = true}, SHIFT(158),
  [257] = {.count = 1, .reusable = true}, SHIFT(159),
  [259] = {.count = 1, .reusable = false}, SHIFT(160),
  [261] = {.count = 1, .reusable = true}, SHIFT(160),
  [263] = {.count = 1, .reusable = true}, SHIFT(161),
  [265] = {.count = 1, .reusable = false}, SHIFT(157),
  [267] = {.count = 1, .reusable = true}, SHIFT(162),
  [269] = {.count = 1, .reusable = false}, SHIFT(163),
  [271] = {.count = 1, .reusable = true}, SHIFT(164),
  [273] = {.count = 1, .reusable = true}, SHIFT(165),
  [275] = {.count = 1, .reusable = true}, SHIFT(166),
  [277] = {.count = 1, .reusable = false}, SHIFT(169),
  [279] = {.count = 1, .reusable = false}, SHIFT(170),
  [281] = {.count = 1, .reusable = false}, SHIFT(171),
  [283] = {.count = 1, .reusable = true}, SHIFT(178),
  [285] = {.count = 1, .reusable = true}, SHIFT(181),
  [287] = {.count = 1, .reusable = true}, SHIFT(182),
  [289] = {.count = 1, .reusable = true}, SHIFT(183),
  [291] = {.count = 1, .reusable = false}, SHIFT(183),
  [293] = {.count = 1, .reusable = false}, SHIFT(184),
  [295] = {.count = 1, .reusable = true}, SHIFT(185),
  [297] = {.count = 1, .reusable = true}, SHIFT(186),
  [299] = {.count = 1, .reusable = true}, SHIFT(187),
  [301] = {.count = 1, .reusable = true}, SHIFT(188),
  [303] = {.count = 1, .reusable = false}, SHIFT(189),
  [305] = {.count = 1, .reusable = true}, SHIFT(191),
  [307] = {.count = 1, .reusable = true}, SHIFT(192),
  [309] = {.count = 1, .reusable = true}, SHIFT(194),
  [311] = {.count = 1, .reusable = true}, SHIFT(195),
  [313] = {.count = 1, .reusable = true}, SHIFT(196),
  [315] = {.count = 1, .reusable = false}, SHIFT(197),
  [317] = {.count = 1, .reusable = true}, SHIFT(197),
  [319] = {.count = 1, .reusable = true}, SHIFT(198),
  [321] = {.count = 1, .reusable = false}, SHIFT(194),
  [323] = {.count = 1, .reusable = true}, SHIFT(199),
  [325] = {.count = 1, .reusable = false}, SHIFT(200),
  [327] = {.count = 1, .reusable = true}, SHIFT(201),
  [329] = {.count = 1, .reusable = true}, SHIFT(202),
  [331] = {.count = 1, .reusable = true}, SHIFT(203),
  [333] = {.count = 1, .reusable = true}, SHIFT(206),
  [335] = {.count = 1, .reusable = false}, SHIFT(207),
  [337] = {.count = 1, .reusable = true}, SHIFT(207),
  [339] = {.count = 1, .reusable = false}, SHIFT(206),
  [341] = {.count = 1, .reusable = true}, SHIFT(208),
  [343] = {.count = 1, .reusable = false}, SHIFT(214),
  [345] = {.count = 1, .reusable = false}, SHIFT(212),
  [347] = {.count = 1, .reusable = true}, SHIFT(213),
  [349] = {.count = 1, .reusable = true}, SHIFT(215),
  [351] = {.count = 1, .reusable = false}, SHIFT(216),
  [353] = {.count = 1, .reusable = false}, SHIFT(217),
  [355] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [357] = {.count = 1, .reusable = false}, SHIFT(218),
  [359] = {.count = 1, .reusable = false}, SHIFT(211),
  [361] = {.count = 1, .reusable = true}, SHIFT(13),
  [363] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [365] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [367] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [369] = {.count = 1, .reusable = false}, SHIFT(7),
  [371] = {.count = 1, .reusable = false}, SHIFT(8),
  [373] = {.count = 1, .reusable = false}, SHIFT(9),
  [375] = {.count = 1, .reusable = false}, SHIFT(222),
  [377] = {.count = 1, .reusable = false}, SHIFT(223),
  [379] = {.count = 1, .reusable = false}, SHIFT(18),
  [381] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [383] = {.count = 1, .reusable = false}, SHIFT(22),
  [385] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [387] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [389] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [391] = {.count = 1, .reusable = false}, SHIFT(229),
  [393] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [395] = {.count = 1, .reusable = false}, SHIFT(235),
  [397] = {.count = 1, .reusable = false}, SHIFT(231),
  [399] = {.count = 1, .reusable = false}, SHIFT(233),
  [401] = {.count = 1, .reusable = true}, SHIFT(232),
  [403] = {.count = 1, .reusable = false}, SHIFT(240),
  [405] = {.count = 1, .reusable = false}, SHIFT(237),
  [407] = {.count = 1, .reusable = false}, SHIFT(238),
  [409] = {.count = 1, .reusable = true}, SHIFT(242),
  [411] = {.count = 1, .reusable = false}, SHIFT(244),
  [413] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [415] = {.count = 1, .reusable = true}, SHIFT(245),
  [417] = {.count = 1, .reusable = false}, SHIFT(246),
  [419] = {.count = 1, .reusable = false}, SHIFT(247),
  [421] = {.count = 1, .reusable = false}, SHIFT(243),
  [423] = {.count = 1, .reusable = true}, SHIFT(40),
  [425] = {.count = 1, .reusable = true}, SHIFT(250),
  [427] = {.count = 1, .reusable = false}, SHIFT(251),
  [429] = {.count = 1, .reusable = false}, SHIFT(252),
  [431] = {.count = 1, .reusable = false}, SHIFT(259),
  [433] = {.count = 1, .reusable = true}, SHIFT(260),
  [435] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [437] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [439] = {.count = 1, .reusable = true}, SHIFT(262),
  [441] = {.count = 1, .reusable = true}, SHIFT(265),
  [443] = {.count = 1, .reusable = true}, SHIFT(266),
  [445] = {.count = 1, .reusable = true}, SHIFT(267),
  [447] = {.count = 1, .reusable = false}, SHIFT(265),
  [449] = {.count = 1, .reusable = true}, SHIFT(270),
  [451] = {.count = 1, .reusable = true}, SHIFT(271),
  [453] = {.count = 1, .reusable = true}, SHIFT(272),
  [455] = {.count = 1, .reusable = true}, SHIFT(273),
  [457] = {.count = 1, .reusable = false}, SHIFT(270),
  [459] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [461] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [463] = {.count = 1, .reusable = true}, SHIFT(274),
  [465] = {.count = 1, .reusable = false}, SHIFT(277),
  [467] = {.count = 1, .reusable = true}, SHIFT(278),
  [469] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [471] = {.count = 1, .reusable = true}, SHIFT(280),
  [473] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [475] = {.count = 1, .reusable = true}, SHIFT(283),
  [477] = {.count = 1, .reusable = true}, SHIFT(63),
  [479] = {.count = 1, .reusable = true}, SHIFT(284),
  [481] = {.count = 1, .reusable = true}, SHIFT(285),
  [483] = {.count = 1, .reusable = true}, SHIFT(286),
  [485] = {.count = 1, .reusable = false}, SHIFT(284),
  [487] = {.count = 1, .reusable = true}, SHIFT(289),
  [489] = {.count = 1, .reusable = true}, SHIFT(290),
  [491] = {.count = 1, .reusable = true}, SHIFT(291),
  [493] = {.count = 1, .reusable = true}, SHIFT(292),
  [495] = {.count = 1, .reusable = false}, SHIFT(289),
  [497] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [499] = {.count = 1, .reusable = false}, SHIFT(293),
  [501] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [503] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [505] = {.count = 1, .reusable = false}, SHIFT(295),
  [507] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [509] = {.count = 1, .reusable = false}, SHIFT(297),
  [511] = {.count = 1, .reusable = true}, SHIFT(298),
  [513] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [515] = {.count = 1, .reusable = true}, SHIFT(300),
  [517] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [519] = {.count = 1, .reusable = true}, SHIFT(75),
  [521] = {.count = 1, .reusable = true}, SHIFT(303),
  [523] = {.count = 1, .reusable = true}, SHIFT(304),
  [525] = {.count = 1, .reusable = true}, SHIFT(305),
  [527] = {.count = 1, .reusable = false}, SHIFT(303),
  [529] = {.count = 1, .reusable = true}, SHIFT(308),
  [531] = {.count = 1, .reusable = true}, SHIFT(309),
  [533] = {.count = 1, .reusable = true}, SHIFT(310),
  [535] = {.count = 1, .reusable = true}, SHIFT(311),
  [537] = {.count = 1, .reusable = false}, SHIFT(308),
  [539] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [541] = {.count = 1, .reusable = false}, SHIFT(312),
  [543] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [545] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [547] = {.count = 1, .reusable = false}, SHIFT(314),
  [549] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [551] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2),
  [553] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2),
  [555] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [557] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [559] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [561] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [563] = {.count = 1, .reusable = true}, SHIFT(315),
  [565] = {.count = 1, .reusable = true}, SHIFT(316),
  [567] = {.count = 1, .reusable = true}, SHIFT(317),
  [569] = {.count = 1, .reusable = true}, SHIFT(319),
  [571] = {.count = 1, .reusable = false}, SHIFT(319),
  [573] = {.count = 1, .reusable = true}, SHIFT(320),
  [575] = {.count = 1, .reusable = true}, SHIFT(321),
  [577] = {.count = 1, .reusable = true}, SHIFT(322),
  [579] = {.count = 1, .reusable = true}, SHIFT(323),
  [581] = {.count = 1, .reusable = false}, SHIFT(331),
  [583] = {.count = 1, .reusable = false}, SHIFT(324),
  [585] = {.count = 1, .reusable = true}, SHIFT(328),
  [587] = {.count = 1, .reusable = true}, SHIFT(325),
  [589] = {.count = 1, .reusable = true}, SHIFT(326),
  [591] = {.count = 1, .reusable = true}, SHIFT(327),
  [593] = {.count = 1, .reusable = true}, SHIFT(329),
  [595] = {.count = 1, .reusable = false}, SHIFT(323),
  [597] = {.count = 1, .reusable = true}, SHIFT(331),
  [599] = {.count = 1, .reusable = false}, SHIFT(330),
  [601] = {.count = 1, .reusable = true}, SHIFT(333),
  [603] = {.count = 1, .reusable = true}, SHIFT(334),
  [605] = {.count = 1, .reusable = true}, SHIFT(335),
  [607] = {.count = 1, .reusable = false}, SHIFT(333),
  [609] = {.count = 1, .reusable = true}, SHIFT(336),
  [611] = {.count = 1, .reusable = true}, SHIFT(337),
  [613] = {.count = 1, .reusable = true}, SHIFT(338),
  [615] = {.count = 1, .reusable = false}, SHIFT(340),
  [617] = {.count = 1, .reusable = true}, SHIFT(339),
  [619] = {.count = 1, .reusable = true}, SHIFT(340),
  [621] = {.count = 1, .reusable = true}, SHIFT(341),
  [623] = {.count = 1, .reusable = true}, SHIFT(343),
  [625] = {.count = 1, .reusable = true}, SHIFT(344),
  [627] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [629] = {.count = 1, .reusable = true}, SHIFT(345),
  [631] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [633] = {.count = 1, .reusable = false}, SHIFT(353),
  [635] = {.count = 1, .reusable = false}, SHIFT(351),
  [637] = {.count = 1, .reusable = false}, SHIFT(354),
  [639] = {.count = 1, .reusable = false}, SHIFT(358),
  [641] = {.count = 1, .reusable = false}, SHIFT(356),
  [643] = {.count = 1, .reusable = false}, SHIFT(350),
  [645] = {.count = 1, .reusable = false}, SHIFT(355),
  [647] = {.count = 1, .reusable = false}, SHIFT(348),
  [649] = {.count = 1, .reusable = true}, SHIFT(352),
  [651] = {.count = 1, .reusable = false}, SHIFT(349),
  [653] = {.count = 1, .reusable = false}, SHIFT(364),
  [655] = {.count = 1, .reusable = false}, SHIFT(363),
  [657] = {.count = 1, .reusable = false}, SHIFT(365),
  [659] = {.count = 1, .reusable = false}, SHIFT(369),
  [661] = {.count = 1, .reusable = false}, SHIFT(367),
  [663] = {.count = 1, .reusable = false}, SHIFT(362),
  [665] = {.count = 1, .reusable = false}, SHIFT(366),
  [667] = {.count = 1, .reusable = false}, SHIFT(360),
  [669] = {.count = 1, .reusable = false}, SHIFT(361),
  [671] = {.count = 1, .reusable = true}, SHIFT(370),
  [673] = {.count = 1, .reusable = true}, SHIFT(371),
  [675] = {.count = 1, .reusable = true}, SHIFT(372),
  [677] = {.count = 1, .reusable = false}, SHIFT(370),
  [679] = {.count = 1, .reusable = true}, SHIFT(376),
  [681] = {.count = 1, .reusable = true}, SHIFT(377),
  [683] = {.count = 1, .reusable = true}, SHIFT(378),
  [685] = {.count = 1, .reusable = true}, SHIFT(379),
  [687] = {.count = 1, .reusable = false}, SHIFT(376),
  [689] = {.count = 1, .reusable = true}, SHIFT(380),
  [691] = {.count = 1, .reusable = false}, SHIFT(381),
  [693] = {.count = 1, .reusable = true}, SHIFT(382),
  [695] = {.count = 1, .reusable = true}, SHIFT(384),
  [697] = {.count = 1, .reusable = true}, SHIFT(387),
  [699] = {.count = 1, .reusable = true}, SHIFT(393),
  [701] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [703] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [705] = {.count = 1, .reusable = false}, SHIFT(394),
  [707] = {.count = 1, .reusable = true}, SHIFT(395),
  [709] = {.count = 1, .reusable = true}, SHIFT(397),
  [711] = {.count = 1, .reusable = true}, SHIFT(398),
  [713] = {.count = 1, .reusable = false}, SHIFT(405),
  [715] = {.count = 1, .reusable = false}, SHIFT(403),
  [717] = {.count = 1, .reusable = true}, SHIFT(404),
  [719] = {.count = 1, .reusable = true}, SHIFT(406),
  [721] = {.count = 1, .reusable = false}, SHIFT(407),
  [723] = {.count = 1, .reusable = false}, SHIFT(408),
  [725] = {.count = 1, .reusable = false}, SHIFT(409),
  [727] = {.count = 1, .reusable = false}, SHIFT(402),
  [729] = {.count = 1, .reusable = true}, SHIFT(110),
  [731] = {.count = 1, .reusable = true}, SHIFT(412),
  [733] = {.count = 1, .reusable = false}, SHIFT(104),
  [735] = {.count = 1, .reusable = false}, SHIFT(105),
  [737] = {.count = 1, .reusable = false}, SHIFT(106),
  [739] = {.count = 1, .reusable = false}, SHIFT(413),
  [741] = {.count = 1, .reusable = false}, SHIFT(414),
  [743] = {.count = 1, .reusable = false}, SHIFT(115),
  [745] = {.count = 1, .reusable = false}, SHIFT(119),
  [747] = {.count = 1, .reusable = false}, SHIFT(419),
  [749] = {.count = 1, .reusable = false}, SHIFT(425),
  [751] = {.count = 1, .reusable = false}, SHIFT(421),
  [753] = {.count = 1, .reusable = false}, SHIFT(423),
  [755] = {.count = 1, .reusable = true}, SHIFT(422),
  [757] = {.count = 1, .reusable = false}, SHIFT(430),
  [759] = {.count = 1, .reusable = false}, SHIFT(427),
  [761] = {.count = 1, .reusable = false}, SHIFT(428),
  [763] = {.count = 1, .reusable = true}, SHIFT(432),
  [765] = {.count = 1, .reusable = false}, SHIFT(435),
  [767] = {.count = 1, .reusable = false}, SHIFT(434),
  [769] = {.count = 1, .reusable = true}, SHIFT(435),
  [771] = {.count = 1, .reusable = true}, SHIFT(436),
  [773] = {.count = 1, .reusable = false}, SHIFT(437),
  [775] = {.count = 1, .reusable = false}, SHIFT(438),
  [777] = {.count = 1, .reusable = false}, SHIFT(433),
  [779] = {.count = 1, .reusable = true}, SHIFT(136),
  [781] = {.count = 1, .reusable = true}, SHIFT(441),
  [783] = {.count = 1, .reusable = false}, SHIFT(442),
  [785] = {.count = 1, .reusable = false}, SHIFT(443),
  [787] = {.count = 1, .reusable = false}, SHIFT(448),
  [789] = {.count = 1, .reusable = true}, SHIFT(449),
  [791] = {.count = 1, .reusable = false}, SHIFT(451),
  [793] = {.count = 1, .reusable = true}, SHIFT(452),
  [795] = {.count = 1, .reusable = true}, SHIFT(451),
  [797] = {.count = 1, .reusable = false}, SHIFT(453),
  [799] = {.count = 1, .reusable = true}, SHIFT(456),
  [801] = {.count = 1, .reusable = true}, SHIFT(457),
  [803] = {.count = 1, .reusable = true}, SHIFT(458),
  [805] = {.count = 1, .reusable = false}, SHIFT(456),
  [807] = {.count = 1, .reusable = true}, SHIFT(461),
  [809] = {.count = 1, .reusable = true}, SHIFT(462),
  [811] = {.count = 1, .reusable = true}, SHIFT(463),
  [813] = {.count = 1, .reusable = true}, SHIFT(464),
  [815] = {.count = 1, .reusable = false}, SHIFT(461),
  [817] = {.count = 1, .reusable = false}, SHIFT(467),
  [819] = {.count = 1, .reusable = false}, SHIFT(465),
  [821] = {.count = 1, .reusable = true}, SHIFT(465),
  [823] = {.count = 1, .reusable = false}, SHIFT(466),
  [825] = {.count = 1, .reusable = true}, SHIFT(470),
  [827] = {.count = 1, .reusable = false}, SHIFT(471),
  [829] = {.count = 1, .reusable = true}, SHIFT(471),
  [831] = {.count = 1, .reusable = false}, SHIFT(470),
  [833] = {.count = 1, .reusable = true}, SHIFT(472),
  [835] = {.count = 1, .reusable = false}, SHIFT(475),
  [837] = {.count = 1, .reusable = true}, SHIFT(476),
  [839] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [841] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [843] = {.count = 1, .reusable = true}, SHIFT(478),
  [845] = {.count = 1, .reusable = true}, SHIFT(482),
  [847] = {.count = 1, .reusable = true}, SHIFT(483),
  [849] = {.count = 1, .reusable = true}, SHIFT(484),
  [851] = {.count = 1, .reusable = false}, SHIFT(482),
  [853] = {.count = 1, .reusable = true}, SHIFT(487),
  [855] = {.count = 1, .reusable = true}, SHIFT(488),
  [857] = {.count = 1, .reusable = true}, SHIFT(489),
  [859] = {.count = 1, .reusable = true}, SHIFT(490),
  [861] = {.count = 1, .reusable = false}, SHIFT(487),
  [863] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [865] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [867] = {.count = 1, .reusable = true}, SHIFT(491),
  [869] = {.count = 1, .reusable = true}, SHIFT(493),
  [871] = {.count = 1, .reusable = true}, SHIFT(494),
  [873] = {.count = 1, .reusable = false}, SHIFT(493),
  [875] = {.count = 1, .reusable = true}, SHIFT(495),
  [877] = {.count = 1, .reusable = true}, SHIFT(496),
  [879] = {.count = 1, .reusable = false}, SHIFT(497),
  [881] = {.count = 1, .reusable = false}, SHIFT(498),
  [883] = {.count = 1, .reusable = false}, SHIFT(502),
  [885] = {.count = 1, .reusable = false}, SHIFT(500),
  [887] = {.count = 1, .reusable = true}, SHIFT(501),
  [889] = {.count = 1, .reusable = true}, SHIFT(503),
  [891] = {.count = 1, .reusable = false}, SHIFT(504),
  [893] = {.count = 1, .reusable = false}, SHIFT(505),
  [895] = {.count = 1, .reusable = false}, SHIFT(499),
  [897] = {.count = 1, .reusable = true}, SHIFT(511),
  [899] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [901] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [903] = {.count = 1, .reusable = true}, SHIFT(512),
  [905] = {.count = 1, .reusable = true}, SHIFT(513),
  [907] = {.count = 1, .reusable = true}, SHIFT(514),
  [909] = {.count = 1, .reusable = true}, SHIFT(515),
  [911] = {.count = 1, .reusable = true}, SHIFT(516),
  [913] = {.count = 1, .reusable = false}, SHIFT(517),
  [915] = {.count = 1, .reusable = true}, SHIFT(518),
  [917] = {.count = 1, .reusable = true}, SHIFT(519),
  [919] = {.count = 1, .reusable = true}, SHIFT(520),
  [921] = {.count = 1, .reusable = true}, SHIFT(521),
  [923] = {.count = 1, .reusable = true}, SHIFT(523),
  [925] = {.count = 1, .reusable = true}, SHIFT(524),
  [927] = {.count = 1, .reusable = true}, SHIFT(527),
  [929] = {.count = 1, .reusable = true}, SHIFT(530),
  [931] = {.count = 1, .reusable = true}, SHIFT(531),
  [933] = {.count = 1, .reusable = true}, SHIFT(532),
  [935] = {.count = 1, .reusable = false}, SHIFT(530),
  [937] = {.count = 1, .reusable = false}, SHIFT(533),
  [939] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [941] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [943] = {.count = 1, .reusable = true}, SHIFT(537),
  [945] = {.count = 1, .reusable = true}, SHIFT(538),
  [947] = {.count = 1, .reusable = true}, SHIFT(539),
  [949] = {.count = 1, .reusable = true}, SHIFT(540),
  [951] = {.count = 1, .reusable = false}, SHIFT(537),
  [953] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [955] = {.count = 1, .reusable = true}, SHIFT(541),
  [957] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [959] = {.count = 1, .reusable = false}, SHIFT(542),
  [961] = {.count = 1, .reusable = false}, SHIFT(545),
  [963] = {.count = 1, .reusable = true}, SHIFT(545),
  [965] = {.count = 1, .reusable = false}, SHIFT(544),
  [967] = {.count = 1, .reusable = true}, SHIFT(546),
  [969] = {.count = 1, .reusable = false}, SHIFT(547),
  [971] = {.count = 1, .reusable = false}, SHIFT(548),
  [973] = {.count = 1, .reusable = false}, SHIFT(549),
  [975] = {.count = 1, .reusable = false}, SHIFT(550),
  [977] = {.count = 1, .reusable = false}, SHIFT(546),
  [979] = {.count = 1, .reusable = false}, SHIFT(551),
  [981] = {.count = 1, .reusable = false}, SHIFT(552),
  [983] = {.count = 1, .reusable = false}, SHIFT(553),
  [985] = {.count = 1, .reusable = false}, SHIFT(554),
  [987] = {.count = 1, .reusable = false}, SHIFT(555),
  [989] = {.count = 1, .reusable = false}, SHIFT(556),
  [991] = {.count = 1, .reusable = true}, SHIFT(559),
  [993] = {.count = 1, .reusable = false}, SHIFT(563),
  [995] = {.count = 1, .reusable = true}, SHIFT(564),
  [997] = {.count = 1, .reusable = true}, SHIFT(566),
  [999] = {.count = 1, .reusable = true}, SHIFT(570),
  [1001] = {.count = 1, .reusable = true}, SHIFT(571),
  [1003] = {.count = 1, .reusable = true}, SHIFT(572),
  [1005] = {.count = 1, .reusable = false}, SHIFT(570),
  [1007] = {.count = 1, .reusable = true}, SHIFT(575),
  [1009] = {.count = 1, .reusable = true}, SHIFT(576),
  [1011] = {.count = 1, .reusable = true}, SHIFT(577),
  [1013] = {.count = 1, .reusable = true}, SHIFT(578),
  [1015] = {.count = 1, .reusable = false}, SHIFT(575),
  [1017] = {.count = 1, .reusable = false}, SHIFT(579),
  [1019] = {.count = 1, .reusable = true}, SHIFT(581),
  [1021] = {.count = 1, .reusable = true}, SHIFT(582),
  [1023] = {.count = 1, .reusable = false}, SHIFT(581),
  [1025] = {.count = 1, .reusable = true}, SHIFT(583),
  [1027] = {.count = 1, .reusable = false}, SHIFT(491),
  [1029] = {.count = 1, .reusable = true}, SHIFT(587),
  [1031] = {.count = 1, .reusable = false}, SHIFT(587),
  [1033] = {.count = 1, .reusable = true}, SHIFT(588),
  [1035] = {.count = 1, .reusable = true}, SHIFT(591),
  [1037] = {.count = 1, .reusable = true}, SHIFT(592),
  [1039] = {.count = 1, .reusable = true}, SHIFT(593),
  [1041] = {.count = 1, .reusable = true}, SHIFT(594),
  [1043] = {.count = 1, .reusable = false}, SHIFT(595),
  [1045] = {.count = 1, .reusable = true}, SHIFT(596),
  [1047] = {.count = 1, .reusable = true}, SHIFT(597),
  [1049] = {.count = 1, .reusable = true}, SHIFT(598),
  [1051] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [1053] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [1055] = {.count = 1, .reusable = true}, SHIFT(601),
  [1057] = {.count = 1, .reusable = true}, SHIFT(602),
  [1059] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [1061] = {.count = 1, .reusable = true}, SHIFT(604),
  [1063] = {.count = 1, .reusable = false}, SHIFT(604),
  [1065] = {.count = 1, .reusable = true}, SHIFT(605),
  [1067] = {.count = 1, .reusable = true}, SHIFT(608),
  [1069] = {.count = 1, .reusable = true}, REDUCE(sym_redirected_statement, 2),
  [1071] = {.count = 1, .reusable = false}, REDUCE(sym_redirected_statement, 2),
  [1073] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [1075] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [1077] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1079] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(3),
  [1082] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1084] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(21),
  [1087] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(178),
  [1090] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(3),
  [1093] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [1095] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [1097] = {.count = 1, .reusable = true}, SHIFT(613),
  [1099] = {.count = 1, .reusable = true}, SHIFT(614),
  [1101] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1103] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1105] = {.count = 1, .reusable = true}, SHIFT(618),
  [1107] = {.count = 1, .reusable = false}, SHIFT(617),
  [1109] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [1112] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3),
  [1115] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(133),
  [1118] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(134),
  [1121] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6),
  [1124] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(7),
  [1127] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8),
  [1130] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9),
  [1133] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(10),
  [1136] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(135),
  [1139] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(12),
  [1142] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3),
  [1145] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(136),
  [1148] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [1151] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(15),
  [1154] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(16),
  [1157] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(137),
  [1160] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(18),
  [1163] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(138),
  [1166] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(139),
  [1169] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(21),
  [1172] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(22),
  [1175] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(23),
  [1178] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(24),
  [1181] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(25),
  [1184] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(26),
  [1187] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2),
  [1189] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(229),
  [1192] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2),
  [1194] = {.count = 1, .reusable = true}, SHIFT(622),
  [1196] = {.count = 1, .reusable = false}, SHIFT(624),
  [1198] = {.count = 1, .reusable = false}, SHIFT(627),
  [1200] = {.count = 1, .reusable = true}, SHIFT(629),
  [1202] = {.count = 1, .reusable = true}, SHIFT(630),
  [1204] = {.count = 1, .reusable = true}, SHIFT(634),
  [1206] = {.count = 1, .reusable = true}, SHIFT(635),
  [1208] = {.count = 1, .reusable = true}, SHIFT(637),
  [1210] = {.count = 1, .reusable = false}, SHIFT(637),
  [1212] = {.count = 1, .reusable = true}, SHIFT(640),
  [1214] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1216] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1218] = {.count = 1, .reusable = true}, SHIFT(644),
  [1220] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 2),
  [1222] = {.count = 1, .reusable = true}, SHIFT(647),
  [1224] = {.count = 1, .reusable = true}, SHIFT(648),
  [1226] = {.count = 1, .reusable = false}, SHIFT(649),
  [1228] = {.count = 1, .reusable = true}, SHIFT(650),
  [1230] = {.count = 1, .reusable = true}, SHIFT(651),
  [1232] = {.count = 1, .reusable = true}, SHIFT(653),
  [1234] = {.count = 1, .reusable = true}, SHIFT(654),
  [1236] = {.count = 1, .reusable = false}, SHIFT(656),
  [1238] = {.count = 1, .reusable = true}, SHIFT(655),
  [1240] = {.count = 1, .reusable = true}, SHIFT(656),
  [1242] = {.count = 1, .reusable = true}, SHIFT(657),
  [1244] = {.count = 1, .reusable = true}, SHIFT(658),
  [1246] = {.count = 1, .reusable = true}, SHIFT(659),
  [1248] = {.count = 1, .reusable = false}, SHIFT(657),
  [1250] = {.count = 1, .reusable = true}, SHIFT(660),
  [1252] = {.count = 1, .reusable = true}, SHIFT(661),
  [1254] = {.count = 1, .reusable = false}, SHIFT(663),
  [1256] = {.count = 1, .reusable = true}, SHIFT(662),
  [1258] = {.count = 1, .reusable = true}, SHIFT(663),
  [1260] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(274),
  [1263] = {.count = 1, .reusable = true}, SHIFT(664),
  [1265] = {.count = 1, .reusable = true}, SHIFT(665),
  [1267] = {.count = 1, .reusable = false}, SHIFT(666),
  [1269] = {.count = 1, .reusable = true}, SHIFT(62),
  [1271] = {.count = 1, .reusable = true}, SHIFT(667),
  [1273] = {.count = 1, .reusable = true}, SHIFT(65),
  [1275] = {.count = 1, .reusable = true}, SHIFT(68),
  [1277] = {.count = 1, .reusable = true}, SHIFT(70),
  [1279] = {.count = 1, .reusable = true}, SHIFT(668),
  [1281] = {.count = 1, .reusable = true}, SHIFT(670),
  [1283] = {.count = 1, .reusable = true}, SHIFT(671),
  [1285] = {.count = 1, .reusable = true}, SHIFT(672),
  [1287] = {.count = 1, .reusable = true}, SHIFT(69),
  [1289] = {.count = 1, .reusable = true}, SHIFT(673),
  [1291] = {.count = 1, .reusable = true}, SHIFT(675),
  [1293] = {.count = 1, .reusable = false}, SHIFT(677),
  [1295] = {.count = 1, .reusable = true}, SHIFT(676),
  [1297] = {.count = 1, .reusable = true}, SHIFT(677),
  [1299] = {.count = 1, .reusable = true}, SHIFT(678),
  [1301] = {.count = 1, .reusable = true}, SHIFT(679),
  [1303] = {.count = 1, .reusable = true}, SHIFT(680),
  [1305] = {.count = 1, .reusable = false}, SHIFT(678),
  [1307] = {.count = 1, .reusable = true}, SHIFT(681),
  [1309] = {.count = 1, .reusable = true}, SHIFT(682),
  [1311] = {.count = 1, .reusable = false}, SHIFT(684),
  [1313] = {.count = 1, .reusable = true}, SHIFT(683),
  [1315] = {.count = 1, .reusable = true}, SHIFT(684),
  [1317] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(293),
  [1320] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1322] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(67),
  [1325] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(65),
  [1328] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(68),
  [1331] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(295),
  [1334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(70),
  [1337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(64),
  [1340] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(69),
  [1343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(62),
  [1346] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1348] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(66),
  [1351] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(63),
  [1354] = {.count = 1, .reusable = true}, SHIFT(685),
  [1356] = {.count = 1, .reusable = true}, SHIFT(686),
  [1358] = {.count = 1, .reusable = false}, SHIFT(687),
  [1360] = {.count = 1, .reusable = true}, SHIFT(74),
  [1362] = {.count = 1, .reusable = true}, SHIFT(688),
  [1364] = {.count = 1, .reusable = true}, SHIFT(77),
  [1366] = {.count = 1, .reusable = true}, SHIFT(79),
  [1368] = {.count = 1, .reusable = true}, SHIFT(81),
  [1370] = {.count = 1, .reusable = true}, SHIFT(689),
  [1372] = {.count = 1, .reusable = true}, SHIFT(691),
  [1374] = {.count = 1, .reusable = true}, SHIFT(692),
  [1376] = {.count = 1, .reusable = false}, SHIFT(694),
  [1378] = {.count = 1, .reusable = true}, SHIFT(693),
  [1380] = {.count = 1, .reusable = true}, SHIFT(694),
  [1382] = {.count = 1, .reusable = true}, SHIFT(695),
  [1384] = {.count = 1, .reusable = true}, SHIFT(696),
  [1386] = {.count = 1, .reusable = true}, SHIFT(697),
  [1388] = {.count = 1, .reusable = false}, SHIFT(695),
  [1390] = {.count = 1, .reusable = true}, SHIFT(698),
  [1392] = {.count = 1, .reusable = true}, SHIFT(699),
  [1394] = {.count = 1, .reusable = false}, SHIFT(701),
  [1396] = {.count = 1, .reusable = true}, SHIFT(700),
  [1398] = {.count = 1, .reusable = true}, SHIFT(701),
  [1400] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(312),
  [1403] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1405] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(78),
  [1408] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(77),
  [1411] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(79),
  [1414] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(314),
  [1417] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(81),
  [1420] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(76),
  [1423] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(80),
  [1426] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(74),
  [1429] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1431] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(75),
  [1434] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [1436] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [1438] = {.count = 1, .reusable = true}, SHIFT(704),
  [1440] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [1442] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [1444] = {.count = 1, .reusable = false}, SHIFT(709),
  [1446] = {.count = 1, .reusable = true}, SHIFT(707),
  [1448] = {.count = 1, .reusable = true}, SHIFT(709),
  [1450] = {.count = 1, .reusable = true}, SHIFT(708),
  [1452] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1454] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1456] = {.count = 1, .reusable = true}, SHIFT(710),
  [1458] = {.count = 1, .reusable = true}, SHIFT(712),
  [1460] = {.count = 1, .reusable = true}, SHIFT(713),
  [1462] = {.count = 1, .reusable = true}, SHIFT(714),
  [1464] = {.count = 1, .reusable = false}, SHIFT(712),
  [1466] = {.count = 1, .reusable = true}, SHIFT(718),
  [1468] = {.count = 1, .reusable = true}, SHIFT(719),
  [1470] = {.count = 1, .reusable = true}, SHIFT(720),
  [1472] = {.count = 1, .reusable = true}, SHIFT(721),
  [1474] = {.count = 1, .reusable = false}, SHIFT(718),
  [1476] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [1478] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [1480] = {.count = 1, .reusable = false}, SHIFT(722),
  [1482] = {.count = 1, .reusable = true}, SHIFT(723),
  [1484] = {.count = 1, .reusable = false}, SHIFT(725),
  [1486] = {.count = 1, .reusable = true}, SHIFT(725),
  [1488] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1490] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1492] = {.count = 1, .reusable = false}, SHIFT(726),
  [1494] = {.count = 1, .reusable = true}, SHIFT(728),
  [1496] = {.count = 1, .reusable = true}, SHIFT(729),
  [1498] = {.count = 1, .reusable = true}, SHIFT(730),
  [1500] = {.count = 1, .reusable = false}, SHIFT(732),
  [1502] = {.count = 1, .reusable = true}, SHIFT(731),
  [1504] = {.count = 1, .reusable = true}, SHIFT(732),
  [1506] = {.count = 1, .reusable = true}, SHIFT(733),
  [1508] = {.count = 1, .reusable = true}, SHIFT(734),
  [1510] = {.count = 1, .reusable = true}, SHIFT(735),
  [1512] = {.count = 1, .reusable = true}, SHIFT(736),
  [1514] = {.count = 1, .reusable = false}, SHIFT(737),
  [1516] = {.count = 1, .reusable = true}, SHIFT(738),
  [1518] = {.count = 1, .reusable = false}, SHIFT(739),
  [1520] = {.count = 1, .reusable = true}, SHIFT(740),
  [1522] = {.count = 1, .reusable = true}, SHIFT(743),
  [1524] = {.count = 1, .reusable = false}, SHIFT(748),
  [1526] = {.count = 1, .reusable = true}, SHIFT(746),
  [1528] = {.count = 1, .reusable = true}, SHIFT(748),
  [1530] = {.count = 1, .reusable = true}, SHIFT(747),
  [1532] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [1534] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [1536] = {.count = 1, .reusable = true}, SHIFT(749),
  [1538] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1540] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1542] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1544] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1546] = {.count = 1, .reusable = false}, SHIFT(751),
  [1548] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(98),
  [1551] = {.count = 1, .reusable = true}, SHIFT(752),
  [1553] = {.count = 1, .reusable = false}, SHIFT(754),
  [1555] = {.count = 1, .reusable = true}, SHIFT(755),
  [1557] = {.count = 1, .reusable = true}, SHIFT(757),
  [1559] = {.count = 1, .reusable = true}, SHIFT(760),
  [1561] = {.count = 1, .reusable = true}, SHIFT(349),
  [1563] = {.count = 1, .reusable = true}, SHIFT(761),
  [1565] = {.count = 1, .reusable = true}, SHIFT(762),
  [1567] = {.count = 1, .reusable = true}, SHIFT(763),
  [1569] = {.count = 1, .reusable = false}, SHIFT(761),
  [1571] = {.count = 1, .reusable = true}, SHIFT(766),
  [1573] = {.count = 1, .reusable = true}, SHIFT(767),
  [1575] = {.count = 1, .reusable = true}, SHIFT(768),
  [1577] = {.count = 1, .reusable = true}, SHIFT(769),
  [1579] = {.count = 1, .reusable = false}, SHIFT(766),
  [1581] = {.count = 1, .reusable = false}, SHIFT(770),
  [1583] = {.count = 1, .reusable = false}, SHIFT(772),
  [1585] = {.count = 1, .reusable = false}, SHIFT(774),
  [1587] = {.count = 1, .reusable = true}, SHIFT(775),
  [1589] = {.count = 1, .reusable = true}, SHIFT(777),
  [1591] = {.count = 1, .reusable = true}, SHIFT(361),
  [1593] = {.count = 1, .reusable = true}, SHIFT(780),
  [1595] = {.count = 1, .reusable = true}, SHIFT(781),
  [1597] = {.count = 1, .reusable = true}, SHIFT(782),
  [1599] = {.count = 1, .reusable = false}, SHIFT(780),
  [1601] = {.count = 1, .reusable = true}, SHIFT(785),
  [1603] = {.count = 1, .reusable = true}, SHIFT(786),
  [1605] = {.count = 1, .reusable = true}, SHIFT(787),
  [1607] = {.count = 1, .reusable = true}, SHIFT(788),
  [1609] = {.count = 1, .reusable = false}, SHIFT(785),
  [1611] = {.count = 1, .reusable = false}, SHIFT(789),
  [1613] = {.count = 1, .reusable = false}, SHIFT(791),
  [1615] = {.count = 1, .reusable = true}, SHIFT(792),
  [1617] = {.count = 1, .reusable = true}, SHIFT(793),
  [1619] = {.count = 1, .reusable = true}, SHIFT(794),
  [1621] = {.count = 1, .reusable = false}, SHIFT(796),
  [1623] = {.count = 1, .reusable = true}, SHIFT(795),
  [1625] = {.count = 1, .reusable = true}, SHIFT(796),
  [1627] = {.count = 1, .reusable = true}, SHIFT(797),
  [1629] = {.count = 1, .reusable = true}, SHIFT(798),
  [1631] = {.count = 1, .reusable = true}, SHIFT(799),
  [1633] = {.count = 1, .reusable = false}, SHIFT(797),
  [1635] = {.count = 1, .reusable = true}, SHIFT(800),
  [1637] = {.count = 1, .reusable = true}, SHIFT(801),
  [1639] = {.count = 1, .reusable = false}, SHIFT(803),
  [1641] = {.count = 1, .reusable = true}, SHIFT(802),
  [1643] = {.count = 1, .reusable = true}, SHIFT(803),
  [1645] = {.count = 1, .reusable = true}, SHIFT(804),
  [1647] = {.count = 1, .reusable = true}, SHIFT(806),
  [1649] = {.count = 1, .reusable = true}, SHIFT(807),
  [1651] = {.count = 1, .reusable = true}, SHIFT(808),
  [1653] = {.count = 1, .reusable = true}, SHIFT(810),
  [1655] = {.count = 1, .reusable = true}, SHIFT(811),
  [1657] = {.count = 1, .reusable = false}, SHIFT(812),
  [1659] = {.count = 1, .reusable = true}, SHIFT(812),
  [1661] = {.count = 1, .reusable = false}, SHIFT(813),
  [1663] = {.count = 1, .reusable = false}, SHIFT(815),
  [1665] = {.count = 1, .reusable = false}, SHIFT(814),
  [1667] = {.count = 1, .reusable = true}, SHIFT(814),
  [1669] = {.count = 1, .reusable = true}, SHIFT(816),
  [1671] = {.count = 1, .reusable = true}, SHIFT(817),
  [1673] = {.count = 1, .reusable = true}, SHIFT(818),
  [1675] = {.count = 1, .reusable = true}, SHIFT(819),
  [1677] = {.count = 1, .reusable = true}, SHIFT(820),
  [1679] = {.count = 1, .reusable = true}, SHIFT(821),
  [1681] = {.count = 1, .reusable = false}, SHIFT(822),
  [1683] = {.count = 1, .reusable = true}, SHIFT(823),
  [1685] = {.count = 1, .reusable = true}, SHIFT(824),
  [1687] = {.count = 1, .reusable = true}, SHIFT(825),
  [1689] = {.count = 1, .reusable = true}, SHIFT(826),
  [1691] = {.count = 1, .reusable = true}, SHIFT(828),
  [1693] = {.count = 1, .reusable = false}, SHIFT(829),
  [1695] = {.count = 1, .reusable = false}, SHIFT(831),
  [1697] = {.count = 1, .reusable = true}, SHIFT(831),
  [1699] = {.count = 1, .reusable = false}, SHIFT(830),
  [1701] = {.count = 1, .reusable = false}, SHIFT(832),
  [1703] = {.count = 1, .reusable = true}, SHIFT(834),
  [1705] = {.count = 1, .reusable = true}, SHIFT(838),
  [1707] = {.count = 1, .reusable = true}, SHIFT(839),
  [1709] = {.count = 1, .reusable = true}, SHIFT(840),
  [1711] = {.count = 1, .reusable = true}, SHIFT(841),
  [1713] = {.count = 1, .reusable = false}, SHIFT(842),
  [1715] = {.count = 1, .reusable = true}, SHIFT(843),
  [1717] = {.count = 1, .reusable = true}, SHIFT(844),
  [1719] = {.count = 1, .reusable = true}, SHIFT(845),
  [1721] = {.count = 1, .reusable = true}, SHIFT(848),
  [1723] = {.count = 1, .reusable = true}, SHIFT(849),
  [1725] = {.count = 1, .reusable = true}, SHIFT(851),
  [1727] = {.count = 1, .reusable = false}, SHIFT(851),
  [1729] = {.count = 1, .reusable = true}, SHIFT(852),
  [1731] = {.count = 1, .reusable = true}, SHIFT(855),
  [1733] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [1735] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [1737] = {.count = 1, .reusable = true}, SHIFT(860),
  [1739] = {.count = 1, .reusable = true}, SHIFT(861),
  [1741] = {.count = 1, .reusable = true}, SHIFT(865),
  [1743] = {.count = 1, .reusable = false}, SHIFT(864),
  [1745] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(419),
  [1748] = {.count = 1, .reusable = true}, SHIFT(867),
  [1750] = {.count = 1, .reusable = false}, SHIFT(869),
  [1752] = {.count = 1, .reusable = false}, SHIFT(872),
  [1754] = {.count = 1, .reusable = true}, SHIFT(874),
  [1756] = {.count = 1, .reusable = true}, SHIFT(875),
  [1758] = {.count = 1, .reusable = true}, SHIFT(879),
  [1760] = {.count = 1, .reusable = true}, SHIFT(880),
  [1762] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [1764] = {.count = 1, .reusable = true}, SHIFT(882),
  [1766] = {.count = 1, .reusable = false}, SHIFT(882),
  [1768] = {.count = 1, .reusable = true}, SHIFT(885),
  [1770] = {.count = 1, .reusable = false}, SHIFT(889),
  [1772] = {.count = 1, .reusable = false}, SHIFT(890),
  [1774] = {.count = 1, .reusable = false}, SHIFT(891),
  [1776] = {.count = 1, .reusable = true}, SHIFT(892),
  [1778] = {.count = 1, .reusable = true}, SHIFT(893),
  [1780] = {.count = 1, .reusable = false}, SHIFT(894),
  [1782] = {.count = 1, .reusable = true}, SHIFT(895),
  [1784] = {.count = 1, .reusable = false}, SHIFT(896),
  [1786] = {.count = 1, .reusable = false}, SHIFT(897),
  [1788] = {.count = 1, .reusable = false}, SHIFT(898),
  [1790] = {.count = 1, .reusable = true}, SHIFT(899),
  [1792] = {.count = 1, .reusable = true}, SHIFT(900),
  [1794] = {.count = 1, .reusable = false}, SHIFT(901),
  [1796] = {.count = 1, .reusable = true}, SHIFT(902),
  [1798] = {.count = 1, .reusable = true}, SHIFT(903),
  [1800] = {.count = 1, .reusable = false}, SHIFT(904),
  [1802] = {.count = 1, .reusable = true}, SHIFT(916),
  [1804] = {.count = 1, .reusable = true}, SHIFT(919),
  [1806] = {.count = 1, .reusable = true}, SHIFT(920),
  [1808] = {.count = 1, .reusable = false}, SHIFT(921),
  [1810] = {.count = 1, .reusable = true}, SHIFT(922),
  [1812] = {.count = 1, .reusable = true}, SHIFT(923),
  [1814] = {.count = 1, .reusable = true}, SHIFT(924),
  [1816] = {.count = 1, .reusable = false}, SHIFT(924),
  [1818] = {.count = 1, .reusable = true}, SHIFT(925),
  [1820] = {.count = 1, .reusable = true}, SHIFT(927),
  [1822] = {.count = 1, .reusable = true}, SHIFT(928),
  [1824] = {.count = 1, .reusable = false}, SHIFT(930),
  [1826] = {.count = 1, .reusable = true}, SHIFT(929),
  [1828] = {.count = 1, .reusable = true}, SHIFT(930),
  [1830] = {.count = 1, .reusable = true}, SHIFT(931),
  [1832] = {.count = 1, .reusable = true}, SHIFT(932),
  [1834] = {.count = 1, .reusable = true}, SHIFT(933),
  [1836] = {.count = 1, .reusable = false}, SHIFT(931),
  [1838] = {.count = 1, .reusable = true}, SHIFT(934),
  [1840] = {.count = 1, .reusable = true}, SHIFT(935),
  [1842] = {.count = 1, .reusable = false}, SHIFT(937),
  [1844] = {.count = 1, .reusable = true}, SHIFT(936),
  [1846] = {.count = 1, .reusable = true}, SHIFT(937),
  [1848] = {.count = 1, .reusable = true}, SHIFT(938),
  [1850] = {.count = 1, .reusable = true}, SHIFT(939),
  [1852] = {.count = 1, .reusable = false}, SHIFT(939),
  [1854] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(466),
  [1857] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1859] = {.count = 1, .reusable = true}, SHIFT(943),
  [1861] = {.count = 1, .reusable = true}, SHIFT(944),
  [1863] = {.count = 1, .reusable = false}, SHIFT(943),
  [1865] = {.count = 1, .reusable = true}, SHIFT(945),
  [1867] = {.count = 1, .reusable = true}, SHIFT(946),
  [1869] = {.count = 1, .reusable = false}, SHIFT(947),
  [1871] = {.count = 1, .reusable = true}, SHIFT(948),
  [1873] = {.count = 1, .reusable = true}, SHIFT(949),
  [1875] = {.count = 1, .reusable = true}, SHIFT(951),
  [1877] = {.count = 1, .reusable = true}, SHIFT(952),
  [1879] = {.count = 1, .reusable = true}, SHIFT(953),
  [1881] = {.count = 1, .reusable = false}, SHIFT(955),
  [1883] = {.count = 1, .reusable = true}, SHIFT(954),
  [1885] = {.count = 1, .reusable = true}, SHIFT(955),
  [1887] = {.count = 1, .reusable = true}, SHIFT(956),
  [1889] = {.count = 1, .reusable = true}, SHIFT(957),
  [1891] = {.count = 1, .reusable = true}, SHIFT(958),
  [1893] = {.count = 1, .reusable = false}, SHIFT(956),
  [1895] = {.count = 1, .reusable = true}, SHIFT(959),
  [1897] = {.count = 1, .reusable = true}, SHIFT(960),
  [1899] = {.count = 1, .reusable = false}, SHIFT(962),
  [1901] = {.count = 1, .reusable = true}, SHIFT(961),
  [1903] = {.count = 1, .reusable = true}, SHIFT(962),
  [1905] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(491),
  [1908] = {.count = 1, .reusable = true}, REDUCE(sym_postfix_expression, 2),
  [1910] = {.count = 1, .reusable = false}, REDUCE(sym_postfix_expression, 2),
  [1912] = {.count = 1, .reusable = true}, SHIFT(964),
  [1914] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1916] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1918] = {.count = 1, .reusable = true}, SHIFT(967),
  [1920] = {.count = 1, .reusable = true}, SHIFT(968),
  [1922] = {.count = 1, .reusable = true}, SHIFT(971),
  [1924] = {.count = 1, .reusable = false}, SHIFT(971),
  [1926] = {.count = 1, .reusable = true}, SHIFT(974),
  [1928] = {.count = 1, .reusable = true}, SHIFT(979),
  [1930] = {.count = 1, .reusable = false}, SHIFT(978),
  [1932] = {.count = 1, .reusable = true}, SHIFT(980),
  [1934] = {.count = 1, .reusable = true}, SHIFT(981),
  [1936] = {.count = 1, .reusable = true}, SHIFT(982),
  [1938] = {.count = 1, .reusable = true}, SHIFT(984),
  [1940] = {.count = 1, .reusable = true}, SHIFT(985),
  [1942] = {.count = 1, .reusable = true}, SHIFT(986),
  [1944] = {.count = 1, .reusable = true}, SHIFT(987),
  [1946] = {.count = 1, .reusable = false}, SHIFT(988),
  [1948] = {.count = 1, .reusable = true}, SHIFT(989),
  [1950] = {.count = 1, .reusable = true}, SHIFT(990),
  [1952] = {.count = 1, .reusable = true}, SHIFT(991),
  [1954] = {.count = 1, .reusable = true}, SHIFT(992),
  [1956] = {.count = 1, .reusable = false}, SHIFT(996),
  [1958] = {.count = 1, .reusable = true}, SHIFT(997),
  [1960] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1962] = {.count = 1, .reusable = true}, SHIFT(999),
  [1964] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1966] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1968] = {.count = 1, .reusable = true}, SHIFT(1003),
  [1970] = {.count = 1, .reusable = true}, SHIFT(1004),
  [1972] = {.count = 1, .reusable = false}, SHIFT(1002),
  [1974] = {.count = 1, .reusable = true}, SHIFT(1007),
  [1976] = {.count = 1, .reusable = true}, SHIFT(1008),
  [1978] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1980] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1982] = {.count = 1, .reusable = false}, SHIFT(1007),
  [1984] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1986] = {.count = 1, .reusable = false}, SHIFT(1011),
  [1988] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1990] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1992] = {.count = 1, .reusable = true}, SHIFT(1014),
  [1994] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1996] = {.count = 1, .reusable = true}, SHIFT(1017),
  [1998] = {.count = 1, .reusable = true}, SHIFT(1019),
  [2000] = {.count = 1, .reusable = false}, SHIFT(1018),
  [2002] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [2004] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [2006] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [2008] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [2010] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [2012] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [2014] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [2016] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2018] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [2020] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2022] = {.count = 1, .reusable = true}, SHIFT(1023),
  [2024] = {.count = 1, .reusable = false}, SHIFT(1025),
  [2026] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2028] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2030] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2032] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2034] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2036] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2038] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2040] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2042] = {.count = 1, .reusable = false}, SHIFT(1032),
  [2044] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2046] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2048] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2050] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1034),
  [2053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(185),
  [2056] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(187),
  [2059] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(188),
  [2062] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(189),
  [2065] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2067] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1037),
  [2071] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2073] = {.count = 1, .reusable = false}, SHIFT(1039),
  [2075] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2079] = {.count = 1, .reusable = true}, SHIFT(1042),
  [2081] = {.count = 1, .reusable = true}, SHIFT(547),
  [2083] = {.count = 1, .reusable = true}, SHIFT(555),
  [2085] = {.count = 1, .reusable = true}, SHIFT(549),
  [2087] = {.count = 1, .reusable = true}, SHIFT(548),
  [2089] = {.count = 1, .reusable = true}, SHIFT(552),
  [2091] = {.count = 1, .reusable = true}, SHIFT(553),
  [2093] = {.count = 1, .reusable = true}, SHIFT(556),
  [2095] = {.count = 1, .reusable = true}, SHIFT(554),
  [2097] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2099] = {.count = 1, .reusable = false}, SHIFT(1051),
  [2101] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2103] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2105] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2107] = {.count = 1, .reusable = false}, SHIFT(1053),
  [2109] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2111] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2113] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2115] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2117] = {.count = 1, .reusable = false}, SHIFT(1059),
  [2119] = {.count = 1, .reusable = false}, SHIFT(1063),
  [2121] = {.count = 1, .reusable = true}, SHIFT(1064),
  [2123] = {.count = 1, .reusable = false}, SHIFT(1066),
  [2125] = {.count = 1, .reusable = false}, SHIFT(1068),
  [2127] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2129] = {.count = 1, .reusable = false}, SHIFT(1069),
  [2131] = {.count = 1, .reusable = false}, SHIFT(1070),
  [2133] = {.count = 1, .reusable = false}, SHIFT(1071),
  [2135] = {.count = 1, .reusable = false}, SHIFT(1072),
  [2137] = {.count = 1, .reusable = false}, SHIFT(1073),
  [2139] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2141] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2143] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2145] = {.count = 1, .reusable = false}, SHIFT(1077),
  [2147] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2149] = {.count = 1, .reusable = false}, SHIFT(1079),
  [2151] = {.count = 1, .reusable = false}, SHIFT(1080),
  [2153] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2155] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2157] = {.count = 1, .reusable = false}, SHIFT(1083),
  [2159] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2161] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2163] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [2165] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2169] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2171] = {.count = 1, .reusable = false}, SHIFT(1097),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2177] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2179] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2181] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2183] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2187] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2189] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2191] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2193] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2195] = {.count = 1, .reusable = false}, SHIFT(1106),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2199] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2201] = {.count = 1, .reusable = false}, SHIFT(1112),
  [2203] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2205] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2207] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(579),
  [2210] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2212] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(491),
  [2215] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [2217] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [2219] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2223] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2225] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2227] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2229] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2231] = {.count = 1, .reusable = false}, SHIFT(1123),
  [2233] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2235] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2237] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2241] = {.count = 1, .reusable = false}, SHIFT(1128),
  [2243] = {.count = 1, .reusable = false}, SHIFT(1132),
  [2245] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [2247] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [2249] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2251] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2257] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2261] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 3),
  [2263] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 3),
  [2265] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2267] = {.count = 1, .reusable = false}, SHIFT(1140),
  [2269] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2271] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [2273] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [2275] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [2277] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [2279] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [2281] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [2283] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [2285] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [2287] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(216),
  [2290] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(212),
  [2293] = {.count = 1, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [2295] = {.count = 1, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [2297] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(215),
  [2300] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(218),
  [2303] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [2305] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [2307] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [2309] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [2311] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2313] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2315] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(6),
  [2318] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(7),
  [2321] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(8),
  [2324] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(9),
  [2327] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(222),
  [2330] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(223),
  [2333] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(13),
  [2336] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(18),
  [2339] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [2342] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2344] = {.count = 1, .reusable = false}, SHIFT(1145),
  [2346] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2348] = {.count = 1, .reusable = true}, SHIFT(233),
  [2350] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(624),
  [2353] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(231),
  [2356] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(233),
  [2359] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(232),
  [2362] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(627),
  [2365] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(237),
  [2368] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(238),
  [2371] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2373] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(244),
  [2376] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(245),
  [2379] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(247),
  [2382] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(251),
  [2385] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(252),
  [2388] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(40),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1157),
  [2393] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2395] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(262),
  [2398] = {.count = 1, .reusable = false}, SHIFT(1161),
  [2400] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2402] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2404] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2406] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2408] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2410] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2412] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2414] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2420] = {.count = 1, .reusable = false}, SHIFT(1172),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2424] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2428] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2430] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2432] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(280),
  [2435] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2437] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2439] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2441] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2443] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2445] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2449] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2451] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2453] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2455] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2457] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2459] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2461] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2463] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2465] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2467] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2469] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2471] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(300),
  [2474] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2478] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2480] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2482] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2484] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2486] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2488] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2490] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2494] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2496] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2498] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2500] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2502] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2504] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2506] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [2508] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [2510] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2512] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2514] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2516] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2518] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2520] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2522] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2524] = {.count = 1, .reusable = false}, SHIFT(1217),
  [2526] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2528] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2530] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2532] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2534] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2536] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2538] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2540] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2542] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2544] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2546] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2548] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2550] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2552] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(321),
  [2555] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(323),
  [2558] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(725),
  [2561] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(324),
  [2564] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [2566] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(326),
  [2569] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(327),
  [2572] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(325),
  [2575] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(329),
  [2578] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(323),
  [2581] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(725),
  [2584] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(330),
  [2587] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(726),
  [2590] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2592] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2594] = {.count = 1, .reusable = false}, SHIFT(1233),
  [2596] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2598] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2600] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2602] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2604] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2606] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2608] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2610] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2612] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2614] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2616] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2618] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2620] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2622] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2624] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2626] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2628] = {.count = 1, .reusable = false}, SHIFT(1246),
  [2630] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2632] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2634] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2636] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2638] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2640] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2642] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2644] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [2646] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [2648] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2650] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2652] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2654] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [2656] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [2658] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 4),
  [2660] = {.count = 1, .reusable = false}, SHIFT(86),
  [2662] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 4),
  [2664] = {.count = 1, .reusable = false}, SHIFT(85),
  [2666] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2668] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2670] = {.count = 1, .reusable = false}, SHIFT(1263),
  [2672] = {.count = 1, .reusable = true}, SHIFT(348),
  [2674] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2676] = {.count = 1, .reusable = true}, SHIFT(351),
  [2678] = {.count = 1, .reusable = true}, SHIFT(354),
  [2680] = {.count = 1, .reusable = true}, SHIFT(356),
  [2682] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2686] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2688] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2690] = {.count = 1, .reusable = true}, SHIFT(355),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2696] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2698] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2700] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2702] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2704] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2706] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2708] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2714] = {.count = 1, .reusable = false}, SHIFT(1281),
  [2716] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2718] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2720] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(770),
  [2723] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(353),
  [2726] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(351),
  [2729] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(354),
  [2732] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(772),
  [2735] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(356),
  [2738] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(350),
  [2741] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(355),
  [2744] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(348),
  [2747] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(352),
  [2750] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(349),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2755] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2757] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2759] = {.count = 1, .reusable = true}, SHIFT(360),
  [2761] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2763] = {.count = 1, .reusable = true}, SHIFT(363),
  [2765] = {.count = 1, .reusable = true}, SHIFT(365),
  [2767] = {.count = 1, .reusable = true}, SHIFT(367),
  [2769] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2773] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2775] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2777] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2779] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2781] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2783] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2785] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2787] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2789] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2791] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2793] = {.count = 1, .reusable = false}, SHIFT(1298),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2797] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2799] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(789),
  [2802] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(364),
  [2805] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(363),
  [2808] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(365),
  [2811] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(791),
  [2814] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(367),
  [2817] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(362),
  [2820] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(366),
  [2823] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(360),
  [2826] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(361),
  [2829] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2831] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2833] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2837] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2839] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2841] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2843] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2845] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2851] = {.count = 1, .reusable = false}, SHIFT(1312),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2855] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2857] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2859] = {.count = 1, .reusable = true}, SHIFT(1313),
  [2861] = {.count = 1, .reusable = false}, SHIFT(1315),
  [2863] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(382),
  [2866] = {.count = 1, .reusable = false}, SHIFT(1316),
  [2868] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2870] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2872] = {.count = 1, .reusable = false}, SHIFT(1321),
  [2874] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2876] = {.count = 1, .reusable = true}, SHIFT(1323),
  [2878] = {.count = 1, .reusable = false}, SHIFT(1323),
  [2880] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2882] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2884] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2886] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2888] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2890] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2892] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2894] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2896] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2898] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2900] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2902] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2904] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2906] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2908] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2910] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2912] = {.count = 1, .reusable = false}, SHIFT(1349),
  [2914] = {.count = 1, .reusable = false}, SHIFT(1350),
  [2916] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2918] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2920] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2922] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2924] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2926] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2928] = {.count = 1, .reusable = false}, SHIFT(1359),
  [2930] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2932] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2934] = {.count = 1, .reusable = true}, SHIFT(1366),
  [2936] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2938] = {.count = 1, .reusable = false}, SHIFT(1364),
  [2940] = {.count = 1, .reusable = false}, SHIFT(1368),
  [2942] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2944] = {.count = 1, .reusable = true}, SHIFT(1371),
  [2946] = {.count = 1, .reusable = true}, SHIFT(1372),
  [2948] = {.count = 1, .reusable = false}, SHIFT(1372),
  [2950] = {.count = 1, .reusable = true}, SHIFT(1373),
  [2952] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(407),
  [2955] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(403),
  [2958] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(406),
  [2961] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(409),
  [2964] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(103),
  [2967] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(104),
  [2970] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(105),
  [2973] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(106),
  [2976] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(413),
  [2979] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(414),
  [2982] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(110),
  [2985] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(115),
  [2988] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(119),
  [2991] = {.count = 1, .reusable = true}, SHIFT(1378),
  [2993] = {.count = 1, .reusable = true}, SHIFT(423),
  [2995] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(869),
  [2998] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(421),
  [3001] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(423),
  [3004] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(422),
  [3007] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(872),
  [3010] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(427),
  [3013] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(428),
  [3016] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3018] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(434),
  [3021] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(436),
  [3024] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(438),
  [3027] = {.count = 1, .reusable = false}, SHIFT(1392),
  [3029] = {.count = 1, .reusable = false}, SHIFT(1390),
  [3031] = {.count = 1, .reusable = false}, SHIFT(1393),
  [3033] = {.count = 1, .reusable = false}, SHIFT(1395),
  [3035] = {.count = 1, .reusable = false}, SHIFT(1397),
  [3037] = {.count = 1, .reusable = false}, SHIFT(1389),
  [3039] = {.count = 1, .reusable = false}, SHIFT(1394),
  [3041] = {.count = 1, .reusable = false}, SHIFT(1387),
  [3043] = {.count = 1, .reusable = true}, SHIFT(1391),
  [3045] = {.count = 1, .reusable = false}, SHIFT(1388),
  [3047] = {.count = 1, .reusable = false}, SHIFT(1403),
  [3049] = {.count = 1, .reusable = false}, SHIFT(1402),
  [3051] = {.count = 1, .reusable = false}, SHIFT(1404),
  [3053] = {.count = 1, .reusable = false}, SHIFT(1406),
  [3055] = {.count = 1, .reusable = false}, SHIFT(1408),
  [3057] = {.count = 1, .reusable = false}, SHIFT(1401),
  [3059] = {.count = 1, .reusable = false}, SHIFT(1405),
  [3061] = {.count = 1, .reusable = false}, SHIFT(1399),
  [3063] = {.count = 1, .reusable = false}, SHIFT(1400),
  [3065] = {.count = 1, .reusable = true}, SHIFT(1409),
  [3067] = {.count = 1, .reusable = true}, SHIFT(1410),
  [3069] = {.count = 1, .reusable = true}, SHIFT(1411),
  [3071] = {.count = 1, .reusable = false}, SHIFT(1409),
  [3073] = {.count = 1, .reusable = false}, SHIFT(1415),
  [3075] = {.count = 1, .reusable = false}, SHIFT(1416),
  [3077] = {.count = 1, .reusable = false}, SHIFT(1417),
  [3079] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [3081] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3083] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3085] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3087] = {.count = 1, .reusable = false}, SHIFT(1421),
  [3089] = {.count = 1, .reusable = false}, SHIFT(1422),
  [3091] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3093] = {.count = 1, .reusable = true}, SHIFT(1424),
  [3095] = {.count = 1, .reusable = false}, SHIFT(1425),
  [3097] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3099] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3103] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3105] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3107] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3109] = {.count = 1, .reusable = false}, SHIFT(1437),
  [3111] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [3113] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3117] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3119] = {.count = 1, .reusable = false}, SHIFT(1445),
  [3121] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3123] = {.count = 1, .reusable = false}, SHIFT(1452),
  [3125] = {.count = 1, .reusable = false}, SHIFT(1450),
  [3127] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3131] = {.count = 1, .reusable = false}, SHIFT(1454),
  [3133] = {.count = 1, .reusable = false}, SHIFT(1455),
  [3135] = {.count = 1, .reusable = false}, SHIFT(1449),
  [3137] = {.count = 1, .reusable = true}, SHIFT(898),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3141] = {.count = 1, .reusable = true}, SHIFT(904),
  [3143] = {.count = 1, .reusable = true}, SHIFT(894),
  [3145] = {.count = 1, .reusable = false}, SHIFT(892),
  [3147] = {.count = 1, .reusable = false}, SHIFT(893),
  [3149] = {.count = 1, .reusable = false}, SHIFT(895),
  [3151] = {.count = 1, .reusable = false}, SHIFT(1462),
  [3153] = {.count = 1, .reusable = false}, SHIFT(1463),
  [3155] = {.count = 1, .reusable = false}, SHIFT(900),
  [3157] = {.count = 1, .reusable = false}, SHIFT(903),
  [3159] = {.count = 1, .reusable = false}, SHIFT(1468),
  [3161] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(442),
  [3164] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(443),
  [3167] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(136),
  [3170] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3172] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3174] = {.count = 1, .reusable = false}, SHIFT(1471),
  [3176] = {.count = 1, .reusable = false}, SHIFT(1472),
  [3178] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3180] = {.count = 1, .reusable = false}, SHIFT(1473),
  [3182] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3184] = {.count = 1, .reusable = false}, SHIFT(1479),
  [3186] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(452),
  [3189] = {.count = 1, .reusable = false}, SHIFT(1482),
  [3191] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3193] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3195] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3197] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3199] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3201] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3203] = {.count = 1, .reusable = false}, SHIFT(1487),
  [3205] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3207] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1493),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3215] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3221] = {.count = 1, .reusable = false}, SHIFT(1494),
  [3223] = {.count = 1, .reusable = false}, SHIFT(1495),
  [3225] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [3227] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [3229] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3231] = {.count = 1, .reusable = false}, SHIFT(1500),
  [3233] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(478),
  [3236] = {.count = 1, .reusable = false}, SHIFT(1503),
  [3238] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3240] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3242] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3244] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3246] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3248] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3250] = {.count = 1, .reusable = false}, SHIFT(1508),
  [3252] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3254] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3256] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3258] = {.count = 1, .reusable = false}, SHIFT(1514),
  [3260] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3262] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3264] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3266] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [3268] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [3270] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3272] = {.count = 1, .reusable = false}, SHIFT(1517),
  [3274] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3276] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(500),
  [3279] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(503),
  [3282] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(505),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3287] = {.count = 1, .reusable = false}, SHIFT(1524),
  [3289] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3291] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [3293] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3295] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [3297] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3299] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3301] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3303] = {.count = 1, .reusable = false}, SHIFT(1530),
  [3305] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [3307] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3311] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3313] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3315] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3317] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3319] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [3321] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3325] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3329] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3331] = {.count = 1, .reusable = false}, SHIFT(1545),
  [3333] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3337] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3341] = {.count = 1, .reusable = false}, SHIFT(1552),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3353] = {.count = 1, .reusable = false}, SHIFT(1553),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3359] = {.count = 1, .reusable = false}, SHIFT(1559),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3365] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1011),
  [3368] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [3370] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3372] = {.count = 1, .reusable = true}, SHIFT(1561),
  [3374] = {.count = 1, .reusable = false}, SHIFT(1098),
  [3376] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3378] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [3380] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3382] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3384] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1018),
  [3387] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [3389] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [3391] = {.count = 1, .reusable = false}, SHIFT(1568),
  [3393] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3395] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3403] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3405] = {.count = 1, .reusable = false}, SHIFT(1573),
  [3407] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3411] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3413] = {.count = 1, .reusable = false}, SHIFT(1579),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3417] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3421] = {.count = 1, .reusable = false}, REDUCE(sym_string, 4),
  [3423] = {.count = 1, .reusable = true}, REDUCE(sym_string, 4),
  [3425] = {.count = 1, .reusable = false}, SHIFT(1581),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3435] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3437] = {.count = 1, .reusable = false}, SHIFT(1587),
  [3439] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3441] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3447] = {.count = 1, .reusable = false}, SHIFT(1592),
  [3449] = {.count = 1, .reusable = false}, SHIFT(1596),
  [3451] = {.count = 1, .reusable = false}, SHIFT(1035),
  [3453] = {.count = 1, .reusable = false}, SHIFT(1037),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3457] = {.count = 1, .reusable = false}, SHIFT(1598),
  [3459] = {.count = 1, .reusable = false}, SHIFT(1038),
  [3461] = {.count = 1, .reusable = false}, SHIFT(1040),
  [3463] = {.count = 1, .reusable = false}, SHIFT(1042),
  [3465] = {.count = 1, .reusable = false}, SHIFT(1036),
  [3467] = {.count = 1, .reusable = false}, SHIFT(1041),
  [3469] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4),
  [3471] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4),
  [3473] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [3475] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3477] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3479] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3481] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3483] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3485] = {.count = 1, .reusable = false}, SHIFT(1607),
  [3487] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3491] = {.count = 1, .reusable = false}, SHIFT(1611),
  [3493] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3495] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3497] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3499] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3501] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3503] = {.count = 1, .reusable = false}, SHIFT(1612),
  [3505] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3509] = {.count = 1, .reusable = false}, SHIFT(1618),
  [3511] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3515] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3517] = {.count = 1, .reusable = false}, SHIFT(1620),
  [3519] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1066),
  [3522] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3524] = {.count = 1, .reusable = false}, SHIFT(1629),
  [3526] = {.count = 1, .reusable = false}, SHIFT(1627),
  [3528] = {.count = 1, .reusable = false}, SHIFT(1630),
  [3530] = {.count = 1, .reusable = false}, SHIFT(1632),
  [3532] = {.count = 1, .reusable = false}, SHIFT(1634),
  [3534] = {.count = 1, .reusable = false}, SHIFT(1626),
  [3536] = {.count = 1, .reusable = false}, SHIFT(1631),
  [3538] = {.count = 1, .reusable = false}, SHIFT(1624),
  [3540] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3542] = {.count = 1, .reusable = false}, SHIFT(1625),
  [3544] = {.count = 1, .reusable = false}, SHIFT(1640),
  [3546] = {.count = 1, .reusable = false}, SHIFT(1639),
  [3548] = {.count = 1, .reusable = false}, SHIFT(1641),
  [3550] = {.count = 1, .reusable = false}, SHIFT(1643),
  [3552] = {.count = 1, .reusable = false}, SHIFT(1645),
  [3554] = {.count = 1, .reusable = false}, SHIFT(1638),
  [3556] = {.count = 1, .reusable = false}, SHIFT(1642),
  [3558] = {.count = 1, .reusable = false}, SHIFT(1636),
  [3560] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3562] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3564] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3566] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3568] = {.count = 1, .reusable = false}, SHIFT(1646),
  [3570] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [3572] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [3574] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3576] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3578] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3580] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3582] = {.count = 1, .reusable = false}, SHIFT(1652),
  [3584] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3586] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3588] = {.count = 1, .reusable = false}, SHIFT(1660),
  [3590] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3592] = {.count = 1, .reusable = false}, SHIFT(1666),
  [3594] = {.count = 1, .reusable = false}, SHIFT(1664),
  [3596] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3598] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3600] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3602] = {.count = 1, .reusable = false}, SHIFT(1669),
  [3604] = {.count = 1, .reusable = false}, SHIFT(1663),
  [3606] = {.count = 1, .reusable = true}, SHIFT(1080),
  [3608] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3610] = {.count = 1, .reusable = false}, SHIFT(1075),
  [3612] = {.count = 1, .reusable = false}, SHIFT(1076),
  [3614] = {.count = 1, .reusable = false}, SHIFT(1078),
  [3616] = {.count = 1, .reusable = false}, SHIFT(1673),
  [3618] = {.count = 1, .reusable = false}, SHIFT(1674),
  [3620] = {.count = 1, .reusable = false}, SHIFT(1082),
  [3622] = {.count = 1, .reusable = false}, SHIFT(1085),
  [3624] = {.count = 1, .reusable = false}, SHIFT(1679),
  [3626] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3628] = {.count = 1, .reusable = false}, SHIFT(1682),
  [3630] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(566),
  [3633] = {.count = 1, .reusable = false}, SHIFT(1685),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3637] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3639] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3641] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3643] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3645] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3647] = {.count = 1, .reusable = false}, SHIFT(1690),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1691),
  [3655] = {.count = 1, .reusable = false}, SHIFT(1696),
  [3657] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3659] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3665] = {.count = 1, .reusable = true}, SHIFT(1698),
  [3667] = {.count = 1, .reusable = false}, SHIFT(1699),
  [3669] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3671] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3673] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3675] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3677] = {.count = 1, .reusable = false}, SHIFT(1706),
  [3679] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3681] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3687] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3689] = {.count = 1, .reusable = false}, SHIFT(1707),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3693] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3695] = {.count = 1, .reusable = false}, SHIFT(1713),
  [3697] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3701] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1132),
  [3704] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3706] = {.count = 1, .reusable = true}, SHIFT(1715),
  [3708] = {.count = 1, .reusable = false}, SHIFT(1714),
  [3710] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [3712] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [3714] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3716] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3718] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3720] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3722] = {.count = 1, .reusable = false}, SHIFT(1719),
  [3724] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3726] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3728] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 4),
  [3730] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 4),
  [3732] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 4),
  [3734] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 4),
  [3736] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3738] = {.count = 1, .reusable = false}, SHIFT(1725),
  [3740] = {.count = 1, .reusable = false}, SHIFT(267),
  [3742] = {.count = 1, .reusable = false}, SHIFT(1730),
  [3744] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3746] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3748] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3750] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3752] = {.count = 1, .reusable = false}, SHIFT(1737),
  [3754] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3756] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3758] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3760] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3762] = {.count = 1, .reusable = false}, SHIFT(1740),
  [3764] = {.count = 1, .reusable = true}, SHIFT(1739),
  [3766] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3768] = {.count = 1, .reusable = false}, SHIFT(286),
  [3770] = {.count = 1, .reusable = false}, SHIFT(285),
  [3772] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3774] = {.count = 1, .reusable = false}, SHIFT(1743),
  [3776] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3778] = {.count = 1, .reusable = true}, SHIFT(1743),
  [3780] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3782] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3784] = {.count = 1, .reusable = false}, SHIFT(1750),
  [3786] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3788] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3790] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3792] = {.count = 1, .reusable = true}, SHIFT(1751),
  [3794] = {.count = 1, .reusable = false}, SHIFT(1753),
  [3796] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3798] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3800] = {.count = 1, .reusable = false}, SHIFT(305),
  [3802] = {.count = 1, .reusable = false}, SHIFT(304),
  [3804] = {.count = 1, .reusable = false}, SHIFT(1755),
  [3806] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3808] = {.count = 1, .reusable = true}, SHIFT(1755),
  [3810] = {.count = 1, .reusable = true}, SHIFT(1756),
  [3812] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3814] = {.count = 1, .reusable = false}, SHIFT(1762),
  [3816] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3818] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3820] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3822] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3824] = {.count = 1, .reusable = false}, SHIFT(1765),
  [3826] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3828] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3830] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [3832] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [3834] = {.count = 1, .reusable = true}, SHIFT(1766),
  [3836] = {.count = 1, .reusable = false}, SHIFT(1767),
  [3838] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(710),
  [3841] = {.count = 1, .reusable = false}, SHIFT(1770),
  [3843] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3847] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3855] = {.count = 1, .reusable = false}, SHIFT(1775),
  [3857] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3859] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3861] = {.count = 1, .reusable = true}, SHIFT(1776),
  [3863] = {.count = 1, .reusable = false}, SHIFT(1781),
  [3865] = {.count = 1, .reusable = true}, SHIFT(1779),
  [3867] = {.count = 1, .reusable = true}, SHIFT(1781),
  [3869] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3871] = {.count = 1, .reusable = true}, SHIFT(1782),
  [3873] = {.count = 1, .reusable = false}, SHIFT(1783),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1783),
  [3877] = {.count = 1, .reusable = true}, SHIFT(1784),
  [3879] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [3881] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [3883] = {.count = 1, .reusable = false}, SHIFT(1786),
  [3885] = {.count = 1, .reusable = true}, SHIFT(1785),
  [3887] = {.count = 1, .reusable = true}, SHIFT(1786),
  [3889] = {.count = 1, .reusable = true}, SHIFT(1787),
  [3891] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3893] = {.count = 1, .reusable = false}, SHIFT(1789),
  [3895] = {.count = 1, .reusable = true}, SHIFT(1790),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1791),
  [3899] = {.count = 1, .reusable = true}, SHIFT(1793),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3903] = {.count = 1, .reusable = false}, SHIFT(1796),
  [3905] = {.count = 1, .reusable = true}, SHIFT(1795),
  [3907] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3909] = {.count = 1, .reusable = true}, SHIFT(1797),
  [3911] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3913] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3915] = {.count = 1, .reusable = false}, SHIFT(1797),
  [3917] = {.count = 1, .reusable = true}, SHIFT(1800),
  [3919] = {.count = 1, .reusable = true}, SHIFT(1801),
  [3921] = {.count = 1, .reusable = false}, SHIFT(1803),
  [3923] = {.count = 1, .reusable = true}, SHIFT(1802),
  [3925] = {.count = 1, .reusable = true}, SHIFT(1803),
  [3927] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [3929] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [3931] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1250),
  [3934] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [3936] = {.count = 1, .reusable = true}, SHIFT(1804),
  [3938] = {.count = 1, .reusable = true}, SHIFT(1805),
  [3940] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3944] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3946] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [3948] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [3950] = {.count = 1, .reusable = true}, SHIFT(1808),
  [3952] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3954] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3956] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3958] = {.count = 1, .reusable = false}, SHIFT(1810),
  [3960] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(757),
  [3963] = {.count = 1, .reusable = true}, SHIFT(1811),
  [3965] = {.count = 1, .reusable = false}, SHIFT(1815),
  [3967] = {.count = 1, .reusable = true}, SHIFT(1813),
  [3969] = {.count = 1, .reusable = true}, SHIFT(1815),
  [3971] = {.count = 1, .reusable = true}, SHIFT(1814),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1816),
  [3975] = {.count = 1, .reusable = true}, SHIFT(1817),
  [3977] = {.count = 1, .reusable = true}, SHIFT(1818),
  [3979] = {.count = 1, .reusable = false}, SHIFT(1820),
  [3981] = {.count = 1, .reusable = true}, SHIFT(1819),
  [3983] = {.count = 1, .reusable = true}, SHIFT(1820),
  [3985] = {.count = 1, .reusable = true}, SHIFT(1821),
  [3987] = {.count = 1, .reusable = false}, SHIFT(1826),
  [3989] = {.count = 1, .reusable = true}, SHIFT(1824),
  [3991] = {.count = 1, .reusable = true}, SHIFT(1826),
  [3993] = {.count = 1, .reusable = true}, SHIFT(1825),
  [3995] = {.count = 1, .reusable = true}, SHIFT(1827),
  [3997] = {.count = 1, .reusable = false}, SHIFT(1828),
  [3999] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(777),
  [4002] = {.count = 1, .reusable = false}, SHIFT(1831),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1831),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4016] = {.count = 1, .reusable = false}, SHIFT(1836),
  [4018] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4024] = {.count = 1, .reusable = false}, SHIFT(1842),
  [4026] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4030] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4032] = {.count = 1, .reusable = false}, SHIFT(1844),
  [4034] = {.count = 1, .reusable = true}, SHIFT(1843),
  [4036] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4038] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4040] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4042] = {.count = 1, .reusable = false}, SHIFT(1851),
  [4044] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4046] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4048] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4050] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4052] = {.count = 1, .reusable = false}, SHIFT(1854),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4056] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4058] = {.count = 1, .reusable = false}, SHIFT(372),
  [4060] = {.count = 1, .reusable = false}, SHIFT(371),
  [4062] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4064] = {.count = 1, .reusable = true}, SHIFT(1859),
  [4066] = {.count = 1, .reusable = false}, SHIFT(1859),
  [4068] = {.count = 1, .reusable = false}, SHIFT(1860),
  [4070] = {.count = 1, .reusable = true}, SHIFT(1863),
  [4072] = {.count = 1, .reusable = false}, SHIFT(1863),
  [4074] = {.count = 1, .reusable = false}, SHIFT(1864),
  [4076] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1868),
  [4080] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4082] = {.count = 1, .reusable = false}, SHIFT(1870),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4086] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4092] = {.count = 1, .reusable = false}, SHIFT(1877),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4096] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4098] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4100] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4102] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4104] = {.count = 1, .reusable = false}, SHIFT(1878),
  [4106] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4110] = {.count = 1, .reusable = false}, SHIFT(1884),
  [4112] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4114] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4116] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1342),
  [4119] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4121] = {.count = 1, .reusable = false}, SHIFT(1885),
  [4123] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4125] = {.count = 1, .reusable = false}, SHIFT(1888),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4129] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4133] = {.count = 1, .reusable = false}, SHIFT(1893),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4137] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4139] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4141] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4143] = {.count = 1, .reusable = false}, SHIFT(1900),
  [4145] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4147] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4149] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4151] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4153] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4155] = {.count = 1, .reusable = false}, SHIFT(1901),
  [4157] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4159] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4161] = {.count = 1, .reusable = false}, SHIFT(1907),
  [4163] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4167] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1368),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4172] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4174] = {.count = 1, .reusable = false}, SHIFT(1909),
  [4176] = {.count = 1, .reusable = false}, SHIFT(1913),
  [4178] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4180] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4182] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4184] = {.count = 1, .reusable = true}, SHIFT(1388),
  [4186] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4188] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4192] = {.count = 1, .reusable = false}, SHIFT(1920),
  [4194] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4196] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4198] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4202] = {.count = 1, .reusable = false}, SHIFT(1925),
  [4204] = {.count = 1, .reusable = false}, SHIFT(1929),
  [4206] = {.count = 1, .reusable = false}, SHIFT(1931),
  [4208] = {.count = 1, .reusable = false}, SHIFT(1933),
  [4210] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4212] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4214] = {.count = 1, .reusable = true}, SHIFT(1400),
  [4216] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4218] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4220] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4222] = {.count = 1, .reusable = false}, SHIFT(1939),
  [4224] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4226] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4228] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4230] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4232] = {.count = 1, .reusable = false}, SHIFT(1944),
  [4234] = {.count = 1, .reusable = false}, SHIFT(1948),
  [4236] = {.count = 1, .reusable = false}, SHIFT(1950),
  [4238] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4240] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4242] = {.count = 1, .reusable = false}, SHIFT(1958),
  [4244] = {.count = 1, .reusable = false}, SHIFT(1956),
  [4246] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4248] = {.count = 1, .reusable = false}, SHIFT(1961),
  [4250] = {.count = 1, .reusable = false}, SHIFT(1963),
  [4252] = {.count = 1, .reusable = false}, SHIFT(1955),
  [4254] = {.count = 1, .reusable = false}, SHIFT(1960),
  [4256] = {.count = 1, .reusable = false}, SHIFT(1953),
  [4258] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4260] = {.count = 1, .reusable = false}, SHIFT(1954),
  [4262] = {.count = 1, .reusable = false}, SHIFT(1969),
  [4264] = {.count = 1, .reusable = false}, SHIFT(1968),
  [4266] = {.count = 1, .reusable = false}, SHIFT(1970),
  [4268] = {.count = 1, .reusable = false}, SHIFT(1972),
  [4270] = {.count = 1, .reusable = false}, SHIFT(1974),
  [4272] = {.count = 1, .reusable = false}, SHIFT(1967),
  [4274] = {.count = 1, .reusable = false}, SHIFT(1971),
  [4276] = {.count = 1, .reusable = false}, SHIFT(1965),
  [4278] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4280] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4284] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4286] = {.count = 1, .reusable = false}, SHIFT(1975),
  [4288] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4290] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4292] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4294] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4296] = {.count = 1, .reusable = false}, SHIFT(1981),
  [4298] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4300] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4302] = {.count = 1, .reusable = false}, SHIFT(1989),
  [4304] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4306] = {.count = 1, .reusable = false}, SHIFT(1995),
  [4308] = {.count = 1, .reusable = false}, SHIFT(1993),
  [4310] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4312] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4314] = {.count = 1, .reusable = false}, SHIFT(1997),
  [4316] = {.count = 1, .reusable = false}, SHIFT(1998),
  [4318] = {.count = 1, .reusable = false}, SHIFT(1992),
  [4320] = {.count = 1, .reusable = true}, SHIFT(1422),
  [4322] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 2),
  [4324] = {.count = 1, .reusable = false}, SHIFT(1418),
  [4326] = {.count = 1, .reusable = false}, SHIFT(1419),
  [4328] = {.count = 1, .reusable = false}, SHIFT(1420),
  [4330] = {.count = 1, .reusable = false}, SHIFT(2001),
  [4332] = {.count = 1, .reusable = false}, SHIFT(2002),
  [4334] = {.count = 1, .reusable = false}, SHIFT(1424),
  [4336] = {.count = 1, .reusable = false}, SHIFT(1427),
  [4338] = {.count = 1, .reusable = false}, SHIFT(2007),
  [4340] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4342] = {.count = 1, .reusable = false}, SHIFT(2011),
  [4344] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4346] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4348] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4350] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4352] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4354] = {.count = 1, .reusable = false}, SHIFT(2012),
  [4356] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4358] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4360] = {.count = 1, .reusable = false}, SHIFT(2018),
  [4362] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4364] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4366] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4368] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4370] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4372] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4374] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4376] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4378] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4380] = {.count = 1, .reusable = false}, SHIFT(2027),
  [4382] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4384] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4386] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4388] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4390] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4392] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4394] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4396] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4398] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4400] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4402] = {.count = 1, .reusable = false}, SHIFT(2042),
  [4404] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4406] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [4408] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [4410] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4412] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(904),
  [4415] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [4417] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4419] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4421] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4423] = {.count = 1, .reusable = false}, SHIFT(2055),
  [4425] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1468),
  [4428] = {.count = 1, .reusable = false}, SHIFT(2057),
  [4430] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4432] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4434] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [4436] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [4438] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4440] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4442] = {.count = 1, .reusable = false}, SHIFT(457),
  [4444] = {.count = 1, .reusable = false}, SHIFT(458),
  [4446] = {.count = 1, .reusable = false}, SHIFT(148),
  [4448] = {.count = 1, .reusable = false}, SHIFT(2069),
  [4450] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4452] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4454] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4456] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4458] = {.count = 1, .reusable = false}, SHIFT(2076),
  [4460] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4462] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4464] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4466] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4468] = {.count = 1, .reusable = false}, SHIFT(2079),
  [4470] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4472] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4474] = {.count = 1, .reusable = false}, SHIFT(2080),
  [4476] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [4478] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [4480] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4482] = {.count = 1, .reusable = false}, SHIFT(484),
  [4484] = {.count = 1, .reusable = false}, SHIFT(2084),
  [4486] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4488] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4490] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4492] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4494] = {.count = 1, .reusable = false}, SHIFT(2091),
  [4496] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4498] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4500] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4502] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4504] = {.count = 1, .reusable = false}, SHIFT(2094),
  [4506] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4508] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4510] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4512] = {.count = 1, .reusable = false}, SHIFT(2096),
  [4514] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4516] = {.count = 1, .reusable = true}, SHIFT(2098),
  [4518] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4520] = {.count = 1, .reusable = false}, SHIFT(2100),
  [4522] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4524] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4526] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4528] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4530] = {.count = 1, .reusable = false}, SHIFT(2107),
  [4532] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4534] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4536] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4538] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4540] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4542] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4544] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4546] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4548] = {.count = 1, .reusable = false}, SHIFT(2114),
  [4550] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4552] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4554] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1539),
  [4557] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [4559] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [4561] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(984),
  [4564] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(985),
  [4567] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(986),
  [4570] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(987),
  [4573] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(988),
  [4576] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [4578] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(990),
  [4581] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(991),
  [4584] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(992),
  [4587] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4589] = {.count = 1, .reusable = false}, SHIFT(2116),
  [4591] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(999),
  [4594] = {.count = 1, .reusable = false}, SHIFT(2119),
  [4596] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4598] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4600] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4602] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4604] = {.count = 1, .reusable = true}, SHIFT(2121),
  [4606] = {.count = 1, .reusable = true}, SHIFT(2122),
  [4608] = {.count = 1, .reusable = false}, SHIFT(2124),
  [4610] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4612] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4614] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4616] = {.count = 1, .reusable = false}, SHIFT(2130),
  [4618] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4620] = {.count = 1, .reusable = true}, SHIFT(2130),
  [4622] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4624] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [4626] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4628] = {.count = 1, .reusable = false}, SHIFT(2132),
  [4630] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [4632] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4634] = {.count = 1, .reusable = false}, SHIFT(2135),
  [4636] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4638] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4640] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4642] = {.count = 1, .reusable = true}, SHIFT(2137),
  [4644] = {.count = 1, .reusable = false}, SHIFT(2142),
  [4646] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4648] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4650] = {.count = 1, .reusable = true}, SHIFT(2141),
  [4652] = {.count = 1, .reusable = true}, SHIFT(2143),
  [4654] = {.count = 1, .reusable = false}, SHIFT(2145),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4658] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4660] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4662] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4664] = {.count = 1, .reusable = false}, SHIFT(2148),
  [4666] = {.count = 1, .reusable = true}, SHIFT(2149),
  [4668] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4670] = {.count = 1, .reusable = true}, SHIFT(2152),
  [4672] = {.count = 1, .reusable = true}, SHIFT(2153),
  [4674] = {.count = 1, .reusable = false}, SHIFT(2155),
  [4676] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4678] = {.count = 1, .reusable = true}, SHIFT(2155),
  [4680] = {.count = 1, .reusable = true}, SHIFT(2156),
  [4682] = {.count = 1, .reusable = true}, SHIFT(2157),
  [4684] = {.count = 1, .reusable = true}, SHIFT(2158),
  [4686] = {.count = 1, .reusable = false}, SHIFT(2156),
  [4688] = {.count = 1, .reusable = true}, SHIFT(2159),
  [4690] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4692] = {.count = 1, .reusable = false}, SHIFT(2162),
  [4694] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4696] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4698] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1596),
  [4701] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1035),
  [4704] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1037),
  [4707] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [4709] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1039),
  [4712] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1038),
  [4715] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1040),
  [4718] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1042),
  [4721] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1036),
  [4724] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1041),
  [4727] = {.count = 1, .reusable = false}, SHIFT(2164),
  [4729] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1049),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4734] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4736] = {.count = 1, .reusable = false}, SHIFT(2171),
  [4738] = {.count = 1, .reusable = true}, SHIFT(2169),
  [4740] = {.count = 1, .reusable = true}, SHIFT(2171),
  [4742] = {.count = 1, .reusable = true}, SHIFT(2170),
  [4744] = {.count = 1, .reusable = true}, SHIFT(2172),
  [4746] = {.count = 1, .reusable = true}, SHIFT(2173),
  [4748] = {.count = 1, .reusable = true}, SHIFT(2174),
  [4750] = {.count = 1, .reusable = false}, SHIFT(2176),
  [4752] = {.count = 1, .reusable = true}, SHIFT(2175),
  [4754] = {.count = 1, .reusable = true}, SHIFT(2176),
  [4756] = {.count = 1, .reusable = true}, SHIFT(2177),
  [4758] = {.count = 1, .reusable = false}, SHIFT(2182),
  [4760] = {.count = 1, .reusable = true}, SHIFT(2180),
  [4762] = {.count = 1, .reusable = true}, SHIFT(2182),
  [4764] = {.count = 1, .reusable = true}, SHIFT(2181),
  [4766] = {.count = 1, .reusable = true}, SHIFT(2183),
  [4768] = {.count = 1, .reusable = false}, SHIFT(2184),
  [4770] = {.count = 1, .reusable = false}, SHIFT(2186),
  [4772] = {.count = 1, .reusable = true}, SHIFT(2187),
  [4774] = {.count = 1, .reusable = true}, SHIFT(2189),
  [4776] = {.count = 1, .reusable = true}, SHIFT(2192),
  [4778] = {.count = 1, .reusable = true}, SHIFT(1625),
  [4780] = {.count = 1, .reusable = true}, SHIFT(2193),
  [4782] = {.count = 1, .reusable = true}, SHIFT(2194),
  [4784] = {.count = 1, .reusable = true}, SHIFT(2195),
  [4786] = {.count = 1, .reusable = false}, SHIFT(2193),
  [4788] = {.count = 1, .reusable = true}, SHIFT(2198),
  [4790] = {.count = 1, .reusable = true}, SHIFT(2199),
  [4792] = {.count = 1, .reusable = true}, SHIFT(2200),
  [4794] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4796] = {.count = 1, .reusable = false}, SHIFT(2198),
  [4798] = {.count = 1, .reusable = false}, SHIFT(2202),
  [4800] = {.count = 1, .reusable = false}, SHIFT(2204),
  [4802] = {.count = 1, .reusable = false}, SHIFT(2206),
  [4804] = {.count = 1, .reusable = true}, SHIFT(2207),
  [4806] = {.count = 1, .reusable = true}, SHIFT(2209),
  [4808] = {.count = 1, .reusable = true}, SHIFT(1637),
  [4810] = {.count = 1, .reusable = true}, SHIFT(2212),
  [4812] = {.count = 1, .reusable = true}, SHIFT(2213),
  [4814] = {.count = 1, .reusable = true}, SHIFT(2214),
  [4816] = {.count = 1, .reusable = false}, SHIFT(2212),
  [4818] = {.count = 1, .reusable = true}, SHIFT(2217),
  [4820] = {.count = 1, .reusable = true}, SHIFT(2218),
  [4822] = {.count = 1, .reusable = true}, SHIFT(2219),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2220),
  [4826] = {.count = 1, .reusable = false}, SHIFT(2217),
  [4828] = {.count = 1, .reusable = false}, SHIFT(2221),
  [4830] = {.count = 1, .reusable = false}, SHIFT(2223),
  [4832] = {.count = 1, .reusable = true}, SHIFT(2224),
  [4834] = {.count = 1, .reusable = true}, SHIFT(2225),
  [4836] = {.count = 1, .reusable = true}, SHIFT(2226),
  [4838] = {.count = 1, .reusable = false}, SHIFT(2228),
  [4840] = {.count = 1, .reusable = true}, SHIFT(2227),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2228),
  [4844] = {.count = 1, .reusable = true}, SHIFT(2229),
  [4846] = {.count = 1, .reusable = true}, SHIFT(2230),
  [4848] = {.count = 1, .reusable = true}, SHIFT(2231),
  [4850] = {.count = 1, .reusable = false}, SHIFT(2229),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2232),
  [4854] = {.count = 1, .reusable = true}, SHIFT(2233),
  [4856] = {.count = 1, .reusable = false}, SHIFT(2235),
  [4858] = {.count = 1, .reusable = true}, SHIFT(2234),
  [4860] = {.count = 1, .reusable = true}, SHIFT(2235),
  [4862] = {.count = 1, .reusable = true}, SHIFT(2236),
  [4864] = {.count = 1, .reusable = true}, SHIFT(2237),
  [4866] = {.count = 1, .reusable = true}, SHIFT(2239),
  [4868] = {.count = 1, .reusable = true}, SHIFT(2240),
  [4870] = {.count = 1, .reusable = true}, SHIFT(2241),
  [4872] = {.count = 1, .reusable = true}, SHIFT(2242),
  [4874] = {.count = 1, .reusable = true}, SHIFT(2243),
  [4876] = {.count = 1, .reusable = false}, SHIFT(2244),
  [4878] = {.count = 1, .reusable = true}, SHIFT(2245),
  [4880] = {.count = 1, .reusable = true}, SHIFT(2246),
  [4882] = {.count = 1, .reusable = true}, SHIFT(2247),
  [4884] = {.count = 1, .reusable = true}, SHIFT(2248),
  [4886] = {.count = 1, .reusable = true}, SHIFT(2250),
  [4888] = {.count = 1, .reusable = false}, SHIFT(2251),
  [4890] = {.count = 1, .reusable = true}, SHIFT(2254),
  [4892] = {.count = 1, .reusable = true}, SHIFT(2255),
  [4894] = {.count = 1, .reusable = true}, SHIFT(2256),
  [4896] = {.count = 1, .reusable = true}, SHIFT(2257),
  [4898] = {.count = 1, .reusable = false}, SHIFT(2258),
  [4900] = {.count = 1, .reusable = true}, SHIFT(2259),
  [4902] = {.count = 1, .reusable = true}, SHIFT(2260),
  [4904] = {.count = 1, .reusable = true}, SHIFT(2261),
  [4906] = {.count = 1, .reusable = true}, SHIFT(2264),
  [4908] = {.count = 1, .reusable = false}, SHIFT(2264),
  [4910] = {.count = 1, .reusable = true}, SHIFT(2267),
  [4912] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [4914] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [4916] = {.count = 1, .reusable = true}, SHIFT(2271),
  [4918] = {.count = 1, .reusable = true}, SHIFT(2272),
  [4920] = {.count = 1, .reusable = true}, SHIFT(2276),
  [4922] = {.count = 1, .reusable = false}, SHIFT(2275),
  [4924] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1679),
  [4927] = {.count = 1, .reusable = false}, SHIFT(572),
  [4929] = {.count = 1, .reusable = false}, SHIFT(2278),
  [4931] = {.count = 1, .reusable = true}, SHIFT(2277),
  [4933] = {.count = 1, .reusable = true}, SHIFT(2278),
  [4935] = {.count = 1, .reusable = true}, SHIFT(2279),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2280),
  [4939] = {.count = 1, .reusable = false}, SHIFT(2285),
  [4941] = {.count = 1, .reusable = true}, SHIFT(2283),
  [4943] = {.count = 1, .reusable = true}, SHIFT(2285),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2284),
  [4947] = {.count = 1, .reusable = true}, SHIFT(2286),
  [4949] = {.count = 1, .reusable = false}, SHIFT(2288),
  [4951] = {.count = 1, .reusable = true}, SHIFT(2287),
  [4953] = {.count = 1, .reusable = true}, SHIFT(2288),
  [4955] = {.count = 1, .reusable = true}, SHIFT(2289),
  [4957] = {.count = 1, .reusable = false}, SHIFT(2290),
  [4959] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1120),
  [4962] = {.count = 1, .reusable = false}, SHIFT(2293),
  [4964] = {.count = 1, .reusable = true}, SHIFT(2291),
  [4966] = {.count = 1, .reusable = true}, SHIFT(2293),
  [4968] = {.count = 1, .reusable = true}, SHIFT(2292),
  [4970] = {.count = 1, .reusable = true}, SHIFT(2294),
  [4972] = {.count = 1, .reusable = true}, SHIFT(2295),
  [4974] = {.count = 1, .reusable = true}, SHIFT(2296),
  [4976] = {.count = 1, .reusable = false}, SHIFT(2298),
  [4978] = {.count = 1, .reusable = true}, SHIFT(2297),
  [4980] = {.count = 1, .reusable = true}, SHIFT(2298),
  [4982] = {.count = 1, .reusable = true}, SHIFT(2299),
  [4984] = {.count = 1, .reusable = false}, SHIFT(2304),
  [4986] = {.count = 1, .reusable = true}, SHIFT(2302),
  [4988] = {.count = 1, .reusable = true}, SHIFT(2304),
  [4990] = {.count = 1, .reusable = true}, SHIFT(2303),
  [4992] = {.count = 1, .reusable = true}, SHIFT(2305),
  [4994] = {.count = 1, .reusable = true}, SHIFT(2306),
  [4996] = {.count = 1, .reusable = false}, SHIFT(2308),
  [4998] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5002] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5004] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5006] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5008] = {.count = 1, .reusable = false}, SHIFT(2309),
  [5010] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5012] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5014] = {.count = 1, .reusable = false}, SHIFT(2315),
  [5016] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5018] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5020] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [5022] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [5024] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1134),
  [5027] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1135),
  [5030] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1136),
  [5033] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [5035] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1138),
  [5038] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1724),
  [5041] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 5),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5045] = {.count = 1, .reusable = false}, SHIFT(2316),
  [5047] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5049] = {.count = 1, .reusable = false}, SHIFT(2318),
  [5051] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5053] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5055] = {.count = 1, .reusable = false}, SHIFT(2321),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5059] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5061] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5063] = {.count = 1, .reusable = true}, SHIFT(2323),
  [5065] = {.count = 1, .reusable = false}, SHIFT(2324),
  [5067] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5069] = {.count = 1, .reusable = true}, SHIFT(2325),
  [5071] = {.count = 1, .reusable = false}, SHIFT(2327),
  [5073] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5075] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5077] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5079] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5081] = {.count = 1, .reusable = false}, SHIFT(2330),
  [5083] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5085] = {.count = 1, .reusable = true}, SHIFT(2331),
  [5087] = {.count = 1, .reusable = false}, SHIFT(2333),
  [5089] = {.count = 1, .reusable = true}, SHIFT(2332),
  [5091] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5093] = {.count = 1, .reusable = true}, SHIFT(2334),
  [5095] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [5097] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [5099] = {.count = 1, .reusable = false}, SHIFT(714),
  [5101] = {.count = 1, .reusable = false}, SHIFT(2336),
  [5103] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5105] = {.count = 1, .reusable = true}, SHIFT(2336),
  [5107] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5109] = {.count = 1, .reusable = true}, SHIFT(2338),
  [5111] = {.count = 1, .reusable = false}, SHIFT(2343),
  [5113] = {.count = 1, .reusable = true}, SHIFT(2341),
  [5115] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5117] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5119] = {.count = 1, .reusable = true}, SHIFT(2344),
  [5121] = {.count = 1, .reusable = false}, SHIFT(2346),
  [5123] = {.count = 1, .reusable = true}, SHIFT(2345),
  [5125] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5127] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5129] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [5131] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [5133] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [5135] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [5137] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5139] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5141] = {.count = 1, .reusable = false}, SHIFT(2350),
  [5143] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1238),
  [5146] = {.count = 1, .reusable = false}, SHIFT(2353),
  [5148] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5150] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5152] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5154] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5156] = {.count = 1, .reusable = true}, SHIFT(2355),
  [5158] = {.count = 1, .reusable = true}, SHIFT(2356),
  [5160] = {.count = 1, .reusable = false}, SHIFT(2358),
  [5162] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5164] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5166] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5168] = {.count = 1, .reusable = false}, SHIFT(2364),
  [5170] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5172] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5174] = {.count = 1, .reusable = true}, SHIFT(2363),
  [5176] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [5178] = {.count = 1, .reusable = true}, SHIFT(2365),
  [5180] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [5182] = {.count = 1, .reusable = true}, SHIFT(2366),
  [5184] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [5186] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [5188] = {.count = 1, .reusable = false}, SHIFT(763),
  [5190] = {.count = 1, .reusable = false}, SHIFT(762),
  [5192] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5194] = {.count = 1, .reusable = false}, SHIFT(2369),
  [5196] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5198] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5200] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5202] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5204] = {.count = 1, .reusable = false}, SHIFT(2376),
  [5206] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5208] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5210] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5212] = {.count = 1, .reusable = true}, SHIFT(2377),
  [5214] = {.count = 1, .reusable = false}, SHIFT(2379),
  [5216] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5218] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5220] = {.count = 1, .reusable = false}, SHIFT(782),
  [5222] = {.count = 1, .reusable = false}, SHIFT(781),
  [5224] = {.count = 1, .reusable = false}, SHIFT(2381),
  [5226] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5228] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5230] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5232] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5234] = {.count = 1, .reusable = false}, SHIFT(2388),
  [5236] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5238] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5240] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5242] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5244] = {.count = 1, .reusable = false}, SHIFT(2391),
  [5246] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5248] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5250] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5252] = {.count = 1, .reusable = false}, SHIFT(2393),
  [5254] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5256] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5258] = {.count = 1, .reusable = false}, SHIFT(2396),
  [5260] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5262] = {.count = 1, .reusable = true}, SHIFT(2396),
  [5264] = {.count = 1, .reusable = true}, SHIFT(2397),
  [5266] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5268] = {.count = 1, .reusable = false}, SHIFT(2400),
  [5270] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5272] = {.count = 1, .reusable = false}, SHIFT(2403),
  [5274] = {.count = 1, .reusable = true}, SHIFT(2403),
  [5276] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5278] = {.count = 1, .reusable = false}, SHIFT(2407),
  [5280] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1330),
  [5283] = {.count = 1, .reusable = false}, SHIFT(2410),
  [5285] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5287] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5289] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5291] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5293] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5295] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5297] = {.count = 1, .reusable = false}, SHIFT(2415),
  [5299] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5301] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5303] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5305] = {.count = 1, .reusable = false}, SHIFT(2421),
  [5307] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5309] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5311] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5313] = {.count = 1, .reusable = true}, SHIFT(2423),
  [5315] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5317] = {.count = 1, .reusable = false}, SHIFT(2427),
  [5319] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5321] = {.count = 1, .reusable = false}, SHIFT(2429),
  [5323] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1356),
  [5326] = {.count = 1, .reusable = false}, SHIFT(2432),
  [5328] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5330] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5332] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5334] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5336] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5338] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5340] = {.count = 1, .reusable = false}, SHIFT(2437),
  [5342] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5344] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5346] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5348] = {.count = 1, .reusable = false}, SHIFT(2443),
  [5350] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5352] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5354] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5356] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5358] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5360] = {.count = 1, .reusable = false}, SHIFT(2446),
  [5362] = {.count = 1, .reusable = true}, SHIFT(1387),
  [5364] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5366] = {.count = 1, .reusable = true}, SHIFT(1390),
  [5368] = {.count = 1, .reusable = true}, SHIFT(1393),
  [5370] = {.count = 1, .reusable = true}, SHIFT(1395),
  [5372] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5374] = {.count = 1, .reusable = true}, SHIFT(2450),
  [5376] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5378] = {.count = 1, .reusable = true}, SHIFT(2452),
  [5380] = {.count = 1, .reusable = true}, SHIFT(1394),
  [5382] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5384] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5386] = {.count = 1, .reusable = false}, SHIFT(2457),
  [5388] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5390] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5392] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5394] = {.count = 1, .reusable = true}, SHIFT(2459),
  [5396] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5398] = {.count = 1, .reusable = false}, SHIFT(2458),
  [5400] = {.count = 1, .reusable = true}, SHIFT(2461),
  [5402] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5404] = {.count = 1, .reusable = false}, SHIFT(2464),
  [5406] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5408] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5410] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1929),
  [5413] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1392),
  [5416] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1393),
  [5419] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1395),
  [5422] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1390),
  [5425] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1931),
  [5428] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1389),
  [5431] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1394),
  [5434] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1387),
  [5437] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1391),
  [5440] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1388),
  [5443] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5445] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5447] = {.count = 1, .reusable = false}, SHIFT(2467),
  [5449] = {.count = 1, .reusable = true}, SHIFT(1399),
  [5451] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5453] = {.count = 1, .reusable = true}, SHIFT(1402),
  [5455] = {.count = 1, .reusable = true}, SHIFT(1404),
  [5457] = {.count = 1, .reusable = true}, SHIFT(1406),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5461] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5463] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5465] = {.count = 1, .reusable = false}, SHIFT(2474),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5469] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5471] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5473] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5475] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5477] = {.count = 1, .reusable = false}, SHIFT(2475),
  [5479] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5481] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5483] = {.count = 1, .reusable = false}, SHIFT(2481),
  [5485] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5487] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5489] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1948),
  [5492] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1403),
  [5495] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1404),
  [5498] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1406),
  [5501] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1402),
  [5504] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1950),
  [5507] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1401),
  [5510] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1405),
  [5513] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1399),
  [5516] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1400),
  [5519] = {.count = 1, .reusable = false}, SHIFT(2483),
  [5521] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5523] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5525] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5527] = {.count = 1, .reusable = true}, SHIFT(1954),
  [5529] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5531] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5533] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5535] = {.count = 1, .reusable = false}, SHIFT(2490),
  [5537] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5539] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5543] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5545] = {.count = 1, .reusable = false}, SHIFT(2495),
  [5547] = {.count = 1, .reusable = false}, SHIFT(2499),
  [5549] = {.count = 1, .reusable = false}, SHIFT(2501),
  [5551] = {.count = 1, .reusable = false}, SHIFT(2503),
  [5553] = {.count = 1, .reusable = true}, SHIFT(2504),
  [5555] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5557] = {.count = 1, .reusable = true}, SHIFT(1966),
  [5559] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5561] = {.count = 1, .reusable = true}, SHIFT(2510),
  [5563] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5565] = {.count = 1, .reusable = false}, SHIFT(2509),
  [5567] = {.count = 1, .reusable = true}, SHIFT(2514),
  [5569] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5571] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5573] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5575] = {.count = 1, .reusable = false}, SHIFT(2514),
  [5577] = {.count = 1, .reusable = false}, SHIFT(2518),
  [5579] = {.count = 1, .reusable = false}, SHIFT(2520),
  [5581] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5583] = {.count = 1, .reusable = true}, SHIFT(2522),
  [5585] = {.count = 1, .reusable = true}, SHIFT(2523),
  [5587] = {.count = 1, .reusable = false}, SHIFT(2525),
  [5589] = {.count = 1, .reusable = true}, SHIFT(2524),
  [5591] = {.count = 1, .reusable = true}, SHIFT(2525),
  [5593] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5595] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5597] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5599] = {.count = 1, .reusable = false}, SHIFT(2526),
  [5601] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5603] = {.count = 1, .reusable = true}, SHIFT(2530),
  [5605] = {.count = 1, .reusable = false}, SHIFT(2532),
  [5607] = {.count = 1, .reusable = true}, SHIFT(2531),
  [5609] = {.count = 1, .reusable = true}, SHIFT(2532),
  [5611] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5613] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5615] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5617] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5619] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5621] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5623] = {.count = 1, .reusable = true}, SHIFT(2540),
  [5625] = {.count = 1, .reusable = false}, SHIFT(2541),
  [5627] = {.count = 1, .reusable = true}, SHIFT(2542),
  [5629] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5631] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5633] = {.count = 1, .reusable = true}, SHIFT(2545),
  [5635] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5637] = {.count = 1, .reusable = false}, SHIFT(2548),
  [5639] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5641] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5643] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5645] = {.count = 1, .reusable = false}, SHIFT(2555),
  [5647] = {.count = 1, .reusable = true}, SHIFT(2558),
  [5649] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5651] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5653] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5655] = {.count = 1, .reusable = false}, SHIFT(2566),
  [5657] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2007),
  [5660] = {.count = 1, .reusable = false}, SHIFT(2570),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5664] = {.count = 1, .reusable = true}, SHIFT(2570),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5668] = {.count = 1, .reusable = true}, SHIFT(2571),
  [5670] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5672] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5674] = {.count = 1, .reusable = false}, SHIFT(2575),
  [5676] = {.count = 1, .reusable = true}, SHIFT(2574),
  [5678] = {.count = 1, .reusable = true}, SHIFT(2575),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2576),
  [5682] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5684] = {.count = 1, .reusable = true}, SHIFT(2579),
  [5686] = {.count = 1, .reusable = true}, SHIFT(2581),
  [5688] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5690] = {.count = 1, .reusable = false}, SHIFT(2582),
  [5692] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1441),
  [5695] = {.count = 1, .reusable = true}, SHIFT(2583),
  [5697] = {.count = 1, .reusable = false}, SHIFT(2586),
  [5699] = {.count = 1, .reusable = true}, SHIFT(2587),
  [5701] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5703] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5705] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5707] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5709] = {.count = 1, .reusable = false}, SHIFT(2592),
  [5711] = {.count = 1, .reusable = true}, SHIFT(2597),
  [5713] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5715] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5717] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5719] = {.count = 1, .reusable = false}, SHIFT(2597),
  [5721] = {.count = 1, .reusable = false}, SHIFT(2601),
  [5723] = {.count = 1, .reusable = true}, SHIFT(2603),
  [5725] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [5727] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5729] = {.count = 1, .reusable = false}, SHIFT(2607),
  [5731] = {.count = 1, .reusable = true}, SHIFT(2608),
  [5733] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1450),
  [5736] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1453),
  [5739] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1455),
  [5742] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [5744] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5748] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(891),
  [5751] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(893),
  [5754] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(895),
  [5757] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(892),
  [5760] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1462),
  [5763] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1463),
  [5766] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(898),
  [5769] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(900),
  [5772] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(903),
  [5775] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [5777] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [5779] = {.count = 1, .reusable = true}, SHIFT(2612),
  [5781] = {.count = 1, .reusable = true}, SHIFT(2614),
  [5783] = {.count = 1, .reusable = false}, SHIFT(2617),
  [5785] = {.count = 1, .reusable = false}, SHIFT(2618),
  [5787] = {.count = 1, .reusable = false}, SHIFT(2619),
  [5789] = {.count = 1, .reusable = true}, SHIFT(2620),
  [5791] = {.count = 1, .reusable = true}, SHIFT(2621),
  [5793] = {.count = 1, .reusable = true}, SHIFT(2622),
  [5795] = {.count = 1, .reusable = false}, SHIFT(2623),
  [5797] = {.count = 1, .reusable = false}, SHIFT(2624),
  [5799] = {.count = 1, .reusable = true}, SHIFT(2625),
  [5801] = {.count = 1, .reusable = true}, SHIFT(2626),
  [5803] = {.count = 1, .reusable = false}, SHIFT(2627),
  [5805] = {.count = 1, .reusable = true}, SHIFT(2628),
  [5807] = {.count = 1, .reusable = true}, SHIFT(2629),
  [5809] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [5811] = {.count = 1, .reusable = true}, SHIFT(2630),
  [5813] = {.count = 1, .reusable = true}, SHIFT(2641),
  [5815] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [5817] = {.count = 1, .reusable = true}, SHIFT(2643),
  [5819] = {.count = 1, .reusable = true}, SHIFT(2645),
  [5821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(161),
  [5824] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(159),
  [5827] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2646),
  [5830] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(162),
  [5833] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(163),
  [5836] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(164),
  [5839] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1474),
  [5842] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(166),
  [5845] = {.count = 1, .reusable = true}, SHIFT(2649),
  [5847] = {.count = 1, .reusable = false}, SHIFT(2650),
  [5849] = {.count = 1, .reusable = true}, SHIFT(2650),
  [5851] = {.count = 1, .reusable = true}, SHIFT(2651),
  [5853] = {.count = 1, .reusable = false}, SHIFT(2653),
  [5855] = {.count = 1, .reusable = true}, SHIFT(2652),
  [5857] = {.count = 1, .reusable = true}, SHIFT(2653),
  [5859] = {.count = 1, .reusable = true}, SHIFT(2654),
  [5861] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [5863] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [5865] = {.count = 1, .reusable = true}, SHIFT(2655),
  [5867] = {.count = 1, .reusable = true}, SHIFT(2657),
  [5869] = {.count = 1, .reusable = false}, SHIFT(2658),
  [5871] = {.count = 1, .reusable = true}, SHIFT(2658),
  [5873] = {.count = 1, .reusable = true}, SHIFT(2659),
  [5875] = {.count = 1, .reusable = false}, SHIFT(2661),
  [5877] = {.count = 1, .reusable = true}, SHIFT(2660),
  [5879] = {.count = 1, .reusable = true}, SHIFT(2661),
  [5881] = {.count = 1, .reusable = true}, SHIFT(2662),
  [5883] = {.count = 1, .reusable = true}, SHIFT(2663),
  [5885] = {.count = 1, .reusable = false}, SHIFT(2664),
  [5887] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1527),
  [5890] = {.count = 1, .reusable = false}, SHIFT(2667),
  [5892] = {.count = 1, .reusable = true}, SHIFT(2665),
  [5894] = {.count = 1, .reusable = true}, SHIFT(2667),
  [5896] = {.count = 1, .reusable = true}, SHIFT(2666),
  [5898] = {.count = 1, .reusable = true}, SHIFT(2668),
  [5900] = {.count = 1, .reusable = true}, SHIFT(2669),
  [5902] = {.count = 1, .reusable = true}, SHIFT(2670),
  [5904] = {.count = 1, .reusable = false}, SHIFT(2672),
  [5906] = {.count = 1, .reusable = true}, SHIFT(2671),
  [5908] = {.count = 1, .reusable = true}, SHIFT(2672),
  [5910] = {.count = 1, .reusable = true}, SHIFT(2673),
  [5912] = {.count = 1, .reusable = false}, SHIFT(2678),
  [5914] = {.count = 1, .reusable = true}, SHIFT(2676),
  [5916] = {.count = 1, .reusable = true}, SHIFT(2678),
  [5918] = {.count = 1, .reusable = true}, SHIFT(2677),
  [5920] = {.count = 1, .reusable = false}, SHIFT(1004),
  [5922] = {.count = 1, .reusable = false}, SHIFT(1003),
  [5924] = {.count = 1, .reusable = false}, SHIFT(514),
  [5926] = {.count = 1, .reusable = false}, SHIFT(2680),
  [5928] = {.count = 1, .reusable = true}, SHIFT(2679),
  [5930] = {.count = 1, .reusable = true}, SHIFT(2680),
  [5932] = {.count = 1, .reusable = true}, SHIFT(2681),
  [5934] = {.count = 1, .reusable = true}, SHIFT(2682),
  [5936] = {.count = 1, .reusable = false}, SHIFT(2687),
  [5938] = {.count = 1, .reusable = true}, SHIFT(2685),
  [5940] = {.count = 1, .reusable = true}, SHIFT(2687),
  [5942] = {.count = 1, .reusable = true}, SHIFT(2686),
  [5944] = {.count = 1, .reusable = true}, SHIFT(2688),
  [5946] = {.count = 1, .reusable = false}, SHIFT(2690),
  [5948] = {.count = 1, .reusable = true}, SHIFT(2689),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2690),
  [5952] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [5954] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2691),
  [5958] = {.count = 1, .reusable = false}, SHIFT(2692),
  [5960] = {.count = 1, .reusable = true}, SHIFT(2692),
  [5962] = {.count = 1, .reusable = true}, SHIFT(2693),
  [5964] = {.count = 1, .reusable = false}, SHIFT(2695),
  [5966] = {.count = 1, .reusable = true}, SHIFT(2694),
  [5968] = {.count = 1, .reusable = true}, SHIFT(2695),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2696),
  [5972] = {.count = 1, .reusable = true}, SHIFT(2697),
  [5974] = {.count = 1, .reusable = false}, SHIFT(2698),
  [5976] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1584),
  [5979] = {.count = 1, .reusable = false}, SHIFT(2701),
  [5981] = {.count = 1, .reusable = true}, SHIFT(2699),
  [5983] = {.count = 1, .reusable = true}, SHIFT(2701),
  [5985] = {.count = 1, .reusable = true}, SHIFT(2700),
  [5987] = {.count = 1, .reusable = true}, SHIFT(2702),
  [5989] = {.count = 1, .reusable = true}, SHIFT(2703),
  [5991] = {.count = 1, .reusable = true}, SHIFT(2704),
  [5993] = {.count = 1, .reusable = false}, SHIFT(2706),
  [5995] = {.count = 1, .reusable = true}, SHIFT(2705),
  [5997] = {.count = 1, .reusable = true}, SHIFT(2706),
  [5999] = {.count = 1, .reusable = true}, SHIFT(2707),
  [6001] = {.count = 1, .reusable = false}, SHIFT(2712),
  [6003] = {.count = 1, .reusable = true}, SHIFT(2710),
  [6005] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6007] = {.count = 1, .reusable = true}, SHIFT(2711),
  [6009] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [6011] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [6013] = {.count = 1, .reusable = false}, SHIFT(1055),
  [6015] = {.count = 1, .reusable = false}, SHIFT(1054),
  [6017] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 6),
  [6019] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 6),
  [6021] = {.count = 1, .reusable = true}, SHIFT(2714),
  [6023] = {.count = 1, .reusable = true}, SHIFT(2715),
  [6025] = {.count = 1, .reusable = false}, SHIFT(2717),
  [6027] = {.count = 1, .reusable = true}, SHIFT(2716),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2717),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2718),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2719),
  [6035] = {.count = 1, .reusable = false}, SHIFT(2724),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2722),
  [6039] = {.count = 1, .reusable = true}, SHIFT(2724),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2723),
  [6043] = {.count = 1, .reusable = true}, SHIFT(2725),
  [6045] = {.count = 1, .reusable = false}, SHIFT(2727),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2726),
  [6049] = {.count = 1, .reusable = true}, SHIFT(2727),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2729),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2730),
  [6055] = {.count = 1, .reusable = false}, SHIFT(2731),
  [6057] = {.count = 1, .reusable = true}, SHIFT(1624),
  [6059] = {.count = 1, .reusable = true}, SHIFT(2732),
  [6061] = {.count = 1, .reusable = true}, SHIFT(1627),
  [6063] = {.count = 1, .reusable = true}, SHIFT(1630),
  [6065] = {.count = 1, .reusable = true}, SHIFT(1632),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2733),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2735),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2736),
  [6073] = {.count = 1, .reusable = true}, SHIFT(2737),
  [6075] = {.count = 1, .reusable = true}, SHIFT(1631),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2738),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2740),
  [6081] = {.count = 1, .reusable = false}, SHIFT(2742),
  [6083] = {.count = 1, .reusable = true}, SHIFT(2741),
  [6085] = {.count = 1, .reusable = true}, SHIFT(2742),
  [6087] = {.count = 1, .reusable = true}, SHIFT(2743),
  [6089] = {.count = 1, .reusable = true}, SHIFT(2744),
  [6091] = {.count = 1, .reusable = true}, SHIFT(2745),
  [6093] = {.count = 1, .reusable = false}, SHIFT(2743),
  [6095] = {.count = 1, .reusable = true}, SHIFT(2746),
  [6097] = {.count = 1, .reusable = true}, SHIFT(2747),
  [6099] = {.count = 1, .reusable = false}, SHIFT(2749),
  [6101] = {.count = 1, .reusable = true}, SHIFT(2748),
  [6103] = {.count = 1, .reusable = true}, SHIFT(2749),
  [6105] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2202),
  [6108] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1629),
  [6111] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1627),
  [6114] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1630),
  [6117] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1632),
  [6120] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2204),
  [6123] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1626),
  [6126] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1631),
  [6129] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1624),
  [6132] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1628),
  [6135] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1625),
  [6138] = {.count = 1, .reusable = true}, SHIFT(2750),
  [6140] = {.count = 1, .reusable = true}, SHIFT(2751),
  [6142] = {.count = 1, .reusable = false}, SHIFT(2752),
  [6144] = {.count = 1, .reusable = true}, SHIFT(1636),
  [6146] = {.count = 1, .reusable = true}, SHIFT(2753),
  [6148] = {.count = 1, .reusable = true}, SHIFT(1639),
  [6150] = {.count = 1, .reusable = true}, SHIFT(1641),
  [6152] = {.count = 1, .reusable = true}, SHIFT(1643),
  [6154] = {.count = 1, .reusable = true}, SHIFT(2754),
  [6156] = {.count = 1, .reusable = true}, SHIFT(2756),
  [6158] = {.count = 1, .reusable = true}, SHIFT(2757),
  [6160] = {.count = 1, .reusable = false}, SHIFT(2759),
  [6162] = {.count = 1, .reusable = true}, SHIFT(2758),
  [6164] = {.count = 1, .reusable = true}, SHIFT(2759),
  [6166] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6168] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6170] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6172] = {.count = 1, .reusable = false}, SHIFT(2760),
  [6174] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6176] = {.count = 1, .reusable = true}, SHIFT(2764),
  [6178] = {.count = 1, .reusable = false}, SHIFT(2766),
  [6180] = {.count = 1, .reusable = true}, SHIFT(2765),
  [6182] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6184] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2221),
  [6187] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1640),
  [6190] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1639),
  [6193] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1641),
  [6196] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1643),
  [6199] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2223),
  [6202] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1638),
  [6205] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1642),
  [6208] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1636),
  [6211] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1637),
  [6214] = {.count = 1, .reusable = false}, SHIFT(2769),
  [6216] = {.count = 1, .reusable = true}, SHIFT(2767),
  [6218] = {.count = 1, .reusable = true}, SHIFT(2769),
  [6220] = {.count = 1, .reusable = true}, SHIFT(2768),
  [6222] = {.count = 1, .reusable = true}, SHIFT(2770),
  [6224] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6226] = {.count = 1, .reusable = true}, SHIFT(2772),
  [6228] = {.count = 1, .reusable = false}, SHIFT(2774),
  [6230] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6232] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6234] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6236] = {.count = 1, .reusable = false}, SHIFT(2780),
  [6238] = {.count = 1, .reusable = true}, SHIFT(2778),
  [6240] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6242] = {.count = 1, .reusable = true}, SHIFT(2779),
  [6244] = {.count = 1, .reusable = false}, SHIFT(2781),
  [6246] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1656),
  [6249] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6251] = {.count = 1, .reusable = false}, SHIFT(2785),
  [6253] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6255] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6257] = {.count = 1, .reusable = true}, SHIFT(2791),
  [6259] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6261] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6263] = {.count = 1, .reusable = false}, SHIFT(2791),
  [6265] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6267] = {.count = 1, .reusable = true}, SHIFT(2797),
  [6269] = {.count = 1, .reusable = true}, SHIFT(2798),
  [6271] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6273] = {.count = 1, .reusable = false}, SHIFT(2796),
  [6275] = {.count = 1, .reusable = false}, SHIFT(2800),
  [6277] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6279] = {.count = 1, .reusable = false}, SHIFT(2804),
  [6281] = {.count = 1, .reusable = true}, SHIFT(2805),
  [6283] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6287] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6289] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6291] = {.count = 1, .reusable = false}, SHIFT(2810),
  [6293] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6295] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6299] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6301] = {.count = 1, .reusable = false}, SHIFT(2815),
  [6303] = {.count = 1, .reusable = false}, SHIFT(2820),
  [6305] = {.count = 1, .reusable = true}, SHIFT(2820),
  [6307] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6309] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1664),
  [6312] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1667),
  [6315] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1669),
  [6318] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1074),
  [6321] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1075),
  [6324] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1076),
  [6327] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1078),
  [6330] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1673),
  [6333] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1674),
  [6336] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1080),
  [6339] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1082),
  [6342] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1085),
  [6345] = {.count = 1, .reusable = true}, SHIFT(2824),
  [6347] = {.count = 1, .reusable = false}, SHIFT(2825),
  [6349] = {.count = 1, .reusable = true}, SHIFT(2825),
  [6351] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6353] = {.count = 1, .reusable = false}, SHIFT(2828),
  [6355] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6357] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6359] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6361] = {.count = 1, .reusable = false}, SHIFT(1125),
  [6363] = {.count = 1, .reusable = false}, SHIFT(1124),
  [6365] = {.count = 1, .reusable = false}, SHIFT(592),
  [6367] = {.count = 1, .reusable = false}, SHIFT(2831),
  [6369] = {.count = 1, .reusable = true}, SHIFT(2830),
  [6371] = {.count = 1, .reusable = true}, SHIFT(2831),
  [6373] = {.count = 1, .reusable = true}, SHIFT(2832),
  [6375] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6377] = {.count = 1, .reusable = false}, SHIFT(2838),
  [6379] = {.count = 1, .reusable = true}, SHIFT(2836),
  [6381] = {.count = 1, .reusable = true}, SHIFT(2838),
  [6383] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6385] = {.count = 1, .reusable = true}, SHIFT(2839),
  [6387] = {.count = 1, .reusable = false}, SHIFT(2841),
  [6389] = {.count = 1, .reusable = true}, SHIFT(2840),
  [6391] = {.count = 1, .reusable = true}, SHIFT(2841),
  [6393] = {.count = 1, .reusable = false}, SHIFT(2844),
  [6395] = {.count = 1, .reusable = true}, SHIFT(2842),
  [6397] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6399] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6401] = {.count = 1, .reusable = true}, SHIFT(2845),
  [6403] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6405] = {.count = 1, .reusable = true}, SHIFT(2847),
  [6407] = {.count = 1, .reusable = false}, SHIFT(2849),
  [6409] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6411] = {.count = 1, .reusable = true}, SHIFT(2849),
  [6413] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6415] = {.count = 1, .reusable = false}, SHIFT(2855),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6419] = {.count = 1, .reusable = true}, SHIFT(2855),
  [6421] = {.count = 1, .reusable = true}, SHIFT(2854),
  [6423] = {.count = 1, .reusable = true}, SHIFT(2856),
  [6425] = {.count = 1, .reusable = true}, SHIFT(2857),
  [6427] = {.count = 1, .reusable = true}, SHIFT(2858),
  [6429] = {.count = 1, .reusable = true}, SHIFT(2859),
  [6431] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6433] = {.count = 1, .reusable = true}, SHIFT(2861),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2862),
  [6437] = {.count = 1, .reusable = false}, SHIFT(2863),
  [6439] = {.count = 1, .reusable = true}, SHIFT(2863),
  [6441] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6443] = {.count = 1, .reusable = false}, SHIFT(2866),
  [6445] = {.count = 1, .reusable = true}, SHIFT(2865),
  [6447] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6449] = {.count = 1, .reusable = true}, SHIFT(2867),
  [6451] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7),
  [6453] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7),
  [6455] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [6457] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [6459] = {.count = 1, .reusable = false}, SHIFT(2869),
  [6461] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6463] = {.count = 1, .reusable = true}, SHIFT(2869),
  [6465] = {.count = 1, .reusable = true}, SHIFT(2870),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2871),
  [6469] = {.count = 1, .reusable = false}, SHIFT(2876),
  [6471] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6473] = {.count = 1, .reusable = true}, SHIFT(2876),
  [6475] = {.count = 1, .reusable = true}, SHIFT(2875),
  [6477] = {.count = 1, .reusable = true}, SHIFT(2877),
  [6479] = {.count = 1, .reusable = false}, SHIFT(2879),
  [6481] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6485] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [6487] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [6489] = {.count = 1, .reusable = true}, SHIFT(2880),
  [6491] = {.count = 1, .reusable = false}, SHIFT(2881),
  [6493] = {.count = 1, .reusable = true}, SHIFT(2881),
  [6495] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6497] = {.count = 1, .reusable = false}, SHIFT(2884),
  [6499] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6501] = {.count = 1, .reusable = true}, SHIFT(2884),
  [6503] = {.count = 1, .reusable = true}, SHIFT(2885),
  [6505] = {.count = 1, .reusable = true}, SHIFT(2886),
  [6507] = {.count = 1, .reusable = false}, SHIFT(2887),
  [6509] = {.count = 1, .reusable = true}, SHIFT(2887),
  [6511] = {.count = 1, .reusable = true}, SHIFT(2888),
  [6513] = {.count = 1, .reusable = false}, SHIFT(2890),
  [6515] = {.count = 1, .reusable = true}, SHIFT(2889),
  [6517] = {.count = 1, .reusable = true}, SHIFT(2890),
  [6519] = {.count = 1, .reusable = true}, SHIFT(2891),
  [6521] = {.count = 1, .reusable = true}, SHIFT(2892),
  [6523] = {.count = 1, .reusable = true}, SHIFT(2893),
  [6525] = {.count = 1, .reusable = true}, SHIFT(2894),
  [6527] = {.count = 1, .reusable = true}, SHIFT(2895),
  [6529] = {.count = 1, .reusable = true}, SHIFT(2897),
  [6531] = {.count = 1, .reusable = false}, SHIFT(1335),
  [6533] = {.count = 1, .reusable = false}, SHIFT(1334),
  [6535] = {.count = 1, .reusable = false}, SHIFT(819),
  [6537] = {.count = 1, .reusable = false}, SHIFT(2900),
  [6539] = {.count = 1, .reusable = true}, SHIFT(2899),
  [6541] = {.count = 1, .reusable = true}, SHIFT(2900),
  [6543] = {.count = 1, .reusable = true}, SHIFT(2901),
  [6545] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6547] = {.count = 1, .reusable = false}, SHIFT(2907),
  [6549] = {.count = 1, .reusable = true}, SHIFT(2905),
  [6551] = {.count = 1, .reusable = true}, SHIFT(2907),
  [6553] = {.count = 1, .reusable = true}, SHIFT(2906),
  [6555] = {.count = 1, .reusable = true}, SHIFT(2908),
  [6557] = {.count = 1, .reusable = false}, SHIFT(2910),
  [6559] = {.count = 1, .reusable = true}, SHIFT(2909),
  [6561] = {.count = 1, .reusable = true}, SHIFT(2910),
  [6563] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6565] = {.count = 1, .reusable = true}, SHIFT(2913),
  [6567] = {.count = 1, .reusable = false}, SHIFT(1361),
  [6569] = {.count = 1, .reusable = false}, SHIFT(1360),
  [6571] = {.count = 1, .reusable = false}, SHIFT(839),
  [6573] = {.count = 1, .reusable = false}, SHIFT(2916),
  [6575] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6577] = {.count = 1, .reusable = true}, SHIFT(2916),
  [6579] = {.count = 1, .reusable = true}, SHIFT(2917),
  [6581] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6583] = {.count = 1, .reusable = false}, SHIFT(2923),
  [6585] = {.count = 1, .reusable = true}, SHIFT(2921),
  [6587] = {.count = 1, .reusable = true}, SHIFT(2923),
  [6589] = {.count = 1, .reusable = true}, SHIFT(2922),
  [6591] = {.count = 1, .reusable = true}, SHIFT(2924),
  [6593] = {.count = 1, .reusable = false}, SHIFT(2926),
  [6595] = {.count = 1, .reusable = true}, SHIFT(2925),
  [6597] = {.count = 1, .reusable = true}, SHIFT(2926),
  [6599] = {.count = 1, .reusable = true}, SHIFT(2927),
  [6601] = {.count = 1, .reusable = false}, SHIFT(2928),
  [6603] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1916),
  [6606] = {.count = 1, .reusable = true}, SHIFT(2929),
  [6608] = {.count = 1, .reusable = false}, SHIFT(2933),
  [6610] = {.count = 1, .reusable = true}, SHIFT(2931),
  [6612] = {.count = 1, .reusable = true}, SHIFT(2933),
  [6614] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6616] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6618] = {.count = 1, .reusable = true}, SHIFT(2935),
  [6620] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6622] = {.count = 1, .reusable = false}, SHIFT(2938),
  [6624] = {.count = 1, .reusable = true}, SHIFT(2937),
  [6626] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6628] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6630] = {.count = 1, .reusable = false}, SHIFT(2944),
  [6632] = {.count = 1, .reusable = true}, SHIFT(2942),
  [6634] = {.count = 1, .reusable = true}, SHIFT(2944),
  [6636] = {.count = 1, .reusable = true}, SHIFT(2943),
  [6638] = {.count = 1, .reusable = true}, SHIFT(2945),
  [6640] = {.count = 1, .reusable = false}, SHIFT(2946),
  [6642] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1936),
  [6645] = {.count = 1, .reusable = false}, SHIFT(2949),
  [6647] = {.count = 1, .reusable = true}, SHIFT(2947),
  [6649] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6651] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6653] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6655] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6657] = {.count = 1, .reusable = true}, SHIFT(2952),
  [6659] = {.count = 1, .reusable = false}, SHIFT(2954),
  [6661] = {.count = 1, .reusable = true}, SHIFT(2953),
  [6663] = {.count = 1, .reusable = true}, SHIFT(2954),
  [6665] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6667] = {.count = 1, .reusable = false}, SHIFT(2960),
  [6669] = {.count = 1, .reusable = true}, SHIFT(2958),
  [6671] = {.count = 1, .reusable = true}, SHIFT(2960),
  [6673] = {.count = 1, .reusable = true}, SHIFT(2959),
  [6675] = {.count = 1, .reusable = true}, SHIFT(2961),
  [6677] = {.count = 1, .reusable = true}, SHIFT(2962),
  [6679] = {.count = 1, .reusable = false}, SHIFT(2963),
  [6681] = {.count = 1, .reusable = true}, SHIFT(1953),
  [6683] = {.count = 1, .reusable = true}, SHIFT(2964),
  [6685] = {.count = 1, .reusable = true}, SHIFT(1956),
  [6687] = {.count = 1, .reusable = true}, SHIFT(1959),
  [6689] = {.count = 1, .reusable = true}, SHIFT(1961),
  [6691] = {.count = 1, .reusable = true}, SHIFT(2965),
  [6693] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6695] = {.count = 1, .reusable = true}, SHIFT(2968),
  [6697] = {.count = 1, .reusable = true}, SHIFT(2969),
  [6699] = {.count = 1, .reusable = true}, SHIFT(1960),
  [6701] = {.count = 1, .reusable = true}, SHIFT(2970),
  [6703] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6705] = {.count = 1, .reusable = false}, SHIFT(2974),
  [6707] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6709] = {.count = 1, .reusable = true}, SHIFT(2974),
  [6711] = {.count = 1, .reusable = true}, SHIFT(2975),
  [6713] = {.count = 1, .reusable = true}, SHIFT(2976),
  [6715] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6717] = {.count = 1, .reusable = false}, SHIFT(2975),
  [6719] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6721] = {.count = 1, .reusable = true}, SHIFT(2979),
  [6723] = {.count = 1, .reusable = false}, SHIFT(2981),
  [6725] = {.count = 1, .reusable = true}, SHIFT(2980),
  [6727] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6729] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2499),
  [6732] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1958),
  [6735] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1959),
  [6738] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1956),
  [6741] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1961),
  [6744] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2501),
  [6747] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1955),
  [6750] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1960),
  [6753] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1953),
  [6756] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1957),
  [6759] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1954),
  [6762] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6764] = {.count = 1, .reusable = true}, SHIFT(2983),
  [6766] = {.count = 1, .reusable = false}, SHIFT(2984),
  [6768] = {.count = 1, .reusable = true}, SHIFT(1965),
  [6770] = {.count = 1, .reusable = true}, SHIFT(2985),
  [6772] = {.count = 1, .reusable = true}, SHIFT(1968),
  [6774] = {.count = 1, .reusable = true}, SHIFT(1970),
  [6776] = {.count = 1, .reusable = true}, SHIFT(1972),
  [6778] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6780] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6782] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6784] = {.count = 1, .reusable = false}, SHIFT(2991),
  [6786] = {.count = 1, .reusable = true}, SHIFT(2990),
  [6788] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6790] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6792] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6794] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6796] = {.count = 1, .reusable = false}, SHIFT(2992),
  [6798] = {.count = 1, .reusable = true}, SHIFT(2995),
  [6800] = {.count = 1, .reusable = true}, SHIFT(2996),
  [6802] = {.count = 1, .reusable = false}, SHIFT(2998),
  [6804] = {.count = 1, .reusable = true}, SHIFT(2997),
  [6806] = {.count = 1, .reusable = true}, SHIFT(2998),
  [6808] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2518),
  [6811] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1969),
  [6814] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1970),
  [6817] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1968),
  [6820] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1972),
  [6823] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2520),
  [6826] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1967),
  [6829] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1971),
  [6832] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1965),
  [6835] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1966),
  [6838] = {.count = 1, .reusable = false}, SHIFT(3001),
  [6840] = {.count = 1, .reusable = true}, SHIFT(2999),
  [6842] = {.count = 1, .reusable = true}, SHIFT(3001),
  [6844] = {.count = 1, .reusable = true}, SHIFT(3000),
  [6846] = {.count = 1, .reusable = true}, SHIFT(3002),
  [6848] = {.count = 1, .reusable = true}, SHIFT(3003),
  [6850] = {.count = 1, .reusable = true}, SHIFT(3004),
  [6852] = {.count = 1, .reusable = false}, SHIFT(3006),
  [6854] = {.count = 1, .reusable = true}, SHIFT(3005),
  [6856] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6858] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6860] = {.count = 1, .reusable = false}, SHIFT(3012),
  [6862] = {.count = 1, .reusable = true}, SHIFT(3010),
  [6864] = {.count = 1, .reusable = true}, SHIFT(3012),
  [6866] = {.count = 1, .reusable = true}, SHIFT(3011),
  [6868] = {.count = 1, .reusable = false}, SHIFT(3013),
  [6870] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1985),
  [6873] = {.count = 1, .reusable = true}, SHIFT(3014),
  [6875] = {.count = 1, .reusable = false}, SHIFT(3017),
  [6877] = {.count = 1, .reusable = true}, SHIFT(3018),
  [6879] = {.count = 1, .reusable = true}, SHIFT(3020),
  [6881] = {.count = 1, .reusable = true}, SHIFT(3023),
  [6883] = {.count = 1, .reusable = true}, SHIFT(3024),
  [6885] = {.count = 1, .reusable = true}, SHIFT(3025),
  [6887] = {.count = 1, .reusable = false}, SHIFT(3023),
  [6889] = {.count = 1, .reusable = true}, SHIFT(3028),
  [6891] = {.count = 1, .reusable = true}, SHIFT(3029),
  [6893] = {.count = 1, .reusable = true}, SHIFT(3030),
  [6895] = {.count = 1, .reusable = true}, SHIFT(3031),
  [6897] = {.count = 1, .reusable = false}, SHIFT(3028),
  [6899] = {.count = 1, .reusable = false}, SHIFT(3032),
  [6901] = {.count = 1, .reusable = true}, SHIFT(3034),
  [6903] = {.count = 1, .reusable = true}, SHIFT(3037),
  [6905] = {.count = 1, .reusable = false}, SHIFT(3037),
  [6907] = {.count = 1, .reusable = true}, SHIFT(3038),
  [6909] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1993),
  [6912] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1996),
  [6915] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1998),
  [6918] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1417),
  [6921] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1419),
  [6924] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1418),
  [6927] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1420),
  [6930] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2001),
  [6933] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2002),
  [6936] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1422),
  [6939] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1424),
  [6942] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1427),
  [6945] = {.count = 1, .reusable = false}, SHIFT(3042),
  [6947] = {.count = 1, .reusable = true}, SHIFT(3041),
  [6949] = {.count = 1, .reusable = true}, SHIFT(3042),
  [6951] = {.count = 1, .reusable = true}, SHIFT(3043),
  [6953] = {.count = 1, .reusable = true}, SHIFT(3044),
  [6955] = {.count = 1, .reusable = false}, SHIFT(3049),
  [6957] = {.count = 1, .reusable = true}, SHIFT(3047),
  [6959] = {.count = 1, .reusable = true}, SHIFT(3049),
  [6961] = {.count = 1, .reusable = true}, SHIFT(3048),
  [6963] = {.count = 1, .reusable = true}, SHIFT(3050),
  [6965] = {.count = 1, .reusable = false}, SHIFT(3052),
  [6967] = {.count = 1, .reusable = true}, SHIFT(3051),
  [6969] = {.count = 1, .reusable = true}, SHIFT(3052),
  [6971] = {.count = 1, .reusable = false}, SHIFT(1411),
  [6973] = {.count = 1, .reusable = false}, SHIFT(1410),
  [6975] = {.count = 1, .reusable = true}, SHIFT(3053),
  [6977] = {.count = 1, .reusable = true}, SHIFT(3054),
  [6979] = {.count = 1, .reusable = true}, SHIFT(3055),
  [6981] = {.count = 1, .reusable = false}, SHIFT(3056),
  [6983] = {.count = 1, .reusable = true}, SHIFT(3057),
  [6985] = {.count = 1, .reusable = true}, SHIFT(3058),
  [6987] = {.count = 1, .reusable = true}, SHIFT(3060),
  [6989] = {.count = 1, .reusable = true}, SHIFT(3061),
  [6991] = {.count = 1, .reusable = false}, SHIFT(3063),
  [6993] = {.count = 1, .reusable = true}, SHIFT(3062),
  [6995] = {.count = 1, .reusable = true}, SHIFT(3063),
  [6997] = {.count = 1, .reusable = true}, SHIFT(3064),
  [6999] = {.count = 1, .reusable = true}, SHIFT(3065),
  [7001] = {.count = 1, .reusable = true}, SHIFT(3066),
  [7003] = {.count = 1, .reusable = false}, SHIFT(3064),
  [7005] = {.count = 1, .reusable = true}, SHIFT(3067),
  [7007] = {.count = 1, .reusable = true}, SHIFT(3068),
  [7009] = {.count = 1, .reusable = false}, SHIFT(3070),
  [7011] = {.count = 1, .reusable = true}, SHIFT(3069),
  [7013] = {.count = 1, .reusable = true}, SHIFT(3070),
  [7015] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2601),
  [7018] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 4),
  [7020] = {.count = 1, .reusable = true}, SHIFT(3071),
  [7022] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [7024] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [7026] = {.count = 1, .reusable = true}, SHIFT(3073),
  [7028] = {.count = 1, .reusable = false}, SHIFT(3073),
  [7030] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7),
  [7032] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7),
  [7034] = {.count = 1, .reusable = true}, SHIFT(3074),
  [7036] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [7038] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 2),
  [7040] = {.count = 1, .reusable = false}, SHIFT(3080),
  [7042] = {.count = 1, .reusable = false}, SHIFT(3078),
  [7044] = {.count = 1, .reusable = false}, SHIFT(3081),
  [7046] = {.count = 1, .reusable = false}, SHIFT(3085),
  [7048] = {.count = 1, .reusable = false}, SHIFT(3083),
  [7050] = {.count = 1, .reusable = false}, SHIFT(3077),
  [7052] = {.count = 1, .reusable = false}, SHIFT(3082),
  [7054] = {.count = 1, .reusable = false}, SHIFT(3075),
  [7056] = {.count = 1, .reusable = true}, SHIFT(3079),
  [7058] = {.count = 1, .reusable = false}, SHIFT(3076),
  [7060] = {.count = 1, .reusable = false}, SHIFT(3091),
  [7062] = {.count = 1, .reusable = false}, SHIFT(3090),
  [7064] = {.count = 1, .reusable = false}, SHIFT(3092),
  [7066] = {.count = 1, .reusable = false}, SHIFT(3096),
  [7068] = {.count = 1, .reusable = false}, SHIFT(3094),
  [7070] = {.count = 1, .reusable = false}, SHIFT(3089),
  [7072] = {.count = 1, .reusable = false}, SHIFT(3093),
  [7074] = {.count = 1, .reusable = false}, SHIFT(3087),
  [7076] = {.count = 1, .reusable = false}, SHIFT(3088),
  [7078] = {.count = 1, .reusable = true}, SHIFT(3097),
  [7080] = {.count = 1, .reusable = true}, SHIFT(3098),
  [7082] = {.count = 1, .reusable = true}, SHIFT(3099),
  [7084] = {.count = 1, .reusable = false}, SHIFT(3097),
  [7086] = {.count = 1, .reusable = true}, SHIFT(3103),
  [7088] = {.count = 1, .reusable = true}, SHIFT(3104),
  [7090] = {.count = 1, .reusable = true}, SHIFT(3105),
  [7092] = {.count = 1, .reusable = true}, SHIFT(3106),
  [7094] = {.count = 1, .reusable = false}, SHIFT(3103),
  [7096] = {.count = 1, .reusable = true}, SHIFT(3107),
  [7098] = {.count = 1, .reusable = true}, SHIFT(3110),
  [7100] = {.count = 1, .reusable = false}, SHIFT(3111),
  [7102] = {.count = 1, .reusable = true}, SHIFT(3112),
  [7104] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [7106] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [7108] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [7110] = {.count = 1, .reusable = false}, SHIFT(3115),
  [7112] = {.count = 1, .reusable = true}, SHIFT(3116),
  [7114] = {.count = 1, .reusable = false}, SHIFT(3117),
  [7116] = {.count = 1, .reusable = true}, SHIFT(3118),
  [7118] = {.count = 1, .reusable = false}, SHIFT(3119),
  [7120] = {.count = 1, .reusable = false}, SHIFT(3120),
  [7122] = {.count = 1, .reusable = false}, SHIFT(3114),
  [7124] = {.count = 1, .reusable = true}, SHIFT(2624),
  [7126] = {.count = 1, .reusable = true}, SHIFT(3123),
  [7128] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3),
  [7130] = {.count = 1, .reusable = false}, SHIFT(2620),
  [7132] = {.count = 1, .reusable = false}, SHIFT(2621),
  [7134] = {.count = 1, .reusable = false}, SHIFT(2622),
  [7136] = {.count = 1, .reusable = false}, SHIFT(3124),
  [7138] = {.count = 1, .reusable = false}, SHIFT(3125),
  [7140] = {.count = 1, .reusable = false}, SHIFT(2626),
  [7142] = {.count = 1, .reusable = false}, SHIFT(2629),
  [7144] = {.count = 1, .reusable = false}, SHIFT(3130),
  [7146] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(2060),
  [7149] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [7151] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [7153] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [7155] = {.count = 1, .reusable = true}, SHIFT(3133),
  [7157] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [7159] = {.count = 1, .reusable = true}, SHIFT(3135),
  [7161] = {.count = 1, .reusable = true}, SHIFT(3137),
  [7163] = {.count = 1, .reusable = true}, SHIFT(3139),
  [7165] = {.count = 1, .reusable = true}, SHIFT(3140),
  [7167] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [7169] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [7171] = {.count = 1, .reusable = true}, SHIFT(3141),
  [7173] = {.count = 1, .reusable = true}, SHIFT(3142),
  [7175] = {.count = 1, .reusable = true}, SHIFT(3143),
  [7177] = {.count = 1, .reusable = false}, SHIFT(1532),
  [7179] = {.count = 1, .reusable = false}, SHIFT(3145),
  [7181] = {.count = 1, .reusable = true}, SHIFT(3144),
  [7183] = {.count = 1, .reusable = true}, SHIFT(3145),
  [7185] = {.count = 1, .reusable = true}, SHIFT(3146),
  [7187] = {.count = 1, .reusable = true}, SHIFT(3147),
  [7189] = {.count = 1, .reusable = false}, SHIFT(3152),
  [7191] = {.count = 1, .reusable = true}, SHIFT(3150),
  [7193] = {.count = 1, .reusable = true}, SHIFT(3152),
  [7195] = {.count = 1, .reusable = true}, SHIFT(3151),
  [7197] = {.count = 1, .reusable = true}, SHIFT(3153),
  [7199] = {.count = 1, .reusable = false}, SHIFT(3155),
  [7201] = {.count = 1, .reusable = true}, SHIFT(3154),
  [7203] = {.count = 1, .reusable = true}, SHIFT(3155),
  [7205] = {.count = 1, .reusable = true}, SHIFT(3156),
  [7207] = {.count = 1, .reusable = false}, SHIFT(3157),
  [7209] = {.count = 1, .reusable = true}, SHIFT(3157),
  [7211] = {.count = 1, .reusable = true}, SHIFT(3158),
  [7213] = {.count = 1, .reusable = false}, SHIFT(3160),
  [7215] = {.count = 1, .reusable = true}, SHIFT(3159),
  [7217] = {.count = 1, .reusable = true}, SHIFT(3160),
  [7219] = {.count = 1, .reusable = true}, SHIFT(3161),
  [7221] = {.count = 1, .reusable = true}, SHIFT(3162),
  [7223] = {.count = 1, .reusable = true}, SHIFT(3163),
  [7225] = {.count = 1, .reusable = false}, SHIFT(1588),
  [7227] = {.count = 1, .reusable = false}, SHIFT(1589),
  [7229] = {.count = 1, .reusable = false}, SHIFT(3165),
  [7231] = {.count = 1, .reusable = true}, SHIFT(3164),
  [7233] = {.count = 1, .reusable = true}, SHIFT(3165),
  [7235] = {.count = 1, .reusable = true}, SHIFT(3166),
  [7237] = {.count = 1, .reusable = true}, SHIFT(3167),
  [7239] = {.count = 1, .reusable = false}, SHIFT(3172),
  [7241] = {.count = 1, .reusable = true}, SHIFT(3170),
  [7243] = {.count = 1, .reusable = true}, SHIFT(3172),
  [7245] = {.count = 1, .reusable = true}, SHIFT(3171),
  [7247] = {.count = 1, .reusable = true}, SHIFT(3173),
  [7249] = {.count = 1, .reusable = false}, SHIFT(3175),
  [7251] = {.count = 1, .reusable = true}, SHIFT(3174),
  [7253] = {.count = 1, .reusable = true}, SHIFT(3175),
  [7255] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 7),
  [7257] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 7),
  [7259] = {.count = 1, .reusable = true}, SHIFT(3177),
  [7261] = {.count = 1, .reusable = true}, SHIFT(3178),
  [7263] = {.count = 1, .reusable = false}, SHIFT(3179),
  [7265] = {.count = 1, .reusable = true}, SHIFT(3179),
  [7267] = {.count = 1, .reusable = true}, SHIFT(3180),
  [7269] = {.count = 1, .reusable = false}, SHIFT(3182),
  [7271] = {.count = 1, .reusable = true}, SHIFT(3181),
  [7273] = {.count = 1, .reusable = true}, SHIFT(3182),
  [7275] = {.count = 1, .reusable = true}, SHIFT(3183),
  [7277] = {.count = 1, .reusable = true}, SHIFT(3184),
  [7279] = {.count = 1, .reusable = true}, SHIFT(3185),
  [7281] = {.count = 1, .reusable = false}, SHIFT(3186),
  [7283] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2189),
  [7286] = {.count = 1, .reusable = true}, SHIFT(3187),
  [7288] = {.count = 1, .reusable = false}, SHIFT(3191),
  [7290] = {.count = 1, .reusable = true}, SHIFT(3189),
  [7292] = {.count = 1, .reusable = true}, SHIFT(3191),
  [7294] = {.count = 1, .reusable = true}, SHIFT(3190),
  [7296] = {.count = 1, .reusable = true}, SHIFT(3192),
  [7298] = {.count = 1, .reusable = true}, SHIFT(3193),
  [7300] = {.count = 1, .reusable = true}, SHIFT(3194),
  [7302] = {.count = 1, .reusable = false}, SHIFT(3196),
  [7304] = {.count = 1, .reusable = true}, SHIFT(3195),
  [7306] = {.count = 1, .reusable = true}, SHIFT(3196),
  [7308] = {.count = 1, .reusable = true}, SHIFT(3197),
  [7310] = {.count = 1, .reusable = false}, SHIFT(3202),
  [7312] = {.count = 1, .reusable = true}, SHIFT(3200),
  [7314] = {.count = 1, .reusable = true}, SHIFT(3202),
  [7316] = {.count = 1, .reusable = true}, SHIFT(3201),
  [7318] = {.count = 1, .reusable = true}, SHIFT(3203),
  [7320] = {.count = 1, .reusable = false}, SHIFT(3204),
  [7322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2209),
  [7325] = {.count = 1, .reusable = false}, SHIFT(3207),
  [7327] = {.count = 1, .reusable = true}, SHIFT(3205),
  [7329] = {.count = 1, .reusable = true}, SHIFT(3207),
  [7331] = {.count = 1, .reusable = true}, SHIFT(3206),
  [7333] = {.count = 1, .reusable = true}, SHIFT(3208),
  [7335] = {.count = 1, .reusable = true}, SHIFT(3209),
  [7337] = {.count = 1, .reusable = true}, SHIFT(3210),
  [7339] = {.count = 1, .reusable = false}, SHIFT(3212),
  [7341] = {.count = 1, .reusable = true}, SHIFT(3211),
  [7343] = {.count = 1, .reusable = true}, SHIFT(3212),
  [7345] = {.count = 1, .reusable = true}, SHIFT(3213),
  [7347] = {.count = 1, .reusable = false}, SHIFT(3218),
  [7349] = {.count = 1, .reusable = true}, SHIFT(3216),
  [7351] = {.count = 1, .reusable = true}, SHIFT(3218),
  [7353] = {.count = 1, .reusable = true}, SHIFT(3217),
  [7355] = {.count = 1, .reusable = false}, SHIFT(3220),
  [7357] = {.count = 1, .reusable = true}, SHIFT(3219),
  [7359] = {.count = 1, .reusable = true}, SHIFT(3220),
  [7361] = {.count = 1, .reusable = true}, SHIFT(3221),
  [7363] = {.count = 1, .reusable = true}, SHIFT(3222),
  [7365] = {.count = 1, .reusable = false}, SHIFT(3227),
  [7367] = {.count = 1, .reusable = true}, SHIFT(3225),
  [7369] = {.count = 1, .reusable = true}, SHIFT(3227),
  [7371] = {.count = 1, .reusable = true}, SHIFT(3226),
  [7373] = {.count = 1, .reusable = true}, SHIFT(3228),
  [7375] = {.count = 1, .reusable = false}, SHIFT(3230),
  [7377] = {.count = 1, .reusable = true}, SHIFT(3229),
  [7379] = {.count = 1, .reusable = true}, SHIFT(3230),
  [7381] = {.count = 1, .reusable = false}, SHIFT(1648),
  [7383] = {.count = 1, .reusable = false}, SHIFT(1647),
  [7385] = {.count = 1, .reusable = true}, SHIFT(3231),
  [7387] = {.count = 1, .reusable = true}, SHIFT(3232),
  [7389] = {.count = 1, .reusable = true}, SHIFT(3233),
  [7391] = {.count = 1, .reusable = false}, SHIFT(3234),
  [7393] = {.count = 1, .reusable = true}, SHIFT(3235),
  [7395] = {.count = 1, .reusable = true}, SHIFT(3236),
  [7397] = {.count = 1, .reusable = true}, SHIFT(3238),
  [7399] = {.count = 1, .reusable = true}, SHIFT(3239),
  [7401] = {.count = 1, .reusable = false}, SHIFT(3241),
  [7403] = {.count = 1, .reusable = true}, SHIFT(3240),
  [7405] = {.count = 1, .reusable = true}, SHIFT(3241),
  [7407] = {.count = 1, .reusable = true}, SHIFT(3242),
  [7409] = {.count = 1, .reusable = true}, SHIFT(3243),
  [7411] = {.count = 1, .reusable = true}, SHIFT(3244),
  [7413] = {.count = 1, .reusable = false}, SHIFT(3242),
  [7415] = {.count = 1, .reusable = true}, SHIFT(3245),
  [7417] = {.count = 1, .reusable = true}, SHIFT(3246),
  [7419] = {.count = 1, .reusable = false}, SHIFT(3248),
  [7421] = {.count = 1, .reusable = true}, SHIFT(3247),
  [7423] = {.count = 1, .reusable = true}, SHIFT(3248),
  [7425] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2800),
  [7428] = {.count = 1, .reusable = true}, SHIFT(3249),
  [7430] = {.count = 1, .reusable = true}, SHIFT(3250),
  [7432] = {.count = 1, .reusable = false}, SHIFT(3251),
  [7434] = {.count = 1, .reusable = true}, SHIFT(3252),
  [7436] = {.count = 1, .reusable = true}, SHIFT(3253),
  [7438] = {.count = 1, .reusable = true}, SHIFT(3255),
  [7440] = {.count = 1, .reusable = true}, SHIFT(3256),
  [7442] = {.count = 1, .reusable = false}, SHIFT(3258),
  [7444] = {.count = 1, .reusable = true}, SHIFT(3257),
  [7446] = {.count = 1, .reusable = true}, SHIFT(3258),
  [7448] = {.count = 1, .reusable = true}, SHIFT(3259),
  [7450] = {.count = 1, .reusable = true}, SHIFT(3260),
  [7452] = {.count = 1, .reusable = true}, SHIFT(3261),
  [7454] = {.count = 1, .reusable = false}, SHIFT(3259),
  [7456] = {.count = 1, .reusable = true}, SHIFT(3262),
  [7458] = {.count = 1, .reusable = true}, SHIFT(3263),
  [7460] = {.count = 1, .reusable = false}, SHIFT(3265),
  [7462] = {.count = 1, .reusable = true}, SHIFT(3264),
  [7464] = {.count = 1, .reusable = true}, SHIFT(3265),
  [7466] = {.count = 1, .reusable = false}, SHIFT(3266),
  [7468] = {.count = 1, .reusable = true}, SHIFT(3266),
  [7470] = {.count = 1, .reusable = true}, SHIFT(3267),
  [7472] = {.count = 1, .reusable = true}, SHIFT(3268),
  [7474] = {.count = 1, .reusable = true}, SHIFT(3269),
  [7476] = {.count = 1, .reusable = false}, SHIFT(3270),
  [7478] = {.count = 1, .reusable = true}, SHIFT(3270),
  [7480] = {.count = 1, .reusable = true}, SHIFT(3271),
  [7482] = {.count = 1, .reusable = false}, SHIFT(3273),
  [7484] = {.count = 1, .reusable = true}, SHIFT(3272),
  [7486] = {.count = 1, .reusable = true}, SHIFT(3273),
  [7488] = {.count = 1, .reusable = true}, SHIFT(3274),
  [7490] = {.count = 1, .reusable = false}, SHIFT(3276),
  [7492] = {.count = 1, .reusable = true}, SHIFT(3275),
  [7494] = {.count = 1, .reusable = true}, SHIFT(3276),
  [7496] = {.count = 1, .reusable = true}, SHIFT(3277),
  [7498] = {.count = 1, .reusable = true}, SHIFT(3278),
  [7500] = {.count = 1, .reusable = false}, SHIFT(3283),
  [7502] = {.count = 1, .reusable = true}, SHIFT(3281),
  [7504] = {.count = 1, .reusable = true}, SHIFT(3283),
  [7506] = {.count = 1, .reusable = true}, SHIFT(3282),
  [7508] = {.count = 1, .reusable = true}, SHIFT(3284),
  [7510] = {.count = 1, .reusable = false}, SHIFT(3286),
  [7512] = {.count = 1, .reusable = true}, SHIFT(3285),
  [7514] = {.count = 1, .reusable = true}, SHIFT(3286),
  [7516] = {.count = 1, .reusable = true}, SHIFT(3287),
  [7518] = {.count = 1, .reusable = true}, SHIFT(3288),
  [7520] = {.count = 1, .reusable = true}, SHIFT(3289),
  [7522] = {.count = 1, .reusable = false}, SHIFT(3290),
  [7524] = {.count = 1, .reusable = true}, SHIFT(3290),
  [7526] = {.count = 1, .reusable = true}, SHIFT(3291),
  [7528] = {.count = 1, .reusable = false}, SHIFT(3293),
  [7530] = {.count = 1, .reusable = true}, SHIFT(3292),
  [7532] = {.count = 1, .reusable = true}, SHIFT(3293),
  [7534] = {.count = 1, .reusable = true}, SHIFT(3294),
  [7536] = {.count = 1, .reusable = true}, SHIFT(3295),
  [7538] = {.count = 1, .reusable = true}, SHIFT(3296),
  [7540] = {.count = 1, .reusable = true}, SHIFT(3297),
  [7542] = {.count = 1, .reusable = true}, SHIFT(3298),
  [7544] = {.count = 1, .reusable = true}, SHIFT(3299),
  [7546] = {.count = 1, .reusable = true}, SHIFT(3300),
  [7548] = {.count = 1, .reusable = true}, SHIFT(3301),
  [7550] = {.count = 1, .reusable = false}, SHIFT(3302),
  [7552] = {.count = 1, .reusable = true}, SHIFT(3302),
  [7554] = {.count = 1, .reusable = true}, SHIFT(3303),
  [7556] = {.count = 1, .reusable = false}, SHIFT(3305),
  [7558] = {.count = 1, .reusable = true}, SHIFT(3304),
  [7560] = {.count = 1, .reusable = true}, SHIFT(3305),
  [7562] = {.count = 1, .reusable = true}, SHIFT(3306),
  [7564] = {.count = 1, .reusable = true}, SHIFT(3308),
  [7566] = {.count = 1, .reusable = true}, SHIFT(3309),
  [7568] = {.count = 1, .reusable = true}, SHIFT(3310),
  [7570] = {.count = 1, .reusable = false}, SHIFT(3311),
  [7572] = {.count = 1, .reusable = true}, SHIFT(3311),
  [7574] = {.count = 1, .reusable = true}, SHIFT(3312),
  [7576] = {.count = 1, .reusable = false}, SHIFT(3314),
  [7578] = {.count = 1, .reusable = true}, SHIFT(3313),
  [7580] = {.count = 1, .reusable = true}, SHIFT(3314),
  [7582] = {.count = 1, .reusable = true}, SHIFT(3315),
  [7584] = {.count = 1, .reusable = false}, SHIFT(1922),
  [7586] = {.count = 1, .reusable = false}, SHIFT(1921),
  [7588] = {.count = 1, .reusable = true}, SHIFT(3316),
  [7590] = {.count = 1, .reusable = false}, SHIFT(3318),
  [7592] = {.count = 1, .reusable = true}, SHIFT(3317),
  [7594] = {.count = 1, .reusable = true}, SHIFT(3318),
  [7596] = {.count = 1, .reusable = true}, SHIFT(3319),
  [7598] = {.count = 1, .reusable = true}, SHIFT(3320),
  [7600] = {.count = 1, .reusable = false}, SHIFT(3325),
  [7602] = {.count = 1, .reusable = true}, SHIFT(3323),
  [7604] = {.count = 1, .reusable = true}, SHIFT(3325),
  [7606] = {.count = 1, .reusable = true}, SHIFT(3324),
  [7608] = {.count = 1, .reusable = true}, SHIFT(3326),
  [7610] = {.count = 1, .reusable = false}, SHIFT(3328),
  [7612] = {.count = 1, .reusable = true}, SHIFT(3327),
  [7614] = {.count = 1, .reusable = true}, SHIFT(3328),
  [7616] = {.count = 1, .reusable = false}, SHIFT(1941),
  [7618] = {.count = 1, .reusable = false}, SHIFT(1940),
  [7620] = {.count = 1, .reusable = false}, SHIFT(3330),
  [7622] = {.count = 1, .reusable = true}, SHIFT(3329),
  [7624] = {.count = 1, .reusable = true}, SHIFT(3330),
  [7626] = {.count = 1, .reusable = true}, SHIFT(3331),
  [7628] = {.count = 1, .reusable = true}, SHIFT(3332),
  [7630] = {.count = 1, .reusable = false}, SHIFT(3337),
  [7632] = {.count = 1, .reusable = true}, SHIFT(3335),
  [7634] = {.count = 1, .reusable = true}, SHIFT(3337),
  [7636] = {.count = 1, .reusable = true}, SHIFT(3336),
  [7638] = {.count = 1, .reusable = true}, SHIFT(3338),
  [7640] = {.count = 1, .reusable = false}, SHIFT(3340),
  [7642] = {.count = 1, .reusable = true}, SHIFT(3339),
  [7644] = {.count = 1, .reusable = true}, SHIFT(3340),
  [7646] = {.count = 1, .reusable = true}, SHIFT(3341),
  [7648] = {.count = 1, .reusable = false}, SHIFT(3342),
  [7650] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2486),
  [7653] = {.count = 1, .reusable = true}, SHIFT(3343),
  [7655] = {.count = 1, .reusable = false}, SHIFT(3347),
  [7657] = {.count = 1, .reusable = true}, SHIFT(3345),
  [7659] = {.count = 1, .reusable = true}, SHIFT(3347),
  [7661] = {.count = 1, .reusable = true}, SHIFT(3346),
  [7663] = {.count = 1, .reusable = true}, SHIFT(3348),
  [7665] = {.count = 1, .reusable = true}, SHIFT(3349),
  [7667] = {.count = 1, .reusable = true}, SHIFT(3350),
  [7669] = {.count = 1, .reusable = false}, SHIFT(3352),
  [7671] = {.count = 1, .reusable = true}, SHIFT(3351),
  [7673] = {.count = 1, .reusable = true}, SHIFT(3352),
  [7675] = {.count = 1, .reusable = true}, SHIFT(3353),
  [7677] = {.count = 1, .reusable = false}, SHIFT(3358),
  [7679] = {.count = 1, .reusable = true}, SHIFT(3356),
  [7681] = {.count = 1, .reusable = true}, SHIFT(3358),
  [7683] = {.count = 1, .reusable = true}, SHIFT(3357),
  [7685] = {.count = 1, .reusable = true}, SHIFT(3359),
  [7687] = {.count = 1, .reusable = false}, SHIFT(3360),
  [7689] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2506),
  [7692] = {.count = 1, .reusable = false}, SHIFT(3363),
  [7694] = {.count = 1, .reusable = true}, SHIFT(3361),
  [7696] = {.count = 1, .reusable = true}, SHIFT(3363),
  [7698] = {.count = 1, .reusable = true}, SHIFT(3362),
  [7700] = {.count = 1, .reusable = true}, SHIFT(3364),
  [7702] = {.count = 1, .reusable = true}, SHIFT(3365),
  [7704] = {.count = 1, .reusable = true}, SHIFT(3366),
  [7706] = {.count = 1, .reusable = false}, SHIFT(3368),
  [7708] = {.count = 1, .reusable = true}, SHIFT(3367),
  [7710] = {.count = 1, .reusable = true}, SHIFT(3368),
  [7712] = {.count = 1, .reusable = true}, SHIFT(3369),
  [7714] = {.count = 1, .reusable = false}, SHIFT(3374),
  [7716] = {.count = 1, .reusable = true}, SHIFT(3372),
  [7718] = {.count = 1, .reusable = true}, SHIFT(3374),
  [7720] = {.count = 1, .reusable = true}, SHIFT(3373),
  [7722] = {.count = 1, .reusable = false}, SHIFT(3376),
  [7724] = {.count = 1, .reusable = true}, SHIFT(3375),
  [7726] = {.count = 1, .reusable = true}, SHIFT(3376),
  [7728] = {.count = 1, .reusable = true}, SHIFT(3377),
  [7730] = {.count = 1, .reusable = true}, SHIFT(3378),
  [7732] = {.count = 1, .reusable = false}, SHIFT(3383),
  [7734] = {.count = 1, .reusable = true}, SHIFT(3381),
  [7736] = {.count = 1, .reusable = true}, SHIFT(3383),
  [7738] = {.count = 1, .reusable = true}, SHIFT(3382),
  [7740] = {.count = 1, .reusable = true}, SHIFT(3384),
  [7742] = {.count = 1, .reusable = false}, SHIFT(3386),
  [7744] = {.count = 1, .reusable = true}, SHIFT(3385),
  [7746] = {.count = 1, .reusable = true}, SHIFT(3386),
  [7748] = {.count = 1, .reusable = false}, SHIFT(1977),
  [7750] = {.count = 1, .reusable = false}, SHIFT(1976),
  [7752] = {.count = 1, .reusable = true}, SHIFT(3387),
  [7754] = {.count = 1, .reusable = true}, SHIFT(3388),
  [7756] = {.count = 1, .reusable = true}, SHIFT(3389),
  [7758] = {.count = 1, .reusable = false}, SHIFT(3390),
  [7760] = {.count = 1, .reusable = true}, SHIFT(3391),
  [7762] = {.count = 1, .reusable = true}, SHIFT(3392),
  [7764] = {.count = 1, .reusable = true}, SHIFT(3394),
  [7766] = {.count = 1, .reusable = true}, SHIFT(3395),
  [7768] = {.count = 1, .reusable = false}, SHIFT(3397),
  [7770] = {.count = 1, .reusable = true}, SHIFT(3396),
  [7772] = {.count = 1, .reusable = true}, SHIFT(3397),
  [7774] = {.count = 1, .reusable = true}, SHIFT(3398),
  [7776] = {.count = 1, .reusable = true}, SHIFT(3399),
  [7778] = {.count = 1, .reusable = true}, SHIFT(3400),
  [7780] = {.count = 1, .reusable = false}, SHIFT(3398),
  [7782] = {.count = 1, .reusable = true}, SHIFT(3401),
  [7784] = {.count = 1, .reusable = true}, SHIFT(3402),
  [7786] = {.count = 1, .reusable = false}, SHIFT(3404),
  [7788] = {.count = 1, .reusable = true}, SHIFT(3403),
  [7790] = {.count = 1, .reusable = true}, SHIFT(3404),
  [7792] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3032),
  [7795] = {.count = 1, .reusable = true}, SHIFT(3405),
  [7797] = {.count = 1, .reusable = true}, SHIFT(3407),
  [7799] = {.count = 1, .reusable = false}, SHIFT(3407),
  [7801] = {.count = 1, .reusable = true}, SHIFT(3408),
  [7803] = {.count = 1, .reusable = false}, SHIFT(3409),
  [7805] = {.count = 1, .reusable = true}, SHIFT(3409),
  [7807] = {.count = 1, .reusable = true}, SHIFT(3410),
  [7809] = {.count = 1, .reusable = false}, SHIFT(3412),
  [7811] = {.count = 1, .reusable = true}, SHIFT(3411),
  [7813] = {.count = 1, .reusable = true}, SHIFT(3412),
  [7815] = {.count = 1, .reusable = true}, SHIFT(3413),
  [7817] = {.count = 1, .reusable = true}, SHIFT(3414),
  [7819] = {.count = 1, .reusable = false}, SHIFT(3415),
  [7821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2589),
  [7824] = {.count = 1, .reusable = false}, SHIFT(3418),
  [7826] = {.count = 1, .reusable = true}, SHIFT(3416),
  [7828] = {.count = 1, .reusable = true}, SHIFT(3418),
  [7830] = {.count = 1, .reusable = true}, SHIFT(3417),
  [7832] = {.count = 1, .reusable = true}, SHIFT(3419),
  [7834] = {.count = 1, .reusable = true}, SHIFT(3420),
  [7836] = {.count = 1, .reusable = true}, SHIFT(3421),
  [7838] = {.count = 1, .reusable = false}, SHIFT(3423),
  [7840] = {.count = 1, .reusable = true}, SHIFT(3422),
  [7842] = {.count = 1, .reusable = true}, SHIFT(3423),
  [7844] = {.count = 1, .reusable = true}, SHIFT(3424),
  [7846] = {.count = 1, .reusable = false}, SHIFT(3429),
  [7848] = {.count = 1, .reusable = true}, SHIFT(3427),
  [7850] = {.count = 1, .reusable = true}, SHIFT(3429),
  [7852] = {.count = 1, .reusable = true}, SHIFT(3428),
  [7854] = {.count = 1, .reusable = false}, SHIFT(3430),
  [7856] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 5),
  [7858] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8),
  [7860] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8),
  [7862] = {.count = 1, .reusable = false}, SHIFT(3432),
  [7864] = {.count = 1, .reusable = true}, SHIFT(3433),
  [7866] = {.count = 1, .reusable = true}, SHIFT(3435),
  [7868] = {.count = 1, .reusable = true}, SHIFT(3438),
  [7870] = {.count = 1, .reusable = true}, SHIFT(3076),
  [7872] = {.count = 1, .reusable = true}, SHIFT(3439),
  [7874] = {.count = 1, .reusable = true}, SHIFT(3440),
  [7876] = {.count = 1, .reusable = true}, SHIFT(3441),
  [7878] = {.count = 1, .reusable = false}, SHIFT(3439),
  [7880] = {.count = 1, .reusable = true}, SHIFT(3444),
  [7882] = {.count = 1, .reusable = true}, SHIFT(3445),
  [7884] = {.count = 1, .reusable = true}, SHIFT(3446),
  [7886] = {.count = 1, .reusable = true}, SHIFT(3447),
  [7888] = {.count = 1, .reusable = false}, SHIFT(3444),
  [7890] = {.count = 1, .reusable = false}, SHIFT(3448),
  [7892] = {.count = 1, .reusable = false}, SHIFT(3450),
  [7894] = {.count = 1, .reusable = false}, SHIFT(3452),
  [7896] = {.count = 1, .reusable = true}, SHIFT(3453),
  [7898] = {.count = 1, .reusable = true}, SHIFT(3455),
  [7900] = {.count = 1, .reusable = true}, SHIFT(3088),
  [7902] = {.count = 1, .reusable = true}, SHIFT(3458),
  [7904] = {.count = 1, .reusable = true}, SHIFT(3459),
  [7906] = {.count = 1, .reusable = true}, SHIFT(3460),
  [7908] = {.count = 1, .reusable = false}, SHIFT(3458),
  [7910] = {.count = 1, .reusable = true}, SHIFT(3463),
  [7912] = {.count = 1, .reusable = true}, SHIFT(3464),
  [7914] = {.count = 1, .reusable = true}, SHIFT(3465),
  [7916] = {.count = 1, .reusable = true}, SHIFT(3466),
  [7918] = {.count = 1, .reusable = false}, SHIFT(3463),
  [7920] = {.count = 1, .reusable = false}, SHIFT(3467),
  [7922] = {.count = 1, .reusable = false}, SHIFT(3469),
  [7924] = {.count = 1, .reusable = true}, SHIFT(3470),
  [7926] = {.count = 1, .reusable = true}, SHIFT(3471),
  [7928] = {.count = 1, .reusable = true}, SHIFT(3472),
  [7930] = {.count = 1, .reusable = false}, SHIFT(3474),
  [7932] = {.count = 1, .reusable = true}, SHIFT(3473),
  [7934] = {.count = 1, .reusable = true}, SHIFT(3474),
  [7936] = {.count = 1, .reusable = true}, SHIFT(3475),
  [7938] = {.count = 1, .reusable = true}, SHIFT(3476),
  [7940] = {.count = 1, .reusable = true}, SHIFT(3477),
  [7942] = {.count = 1, .reusable = false}, SHIFT(3475),
  [7944] = {.count = 1, .reusable = true}, SHIFT(3478),
  [7946] = {.count = 1, .reusable = true}, SHIFT(3479),
  [7948] = {.count = 1, .reusable = false}, SHIFT(3481),
  [7950] = {.count = 1, .reusable = true}, SHIFT(3480),
  [7952] = {.count = 1, .reusable = true}, SHIFT(3481),
  [7954] = {.count = 1, .reusable = true}, SHIFT(3482),
  [7956] = {.count = 1, .reusable = true}, SHIFT(3483),
  [7958] = {.count = 1, .reusable = true}, SHIFT(3485),
  [7960] = {.count = 1, .reusable = true}, SHIFT(3486),
  [7962] = {.count = 1, .reusable = true}, SHIFT(3487),
  [7964] = {.count = 1, .reusable = true}, SHIFT(3488),
  [7966] = {.count = 1, .reusable = true}, SHIFT(3489),
  [7968] = {.count = 1, .reusable = false}, SHIFT(3490),
  [7970] = {.count = 1, .reusable = true}, SHIFT(3491),
  [7972] = {.count = 1, .reusable = true}, SHIFT(3492),
  [7974] = {.count = 1, .reusable = true}, SHIFT(3493),
  [7976] = {.count = 1, .reusable = true}, SHIFT(3494),
  [7978] = {.count = 1, .reusable = true}, SHIFT(3496),
  [7980] = {.count = 1, .reusable = false}, SHIFT(3497),
  [7982] = {.count = 1, .reusable = true}, SHIFT(3500),
  [7984] = {.count = 1, .reusable = true}, SHIFT(3501),
  [7986] = {.count = 1, .reusable = true}, SHIFT(3504),
  [7988] = {.count = 1, .reusable = false}, SHIFT(3504),
  [7990] = {.count = 1, .reusable = true}, SHIFT(3507),
  [7992] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [7994] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [7996] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [7998] = {.count = 1, .reusable = true}, SHIFT(3511),
  [8000] = {.count = 1, .reusable = true}, SHIFT(3512),
  [8002] = {.count = 1, .reusable = true}, SHIFT(3516),
  [8004] = {.count = 1, .reusable = false}, SHIFT(3515),
  [8006] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3130),
  [8009] = {.count = 1, .reusable = true}, SHIFT(3517),
  [8011] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4),
  [8013] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [8015] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [8017] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [8019] = {.count = 1, .reusable = true}, SHIFT(3518),
  [8021] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [8023] = {.count = 1, .reusable = true}, SHIFT(3519),
  [8025] = {.count = 1, .reusable = true}, SHIFT(3524),
  [8027] = {.count = 1, .reusable = true}, SHIFT(3525),
  [8029] = {.count = 1, .reusable = true}, SHIFT(3527),
  [8031] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [8033] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [8035] = {.count = 1, .reusable = true}, SHIFT(3528),
  [8037] = {.count = 1, .reusable = false}, SHIFT(3529),
  [8039] = {.count = 1, .reusable = true}, SHIFT(3529),
  [8041] = {.count = 1, .reusable = true}, SHIFT(3530),
  [8043] = {.count = 1, .reusable = false}, SHIFT(3532),
  [8045] = {.count = 1, .reusable = true}, SHIFT(3531),
  [8047] = {.count = 1, .reusable = true}, SHIFT(3532),
  [8049] = {.count = 1, .reusable = true}, SHIFT(3533),
  [8051] = {.count = 1, .reusable = true}, SHIFT(3534),
  [8053] = {.count = 1, .reusable = true}, SHIFT(3535),
  [8055] = {.count = 1, .reusable = true}, SHIFT(3536),
  [8057] = {.count = 1, .reusable = false}, SHIFT(3537),
  [8059] = {.count = 1, .reusable = true}, SHIFT(3537),
  [8061] = {.count = 1, .reusable = true}, SHIFT(3538),
  [8063] = {.count = 1, .reusable = false}, SHIFT(3540),
  [8065] = {.count = 1, .reusable = true}, SHIFT(3539),
  [8067] = {.count = 1, .reusable = true}, SHIFT(3540),
  [8069] = {.count = 1, .reusable = true}, SHIFT(3541),
  [8071] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 8),
  [8073] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 8),
  [8075] = {.count = 1, .reusable = true}, SHIFT(3543),
  [8077] = {.count = 1, .reusable = true}, SHIFT(3544),
  [8079] = {.count = 1, .reusable = true}, SHIFT(3545),
  [8081] = {.count = 1, .reusable = false}, SHIFT(2195),
  [8083] = {.count = 1, .reusable = false}, SHIFT(2194),
  [8085] = {.count = 1, .reusable = true}, SHIFT(3546),
  [8087] = {.count = 1, .reusable = false}, SHIFT(3548),
  [8089] = {.count = 1, .reusable = true}, SHIFT(3547),
  [8091] = {.count = 1, .reusable = true}, SHIFT(3548),
  [8093] = {.count = 1, .reusable = true}, SHIFT(3549),
  [8095] = {.count = 1, .reusable = true}, SHIFT(3550),
  [8097] = {.count = 1, .reusable = false}, SHIFT(3555),
  [8099] = {.count = 1, .reusable = true}, SHIFT(3553),
  [8101] = {.count = 1, .reusable = true}, SHIFT(3555),
  [8103] = {.count = 1, .reusable = true}, SHIFT(3554),
  [8105] = {.count = 1, .reusable = true}, SHIFT(3556),
  [8107] = {.count = 1, .reusable = false}, SHIFT(3558),
  [8109] = {.count = 1, .reusable = true}, SHIFT(3557),
  [8111] = {.count = 1, .reusable = true}, SHIFT(3558),
  [8113] = {.count = 1, .reusable = false}, SHIFT(2214),
  [8115] = {.count = 1, .reusable = false}, SHIFT(2213),
  [8117] = {.count = 1, .reusable = false}, SHIFT(3560),
  [8119] = {.count = 1, .reusable = true}, SHIFT(3559),
  [8121] = {.count = 1, .reusable = true}, SHIFT(3560),
  [8123] = {.count = 1, .reusable = true}, SHIFT(3561),
  [8125] = {.count = 1, .reusable = true}, SHIFT(3562),
  [8127] = {.count = 1, .reusable = false}, SHIFT(3567),
  [8129] = {.count = 1, .reusable = true}, SHIFT(3565),
  [8131] = {.count = 1, .reusable = true}, SHIFT(3567),
  [8133] = {.count = 1, .reusable = true}, SHIFT(3566),
  [8135] = {.count = 1, .reusable = true}, SHIFT(3568),
  [8137] = {.count = 1, .reusable = false}, SHIFT(3570),
  [8139] = {.count = 1, .reusable = true}, SHIFT(3569),
  [8141] = {.count = 1, .reusable = true}, SHIFT(3570),
  [8143] = {.count = 1, .reusable = true}, SHIFT(3571),
  [8145] = {.count = 1, .reusable = false}, SHIFT(3572),
  [8147] = {.count = 1, .reusable = true}, SHIFT(3572),
  [8149] = {.count = 1, .reusable = true}, SHIFT(3573),
  [8151] = {.count = 1, .reusable = false}, SHIFT(3575),
  [8153] = {.count = 1, .reusable = true}, SHIFT(3574),
  [8155] = {.count = 1, .reusable = true}, SHIFT(3575),
  [8157] = {.count = 1, .reusable = true}, SHIFT(3576),
  [8159] = {.count = 1, .reusable = true}, SHIFT(3577),
  [8161] = {.count = 1, .reusable = false}, SHIFT(3578),
  [8163] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2788),
  [8166] = {.count = 1, .reusable = false}, SHIFT(3581),
  [8168] = {.count = 1, .reusable = true}, SHIFT(3579),
  [8170] = {.count = 1, .reusable = true}, SHIFT(3581),
  [8172] = {.count = 1, .reusable = true}, SHIFT(3580),
  [8174] = {.count = 1, .reusable = true}, SHIFT(3582),
  [8176] = {.count = 1, .reusable = true}, SHIFT(3583),
  [8178] = {.count = 1, .reusable = true}, SHIFT(3584),
  [8180] = {.count = 1, .reusable = false}, SHIFT(3586),
  [8182] = {.count = 1, .reusable = true}, SHIFT(3585),
  [8184] = {.count = 1, .reusable = true}, SHIFT(3586),
  [8186] = {.count = 1, .reusable = true}, SHIFT(3587),
  [8188] = {.count = 1, .reusable = false}, SHIFT(3592),
  [8190] = {.count = 1, .reusable = true}, SHIFT(3590),
  [8192] = {.count = 1, .reusable = true}, SHIFT(3592),
  [8194] = {.count = 1, .reusable = true}, SHIFT(3591),
  [8196] = {.count = 1, .reusable = true}, SHIFT(3593),
  [8198] = {.count = 1, .reusable = false}, SHIFT(3594),
  [8200] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2807),
  [8203] = {.count = 1, .reusable = false}, SHIFT(3597),
  [8205] = {.count = 1, .reusable = true}, SHIFT(3595),
  [8207] = {.count = 1, .reusable = true}, SHIFT(3597),
  [8209] = {.count = 1, .reusable = true}, SHIFT(3596),
  [8211] = {.count = 1, .reusable = true}, SHIFT(3598),
  [8213] = {.count = 1, .reusable = true}, SHIFT(3599),
  [8215] = {.count = 1, .reusable = true}, SHIFT(3600),
  [8217] = {.count = 1, .reusable = false}, SHIFT(3602),
  [8219] = {.count = 1, .reusable = true}, SHIFT(3601),
  [8221] = {.count = 1, .reusable = true}, SHIFT(3602),
  [8223] = {.count = 1, .reusable = true}, SHIFT(3603),
  [8225] = {.count = 1, .reusable = false}, SHIFT(3608),
  [8227] = {.count = 1, .reusable = true}, SHIFT(3606),
  [8229] = {.count = 1, .reusable = true}, SHIFT(3608),
  [8231] = {.count = 1, .reusable = true}, SHIFT(3607),
  [8233] = {.count = 1, .reusable = true}, SHIFT(3609),
  [8235] = {.count = 1, .reusable = true}, SHIFT(3610),
  [8237] = {.count = 1, .reusable = true}, SHIFT(3611),
  [8239] = {.count = 1, .reusable = false}, SHIFT(3612),
  [8241] = {.count = 1, .reusable = true}, SHIFT(3612),
  [8243] = {.count = 1, .reusable = true}, SHIFT(3613),
  [8245] = {.count = 1, .reusable = false}, SHIFT(3615),
  [8247] = {.count = 1, .reusable = true}, SHIFT(3614),
  [8249] = {.count = 1, .reusable = true}, SHIFT(3615),
  [8251] = {.count = 1, .reusable = true}, SHIFT(3616),
  [8253] = {.count = 1, .reusable = true}, SHIFT(3617),
  [8255] = {.count = 1, .reusable = true}, SHIFT(3618),
  [8257] = {.count = 1, .reusable = true}, SHIFT(3619),
  [8259] = {.count = 1, .reusable = true}, SHIFT(3620),
  [8261] = {.count = 1, .reusable = true}, SHIFT(3622),
  [8263] = {.count = 1, .reusable = true}, SHIFT(3623),
  [8265] = {.count = 1, .reusable = true}, SHIFT(3624),
  [8267] = {.count = 1, .reusable = true}, SHIFT(3625),
  [8269] = {.count = 1, .reusable = false}, SHIFT(3626),
  [8271] = {.count = 1, .reusable = true}, SHIFT(3626),
  [8273] = {.count = 1, .reusable = true}, SHIFT(3627),
  [8275] = {.count = 1, .reusable = false}, SHIFT(3629),
  [8277] = {.count = 1, .reusable = true}, SHIFT(3628),
  [8279] = {.count = 1, .reusable = true}, SHIFT(3629),
  [8281] = {.count = 1, .reusable = true}, SHIFT(3630),
  [8283] = {.count = 1, .reusable = true}, SHIFT(3631),
  [8285] = {.count = 1, .reusable = false}, SHIFT(3632),
  [8287] = {.count = 1, .reusable = true}, SHIFT(3632),
  [8289] = {.count = 1, .reusable = true}, SHIFT(3633),
  [8291] = {.count = 1, .reusable = false}, SHIFT(3635),
  [8293] = {.count = 1, .reusable = true}, SHIFT(3634),
  [8295] = {.count = 1, .reusable = true}, SHIFT(3635),
  [8297] = {.count = 1, .reusable = true}, SHIFT(3636),
  [8299] = {.count = 1, .reusable = false}, SHIFT(2492),
  [8301] = {.count = 1, .reusable = false}, SHIFT(2491),
  [8303] = {.count = 1, .reusable = true}, SHIFT(3637),
  [8305] = {.count = 1, .reusable = false}, SHIFT(3639),
  [8307] = {.count = 1, .reusable = true}, SHIFT(3638),
  [8309] = {.count = 1, .reusable = true}, SHIFT(3639),
  [8311] = {.count = 1, .reusable = true}, SHIFT(3640),
  [8313] = {.count = 1, .reusable = true}, SHIFT(3641),
  [8315] = {.count = 1, .reusable = false}, SHIFT(3646),
  [8317] = {.count = 1, .reusable = true}, SHIFT(3644),
  [8319] = {.count = 1, .reusable = true}, SHIFT(3646),
  [8321] = {.count = 1, .reusable = true}, SHIFT(3645),
  [8323] = {.count = 1, .reusable = true}, SHIFT(3647),
  [8325] = {.count = 1, .reusable = false}, SHIFT(3649),
  [8327] = {.count = 1, .reusable = true}, SHIFT(3648),
  [8329] = {.count = 1, .reusable = true}, SHIFT(3649),
  [8331] = {.count = 1, .reusable = false}, SHIFT(2511),
  [8333] = {.count = 1, .reusable = false}, SHIFT(2510),
  [8335] = {.count = 1, .reusable = false}, SHIFT(3651),
  [8337] = {.count = 1, .reusable = true}, SHIFT(3650),
  [8339] = {.count = 1, .reusable = true}, SHIFT(3651),
  [8341] = {.count = 1, .reusable = true}, SHIFT(3652),
  [8343] = {.count = 1, .reusable = true}, SHIFT(3653),
  [8345] = {.count = 1, .reusable = false}, SHIFT(3658),
  [8347] = {.count = 1, .reusable = true}, SHIFT(3656),
  [8349] = {.count = 1, .reusable = true}, SHIFT(3658),
  [8351] = {.count = 1, .reusable = true}, SHIFT(3657),
  [8353] = {.count = 1, .reusable = true}, SHIFT(3659),
  [8355] = {.count = 1, .reusable = false}, SHIFT(3661),
  [8357] = {.count = 1, .reusable = true}, SHIFT(3660),
  [8359] = {.count = 1, .reusable = true}, SHIFT(3661),
  [8361] = {.count = 1, .reusable = true}, SHIFT(3662),
  [8363] = {.count = 1, .reusable = false}, SHIFT(3663),
  [8365] = {.count = 1, .reusable = true}, SHIFT(3663),
  [8367] = {.count = 1, .reusable = true}, SHIFT(3664),
  [8369] = {.count = 1, .reusable = false}, SHIFT(3666),
  [8371] = {.count = 1, .reusable = true}, SHIFT(3665),
  [8373] = {.count = 1, .reusable = true}, SHIFT(3666),
  [8375] = {.count = 1, .reusable = true}, SHIFT(3667),
  [8377] = {.count = 1, .reusable = true}, SHIFT(3668),
  [8379] = {.count = 1, .reusable = false}, SHIFT(3669),
  [8381] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3020),
  [8384] = {.count = 1, .reusable = false}, SHIFT(3672),
  [8386] = {.count = 1, .reusable = true}, SHIFT(3670),
  [8388] = {.count = 1, .reusable = true}, SHIFT(3672),
  [8390] = {.count = 1, .reusable = true}, SHIFT(3671),
  [8392] = {.count = 1, .reusable = true}, SHIFT(3673),
  [8394] = {.count = 1, .reusable = true}, SHIFT(3674),
  [8396] = {.count = 1, .reusable = true}, SHIFT(3675),
  [8398] = {.count = 1, .reusable = false}, SHIFT(3677),
  [8400] = {.count = 1, .reusable = true}, SHIFT(3676),
  [8402] = {.count = 1, .reusable = true}, SHIFT(3677),
  [8404] = {.count = 1, .reusable = true}, SHIFT(3678),
  [8406] = {.count = 1, .reusable = false}, SHIFT(3683),
  [8408] = {.count = 1, .reusable = true}, SHIFT(3681),
  [8410] = {.count = 1, .reusable = true}, SHIFT(3683),
  [8412] = {.count = 1, .reusable = true}, SHIFT(3682),
  [8414] = {.count = 1, .reusable = false}, SHIFT(3684),
  [8416] = {.count = 1, .reusable = true}, SHIFT(3685),
  [8418] = {.count = 1, .reusable = true}, SHIFT(3686),
  [8420] = {.count = 1, .reusable = false}, SHIFT(2594),
  [8422] = {.count = 1, .reusable = false}, SHIFT(2593),
  [8424] = {.count = 1, .reusable = false}, SHIFT(2024),
  [8426] = {.count = 1, .reusable = false}, SHIFT(3688),
  [8428] = {.count = 1, .reusable = true}, SHIFT(3687),
  [8430] = {.count = 1, .reusable = true}, SHIFT(3688),
  [8432] = {.count = 1, .reusable = true}, SHIFT(3689),
  [8434] = {.count = 1, .reusable = true}, SHIFT(3690),
  [8436] = {.count = 1, .reusable = false}, SHIFT(3695),
  [8438] = {.count = 1, .reusable = true}, SHIFT(3693),
  [8440] = {.count = 1, .reusable = true}, SHIFT(3695),
  [8442] = {.count = 1, .reusable = true}, SHIFT(3694),
  [8444] = {.count = 1, .reusable = true}, SHIFT(3696),
  [8446] = {.count = 1, .reusable = false}, SHIFT(3698),
  [8448] = {.count = 1, .reusable = true}, SHIFT(3697),
  [8450] = {.count = 1, .reusable = true}, SHIFT(3698),
  [8452] = {.count = 1, .reusable = true}, SHIFT(3699),
  [8454] = {.count = 1, .reusable = true}, SHIFT(3700),
  [8456] = {.count = 1, .reusable = false}, SHIFT(3701),
  [8458] = {.count = 1, .reusable = true}, SHIFT(3075),
  [8460] = {.count = 1, .reusable = true}, SHIFT(3702),
  [8462] = {.count = 1, .reusable = true}, SHIFT(3078),
  [8464] = {.count = 1, .reusable = true}, SHIFT(3081),
  [8466] = {.count = 1, .reusable = true}, SHIFT(3083),
  [8468] = {.count = 1, .reusable = true}, SHIFT(3703),
  [8470] = {.count = 1, .reusable = true}, SHIFT(3705),
  [8472] = {.count = 1, .reusable = true}, SHIFT(3706),
  [8474] = {.count = 1, .reusable = true}, SHIFT(3707),
  [8476] = {.count = 1, .reusable = true}, SHIFT(3082),
  [8478] = {.count = 1, .reusable = true}, SHIFT(3708),
  [8480] = {.count = 1, .reusable = true}, SHIFT(3710),
  [8482] = {.count = 1, .reusable = false}, SHIFT(3712),
  [8484] = {.count = 1, .reusable = true}, SHIFT(3711),
  [8486] = {.count = 1, .reusable = true}, SHIFT(3712),
  [8488] = {.count = 1, .reusable = true}, SHIFT(3713),
  [8490] = {.count = 1, .reusable = true}, SHIFT(3714),
  [8492] = {.count = 1, .reusable = true}, SHIFT(3715),
  [8494] = {.count = 1, .reusable = false}, SHIFT(3713),
  [8496] = {.count = 1, .reusable = true}, SHIFT(3716),
  [8498] = {.count = 1, .reusable = true}, SHIFT(3717),
  [8500] = {.count = 1, .reusable = false}, SHIFT(3719),
  [8502] = {.count = 1, .reusable = true}, SHIFT(3718),
  [8504] = {.count = 1, .reusable = true}, SHIFT(3719),
  [8506] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3448),
  [8509] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3080),
  [8512] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3078),
  [8515] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3081),
  [8518] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3450),
  [8521] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3083),
  [8524] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3077),
  [8527] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3082),
  [8530] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3075),
  [8533] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3079),
  [8536] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3076),
  [8539] = {.count = 1, .reusable = true}, SHIFT(3720),
  [8541] = {.count = 1, .reusable = true}, SHIFT(3721),
  [8543] = {.count = 1, .reusable = false}, SHIFT(3722),
  [8545] = {.count = 1, .reusable = true}, SHIFT(3087),
  [8547] = {.count = 1, .reusable = true}, SHIFT(3723),
  [8549] = {.count = 1, .reusable = true}, SHIFT(3090),
  [8551] = {.count = 1, .reusable = true}, SHIFT(3092),
  [8553] = {.count = 1, .reusable = true}, SHIFT(3094),
  [8555] = {.count = 1, .reusable = true}, SHIFT(3724),
  [8557] = {.count = 1, .reusable = true}, SHIFT(3726),
  [8559] = {.count = 1, .reusable = true}, SHIFT(3727),
  [8561] = {.count = 1, .reusable = false}, SHIFT(3729),
  [8563] = {.count = 1, .reusable = true}, SHIFT(3728),
  [8565] = {.count = 1, .reusable = true}, SHIFT(3729),
  [8567] = {.count = 1, .reusable = true}, SHIFT(3730),
  [8569] = {.count = 1, .reusable = true}, SHIFT(3731),
  [8571] = {.count = 1, .reusable = true}, SHIFT(3732),
  [8573] = {.count = 1, .reusable = false}, SHIFT(3730),
  [8575] = {.count = 1, .reusable = true}, SHIFT(3733),
  [8577] = {.count = 1, .reusable = true}, SHIFT(3734),
  [8579] = {.count = 1, .reusable = false}, SHIFT(3736),
  [8581] = {.count = 1, .reusable = true}, SHIFT(3735),
  [8583] = {.count = 1, .reusable = true}, SHIFT(3736),
  [8585] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3467),
  [8588] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3091),
  [8591] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3090),
  [8594] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3092),
  [8597] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3469),
  [8600] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3094),
  [8603] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3089),
  [8606] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3093),
  [8609] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3087),
  [8612] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3088),
  [8615] = {.count = 1, .reusable = false}, SHIFT(3739),
  [8617] = {.count = 1, .reusable = true}, SHIFT(3737),
  [8619] = {.count = 1, .reusable = true}, SHIFT(3739),
  [8621] = {.count = 1, .reusable = true}, SHIFT(3738),
  [8623] = {.count = 1, .reusable = true}, SHIFT(3740),
  [8625] = {.count = 1, .reusable = true}, SHIFT(3741),
  [8627] = {.count = 1, .reusable = true}, SHIFT(3742),
  [8629] = {.count = 1, .reusable = false}, SHIFT(3744),
  [8631] = {.count = 1, .reusable = true}, SHIFT(3743),
  [8633] = {.count = 1, .reusable = true}, SHIFT(3744),
  [8635] = {.count = 1, .reusable = true}, SHIFT(3745),
  [8637] = {.count = 1, .reusable = false}, SHIFT(3750),
  [8639] = {.count = 1, .reusable = true}, SHIFT(3748),
  [8641] = {.count = 1, .reusable = true}, SHIFT(3750),
  [8643] = {.count = 1, .reusable = true}, SHIFT(3749),
  [8645] = {.count = 1, .reusable = false}, SHIFT(3751),
  [8647] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3107),
  [8650] = {.count = 1, .reusable = true}, SHIFT(3752),
  [8652] = {.count = 1, .reusable = false}, SHIFT(3755),
  [8654] = {.count = 1, .reusable = true}, SHIFT(3756),
  [8656] = {.count = 1, .reusable = true}, SHIFT(3758),
  [8658] = {.count = 1, .reusable = true}, SHIFT(3761),
  [8660] = {.count = 1, .reusable = true}, SHIFT(3762),
  [8662] = {.count = 1, .reusable = true}, SHIFT(3763),
  [8664] = {.count = 1, .reusable = false}, SHIFT(3761),
  [8666] = {.count = 1, .reusable = true}, SHIFT(3766),
  [8668] = {.count = 1, .reusable = true}, SHIFT(3767),
  [8670] = {.count = 1, .reusable = true}, SHIFT(3768),
  [8672] = {.count = 1, .reusable = true}, SHIFT(3769),
  [8674] = {.count = 1, .reusable = false}, SHIFT(3766),
  [8676] = {.count = 1, .reusable = false}, SHIFT(3770),
  [8678] = {.count = 1, .reusable = true}, SHIFT(3772),
  [8680] = {.count = 1, .reusable = false}, SHIFT(3775),
  [8682] = {.count = 1, .reusable = true}, SHIFT(3775),
  [8684] = {.count = 1, .reusable = true}, SHIFT(3776),
  [8686] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3115),
  [8689] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3118),
  [8692] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3120),
  [8695] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2619),
  [8698] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2620),
  [8701] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2621),
  [8704] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2622),
  [8707] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3124),
  [8710] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3125),
  [8713] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2624),
  [8716] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2626),
  [8719] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2629),
  [8722] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [8724] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [8726] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [8728] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [8730] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [8732] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [8734] = {.count = 1, .reusable = true}, SHIFT(3779),
  [8736] = {.count = 1, .reusable = false}, SHIFT(3780),
  [8738] = {.count = 1, .reusable = true}, SHIFT(3781),
  [8740] = {.count = 1, .reusable = true}, SHIFT(3785),
  [8742] = {.count = 1, .reusable = true}, SHIFT(3787),
  [8744] = {.count = 1, .reusable = true}, SHIFT(3788),
  [8746] = {.count = 1, .reusable = true}, SHIFT(3789),
  [8748] = {.count = 1, .reusable = true}, SHIFT(3790),
  [8750] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 9),
  [8752] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 9),
  [8754] = {.count = 1, .reusable = true}, SHIFT(3792),
  [8756] = {.count = 1, .reusable = false}, SHIFT(3793),
  [8758] = {.count = 1, .reusable = true}, SHIFT(3793),
  [8760] = {.count = 1, .reusable = true}, SHIFT(3794),
  [8762] = {.count = 1, .reusable = false}, SHIFT(3796),
  [8764] = {.count = 1, .reusable = true}, SHIFT(3795),
  [8766] = {.count = 1, .reusable = true}, SHIFT(3796),
  [8768] = {.count = 1, .reusable = true}, SHIFT(3797),
  [8770] = {.count = 1, .reusable = true}, SHIFT(3798),
  [8772] = {.count = 1, .reusable = false}, SHIFT(3799),
  [8774] = {.count = 1, .reusable = true}, SHIFT(3799),
  [8776] = {.count = 1, .reusable = true}, SHIFT(3800),
  [8778] = {.count = 1, .reusable = false}, SHIFT(3802),
  [8780] = {.count = 1, .reusable = true}, SHIFT(3801),
  [8782] = {.count = 1, .reusable = true}, SHIFT(3802),
  [8784] = {.count = 1, .reusable = true}, SHIFT(3803),
  [8786] = {.count = 1, .reusable = true}, SHIFT(3804),
  [8788] = {.count = 1, .reusable = true}, SHIFT(3805),
  [8790] = {.count = 1, .reusable = false}, SHIFT(2793),
  [8792] = {.count = 1, .reusable = false}, SHIFT(2792),
  [8794] = {.count = 1, .reusable = false}, SHIFT(2241),
  [8796] = {.count = 1, .reusable = false}, SHIFT(3807),
  [8798] = {.count = 1, .reusable = true}, SHIFT(3806),
  [8800] = {.count = 1, .reusable = true}, SHIFT(3807),
  [8802] = {.count = 1, .reusable = true}, SHIFT(3808),
  [8804] = {.count = 1, .reusable = true}, SHIFT(3809),
  [8806] = {.count = 1, .reusable = false}, SHIFT(3814),
  [8808] = {.count = 1, .reusable = true}, SHIFT(3812),
  [8810] = {.count = 1, .reusable = true}, SHIFT(3814),
  [8812] = {.count = 1, .reusable = true}, SHIFT(3813),
  [8814] = {.count = 1, .reusable = true}, SHIFT(3815),
  [8816] = {.count = 1, .reusable = false}, SHIFT(3817),
  [8818] = {.count = 1, .reusable = true}, SHIFT(3816),
  [8820] = {.count = 1, .reusable = true}, SHIFT(3817),
  [8822] = {.count = 1, .reusable = false}, SHIFT(2812),
  [8824] = {.count = 1, .reusable = false}, SHIFT(2811),
  [8826] = {.count = 1, .reusable = false}, SHIFT(2255),
  [8828] = {.count = 1, .reusable = false}, SHIFT(3819),
  [8830] = {.count = 1, .reusable = true}, SHIFT(3818),
  [8832] = {.count = 1, .reusable = true}, SHIFT(3819),
  [8834] = {.count = 1, .reusable = true}, SHIFT(3820),
  [8836] = {.count = 1, .reusable = true}, SHIFT(3821),
  [8838] = {.count = 1, .reusable = false}, SHIFT(3826),
  [8840] = {.count = 1, .reusable = true}, SHIFT(3824),
  [8842] = {.count = 1, .reusable = true}, SHIFT(3826),
  [8844] = {.count = 1, .reusable = true}, SHIFT(3825),
  [8846] = {.count = 1, .reusable = true}, SHIFT(3827),
  [8848] = {.count = 1, .reusable = false}, SHIFT(3829),
  [8850] = {.count = 1, .reusable = true}, SHIFT(3828),
  [8852] = {.count = 1, .reusable = true}, SHIFT(3829),
  [8854] = {.count = 1, .reusable = true}, SHIFT(3830),
  [8856] = {.count = 1, .reusable = true}, SHIFT(3831),
  [8858] = {.count = 1, .reusable = true}, SHIFT(3833),
  [8860] = {.count = 1, .reusable = true}, SHIFT(3834),
  [8862] = {.count = 1, .reusable = true}, SHIFT(3835),
  [8864] = {.count = 1, .reusable = true}, SHIFT(3836),
  [8866] = {.count = 1, .reusable = true}, SHIFT(3837),
  [8868] = {.count = 1, .reusable = false}, SHIFT(3838),
  [8870] = {.count = 1, .reusable = true}, SHIFT(3838),
  [8872] = {.count = 1, .reusable = true}, SHIFT(3839),
  [8874] = {.count = 1, .reusable = false}, SHIFT(3841),
  [8876] = {.count = 1, .reusable = true}, SHIFT(3840),
  [8878] = {.count = 1, .reusable = true}, SHIFT(3841),
  [8880] = {.count = 1, .reusable = true}, SHIFT(3842),
  [8882] = {.count = 1, .reusable = true}, SHIFT(3843),
  [8884] = {.count = 1, .reusable = false}, SHIFT(3844),
  [8886] = {.count = 1, .reusable = true}, SHIFT(3844),
  [8888] = {.count = 1, .reusable = true}, SHIFT(3845),
  [8890] = {.count = 1, .reusable = false}, SHIFT(3847),
  [8892] = {.count = 1, .reusable = true}, SHIFT(3846),
  [8894] = {.count = 1, .reusable = true}, SHIFT(3847),
  [8896] = {.count = 1, .reusable = true}, SHIFT(3848),
  [8898] = {.count = 1, .reusable = true}, SHIFT(3849),
  [8900] = {.count = 1, .reusable = true}, SHIFT(3850),
  [8902] = {.count = 1, .reusable = false}, SHIFT(3025),
  [8904] = {.count = 1, .reusable = false}, SHIFT(3024),
  [8906] = {.count = 1, .reusable = false}, SHIFT(2538),
  [8908] = {.count = 1, .reusable = false}, SHIFT(3852),
  [8910] = {.count = 1, .reusable = true}, SHIFT(3851),
  [8912] = {.count = 1, .reusable = true}, SHIFT(3852),
  [8914] = {.count = 1, .reusable = true}, SHIFT(3853),
  [8916] = {.count = 1, .reusable = true}, SHIFT(3854),
  [8918] = {.count = 1, .reusable = false}, SHIFT(3859),
  [8920] = {.count = 1, .reusable = true}, SHIFT(3857),
  [8922] = {.count = 1, .reusable = true}, SHIFT(3859),
  [8924] = {.count = 1, .reusable = true}, SHIFT(3858),
  [8926] = {.count = 1, .reusable = true}, SHIFT(3860),
  [8928] = {.count = 1, .reusable = false}, SHIFT(3862),
  [8930] = {.count = 1, .reusable = true}, SHIFT(3861),
  [8932] = {.count = 1, .reusable = true}, SHIFT(3862),
  [8934] = {.count = 1, .reusable = true}, SHIFT(3863),
  [8936] = {.count = 1, .reusable = false}, SHIFT(3864),
  [8938] = {.count = 1, .reusable = true}, SHIFT(3864),
  [8940] = {.count = 1, .reusable = true}, SHIFT(3865),
  [8942] = {.count = 1, .reusable = false}, SHIFT(3867),
  [8944] = {.count = 1, .reusable = true}, SHIFT(3866),
  [8946] = {.count = 1, .reusable = true}, SHIFT(3867),
  [8948] = {.count = 1, .reusable = true}, SHIFT(3868),
  [8950] = {.count = 1, .reusable = true}, SHIFT(3869),
  [8952] = {.count = 1, .reusable = false}, SHIFT(3870),
  [8954] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3435),
  [8957] = {.count = 1, .reusable = true}, SHIFT(3871),
  [8959] = {.count = 1, .reusable = false}, SHIFT(3875),
  [8961] = {.count = 1, .reusable = true}, SHIFT(3873),
  [8963] = {.count = 1, .reusable = true}, SHIFT(3875),
  [8965] = {.count = 1, .reusable = true}, SHIFT(3874),
  [8967] = {.count = 1, .reusable = true}, SHIFT(3876),
  [8969] = {.count = 1, .reusable = true}, SHIFT(3877),
  [8971] = {.count = 1, .reusable = true}, SHIFT(3878),
  [8973] = {.count = 1, .reusable = false}, SHIFT(3880),
  [8975] = {.count = 1, .reusable = true}, SHIFT(3879),
  [8977] = {.count = 1, .reusable = true}, SHIFT(3880),
  [8979] = {.count = 1, .reusable = true}, SHIFT(3881),
  [8981] = {.count = 1, .reusable = false}, SHIFT(3886),
  [8983] = {.count = 1, .reusable = true}, SHIFT(3884),
  [8985] = {.count = 1, .reusable = true}, SHIFT(3886),
  [8987] = {.count = 1, .reusable = true}, SHIFT(3885),
  [8989] = {.count = 1, .reusable = true}, SHIFT(3887),
  [8991] = {.count = 1, .reusable = false}, SHIFT(3888),
  [8993] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3455),
  [8996] = {.count = 1, .reusable = false}, SHIFT(3891),
  [8998] = {.count = 1, .reusable = true}, SHIFT(3889),
  [9000] = {.count = 1, .reusable = true}, SHIFT(3891),
  [9002] = {.count = 1, .reusable = true}, SHIFT(3890),
  [9004] = {.count = 1, .reusable = true}, SHIFT(3892),
  [9006] = {.count = 1, .reusable = true}, SHIFT(3893),
  [9008] = {.count = 1, .reusable = true}, SHIFT(3894),
  [9010] = {.count = 1, .reusable = false}, SHIFT(3896),
  [9012] = {.count = 1, .reusable = true}, SHIFT(3895),
  [9014] = {.count = 1, .reusable = true}, SHIFT(3896),
  [9016] = {.count = 1, .reusable = true}, SHIFT(3897),
  [9018] = {.count = 1, .reusable = false}, SHIFT(3902),
  [9020] = {.count = 1, .reusable = true}, SHIFT(3900),
  [9022] = {.count = 1, .reusable = true}, SHIFT(3902),
  [9024] = {.count = 1, .reusable = true}, SHIFT(3901),
  [9026] = {.count = 1, .reusable = false}, SHIFT(3904),
  [9028] = {.count = 1, .reusable = true}, SHIFT(3903),
  [9030] = {.count = 1, .reusable = true}, SHIFT(3904),
  [9032] = {.count = 1, .reusable = true}, SHIFT(3905),
  [9034] = {.count = 1, .reusable = true}, SHIFT(3906),
  [9036] = {.count = 1, .reusable = false}, SHIFT(3911),
  [9038] = {.count = 1, .reusable = true}, SHIFT(3909),
  [9040] = {.count = 1, .reusable = true}, SHIFT(3911),
  [9042] = {.count = 1, .reusable = true}, SHIFT(3910),
  [9044] = {.count = 1, .reusable = true}, SHIFT(3912),
  [9046] = {.count = 1, .reusable = false}, SHIFT(3914),
  [9048] = {.count = 1, .reusable = true}, SHIFT(3913),
  [9050] = {.count = 1, .reusable = true}, SHIFT(3914),
  [9052] = {.count = 1, .reusable = false}, SHIFT(3099),
  [9054] = {.count = 1, .reusable = false}, SHIFT(3098),
  [9056] = {.count = 1, .reusable = true}, SHIFT(3915),
  [9058] = {.count = 1, .reusable = true}, SHIFT(3916),
  [9060] = {.count = 1, .reusable = true}, SHIFT(3917),
  [9062] = {.count = 1, .reusable = false}, SHIFT(3918),
  [9064] = {.count = 1, .reusable = true}, SHIFT(3919),
  [9066] = {.count = 1, .reusable = true}, SHIFT(3920),
  [9068] = {.count = 1, .reusable = true}, SHIFT(3922),
  [9070] = {.count = 1, .reusable = true}, SHIFT(3923),
  [9072] = {.count = 1, .reusable = false}, SHIFT(3925),
  [9074] = {.count = 1, .reusable = true}, SHIFT(3924),
  [9076] = {.count = 1, .reusable = true}, SHIFT(3925),
  [9078] = {.count = 1, .reusable = true}, SHIFT(3926),
  [9080] = {.count = 1, .reusable = true}, SHIFT(3927),
  [9082] = {.count = 1, .reusable = true}, SHIFT(3928),
  [9084] = {.count = 1, .reusable = false}, SHIFT(3926),
  [9086] = {.count = 1, .reusable = true}, SHIFT(3929),
  [9088] = {.count = 1, .reusable = true}, SHIFT(3930),
  [9090] = {.count = 1, .reusable = false}, SHIFT(3932),
  [9092] = {.count = 1, .reusable = true}, SHIFT(3931),
  [9094] = {.count = 1, .reusable = true}, SHIFT(3932),
  [9096] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3770),
  [9099] = {.count = 1, .reusable = true}, SHIFT(3933),
  [9101] = {.count = 1, .reusable = false}, SHIFT(3935),
  [9103] = {.count = 1, .reusable = true}, SHIFT(3935),
  [9105] = {.count = 1, .reusable = true}, SHIFT(3938),
  [9107] = {.count = 1, .reusable = false}, SHIFT(3937),
  [9109] = {.count = 1, .reusable = true}, SHIFT(3939),
  [9111] = {.count = 1, .reusable = true}, SHIFT(3940),
  [9113] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 10),
  [9115] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 10),
  [9117] = {.count = 1, .reusable = true}, SHIFT(3941),
  [9119] = {.count = 1, .reusable = true}, SHIFT(3942),
  [9121] = {.count = 1, .reusable = true}, SHIFT(3943),
  [9123] = {.count = 1, .reusable = true}, SHIFT(3944),
  [9125] = {.count = 1, .reusable = true}, SHIFT(3945),
  [9127] = {.count = 1, .reusable = false}, SHIFT(3946),
  [9129] = {.count = 1, .reusable = true}, SHIFT(3946),
  [9131] = {.count = 1, .reusable = true}, SHIFT(3947),
  [9133] = {.count = 1, .reusable = false}, SHIFT(3949),
  [9135] = {.count = 1, .reusable = true}, SHIFT(3948),
  [9137] = {.count = 1, .reusable = true}, SHIFT(3949),
  [9139] = {.count = 1, .reusable = true}, SHIFT(3950),
  [9141] = {.count = 1, .reusable = true}, SHIFT(3951),
  [9143] = {.count = 1, .reusable = false}, SHIFT(3952),
  [9145] = {.count = 1, .reusable = true}, SHIFT(3952),
  [9147] = {.count = 1, .reusable = true}, SHIFT(3953),
  [9149] = {.count = 1, .reusable = false}, SHIFT(3955),
  [9151] = {.count = 1, .reusable = true}, SHIFT(3954),
  [9153] = {.count = 1, .reusable = true}, SHIFT(3955),
  [9155] = {.count = 1, .reusable = true}, SHIFT(3956),
  [9157] = {.count = 1, .reusable = true}, SHIFT(3957),
  [9159] = {.count = 1, .reusable = true}, SHIFT(3958),
  [9161] = {.count = 1, .reusable = true}, SHIFT(3959),
  [9163] = {.count = 1, .reusable = true}, SHIFT(3960),
  [9165] = {.count = 1, .reusable = true}, SHIFT(3961),
  [9167] = {.count = 1, .reusable = false}, SHIFT(3962),
  [9169] = {.count = 1, .reusable = true}, SHIFT(3962),
  [9171] = {.count = 1, .reusable = true}, SHIFT(3963),
  [9173] = {.count = 1, .reusable = false}, SHIFT(3965),
  [9175] = {.count = 1, .reusable = true}, SHIFT(3964),
  [9177] = {.count = 1, .reusable = true}, SHIFT(3965),
  [9179] = {.count = 1, .reusable = true}, SHIFT(3966),
  [9181] = {.count = 1, .reusable = true}, SHIFT(3967),
  [9183] = {.count = 1, .reusable = true}, SHIFT(3968),
  [9185] = {.count = 1, .reusable = false}, SHIFT(3441),
  [9187] = {.count = 1, .reusable = false}, SHIFT(3440),
  [9189] = {.count = 1, .reusable = true}, SHIFT(3969),
  [9191] = {.count = 1, .reusable = false}, SHIFT(3971),
  [9193] = {.count = 1, .reusable = true}, SHIFT(3970),
  [9195] = {.count = 1, .reusable = true}, SHIFT(3971),
  [9197] = {.count = 1, .reusable = true}, SHIFT(3972),
  [9199] = {.count = 1, .reusable = true}, SHIFT(3973),
  [9201] = {.count = 1, .reusable = false}, SHIFT(3978),
  [9203] = {.count = 1, .reusable = true}, SHIFT(3976),
  [9205] = {.count = 1, .reusable = true}, SHIFT(3978),
  [9207] = {.count = 1, .reusable = true}, SHIFT(3977),
  [9209] = {.count = 1, .reusable = true}, SHIFT(3979),
  [9211] = {.count = 1, .reusable = false}, SHIFT(3981),
  [9213] = {.count = 1, .reusable = true}, SHIFT(3980),
  [9215] = {.count = 1, .reusable = true}, SHIFT(3981),
  [9217] = {.count = 1, .reusable = false}, SHIFT(3460),
  [9219] = {.count = 1, .reusable = false}, SHIFT(3459),
  [9221] = {.count = 1, .reusable = false}, SHIFT(3983),
  [9223] = {.count = 1, .reusable = true}, SHIFT(3982),
  [9225] = {.count = 1, .reusable = true}, SHIFT(3983),
  [9227] = {.count = 1, .reusable = true}, SHIFT(3984),
  [9229] = {.count = 1, .reusable = true}, SHIFT(3985),
  [9231] = {.count = 1, .reusable = false}, SHIFT(3990),
  [9233] = {.count = 1, .reusable = true}, SHIFT(3988),
  [9235] = {.count = 1, .reusable = true}, SHIFT(3990),
  [9237] = {.count = 1, .reusable = true}, SHIFT(3989),
  [9239] = {.count = 1, .reusable = true}, SHIFT(3991),
  [9241] = {.count = 1, .reusable = false}, SHIFT(3993),
  [9243] = {.count = 1, .reusable = true}, SHIFT(3992),
  [9245] = {.count = 1, .reusable = true}, SHIFT(3993),
  [9247] = {.count = 1, .reusable = true}, SHIFT(3994),
  [9249] = {.count = 1, .reusable = false}, SHIFT(3995),
  [9251] = {.count = 1, .reusable = true}, SHIFT(3995),
  [9253] = {.count = 1, .reusable = true}, SHIFT(3996),
  [9255] = {.count = 1, .reusable = false}, SHIFT(3998),
  [9257] = {.count = 1, .reusable = true}, SHIFT(3997),
  [9259] = {.count = 1, .reusable = true}, SHIFT(3998),
  [9261] = {.count = 1, .reusable = true}, SHIFT(3999),
  [9263] = {.count = 1, .reusable = true}, SHIFT(4000),
  [9265] = {.count = 1, .reusable = false}, SHIFT(4001),
  [9267] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3758),
  [9270] = {.count = 1, .reusable = false}, SHIFT(4004),
  [9272] = {.count = 1, .reusable = true}, SHIFT(4002),
  [9274] = {.count = 1, .reusable = true}, SHIFT(4004),
  [9276] = {.count = 1, .reusable = true}, SHIFT(4003),
  [9278] = {.count = 1, .reusable = true}, SHIFT(4005),
  [9280] = {.count = 1, .reusable = true}, SHIFT(4006),
  [9282] = {.count = 1, .reusable = true}, SHIFT(4007),
  [9284] = {.count = 1, .reusable = false}, SHIFT(4009),
  [9286] = {.count = 1, .reusable = true}, SHIFT(4008),
  [9288] = {.count = 1, .reusable = true}, SHIFT(4009),
  [9290] = {.count = 1, .reusable = true}, SHIFT(4010),
  [9292] = {.count = 1, .reusable = false}, SHIFT(4015),
  [9294] = {.count = 1, .reusable = true}, SHIFT(4013),
  [9296] = {.count = 1, .reusable = true}, SHIFT(4015),
  [9298] = {.count = 1, .reusable = true}, SHIFT(4014),
  [9300] = {.count = 1, .reusable = false}, SHIFT(4016),
  [9302] = {.count = 1, .reusable = true}, SHIFT(4017),
  [9304] = {.count = 1, .reusable = false}, SHIFT(4017),
  [9306] = {.count = 1, .reusable = true}, SHIFT(4019),
  [9308] = {.count = 1, .reusable = true}, SHIFT(4020),
  [9310] = {.count = 1, .reusable = true}, SHIFT(4021),
  [9312] = {.count = 1, .reusable = true}, SHIFT(4022),
  [9314] = {.count = 1, .reusable = true}, SHIFT(4023),
  [9316] = {.count = 1, .reusable = true}, SHIFT(4024),
  [9318] = {.count = 1, .reusable = true}, SHIFT(4025),
  [9320] = {.count = 1, .reusable = false}, SHIFT(4026),
  [9322] = {.count = 1, .reusable = true}, SHIFT(4026),
  [9324] = {.count = 1, .reusable = true}, SHIFT(4027),
  [9326] = {.count = 1, .reusable = false}, SHIFT(4029),
  [9328] = {.count = 1, .reusable = true}, SHIFT(4028),
  [9330] = {.count = 1, .reusable = true}, SHIFT(4029),
  [9332] = {.count = 1, .reusable = true}, SHIFT(4030),
  [9334] = {.count = 1, .reusable = true}, SHIFT(4031),
  [9336] = {.count = 1, .reusable = false}, SHIFT(4032),
  [9338] = {.count = 1, .reusable = true}, SHIFT(4032),
  [9340] = {.count = 1, .reusable = true}, SHIFT(4033),
  [9342] = {.count = 1, .reusable = false}, SHIFT(4035),
  [9344] = {.count = 1, .reusable = true}, SHIFT(4034),
  [9346] = {.count = 1, .reusable = true}, SHIFT(4035),
  [9348] = {.count = 1, .reusable = true}, SHIFT(4036),
  [9350] = {.count = 1, .reusable = true}, SHIFT(4037),
  [9352] = {.count = 1, .reusable = true}, SHIFT(4038),
  [9354] = {.count = 1, .reusable = false}, SHIFT(3763),
  [9356] = {.count = 1, .reusable = false}, SHIFT(3762),
  [9358] = {.count = 1, .reusable = false}, SHIFT(3487),
  [9360] = {.count = 1, .reusable = false}, SHIFT(4040),
  [9362] = {.count = 1, .reusable = true}, SHIFT(4039),
  [9364] = {.count = 1, .reusable = true}, SHIFT(4040),
  [9366] = {.count = 1, .reusable = true}, SHIFT(4041),
  [9368] = {.count = 1, .reusable = true}, SHIFT(4042),
  [9370] = {.count = 1, .reusable = false}, SHIFT(4047),
  [9372] = {.count = 1, .reusable = true}, SHIFT(4045),
  [9374] = {.count = 1, .reusable = true}, SHIFT(4047),
  [9376] = {.count = 1, .reusable = true}, SHIFT(4046),
  [9378] = {.count = 1, .reusable = true}, SHIFT(4048),
  [9380] = {.count = 1, .reusable = false}, SHIFT(4050),
  [9382] = {.count = 1, .reusable = true}, SHIFT(4049),
  [9384] = {.count = 1, .reusable = true}, SHIFT(4050),
  [9386] = {.count = 1, .reusable = true}, SHIFT(4051),
  [9388] = {.count = 1, .reusable = false}, SHIFT(4051),
  [9390] = {.count = 1, .reusable = true}, SHIFT(4052),
  [9392] = {.count = 1, .reusable = true}, SHIFT(4053),
  [9394] = {.count = 1, .reusable = true}, SHIFT(4054),
  [9396] = {.count = 1, .reusable = true}, SHIFT(4055),
  [9398] = {.count = 1, .reusable = true}, SHIFT(4056),
  [9400] = {.count = 1, .reusable = false}, SHIFT(4057),
  [9402] = {.count = 1, .reusable = true}, SHIFT(4057),
  [9404] = {.count = 1, .reusable = true}, SHIFT(4058),
  [9406] = {.count = 1, .reusable = false}, SHIFT(4060),
  [9408] = {.count = 1, .reusable = true}, SHIFT(4059),
  [9410] = {.count = 1, .reusable = true}, SHIFT(4060),
  [9412] = {.count = 1, .reusable = true}, SHIFT(4061),
  [9414] = {.count = 1, .reusable = true}, SHIFT(4062),
  [9416] = {.count = 1, .reusable = true}, SHIFT(4063),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
